;;;      (h=0.25D)   6533
;;;       
;;;:  ..
;;; : 27.08.2001
;;;CAD-CEE 2000
;;;: (fn_a1 inp r1 a b ang1 mb)
;;;   : inp - ,    ;
;;;        r1 -    X;
;;;        a, b -  ;
;;;        ang1 - ,    ;
;;;        mb -  ;
;;;   a1
(defun fn_a1 (inp r1 a b ang1 mb / inp_z pt1 pt2 x1 y1 xs ls a1 pt_i y)
  (setq	y0    (* (/ b a) (sqrt (- (expt a 2.0) (expt r1 2.0))))
	y     (- b y0)
	x1    (+ r1 0.5)
	y1    (+ (/ (* a (- x1 r1) (sqrt (- (expt a 2.0) (expt r1 2.0))))
		    (* b r1)
		 ) ;_  /
		 y0
	      ) ;_  +
	pt1   (list x1 y1 0.0)
	inp_z (list r1 y0 0.0)
	ang3  (angle inp_z pt1)
	xs    (* y (/ (cos ang3) (sin ang3)))
	pt_i  (polar inp (/ pi 2.0) (* y mb))
	pt1   (polar pt_i ang1 (* xs mb))
	a1    (angle inp pt1)		;      
  ) ;_  setq
;;;      
  (setq a1 a1)
) ;_  FN_A1


;;;      
;;;:  ..
;;; : 24.08.2001
;;;CAD-CEE 2000
;;;: (ellpt r0 s0 r1 ang2 mb)
;;;   : r0 -   ;
;;;        s0 -  ;
;;;        r1 -    (   );
;;;        ang2 -     ;
;;;        mb -  
;;;  ellst (inp inptB_0 inptEl a1 ang1)
;;;   : inp -   ;
;;;        inptB_0 -    ;
;;;        inptEl -   ;
;;;        a1 -    (   );
;;;        ang1 -   

(defun ellpt (r0  s0    r1    ang2  mb	 /     inptB_0	   dl_b	 dl_mx
		 pt_i  inp   cnell xb	 yb    xc    yc	   ang1	 ang2
		 ang3  a     b	   pt2	 vspm  ddv   y0	   y	 inptEl
		 ellst
		) 


;;;       (inp)
  (defun fn_osn_pn (/ x1 y1)
;;;      
    (setq x1	 (nth 0 inptB_0)
	  y1	 (nth 1 inptB_0)
	  a	 (+ r0 s0)
	  b	 (+ (* 0.5 r0) s0)
	  ang1	 (angle inptB_0 pt_i)
	  inptEl (polar inptB_0 ang2 (* (+ (* r0 0.5) s0) mb))
	  pt_i	 (polar inptB_0 ang1 (* r1 mb))
    ) ;_  setq
    (if (/= ang1 0.0) (setq ang1 pi))
    (if	(/= r1 0.0)
      (progn
	(setq y0   (* (/ b a) (sqrt (- (expt a 2.0) (expt r1 2.0))))
	      y	   (- b y0)
	      inp  (polar pt_i ang2 (* y mb))
	) ;_  setq
      ) ;_  progn
      (progn
	(setq inp (polar inptB_0 0.0 0.0)
	) ;_  setq
      ) ;_  progn
    ) ;_  if
  ) ;_  FN_OSN_PN


;;;  ------------------------------- -------------------------
;;; ---------------------------   ----------------------
  (initget 1)
  (setq	inptB_0 (getpoint "\n    : "))

  (if (= (getvar "ORTHOMODE") 0)
    (progn
      (setq ddv 1)
      (setvar "ORTHOMODE" 1)
    ) ;_  progn
    (setq ddv 0)
  ) ;_  if
    
  (if (/= r1 0.0)
    (progn
      (initget 1)
      (setq pt_i (getpoint inptB_0 "\n  :"))
    ) ;_  progn
    (setq pt_i inptB_0)
  ) ;_  if

  (if (= ddv 1)
      (setvar "ORTHOMODE" 0)
  ) ;_  if

;;;      inp
  (fn_osn_pn)

;;;       
  (if (/= r1 0.0)
    (setq a1 (fn_a1 inp r1 a b ang1 mb))
    (setq a1 (/ pi 2.0))
  ) ;_  if

;;;   
  (setq ellst (list inp inptB_0 inptEl a1 ang1))  
) ;_  ELLPT


;;;     
;;; : 24.08.2001
;;;CAD-CEE 2000
;;;: (ellpt2 inptEl r0 x0 x ang1 mb)
;;;   : inptEl -   ;
;;;        r0 -    ( );
;;;        x0 -     (,  );
;;;        x -    X    ( );
;;;        ang1 -    X;
;;;        mb -  ;
;;; ellst2 -  
(defun ellpt2 (inptEl r0 x0 x ang1 mb / a b y pt1 pt2 ellst2 kf an)
    (setq a   (+ r0 x0)
	  b   (+ (* 0.5 r0) x0)
	  y   (* (/ b a) (sqrt (- (expt a 2.0) (expt x 2.0))))
	  pt1 (polar inptEl ang1 (* x mb))
	  pt2 (polar pt1 (/ pi 2.0) (* y mb))
    ) ;_  setq
;;;   
  (setq ellst2 pt2) 
) ;_  defun
