;;;      
;;;:  ..
;;; : 28.08.2001
;;;CAD-CEE 2000
;;;: (okrpt r0 s0 r1 ang2 mb)
;;;   : r0 -   ;
;;;        s0 -  ;
;;;        r1 -    (   );
;;;        ang2 -     ;
;;;        mb -  
;;;  ellst (inp inptB_0 inptEl a1 ang1)
;;;   : inp -   ;
;;;        inptB_0 -    ;
;;;        inptEl -   ;
;;;        a1 -    (   );
;;;        ang1 -   

(defun okrpt (r0  s0    r1    ang2  mb	 /     inptB_0	   dl_b	 dl_mx
		 pt_i  inp   cnell xb	 yb    xc    yc	   ang1	 ang2
		 ang3  a     b	   pt2	 vspm  ddv   y0	   y	 inptEl
		 ellst
		) 


;;;       (inp)
  (defun fn_osn_pn ()
;;;      
    (setq ang1	 (angle inptB_0 pt_i)
	  inptEl (polar inptB_0 ang2 (* (+ r0 s0) mb))
	  pt_i	 (polar inptB_0 ang1 (* r1 mb))
    ) ;_  setq
    (if (/= ang1 0.0) (setq ang1 pi))
    (if	(/= r1 0.0)
      (progn
	(setq y0   (sqrt (- (expt (+ r0 s0) 2.0) (expt r1 2.0)))
	      y	   (- (+ r0 s0) y0)
	      inp  (polar pt_i ang2 (* y mb));  
	) ;_  setq
      ) ;_  progn
      (progn
	(setq inp inptB_0);  
      ) ;_  progn
    ) ;_  if
  ) ;_  FN_OSN_PN


;;;  ------------------------------- -------------------------
;;; ---------------------------   ----------------------
  (initget 1)
  (setq	inptB_0 (getpoint "\n    : "))

  (if (= (getvar "ORTHOMODE") 0)
    (progn
      (setq ddv 1)
      (setvar "ORTHOMODE" 1)
    ) ;_  progn
    (setq ddv 0)
  ) ;_  if
    
  (if (/= r1 0.0)
    (progn
      (initget 1)
      (setq pt_i (getpoint inptB_0 "\n  :"))
    ) ;_  progn
    (setq pt_i inptB_0)
  ) ;_  if

  (if (= ddv 1)
      (setvar "ORTHOMODE" 0)
  ) ;_  if

;;;      inp
  (fn_osn_pn)

;;;       
  (if (/= r1 0.0)
    (setq a1 (angle inptEl inp))
    (setq a1 (/ pi 2.0))
  ) ;_  if

;;;   
  (setq ellst (list inp inptB_0 inptEl a1 ang1))  
) ;_  OKRPT


;;;     
;;; : 28.08.2001
;;;CAD-CEE 2000
;;;: (okrpt2 inptEl r0 x0 x ang1 mb)
;;;   : inptEl -   ;
;;;        r0 -    ( );
;;;        x0 -     (,  );
;;;        x -    X    ( );
;;;        ang1 -    X;
;;;        mb -  ;
;;; ellst2 -  
(defun okrpt2 (inptEl r0 x0 x ang1 mb / a b y pt1 pt2 ellst2 kf an)
    (setq a   (+ r0 x0)
	  b   (+ (* 0.5 r0) x0)
	  y   (* (/ b a) (sqrt (- (expt a 2.0) (expt x 2.0))))
	  pt1 (polar inptEl ang1 (* x mb))
	  pt2 (polar pt1 (/ pi 2.0) (* y mb))
    ) ;_  setq
;;;   
  (setq ellst2 pt2) 
) ;_  defun
