;;;     
;;;:  ..
;;; : 27.09.2000
;;;CAD-CEE 2000
;;;-------------------------------------------------------------------------
;;;    
;;;
;;;  cpt -   ;
;;;  dln -  ;
;;;  dmt -  ;
;;;  a1 -   , .
;;;
;;;     :  (obrobj '(10 10 0) 20 10 1.57)
;;;
;;;-------------------------------------------------------------------------

(defun  obrobj (cpt dln dmt a1 / pt5 pt6 pt7 pt8 pt9 pt10
	        pt11 pt12 delt1 delt2 delt3 deltR cut pt13
		pt14 delt4 delt5)
  
;;;    
  (defun hidef ()
    (command "_layer" "_s" "" "")
  ) ;_  defun
  
  (setq	pt1  (polar cpt (+ (/ pi 2) a1) (/ dmt 2))
	pt2  (polar pt1 (+ 0 a1) dln)
	pt3  (polar cpt (+ (* (/ pi 2) 3) a1) (/ dmt 2))
	pt4  (polar pt3 (+ 0 a1) dln)
	pt5  (polar pt1 (+ (/ pi 2) a1) (* dmt 0.1))
	pt6  (polar pt2 (+ (/ pi 2) a1) (* dmt 0.1))
	pt7  (polar pt3 (+ (* (/ pi 2) 3) a1) (* dmt 0.1))
	pt8  (polar pt4 (+ (* (/ pi 2) 3) a1) (* dmt 0.1))
	pt9  (polar pt3 (+ (/ pi 2) a1) (* dmt 0.01))
	pt10 (polar pt4 (+ (/ pi 2) a1) (* dmt 0.01))
	pt11 (polar pt1 (+ (* (/ pi 2) 3) a1) (* dmt 0.01))
	pt12 (polar pt2 (+ (* (/ pi 2) 3) a1) (* dmt 0.01))
	pt13 (polar pt2 (+ 0 a1) (* dmt 0.1))
	pt14 (polar pt3 (+ pi a1) (* dmt 0.1))
  ) ;_  setq

  (hidef)
  (command "_line" pt1 pt2 "")
  (setq cut (ssadd (entlast)))
  (command "_line" pt3 pt4 "")
  (ssadd (entlast) cut)
  (command "_line" pt2 pt4 "") 
  (ssadd (entlast) cut)
  (command "_line" pt1 pt3 "") 
  (ssadd (entlast) cut)

;;;       
  (defun dlln (dlt / id id1 d1 d2 no no1)
     (if dlt
       (setq id (sslength dlt))
       (setq id 0)
     ) ;_  if
     (setq id1 (sslength cut)
	   no  -1
     ) ;_  setq
     (repeat id1
       (setq no	 (1+ no)
	     no1 -1
       ) ;_  setq
       (setq d1 (ssname cut no))
       (repeat id
	 (setq no1 (1+ no1))
	 (setq d2 (ssname dlt no1))
	 (if (eq d1 d2)
	   (ssdel d1 dlt)
	 ) ;_  if
       ) ;_  repeat
     ) ;_  repeat
  ) ;_  defun


;;;       "cut"  
;;;     
  (defun srt (dlt / id d1 no)
    (if dlt
       (setq id (sslength dlt))
       (setq id 0)
    ) ;_  if
    (setq no -1) 
    (repeat id
      (setq no (1+ no)
	    d1 (ssname dlt no)
      ) ;_  setq
      (if (or (ssmemb d1 delt1)
	      (ssmemb d1 delt3)
	      (ssmemb d1 delt4)
	      (ssmemb d1 delt5)
	  ) ;_  or
	(ssadd d1 deltR)
	(progn
	  (ssdel d1 dlt)
	  (if (or (= (cdr (assoc 8 (entget d1))) "")
		  (= (cdr (assoc 8 (entget d1))) "")
	      ) ;_  or
              (entdel d1)
	  )  
	  (setq no (1- no))
	) ;_  progn
      ) ;_  if
    ) ;_  repeat
  ) ;_  defun


;;;    
  (defun delos (/ id no d1)
    (if deltR
       (setq id (sslength deltR))
       (setq id 0)
    ) ;_  if
    (setq no -1)
    (repeat id
      (setq no (1+ no)
	    d1 (ssname deltR no)
      ) ;_  setq
      (if (or
	    (= (cdr (assoc 0 (entget d1))) "")
	    (= (cdr (assoc 0 (entget d1))) "LWPOLYLINE")
	  ) ;_  or
	(progn
	  (ssdel d1 deltR)
	  (command "_explode" d1 "")
	  (setq no (1- no))
	) ;_  progn
      ) ;_  if
    ) ;_  repeat
    (if	(and (/= id 0) (< no (- id 1)))
      (progn
	(setq delt1 (ssget "_C" pt1 pt6)
	      delt2 (ssget "_C" pt3 pt2)
	      delt3 (ssget "_C" pt7 pt4)
	      delt4 (ssget "_C" pt14 pt1)
	      delt5 (ssget "_C" pt4 pt13)
	      deltR (ssadd)
	) ;_  setq
	(dlln delt1)
	(dlln delt2)
	(dlln delt3)
	(dlln delt4)
	(dlln delt5)
	(srt delt2)
      ) ;_  progn
    ) ;_  if 
  ) ;_  defun


;;; ---------------------------- ------------------------

  (command "_LAYER" "_LO" " " "")
  (command "_LAYER" "_LO" " 2" "")

;;;      
  (setq	delt1 (ssget "_C" pt1 pt6)
	delt2 (ssget "_C" pt3 pt2)
	delt3 (ssget "_C" pt7 pt4)
	delt4 (ssget "_C" pt14 pt1)
	delt5 (ssget "_C" pt4 pt13)
	deltR (ssadd)
  ) ;_  setq

  (dlln delt1)
  (dlln delt2)
  (dlln delt3)
  (dlln delt4)
  (dlln delt5)

  (srt delt2)

  (delos)

;;;    "cut"  
  (command "_TRIM" cut "" "_f" pt9 pt10	"" "")
  (command "_TRIM" cut "" "_f" pt10 pt11 "" "")
  (command "_TRIM" cut "" "_f" pt11 pt12 "" "")
  (command "_TRIM" cut "" "_f" pt12 pt9 "" "")

  (entdel (ssname cut 0))
  (entdel (ssname cut 1))
  (entdel (ssname cut 2))
  (entdel (ssname cut 3))


  (command "_LAYER" "_U" " " "")
  (command "_LAYER" "_U" " 2" "")

  (prin1)
) ;_  defun
