;;;  
;;;:  ..
;;; : 04.10.2000
;;;CAD-CEE 2000

(defun blts  (      
	     /	    cmd	   blpm	  apsz	 osmd	dmt    dln    dln1
	     dgb    sgb	   hgb	  dvt	 fsk	rsp    cpt    pt1
	     pto1   pto2   ept	  pt2	 pt3	pt4    pt5    pt6
	     pt7    pt8	   pt9	  pt10	 pt11	pt12   pt13   pt14
	     pt14-1 pt14-2 pt15	  pt16	 pt17	pt18   pt19   pt19-1
	     pt19-2 pt20   pt21	  pt22	 pt23	pt24   pt25   tgb
	     tgbt   tgbn   edat3  label	 sset   clay  cltp    ccol
	     xyc    ang    mb     a1     inpt0  zam
	    )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  
  (setq	dmt  (nth 3 bb)
	dln  (nth 4 bb)
	dln1 (nth 5 bb)
	dgb  (nth 6 bb)
	sgb  (nth 7 bb)
	hgb  (nth 8 bb)
	dvt  (nth 9 bb)
	fsk  (nth 10 bb)
	rsp  (nth 11 bb)
  ) ;_ end of setq

;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )

  

     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )
     (defun axs ()
          (command "_'layer" "_s" " " "")
      )
     (defun ton ()
          (command "_'layer" "_s" "" "")
      )

  (defun ris_blt ()

    (setq cpt inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)
    
;;;;;;;;;     
    (defun bl_gl_sb ()


      (defun acsl ()
	(setq pt1  (polar cpt (+ pi a1) (* hgb mb))
	      pto1 (polar pt1 (+ pi a1) (* 2.00 mb))
	      ept  (polar cpt (+ 0 a1) (* dln mb))
	      pto2 (polar ept (+ 0 a1) (* 2.00 mb))
	) ;_ end of setq

	(axs)

	(command "_line" pto1 pto2 "")	;   
	(setq label (entlast)
	      sset  (ssadd (entlast))
	) ;_ end of setq
      ) ;_ end of defun

      (acsl)
					;    
      (defun gbgl ()
	(setq pt2  (polar cpt (+ (/ pi 2) a1) (* (/ dgb 2.00) mb))
	      pt3  (polar pt2
			  (+ pi a1)
			  (* (- hgb (* dgb (- 0.25 (* 0.225 (cos (/ pi 6)))))) mb)
		   ) ;_ end of polar
	      pt4  (polar pt3
			  (+ (/ (* pi 4) 3) a1)
			  (* (* dgb (- 0.50 (* 0.45 (cos (/ pi 6))))) mb)
		   ) ;_ end of polar
	      pt7  (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dgb 2.00) mb))
	      pt6  (polar pt7
			  (+ pi a1)
			  (* (- hgb (* dgb (- 0.25 (* 0.225 (cos (/ pi 6)))))) mb)
		   ) ;_ end of polar
	      pt5  (polar pt6
			  (+ (/ (* pi 2) 3) a1)
			  (* (* dgb (- 0.5000 (* 0.4500 (cos (/ pi 6))))) mb)
		   ) ;_ end of polar
	      pt8  (polar cpt (+ (/ pi 2) a1) (/ (distance cpt pt2) 2.00))
	      pt9  (polar pt8
			  (+ pi a1)
			  (* (- hgb (* dgb (- 0.25 (* 0.225 (cos (/ pi 6)))))) mb)
		   ) ;_ end of polar
	      pt10 (polar pt9
			  (+ (/ (* pi 2) 3) a1)
			  (* (* dgb (- 0.50 (* 0.45 (cos (/ pi 6))))) mb)
		   ) ;_ end of polar
	      pt11 (polar cpt (+ (/ (* pi 3) 2) a1) (/ (distance cpt pt2) 2.00))
	      pt12 (polar pt11
			  (+ pi a1)
			  (* (- hgb (* dgb (- 0.25 (* 0.225 (cos (/ pi 6)))))) mb)
		   ) ;_ end of polar
	      pt13 (polar pt12
			  (+ (/ (* pi 4) 3) a1)
			  (* (* dgb (- 0.50 (* 0.45 (cos (/ pi 6))))) mb)
		   ) ;_ end of polar
	) ;_ end of setq
	(osn)
	(command "_line"
		 pt7
		 pt2
		 pt3
		 pt4
		 pt5
		 pt6
		 pt7
		 "")
	(command "_line"
		 pt8
		 pt9
		 pt10
		 "")
	(command "_line"
		 pt11
		 pt12
		 pt13
		 "")
	(command "_arc"
		 pt9
		 pt1
		 pt12
	)				;  
					;    
      ) ;_ end of defun

					;    
      (defun gbbv ()
	(setq pt2  (polar cpt (+ (/ pi 2) a1) (* (/ sgb 2.00) mb))
	      pt7  (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ sgb 2.00) mb))
	      pt3  (polar pt2
			  (+ pi a1)
			  (* (- hgb (* dgb (- (/ 0.25 (cos (/ pi 6))) 0.225))) mb)
		   ) ;_ end of polar
	      pt6  (polar pt7
			  (+ pi a1)
			  (* (- hgb (* dgb (- (/ 0.25 (cos (/ pi 6))) 0.225))) mb)
		   ) ;_ end of polar
	      pt8  (polar cpt
			  (+ pi a1)
			  (* (- hgb (* dgb (- (/ 0.25 (cos (/ pi 6))) 0.225))) mb)
		   ) ;_ end of polar
	      pt9  (polar cpt
			  (+ (/ pi 2) a1)
			  (* (/ (/ (* dgb (cos (/ pi 6))) 2.0000) 2.00) mb)
		   ) ;_ end of polar
	      pt10 (polar cpt
			  (+ (/ (* pi 3) 2) a1)
			  (* (/ (/ (* dgb (cos (/ pi 6))) 2.00) 2.00) mb)
		   ) ;_ end of polar
	      pt4  (polar pt9 (+ pi a1) (* hgb mb))
	      pt5  (polar pt10 (+ pi a1) (* hgb mb))
	) ;_ end of setq
	(osn)
	(command "_line"
		 pt6
		 pt7
		 pt2
		 pt3
		 ""
		 "_line"
		 cpt
		 pt8
		 ""
		 "_line"
		 pt4
		 pt5
		 ""
		 "_arc"
		 pt3
		 pt4
		 pt8
		 "_arc"
		 pt8
		 pt5
		 pt6
	)				;    
      ) ;_ end of defun

      (if (and (eq glv1 "1") (eq vsb1 "0"))
	(gbgl)
	(gbbv)
      ) ;_ end of if

					;   
      (defun strg ()
	(setq pt14   (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dmt 2.00) mb))
	      pt14-1 (polar cpt (+ (/ (* pi 3) 2) a1) (* (+ (/ dmt 2.00) rsp) mb))
	      pt14-2 (polar pt14-1 (+ (/ pi 4) a1) (* (/ rsp (cos (/ pi 4))) mb))
	      pt15   (polar pt14 (+ 0 a1) (* (- dln fsk) mb))
	      pt16   (polar pt15 (+ (/ pi 4) a1) (* (* fsk (sqrt 2.00)) mb))
	      pt19   (polar cpt (+ (/ pi 2) a1) (* (/ dmt 2.0000) mb))
	      pt19-1 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dmt 2.00) rsp) mb))
	      pt19-2 (polar pt19-1 (+ (/ (* pi 7) 4) a1) (* (/ rsp (cos (/ pi 4))) mb))
	      pt18   (polar pt19 (+ 0 a1) (* (- dln fsk) mb))
	      pt17   (polar pt18 (+ (/ (* pi 7) 4) a1) (* (* fsk (sqrt 2.00)) mb))
	      pt20   (polar pt14 (+ 0 a1) (* (- dln dln1) mb))
	      pt21   (polar pt19 (+ 0 a1) (* (- dln dln1) mb))
	) ;_ end of setq

	(if (< (* (/ (- dmt dvt) 2) mb) 0.6)
	  (progn
	    (setq dvt (- dmt (/ (* 2 0.6) mb)))
	    (if	(> (/ (- dmt dvt) 2) fsk)
	      (setq zam dln1)
	      (setq zam (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)))
	    ) ;_  if
	    (setq pt22 (polar pt21 (+ (/ (* pi 3) 2) a1) (* (/ (- dmt dvt) 2.00) mb))
		  pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
		  pt24 (polar pt22 (+ 0 a1) (* zam mb)) 
		  pt25 (polar pt23 (+ 0 a1) (* zam mb)) 
	    ) ;_  setq
	  ) ;_  progn
	  (setq	pt22 (polar pt21 (+ (/ (* pi 3) 2) a1) (* (/ (- dmt dvt) 2.00) mb))
		pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb)) 
		pt24 (polar pt22 (+ 0 a1) (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)) 
		pt25 (polar pt23 (+ 0 a1) (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb))
	  ) ;_  setq
	) ;_  if
	
	(command "_line"
		 pt14-2
		 pt15
		 pt16
		 pt17
		 pt18
		 pt19-2
		 ""
		 "_arc"
		 pt19-1
		 "_e"
		 pt19-2
		 "_r"
		 (* rsp mb)
		 "_arc"
		 pt14-2
		 "_e"
		 pt14-1
		 "_r"
		 (* rsp mb)
		 "_line"
		 pt15
		 pt18
		 ""
	) ;_ end of command
	(if (/= dln dln1)
	  (command "_line" pt20 pt21 "")
	) ;_ end of if
	(if (not (< (* (/ dmt 2) mb) 0.6))
	  (progn
	    (ton)
	    (command "_line"
		     pt22
		     pt24
		     ""
		     "_line"
		     pt23
		     pt25
		     ""
		    ) ;_  command
	  ) ;_  command
	) ;_ end of if
	                                  ;    
      ) ;_ end of defun

      (strg)


    ) ;_ end of defun
;;;;;_end of      BL_GL_SB

;;;;;;;  
    (defun bl_vs ()
      (setq tgb	 (/ (sqrt (- (expt dgb 2) (expt sgb 2))) sgb)
	    tgbt (atan tgb)
      ) ;_ end of setq
      (setq pt1	 (polar cpt (+ tgbt a1) (* (/ dgb 2.0) mb))
	    pt3	 (polar cpt (+ (+ tgbt (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt5	 (polar cpt (+ (+ tgbt (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt7	 (polar cpt (+ (+ tgbt pi) a1) (* (/ dgb 2.0) mb))
	    pt9	 (polar cpt (+ (+ tgbt (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt11 (polar cpt (+ (+ tgbt (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    tgbn (- pi tgbt)
	    pt6	 (polar cpt (+ tgbn a1) (* (/ dgb 2.0) mb))
	    pt8	 (polar cpt (+ (+ tgbn (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt10 (polar cpt (+ (+ tgbn (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt12 (polar cpt (+ (+ tgbn pi) a1) (* (/ dgb 2.0) mb))
	    pt2	 (polar cpt (+ (+ tgbn (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt4	 (polar cpt (+ (+ tgbn (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    pt13 (polar cpt (+ 0 a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt14 (polar cpt (+ pi a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt15 (polar cpt (+ (/ (* pi 3) 2) a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt16 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dgb 2.0) 3) mb))
      ) ;_ end of setq

      (axs)
      (command "_line" pt14 pt13 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" pt15 pt16 "")

      (osn)
      (command "_circle" cpt (* (/ (* sgb 0.9000) 2.0000) mb))
      (command "_line"
	       pt12
	       pt1
	       ""
	       "_line"
	       pt2
	       pt3
	       ""
	       "_line"
	       pt4
	       pt5
	       ""
	       "_line"
	       pt6
	       pt7
	       ""
	       "_line"
	       pt8
	       pt9
	       ""
	       "_line"
	       pt10
	       pt11
	       ""
      ) ;_ end of command
      (command "_arc"
	       pt1
	       "_e"
	       pt2
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt3
	       "_e"
	       pt4
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt5
	       "_e"
	       pt6
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt7
	       "_e"
	       pt8
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt9
	       "_e"
	       pt10
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt11
	       "_e"
	       pt12
	       "_r"
	       (* (/ dgb 2.0) mb)
      ) ;_ end of command


    ) ;_ end of defun
;;; _end of   BL_VS

    (cond
      ((and (or (eq glv1 "1") (eq vsb1 "1")) (eq vsv1 "0"))
       (bl_gl_sb)
      )
      ((and (eq glv1 "0") (eq vsb1 "0") (eq vsv1 "1")) (bl_vs))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun
;;;_end of RIS_BLT


(defun clip_bl ()
   

    (initget 1) 
    (if (eq p1 "1")
             (setq inpt0 (getpoint "\n  :"))
             (setq inpt0 (list (atof xc) (atof yc)))
    )
    (if (eq p2 "1")
             (progn 
                  (setq a1 (getangle inpt0 (strcat "\n   <" angl ">:")))
	          (if (= a1 nil)
		           (setq a1 (atof angl))
		  )
	      )
             (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if 
    (setq mb (atof mash))
        
    (ris_blt)
  
    (if	(eq p3 "0")
           (anblk sset cpt)
    ) ;_  if
  
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
  ) ;_ end of defun
  
  (clip_bl)
  (prin1)
) ;_ end of defun BLTS
