;;;  
;;;:  ..
;;; : 14.08.2000
;;; :
;;;CAD-CEE 2000

(defun shpl  (      
	     /	    cmd	   blpm	  apsz	 osmd	dmt    dln    dln0
	     dln1   dln0   rds    dmt1	 fsk    cpt    pt1    dvt 
	     pto1   pto2   ept	  pt2	 pt3	pt4    pt5    pt6
	     pt7    pt8	   pt9	  pt10	 pt11	pt12   pt13   pt14
	     pt15  pt16    pt17	  pt18   pt19   pt20   pt21   pt22
	     pt23   pt24   pt25   edat3  label	sset   clay   cltp
	     ccol   xyc    ang    mb     inpt0  a1     zam    zam1
	    )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  
  (setq	dmt  (nth 3 bb)
	dln  (nth 4 bb)
	dln0 (nth 5 bb)
	dln1 (nth 6 bb)
	fsk  (nth 7 bb)
	rds  (nth 8 bb)
	dmt1 (nth 9 bb)
	dvt  (nth 10 bb)
  ) ;_ end of setq

;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )
     (defun axs ()
          (command "_'layer" "_s" " " "")
      )
     (defun ton ()
          (command "_'layer" "_s" "" "")
      )

  (defun ris_shpl ()

    (setq cpt inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)
    
;;;;;;;;;     
    (defun sh_gl ()


      (defun acsl ()
	(setq pto1  (polar cpt (+ pi a1) (* 2.00 mb))
	      ept  (polar cpt (+ 0 a1) (* dln mb))
	      pto2 (polar ept (+ 0 a1) (* 2.00 mb))
	) ;_ end of setq

	(axs)

	(command "_line" pto1 pto2 "")	;   
	(setq label (entlast)
	      sset  (ssadd (entlast))
	) ;_ end of setq
      ) ;_ end of defun

      (acsl)
      

      (if (= dln1 0) (setq dln1 dln0))
      (if (= dln dln0)
	           (setq dln0 (- dln0 fsk)
			 dln1 dln0
		   )	           
      )	
      
					;    
      (defun glsh ()
	
;;;	   
	(setq pt2  (polar cpt (+ (/ pi 2) a1) (* (- (/ dmt 2.00) fsk) mb))
	      pt3  (polar pt2 (+ (/ pi 4) a1) (* (* 1.414214 fsk) mb))
	      pt4  (polar pt3 (+ 0 a1) (* (- dln1 fsk) mb))
	      pt5  (polar pt4 (+ 0 a1) (* (- (- dln dln0) dln1) mb))
              pt6  (polar pt5 (+ 0 a1) (* (- dln0 fsk) mb))
	      pt7  (polar pt6 (+ (/ (* pi 7) 4) a1) (* (* 1.414214 fsk) mb))
	      pt8  (polar pt7 (+ (/ (* pi 3) 2) a1) (* (- dmt (* fsk 2.00)) mb))
	      pt9  (polar pt8 (+ (/ (* pi 5) 4) a1) (* (* 1.414214 fsk) mb))
	      pt10 (polar pt9 (+ pi a1) (* (- dln0 fsk) mb))
	      pt11 (polar pt10 (+ pi a1) (* (- (- dln dln0) dln1) mb))
	      pt12 (polar pt11 (+ pi a1) (* (- dln1 fsk) mb))
	      pt13 (polar pt12 (+ (/ (* pi 3) 4) a1) (* (* 1.414214 fsk) mb))
        )

;;;	    
	(if (< (* (/ (- dmt dvt) 2) mb) 0.6)
	  (progn
	    (setq dvt (- dmt (/ (* 2 0.6) mb)))
	    (if	(> (* (/ (- dmt dvt) 2) mb) (* fsk mb))
	      (setq zam dln1)
	      (setq zam (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)))
	    ) ;_  if
	    (if	(> (* (/ (- dmt dvt) 2) mb) (* fsk mb))
	      (setq zam1 dln0)
	      (setq zam1 (+ (- dln0 fsk) (/ (- dmt dvt) 2.00)))
	    ) ;_  if
	    (setq pt14 (polar pt4
			      (+ (/ (* pi 3) 2) a1)
			      (* (/ (- dmt dvt) 2.00) mb)
		       ) ;_  polar
		  pt15 (polar pt11
			      (+ (/ pi 2) a1)
			      (* (/ (- dmt dvt) 2.00) mb)
		       ) ;_  polar
		  pt16 (polar pt5
			      (+ (/ (* pi 3) 2) a1)
			      (* (/ (- dmt dvt) 2.00) mb)
		       ) ;_  polar
		  pt17 (polar pt10
			      (+ (/ pi 2) a1)
			      (* (/ (- dmt dvt) 2.00) mb)
		       ) ;_  polar
		  pt18 (polar pt14 (+ pi a1) (* zam mb))
		  pt19 (polar pt15 (+ pi a1) (* zam mb))
		  pt20 (polar pt16 (+ 0 a1) (* zam1 mb))
		  pt21 (polar pt17 (+ 0 a1) (* zam1 mb))
	    ) ;_  setq
	  ) ;_  progn
	  (setq	pt14 (polar pt4
			    (+ (/ (* pi 3) 2) a1)
			    (* (/ (- dmt dvt) 2.00) mb)
		     ) ;_  polar
		pt15 (polar pt11
			    (+ (/ pi 2) a1)
			    (* (/ (- dmt dvt) 2.00) mb)
		     ) ;_  polar
		pt16 (polar pt5
			    (+ (/ (* pi 3) 2) a1)
			    (* (/ (- dmt dvt) 2.00) mb)
		     ) ;_  polar
		pt17 (polar pt10
			    (+ (/ pi 2) a1)
			    (* (/ (- dmt dvt) 2.00) mb)
		     ) ;_  polar
		pt18 (polar pt14
			    (+ pi a1)
			    (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
		     ) ;_  polar
		pt19 (polar pt15
			    (+ pi a1)
			    (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
		     ) ;_  polar
		pt20 (polar pt16
			    (+ 0 a1)
			    (* (+ (- dln0 fsk) (/ (- dmt dvt) 2.00)) mb)
		     ) ;_  polar
		pt21 (polar pt17
			    (+ 0 a1)
			    (* (+ (- dln0 fsk) (/ (- dmt dvt) 2.00)) mb)
		     ) ;_  polar
	  ) ;_  setq
	) ;_  if
	       
;;;	    
	(osn)
	(command "_line" pt11 pt12 pt13 pt2 pt3 pt4 "")
	(command "_line" pt5 pt6 pt7 pt8 pt9 pt10 "")
	(if (< (+ dln1 dln0) dln)
	     (progn
	       (command "_line" pt4 pt11 "")
	       (command "_line" pt5 pt10 "")
	     )
	)  
	(command "_line" pt3 pt12 "")
	(command "_line" pt6 pt9 "")
	      
;;;           
      (if (not (< (* (/ dmt 2) mb) 0.6))
	(progn
	  (ton)
	  (if (>= (+ dln1 dln0) dln)
	    (progn
	      (command "_line" pt18 pt20 "")
	      (command "_line" pt19 pt21 "")
	    ) ;_  progn
	    (progn
	      (command "_line" pt14 pt18 "")
	      (command "_line" pt15 pt19 "")
	      (command "_line" pt16 pt20 "")
	      (command "_line" pt17 pt21 "")
	    ) ;_  progn
	  ) ;_  if
	) ;_  progn
      ) ;_  if

	      
					;   
      ) ;_ end of defun


					;   
      (defun strg1 ()
	(setq  pt22 (polar pt4 (+ (/ (* pi 7) 4) a1) (* (* 1.414214 (/ (- dmt dmt1) 2.00)) mb))
	       pt23 (polar pt11 (+ (/ pi 4) a1) (* (* 1.414214 (/ (- dmt dmt1) 2.00)) mb))
	       pt24 (polar pt5 (+ (/ (* pi 5) 4) a1) (* (* 1.414214 (/ (- dmt dmt1) 2.00)) mb))
	       pt25 (polar pt10 (+ (/ (* pi 3) 4) a1) (* (* 1.414214 (/ (- dmt dmt1) 2.00)) mb))
	)
	
      (osn)
	(command "_line" pt4 pt22 pt24 pt5 "")
	(command "_line" pt11 pt23 pt25 pt10 "")
	
      ) ;_ end of defun


	                                 ;      
      (defun strg2 ()

      (osn)
	(command "_line" pt4 pt5 "")
	(command "_line" pt11 pt10 "")
	
      ) ;_ end of defun
	

      (glsh)
      
      (if (= dmt1 0)	
               (strg2)
	       (strg1)
      )	


    ) ;_ end of defun
;;;;;_end of   SH_GL

;;;;;;;  
    (defun sh_vs ()
      
;;;     
      (setq pt2	(polar cpt (+ 0 a1) (* (/ (* dmt 5) 8) mb))
	    pt3	(polar cpt (+ pi a1) (* (/ (* dmt 5) 8) mb))
	    pt4	(polar cpt (+ (/ pi 2) a1) (* (/ (* dmt 5) 8) mb))
	    pt5	(polar cpt (+ (/ (* pi 3) 2) a1) (* (/ (* dmt 5) 8) mb))
      )
      
;;;     
      (if (< (* (/ (- dmt dvt) 2) mb) 0.6)
	(setq dvt (- dmt (/ (* 2 0.6) mb)))
      ) ;_  if
      (setq pt6 (polar cpt (+ (/ (* pi 55) 36) a1) (* (/ dvt 2.00) mb))
	    pt7 (polar cpt (+ (/ (* pi 71) 36) a1) (* (/ dvt 2.00) mb))
      ) 

      (axs)
      (command "_line" pt2 pt3 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" pt4 pt5 "")

      (osn)
      (command "_circle" cpt (* (/ dmt 2.0000) mb))
      
      (if (not (< (* (/ dmt 2) mb) 0.6))
	(ton)
	(command "_arc" "_ce" cpt pt7 pt6)
      ) ;_  if

    ) ;_ end of defun
;;; _end of   SH_VS

    (cond
      ((and (eq glv1 "1")(eq vsv1 "0"))
       (sh_gl)
      )
      ((and (eq glv1 "0")(eq vsv1 "1"))
       (sh_vs)
      )
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun
;;;_end of RIS_shpl

    
    (defun clip_bl ()

      (initget 1)
      (if (eq p1 "1")
	(setq inpt0 (getpoint "\n  :"))
	(setq inpt0 (list (atof xc) (atof yc)))
      ) ;_  if
      (if (eq p2 "1")
	(progn
	  (setq	a1
		 (getangle inpt0
			   (strcat "\n   <" angl ">:")
		 ) ;_  getangle
	  ) ;_  setq
	  (if (= a1 nil)
	    (setq a1 (atof angl))
	  ) ;_  if
	) ;_  progn
	(setq a1 (* pi (/ (atof angl) 180)))
      ) ;_  if 
      (setq mb (atof mash))

      (ris_shpl)

      (if (eq p3 "0")
	(anblk sset cpt)
      ) ;_  if

      (setvar "celtype" cltp)
      (setvar "cecolor" ccol)
      (setvar "aperture" apsz)
      (setvar "osmode" osmd)
      (setvar "clayer" clay)
    ) ;_ end of defun
  
  (clip_bl)
  (prin1)
) ;_ end of defun shpl
