;;;       (  H)
;;;:  ..
;;; : 24.04.2004
;;;CAD-CEE 2000
;;;: (dimVl kv hv pr)
;;;   kv -   (H7, H11, H12, H14, H15, H16  nil -     );
;;;      hv -   (0 - ; 1 - );
;;;      pr -   (0 - ; 1 - )

(defun dimVl (kv hv pr / dfl dfl2 dat1 mash fld	strd strd cmd osmd ccol	cltp dyf
	      it14 it15	it16 as	bs bss bss1 fldat val mb pt1 pt2 distx disty
	      dist ang txt it kv1 spis endw vsp	dat2 kv2 vsp2 h7 h11 h12 clay
	      masht vsp3 vsp4 txt2
	     )

  (setq	dfl  (findfile (strcat pathlisp2 "dim\\dimln.d"))
	dfl2 (findfile (strcat pathlisp2 "dim\\dimVl.d"))
	dat1 (findfile (strcat pathdat2 "dim\\Dimdopsk.dat"))
	dat2 (findfile (strcat pathdat2 "dim\\h71112.dat"))
	spis '(7 11 12 14 15 16)
	endw 0
  ) ;_  setq

  (if (= pr 0)
    (setq vsp2 "h")
    (setq vsp2 "H")
  ) ;_  if

;;;      DIMLN.D 
  (defun rdfl ()
    (setq fld	(open dfl "r")
	  strd	(read-line fld)
	  strdd	(read strd)
	  mash	(rtos (nth 0 strdd))
	  kv2	(itoa (nth 1 strdd))
	  mb	(nth 0 strdd)
    ) ;_  setq
    (close fld)
  ) ;_  defun


;;;      DIMVL.D 
  (defun rdfl2 ()
    (setq fld	(open dfl2 "r")
	  strd	(read-line fld)
	  strdd	(read strd)
	  kv1	(itoa (nth 0 strdd))
	  vsp4	(nth 1 strdd)
    ) ;_  setq
    (close fld)
  ) ;_  defun

;;;       DIMLN.D
  (defun wrfl ()

    (setq fld  (open dfl "w")
	  strd (strcat "(" mash " " kv2 ")")
    ) ;_  setq
    (write-line strd fld)
    (close fld)

  ) ;_  defun

;;;       DIMVL.D
  (defun wrfl2 ()

    (setq fld  (open dfl2 "w")
	  strd (strcat "(" kv1 " \"" vsp4 "\")")
    ) ;_  setq
    (write-line strd fld)
    (close fld)

  ) ;_  defun


;;;      
  (defun desk_f	()
    (setq fldat	(open dat1 "r")
	  as	(read-line fldat)
	  dyf	(read as)
	  bs	(read-line fldat)
	  bss	(read bs)
	  bss1	(nth 0 bss)
	  it14	(nth 1 bss)
	  it15	(nth 2 bss)
	  it16	(nth 3 bss)
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun whl ()
    (while (>= val bss1)
      (setq bs	 (read-line fldat)
	    bss	 (read bs)
	    bss1 (nth 0 bss)
      ) ;_  setq
      (if (>= val bss1)
	(setq it14 (nth 1 bss)
	      it15 (nth 2 bss)
	      it16 (nth 3 bss)
	) ;_  setq
      ) ;_  if
    ) ;_  while
    (close fldat)
  ) ;_  defun

  ;;;      
  (defun desk_f2 ()
    (setq fldat	(open dat2 "r")
	  as	(read-line fldat)
	  dyf	(read as)
	  bs	(read-line fldat)
	  bss	(read bs)
	  bss1	(nth 0 bss)
	  h7	(nth 1 bss)
	  h11	(nth 2 bss)
	  h12	(nth 3 bss)
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun whl2 ()
    (while (>= val bss1)
      (setq bs	 (read-line fldat)
	    bss	 (read bs)
	    bss1 (nth 0 bss)
      ) ;_  setq
      (if (>= val bss1)
	(setq h7  (nth 1 bss)
	      h11 (nth 2 bss)
	      h12 (nth 3 bss)
	) ;_  setq
      ) ;_  if
    ) ;_  while
    (close fldat)
  ) ;_  defun

;;;        
;;;   it -  
  (defun itfn (it / vsp1 vsp2 n i smv str)
    (setq vsp1 (rtos it 2 3)
	  n    (1+ (strlen vsp1))
	  i    1
	  str  ""
    ) ;_  setq
    (while (/= i n)
      (setq smv (substr vsp1 i 1))
      (if (eq smv ".")
	(setq smv ",")
      ) ;_  if
      (setq str	(strcat str smv)
	    i	(1+ i)
      ) ;_  setq
    ) ;_  while
    (setq vsp2 str)
  ) ;_  defun

;;;         
;;;   it -  
  (defun itfn2 (it / vsp1 vsp2 n i smv str)
    (setq vsp1 (rtos it 2 1)
	  n    (1+ (strlen vsp1))
	  i    1
	  str  ""
    ) ;_  setq
    (while (/= i n)
      (setq smv (substr vsp1 i 1))
      (if (eq smv ".")
	(setq smv ",")
      ) ;_  if
      (setq str	(strcat str smv)
	    i	(1+ i)
      ) ;_  setq
    ) ;_  while
    (setq vsp2 str)
  ) ;_  defun

;;;  ------------- -------------
  (setq cmd (getvar "cmdecho"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
;;;  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

;;;   
  (rdfl)
  (rdfl2)

;;;   ()
  (if (= (getvar "USERR1") 0)
    (setq mb (atof mash))
    (setq mb (getvar "USERR1"))
  ) ;_ end of if
  (setq mash (rtos mb))
  (setvar "USERR1" mb)
  (if (< mb 1.0)
    (setq masht (strcat "1:" (rtos (/ 1.0 mb))))
    (setq masht (strcat (rtos mb) ":1"))
  ) ;_ end of if
;;;  
  
;;;  (initget 1)
  (if (= kv nil)
    (progn
      (setq
	kv
	 (getint
	   (strcat
	     "\n\n    "
	     vsp2
	     " (7, 11, 12, 14, 15  16) <"
	     kv1
	     ">:"
	    ) ;_ end of strcat
	 ) ;_  getint
      ) ;_  setq
      (if (or (= kv nil) (not (member kv spis)))
	(setq kv (atoi kv1))
	(setq kv1 (itoa kv))
      ) ;_  if
    ) ;_  progn
  ) ;_  if
  

;;;  (setq	mb (getreal
;;;	     (strcat "\n\n      " vsp2 (itoa kv) " <" mash ">:")
;;;	   ) ;_  getreal
;;;  ) ;_  setq
;;;  (prin1)
;;;  (if (eq mb nil)
;;;    (setq mb (atof mash))
;;;    (setq mash (rtos mb))
;;;  ) ;_  if
  (setq	vsp3
	 (getstring
	   nil
	   (strcat
	     "\n      (Y()  N()) <"
	     vsp4
	     "> ?: "
	   ) ;_ end of strcat
	 ) ;_  getstring
  ) ;_  setq
  (if (or (= vsp3 nil) (= vsp3 "") (= vsp3 " "))
    (setq vsp4 vsp4)
    (setq vsp4 vsp3)
  ) ;_  if
  (if (or (= vsp4 "Y") (= vsp4 "y") (= vsp4 "") (= vsp4 ""))
    (setq txt2 "\\"
	  vsp4 "Y"
    ) ;_  setq
    (setq txt2 ""
	  vsp4 "N"
    ) ;_  setq
  ) ;_  if
  (wrfl2)
  (wrfl)


;;;   

  (while (/= endw 1)
;;;    (setvar "osmode" (+ 512 1)) ;      
    (initget 1)
    (setq pt1 (getpoint
		(strcat "\n\n      ( " masht "):")
	      ) ;_  getpoint
    ) ;_  setq
    (initget 1)
    (setq pt2 (getpoint	pt1
			"\n     :"
	      ) ;_  getpoint
    ) ;_  setq
    (setq dist	(distance pt1 pt2)
	  ang	(angle pt1 pt2)
	  distx	(abs (* dist (cos ang)))
	  disty	(abs (* dist (sin ang)))
    ) ;_  setq
    (if	(= hv 0)
      (setq val (/ distx mb))
      (setq val (/ disty mb))
    ) ;_  if
;;;    (if	(= hv 2)
;;;      (setq val (/ dist mb))
;;;    ) ;_  if
    (if	(or (< val 1) (> val 3150))
      (progn
	(setq endw 1)
	(setvar "cmdecho" cmd)
	(setvar "celtype" cltp)
	(setvar "cecolor" ccol)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(prin1)
	(princ "\n    ")
      ) ;_  progn
    ) ;_  if
    (if	(= endw 0)
      (progn
	(cond ((= kv 7) (desk_f2) (whl2) (setq it h7))
	      ((= kv 11) (desk_f2) (whl2) (setq it h11))
	      ((= kv 12) (desk_f2) (whl2) (setq it h12))
	      ((= kv 14) (desk_f) (whl) (setq it (* it14 2.0)))
	      ((= kv 15) (desk_f) (whl) (setq it (* it15 2.0)))
	      ((= kv 16) (desk_f) (whl) (setq it (* it16 2.0)))
	) ;_  cond
	(if (= pr 1)
	  (setq txt (strcat txt2 (itfn2 val) "@$" (itfn it)))
	  (setq txt (strcat txt2 (itfn2 val) "@&" (itfn it)))
	) ;_  if
	(command "_LAYER" "_s" "" "")
	(cond ((= hv 0)
	       (command "_DIMLINEAR" pt1 pt2 "_h" "_t" txt pause)
	      )
	      ((= hv 1)
	       (command "_DIMLINEAR" pt1 pt2 "_v" "_t" txt pause)
	      )
	) ;_  cond
	(setvar "cmdecho" cmd)
	(setvar "celtype" cltp)
	(setvar "cecolor" ccol)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(prin1)
	(setq vsp
	       (getstring
		 nil
		 (strcat
		   "\n   ENTER  SPACE(),  ESC ("
		   vsp2
		   (itoa kv)
		   ",  "
		   masht
		   "):"
		 ) ;_ end of strcat
	       ) ;_  getstring
	) ;_  setq
	(if (or (= vsp nil) (= vsp "") (= vsp " "))
	  (setq endw 0)
	  (setq endw 1)
	) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  while

  (prin1)
) ;_  DIMVl
