;;;       (  )
;;;:  ..
;;; : 30.01.2003
;;;CAD-CEE 2000
;;;: (dimVl04)

(defun dimVl04 (/ dfl dfl2 dat1 mash fld strd strd cmd osmd ccol cltp dyf
	      it14 it15	it16 as	bs bss bss1 fldat val mb pt1 pt2 distx disty
	      dist ang txt it kv1 spis endw vsp	dat2 kv2 vsp2 h7 h11 h12 clay
              objname objlist rad name endw2 itt masht
	     )

  (setq	dfl   (findfile (strcat pathlisp2 "dim\\dimln.d"))
	dfl2  (findfile (strcat pathlisp2 "dim\\dimVl04.d"))
;;;	dat1  (findfile (strcat pathdat2 "dim\\Dimdopsk.dat"))
;;;	dat2  (findfile (strcat pathdat2 "dim\\h71112.dat"))
;;;	spis  '(7 11 12 14 15 16)
	endw  0
	endw2 t
  ) ;_  setq

;;;      DIMLN.D 
  (defun rdfl ()
    (setq fld	(open dfl "r")
	  strd	(read-line fld)
	  strdd	(read strd)
	  mash	(rtos (nth 0 strdd))
	  kv2	(itoa (nth 1 strdd))
	  mb	(nth 0 strdd)
    ) ;_  setq
    (close fld)
  ) ;_  defun


;;;      DIMVL04.D 
  (defun rdfl2 ()
    (setq fld	(open dfl2 "r")
	  strd	(read-line fld)
	  strdd	(read strd)
	  itt	(nth 0 strdd)
    ) ;_  setq
    (close fld)
  ) ;_  defun

;;;       DIMLN.D
  (defun wrfl ()

    (setq fld  (open dfl "w")
	  strd (strcat "(" mash " " kv2 ")")
    ) ;_  setq
    (write-line strd fld)
    (close fld)

  ) ;_  defun

;;;       DIMVL04.D
  (defun wrfl2 ()

    (setq fld  (open dfl2 "w")
	  strd (strcat "(\"" itt "\")")
    ) ;_  setq
    (write-line strd fld)
    (close fld)

  ) ;_  defun


;;;        
;;;   it -  
  (defun itfn (it / vsp1 vsp2 n i smv str)
    (setq vsp1 (rtos it 2 3)
	  n    (1+ (strlen vsp1))
	  i    1
	  str  ""
    ) ;_  setq
    (while (/= i n)
      (setq smv (substr vsp1 i 1))
      (if (eq smv ".")
	(setq smv ",")
      ) ;_  if
      (setq str	(strcat str smv)
	    i	(1+ i)
      ) ;_  setq
    ) ;_  while
    (setq vsp2 str)
  ) ;_  defun

;;;         
;;;   it -  
  (defun itfn2 (it / vsp1 vsp2 n i smv str)
    (setq vsp1 (rtos it 2 1)
	  n    (1+ (strlen vsp1))
	  i    1
	  str  ""
    ) ;_  setq
    (while (/= i n)
      (setq smv (substr vsp1 i 1))
      (if (eq smv ".")
	(setq smv ",")
      ) ;_  if
      (setq str	(strcat str smv)
	    i	(1+ i)
      ) ;_  setq
    ) ;_  while
    (setq vsp2 str)
  ) ;_  defun

;;;  ------------- -------------
  (setq cmd (getvar "cmdecho"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
;;;  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

;;;   
  (rdfl)
  (rdfl2)

;;;   ()
  (if (= (getvar "USERR1") 0)
    (setq mb (atof mash))
    (setq mb (getvar "USERR1"))
  ) ;_ end of if
  (setq mash (rtos mb))
  (setvar "USERR1" mb)
  (if (< mb 1.0)
    (setq masht (strcat "1:" (rtos (/ 1.0 mb))))
    (setq masht (strcat (rtos mb) ":1"))
  ) ;_ end of if
;;;  

;;;  (setq	mb (getreal
;;;	     (strcat "\n\n   <" mash ">:")
;;;	   ) ;_  getreal
;;;  ) ;_  setq
;;;  (prin1)
;;;  (if (eq mb nil)
;;;    (setq mb (atof mash))
;;;    (setq mash (rtos mb))
;;;  ) ;_  if
  (wrfl)


;;;   

  (while (/= endw 1)
    (while endw2
      (initget 1)
      (setq objname (entsel (strcat "\n     ( " masht "):")))
      (if objname
	(progn
	  (setq objlist (entget (nth 0 objname)))
	  (setq	name  (cdr (assoc 0 objlist))
		endw2 nil
	  ) ;_  setq
	) ;_  progn
      ) ;_  if
      (if (or (eq name "CIRCLE") (eq name "ARC"))
	(setq rad (cdr (assoc 40 objlist)))
	(setq endw2 t)
      ) ;_  if
    ) ;_  while
    (setq endw2 t)
    (setq val (/ rad mb))
;;;     
    (setq vsp
	   (getstring
	     t
	     (strcat "\n   " (itfn2 val) "     <" itt ">: ")
	   ) ;_  getstring
    ) ;_  setq
    (if	(or (= vsp nil) (= vsp ""))
      (setq itt itt)
      (setq itt vsp)
    ) ;_  if
    (if	(= endw 0)
      (progn
	(setq txt (strcat "R" (itfn2 val) itt))
	(command "_LAYER" "_s" "" "")
	(command "_DIMRADIUS" objname txt pause)
;;;	(cond ((eq name "CIRCLE")
;;;	       (command "_DIMDIAMETER" objname txt pause)
;;;	      )
;;;	      ((eq name "ARC")
;;;	       (command "_DIMRADIUS" objname txt pause)
;;;	      )
;;;	) ;_ end of cond
      
	(setvar "cmdecho" cmd)
	(setvar "celtype" cltp)
	(setvar "cecolor" ccol)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(wrfl2)
	(prin1)
	(setq vsp
	       (getstring
		 nil
		 (strcat "\n   ENTER  SPACE(),  ESC ( " masht "):")
	       ) ;_  getstring
	) ;_  setq
	(if (or (= vsp nil) (= vsp "") (= vsp " "))
	  (setq endw 0)
	  (setq endw 1)
	) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  while

  (prin1)
) ;_  DIMVl04
