;;;   - 
;;;:  ..
;;; : 15.04.2002
;;;CAD-CEE 2000
;;;: C:POINT10

(defun c:point10 (/ tipf db d dotv notv	l1 l2 l3 l4 l5 l6 lt l s sech
		  sprd name1 orx aby dlg dfl lsp1 lsp2 lsp3 lsp4 lsp5
		  fld strd strdd strd1 strdd1 p1 p2 p3 angl mash name1
		  spis pti inptG xc yc dcl_id inptG a1 mb cmd blpm apsz
		  osmd clay cltp ccol vs vctr pv anbl sset label sech2
		  sbk py dy pyf	dyf stf	fldat dfl2 as ass bs bss bss1
		  bss2 fldat2 as2 ass2 dtb stb shtrp spism mtr hpa hpn
		  st bd	pd co dat1 dat2	dat3 dat4 dat5 sbk r1 r2 r3 r4
		  r5 lr	tpf dtr	btr htr	sh1 sh2	rst agl	n0 n svr r ms
		  rdm label
		 )

  (setq	dlg  (findfile (strcat pathdcl2 "element\\point10.dcl"))
	dfl  (findfile (strcat pathlisp2 "element\\point10.d"))
  ) ;_  setq



;;;      POINT10.D 
  (defun rdfl ()
    (setq fld	 (open dfl "r")
	  strd1	 (read-line fld)
	  strdd1 (read strd1)
	  sech	 (itoa (nth 0 strdd1))
	  sprd	 (itoa (nth 1 strdd1))
	  sbk	 (itoa (nth 2 strdd1))
	  svr	 (itoa (nth 3 strdd1))
	  shtrp	 (itoa (nth 4 strdd1))
	  strd	 (read-line fld)
	  strdd	 (read strd)
	  p1	 (itoa (nth 0 strdd))
	  p2	 (itoa (nth 1 strdd))
	  angl	 (rtos (nth 2 strdd))
	  mash	 (rtos (nth 3 strdd))
    ) ;_  setq
    (close fld)
  ) ;_  defun


;;;            
  (defun s_t ()
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Svr" svr)
    (set_tile "Shtr" shtrp)
  ) ;_  defun


;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       POINT10.D
  (defun wrfl ()

    (setq fld  (open dfl "w")
	  strd (strcat "(" p1 " " p2 " " angl " " mash ")")
    ) ;_  setq
    (write-line strd1 fld)
    (write-line strd fld)
    (close fld)

  ) ;_  defun


  (defun wrfl_os ()
    (setq strd1	(strcat	"("
			sech
			" "
			sprd
			" "
			sbk
			" "
			svr
			" "
			shtrp
			")"
		) ;_  strcat
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun name ()
    (cond ((and	(eq sech "1")
		(eq sprd "0")
		(eq sbk "0")
		(eq svr "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\shttor(1).slb"))
	  )
	  ((and	(eq sech "0")
		(eq sprd "1")
		(eq sbk "0")
		(eq svr "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\shttor(2).slb"))
	  )
	  ((and	(eq sech "0")
		(eq sprd "0")
		(eq sbk "1")
		(eq svr "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\shttor(3).slb"))
	  )
	  ((and	(eq sech "0")
		(eq sprd "0")
		(eq sbk "0")
		(eq svr "1")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\shttor(4).slb"))
	  )
    ) ;_  cond

  ) ;_  defun


;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
  (defun prv_p (p vf pole pk / n i sm us)
    (setq us 0
	  i  1
	  n  (strlen p)
	  sm (substr p 1 1)
    ) ;_  setq

    (while (not (eq sm ","))
      (if (not (or (eq sm "0")
		   (eq sm "1")
		   (eq sm "2")
		   (eq sm "3")
		   (eq sm "4")
		   (eq sm "5")
		   (eq sm "6")
		   (eq sm "7")
		   (eq sm "8")
		   (eq sm "9")
		   (eq sm ".")
	       ) ;_  or
	  ) ;_  not
	(setq sm ","
	      us 1
	) ;_  setq
      ) ;_  if
      (if (or (= i n) (= us 1))
	(setq sm ",")
	(progn (setq i	(1+ i)
		     sm	(substr p i 1)
	       ) ;_  setq
	       (if (eq sm ",")
		 (setq us 1)
	       ) ;_  if
	) ;_  progn
      ) ;_  if
    ) ;_  while

    (if	(or (/= i n) (= us 1))
      (progn (attn)
	     (mode_tile pole 2)
	     (set vf (eval vf))
	     (if (= vf 'l)
	       (setq l 0)
	     ) ;_  if
	     (if (= (type (eval vf)) 'STR)
	       (set_tile pole (eval vf))
	       (if (= (type (eval vf)) 'INT)
		 (set_tile pole (itoa (eval vf)))
		 (set_tile pole (rtos (eval vf)))
	       ) ;_  if
	     ) ;_  if
      ) ;_  progn
      (if (eq pk "s")
	(set vf p)
	(if (eq pk "i")
	  (set vf (atoi p))
	  (set vf (atof p))
	) ;_  if
      ) ;_  if
    ) ;_  if 
  ) ;_  defun

;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))

;;;    (if (= l 0)
    (setq srv (* 2.0 mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 1.0)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
;;;	     (if (eq sech2 "1")
;;;	       (setq sech "0"
;;;		     sbk  "1"
;;;	       ) ;_  setq
;;;	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
  (defun attn ()
    (new_dialog "att1" dcl_id)
    (action_tile "accept" "(done_dialog 1)")
    (start_dialog)
  ) ;_  defun


;;;    
  (defun ins1 ()

    (if	(and (eq p2 "0") (eq angl nil))
      (setq angl "0")
    ) ;_  if
    (if	(eq p3 nil)
      (setq p3 "0")
    ) ;_  if

    (new_dialog "ins1" dcl_id)

    (setq sech2 sech)
    (s_t1)
    (pred)

    (action_tile "xcor" "(setq xc $value)")
    (action_tile "ycor" "(setq yc $value)")

    (action_tile
      "Mash"
      "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)"
    ) ;_  action_tile
    (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

    (action_tile
      "per1"
      (strcat
	"(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
	"(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
	"(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
	"(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "per2"
      (strcat
	"(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
	"(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile "per3" "(setq p3 $value)")

    (action_tile "accept" "(done_dialog)(wrfl)")
    (action_tile "cancel" "(exit)")

    (start_dialog)			;   


  ) ;_  defun

;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "point10" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (s_t)
    
    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if

;;;       
    (action_tile
      "Sech"
      (strcat "(setq sech $value)" "(setq sprd \"0\")"
	      "(setq sbk \"0\")" "(setq svr \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
	     ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)" "(setq sech \"0\")"
	      "(setq sbk \"0\")" "(setq svr \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
	     ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)" "(setq sech \"0\")"
	      "(setq sprd \"0\")" "(setq svr \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
	     ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Svr"
      (strcat "(setq svr $value)" "(setq sech \"0\")"
	      "(setq sprd \"0\")" "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
	     ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)


;;;   

  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 angl)
	(setq a1 (* (/ (- a1 (/ pi 2)) pi) 180))
      ) ;_  if
    ) ;_  progn
    (setq a1 angl)
  ) ;_  if




  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

;;;  (if (< vs (* (* l mb) 2))
;;;    (command "_ZOOM" "_C" inptG (* (* l mb) 2))
;;;  ) ;_  if


;;;    
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq svr "0")
	 ) ;_  and
	 (if (eq shtrp "1")
	   (command "_INSERT" "c:\\cad-cee2\\dwg\\point10" inptG mb mb a1)
	   (command "_INSERT" "c:\\cad-cee2\\dwg\\pnt10_1" inptG mb mb a1)
	 ) ;_  if
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	      (eq svr "0")
	 ) ;_  and
	 (command "_INSERT" "c:\\cad-cee2\\dwg\\pnt10_2" inptG mb mb a1)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	      (eq svr "0")
	 ) ;_  and
	 (command "_INSERT" "c:\\cad-cee2\\dwg\\pnt10_3" inptG mb mb a1)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq svr "1")
	 ) ;_  and
	 (command "_INSERT" "c:\\cad-cee2\\dwg\\pnt10_4" inptG mb mb a1)
	)
  ) ;_  cond

;;;   
  (if (eq p3 "1")
    (progn
      (setq label (entlast))
      (command "_EXPLODE" label "")
    ) ;_  progn
  ) ;_  if

  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400))
  (prin1)

) ;_  KRPEZL
