;;;       28759.3-90
;;;( )
;;;:  ..
;;; : 12.02.2001
;;;CAD-CEE 2000
;;;: C:FLANAPAR

(defun c:flanapar (/ tipf d dotv notv d1 d2 d3 d4 d5 d6 d7 h b l sech sprd
		    name1 orx aby dlg dfl lsp1 lsp2 fld strd strdd strd1 strdd1
		    p1 p2 p3 angl mash name1 spis pti inptG xc yc dcl_id inptG
		    a1 mb cmd blpm apsz osmd clay cltp ccol vs vctr pv anbl sset
		    label sech2 sbk py dy pyf dyf fldat dfl2 as ass bs bss bss1
		    bss2 fldat2 as2 ass2 dtb stb shtrp spism mtr rad hpa hpn osv1)

  (setq	dlg  (findfile (strcat pathdcl2 "flan\\fn287593.dcl"))
	dfl  (findfile (strcat pathlisp2 "flanapp\\flanapar.d"))
	dfl2 (findfile (strcat pathdat2 "flan\\fn287593.dat"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "flanapp\\flshpapr.lsp"))
	lsp2 (findfile (strcat pathlisp2 "flanapp\\flpazapr.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)
  (load lsp2)

  (setq spis '(
	       "  "
	       "  "
	      ) 
  ) ;_  setq

  (setq spism '(""
	       ""
	      ) 
  ) ;_  setq

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun
  
;;;      FLANAPAR.D 
  (defun rdfl ()
    (setq fld	 (open dfl "r")
	  strd1	 (read-line fld)
	  strdd1 (read strd1)
	  tipf	 (itoa (nth 0 strdd1))
	  py	 (itoa (nth 1 strdd1))
	  dy	 (itoa (nth 2 strdd1))
	  mtr	 (itoa (nth 3 strdd1))
	  l	 (nth 4 strdd1)
	  sech	 (itoa (nth 5 strdd1))
	  sprd	 (itoa (nth 6 strdd1))
	  sbk	 (itoa (nth 7 strdd1))
	  shtrp	 (itoa (nth 8 strdd1))
	  osv1	 (itoa (nth 9 strdd1))
	  strd	 (read-line fld)
	  strdd	 (read strd)
	  p1	 (itoa (nth 0 strdd))
	  p2	 (itoa (nth 1 strdd))
	  angl	 (rtos (nth 2 strdd))
	  mash	 (rtos (nth 3 strdd))
    ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "Py" py)
    (set_tile "Dy" dy)
    (set_tile "Mp" mtr)
    (set_tile "D1" (itoa d1))
    (set_tile "D2" (itoa d2))
    (set_tile "Dotv" (rtos dotv))
    (set_tile "Notv" (itoa notv))
    (set_tile "B" (itoa b))
    (set_tile "L" (itoa l))
    (set_tile "H" (itoa h))
    (set_tile "D6" (itoa d6))
    (set_tile "D7" (itoa d7))
    (set_tile "Osv" osv1)
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Shtr" shtrp)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       FLANAPAR.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " py " " dy  " " mtr " " (itoa l) " " sech
			    " " sprd " " sbk " " shtrp " " osv1 ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flanapr(1).slb"))
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flanapr(5).slb"))
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flanapr(3).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flanapr(2).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flanapr(6).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flanapr(4).slb"))
	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;
  (defun nfn ()
    (set_tile "D3" "")
    (set_tile "D4" "")
    (set_tile "D5" "")
    (set_tile "A" "")
    (set_tile "A1" "")
  )  


  
;;;      
(defun desk_f ()
  (setq	fldat (open dfl2 "r")
	as    (read-line fldat)
	ass   (read as)
	pyf   (nth 0 ass)
	dyf   (nth 1 ass)
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	bss2  (nth 1 bss)
	d     (nth 2 bss)
	d1    (nth 3 bss)
	d2    (nth 4 bss)
	d3    (nth 5 bss)
	d4    (nth 6 bss)
	a     (nth 7 bss)
	d5    (nth 8 bss)
	aa1   (nth 9 bss)
	d6    (nth 10 bss)
	d7    (nth 11 bss)
	b     (nth 12 bss)
	h     (nth 13 bss)
	dotv  (nth 14 bss)
	notv  (nth 15 bss)
  ) ;_  setq
) ;_  defun



 ;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun



;;;      
(defun whl ( )
  (if (or (/= (atof py) (atof bss1))
	  (/= (atof dy) (atof bss2))
      ) ;_  or
    (clos_dfl2)
  ) ;_  if 
  (while (or (/= (atof py) (atof bss1))
	     (/= (atof dy) (atof bss2))
	 ) ;_  or
    (setq bs  (read-line fldat)
	  bss (read bs)
    ) ;_  setq
    (if	(= bss nil)
      (progn (attn2)
	     (if (> (atoi py) 1)
	       (setq py (itoa (- (atoi py) 1)))
	       (setq py (itoa (+ (atoi py) 1)))
	     ) ;_  if
	     (set_tile "Py" py)
	     (clos_dfl2)
	     (whl)
	     (setq py bss1
		   dy bss2
	     ) ;_  setq
	     (set_tile "Py" py)
	     (set_tile "Dy" dy)
	     (mode_tile "Py" 2)
      ) ;_  progn
      (setq bss1 (nth 0 bss)
	    bss2 (nth 1 bss)
	    d	 (nth 2 bss)
	    d1	 (nth 3 bss)
	    d2	 (nth 4 bss)
	    d3	 (nth 5 bss)
	    d4	 (nth 6 bss)
	    a	 (nth 7 bss)
	    d5	 (nth 8 bss)
	    aa1	 (nth 9 bss)
	    d6	 (nth 10 bss)
	    d7	 (nth 11 bss)
	    b	 (nth 12 bss)
	    h	 (nth 13 bss)
	    dotv (nth 14 bss)
	    notv (nth 15 bss)
      ) ;_  setq
    ) ;_  if
  ) ;_  while
  (if (eq mtr "1")
    (setq d3 d5
	  a  (+ aa1 0.6)
    ) ;_  setq
  ) ;_  if
) ;_  defun



;;;     
  (defun vtr()
    (cond ((eq tipf "0")
	   (nfn)
	   (set_tile "D3" (itoa d3))
	   (set_tile "D4" (itoa d4))
	   (set_tile "A" (rtos a))
	  )
	  ((eq tipf "1")
	   (nfn)
	   (set_tile "D5" (itoa d5))
	   (set_tile "A1" (rtos aa1))
	  )
    ) ;_  cond
  )


;;;    
    (defun tipf_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun

;;;    
    (defun pyf_l ()
      (start_list "Py")
      (mapcar 'add_list pyf)
      (end_list)
    ) ;_  defun


;;;    
    (defun dyf_l ()
      (start_list "Dy")
      (mapcar 'add_list dyf)
      (end_list)
    ) ;_  defun

;;;    
    (defun mtrf_l ()
      (start_list "Mp")
      (mapcar 'add_list spism)
      (end_list)
    ) ;_  defun
  

;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun


  ;;;    (   )
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn3 i1 i3 obz)
	 (mode_tile pole 2)
       ) ;_  progn
     ) ;_  if
   ) ;_  defun



;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* dotv mb))
;;;      (setq srv (* (/ (- dn db) 2) mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;   -   Dy  
   (defun attn2 ()
        (new_dialog "att2" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn3 (ot dov obz / str1)
        (setq str1 (strcat "  " (itoa ot) " " obz "   " (rtos dov) " " obz "  0 ."))
        (new_dialog "att3" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun



;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "flanotr" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (desk_f)
    (whl)
    (tipf_l)
    (pyf_l)
    (dyf_l)
    (mtrf_l)
    (s_t)
    (vtr)
    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (mode_tile "Tipf" 2)

;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(vtr)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Py"
      (strcat "(setq py $value)"
	      "(desk_f)"
	      "(whl)"
	      "(s_t)"
	      "(vtr)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Dy"
      (strcat "(setq dy $value)"
	      "(desk_f)"
	      "(whl)"
	      "(s_t)"
	      "(vtr)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Mp"
      (strcat "(setq mtr $value)"
	      "(desk_f)"
	      "(whl)"
	      "(s_t)"
	      "(vtr)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "L"
      (strcat "(prv_p $value 'l \"L\" \"i\")"
	      "(if (> l 0) (prov (+ h 10) l 10000 \"L\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Osv"
      (strcat "(setq osv1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile


    (action_tile "accept" "(close fldat)(done_dialog)")
    (action_tile "cancel" "(close fldat)(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
      ) ;_  if
    ) ;_  progn
    (setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
  ) ;_  if

;;;      
  (setq a1 (+ a1 (/ pi 2)))


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq rad (getvar "filletrad"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))
  (if (> d (+ l b))
    (setq pv (* d mb))
    (setq pv (* (+ l b) mb))
  ) ;_  if

  (if (< vs (* pv 2))
    (command "_ZOOM" "_C" inptG (* pv 2))
  ) ;_  if
  
;;;    
  (cond ((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (if (eq osv1 "0")
	    (flpazapr inptG d d1 d2 d4 d3 a dotv notv b l h d7 d6 0 shtrp a1)
	    (flpazapr inptG d d1 d2 d4 d3 a dotv notv b l h d7 d6 4 shtrp a1)
	 ) ;_  if  
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (flpazapr inptG d d1 d2 d4 d3 a dotv notv b l h d7 d6 1 shtrp a1)
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (flpazapr inptG d d1 d2 d4 d3 a dotv notv b l h d7 d6 2 shtrp a1)
	)
        ((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (if (eq osv1 "0")
	    (flshpapr inptG d d1 d2 d5 aa1 dotv notv b l h d7 d6 0 shtrp a1)
	    (flshpapr inptG d d1 d2 d5 aa1 dotv notv b l h d7 d6 4 shtrp a1)
	 ) ;_  if  
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (flshpapr inptG d d1 d2 d5 aa1 dotv notv b l h d7 d6 1 shtrp a1)
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (flshpapr inptG d d1 d2 d5 aa1 dotv notv b l h d7 d6 2 shtrp a1)
	)
  ) ;_  cond

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "cmdecho" cmd)
  (setvar "blipmode" blpm)
  (setvar "aperture" apsz)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setvar "filletrad" rad)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  FLANAPAR
