;;;    ,   
;;;:  ..
;;; :13.02.2001
;;;CAD-CEE 2000
;;; (flpazapr inptG db d d1 d2 d3 a dotv notv b l h dm dn fl shtr a1)
;;;   :
;;;      inptG -  ;
;;;      db -   , ;
;;;      d -   , ;
;;;      d1 -   , ;
;;;      d2 -  D4 (.  ), ;
;;;      d3 -  D3 (.  ), ;
;;;      a -  , ;
;;;      dotv -  , ;
;;;      notv -  ;
;;;      b -  , ;
;;;      l -  , ;
;;;      h4 -  , ;
;;;      dm -    , ;
;;;      dn -    , ;
;;;      fl -   (0 - ; 1 -  ; 2 - ; 3 -  ; 4 -   );
;;;      shtr -      ("1" -  , "0" - );
;;;      a1 -   , .


(defun flpazapr (inptG db d d1 d2 d3 a dotv notv b l h4 dm dn fl shtr a1 / h h2 rd)

;;;  
  (setq	h  3.0
	h2 5.0
	b  (- b h)
	rd (* 7.0 mb)
  ) ;_  setq


;;;    
  (defun sh_f (/ p1 p2 p3 p4 p5	p6 p7 p8 p9 p10 p11 p12 p13 p15 p16
	       p17 os1 os2 ph1 ph2 ph3 ph4 ph5 ph6 av p2a p2aa p2b
	       p6a p6b p6c p6d label4 label5)

;;;     
    (defun patr_f (/ label3 sm)

;;;  
      (setq p15	(polar p2 (- a1 (/ pi 2)) (* (- l h4) mb))
	    p16	(polar p2a (- a1 (/ pi 2)) (* (- l h4) mb))
	    p17	(polar p16 a1 (* (/ dn 2.0) mb))
	    os2	(polar os1 (- a1 (/ pi 2)) (* (+ l (* b 0.2)) mb))
      ) ;_  setq
      
      (osn)
      (command "_LINE" p2a p16 "")
      (command "_LINE" p2 p15 "")
      (command "_LINE" p16 p17 "")

    ) ;_  defun

;;;     
(setq os1  (polar inptG (+ (/ pi 2) a1) (* (* b 0.1) mb))
      os2  (polar os1 (- a1 (/ pi 2)) (* (+ h4 (* b 0.2)) mb))
      p1   (polar inptG (+ pi a1) (* (/ db 2.0) mb))
      p2   (polar p1 (- a1 (/ pi 2.0)) (* h4 mb))
      p2a  (polar p2 (+ a1 pi) (* (/ (- dn db) 2.0) mb))
      p2aa (polar p2 (+ a1 pi) (* (/ (- dn db) 4.0) mb))
      p6   (polar inptG (+ pi a1) (* (/ d2 2.0) mb))
      p5   (polar p6 (+ a1 (* (/ pi 4.0) 5.0)) (* (* h (sqrt 2.0)) mb))
      p4   (polar p5 (+ pi a1) (* (- (/ (- d1 dotv d2) 2.0) h) mb))
      p3   (polar p4 (- a1 (/ pi 2.0)) (* b mb))
      p2b  (polar p3 a1 (* (/ (- d1 dotv dm) 2.0) mb))
      p6a  (polar p6 a1 (* (/ (- d2 d3) 2.0) mb))
      p6b  (polar p6a (- a1 (/ pi 2)) (* h2 mb))
      p6c  (polar p6b a1 (* a mb))
      p6d  (polar p6c (+ a1 (/ pi 2)) (* h2 mb))
      p7   (polar p4 (+ pi a1) (* dotv mb))
      p8   (polar p7 (+ pi a1) (* (/ (- d (+ dotv d1)) 2.0) mb))
      p9   (polar p8 (- a1 (/ pi 2)) (* b mb))
      p10  (polar p9 a1 (* (/ (- d (+ dotv d1)) 2.0) mb))
      p11  (polar inptG (+ pi a1) (* (/ d1 2.0) mb))
      p12  (polar p11 (- a1 (/ pi 2)) (* (+ b (* h 2)) mb))
      p13  (polar inptG (- a1 (/ pi 2)) (* h4 mb))
      ph1  (polar p10 (+ (* (/ pi 4) 3) a1) (* 5 mb))
      ph2  (polar p2b a1 (* 3 mb))
      ph3  (polar ph2 a1 (* (- dm 6) mb))
      ph4  (polar ph1 a1 (* (+ 8 (+ d1 dotv)) mb))
      ph5  (polar p2aa (- a1 (/ pi 2)) (* 5.0 mb))
      ph6  (polar ph5 a1 (* (+ db (/ (- dn db) 2.0)) mb))
) ;_  setq

    
    (osn)
    (command "_LINE" p2 p13 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))

;;;     
    (command "_LINE" p2a p2b "")
    (setq label4 (entlast))
    (command "_LINE" p2b p3 "")
    (setq label5 (entlast))

    (command "_FILLET" "_R" rd)
    (command "_FILLET" label4 label5)

;;;     
    (command "_PLINE" p4 p5 p6 p6a p6b p6c p6d p1 p2 p2a "")
    
    (if	(/= l 0)
	(patr_f)
    ) ;_  if

 
;;;      
    (command "_PLINE" p7 p8 p9 p10 "")
    (command "_LINE" p4 p7 "")
    (command "_LINE" p3 p10 "")
    (command "_LINE" inptG p1 "")
    (if	(/= fl 3)
      (progn
	(command "_LINE" p6d p6a "")
	(axs)
	(command "_LINE" p11 p12 "")
      ) ;_  progn
    ) ;_  if

    (osn)
;;;      
    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_  while

    (setq label (entlast))
    (if	(and (/= fl 3) (/= fl 4))
      (progn
	(command "_LINE" p7 p10 "")
	(command "_LINE" p3 p4 "")
      ) ;_  progn
    ) ;_  if
    
    (command "_MIRROR" sset "" os1 os2 "_N")
    (axs)
    (command "_LINE" os1 os2 "")

    (setq av (* (/ a1 pi) 180))
    (if	(= shtr "1")
      (progn
	(ton)
	(command "_BHATCH" "_P" "_U" 45 2 "_N" ph1 "")
	(command "_BHATCH" ph2 "")
	(command "_BHATCH" ph3 "")
	(command "_BHATCH" ph4 "")
	(if (/= l 0)
	  (progn
	    (command "_BHATCH" "_P" "_U" 315 2 "_N" ph5 "")
	    (command "_BHATCH" ph6 "")
	  ) ;_  progn
	) ;_  if
      ) ;_  progn
    ) ;_  if
    
;;;      
    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_  while

  ) ;_  SH_F


;;;     
  (defun sp_f (/ p1 p2 p3 os1 os2 os3 os4 av)

    (setq av  (/ pi notv)
	  p1  (polar inptG (+ (+ pi av) a1) (* (/ d1 2.0) mb))
	  p2  (polar p1 (+ (+ pi av) a1) (* (* dotv 0.55) mb))
	  p3  (polar p1 (+ av a1) (* (* dotv 0.55) mb))
	  os1 (polar inptG (+ pi a1) (* (* d 0.55) mb))
	  os2 (polar inptG a1 (* (* d 0.55) mb))
	  os3 (polar inptG (+ a1 (/ pi 2)) (* (* d 0.55) mb))
	  os4 (polar inptG (- a1 (/ pi 2)) (* (* d 0.55) mb))
    ) ;_  setq

    (axs)
    (command "_LINE" p2 p3 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (osn)
    (if	(and (>= (* dotv mb) 0.6) (/= osv1 "1"))
      (progn
	(command "_CIRCLE" p1 "_d" (* dotv mb))
	(setq sset (ssadd (entlast) sset))
      ) ;_  progn
    ) ;_  if
;;;     


    (command "_ARRAY" sset "" "_p" inptG notv "" "")

    (command "_CIRCLE" inptG "_d" (* d mb))
    (command "_CIRCLE" inptG "_d" (* d2 mb))
    (command "_CIRCLE" inptG "_d" (* db mb))

    (if	(> (* h mb) 0.6)
      (command "_CIRCLE" inptG "_d" (* (+ d2 (* h 2)) mb))
    ) ;_  if

    (if	(> (* (/ (- d2 d3) 2.0) mb) 0.6)
      (command "_CIRCLE" inptG "_d" (* d3 mb))
    ) ;_  if

    (if	(> (* a mb) 0.6)
      (command "_CIRCLE" inptG "_d" (* (- d3 (* a 2.0)) mb))
    ) ;_  if

    (axs)
    (command "_CIRCLE" inptG "_d" (* d1 mb))
    (command "_LINE" os1 os2 "")
    (command "_LINE" os3 os4 "")

;;;     
    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_  while

  ) ;_  SP_F


  ;;;     
  (defun sb_f (/ p1 p2 p3 p4 p5	p6 p7 p8 p11 p12 p14 p15 p16 os1 os2
	       p2a p2b p2bb p2c label4 label5)

;;;     
    (defun patr_f2 ()

;;;  
      (setq p15	(polar p2a (- a1 (/ pi 2)) (* (- l h4) mb))
	    p16	(polar p15 a1 (* (/ dn 2.0) mb))
	    os2	(polar os1 (- a1 (/ pi 2)) (* (+ l 3 (* b 0.2)) mb))
      ) ;_  setq
      (command "_LINE" p2a p15 "")
      (command "_LINE" p15 p16 "")

    ) ;_  defun

;;;     
    (setq os1  (polar inptG (+ (/ pi 2) a1) (* (* b 0.1) mb))
	  os2  (polar os1 (- a1 (/ pi 2)) (* (+ h4 (* b 0.2)) mb))
	  p1   (polar inptG (+ pi a1) (* (/ db 2.0) mb))
	  p2   (polar p1 (- a1 (/ pi 2)) (* h4 mb))
	  p2a  (polar p2 (+ a1 pi) (* (/ (- dn db) 2.0) mb))
	  p6   (polar inptG (+ pi a1) (* (/ d2 2.0) mb))
	  p5   (polar p6 (+ a1 (* (/ pi 4.0) 5.0)) (* (* h (sqrt 2.0)) mb))
	  p4   (polar p5 (+ pi a1) (* (- (/ (- d d2) 2.0) h) mb))
	  p3   (polar p4 (- a1 (/ pi 2.0)) (* b mb))
	  p2b  (polar p3 a1 (* (/ (- d dm) 2.0) mb))
	  p2bb (polar p2b a1 (* (/ dm 2.0) mb))
	  p7   (polar p2 a1 (* (/ db 2.0) mb))
	  p8   (polar inptG (- a1 (/ pi 2)) (* h mb))
	  p11  (polar inptG (+ pi a1) (* (/ d1 2.0) mb))
	  p12  (polar p11 (- a1 (/ pi 2)) (* (+ b (* h 2)) mb))
    ) ;_  setq

    (axs)
    (command "_LINE" p11 p12 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))

    (osn)
    ;;;     
    (command "_LINE" p2a p2b "")
    (setq label4 (entlast))
    (command "_LINE" p2b p3 "")
    (setq label5 (entlast))

    (command "_FILLET" "_R" rd)
    (command "_FILLET" label4 label5)
    
;;;     
    (command "_LINE" p3 p2bb "")
    (command "_LINE" p5 p8 "")
    (command "_PLINE" p7 p2 p2a "")
    (command "_PLINE" p3 p4 p5 p6 inptG "")
    (if	(/= l 0)
	(patr_f2)
    ) ;_  if

;;;      
    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_  while

    (setq label (entlast))
    
    (command "_MIRROR" sset "" os1 os2 "_N")
    (axs)
    (command "_LINE" os1 os2 "")
    
    
;;;      
    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_  while

  ) ;_  SB_F


;;;   
  (if (or (= fl 0)(= fl 3)(= fl 4))
    (sh_f)
    (if	(= fl 1)
      (sp_f)
      (sb_f)
    ) ;_  if
  ) ;_  if

;;;   


) ;_  FLPAZAPR

