;;;    
;;;:  ..
;;; : 06.10.2000
;;;CAD-CEE 2000


(defun otvsl ( / cmd blpm apsz osmd clay cltp ccol rfas vcpt ept 
                 dlin dlrch colvit aler1 aler2 aler3 cpt pt1 pt2 
                 pt3 pt4 pt5 pt6 pt7 pt8 pt9 pt10 pt11 pt12 pt1f 
                 pt2f pt3f pt4f pt5f pt6f pt7f pt8f label sset 
                 expp prec partname partname1 partname2 inpt0 a1)



  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  ;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )

     (defun ton ()
          (command "_'layer" "_s" "" "")
      )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 (if (eq fasn1 "1")
     (setq rfas fas1)
     (setq rfas fas2)
 )
     (defun prim ()
	(defun izmer ()  
          (initget 1)
	  (setq vcpt (getpoint "\n  :"))
	  (initget 1)
	  (setq ept (polar vcpt 0 (getdist vcpt "\n  :")))
          (setq dlin (/ (distance vcpt ept) mb))
        )

          (izmer)
        (defun colvt3 ()
          (cond 
               ((and (eq fas11 "0") (eq fas21 "0"))
                (setq dlrch dlin))
               ((and (eq fas11 "1") (eq fas21 "0"))
                (setq dlrch (- dlin rfas)))
               ((and (eq fas11 "1") (eq fas21 "1"))
                (setq dlrch (- dlin rfas rfas)))
           )
          (setq colvit (/ dlrch shagv))
         )
          (colvt3)
          (setq aler1 "\n            " 
                aler2 "\n  3-  " 
                aler3 "\n              ")
          (while (< colvit 3.0) 
                 (progn (alert (strcat aler1 aler2 aler3)) (izmer) (colvt3))
          )
       ) ;_end of prim

          (if (eq dlnu1 "1")
            (progn (prim)
              (setq dlin (/ (distance vcpt ept) mb))
            )
            (setq dlin dln1)
          )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  (defun ris_otvs ()

    (setq cpt inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)

    (if	(> htv rfas)
      (setq rfas htv)
    ) ;_  if

 (setq pt1 (polar cpt (+ (/ pi 2) a1) (* (- (* 0.5 dmtr) htv) mb))
       pt2 (polar cpt (+ (- (/ pi 2)) a1) (* (- (* 0.5 dmtr) htv) mb))
       pt3 (polar pt1 (+ 0 a1) (* dlin mb))
       pt4 (polar pt2 (+ 0 a1) (* dlin mb))
       pt5 (polar cpt (+ (/ pi 2) a1) (* (* 0.5 dmtr) mb))
       pt6 (polar cpt (+ (- (/ pi 2)) a1) (* (* 0.5 dmtr) mb))
       pt7 (polar pt5 (+ 0 a1) (* dlin mb))
       pt8 (polar pt6 (+ 0 a1) (* dlin mb))
       pt9 (polar pt1 (+ (/ pi 2) a1) (* rfas mb))
       pt10 (polar pt2 (+ (- (/ pi 2)) a1) (* rfas mb))
       pt11 (polar pt9 (+ 0 a1) (* dlin mb))
       pt12 (polar pt10 (+ 0 a1) (* dlin mb))
       pt1f (polar pt1 (+ 0 a1) (* rfas mb))
       pt2f (polar pt2 (+ 0 a1) (* rfas mb))
       pt3f (polar pt3 (+ pi a1) (* rfas mb))
       pt4f (polar pt4 (+ pi a1) (* rfas mb))
       pt5f (polar pt1f (+ (/ (* pi 3) 4) a1) (* (* (sqrt 2.0) htv) mb))
       pt6f (polar pt2f (+ (/ (* pi 5) 4) a1) (* (* (sqrt 2.0) htv) mb))
       pt7f (polar pt3f (+ (/ pi 4) a1) (* (* (sqrt 2.0) htv) mb))
       pt8f (polar pt4f (+ (- (/ pi 4)) a1) (* (* (sqrt 2.0) htv) mb))
 )

(defun nonfas ()
  (osn)
  (command "_line" pt1 pt3 "")
  (setq	label (entlast)
	sset  (ssadd (entlast))
  ) ;_ end of setq
  (command "_line" pt2 pt4 "")
  (ton)
  (command "_line" pt5 pt7 ""
	   "_line" pt6 pt8 ""
	  ) ;_  command

) ;_  defun

(defun onefas ()
  (osn)
  (command "_line" pt1f pt3 "")
  (setq	label (entlast)
	sset  (ssadd (entlast))
  ) ;_ end of setq
  (command "_line" pt9 pt1f pt2f pt10 ""
	   "_line" pt2f pt4 ""
	  ) ;_  command
  (ton)
  (command "_line" pt5f	pt7 ""
	   "_line" pt6f pt8	""
	  ) ;_  command
) ;_  defun

(defun twofas ()
  (osn)
  (command "_line" pt1f pt3f "")
  (setq	label (entlast)
	sset  (ssadd (entlast))
  ) ;_ end of setq
  (command "_line" pt9 pt1f pt2f pt10 ""
	   "_line" pt11 pt3f pt4f pt12 ""
	   "_line" pt2f	pt4f ""
	  ) ;_  command
  (ton)
  (command "_line" pt5f	pt7f ""
	   "_line"	pt6f pt8f ""
	  ) ;_  command
) ;_  defun
    
;*********************************************************************
 (cond ((eq fas11 "0") (nonfas))
       ((and (eq fas11 "1")
             (eq fas21 "0")) (onefas))
       ((and (eq fas11 "1")
             (eq fas21 "1")) (twofas))
  )
    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

 ) ;_end of RIS_OTVS

        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  (defun clip_bl ()
    
    

    (initget 1) 
    (if (eq p1 "1")
             (setq inpt0 (getpoint "\n  :"))
             (setq inpt0 (list (atof xc) (atof yc)))
    )
    (if (eq p2 "1")
             (progn 
                  (setq a1 (getangle inpt0 (strcat "\n   <" angl ">:")))
	          (if (= a1 nil)
		           (setq a1 (atof angl))
		  )
	      )
             (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if 
    (setq mb (atof mash))
    
    (ris_otvs)
  
    (if	(eq p3 "0")
           (anblk sset cpt)
    ) ;_  if

    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun
  (clip_bl)


  (prin1)
)
