;;;     ()
;;;:  ..
;;; : 14.08.2001
;;;CAD-CEE 2000
;;;: C:KRDN2

(defun c:krdn2 (/ tipf db d dotv notv d1 d2 d3 d4 d5 d6 h h2 b l s sech sprd
		    name1 orx aby dlg dfl lsp1 lsp2 lsp3 lsp4 lsp5 fld strd strdd
		    strd1 strdd1 p1 p2 p3 angl mash name1 spis pti inptG xc yc
		    dcl_id inptG a1 mb cmd blpm apsz osmd clay cltp ccol
		    vs vctr pv anbl sset label sech2 sbk py dy pyf dyf stf fldat dfl2
		    as ass bs bss bss1 bss2 fldat2 as2 ass2 dtb stb shtrp
		    spism mtr hpa hpn st bd pd co fr ang1 dat1 smin smax d1 massa)

  (setq	dlg  (findfile (strcat pathdcl2 "korpus\\krdn2.dcl"))
	dfl  (findfile (strcat pathlisp2 "korpus\\krdn2.d"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "korpus\\krsh.lsp"))
	dat1 (findfile (strcat pathdat2 "korpus\\flat.dat"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

;;;   
  (setq	dyf '("400"	 "500"	   "600"     "700"     "800"
	       "900"	 "1000"	   "1200"    "1400"    "1600"
	       "1800"	 "2000"	   "2200"    "2400"    "2500"
	       "2600"	 "2800"	   "3000"    "3200"    "3400"
	       "3600"	 "3800"	   "4000"    "4500"    "5000"
	       "5600"
	      )
  ) ;_  setq

;;;    
  (setq stf '("3" "4" "6" "8" "10" "12" "14" "16" "20" "25"))

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun
  (defun textf ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  
;;;      KRDN2.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   dy	  (itoa (nth 0 strdd1))
	   st	  (itoa (nth 1 strdd1))
	   sech	  (itoa (nth 2 strdd1))
	   sprd	  (itoa (nth 3 strdd1))
	   shtrp  (itoa (nth 4 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "D" dy)
    (set_tile "S" st)
    (set_tile "D1" (rtos d))
    (set_tile "M" massa)
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Shtr" shtrp)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       KRDN2.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" dy " " st " " sech " " sprd " " shtrp ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\krdn(3).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\krdn(2).slb"))
	)
  ) ;_  cond

) ;_  defun

;;;      
(defun desk_f ()
  (setq	fldat (open dat1 "r")
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	d     (nth 1 bss)
	smin  (nth 2 bss)
	smax  (nth 3 bss)
  ) ;_  setq
) ;_  defun


 ;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun



;;;      
(defun whl ()
  (if (/= d1 bss1)
    (clos_dfl2)
  ) ;_  if 
  (while (/= d1 bss1)
    (setq bs   (read-line fldat)
	  bss  (read bs)
	  bss1 (nth 0 bss)
	  d    (nth 1 bss)
	  smin (nth 2 bss)
	  smax (nth 3 bss)
    ) ;_  setq
  ) ;_  while
) ;_  defun


  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;   
    (defun dyf_l ()
      (start_list "D")
      (mapcar 'add_list dyf)
      (end_list)
    ) ;_  defun

;;;    
    (defun stf_l ()
      (start_list "S")
      (mapcar 'add_list stf)
      (end_list)
    ) ;_  defun

  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

  

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;    
  (defun rs_mss	(/  ro so vo)
    (setq ro     7950 ;    (121810-)
          so     (* pi (expt (/ d 2.0) 2.0))
	  vo     (* (* so s) 0.000000001)
	  massa  (* vo ro)
	  massa  (rtos massa 2 3)
    ) ;_  setq  
  ) ;_  defun


;;;    
;;;  : (os_ln l)
;;;      l -   
   (defun os_ln	(l / pt1)
         (setq pt1 (polar inptG (+ a1 (/ pi 2.0)) (* l mb)))
         (axs)
         (command "_LINE" inptG pt1 "")
         (setq label (entlast))
         (setq sset (ssadd (entlast)))
   ) ;_  defun


;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "krdn2" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (dyf_l)
    (stf_l)
    (setq d1 (atof (nth (atoi dy) dyf))
	  s (atof (nth (atoi st) stf))
    ) ;_  setq
    (desk_f)
    (whl)
    (rs_mss)
    (s_t)
    
    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (mode_tile "D" 2)

;;;     
    (action_tile
      "D"
      (strcat "(setq dy $value)"
	      "(setq d1 (atof (nth (atoi dy) dyf)))"
	      "(whl)"
	      "(prov smin s smax \"S\" \"\")"
	      "(rs_mss)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile  
    (action_tile
      "S"
      (strcat "(setq st $value)"
	      "(setq s  (atof (nth (atoi st) stf)))"
	      "(prov smin s smax \"S\" \"\")"
	      "(rs_mss)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(if (<= smin s smax) (done_dialog) (prov smin s smax \"S\" \"\"))")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 (- a1 (/ pi 2)))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* d mb) 2))
    (command "_ZOOM" "_C" inptG (* (* d mb) 2))
  ) ;_  if

  
;;;    
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (os_ln s)
	 (krsh d s inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (krsh2 d inptG a1 mb)
	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  KRDN2
