;;;    
;;;: (shell d sp l ip a1 mb)
;;;:   d -   ;
;;;       sp -   ;
;;;       l -  ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 02.08.2001

(defun shell (d	 sp   l	  ip   a1   mb	 /    p1   p2	p3   p5	  p4
		p6   p7	  p8   ks0  ks12 z    r1   a	box  pt	  lsta
		e    flag ang1 pt1  pt2	 lt
	       ) 

  (command "_layer" "_s" "" "")

;;;      
  (setq	r1 (* d mb 0.5)
	sp (* mb sp)
	l (* mb l)
	p1 (polar ip (+ a1 pi) (+ r1 sp))
	p2 (polar ip (+ a1 pi) r1)
	p3 (polar ip a1 r1)
	p4 (polar ip a1 (+ r1 sp))
	p5 (polar p1 (- a1 (/ pi 2.0)) l)
	p6 (polar p2 (- a1 (/ pi 2.0)) l)
	p7 (polar p3 (- a1 (/ pi 2.0)) l)
	p8 (polar p4 (- a1 (/ pi 2.0)) l)
  ) ;_  setq

  (command "_line" p1 p5 "" "_line" p2 p6 "" "_line" p3 p7 "" "_line" p4 p8 "")
  (command "_line" p1 p4 "" "_line" p5 p8 "")
  
  (if (eq shtrp "1")
    (progn
      (setq lt	 (distance p5 p2)
	    ang1 (angle p5 p2)
	    pt1	 (polar p5 ang1 (/ lt 2.0))
	    pt2	 (polar pt1 a1 (+ (* r1 2.0) sp))
	    av	 (* (/ a1 pi) 180)
      ) ;_  setq
      (command "_layer" "_s" "" "")
      (command "_bhatch" "_p" "_u" (+ av 45) 2.0 "_n" pt1 pt2 "")
    ) ;_  progn
  ) ;_  if
 
  
) ;_  SHELL


;;;   
;;;: (shell2 d s ip a1 mb)
;;;:   d -   ;
;;;       s -   ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 02.08.2001
(defun shell2 (d s ip a1 mb / pt1 pt2 pt3 pt4 p1 p2 p3 p4)
      (command "_layer" "_s" "" "")
      (command "_circle" ip (* (/ d 2.0) mb))
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_circle" ip (* (+ (/ d 2.0) s) mb))
;;;     
      (setq pt1	(polar ip (+ a1 pi) (* (* (+ d (* s 2.0)) 0.55) mb))
	    pt2	(polar pt1 a1 (* (* (+ d (* s 2.0)) 1.1) mb))
	    pt3	(polar ip (+ a1 (/ pi 2.0)) (* (* (+ d (* s 2.0)) 0.55) mb))
	    pt4	(polar pt3 (- a1 (/ pi 2.0)) (* (* (+ d (* s 2.0)) 1.1) mb))
      ) ;_  setq

      (command "_layer" "_s" " " "")
      (command "_line" pt1 pt2 "")
      (command "_line" pt3 pt4 "")

;;;  
      (if (eq shtrp "1")
	(progn
	  (setq	p1   (polar inptG (+ a1 (/ pi 4.0)) (* (+ (/ d 2.0) (* s 0.5)) mb))
		p2   (polar inptG (+ a1 (* (/ pi 4.0) 3.0)) (* (+ (/ d 2.0) (* s 0.5)) mb))
		p3   (polar inptG (+ a1 (* (/ pi 4.0) 5.0)) (* (+ (/ d 2.0) (* s 0.5)) mb))
		p4   (polar inptG (+ a1 (* (/ pi 4.0) 7.0)) (* (+ (/ d 2.0) (* s 0.5)) mb))
		av   (* (/ a1 pi) 180)
	  ) ;_  setq
	  (command "_layer" "_s" "" "")
	  (command "_bhatch" "_p" "_u" (+ av 45) 2.0 "_n" p1 p2 p3 p4 "")
	) ;_  progn
      ) ;_  if
) ;_  SHELL2

;;;   
;;;: (shell3 d sp l ip a1 mb)
;;;:   d -   ;
;;;       sp -   ;
;;;       l -  ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 03.08.2001

(defun shell3 (d  sp   l   ip   a1   mb	 /    p1   p2	p3   p5	  p4
		p6   p7	  p8   ks0  ks12 z    r1   a	box  pt	  lsta
		e    flag ang1 pt1  pt2	 lt
	       ) 

  (command "_layer" "_s" "" "")

;;;      
  (setq	r1 (* d mb 0.5)
	sp (* mb sp)
	l (* mb l)
	p1 (polar ip (+ a1 pi) (+ r1 sp))
	p4 (polar ip a1 (+ r1 sp))
	p5 (polar p1 (- a1 (/ pi 2.0)) l)
	p8 (polar p4 (- a1 (/ pi 2.0)) l)
  ) ;_  setq

  (command "_line" p1 p5 "" "_line" p4 p8 "")
  (command "_line" p1 p4 "" "_line" p5 p8 "")
  
) ;_  SHELL3