;;;    90  
;;;: (lpotr2 dn l1 b b1 h h1 k lf d s1 s2 al hl ip an1 mb pdl shtrp)
;;;:   dn -   Dn;
;;;       l1 -  l1;
;;;       b -  b;
;;;       b1 -  b1;
;;;       h -  h;
;;;       h1 -  h1;
;;;       k -  K;
;;;       lf -  lf;
;;;       d -   d;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       hl -  B;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - );
;;;       shtrp -  ("1" - , "0" - )
;;; : 03.10.2001

(defun lpotr2 (dn l1   b    b1	 h    h1   k	lf   d	  s1   s2
		  al   hl   ip	 an1  mb   pdl	shtrp	  /    p1
		  p2   p3   p4	 p5   p6   p7	p8   ks0  ks12 z
		  box  lsta e	 flag ang1 lt1	lt2  p9	  p10  an0
		  an2  ip1  pc3	 an3  label1	sset1	  r0   p11
		  p12  p13  p14	 p15  p16  p17	p18  p19  p20  p21
		  p21a p22  p23	 p24  p25  p26	p16a p27  p28  p29
		  p30  p31  os1	 os2  os3  os4	p28a p30a
		 ) 


;;;      
  (setq	r0 (* dn 0.5 mb)
	l1 (* l1 mb)
	b  (* b mb)
	b1 (* b1 mb)
	h  (* h mb)
	h1 (* h1 mb)
	k  (* k mb)
	lf (* lf mb)
	d  (* d mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
;;;	al (* al mb)
	hl (* hl mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt xt1 lt1 lt2 lt3 lt4)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (* b1 0.5)
	   lt3 (* b 0.5)
	   xt  (- lt1 (sqrt (- (expt lt1 2.0) (expt lt2 2.0))))
	   xt1 (- lt1 (sqrt (- (expt lt1 2.0) (expt lt3 2.0))))
	   l1  (- l1 xt)
	   k   (- k xt1)
	   lt4 (* (- l1 k) 1.73205)
     ) ;_  setq
;;;        
     (setq p1  (polar ip an1 s2)
;;;	   p2  (polar p1 an1 (- b b1))
;;;	   p3  (polar p2 (- an1 (/ pi 2.0)) h1)
;;;	   p4  (polar p3 an1 b2)
;;;	   p5  (polar p4 (+ an1 (/ pi 2.0)) h1)
	   p6  (polar p1 an1 l1)
	   p7  (polar p6 (+ an1 (/ pi 2.0)) (- h1 h))
;;;	   p8  (polar p6 (+ an1 (/ pi 2.0)) n)
	   p10 (polar p1 (+ an1 (/ pi 2.0)) h1)
	   p9  (polar p10 an1 k)
	   p8  (polar p7 (+ an1 (/ pi 2.0)) (- h lt4))
	   p11 (polar p7 (+ an1 pi) l1)
	   p12 (polar p1 (- an1 (/ pi 2.0)) (/ (- hl h1) 2.0));  
	   p13 (polar p12 (+ an1 pi) s2);  
	   p14 (polar p13 (+ an1 (/ pi 2.0)) hl);  
	   p15 (polar p14 an1 s2);  
     ) ;_  setq
    
;;;       
     (setq p28a	(polar p7 (+ an1 pi) lf)
	   p29  (polar p28a an1 (/ d 2.0))
	   p30  (polar p29 (- an1 (/ pi 2.0)) (- h1 h))
	   os3  (polar p28a (+ an1 (/ pi 2.0)) s1)
	   os4  (polar os3 (- an1 (/ pi 2.0)) (+ (- h1 h) s1 s1)) 
     ) ;_  setq

;;;      (  )
     (osn)
     (command "_LINE" p1 p6 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
;;;     (command "_LINE" p2 p3 p4 p5 "")
     (command "_LINE" p6 p8 p9 p10 "")
     (command "_LINE" p7 p11 "")
     (command "_LINE" p1 p10 "")

;;;     
     (if (= pdl "1")
       (command "_LINE" p1 p12 p13 p14 p15 p10 "")
     ) ;_  if

;;;      
     (axs)
;;;     (command "_LINE" os1 os2 "")
     (command "_LINE" os3 os4 "")

;;;     
    (osn)
    (command "_LINE" p29 p30 "")
    (setq label1 (entlast))
    (command "_MIRROR" label1 "" os3 os4 "_N")

;;; ----  -----
    (if	(eq shtrp "1")
      (sht)
    ) ;_  if

  ) ;_  OPR


;;;    
  (defun sht (/ dl1 dl3 ang1 ang3 pt1 pt2 pt3)
    (setq dl1  (distance p13 p15)
	  dl3  (distance p6 p29)
	  ang1 (angle p13 p15)
	  ang3 (angle p6 p29)
	  pt1  (polar p13 ang1 (/ dl1 2.0))
	  pt2  (polar p1 (+ an1 (/ pi 4.0)) (- h1 h))
	  pt3  (polar p6 ang3 (/ dl3 2.0))
    ) ;_  setq
    (ton)
    (command "_BHATCH" "_p" "_u" 45 2.0 "_n" pt2 pt3 "")
    (if	(eq pdl "1")
      (command "_BHATCH" "_p" "_u" 315 3.0 "_n" pt1 "")
    ) ;_  if
  ) ;_  SHT
 
;;;  ---------- ---------
  (opr)
  
) ;_  LPOTR2


;;;    90   
;;;: (lpotra2 dn n0 l1 b b1 k lf d s1 s2 al ip an1 mb pdl)
;;;:   dn -   Dn;
;;;       n0 -  ;
;;;       l1 -  l1;
;;;       b -  b;
;;;       b1 -  b1;
;;;       k -  k;
;;;       lf -  lf;
;;;       d -   d;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - )
;;; : 03.10.2001

(defun lpotra2 (dn n0	l1   b	  b1   k    lf	 d    s1   s2	al
		   ip	an1  mb	  pdl  /    p1	 p2   p3   p4	p5
		   p6	p7   p8	  ks0  ks12 z	 box  lsta e	flag
		   ang1	lt1  lt2  p9   p10  an0	 an2  ip1  pc3	an3
		   label1    sset1     r0   pc1  pc2  os1	os2
		   os3	os4  os5  label2    sset2     p11  p12	p3a
		   p2a  an3  an4
		  ) 


;;;      
  (setq	r0 (* dn 0.5 mb)
	l1 (* l1 mb)
	b  (* b mb)
	b1 (* b1 mb)
	k  (* k mb)
	lf (* lf mb)
	d  (* d mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
	al (* al mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt xt1 xt2 lt1 lt2 lt3 lt4)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (- (* b 0.5) s1)
	   lt3 (* b 0.5)
	   lt4 (* b1 0.5)
	   xt  (- lt1 (sqrt (- (expt lt1 2.0) (expt lt2 2.0))))
	   xt1 (- lt1 (sqrt (- (expt lt1 2.0) (expt lt3 2.0))))
	   xt2 (- lt1 (sqrt (- (expt lt1 2.0) (expt lt4 2.0))))
	   ip1 (polar ip (+ an1 pi) r0)
	   an0 (/ al (* 2.0 (+ r0 (* 0.5 s2))))
	   an2 (/ b1 (* 2.0 (+ r0 s2)))
     ) ;_  setq
;;;        
     (setq p1  (polar ip an1 s2)
	   p2  (polar p1 (+ an1 pi) xt)
	   p2  (polar p2 (+ an1 (/ pi 2.0)) lt2)
           p3  (polar p1 (+ an1 pi) xt1)
	   p3  (polar p3 (+ an1 (/ pi 2.0)) lt3)
	   p4  (polar p1 (+ an1 pi) xt2)
	   p4  (polar p4 (+ an1 (/ pi 2.0)) lt4)
;;;	   p4  (polar ip1 (+ an1 an2) lt1)
	   p5  (polar p4 an1 l1)
	   p6  (polar p3 an1 (- l1 (- xt2 xt1)))
	   p7  (polar p2 an1 (- l1 (- xt2 xt)))
;;;	   p6  (polar p5 (- an1 (/ pi 2.0)) (/ (- b1 b) 2.0))
;;;	   p7  (polar p6 (- an1 (/ pi 2.0)) s1)
;;;	   p3  (polar p6 (+ an1 pi) (- l1 xt1))
;;;	   p2  (polar p7 (+ an1 pi) (- l1 xt))
	   p3a (polar p3 an1 k)
	   p2a (polar p3a (- an1 (/ pi 2.0)) s1)
	   p8  (polar p5 (- an1 (/ pi 2.0)) (/ b1 2.0))
	   p9  (polar ip1 (+ an1 an0) (+ r0 s2))
	   p10 (polar ip1 (+ an1 an0) r0)
	   os1 (polar ip an1 (+ l1 s2 s1))
	   pc2 (polar p8 (+ an1 pi) lf)
     ) ;_  setq
    
;;;        
     (setq os4 (polar pc2 (+ an1 (/ pi 2.0)) d)
	   os5 (polar pc2 (- an1 (/ pi 2.0)) d)
     ) ;_  setq

;;;      (  )
     (osn)
     (command "_LINE" p2a p3a "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
     (setq label1 (entlast))
     (setq sset1 (ssadd (entlast)))
     (setq label2 (entlast))
     (setq sset2 (ssadd (entlast)))
     (command "_LINE" p4 p5 p8 "")
     (command "_LINE" p6 p3 "" "_LINE" p7 p2 "")
;;;     (command "_ARC" "_c" ip1 p1 p4)

;;;     
     (if (= pdl "1")
       (progn
	 (command "_ARC" "_c" ip1 p1 p9)
	 (command "_LINE" p9 p10 "")
       ) ;_  progn
     ) ;_  if

     (while (setq label1 (entnext label1))
       (setq sset1 (ssadd label1 sset1))
     ) ;_  while
     (command "_MIRROR" sset1 "" os1 ip "_N")

;;;      
     (axs)
     (command "_LINE" ip os1 "")
     (command "_LINE" os4 os5 "")

;;;     
    (osn)
    (command "_CIRCLE" pc2 (/ d 2.0))
    
;;; 
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (if	(> n0 1)
      (command "_ARRAY" sset2 "" "_p" ip1 n0 "" "")
    ) ;_  if
 
  ) ;_  OPR

;;;  ---------- ---------
  (opr)
) ;_  LPOTRA2


;;;    90 
;;;: (lpotrb2 dn l1 b b1 h h1 k s1 s2 al hl ip an1 mb pdl)
;;;:   dn -   Dn;
;;;       l1 -  l1;
;;;       b -  b;
;;;       b1 -  b1;
;;;       h -  h;
;;;       h1 -  h1;
;;;       k -  k;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       hl -  H;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - )
;;; : 03.10.2001

(defun lpotrb2 (dn l1	b    b1	  h    h1   k	 s1   s2   al	hl
		   ip	an1  mb	  pdl  /    p1	 p2   p3   p4	p5
		   p6	p7   p8	  ks0  ks12 z	 box  lsta e	flag
		   ang1	lt1  lt2  p9   p10  an0	 an2  ip1  pc3	an3
		   label1    sset1     r0   p11	 p12  xt1  p4a	p5a
		   pc1	pc2
		  ) 


;;;      
  (setq	r0 (* dn 0.5 mb)
	l1 (* l1 mb)
	b  (* b mb)
	b1 (* b1 mb)
	h  (* h mb)
	h1 (* h1 mb)
	k  (* k mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
	al (* al mb)
	hl (* hl mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt xt1 xt2 lt1 lt2 lt3 lt4 lt5)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (* b1 0.5)
	   lt3 (* b 0.5)
	   xt  (- lt1 (sqrt (- (expt lt1 2.0) (expt lt2 2.0))))
	   xt1 (- lt1 (sqrt (- (expt lt1 2.0) (expt lt3 2.0))))
	   lt4 (/ (- hl h1) 2.0)
	   an0 (/ al (* 2.0 (+ r0 (* s2 0.5))))
	   xt2  (* lt1 (sin an0))
	   lt5 (* (- (- l1 xt) (- k xt1)) 1.73205)
     ) ;_  setq
;;;        
     (setq ;p1  (polar ip (+ an1 pi) (/ a2 2.0))
	   p2  (polar ip (+ an1 pi) (/ b1 2.0))
	   p3  (polar p2 (+ an1 (/ pi 2.0)) (- h1 h))
	   p6  (polar ip (+ an1 (/ pi 2.0)) (- h1 h))
	   p4  (polar p6 (+ an1 pi) (/ b 2.0))
	   p5  (polar p6 (+ an1 pi) (- (/ b 2.0) s1))
;;;	   p7  (polar ip (- an1 (/ pi 2.0)) h1)
;;;	   p8  (polar p7 (+ an1 pi) (/ a2 2.0))
	   p9  (polar p4 (+ an1 (/ pi 2.0)) h)
	   p10 (polar p5 (+ an1 (/ pi 2.0)) h)
	   p4a (polar p4 (+ an1 (/ pi 2.0)) (- h lt5))
	   p5a (polar p5 (+ an1 (/ pi 2.0)) (- h lt5))
	   pc1 (polar ip (+ an1 (/ pi 2.0)) (+ h1 lt4))
	   pc2 (polar pc1 (- an1 (/ pi 2.0)) hl)
	   p11 (polar pc1 (+ an1 pi) xt2)
	   p12 (polar p11 (- an1 (/ pi 2.0)) hl)
     ) ;_  setq
    

;;;      (  )
     (osn)
     (command "_LINE" ip p2 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
     (setq label1 (entlast))
     (setq sset1 (ssadd (entlast)))
     (command "_LINE" p2 p3 p6 "")
     (command "_LINE" p4 p9 p10 p5 "")
;;;     (command "_LINE" p7 p8 p1 "")
     (command "_LINE" p4a p5a "")

;;;     
     (if (= pdl "1")
       (command "_LINE" pc2 p12 p11 pc1 "")
     ) ;_  if

;;;     
     (while (setq label1 (entnext label1))
       (setq sset1 (ssadd label1 sset1))
     ) ;_  while
     (command "_MIRROR" sset1 "" pc1 pc2 "_N")
  ) ;_  OPR
 
;;;  ---------- ---------
  (opr)
  
) ;_  LPOTRB2


;;;    90  
;;;: (lpotrc2 dn l1 b b1 h h1 k s1 s2 al hl ip an1 mb pdl)
;;;:   dn -   Dn;
;;;       l1 -  l1;
;;;       b -  b;
;;;       b1 -  b1;
;;;       h -  h;
;;;       h1 -  h1;
;;;       k -  K;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       hl -  B;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - );
;;; : 03.10.2001

(defun lpotrc2 (dn l1	b    b1	  h    h1   k	 s1   s2   al	hl
		   ip	an1  mb	  pdl  /    p1	 p2   p3   p4	p5
		   p6	p7   p8	  ks0  ks12 z	 box  lsta e	flag
		   ang1	lt1  lt2  p9   p10  an0	 an2  ip1  pc3	an3
		   label1    sset1     r0   p11	 p12  p13  p14	p15
		   p16	p17  p18  p19  p20
		  )



;;;      
  (setq	r0 (* dn 0.5 mb)
	l1 (* l1 mb)
	b  (* b mb)
	b1 (* b1 mb)
	h  (* h mb)
	h1 (* h1 mb)
	k  (* k mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
	al (* al mb)
	hl (* hl mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt xt1 xt2 xt3 xt4 lt1 lt2)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (* b1 0.5)
	   lt3 (* b 0.5)
	   xt  (- lt1 (sqrt (- (expt lt1 2.0) (expt lt2 2.0))))
	   xt1 (- lt1 (sqrt (- (expt lt1 2.0) (expt lt3 2.0))))
	   lt4 (* (- (- l1 xt) (- k xt1)) 1.73205)
;;;	   ip1 (polar ip (+ an1 pi) r0)
	   an0 (/ al (* 2.0 (+ r0 (* s2 0.5))))
	   xt2 (- (+ r0 s2) (* r0 (cos an0)))
	   xt3 (- (+ r0 s2) (* (+ r0 s2) (cos an0)))
     ) ;_  setq
;;;        
     (setq p1  (polar ip an1 s2)
;;;	   p2  (polar p1 an1 (- b b1 xt))
;;;	   p3  (polar p2 (- an1 (/ pi 2.0)) h1)
;;;	   p4  (polar p3 an1 b2)
;;;	   p5  (polar p4 (+ an1 (/ pi 2.0)) h1)
	   p6  (polar p1 an1 (- l1 xt))
	   p7  (polar p6 (+ an1 (/ pi 2.0)) (- h1 h))
	   p8  (polar p7 (+ an1 (/ pi 2.0)) (- h lt4))
	   p10 (polar p1 (+ an1 (/ pi 2.0)) h1)
	   p9  (polar p10 an1 (- k xt1))
	   p18 (polar p10 (+ an1 pi) xt1)
	   p20 (polar p18 (- an1 (/ pi 2.0)) h)
	   p19 (polar p1 (+ an1 pi) xt)
	   p11 (polar p7 (+ an1 pi) l1)
	   p12 (polar p1 (- an1 (/ pi 2.0)) (/ (- hl h1) 2.0));  
	   p13 (polar p12 (+ an1 pi) xt2);  
	   p14 (polar p13 (+ an1 (/ pi 2.0)) hl);  
	   p15 (polar p14 an1 xt2);  
	   p16 (polar p12 (+ an1 pi) xt3);  
	   p17 (polar p16 (+ an1 (/ pi 2.0)) hl);  
     ) ;_  setq

;;;     
    (if	(= pdl "1")
      (obrobj p12 hl (* 4.0 s2) (/ pi 2.0))
      (obrobj p19 h1 (* 4.0 s1) (/ pi 2.0))
    ) ;_  if


;;;      (  )
     (osn)
     (command "_LINE" p19 p6 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
;;;     (command "_LINE" p2 p3 p4 p5 "")
     (command "_LINE" p6 p8 p9 p18 "")
     (command "_LINE" p7 p11 "")
     (command "_LINE" p20 p18 "")
     (command "_LINE" p7 p11 p19 "")

;;;     
     (if (= pdl "1")
       (command "_LINE" p1 p12 p13 p14 p15 p10 "" "_LINE" p16 p17 "")
     ) ;_  if
  ) ;_  OPR
 
;;;  ---------- ---------
  (opr)
  
) ;_  LPOTRC2