;;; -    ( 1)
;;;: (stotr1 dn s d10 ag a a1 a2 b b1 b2 b3 c 1 h h1 m n d d1 d2 s1 s2 al hl ip an1 mb pr pr2 pdl shtrp)
;;;:   dn -   Dn;
;;;       s -    S;
;;;       d10 -   ;
;;;       ag -     ;
;;;       a -  a;
;;;       a1 -  a1;
;;;       a2 -  a2;
;;;       b -  b;
;;;       b1 -  b1;
;;;       b2 -  b2;
;;;       b3 -  b3;
;;;       c -  c;
;;;       c1 -  c1;
;;;       h -  h;
;;;       h1 -  h1;
;;;       m -  m;
;;;       n -  n;
;;;       d -   d;
;;;       d1 -   d1;
;;;       d2 -   d2;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       hl -  H;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pr -   (1 - , 2 - , 3 -  , 4 - )
;;;       pr2 -    (0 -  , 1 -  )
;;;       pdl -    ("1" - );
;;;       shtrp -  ("1" - , "0" - )
;;; : 16.01.2002

(defun stotr1 (dn s     d10   ag	   a	 a1    a2    b	   b1	 b2
		 b3    c     1	   h	 h1    m     n	   d	 d1
		 d2    s1    s2	   al	 hl    ip    an1   mb	 pr
		 pr2   pdl   shtrp /	 po1   po2   po3   po4	 po5
		 po6   po7   po8   po1a	 po2a  po3a  po4a  po5a	 po6a
		 po7a  po8a  po9   po10	 po11  po12  po13  po14	 po15
		 po9a  po10a po11a po12a po13a po14a po15a pto1	 po16
		 po17  po15b po15c po16a po16b po16c po17a po17b po17c
		 pto2  elpt  ang1  ang2	 ang3  ang4  ang5  po18	 po19
		 po20  po21  po18a po19a po20a po21a pco2  po22	 po23
		 po24  po25  po22a po23a po24a po25a pto3  pto4	 p1
		 p2    p3    p4	   p5	 p6    p7    p8	   ks0	 ks12
		 z     box   lsta  e	 flag  ang1  lt1   lt2	 p9
		 p10   an0   an2   ip1	 pc3   an3   label1	 sset1
		 r0    p11   p12   p13	 p14   p15   p16   p17	 p18
		 p19   p20   p21   p23a	 p22   p23   p24   p25	 p26
		 p18a  p27   p28   p29	 p30   p31   os1   os2	 os3
		 os4   p20a  p30a  xt1	 lspo1 lspo2 p3a   pob1  pob2
	         lt1   pc1   pc2   ipc   p2a   p5a   x0    y0    z0
	         p32   p33   p34   p35   label2 label3 po26 po27 po26a
	         po27a ang6  ang7  label4 p36  p37   p38   p39   p40
	         p15a  p23a  p41   p42    p43  p44   p45   label5 label6
	         lspo3 lspo4 labela labelb sseta
		)
  
  (setq lspo1 (findfile (strcat pathlisp2 "opora\\ellptst.lsp"))
	lspo2 (findfile (strcat pathlisp2 "opora\\konptst.lsp"))
	lspo3 (findfile (strcat pathlisp2 "korpus\\ellips.lsp"))
;;;	lspo4 (findfile (strcat pathlisp2 "korpus\\shellkon.lsp"))
	elpt (findfile (strcat pathlisp2 "$ellpt.lsp"))
  ) ;_  setq

  
  (load lspo1)
  (load lspo2)
  (load lspo3)
;;;  (load lspo4)
  (load elpt)


;;;      
  (setq	dn  (* dn mb)
	s   (* s mb)
	d10 (* d10 mb)
	r0  (/ d10 2.0)
	a   (* a mb)
	a1  (* a1 mb)
	a2  (* a2 mb)
	b   (* b mb)
	b1  (* b1 mb)
	b2  (* b2 mb)
	b3  (* b3 mb)
	c   (* c mb)
	c1  (* c1 mb)
	h   (* h mb)
	h1  (* h1 mb)
	m   (* m mb)
	n   (* n mb)
	d   (* d mb)
	d1  (* d1 mb)
	d2  (* d2 mb)
	s1  (* s1 mb)
	s2  (* s2 mb)
	al  (* al mb)
	hl  (* hl mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;    
  (if (= pr2 0)
    (ellptst)
    (konptst)
  ) ;_  if


;;;  -   
  (defun oprsh (/ ip1 xt1 x0 y0 lt1 lt2)
;;;     
    (if	(= pr2 0)
      (setq ip1	(polar ip (/ pi 2.0) (+ (* dn 0.25) s))
	    x0	(nth 0 ip1)
	    y0	(nth 1 ip1)
      ) ;_  setq
      (setq ip1	(polar ip (- 0.0 (/ pi 2.0)) (* (+ (/ dn 2.0) s) (/ (cos ag) (sin ag))))
	    x0	(nth 0 ip1)
	    y0	(nth 1 ip1)
      ) ;_  setq
    ) ;_  if

      
;;;    -------------    ------------
   (defun ntrop ()
;;;        
    
;;;     
    (setq p1  (list (+ x0 (nth 0 po3)) (+ y0 (nth 1 po3)) 0.0)
	  p2  (list (+ x0 (nth 0 po3a)) (+ y0 (nth 1 po3a)) 0.0)
	  p3a (list (+ x0 (nth 0 pto3)) (+ y0 (nth 1 pto3)) 0.0)
	  p3  (list (+ x0 (nth 0 pto4)) (+ y0 (nth 1 pto4)) 0.0)
	  p4  (list (+ x0 (nth 0 pto2)) (+ y0 (nth 1 pto2)) 0.0)
	  p5  (list (+ x0 (nth 0 po7a)) (+ y0 (nth 1 po7a)) 0.0)
	  p6  (list (+ x0 (nth 0 po7)) (+ y0 (nth 1 po7)) 0.0)
    ) ;_  setq
    
;;;    -
    (setq p7  (list (+ x0 (nth 0 po10)) (+ y0 (nth 1 po10)) 0.0)
	  p8  (list (+ x0 (nth 0 po15)) (+ y0 (nth 1 po15)) 0.0)
	  p9  (list (+ x0 (nth 0 po16)) (+ y0 (nth 1 po16)) 0.0)
	  p10 (list (+ x0 (nth 0 po17)) (+ y0 (nth 1 po17)) 0.0)
	  p11 (list (+ x0 (nth 0 po14)) (+ y0 (nth 1 po14)) 0.0)
	  p12 (list (+ x0 (nth 0 po18a)) (+ y0 (nth 1 po18a)) 0.0)
	  p13 (list (+ x0 (nth 0 po19a)) (+ y0 (nth 1 po19a)) 0.0)
	  p14 (list (+ x0 (nth 0 po22)) (+ y0 (nth 1 po22)) 0.0)
	  p15 (list (+ x0 (nth 0 po23)) (+ y0 (nth 1 po23)) 0.0)
	  p16 (list (+ x0 (nth 0 po23a)) (+ y0 (nth 1 po23a)) 0.0)
	  p17 (list (+ x0 (nth 0 po22a)) (+ y0 (nth 1 po22a)) 0.0)
    ) ;_  setq
    
;;;        
    (cond ((<= d2 20) (setq xt1 (* 1.6 mb)))
	  ((<= d2 30) (setq xt1 (* 2.0 mb)))
	  ((<= d2 48) (setq xt1 (* 2.5 mb)))
    ) ;_  cond
    (if	(< xt1 1.0)
      (setq xt1 1.0)
    ) ;_  if

    (setq p18a (polar p9 pi c)
	  p18  (polar p18a 0.0 (/ d 2.0))
	  p19  (polar p18 (- 0.0 (/ pi 2.0)) h1)
	  p20a (polar p9 pi c1)
	  p20  (polar p20a 0.0 (/ d1 2.0))
	  p21  (polar p20 (- 0.0 (/ pi 2.0)) s1a)
	  p23a (polar p21 pi (/ d1 2.0))
	  p22  (polar p23a 0.0 (/ d2 2.0))
	  p23  (polar p23a 0.0 (- (/ d2 2.0) xt1))
	  p24  (polar p23 (- 0.0 (/ pi 2.0)) h1)
	  p25  (polar p22 (- 0.0 (/ pi 2.0)) h1)
	  os1  (polar p18a (/ pi 2.0) s1)
	  os2  (polar p18a (- 0.0 (/ pi 2.0)) (+ h1 s1))
	  os3  (polar p20a (/ pi 2.0) s1)
	  os4  (polar p20a (- 0.0 (/ pi 2.0)) (+ h1 s1))
    ) ;_  setq

;;;    -
    (osn)
    (command "_LINE" p8 p7 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (command "_LINE" p8 p9 p12 p13 p10 "")
    (command "_LINE" p10 p11 "")
    (command "_LINE" p9 p10 "")
    (command "_LINE" p14 p17 p16 p15 "")
;;;     
    (if	(= pdl "1")
      (progn
	(command "_SPLINE" p2 p3a p3 p4 p5 "" "" "")
	(command "_LINE" p1 p2 "")
	(command "_LINE" p5 p6 "")
      ) ;_  progn
    ) ;_  if

;;;       
    (axs)
    (command "_LINE" os1 os2 "")
    (if	(/= d1 0.0)
      (command "_LINE" os3 os4 "")
    ) ;_  if

;;;     
    (osn)
    (command "_LINE" p18 p19 "")
    (setq label1 (entlast))
    (command "_MIRROR" label1 "" os1 os2 "_N")

;;;     
    (if	(/= d1 0.0)
      (progn
	(command "_LINE" p20 p21 "")
	(setq label1 (entlast))
	(setq sset1 (ssadd (entlast)))
	(command "_LINE" p23 p24 "")
	(while (setq label1 (entnext label1))
	  (setq sset1 (ssadd label1 sset1))
	) ;_  while
	(command "_MIRROR" sset1 "" os3 os4 "_N")
      ) ;_  progn
    ) ;_  if

;;;     
    (command "_TRIM" "_f" p8 p7 "" "" "_f" p7 p11 "" "")

;;; ----  -----
    (if	(eq shtrp "1")
      (sht)
    ) ;_  if
    
;;;     
    (if	(/= d1 0.0)
      (progn
	(ton)
	(command "_LINE" p22 p25 "")
	(setq label1 (entlast))
	(command "_MIRROR" label1 "" os3 os4 "_N")
      ) ;_  progn
    ) ;_  if
   );_  NTROP

;;;    -------------    120 ------------
   (defun ugop ()
;;;       X
      (defun newx (x z / x1)
	(setq x1 (- (* x (cos (/ pi 3.0))) (* z (sin (/ pi 3.0)))))
      ) ;_  defun

;;;    Y   
      (defun newy (dx x / y a b)
	(setq a (+ (/ dn 2.0) dx)
	      b (+ (* dn 0.25) dx)
	      y (- 0.0 (* (/ b a) (sqrt (- (expt a 2.0) (expt x 2.0)))))
	) ;_  setq
      ) ;_  defun

;;;       
      (setq lt1 (- (/ dn 2.0) (* 2.0 s))
	    pob1 (list (+ x0 lt1) (+ y0 (newy (/ s 2.0) lt1)) 0.0)
	    pob2 (list (+ x0 lt1) (+ y0 (newy (* s 2.0) lt1)) 0.0)
	    p1  (list (- x0 (newx (nth 0 po11a) (nth 2 po10a))) (+ y0 (nth 1 po10a)) 0.0)
	    p2  (list (- x0 (newx (nth 0 po15b) (nth 2 po15b))) (+ y0 (nth 1 po15b)) 0.0)
	    p3  (list (- x0 (newx (nth 0 po16b) (nth 2 po16b))) (+ y0 (nth 1 po16b)) 0.0)
	    p4  (list (- x0 (newx (nth 0 po21) (nth 2 po21))) (+ y0 (nth 1 po21)) 0.0)
	    p5  (list (- x0 (newx (nth 0 po21a) (nth 2 po21a))) (+ y0 (nth 1 po21a)) 0.0)
	    p6  (list (- x0 (newx (nth 0 po25) (nth 2 po25))) (+ y0 (nth 1 po25)) 0.0)
	    p7  (list (- x0 (newx (nth 0 po25a) (nth 2 po25a))) (+ y0 (nth 1 po25a)) 0.0)
	    p8  (list (- x0 (newx (nth 0 po24a) (nth 2 po24a))) (+ y0 (nth 1 po24a)) 0.0)
	    p9  (list (- x0 (newx (nth 0 po23a) (nth 2 po23a))) (+ y0 (nth 1 po23a)) 0.0)
	    p10 (list (- x0 (newx (nth 0 po23) (nth 2 po23))) (+ y0 (nth 1 po23)) 0.0)
	    p11 (list (- x0 (newx (nth 0 po19a) (nth 2 po19a))) (+ y0 (nth 1 po19a)) 0.0)
	    p12 (list (- x0 (newx (nth 0 po19) (nth 2 po19))) (+ y0 (nth 1 po19)) 0.0)
	    p13 (list (- x0 (newx (nth 0 po17) (nth 2 po17))) (+ y0 (nth 1 po17)) 0.0)
	    p14 (list (- x0 (newx (nth 0 po17a) (nth 2 po17a))) (+ y0 (nth 1 po17a)) 0.0)
	    p15 (list (- x0 (newx (nth 0 po17c) (nth 2 po17c))) (+ y0 (nth 1 po17c)) 0.0)
	    p16 (list (- x0 (newx (nth 0 po17b) (nth 2 po17b))) (+ y0 (nth 1 po17b)) 0.0)
	    p17 (list (- x0 (newx (nth 0 po20) (nth 2 po20))) (+ y0 (nth 1 po20)) 0.0)
	    p18 (list (- x0 (newx (nth 0 po20a) (nth 2 po20a))) (+ y0 (nth 1 po20a)) 0.0)
	    p19 (list (- x0 (newx (nth 0 po24) (nth 2 po24))) (+ y0 (nth 1 po24)) 0.0)
	    p20 (list (- x0 (newx (nth 0 po14a) (nth 2 po14a))) (+ y0 (nth 1 po14a)) 0.0)
	    p21 (list (- x0 (newx (nth 0 po13a) (nth 2 po13a))) (+ y0 (nth 1 po13a)) 0.0)
	    p22 (list (- x0 (newx (nth 0 po13) (nth 2 po13))) (+ y0 (nth 1 po14a)) 0.0)
	    p23 (list (- x0 (newx (nth 0 po14) (nth 2 po14))) (+ y0 (nth 1 po13a)) 0.0)
	    p24 (list (- x0 (newx (nth 0 po16a) (nth 2 po16a))) (+ y0 (nth 1 po16a)) 0.0)
	    p25 (list (- x0 (newx (nth 0 po15a) (nth 2 po15a))) (+ y0 (nth 1 po15a)) 0.0)
	    p26 (list (- x0 (newx (nth 0 po11) (nth 2 po11))) (+ y0 (nth 1 po11)) 0.0)
	    p20 (polar p20 (angle p16 p20) (* 0.2 (distance p16 p20))); 
	    p21 (polar p21 (angle p15 p21) (* 0.2 (distance p15 p21))); 
	    p22 (polar p22 (angle p14 p22) (* 0.2 (distance p14 p22))); 
	    p23 (polar p23 (angle p13 p23) (* 0.2 (distance p13 p23))); 
      ) ;_  setq

;;;       
      (command "_LAYER" "_LO" " " "")
      (command "_LAYER" "_LO" " 2" "")
     
;;;     
      (osn)
      (command "_PLINE" p1 p2 p3 "")
      (if (< (distance p13 p24) (distance p13 p15))
	(command "_PLINE" p26 p25 p24 "")
      ) ;_  if
      (command "_LINE" p12 p4 p5 p11 p12 "")
      (command "_LINE" p6 p7 p9 p10 "")
      (command "_LINE" p19 p8 "")
      (command "_LINE" p17 p18 "")
      (command "_LINE" p13 p23 "" "_LINE" p14 p22 "")
      (command "_LINE" p15 p21 "" "_LINE" p16 p20 "")

;;;     
      (if (= pr2 0)
	(progn
	  (axs)
	  (command "_LINE" ip1 ip "")
	  (setq labela (entlast))
	  (setq labelb labela)
	  (ellips3 dn s (* dn 0.25) 0.0 ip1 pi 1.0 1)
	  (setq sseta (ssadd (entnext labela)))
	  (while (setq labela (entnext labela))
	    (setq sseta (ssadd labela sseta))
	  ) ;_  while
	  (command "_TRIM" sseta "" "_f" p23 p21 "" "")
	  (command "_TRIM" sseta "" "_f" p20 p1 "" "")
;;;	      
	  (command "_LAYER" "_U" " " "")
          (command "_LAYER" "_U" " 2" "")
	  (command "_ERASE" sseta labelb "")
	) ;_  progn
        (progn
	  (setq pob1 (polar ip pi (+ (/ dn 2.0) s))
	        pob2 (polar pob1 (angle pob1 ip1) s)
	  ) ;_  setq
	  (command "_TRIM" "_f" ip ip1 "" "_f" pob1 pob2 "" "" "_f" p23 p21 "" "_f" p20 p1"" "")
;;;	      
	  (command "_LAYER" "_U" " " "")
          (command "_LAYER" "_U" " 2" "")
        ) ;_  progn	 
      ) ;_  if

;;;     (if (= pr2 0)
;;;       (command	"_TRIM"	"_f" pob1 pob2 "" "" "_f" p23 p21 "" "_f" p20 p1"" "")
;;;       (progn
;;;	 (setq pob1 (polar ip pi (+ (/ dn 2.0) s))
;;;	       pob2 (polar pob1 (angle pob1 ip1) s)
;;;	 ) ;_  setq
;;;	 (command "_TRIM" "_f" ip ip1 "" "_f" pob1 pob2 "" "" "_f" p23 p21 "" "_f" p20 p1"" "")
;;;       ) ;_  progn	 
;;;     ) ;_  if
 
     
   ) ;_  UGOP

;;;    
  (defun sht (/	dl1 dl2	dl3 dl4	ang1 ang2 ang3 ang4 pt1	pt2 pt3	pt4 pt5
	      pt6 pt7)
    (setq dl1  (distance p5 p11)
	  dl2  (distance p12 p18)
	  dl3  (distance p14 p19)
	  ang1 (angle p5 p11)
	  ang2 (angle p12 p18)
	  ang3 (angle p14 p19)
	  pt1  (polar p5 (/ pi 3.0) s2)
	  pt2  (polar p12 ang2 (/ dl2 2.0))
	  pt3  (polar p14 ang3 (/ dl3 2.0))
	  pt4  (polar p21 (/ pi 4.0) s1)
	  pt5  (polar p13 (/ pi 4.0) s1)
	  pt6  (polar p25 (/ pi 4.0) s1)
	  pt7  (polar p16 (/ pi 4.0) s1)
    ) ;_  setq
    (ton)
;;;    (command "_BHATCH" "_p" "_u" 45 2.0 "_n" pt2 pt4 pt5 "")
    (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pt3 pt6 pt7 "")
    (if	(eq pdl "1")
      (if (= pr2 0)
	(command "_BHATCH" "_p" "_u" 45 2.0 "_n" pt1 "")
	(progn
	  (setq pt1 (polar p5 (angle p5 p1) (/ (distance p5 p1) 2.0)))
	  (command "_BHATCH" "_p" "_u" 45 2.0 "_n" pt1 "")
	) ;_  progn
      ) ;_  if
    ) ;_  if
  ) ;_  SHT

;;;   ------------ ----------
   (ntrop)
   (ugop) 	 
  ) ;_  OPRSH

  
;;;    
  (defun oprsn (/ )
;;;       
    (setq ipc (polar ip pi (/ d10 2.0))
	  x0  (nth 0 ipc)
	  y0  (nth 1 ipc)
    ) ;_  setq

;;;     
    (setq p1  (list (+ x0 (nth 0 po2a)) (+ y0 (nth 2 po2a)) 0.0)
	  p2  (list (+ x0 (nth 0 po8a)) (+ y0 (nth 2 po8a)) 0.0)
	  p3  (list (+ x0 (nth 0 po6a)) (+ y0 (nth 2 po6a)) 0.0)
          p2a (list (+ x0 (nth 0 po8)) (+ y0 (nth 2 po8)) 0.0)
	  p3a (list (+ x0 (nth 0 po6)) (+ y0 (nth 2 po6)) 0.0)
	  p4  (list (+ x0 (nth 0 po4a)) (+ y0 (nth 2 po4a)) 0.0)
	  os1 (list (+ x0 (nth 0 po3a) 5.0) (+ y0 (nth 2 po3a)) 0.0)
	  os2 (list (- (+ x0 (nth 0 po7a)) 5.0) (+ y0 (nth 2 po7a)) 0.0)
	  p23 (list (+ x0 (nth 0 po3a)) (+ y0 (nth 2 po3a)) 0.0)
	  p24 (list (+ x0 (nth 0 po7)) (+ y0 (nth 2 po7)) 0.0)
	  p25 (list (+ x0 (nth 0 po7a)) (+ y0 (nth 2 po7a)) 0.0)
    ) ;_  setq

;;;   -
    (setq p5  (list (+ x0 (nth 0 po18)) (+ y0 (nth 2 po18)) 0.0)
	  p5a (list (+ x0 (nth 0 po18)) y0 0.0)
	  p6  (list (+ x0 (nth 0 po21)) (+ y0 (nth 2 po21)) 0.0)
	  p7  (list (+ x0 (nth 0 po20)) (+ y0 (nth 2 po20)) 0.0)
	  p8  (list (+ x0 (nth 0 po19)) (+ y0 (nth 2 po19)) 0.0)
	  p9  (list (+ x0 (nth 0 po22)) (+ y0 (nth 2 po22)) 0.0)
	  p10 (list (+ x0 (nth 0 po25)) (+ y0 (nth 2 po25)) 0.0)
	  p11 (list (+ x0 (nth 0 po24)) (+ y0 (nth 2 po24)) 0.0)
	  p12 (list (+ x0 (nth 0 po23)) (+ y0 (nth 2 po23)) 0.0)
	  p13 (list (+ x0 (nth 0 po17)) (+ y0 (nth 2 po17)) 0.0)
	  p14 (list (+ x0 (nth 0 po17a)) (+ y0 (nth 2 po17a)) 0.0)
	  p15 (list (+ x0 (nth 0 po17c)) (+ y0 (nth 2 po17c)) 0.0)
	  p16 (list (+ x0 (nth 0 po17b)) (+ y0 (nth 2 po17b)) 0.0)
	  p17 (list (+ x0 (nth 0 po14)) (+ y0 (nth 2 po14)) 0.0)
	  p18 (list (+ x0 (nth 0 po13)) (+ y0 (nth 2 po13)) 0.0)
	  p19 (list (+ x0 (nth 0 po13a)) (+ y0 (nth 2 po13a)) 0.0)
	  p20 (list (+ x0 (nth 0 po14a)) (+ y0 (nth 2 po14a)) 0.0)
	  pc1 (polar p5a pi c)
	  pc2 (polar p5a pi c1)
	  p21 (polar pc2 0.0 (/ d2 2.0))
	  p22 (polar pc2 (- 0.0 (/ pi 2.0)) (/ d2 2.0))
	  os3 (polar pc2 (/ pi 2.0) d2)
	  os4 (polar pc2 (- 0.0 (/ pi 2.0)) d2)
    ) ;_  setq

;;;          
    (cond ((<= d2 20) (setq xt1 (* 1.6 mb)))
	  ((<= d2 30) (setq xt1 (* 2.0 mb)))
	  ((<= d2 48) (setq xt1 (* 2.5 mb)))
    ) ;_  cond
    (if	(< xt1 1.0)
      (setq xt1 1.0)
    ) ;_  if
   
;;;    
;;;    -
    (axs)
    (command "_LINE" os1 os2 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (setq label1 (entlast))
    (setq sset1 (ssadd (entlast)))
    
    (osn)
    (command "_LINE" p5 p6 p7 p8 p5 "")
    (command "_LINE" p9 p10 p11 p12 p9 "")
    (command "_LINE" p13 p17 p18 p14 "")
    (command "_LINE" p15 p19 p20 p16 "")
   
;;;     
    (if	(= pdl "1")
      (progn
	(command "_LINE" p1 p2 "" "_LINE" p3 p4 "")
	(command "_SPLINE" p1 p23 p4 "" "" "")
	(command "_SPLINE" p2 p25 p3 "" "" "")
	(if (> (distance p1 p2a) (distance p1 p2))
	  (progn
	    (command "_LINE" p2 p2a "" "_LINE" p3a p3 "")
	    (command "_SPLINE" p2a p24 p3a "" "" "")
	  ) ;_  progn
	) ;_  if
      ) ;_  progn
    ) ;_  if

;;;     
    (osn)
    (command "_CIRCLE" pc1 (/ d 2.0))

;;;     
    (if	(/= d1 0.0)
      (progn
	(command "_CIRCLE" pc2 (- (/ d2 2.0) xt1))
	(axs)
	(command "_LINE" os3 os4 "")

;;;     
	(ton)
	(command "_ARC" "_c" pc2 p21 p22)
      ) ;_  progn
    ) ;_  if


;;; 
    (while (setq label1 (entnext label1))
      (setq sset1 (ssadd label1 sset1))
    ) ;_  while
    (command "_ARRAY" sset1 "" "_p" ipc 3 "" "")

;;;    
    (axs)
    (command "_CIRCLE" ipc (/ d10 2.0))

  ) ;_  OPRSN


  
;;;  -    
  (defun oprst (/ ip1 xt1 x0 y0 lt1 lt2)
    
;;;     
    (if	(= pr2 0)
      (setq ip1	(polar ip (/ pi 2.0) (+ (* dn 0.25) s))
	    x0	(nth 0 ip1)
	    y0	(nth 1 ip1)
      ) ;_  setq
      (setq ip1	(polar ip (- 0.0 (/ pi 2.0)) (* (+ (/ dn 2.0) s) (/ (cos ag) (sin ag))))
	    x0	(nth 0 ip1)
	    y0	(nth 1 ip1)
      ) ;_  setq
    ) ;_  if
    
;;;    -------------    ------------
   (defun ntrop2 ()
;;;        
;;;     
    (setq p1  (list (+ x0 (nth 2 po4)) (+ y0 (nth 1 po4)) 0.0)
	  p2  (list (+ x0 (nth 2 po3)) (+ y0 (nth 1 po3)) 0.0)
	  p3  (list (+ x0 (nth 2 po2)) (+ y0 (nth 1 po2)) 0.0)
	  p4  (list (+ x0 (nth 2 po2a)) (+ y0 (nth 1 po2a)) 0.0)
	  p5  (list (+ x0 (nth 2 po8a)) (+ y0 (nth 1 po8a)) 0.0)
	  p6  (list (+ x0 (nth 2 po7a)) (+ y0 (nth 1 po7a)) 0.0)
	  p7  (list (+ x0 (nth 2 po6a)) (+ y0 (nth 1 po6a)) 0.0)
	  p8  (list (+ x0 (nth 2 po4a)) (+ y0 (nth 1 po4a)) 0.0)
	  p9  (list (+ x0 (nth 2 po3a)) (+ y0 (nth 1 po3a)) 0.0)
    ) ;_  setq
    
;;;    -
    (setq p10  (list (+ x0 (nth 2 po10)) (+ y0 (nth 1 po10)) 0.0)
	  p11  (list (+ x0 (nth 2 po11)) (+ y0 (nth 1 po11)) 0.0)
	  p12  (list (+ x0 (nth 2 po15a)) (+ y0 (nth 1 po15a)) 0.0)
	  p13  (list (+ x0 (nth 2 po16a)) (+ y0 (nth 1 po16a)) 0.0)
	  p14  (list (+ x0 (nth 2 po16)) (+ y0 (nth 1 po16)) 0.0)
	  p15  (list (+ x0 (nth 2 po15)) (+ y0 (nth 1 po15)) 0.0)
	  p16  (list (+ x0 (nth 2 po11a)) (+ y0 (nth 1 po11a)) 0.0)
	  p17  (list (+ x0 (nth 2 po10a)) (+ y0 (nth 1 po10a)) 0.0)
	  p18  (list (+ x0 (nth 2 po15b)) (+ y0 (nth 1 po15b)) 0.0)
	  p19  (list (+ x0 (nth 2 po16b)) (+ y0 (nth 1 po16b)) 0.0)
	  p20  (list (+ x0 (nth 2 po16c)) (+ y0 (nth 1 po16c)) 0.0)
	  p21  (list (+ x0 (nth 2 po15c)) (+ y0 (nth 1 po15c)) 0.0)
	  p22  (list (+ x0 (nth 2 po21)) (+ y0 (nth 1 po21)) 0.0)
	  p23  (list (+ x0 (nth 2 po18)) (+ y0 (nth 1 po18)) 0.0)
	  p24  (list (+ x0 (nth 2 po18a)) (+ y0 (nth 1 po18a)) 0.0)
	  p25  (list (+ x0 (nth 2 po21a)) (+ y0 (nth 1 po21a)) 0.0)
	  p26  (list (+ x0 (nth 2 po25)) (+ y0 (nth 1 po25)) 0.0)
	  p27  (list (+ x0 (nth 2 po22)) (+ y0 (nth 1 po22)) 0.0)
	  p28  (list (+ x0 (nth 2 po22a)) (+ y0 (nth 1 po22a)) 0.0)
	  p29  (list (+ x0 (nth 2 po25a)) (+ y0 (nth 1 po25a)) 0.0)
	  p30  (polar p21 pi (/ s1 2.0))
	  p31  (polar p15 pi (/ s1 2.0))
	  p32  (polar p30 (- 0.0 (/ pi 2.0)) (- h m s1 s1))
	  p33  (polar p31 (- 0.0 (/ pi 2.0)) (- h m s1 s1))
    ) ;_  setq
    

;;;    -
    (osn)
    (command "_LINE" p22 p23 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (command "_LINE" p15 p12 "" "_LINE" p21 p18 "")
    (command "_LINE" p14 p10 p11 p13 "")
    (command "_LINE" p20 p16 p17 p19 "")
    (command "_LINE" p22 p25 p24 p23 "")
    (command "_LINE" p26 p29 p28 p27 "")

;;;      
   (if (= pdl "1")
     (progn
       (command "_SPLINE" p1 p2 p3 "" "" "")
       (command "_SPLINE" p8 p9 p4 "" "" "")
       (command "_SPLINE" p5 p6 p7 "" "" "")
       (command "_LINE" p1 p8 "" "_LINE" p3 p4 "")
       (command "_LINE" p7 p8 "" "_LINE" p4 p5 "")
     ) ;_  progn
   ) ;_  if

;;;    
   (command	"_TRIM"	"_f" p14 p10 p11 p13 ""	"" "_f"	p31 p33	"" "") 
   (command	"_TRIM"	"_f" p20 p16 p17 p19 ""	"" "_f"	p30 p32	"" "")
   
  );_  NTROP2

;;;    -------------    120 ------------
   (defun ugop2 ()
;;;       X
      (defun newx (x z / x1)
	(setq x1 (- (* x (cos (/ pi 6.0))) (* z (sin (/ pi 6.0)))))
      ) ;_  defun

;;;    Y   
      (defun newy (dx x / y a b)
	(setq a (+ (/ dn 2.0) dx)
	      b (+ (* dn 0.25) dx)
	      y (- 0.0 (* (/ b a) (sqrt (- (expt a 2.0) (expt x 2.0)))))
	) ;_  setq
      ) ;_  defun

;;;       
      (setq lt1 (- (/ dn 2.0) (* 2.0 s))
	    pob1 (list (- x0 lt1) (+ y0 (newy (- 0.0 (/ s 2.0)) lt1)) 0.0)
	    pob2 (list (- x0 lt1) (+ y0 (newy (* s 2.0) lt1)) 0.0)
	    p1  (list (- x0 (newx (nth 0 po11a) (nth 2 po10a))) (+ y0 (nth 1 po10a)) 0.0)
	    p2  (list (- x0 (newx (nth 0 po15b) (nth 2 po15b))) (+ y0 (nth 1 po15b)) 0.0)
	    p3  (list (- x0 (newx (nth 0 po16b) (nth 2 po16b))) (+ y0 (nth 1 po16b)) 0.0)
	    p4  (list (- x0 (newx (nth 0 po21) (nth 2 po21))) (+ y0 (nth 1 po21)) 0.0)
	    p5  (list (- x0 (newx (nth 0 po21a) (nth 2 po21a))) (+ y0 (nth 1 po21a)) 0.0)
	    p6  (list (- x0 (newx (nth 0 po25) (nth 2 po25))) (+ y0 (nth 1 po25)) 0.0)
	    p7  (list (- x0 (newx (nth 0 po25a) (nth 2 po25a))) (+ y0 (nth 1 po25a)) 0.0)
	    p8  (list (- x0 (newx (nth 0 po24a) (nth 2 po24a))) (+ y0 (nth 1 po24a)) 0.0)
	    p9  (list (- x0 (newx (nth 0 po23a) (nth 2 po23a))) (+ y0 (nth 1 po23a)) 0.0)
	    p10 (list (- x0 (newx (nth 0 po23) (nth 2 po23))) (+ y0 (nth 1 po23)) 0.0)
	    p11 (list (- x0 (newx (nth 0 po19a) (nth 2 po19a))) (+ y0 (nth 1 po19a)) 0.0)
	    p12 (list (- x0 (newx (nth 0 po19) (nth 2 po19))) (+ y0 (nth 1 po19)) 0.0)
	    p13 (list (- x0 (newx (nth 0 po17) (nth 2 po17))) (+ y0 (nth 1 po17)) 0.0)
	    p14 (list (- x0 (newx (nth 0 po17a) (nth 2 po17a))) (+ y0 (nth 1 po17a)) 0.0)
	    p15 (list (- x0 (newx (nth 0 po17c) (nth 2 po17c))) (+ y0 (nth 1 po17c)) 0.0)
	    p16 (list (- x0 (newx (nth 0 po17b) (nth 2 po17b))) (+ y0 (nth 1 po17b)) 0.0)
	    p17 (list (- x0 (newx (nth 0 po20) (nth 2 po20))) (+ y0 (nth 1 po20)) 0.0)
	    p18 (list (- x0 (newx (nth 0 po20a) (nth 2 po20a))) (+ y0 (nth 1 po20a)) 0.0)
	    p19 (list (- x0 (newx (nth 0 po24) (nth 2 po24))) (+ y0 (nth 1 po24)) 0.0)
	    p20 (list (- x0 (newx (nth 0 po14a) (nth 2 po14a))) (+ y0 (nth 1 po14a)) 0.0)
	    p21 (list (- x0 (newx (nth 0 po13a) (nth 2 po13a))) (+ y0 (nth 1 po13a)) 0.0)
	    p22 (list (- x0 (newx (nth 0 po13) (nth 2 po13))) (+ y0 (nth 1 po14a)) 0.0)
	    p23 (list (- x0 (newx (nth 0 po14) (nth 2 po14))) (+ y0 (nth 1 po13a)) 0.0)
	    p24 (list (- x0 (newx (nth 0 po16a) (nth 2 po16a))) (+ y0 (nth 1 po16a)) 0.0)
	    p25 (list (- x0 (newx (nth 0 po15a) (nth 2 po15a))) (+ y0 (nth 1 po15a)) 0.0)
	    p26 (list (- x0 (newx (nth 0 po11) (nth 2 po11))) (+ y0 (nth 1 po11)) 0.0)
	    p27 (list (- x0 (newx (nth 0 po4a) (nth 2 po4a))) (+ y0 (nth 1 po4a)) 0.0)
	    p28 (list (- x0 (newx (nth 0 po5a) (nth 2 po5a))) (+ y0 (nth 1 po5a)) 0.0)
	    p29 (list (- x0 (newx (nth 0 po6a) (nth 2 po6a))) (+ y0 (nth 1 po6a)) 0.0)
	    p30 (list (- x0 (newx (nth 0 po6) (nth 2 po6))) (+ y0 (nth 1 po6)) 0.0)
	    p30 (polar p30 (angle p29 p30) (/ s 2.0))
	    p31 (list (- x0 (newx (nth 0 po7a) (nth 2 po7a))) (+ y0 (nth 1 po7a)) 0.0)
	    p32 (list (- x0 (newx (nth 0 po8a) (nth 2 po8a))) (+ y0 (nth 1 po8a)) 0.0)
	    p21 (polar p21 (angle p15 p21) (* s2 2.0)); 
	    p20 (polar p20 (angle p16 p20) (* s2 2.0)); 
      ) ;_  setq
     
;;;     
      (osn)
      (command "_PLINE" p1 p2 p3 "")
      (setq label1 (entlast))
      (setq sset1 (ssadd (entlast)))
      (if (< (distance p13 p24) (distance p13 p15))
	(command "_PLINE" p26 p25 p24 "")
      ) ;_  if
      (command "_LINE" p12 p4 p5 p11 p12 "")
      (command "_LINE" p6 p7 p9 p10 "")
      (command "_LINE" p19 p8 "")
      (command "_LINE" p17 p18 "")
      (command "_LINE" p13 p23 "" "_LINE" p14 p22 "")
      (command "_LINE" p15 p21 "" "_LINE" p16 p20 "")

;;;     
      (if (and (= pdl "1") (= pr2 0))
	(progn
	  (command "_SPLINE" p27 p28 p29 "" "" "")
	  (setq label2 (entlast))
	  (command "_SPLINE" p29 p31 p32 "" "" "")
	  (setq label3 (entlast))
	  (command "_LINE" p30 p29 "")
	) ;_  progn
      ) ;_  if


;;;     
      (if (= pr2 0)
	(progn
	  (if (= pdl "1")
	    (command "_TRIM" label2 label3 "" "_f" p20 p21 "" "")
	    (command "_TRIM" "_f" pob1 pob2 "" "" "_f" p20 p21 "" "")
	  ) ;_  if
	  (command "_TRIM" "_f" pob1 pob2 "" "" "_f" p32 p23 "" "_f" p22 p30 p1 ""
		   "_f"	p27 p30 "" "")
	) ;_  progn
	(progn
	  (setq pob1 (polar ip pi (+ (/ dn 2.0) s))
	        pob2 (polar pob1 (angle pob1 ip1) s)
	  ) ;_  setq
	  (command "_TRIM" "_f" ip ip1 "" "_f" pob1 pob2 "" "" "_f" p22 p23 "" "")
	  (command "_TRIM" "_f" ip ip1 "" "_f" pob1 pob2 "" "" "_f" p20 p21 "" "")
	  (command "_TRIM" "_f" ip ip1 "" "_f" pob1 pob2 "" "" "_f" p20 p1 "" "")
	) ;_  progn
      ) ;_  if
           

;;;      
      (while (setq label1 (entnext label1))
        (setq sset1 (ssadd label1 sset1))
      ) ;_  while
      (command "_MIRROR" sset1 "" ip "@0,25" "_N")
 
   ) ;_  UGOP2

;;;   ------------ ----------
   (ntrop2)
   (ugop2) 	 
  ) ;_  OPRST


;;;  -  
  (defun oprsb (/ ip1 xt1 x0 y0 lt1 lt2)
;;;     
    (if	(= pr2 0)
      (setq ip1	(polar ip (/ pi 2.0) (+ (* dn 0.25) s))
	    x0	(nth 0 ip1)
	    y0	(nth 1 ip1)
      ) ;_  setq
      (setq ip1	(polar ip (- 0.0 (/ pi 2.0)) (* (+ (/ dn 2.0) s) (/ (cos ag) (sin ag))))
	    x0	(nth 0 ip1)
	    y0	(nth 1 ip1)
      ) ;_  setq
    ) ;_  if

;;;    Y   
      (defun newy (dx x / y a b)
	(setq a (+ (/ dn 2.0) dx)
	      b (+ (* dn 0.25) dx)
	      y (- 0.0 (* (/ b a) (sqrt (- (expt a 2.0) (expt x 2.0)))))
	) ;_  setq
      ) ;_  defun
    
;;;    -------------    ------------
   (defun ntrop3 ()
;;;        
    
;;;     
    (setq p1  (list (+ x0 (nth 0 po3)) (+ y0 (nth 1 po3)) 0.0)
	  p2  (list (+ x0 (nth 0 po3a)) (+ y0 (nth 1 po3a)) 0.0)
	  p3a (list (+ x0 (nth 0 pto3)) (+ y0 (nth 1 pto3)) 0.0)
	  p3  (list (+ x0 (nth 0 pto4)) (+ y0 (nth 1 pto4)) 0.0)
	  p4  (list (+ x0 (nth 0 pto2)) (+ y0 (nth 1 pto2)) 0.0)
	  p5  (list (+ x0 (nth 0 po7a)) (+ y0 (nth 1 po7a)) 0.0)
	  p6  (list (+ x0 (nth 0 po7)) (+ y0 (nth 1 po7)) 0.0)
	  p18 (list (+ x0 (nth 0 po26)) (+ y0 (nth 1 po26)) 0.0)
	  p19 (list (+ x0 (nth 0 po2)) (+ y0 (nth 1 po2)) 0.0)
	  p20 (list (+ x0 (nth 0 po1)) (+ y0 (nth 1 po1)) 0.0)
	  p21 (list (+ x0 (nth 0 po8)) (+ y0 (nth 1 po8)) 0.0)
	  p22 (list (+ x0 (nth 0 po27)) (+ y0 (nth 1 po27)) 0.0)
	  p23 (list (+ x0 (nth 0 po26a)) (+ y0 (nth 1 po26a)) 0.0)
	  p24 (list (+ x0 (nth 0 po2a)) (+ y0 (nth 1 po2a)) 0.0)
	  p25 (list (+ x0 (nth 0 po1a)) (+ y0 (nth 1 po1a)) 0.0)
	  p26 (list (+ x0 (nth 0 po8a)) (+ y0 (nth 1 po8a)) 0.0)
	  p27 (list (+ x0 (nth 0 po27a)) (+ y0 (nth 1 po27a)) 0.0)
    ) ;_  setq
    
;;;    -
    (setq lt1 (- (/ dn 2.0) (* 2.0 s))
	  pob1 (list (- x0 lt1) (+ y0 (newy (/ s 2.0) lt1)) 0.0)
	  pob2 (list (- x0 lt1) (+ y0 (newy (* s 2.0) lt1)) 0.0)
          p7  (list (+ x0 (nth 0 po10)) (+ y0 (nth 1 po10)) 0.0)
	  p8  (list (+ x0 (nth 0 po15)) (+ y0 (nth 1 po15)) 0.0)
	  p9  (list (+ x0 (nth 0 po16)) (+ y0 (nth 1 po16)) 0.0)
	  p10 (list (+ x0 (nth 0 po17)) (+ y0 (nth 1 po17)) 0.0)
	  p11 (list (+ x0 (nth 0 po14)) (+ y0 (nth 1 po14)) 0.0)
	  p12 (list (+ x0 (nth 0 po18a)) (+ y0 (nth 1 po18a)) 0.0)
	  p13 (list (+ x0 (nth 0 po19a)) (+ y0 (nth 1 po19a)) 0.0)
	  p14 (list (+ x0 (nth 0 po22)) (+ y0 (nth 1 po22)) 0.0)
	  p15 (list (+ x0 (nth 0 po23)) (+ y0 (nth 1 po23)) 0.0)
	  p16 (list (+ x0 (nth 0 po23a)) (+ y0 (nth 1 po23a)) 0.0)
	  p17 (list (+ x0 (nth 0 po22a)) (+ y0 (nth 1 po22a)) 0.0)
	  p28 (list (+ x0 (nth 0 po9)) (+ y0 (nth 1 po9)) 0.0)
	  p29 (polar p28 (- 0.0 (/ pi 2.0)) (* 2.0 s))
    ) ;_  setq

;;;    -
    (osn)
    (command "_LINE" p8 p7 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (command "_LINE" p8 p9 p12 p13 p10 "")
    (command "_LINE" p10 p11 "")
    (setq label1 (entlast))
    (command "_LINE" p9 p10 "")
    (command "_LINE" p14 p17 p16 p15 "")
    (command "_SPLINE" p7 p28 p11 "" "" "")
    (setq label2 (entlast))
;;;     
    (if	(= pdl "1")
      (progn
	(command "_SPLINE" p2 p3a p3 p4 p5 "" "" "")
	(command "_SPLINE" p2 p23 p24 "" "" "")
	(setq label3 (entlast))
	(command "_SPLINE" p19 p20 p21 "" "" "")
	(command "_SPLINE" p21 p22 p6 "" "" "")
	(setq label4 (entlast))
	(command "_SPLINE" p26 p27 p5 "" "" "")
	(command "_SPLINE" p24 p25 p26 "" "" "")
	(command "_LINE" p5 p6 "")
	(setq label5 (entlast))
	(command "_LINE" p19 p24 "")
	(setq label6 (entlast))
	(command "_LINE" p21 p26 "")
      ) ;_  progn
    ) ;_  if

;;;     
    (if	(= pr2 0)
      (progn
	(if (= pdl "1")
	  (command "_TRIM" label3 label4 label5 label6 "" "_f" p20 p29 "" "")
	) ;_  if
	(command "_TRIM" label label1 label2 "" "_f" p28 p29 "" "")
      ) ;_  progn
      (progn
	(if (= pdl "1")
	  (progn
	    (setq pob1 (polar ip 0.0 (+ (/ dn 2.0) s)))
	    (command "_LINE" pob1 p1 "")
	    (command "_TRIM" label3 label4 label5 label6 "" "_f" p20 p29 "" "")
	    (command "_TRIM" label3 label6 "" "_f" p1 p24 "" "")
	  );_  progn
	) ;_  if
	(progn
	   (command "_TRIM" label label1 label2 "" "_f" p28 p29 "" "")
	   (if (/= pdl "1")
	     (progn
	       (setq pob1 (polar ip 0.0 (+ (/ dn 2.0) s)))
	       (command "_LINE" pob1 p3 "")
	       (command "_TRIM" label label2 "" "_f" p3 p29 "" "")
	     ) ;_  progn
	   ) ;_  if
	) ;_  progn
      ) ;_  progn
    ) ;_  if

   );_  NTROP3

;;;    -------------    120 ------------
   (defun ugop3 ()
;;;       X
      (defun newx (x z / x1)
	(setq x1 (- (* x (cos (/ pi 3.0))) (* z (sin (/ pi 3.0)))))
      ) ;_  defun

;;;         
      (setq p1  (list (- x0 (newx (nth 0 po4) (nth 2 po4))) (+ y0 (nth 1 po4)) 0.0)
	    p2  (list (- x0 (newx (nth 0 po3) (nth 2 po3))) (+ y0 (nth 1 po3)) 0.0)
	    p3  (list (- x0 (newx (nth 0 po2) (nth 2 po2))) (+ y0 (nth 1 po2)) 0.0)
	    p4  (list (- x0 (newx (nth 0 po1) (nth 2 po1))) (+ y0 (nth 1 po1)) 0.0)
	    p5  (list (- x0 (newx (nth 0 po8) (nth 2 po8))) (+ y0 (nth 1 po8)) 0.0)
	    p6  (list (- x0 (newx (nth 0 po4a) (nth 2 po4a))) (+ y0 (nth 1 po4a)) 0.0)
	    p7  (list (- x0 (newx (nth 0 po3a) (nth 2 po3a))) (+ y0 (nth 1 po3a)) 0.0)
	    p8  (list (- x0 (newx (nth 0 po2a) (nth 2 po2a))) (+ y0 (nth 1 po2a)) 0.0)
	    p9  (list (- x0 (newx (nth 0 po1a) (nth 2 po1a))) (+ y0 (nth 1 po1a)) 0.0)
	    p10 (list (- x0 (newx (nth 0 po8a) (nth 2 po8a))) (+ y0 (nth 1 po8a)) 0.0)
	    p11 (list (- x0 (newx (nth 0 po7a) (nth 2 po7a))) (+ y0 (nth 1 po7a)) 0.0)
	    p12 (list (- x0 (newx (nth 0 po6a) (nth 2 po6a))) (+ y0 (nth 1 po6a)) 0.0)
	    p13 (list (- x0 (newx (nth 0 po5a) (nth 2 po5a))) (+ y0 (nth 1 po5a)) 0.0)
      ) ;_  setq

;;;       -
      (setq p14  (list (- x0 (newx (nth 0 po10a) (nth 2 po10a))) (+ y0 (nth 1 po10a)) 0.0)
	    p15  (list (- x0 (newx (nth 0 po11a) (nth 2 po11a))) (+ y0 (nth 1 po11a)) 0.0)
	    p15a (list (- x0 (newx (nth 0 po12a) (nth 2 po12a))) (+ y0 (nth 1 po12a)) 0.0)
	    p16  (list (- x0 (newx (nth 0 po13a) (nth 2 po13a))) (+ y0 (nth 1 po13a)) 0.0)
	    p17  (list (- x0 (newx (nth 0 po17c) (nth 2 po17c))) (+ y0 (nth 1 po17c)) 0.0)
	    p18  (list (- x0 (newx (nth 0 po16c) (nth 2 po16c))) (+ y0 (nth 1 po16c)) 0.0)
	    p19  (list (- x0 (newx (nth 0 po16b) (nth 2 po16b))) (+ y0 (nth 1 po16b)) 0.0)
	    p20  (list (- x0 (newx (nth 0 po15b) (nth 2 po15b))) (+ y0 (nth 1 po15b)) 0.0)
	    p21  (list (- x0 (newx (nth 0 po15c) (nth 2 po15c))) (+ y0 (nth 1 po15c)) 0.0)
	    p22  (list (- x0 (newx (nth 0 po11) (nth 2 po11))) (+ y0 (nth 1 po11)) 0.0)
	    p23  (list (- x0 (newx (nth 0 po10) (nth 2 po10))) (+ y0 (nth 1 po10)) 0.0)
	    p23a (list (- x0 (newx (nth 0 po9) (nth 2 po9))) (+ y0 (nth 1 po9)) 0.0)
	    p24  (list (- x0 (newx (nth 0 po14) (nth 2 po14))) (+ y0 (nth 1 po14)) 0.0)
	    p25  (list (- x0 (newx (nth 0 po17) (nth 2 po17))) (+ y0 (nth 1 po17)) 0.0)
	    p26  (list (- x0 (newx (nth 0 po16) (nth 2 po16))) (+ y0 (nth 1 po16)) 0.0)
	    p27  (list (- x0 (newx (nth 0 po16a) (nth 2 po16a))) (+ y0 (nth 1 po16a)) 0.0)
	    p28  (list (- x0 (newx (nth 0 po15a) (nth 2 po15a))) (+ y0 (nth 1 po15a)) 0.0)
	    p29  (list (- x0 (newx (nth 0 po15) (nth 2 po15))) (+ y0 (nth 1 po15)) 0.0)
	    p30  (list (- x0 (newx (nth 0 po21) (nth 2 po21))) (+ y0 (nth 1 po21)) 0.0)
	    p31  (list (- x0 (newx (nth 0 po18) (nth 2 po18))) (+ y0 (nth 1 po18)) 0.0)
	    p32  (list (- x0 (newx (nth 0 po19) (nth 2 po19))) (+ y0 (nth 1 po19)) 0.0)
	    p33  (list (- x0 (newx (nth 0 po19a) (nth 2 po19a))) (+ y0 (nth 1 po19a)) 0.0)
	    p34  (list (- x0 (newx (nth 0 po18a) (nth 2 po18a))) (+ y0 (nth 1 po18a)) 0.0)
	    p35  (list (- x0 (newx (nth 0 po21a) (nth 2 po21a))) (+ y0 (nth 1 po21a)) 0.0)
	    p36  (list (- x0 (newx (nth 0 po25) (nth 2 po25))) (+ y0 (nth 1 po25)) 0.0)
	    p37  (list (- x0 (newx (nth 0 po22) (nth 2 po22))) (+ y0 (nth 1 po22)) 0.0)
	    p38  (list (- x0 (newx (nth 0 po23) (nth 2 po23))) (+ y0 (nth 1 po23)) 0.0)
	    p39  (list (- x0 (newx (nth 0 po23a) (nth 2 po23a))) (+ y0 (nth 1 po23a)) 0.0)
	    p40  (list (- x0 (newx (nth 0 po22a) (nth 2 po22a))) (+ y0 (nth 1 po22a)) 0.0)
	    p41  (list (- x0 (newx (nth 0 po25a) (nth 2 po25a))) (+ y0 (nth 1 po25a)) 0.0)
	    p42  (polar p21 (- 0.0 (/ pi 2.0)) (* 0.9 (- h m s1)))
	    p43  (polar p29 (- 0.0 (/ pi 2.0)) (* 0.9 (- h m s1)))
	    p44  (polar p16 (angle p16 p17) (* 0.9 (distance p16 p17)))
	    p45  (polar p24 (angle p24 p25) (* 0.9 (distance p24 p25)))
      );_  setq
     
;;;     
      (osn)
;;;     
    (if	(= pdl "1")
      (progn
	(command "_SPLINE" p1 p2 p3 "" "" "")
	(command "_SPLINE" p3 p4 p5 "" "" "")
	(command "_SPLINE" p6 p7 p8 "" "" "")
	(command "_SPLINE" p8 p9 p10 "" "" "")
	(command "_SPLINE" p12 p11 p10 "" "" "")
	(command "_SPLINE" p6 p13 p12 "" "" "")
	(command "_LINE" p1 p6 "")
	(command "_LINE" p3 p8 "")
	(command "_LINE" p5 p10 "")
      ) ;_  progn
    ) ;_  if

;;;     -
    (command "_SPLINE" p15 p15a p16 "" "" "")
    (command "_SPLINE" p23 p23a p24 "" "" "")
    (command "_LINE" p16 p17 "")
    (setq label1 (entlast))
    (command "_LINE" p24 p25 "")
    (setq label2 (entlast))
    (command "_LINE" p14 p15 "" "_LINE" p22 p23 "")
    (command "_LINE" p20 p21 "" "_LINE" p28 p29 "")
    (command "_PLINE" p19 p20 p14 "")
    (setq label3 (entlast))
    (command "_PLINE" p15 p21 p18 "")
    (command "_PLINE" p27 p28 p22 "")
    (setq label4 (entlast))
    (command "_PLINE" p23 p29 p26 "")
    (command "_PLINE" p30 p32 p33 p35 p30 "")
    (command "_PLINE" p36 p41 p39 p38 "")
    (command "_LINE" p31 p34 "" "_LINE" p37 p40 "")
    

;;;     
    (if	(= pr2 0)
      (progn
	(command "_TRIM" label2 label4 "" "_f" p29 p43 "" "")
	(command "_TRIM" label1 label3 "" "_f" p21 p42 p12 "" "")
      ) ;_  progn
      (progn
	(command "_TRIM" label2 label4 "" "_f" p29 p43 "" "")
	(command "_TRIM" label1 label3 "" "_f" p21 p42 p12 "" "")
      ) ;_  progn
    ) ;_  if
 
   ) ;_  UGOP3

;;;   ------------ ----------
   (ntrop3)
   (ugop3) 	 
  ) ;_  OPRSB

 
;;;  ----------  STOTR---------
  (cond	((= pr 1) (oprsh))
	((= pr 2) (oprsn))
	((= pr 3) (oprst))
	((= pr 4) (oprsb))
  ) ;_  cond
	
  
) ;_  STOTR1
