;;; -    ( 2)
;;;: (stotr2 dn s d10 ag dtr str a b b1 b2 c h h1 d d1 d2 s2 ip an1 mb pr pr2 pdl shtrp)
;;;:   dn -   Dn;
;;;       s -    S;
;;;       d10 -   ;
;;;       ag -     ;
;;;       dtr -     Dt;
;;;       str -     St;
;;;       a -  a;
;;;       b -  b;
;;;       b1 -  b1;
;;;       b2 -  b2;
;;;       c -  c;
;;;       h -  h;
;;;       h1 -  h1;
;;;       d -   d;
;;;       d1 -   d1;
;;;       d2 -    D2;
;;;       s2 -    s2;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pr -   (1 - , 2 - , 3 -  , 4 - )
;;;       pr2 -    (0 -  , 1 -  )
;;;       pdl -    ("1" - );
;;;       shtrp -  ("1" - , "0" - )
;;; : 18.01.2002

(defun stotr2   (dn	s      d10    ag     dtr    str	   a
		 b	b1     b2     c	     h	    h1	   d
		 d1	d2     s2     ip     an1    mb
		 pr	pr2    pdl    shtrp  /	    po1	   po2
		 po3	po4    po5    po6    po7    po8	   po1a
		 po2a	po3a   po4a   po5a   po6a   po7a   po8a
		 po9	po10   po11   po12   po13   po14   po15
		 po9a	po10a  po11a  po12a  po13a  po14a  po15a
		 pto1	po16   po17   po15b  po15c  po16a  po16b
		 po16c	po17a  po17b  po17c  pto2   elpt   ang1
		 ang2	ang3   ang4   ang5   po18   po19   po20
		 po21	po18a  po19a  po20a  po21a  pco2   po22
		 po23	po24   po25   po22a  po23a  po24a  po25a
		 pto3	pto4   p1     p2     p3	    p4	   p5
		 p6	p7     p8     ks0    ks12   z	   box
		 lsta	e      flag   ang1   lt1    lt2	   p9
		 p10	an0    an2    ip1    pc3    an3	   label1
		 sset1	r0     p11    p12    p13    p14	   p15
		 p16	p17    p18    p19    p20    p21	   p23a
		 p22	p23    p24    p25    p26    p18a   p27
		 p28	p29    p30    p31    os1    os2	   os3
		 os4	p20a   p30a   xt1    lspo1  lspo2  p3a
		 pob1	pob2   lt1    pc1    pc2    ipc	   p2a
		 p5a	x0     y0     z0     p32    p33	   p34
		 p35	label2 label3 po26   po27   po26a  po27a
		 ang6	ang7   label4 p36    p37    p38	   p39
		 p40	p15a   p23a   p41    p42    p43	   p44
		 p45	label5 label6 lspo3  lspo4  labela labelb
		 sseta  p1a    p4a    p6a    p8a    p9a    p11a
		 p13a   p14a   p16a   pt1    pt2    pt3    pt4
		 pt5    ag3    ag4    p17a   19a    po30   po31
		 po32   po33   po34   po35   po35   po36   po30a
		 po31a  po32a  po33a  p30a   p31a   p32a   p33a
		 ag5    ag6    rdr    p26a
		 )
 
  (setq lspo1 (findfile (strcat pathlisp2 "opora\\ellptst2.lsp"))
	lspo3 (findfile (strcat pathlisp2 "korpus\\ellips.lsp"))
	elpt (findfile (strcat pathlisp2 "$ellpt.lsp"))
  ) ;_  setq

  
  (load lspo1)
  (load lspo3)
  (load elpt)


;;;      
  (setq	dn  (* dn mb)
	s   (* s mb)
	d10 (* d10 mb)
	r0  (/ d10 2.0)
	a   (* a mb)
	b   (* b mb)
	b1  (* b1 mb)
	b2  (* b2 mb)
	c   (* c mb)
	h   (* h mb)
	h1  (* h1 mb)
	d   (* d mb)
	d1  (* d1 mb)
	d2  (* d2 mb)
	s2  (* s2 mb)
	dtr (* dtr mb)
	str (* str mb)
	rdr (* 0.5 d)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;    
    (ellptst2)

;;;  -   
  (defun oprsh (/ ip1 xt1 x0 y0 lt1 lt2)
    
;;;     
   (setq ip1 (polar ip (/ pi 2.0) (+ (* dn 0.25) s))
	 x0  (nth 0 ip1)
	 y0  (nth 1 ip1)
   ) ;_  setq

      
;;;    -------------    ------------
   (defun ntrop ()
;;;        
    
;;;     
    (setq p2  (list (+ x0 (nth 0 po2)) (+ y0 (nth 1 po2)) 0.0)
	  p2a (list (+ x0 (nth 0 po2a)) (+ y0 (nth 1 po2a)) 0.0)
	  p4a (list (+ x0 (nth 0 po4a)) (+ y0 (nth 1 po4a)) 0.0)
	  p4  (list (+ x0 (nth 0 po4)) (+ y0 (nth 1 po4)) 0.0)
	  pt1 (list (+ x0 (nth 0 pto1)) (+ y0 (nth 1 pto1)) 0.0)
	  pt2  (list (+ x0 (nth 0 pto2)) (+ y0 (nth 1 pto2)) 0.0)
    ) ;_  setq
    
;;;    -
    (setq p6   (list (+ x0 (nth 0 po6)) (+ y0 (nth 1 po6)) 0.0)
	  p8   (list (+ x0 (nth 0 po8)) (+ y0 (nth 1 po8)) 0.0)
	  p6a  (list (+ x0 (nth 0 po6a)) (+ y0 (nth 1 po6a)) 0.0)
	  p8a  (list (+ x0 (nth 0 po8a)) (+ y0 (nth 1 po8a)) 0.0)
	  p9   (list (+ x0 (nth 0 po9)) (+ y0 (nth 1 po9)) 0.0)
	  p11  (list (+ x0 (nth 0 po11)) (+ y0 (nth 1 po11)) 0.0)
	  p9a  (list (+ x0 (nth 0 po9a)) (+ y0 (nth 1 po9a)) 0.0)
	  p11a (list (+ x0 (nth 0 po11a)) (+ y0 (nth 1 po11a)) 0.0)
	  p13  (list (+ x0 (nth 0 po13)) (+ y0 (nth 1 po13)) 0.0)
	  p16  (list (+ x0 (nth 0 po16)) (+ y0 (nth 1 po16)) 0.0)
	  p13a (list (+ x0 (nth 0 po13a)) (+ y0 (nth 1 po13a)) 0.0)
	  p16a (list (+ x0 (nth 0 po16a)) (+ y0 (nth 1 po16a)) 0.0)
	  pt3  (list (+ x0 (nth 0 pto3)) (+ y0 (nth 1 pto3)) 0.0)
	  pt4  (list (+ x0 (nth 0 pto4)) (+ y0 (nth 1 pto4)) 0.0)
	  pt5  (polar pt4 (- 0.0 (/ pi 2.0)) h1)
	  p26  (list (+ x0 (nth 0 po26)) (+ y0 (nth 1 po26)) 0.0)
	  p26a (list (+ x0 (nth 0 po26a)) (+ y0 (nth 1 po26a)) 0.0)
    ) ;_  setq
    
;;;        
    (cond ((<= d1 20) (setq xt1 (* 1.6 mb)))
	  ((<= d1 30) (setq xt1 (* 2.0 mb)))
	  ((<= d1 48) (setq xt1 (* 2.5 mb)))
    ) ;_  cond
    (if	(< xt1 1.0)
      (setq xt1 1.0)
    ) ;_  if

    (setq p17  (polar pt3 0.0 b1)
	  p18  (polar p17 0.0 (/ d 2.0))
	  p19  (polar p18 (- 0.0 (/ pi 2.0)) h1)
	  p20  (polar pt3 pi b2)
	  p21  (polar p20 pi (- (/ d1 2.0) xt1))
	  p22  (polar p21 (- 0.0 (/ pi 2.0)) h1)
	  p23  (polar p20 pi (/ d1 2.0))
	  p24  (polar p23 (- 0.0 (/ pi 2.0)) h1)
	  os1  (polar p17 (/ pi 2.0) str)
	  os2  (polar p17 (- 0.0 (/ pi 2.0)) (+ h1 str))
	  os3  (polar p20 (/ pi 2.0) str)
	  os4  (polar p20 (- 0.0 (/ pi 2.0)) (+ h1 str))
    ) ;_  setq

;;;    -
    (osn)
    (command "_LINE" p6 p9 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (command "_LINE" p16 p16a p13a p13 p16 "")
    (command "_LINE" p8 p11 "")
    (command "_LINE" p8a p11a "" "_LINE" p6a p9a "")
    (command "_LINE" p26 p26a "")
     
;;;     
    (if	(= pdl "1")
      (progn
	(command "_SPLINE" p4a pt2 p2a "" "" "")
	(command "_LINE" p2 p2a "")
	(command "_LINE" p4 p4a "")
      ) ;_  progn
    ) ;_  if

;;;       
    (axs)
    (command "_LINE" os1 os2 "")
    (if	(/= d1 0.0)
      (command "_LINE" os3 os4 "")
    ) ;_  if

;;;     
    (osn)
    (command "_LINE" p18 p19 "")
    (setq label1 (entlast))
    (command "_MIRROR" label1 "" os1 os2 "_N")

;;;     
    (if	(/= d1 0.0)
      (progn
	(command "_LINE" p21 p22 "")
	(setq label1 (entlast))
	(command "_MIRROR" label1 "" os3 os4 "_N")
      ) ;_  progn
    ) ;_  if


;;; ----  -----
    (if	(eq shtrp "1")
      (sht)
    ) ;_  if
    
;;;     
    (if	(/= d1 0.0)
      (progn
	(ton)
	(command "_LINE" p23 p24 "")
	(setq label1 (entlast))
	(command "_MIRROR" label1 "" os3 os4 "_N")
      ) ;_  progn
    ) ;_  if

;;;      
    (axs)
    (command "_LINE" pt1 pt5 "")     
   );_  NTROP

;;;    -------------    120 ------------
   (defun ugop ()
;;;       X
      (defun newx (x z / x1)
	(setq x1 (- (* x (cos (/ pi 3.0))) (* z (sin (/ pi 3.0)))))
      ) ;_  defun

;;;    Y   
      (defun newy (dx x / y a b)
	(setq a (+ (/ dn 2.0) dx)
	      b (+ (* dn 0.25) dx)
	      y (- 0.0 (* (/ b a) (sqrt (- (expt a 2.0) (expt x 2.0)))))
	) ;_  setq
      ) ;_  defun

;;;       
      (setq lt1 (- (/ dn 2.0) (* 2.0 s))
;;;	    pob1 (list (+ x0 lt1) (+ y0 (newy (/ s 2.0) lt1)) 0.0)
;;;	    pob2 (list (+ x0 lt1) (+ y0 (newy (* s 2.0) lt1)) 0.0)
	    p15  (list (- x0 (newx (nth 0 po15) (nth 2 po15))) (+ y0 (nth 1 po15)) 0.0)
	    p16  (list (- x0 (newx (nth 0 po16) (nth 2 po16))) (+ y0 (nth 1 po16)) 0.0)
	    p13  (list (- x0 (newx (nth 0 po13) (nth 2 po13))) (+ y0 (nth 1 po13)) 0.0)
	    pt3  (list (- x0 (newx (nth 0 pto3) (nth 2 pto3))) (+ y0 (nth 1 pto3)) 0.0)
	    p26  (list (- x0 (newx (nth 0 po26) (nth 2 po26))) (+ y0 (nth 1 po26)) 0.0)
	    p25  (list (- x0 (newx (nth 0 po25) (nth 2 po25))) (+ y0 (nth 1 po25)) 0.0)
	    p27  (list (- x0 (newx (nth 0 po27) (nth 2 po27))) (+ y0 (nth 1 po27)) 0.0)
            p15a (polar p15 (- 0.0 (/ pi 2.0)) h1)
	    p16a (polar p16 (- 0.0 (/ pi 2.0)) h1)
	    p13a (polar p13 (- 0.0 (/ pi 2.0)) h1)
	    pt5  (polar pt3 (- 0.0 (/ pi 2.0)) (+ h1 str))
	    p9   (polar pt3 0.0 (/ dtr 2.0))
	    p11  (polar pt3 pi (/ dtr 2.0))
	    p6   (polar p9 (/ pi 2.0) (- h h1))
	    p8   (polar p11 (/ pi 2.0) (- h h1))
	    pt1  (polar pt3 (/ pi 2.0) (- h h1))
      ) ;_  setq
     
;;;     
      (osn)
      (command "_LINE" p15 p15a p13a p13 p15 "")
      (command "_LINE" p15 p15a "" "_LINE" p16 p16a ""  "_LINE" p13 p13a "")
      (command "_LINE" p11 p8 "" "_LINE" p9 p6 "")
      (command "_ELLIPSE" "_a" p25 p27 p26 p25 p27)

;;;           
      (axs)
      (command "_LINE" pt5 pt1 "")

;;;     
      (axs)
      (command "_LINE" ip ip1 "")
      (setq labela (entlast))
      (setq labelb labela)
      (ellips3 dn s (* dn 0.25) 0.0 ip1 pi 1.0 1)
      (setq sseta (ssadd (entnext labela)))
      (while (setq labela (entnext labela))
	(setq sseta (ssadd labela sseta))
      ) ;_  while
      (command "_TRIM" sseta "" "_f" p8 p6 "" "")
      (command "_ERASE" sseta labelb "")
     
   ) ;_  UGOP

;;;    
  (defun sht (/	dl1    dl2    dl3    dl4    dl5	   ang1	  ang2	 ang3
		ang4   ang5   pts1   pts2   pts3   pts4	  pts5	 pts6
	       ) 
    (setq dl1  (distance pt1 pt2)
	  dl2  (distance p6 p9a)
	  dl3  (distance p8 p11a)
	  dl4  (distance p16 p22)
	  dl5  (distance p13 p19)
	  ang1 (angle pt1 pt2)
	  ang2 (angle p6 p9a)
	  ang3 (angle p8 p11a)
	  ang4 (angle p16 p22)
	  ang5 (angle p13 p19)
	  pts1 (polar pt1 ang1 (/ dl1 2.0))
	  pts2 (polar p6 ang2 (/ dl2 2.0))
	  pts3 (polar p8 ang3 (/ dl3 2.0))
	  pts4 (polar p16 ang4 (/ dl4 2.0))
	  pts5 (polar p13 ang5 (/ dl5 2.0))
	  pts6 (polar pt3 (- 0.0 (/ pi 2.0)) (/ h1 2.0))
    ) ;_  setq
    (ton)
    (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pts4 pts5 "")
    (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pts6 "")
    (command "_BHATCH" "_p" "_u" 45 2.0 "_n" pts2 pts3 "")
    (if	(eq pdl "1")
      (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pts1 "")
    ) ;_  if
   ) ;_  SHT

;;;   ------------ ----------
    (ntrop)
    (ugop) 	 
  ) ;_  OPRSH

  
;;;    
  (defun oprsn (/ )
;;;       
    (setq ipc (polar ip pi (/ d10 2.0))
	  x0  (nth 0 ipc)
	  y0  (nth 1 ipc)
    ) ;_  setq

;;;     
    (setq p1a  (list (+ x0 (nth 0 po1a)) (+ y0 (nth 2 po1a)) 0.0)
	  p3a  (list (+ x0 (nth 0 po3a)) (+ y0 (nth 2 po3a)) 0.0)
	  p4a  (list (+ x0 (nth 0 po4a)) (+ y0 (nth 2 po4a)) 0.0)
    ) ;_  setq

;;;   -
    (setq p13a (list (+ x0 (nth 0 po13a)) (+ y0 (nth 2 po13a)) 0.0)
	  p14a (list (+ x0 (nth 0 po14a)) (+ y0 (nth 2 po14a)) 0.0)
	  p15a (list (+ x0 (nth 0 po15a)) (+ y0 (nth 2 po15a)) 0.0)
	  p16a (list (+ x0 (nth 0 po16a)) (+ y0 (nth 2 po16a)) 0.0)
	  pt4  (list (+ x0 (nth 0 pto4)) (+ y0 (nth 2 pto4)) 0.0)
	  pc1  (polar pt4 0.0 b1)
	  pc2  (polar pt4 pi b2)
	  pt1  (polar pt4 0.0 (+ b1 c h1))
	  pt2  (polar pt4 pi (+ (- b b1 c) h1))
	  pt3  (polar pt4 (/ pi 2.0) (+ (/ a 2.0) h1))
	  pt5  (polar pt4 (- 0.0 (/ pi 2.0)) (+ (/ a 2.0) h1))
	  os1  (polar pc1 (/ pi 2.0) d)
	  os2  (polar pc1 (- 0.0 (/ pi 2.0)) d)
	  os3  (polar pc2 (/ pi 2.0) d1)
	  os4  (polar pc2 (- 0.0 (/ pi 2.0)) d1)
	  p17  (polar pc2 0.0 (/ d1 2.0))
	  p18  (polar pc2 (- 0.0 (/ pi 2.0)) (/ d1 2.0))
	  p19  (polar pt4 (/ pi 2.0) (/ a 4.0))
	  p20  (polar p19 0.0 (/ d2 2.0))
	  p21  (polar p19 pi (/ d2 2.0))
    ) ;_  setq

;;;          
    (cond ((<= d2 20) (setq xt1 (* 1.6 mb)))
	  ((<= d2 30) (setq xt1 (* 2.0 mb)))
	  ((<= d2 48) (setq xt1 (* 2.5 mb)))
    ) ;_  cond
    (if	(< xt1 1.0)
      (setq xt1 1.0)
    ) ;_  if

;;;    
;;;    -
    (axs)
    (command "_LINE" pt1 pt2 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (setq label1 (entlast))
    (setq sset1 (ssadd (entlast)))
;;;    (command "_LINE" os1 os2 "")
    
    (osn)
    (command "_LINE" p13a p14a "" "_LINE" p15a p16a "")
    (command "_LINE" p13a p16a "")
    (setq label2 (entlast))
    (command "_LINE" p14a p15a "")
    (setq label3 (entlast))
   
;;;     
    (if	(= pdl "1")
      (if (> d2 a)
	(progn
	  (command "_ELLIPSE" "_c" pt4 p4a p1a)
	  (command "_TRIM" label2 label3 "" "_f" p20 p21 "" "_f" p20 p21 "" "")
;;;	  (punkt2)
;;;	  (command "_ELLIPSE" "_c" pt4 p4a p1a)
	) ;_  progn
;;;	(progn
;;;	  (punkt2)
;;;	  (command "_ELLIPSE" "_c" pt4 p4a p1a)
;;;	) ;_  progn
      ) ;_  if
    ) ;_  if

;;;        ()
;;;    (punkt2)
;;;    (command "_CIRCLE" pt4 (/ dtr 2.0))
;;;    (command "_CIRCLE" pt4 (- (/ dtr 2.0) str))
;;;
;;;;;;       
    (axs)
    (command "_LINE" pt3 pt5 "")

;;;     
    (osn)
    (command "_CIRCLE" pc1 (/ d 2.0))

;;;     
    (if	(/= d1 0.0)
      (progn
	(command "_CIRCLE" pc2 (- (/ d1 2.0) xt1))
	(axs)
	(command "_LINE" os3 os4 "")
	
;;;     
	(ton)
	(command "_ARC" "_c" pc2 p17 p18)
      ) ;_  progn
    ) ;_  if

   
;;; 
    (while (setq label1 (entnext label1))
      (setq sset1 (ssadd label1 sset1))
    ) ;_  while
    (command "_ARRAY" sset1 "" "_p" ipc 3 "" "")

;;;    
    (axs)
    (command "_CIRCLE" ipc (/ d10 2.0))

  ) ;_  OPRSN


  
;;;  -    
  (defun oprst (/ ip1 xt1 x0 y0 lt1 lt2)
    
;;;     
    (setq ip1	(polar ip (/ pi 2.0) (+ (* dn 0.25) s))
	  x0	(nth 0 ip1)
	  y0	(nth 1 ip1)
    ) ;_  setq
    
;;;    -------------    ------------
   (defun ntrop2 ()
;;;        
;;;     
    (setq p1  (list (+ x0 (nth 2 po1)) (+ y0 (nth 1 po1)) 0.0)
	  p2  (list (+ x0 (nth 2 po2)) (+ y0 (nth 1 po2)) 0.0)
	  p3  (list (+ x0 (nth 2 po3)) (+ y0 (nth 1 po3)) 0.0)
	  p1a (list (+ x0 (nth 2 po1a)) (+ y0 (nth 1 po1a)) 0.0)
	  p2a (list (+ x0 (nth 2 po2a)) (+ y0 (nth 1 po2a)) 0.0)
	  p3a (list (+ x0 (nth 2 po3a)) (+ y0 (nth 1 po3a)) 0.0)
	  p4a (list (+ x0 (nth 2 po4a)) (+ y0 (nth 1 po4a)) 0.0)
    ) ;_  setq
    
;;;    -
    (setq p5   (list (+ x0 (nth 2 po5)) (+ y0 (nth 1 po5)) 0.0)
	  p6   (list (+ x0 (nth 2 po6)) (+ y0 (nth 1 po6)) 0.0)
	  p7   (list (+ x0 (nth 2 po7)) (+ y0 (nth 1 po7)) 0.0)
	  pt3  (polar p6 (- 0.0 (/ pi 2.0)) (- h h1))
	  p9   (polar pt3 0.0 (/ dtr 2.0))
	  p11  (polar pt3 pi (/ dtr 2.0))
	  p13  (polar pt3 pi (/ a 2.0))
	  p14  (polar pt3 0.0 (/ a 2.0))
	  p13a (polar p13 (- 0.0 (/ pi 2.0)) h1)
	  p14a (polar p14 (- 0.0 (/ pi 2.0)) h1)
	  pt5  (polar pt3 (- 0.0 (/ pi 2.0)) (+ h1 h1))
	  pt1  (polar pt3 (/ pi 2.0) h)
	  pt2  (polar pt3 (/ pi 2.0) (* 0.1 h))  
    ) ;_  setq
    

;;;    -
    (osn)
    (command "_LINE" p13 p14 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (command "_ELLIPSE" "_a" p5 p7 p6 p5 p7)
    (command "_LINE" p13 p13a p14a p14 "")
    (command "_LINE" p5 p9 "")
    (setq label1 (entlast))
    (command "_LINE" p7 p11 "")
    (setq label2 (entlast))

;;;      
   (if (= pdl "1")
     (progn
       (command "_ELLIPSE" "_a" p3 p1 p2 p1 p3)
       (command "_ELLIPSE" "_a" p3a p1a p2a "0" "360")
       (command "_LINE" p1 p1a "" "_LINE" p3 p3a "")
     ) ;_  progn
   ) ;_  if

;;;    
   (command  "_TRIM" label1 label2 "" "_f" p6 pt2 "" "") 
   
  );_  NTROP2

;;;    -------------    120 ------------
   (defun ugop2 ()
;;;       X
      (defun newx (x z / x1)
	(setq x1 (- (* x (cos (/ pi 6.0))) (* z (sin (/ pi 6.0)))))
      ) ;_  defun

;;;       
      (setq p15  (list (- x0 (newx (nth 0 po15) (nth 2 po15))) (+ y0 (nth 1 po15)) 0.0)
	    p16  (list (- x0 (newx (nth 0 po16) (nth 2 po16))) (+ y0 (nth 1 po16)) 0.0)
	    p13  (list (- x0 (newx (nth 0 po13) (nth 2 po13))) (+ y0 (nth 1 po13)) 0.0)
	    pt3  (list (- x0 (newx (nth 0 pto3) (nth 2 pto3))) (+ y0 (nth 1 pto3)) 0.0)
	    p25  (list (- x0 (newx (nth 0 po25) (nth 2 po25))) (+ y0 (nth 1 po25)) 0.0)
	    p26  (list (- x0 (newx (nth 0 po26) (nth 2 po26))) (+ y0 (nth 1 po26)) 0.0)
	    p27  (list (- x0 (newx (nth 0 po27) (nth 2 po27))) (+ y0 (nth 1 po27)) 0.0)
	    p15a (polar p15 (- 0.0 (/ pi 2.0)) h1)
	    p16a (polar p16 (- 0.0 (/ pi 2.0)) h1)
	    p13a (polar p13 (- 0.0 (/ pi 2.0)) h1)
	    pt5  (polar pt3 (- 0.0 (/ pi 2.0)) (* h1 2.0))
	    p9   (polar pt3 0.0 (/ dtr 2.0))
	    p11  (polar pt3 pi (/ dtr 2.0))
	    p8   (polar p11 (/ pi 2.0) (- h h1))
	    p6   (polar p9 (/ pi 2.0) (- h h1))
	    pt1  (polar pt3 (/ pi 2.0) (- h h1))
      ) ;_  setq
     
;;;     
      (osn)
      (command "_LINE" p15 p13 "")
      (setq label1 (entlast))
      (setq sset1 (ssadd (entlast)))
      (command "_LINE" p15 p15a p13a p13 "")
      (command "_LINE" p16 p16a "")
      (command "_LINE" p11 p8 ""  "_LINE" p9 p6 "")
      (command "_ELLIPSE" "_a" p25 p27 p26 p25 p27)

;;;      
      (axs)
      (command "_LINE" pt5 pt1 "")

;;;     
      (axs)
      (command "_LINE" ip ip1 "")
      (setq labela (entlast))
      (setq labelb labela)
      (ellips3 dn s (* dn 0.25) 0.0 ip1 pi 1.0 1)
      (setq sseta (ssadd (entnext labela)))
      (while (setq labela (entnext labela))
	(setq sseta (ssadd labela sseta))
      ) ;_  while
      (command "_TRIM" sseta "" "_f" p8 p6 "" "")
      (command "_ERASE" sseta labelb "")

           
;;;      
      (while (setq label1 (entnext label1))
        (setq sset1 (ssadd label1 sset1))
      ) ;_  while
      (command "_MIRROR" sset1 "" ip "@0,25" "_N")
 
   ) ;_  UGOP2

;;;   ------------ ----------
   (ntrop2)
   (ugop2) 	 
  ) ;_  OPRST


;;;  -  
  (defun oprsb (/ ip1 xt1 x0 y0 lt1 lt2)
;;;     
      (setq ip1	(polar ip (/ pi 2.0) (+ (* dn 0.25) s))
	    x0	(nth 0 ip1)
	    y0	(nth 1 ip1)
      ) ;_  setq

;;;    Y   
      (defun newy (dx x / y a b)
	(setq a (+ (/ dn 2.0) dx)
	      b (+ (* dn 0.25) dx)
	      y (- 0.0 (* (/ b a) (sqrt (- (expt a 2.0) (expt x 2.0)))))
	) ;_  setq
      ) ;_  defun
    
;;;    -------------    ------------
   (defun ntrop3 ()
;;;        
    
;;;     
    (setq p2  (list (+ x0 (nth 0 po2)) (+ y0 (nth 1 po2)) 0.0)
	  p2a (list (+ x0 (nth 0 po2a)) (+ y0 (nth 1 po2a)) 0.0)
	  p4a (list (+ x0 (nth 0 po4a)) (+ y0 (nth 1 po4a)) 0.0)
	  p4  (list (+ x0 (nth 0 po4)) (+ y0 (nth 1 po4)) 0.0)
	  pt1 (list (+ x0 (nth 0 pto1)) (+ y0 (nth 1 pto1)) 0.0)
	  pt2  (list (+ x0 (nth 0 pto2)) (+ y0 (nth 1 pto2)) 0.0)
    ) ;_  setq
    
;;;    -
    (setq p6   (list (+ x0 (nth 0 po6)) (+ y0 (nth 1 po6)) 0.0)
	  p8   (list (+ x0 (nth 0 po8)) (+ y0 (nth 1 po8)) 0.0)
	  p6a  (list (+ x0 (nth 0 po6a)) (+ y0 (nth 1 po6a)) 0.0)
	  p8a  (list (+ x0 (nth 0 po8a)) (+ y0 (nth 1 po8a)) 0.0)
	  p9   (list (+ x0 (nth 0 po9)) (+ y0 (nth 1 po9)) 0.0)
	  p11  (list (+ x0 (nth 0 po11)) (+ y0 (nth 1 po11)) 0.0)
	  p9a  (list (+ x0 (nth 0 po9a)) (+ y0 (nth 1 po9a)) 0.0)
	  p11a (list (+ x0 (nth 0 po11a)) (+ y0 (nth 1 po11a)) 0.0)
	  p13  (list (+ x0 (nth 0 po13)) (+ y0 (nth 1 po13)) 0.0)
	  p16  (list (+ x0 (nth 0 po16)) (+ y0 (nth 1 po16)) 0.0)
	  p13a (list (+ x0 (nth 0 po13a)) (+ y0 (nth 1 po13a)) 0.0)
	  p16a (list (+ x0 (nth 0 po16a)) (+ y0 (nth 1 po16a)) 0.0)
	  pt3  (list (+ x0 (nth 0 pto3)) (+ y0 (nth 1 pto3)) 0.0)
	  pt4  (list (+ x0 (nth 0 pto4)) (+ y0 (nth 1 pto4)) 0.0)
	  pt5  (polar pt4 (- 0.0 (/ pi 2.0)) h1)
    ) ;_  setq
    
;;;        
    (cond ((<= d1 20) (setq xt1 (* 1.6 mb)))
	  ((<= d1 30) (setq xt1 (* 2.0 mb)))
	  ((<= d1 48) (setq xt1 (* 2.5 mb)))
    ) ;_  cond
    (if	(< xt1 1.0)
      (setq xt1 1.0)
    ) ;_  if

    (setq p17  (polar pt3 0.0 b1)
	  p18  (polar p17 0.0 (/ d 2.0))
	  p19  (polar p18 (- 0.0 (/ pi 2.0)) h1)
	  p20  (polar pt3 pi b2)
	  p21  (polar p20 pi (- (/ d1 2.0) xt1))
	  p22  (polar p21 (- 0.0 (/ pi 2.0)) h1)
	  p23  (polar p20 pi (/ d1 2.0))
	  p24  (polar p23 (- 0.0 (/ pi 2.0)) h1)
	  os1  (polar p17 (/ pi 2.0) str)
	  os2  (polar p17 (- 0.0 (/ pi 2.0)) (+ h1 str))
	  os3  (polar p20 (/ pi 2.0) str)
	  os4  (polar p20 (- 0.0 (/ pi 2.0)) (+ h1 str))
    ) ;_  setq

;;;    -
    (osn)
    (command "_LINE" p6 p9 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (command "_LINE" p16 p16a p13a p13 p16 "")
    (command "_LINE" p8 p11 "")

;;;      
;;;    (punkt2)
;;;    (command "_LINE" p8a p11a "" "_LINE" p6a p9a "")
     
;;;     
    (if	(= pdl "1")
      (progn
	(osn)
	(command "_SPLINE" p4a pt2 p2a "" "" "")
	(command "_LINE" p2 p2a "")
	(command "_LINE" p4 p4a "")
      ) ;_  progn
    ) ;_  if
   
;;;      
    (axs)
    (command "_LINE" pt1 pt5 "") 

   );_  NTROP3

;;;    -------------    120 ------------
   (defun ugop3 ()
;;;       X
      (defun newx (x z / x1)
	(setq x1 (- (* x (cos (/ pi 3.0))) (* z (sin (/ pi 3.0)))))
      ) ;_  defun

;;;         
      (setq p1   (list (- x0 (newx (nth 0 po1) (nth 2 po1))) (+ y0 (nth 1 po1)) 0.0)
	    p2   (list (- x0 (newx (nth 0 po2) (nth 2 po2))) (+ y0 (nth 1 po2)) 0.0)
	    p3   (list (- x0 (newx (nth 0 po3) (nth 2 po3))) (+ y0 (nth 1 po3)) 0.0)
	    p4   (list (- x0 (newx (nth 0 po4) (nth 2 po4))) (+ y0 (nth 1 po4)) 0.0)
	    p17  (list (- x0 (newx (nth 0 po17) (nth 2 po17))) (+ y0 (nth 1 po17)) 0.0)
	    p18  (list (- x0 (newx (nth 0 po18) (nth 2 po18))) (+ y0 (nth 1 po18)) 0.0)
	    p19  (list (- x0 (newx (nth 0 po19) (nth 2 po19))) (+ y0 (nth 1 po19)) 0.0)
	    p20  (list (- x0 (newx (nth 0 po20) (nth 2 po20))) (+ y0 (nth 1 po20)) 0.0)
	    p30  (list (- x0 (newx (nth 0 po30) (nth 2 po30))) (+ y0 (nth 1 po30)) 0.0)
	    p31  (list (- x0 (newx (nth 0 po31) (nth 2 po31))) (+ y0 (nth 1 po31)) 0.0)
	    p32  (list (- x0 (newx (nth 0 po32) (nth 2 po32))) (+ y0 (nth 1 po32)) 0.0)
	    p33  (list (- x0 (newx (nth 0 po33) (nth 2 po33))) (+ y0 (nth 1 po33)) 0.0)
	    p1a  (list (- x0 (newx (nth 0 po1a) (nth 2 po1a))) (+ y0 (nth 1 po1a)) 0.0)
	    p2a  (list (- x0 (newx (nth 0 po2a) (nth 2 po2a))) (+ y0 (nth 1 po2a)) 0.0)
	    p3a  (list (- x0 (newx (nth 0 po3a) (nth 2 po3a))) (+ y0 (nth 1 po3a)) 0.0)
	    p4a  (list (- x0 (newx (nth 0 po4a) (nth 2 po4a))) (+ y0 (nth 1 po4a)) 0.0)
	    p17a (list (- x0 (newx (nth 0 po17a) (nth 2 po17a))) (+ y0 (nth 1 po17a)) 0.0)
	    p18a (list (- x0 (newx (nth 0 po18a) (nth 2 po18a))) (+ y0 (nth 1 po18a)) 0.0)
	    p19a (list (- x0 (newx (nth 0 po19a) (nth 2 po19a))) (+ y0 (nth 1 po19a)) 0.0)
	    p20a (list (- x0 (newx (nth 0 po20a) (nth 2 po20a))) (+ y0 (nth 1 po20a)) 0.0)
	    p30a (list (- x0 (newx (nth 0 po30a) (nth 2 po30a))) (+ y0 (nth 1 po30a)) 0.0)
	    p31a (list (- x0 (newx (nth 0 po31a) (nth 2 po31a))) (+ y0 (nth 1 po31a)) 0.0)
	    p32a (list (- x0 (newx (nth 0 po32a) (nth 2 po32a))) (+ y0 (nth 1 po32a)) 0.0)
	    p33a (list (- x0 (newx (nth 0 po33a) (nth 2 po33a))) (+ y0 (nth 1 po33a)) 0.0)
	    pt1  (list (- x0 (newx (nth 0 pto1) (nth 2 pto1))) (+ y0 (nth 1 pto1)) 0.0)
	    pt2  (list (- x0 (newx (nth 0 pto2) (nth 2 pto2))) (+ y0 (nth 1 pto2)) 0.0)
      ) ;_  setq

;;;       -
      (setq p5   (list (- x0 (newx (nth 0 po5) (nth 2 po5))) (+ y0 (nth 1 po5)) 0.0)
	    p6   (list (- x0 (newx (nth 0 po6) (nth 2 po6))) (+ y0 (nth 1 po6)) 0.0)
	    p7   (list (- x0 (newx (nth 0 po7) (nth 2 po7))) (+ y0 (nth 1 po7)) 0.0)
	    p8   (list (- x0 (newx (nth 0 po8) (nth 2 po8))) (+ y0 (nth 1 po8)) 0.0)
	    p21  (list (- x0 (newx (nth 0 po21) (nth 2 po21))) (+ y0 (nth 1 po21)) 0.0)
	    p22  (list (- x0 (newx (nth 0 po22) (nth 2 po22))) (+ y0 (nth 1 po22)) 0.0)
	    p23  (list (- x0 (newx (nth 0 po23) (nth 2 po23))) (+ y0 (nth 1 po23)) 0.0)
	    p24  (list (- x0 (newx (nth 0 po24) (nth 2 po24))) (+ y0 (nth 1 po24)) 0.0)
	    p34  (list (- x0 (newx (nth 0 po34) (nth 2 po34))) (+ y0 (nth 1 po34)) 0.0)
	    p35  (list (- x0 (newx (nth 0 po35) (nth 2 po35))) (+ y0 (nth 1 po35)) 0.0)
	    p36  (list (- x0 (newx (nth 0 po36) (nth 2 po36))) (+ y0 (nth 1 po36)) 0.0)
	    p37  (list (- x0 (newx (nth 0 po37) (nth 2 po37))) (+ y0 (nth 1 po37)) 0.0)
	    p15  (list (- x0 (newx (nth 0 po15) (nth 2 po15))) (+ y0 (nth 1 po15)) 0.0)
	    p13  (list (- x0 (newx (nth 0 po13) (nth 2 po13))) (+ y0 (nth 1 po13)) 0.0)
	    p14  (list (- x0 (newx (nth 0 po14) (nth 2 po14))) (+ y0 (nth 1 po14)) 0.0)
	    pt3  (list (- x0 (newx (nth 0 pto3) (nth 2 pto3))) (+ y0 (nth 1 pto3)) 0.0)
	    p15a (polar p15 (- 0.0 (/ pi 2.0)) h1)
	    p14a (polar p14 (- 0.0 (/ pi 2.0)) h1)
	    p13a (polar p13 (- 0.0 (/ pi 2.0)) h1)
	    pt5  (polar pt3 (- 0.0 (/ pi 2.0)) (* h1 2.0))
	    p9   (polar pt3 0.0 (/ dtr 2.0))
	    p11  (polar pt3 pi (/ dtr 2.0))
	    p25  (polar p9 (/ pi 2.0) (- h h1))
	    p26  (polar p11 (/ pi 2.0) (- h h1))
	    pt4  (polar pt3 (/ pi 2.0) h1)
	    pt1  (polar pt3 (/ pi 2.0) h)
      );_  setq
     
;;;     
      (osn)
;;;     
      (if (= pdl "1")
	(progn
	  (command "_SPLINE" p33 p1 p30 p17 p2 p18 p31 "" "" "")
          (command "_SPLINE" p4a p20a p33a p1a p30a p17a p2a p18a p31a p3a p32a p19a "_c" "")
	  (command "_LINE" p33 p33a "" "_LINE" p31 p31a "")
	) ;_  progn
      ) ;_  if

;;;     -
      (command "_LINE" p15 p15a p13a p13 p15 "")
      (command "_LINE" p14 p14a "")
      (command "_SPLINE" p8 p24 p37 p5 p34 p21 p6 p22 p35 p7 p36 p23 "_c" "")

;;;      
      (command "_LINE" p11 p35 "")
      (setq label1 (entlast))
      (command "_LINE" p9 p37 "")
      (setq label2 (entlast))

;;;      
      (axs)
      (command "_LINE" pt5 pt1 "")

;;;     
      (command  "_TRIM" label1 label2 "" "_f" pt4 pt2 "" "")

   ) ;_  UGOP3

;;;   ------------ ----------
   (ntrop3)
   (ugop3) 	 
  ) ;_  OPRSB

 
;;;  ----------  STOTR---------
  (cond	((= pr 1) (oprsh))
	((= pr 2) (oprsn))
	((= pr 3) (oprst))
	((= pr 4) (oprsb))
  ) ;_  cond
	
  
) ;_  STOTR2
