;;;    
;;;:  ..
;;; : 27.09.2001
;;;CAD-CEE 2000
;;;: C:UBOPOR

(defun c:ubopor (/ tipf	 db    d     dotv  notv	 d1    d2    d3
		   d4	 d5    d6    h	   h2	 b     l     s
		   sech	 sprd  name1 orx   aby	 dlg   dfl   lsp1
		   lsp2	 lsp3  lsp4  lsp5  fld	 strd  strdd strd1
		   strdd1      p1    p2	   p3	 angl  mash  name1
		   spis	 pti   inptG xc	   yc	 dcl_id	     inptG
		   a1	 mb    cmd   blpm  apsz	 osmd  clay  cltp
		   ccol	 vs    vctr  pv	   anbl	 sset  label sech2
		   sbk	 py    dy    pyf   dyf	 stf   fldat dfl2
		   as	 ass   bs    bss   bss1	 bss2  fldat2
		   as3	 ass3  dtb   stb   shtrp spism mtr   hpa
		   hpn	 st    bd    pd	   co	 dat1  dat2  dat3
		   dat4	 dat5  l1    s1	   r	 fillr qmax  qmin
		   qmaxl qminl qmxl  qmnl  as1	 as2   bss3  s2
		   s3	 n     d0    h	   s10	 s20   s30   dflt1
		   sl    sn    prvh  y1
		  ) 


  (setq	dlg  (findfile (strcat pathdcl2 "opora\\ubopor.dcl"))
	dfl  (findfile (strcat pathlisp2 "opora\\ubopor.d"))
	dat1 (findfile (strcat pathdat2 "opora\\ub123.dat"))
	dat2 (findfile (strcat pathdat2 "opora\\ub5.dat"))
	dat3 (findfile (strcat pathdat2 "korpus\\el6533v.dat"))
        dat4 (findfile (strcat pathdat2 "opora\\ub1ob.dat"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "opora\\ubotr.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

;;;    
  (setq spis '(" 1"
	       " 2"
	       " 3"
	    ;;;" 5"
               " 1 ()"
	      ) 
  ) ;_  setq

;;;     
;;;  (setq sl '("4" "5" "6" "8" "10" "12" "14" "16"))

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt ()
     (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun textf ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  
;;;      KONPR.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   dy	  (itoa (nth 1 strdd1))
	   s	  (nth 2 strdd1)
	   qmxl   (itoa (nth 3 strdd1))
	   qmnl   (itoa (nth 4 strdd1))
	   h      (nth 5 strdd1)
	   sech	  (itoa (nth 6 strdd1))
	   sprd	  (itoa (nth 7 strdd1))
	   shtrp  (itoa (nth 8 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "Qmax" qmxl)
    (set_tile "Qmin" qmnl)
    (set_tile "D" dy)
    (set_tile "S" (rtos s))
    (set_tile "H" (rtos h))
    (set_tile "S1" (rtos s1))
    (set_tile "S2" (rtos s2))
    (set_tile "S3" (rtos s3))
    (set_tile "D1" (rtos d1))
    (set_tile "D2" (rtos d2))
    (set_tile "D3" (rtos d3))
    (set_tile "D0" (rtos d0))
    (set_tile "N" (itoa n))
    (set_tile "L" (rtos l))
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Shtr" shtrp)
    (if	(or (= tipf "0") (= tipf "3"))
      (mode_tile "S3" 1)
      (mode_tile "S3" 0)
    ) ;_  if
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       KONPR.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " dy " " (rtos s) " " qmxl " " qmnl " " (rtos h) " "
			        sech " " sprd " " shtrp ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(1).slb"))
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(2).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(3).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(4).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(5).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(6).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(1).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "opora\\ubopor(2).slb"))
	)
;;;	((and (eq tipf "3")
;;;	      (eq sech "1")
;;;	      (eq sprd "0")
;;;	 ) ;_  and
;;;	 (setq name1 (strcat pathdat2 "opora\\ubopor(7).slb"))
;;;	)
;;;	((and (eq tipf "3")
;;;	      (eq sech "0")
;;;	      (eq sprd "1")
;;;	 ) ;_  and
;;;	 (setq name1 (strcat pathdat2 "opora\\ubopor(8).slb"))
;;;	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;     
  (defun defl ()
    (setq dy   "0"
	  qmnl "0"
	  qmxl "0"
    ) ;_  setq
  ) ;_  defun

;;;     
  (defun dflt ()
    (setq dflt1 (list dy qmxl qmnl d qmax qmin d1 d2 d3 s1 s2 s3 d0 n l))  
  ) ;_  defun

;;;     
  (defun vost ()
    (setq dy   (nth 0 dflt1)
	  qmxl (nth 1 dflt1)
	  qmnl (nth 2 dflt1)
	  d    (nth 3 dflt1)
	  qmax (nth 4 dflt1)
	  qmin (nth 5 dflt1)
	  d1   (nth 6 dflt1)
	  d2   (nth 7 dflt1)
	  d3   (nth 8 dflt1)
	  s1   (nth 9 dflt1)
	  s2   (nth 10 dflt1)
	  s3   (nth 11 dflt1)
	  d0   (nth 12 dflt1)
	  n    (nth 13 dflt1)
	  l    (nth 14 dflt1)
    ) ;_  setq
  ) ;_  defun

	 
;;;    
  (defun dfl_fn	()
    (cond ((= tipf "0") (setq dfl2 dat1))
	  ((= tipf "1") (setq dfl2 dat1))
	  ((= tipf "2") (setq dfl2 dat1))
	  ((= tipf "3") (setq dfl2 dat4))
;;;	  ((= tipf "3") (setq dfl2 dat2))
    ) ;_  cond
  ) ;_  defun

;;;   Qmin
  (defun dfl_fn2 ()
    (if	(< (atoi tipf) 3)
      (cond ((= qmax 0.25) (setq qminl (list "0.125" "0.2")))
	    ((= qmax 0.63) (setq qminl (list "0.32" "0.5")))
	    ((= qmax 1.6) (setq qminl (list "0.8" "1.32")))
	    ((= qmax 2.5) (setq qminl (list "1.32" "2.0")))
	    ((= qmax 4.0) (setq qminl (list "2.0" "3.2")))
	    ((= qmax 6.3) (setq qminl (list "3.2" "5.0")))
	    ((= qmax 10.0) (setq qminl (list "5.0" "8.0")))
	    ((= qmax 16.0) (setq qminl (list "8.0" "10.0")))
      ) ;_  cond
      (cond ((= qmax 0.32) (setq qminl (list "0.125")))
	    ((= qmax 1.5) (setq qminl (list "0.2")))
	    ((= qmax 3.2) (setq qminl (list "0.4")))
	    ((= qmax 5.0) (setq qminl (list "0.63")))
	    ((= qmax 10.0) (setq qminl (list "1.6")))
	    ((= qmax 12.5) (setq qminl (list "2.5")))
      ) ;_  cond
;;;      (cond ((= qmax 0.63) (setq qminl (list "0.125")))
;;;	    ((= qmax 1.6) (setq qminl (list "0.32")))
;;;	    ((= qmax 2.5) (setq qminl (list "0.5")))
;;;	    ((= qmax 4.0) (setq qminl (list "0.8")))
;;;	    ((= qmax 6.3) (setq qminl (list "1.32")))
;;;	    ((= qmax 10.0) (setq qminl (list "2.0")))
;;;      ) ;_  cond
    ) ;_  if
  ) ;_  defun

;;;      
(defun desk_f ()
  (setq	fldat (open dfl2 "r")
	as    (read-line fldat)
	dyf   (read as)
	as1   (read-line fldat)
	qmaxl (read as1)
	as2   (read-line fldat)
;;;	qminl (read as2)
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	bss2  (nth 2 bss)
	bss3  (nth 3 bss)
	d1    (nth 4 bss)
	d2    (nth 5 bss)
	d3    (nth 6 bss)
	s1    (nth 7 bss)
	s2    (nth 8 bss)
	s3    (nth 9 bss)
	d0    (nth 10 bss)
	n     (nth 11 bss)
	l     (+ 160 (* 4.0 s1))
	y1    1
  ) ;_  setq
) ;_  defun


 ;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun



;;;      
(defun whl ()
  (if (or (/= qmax bss1)
	  (/= qmnl bss2)
	  (/= d bss3)
      ) ;_  or
    (clos_dfl2)
  ) ;_  if 
  (while (or (/= qmax bss1)
	     (/= qmnl bss2)
	     (/= d bss3)
         ) ;_  or
    (setq bs (read-line fldat))
    (if	(or (= bs nil) (= bs ""))
      (progn
	(attn3)
	(vost)
	(setq bss1 qmax
	      bss2 qmnl
	      bss3 d
	      y1   0
	) ;_  setq
      ) ;_  progn
      (setq bss	 (read bs)
	    bss1 (nth 0 bss)
	    bss2 (nth 2 bss)
	    bss3 (nth 3 bss)
	    d1	 (nth 4 bss)
	    d2	 (nth 5 bss)
	    d3	 (nth 6 bss)
	    s1	 (nth 7 bss)
	    s2	 (nth 8 bss)
	    s3	 (nth 9 bss)
	    d0	 (nth 10 bss)
	    n	 (nth 11 bss)
	    l	 (+ 160 (* 4.0 s1))
	    y1   1
      ) ;_  setq
    ) ;_  if
  ) ;_  while
) ;_  defun


;;;    
    (defun tipf_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun


;;;   
    (defun dyf_l ()
      (start_list "D")
      (mapcar 'add_list dyf)
      (end_list)
    ) ;_  defun

  
;;;   Qmax
    (defun qmax_l ()
      (start_list "Qmax")
      (mapcar 'add_list qmaxl)
      (end_list)
    ) ;_  defun

;;;   Qmin
    (defun qmin_l ()
      (start_list "Qmin")
      (mapcar 'add_list qminl)
      (end_list)
    ) ;_  defun

  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

  
;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun



;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s1 mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
;;;	     (if (eq sech2 "1")
;;;	       (setq sech "0"
;;;		     sbk  "1"
;;;	       ) ;_  setq
;;;	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
;;;	     (if (eq sech2 "1")
;;;	       (setq sech "1"
;;;		     sbk  "0"
;;;	       ) ;_  setq
;;;	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;       
  (defun prv_otr ()
    (desk_f)
    (setq qmax (atof (nth (atoi qmxl) qmaxl)))
    (dfl_fn2)
    (setq qmin (atof (nth (atoi qmnl) qminl)))
    (setq d (atof (nth (atoi dy) dyf)))
    (whl)
    (s_t)
    (if	(/= y1 0)
      (progn
	(close fldat)
	(done_dialog)
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (itoa ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;   -      
   (defun attn3 ()
        (new_dialog "att3" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun

  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "ubopor" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (dfl_fn)
    (desk_f)
;;;       , Qmax, Qmin 
    (setq qmax (atof (nth (atoi qmxl) qmaxl))
	  d    (atof (nth (atoi dy) dyf))
    ) ;_  setq
    (dfl_fn2)
    (setq qmin (atof (nth (atoi qmnl) qminl)))
    (whl)
    (tipf_l)
    (dyf_l)
    (qmax_l)
    (qmin_l)
    (s_t)
    
;;;    (if	(eq sech "1")
;;;      (mode_tile "Shtr" 0)
;;;    ) ;_  if
    (mode_tile "Tipf" 2)

;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(defl)"
	      "(dfl_fn)"
	      "(desk_f)"
	      "(setq qmax (atof (nth (atoi qmxl) qmaxl)))"
	      "(dfl_fn2)"
	      "(setq qmin (atof (nth (atoi qmnl) qminl)))"
	      "(setq d (atof (nth (atoi dy) dyf)))"
	      "(whl)"
	      "(dyf_l)"
	      "(qmax_l)"
	      "(qmin_l)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Qmax"
      (strcat "(dflt)"
	      "(setq qmxl $value)"
	      "(desk_f)"
	      "(setq qmax (atof (nth (atoi qmxl) qmaxl)))"
	      "(dfl_fn2)"
	      "(setq qmin (atof (nth (atoi qmnl) qminl)))"
	      "(whl)"
	      "(dfl_fn2)"
	      "(qmin_l)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Qmin"
      (strcat "(dflt)"
	      "(setq qmnl $value)"
	      "(desk_f)"
	      "(setq qmin (atof (nth (atoi qmnl) qminl)))"
	      "(whl)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(dflt)"
	      "(setq dy $value)"
	      "(desk_f)"
	      "(setq d (atof (nth (atoi dy) dyf)))"
;;;	      "(whl)"  ; 
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "H"
      (strcat "(prv_p $value 'h \"H\" \"r\")"
	      "(prov 600 h 5000 \"H\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S1"
      (strcat "(setq s10 s1)"
	      "(prv_p $value 's1 \"S1\" \"r\")"
	      "(prov 4 s1 s10 \"S1\" \"\")"
	      "(if (> s1 s10) (setq s1 s10))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S2"
      (strcat "(setq s20 s2)"
	      "(prv_p $value 's2 \"S2\" \"r\")"
	      "(prov 4 s2 s20 \"S2\" \"\")"
	      "(if (> s2 s20) (setq s2 s20))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S3"
      (strcat "(setq s30 s3)"
	      "(prv_p $value 's3 \"S3\" \"r\")"
	      "(prov 4 s3 s30 \"S3\" \"\")"
	      "(if (> s3 s30) (setq s3 s30))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S"
      (strcat "(prv_p $value 's \"S\" \"r\")"
	      "(prov 4 s 100 \"S\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
;;;	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
;;;	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(prv_otr)")
    (action_tile "cancel" "(close fldat)(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
;;;  (if (eq p2 "1")
;;;    (progn
;;;      (setq
;;;	a1 (getangle inptG
;;;		     (strcat "\n   <" angl ">:")
;;;	   ) ;_  getangle
;;;      ) ;_  setq
;;;      (if (= a1 nil)
;;;	(setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
;;;	(setq a1 (- a1 (/ pi 2)))
;;;      ) ;_  if
;;;    ) ;_  progn
;;;    (setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
;;;  ) ;_  if

  


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setq fillr (getvar "filletrad"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (eq sech "1")
    (if	(> h d3)
      (setq prvh h)
      (setq prvh d3)
    ) ;_  if
    (setq prvh d3)
  ) ;_  if

  (if (< vs (* (* prvh mb) 2))
    (command "_ZOOM" "_C" inptG (* (* prvh mb) 2))
  ) ;_  if

  
;;;    
(cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (ubotr d s d1 d2 d3 s1 s2 s3 d0 n l h inptG 0 mb 1 shtrp)
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (ubotr2 d d1 d2 d3 s1 d0 n l inptG 0 mb 1 shtrp)
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (ubotr d s d1 d2 d3 s1 s2 s3 d0 n l h inptG 0 mb 2 shtrp)
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (ubotr2 d d1 d2 d3 s1 d0 n l inptG 0 mb 2 shtrp)
	)
	((and (eq tipf "2")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (ubotr d s d1 d2 d3 s1 s2 s3 d0 n l h inptG 0 mb 3 shtrp)
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (ubotr2 d d1 d2 d3 s1 d0 n l inptG 0 mb 3 shtrp)
	)
	((and (eq tipf "3")
	      (eq sech "1")
	      (eq sprd "0")
	 ) ;_  and
	 (ubotr d s d1 d2 d3 s1 s2 s3 d0 n l h inptG 0 mb 1 shtrp)
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "1")
	 ) ;_  and
	 (ubotr2 d d1 d2 d3 s1 d0 n l inptG 0 mb 1 shtrp)
	)
;;;	((and (eq tipf "3")
;;;	      (eq sech "1")
;;;	      (eq sprd "0")
;;;	 ) ;_  and
;;;	 (ubotr d s d1 d2 d3 s1 s2 s3 d0 n l h inptG 0 mb 5 shtrp)
;;;	)
;;;	((and (eq tipf "3")
;;;	      (eq sech "0")
;;;	      (eq sprd "1")
;;;	 ) ;_  and
;;;	 (ubotr2 d d1 d2 d3 s1 d0 n l inptG 0 mb 5 shtrp)
;;;	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "filletrad" fillr)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  UBOPOR
