;;;        18512-73
;;;:  ..
;;; : 14.05.2002
;;;CAD-CEE 2000
;;;: C:KRPDH

(defun c:krpdh (/ tipf dd dv dotv notv d d1 d2 d3 h0 h10 h h1 h2 h3 sech sprd
		name1 orx aby dlg dfl lsp1 lsp2	lsp3 lsp4 lsp5 fld strd	strdd
		strd1 strdd1 p1	p2 p3 angl mash	name1 spis pti inptG xc	yc
		dcl_id inptG a1	mb cmd blpm apsz osmd clay cltp	ccol vs	vctr pv
		anbl sset label	sech2 sbk ddy dvy ddyf dvyf fldat dfl2 as ass bs
		bss bss1 bss2 fldat2 dfl3 as2 ass2 dtb stb shtrp spism dfl1 hpa
		hpn vsp1 dl sps1 sps2 sps dat1 dat2 hole
	       )

  (setq	dlg  (findfile (strcat pathdcl2 "privod\\krpdh.dcl"))
	dfl  (findfile (strcat pathlisp2 "privod\\krpdh.d"))
	dfl1 (findfile (strcat pathdat2 "privod\\cover2g.dat"))
	dfl2 (findfile (strcat pathdat2 "privod\\cover2.dat"))
	dat1 (findfile (strcat pathdat2 "privod\\cover21.dat"))
	dat2 (findfile (strcat pathdat2 "privod\\cover22.dat"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "privod\\cov21.lsp"))
	lsp2 (findfile (strcat pathlisp2 "privod\\cov22.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)
  (load lsp2)

  (setq	spis '(" 1 ()"
	       " 2 ()"
	      )
  ) ;_  setq

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun
  (defun textf ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun


;;;      KRPDH.D 
  (defun rdfl ()
    (setq fld	 (open dfl "r")
	  strd1	 (read-line fld)
	  strdd1 (read strd1)
	  tipf	 (itoa (nth 0 strdd1))
	  ddy	 (itoa (nth 1 strdd1))
	  dvy	 (itoa (nth 2 strdd1))
	  sech	 (itoa (nth 3 strdd1))
	  sprd	 (itoa (nth 4 strdd1))
	  sbk	 (itoa (nth 5 strdd1))
	  shtrp	 (itoa (nth 6 strdd1))
	  osv1	 (itoa (nth 7 strdd1))
	  strd	 (read-line fld)
	  strdd	 (read strd)
	  p1	 (itoa (nth 0 strdd))
	  p2	 (itoa (nth 1 strdd))
	  angl	 (rtos (nth 2 strdd))
	  mash	 (rtos (nth 3 strdd))
    ) ;_  setq
    (close fld)
  ) ;_  defun


;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "D" ddy)
    (set_tile "dv" dvy)
    (set_tile "D1" (rtos d1))
    (set_tile "D2" (rtos d2))
    (set_tile "H" (rtos h))
    (set_tile "Dotv" (rtos dotv))
    (set_tile "Notv" (itoa notv))
    (set_tile "Osv" osv1)
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Shtr" shtrp)
    (if	(= tipf "0")
      (progn
	(set_tile "H0" (rtos h0))
	(set_tile "H2" (rtos h2))
	(set_tile "H10" " ")
	(set_tile "H3" " ")
      ) ;_  progn
      (progn
	(set_tile "H0" " ")
	(set_tile "H2" " ")
	(set_tile "H10" (rtos h10))
	(set_tile "H3" (rtos h3))
      ) ;_  progn
    ) ;_  if

  ) ;_  defun


;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       KRPDH.D
  (defun wrfl ()

    (setq fld  (open dfl "w")
	  strd (strcat "(" p1 " " p2 " " angl " " mash ")")
    ) ;_  setq
    (write-line strd1 fld)
    (write-line strd fld)
    (close fld)

  ) ;_  defun


  (defun wrfl_os ()
    (setq strd1	(strcat	"(" tipf " " ddy " " dvy " " sech " " sprd " " sbk " "
			shtrp " " osv1 ")"
		       ) ;_  strcat
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun name ()
    (cond ((and	(eq tipf "0")
		(eq sech "1")
		(eq sprd "0")
		(eq sbk "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "privod\\krpdh(1).slb"))
	  )
	  ((and	(eq tipf "0")
		(eq sech "0")
		(eq sprd "1")
		(eq sbk "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "privod\\krpdh(3).slb"))
	  )
	  ((and	(eq tipf "0")
		(eq sech "0")
		(eq sprd "0")
		(eq sbk "1")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "privod\\krpdh(5).slb"))
	  )
	  ((and	(eq tipf "1")
		(eq sech "1")
		(eq sprd "0")
		(eq sbk "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "privod\\krpdh(2).slb"))
	  )
	  ((and	(eq tipf "1")
		(eq sech "0")
		(eq sprd "1")
		(eq sbk "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "privod\\krpdh(4).slb"))
	  )
	  ((and	(eq tipf "1")
		(eq sech "0")
		(eq sprd "0")
		(eq sbk "1")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "privod\\krpdh(6).slb"))
	  )
    ) ;_  cond

  ) ;_  defun


;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;  
  (defun defl ()
    (setq ddy "0"
	  dvy "0"
    ) ;_  setq
  ) ;_  defun


;;;       
  (defun lst_per (lst / nl i els lst1)
    (setq nl   (length lst)
	  i    1
	  lst1 '()
    ) ;_  setq
    (while (<= i nl)
      (setq els	 (itoa (fix (nth (1- i) lst)))
	    i	 (1+ i)
	    lst1 (cons els lst1)
      ) ;_  setq
    ) ;_  while
    (setq lst1 (reverse lst1))
  ) ;_  defun

;;;      
  (defun fn_dd (/ rl rl1 d1 d2 d3)
    (setq rl  (open dfl1 "r")
	  d1  (read (read-line rl))
	  d2  (read (read-line rl))
	  d3  (read (read-line rl))
    ) ;_  setq
    (if	(= tipf "1")
      (setq d1 (read (read-line rl)))
    ) ;_  if
    (setq dl (append d1 d2 d3))
    (close rl)
  ) ;_  defun

;;;     
  (defun fn_dat	()
    (cond ((= tipf "0") (setq dfl3 dat1))
	  ((= tipf "1") (setq dfl3 dat2))
    ) ;_  cond
  ) ;_  defun

;;;       (1 )
  (defun desk_f	()
    (setq fldat	(open dfl2 "r")
	  as	(read-line fldat)
	  ass	(read as)
	  dd	(nth 0 ass)
	  d1	(nth 1 ass)
	  d2	(nth 2 ass)
	  d3	(nth 3 ass)
	  dotv	(nth 4 ass)
	  h	(nth 5 ass)
	  h1	(nth 6 ass)
	  notv	(nth 7 ass)
	  sps1  (nth 8 ass);      1
	  sps2  (nth 9 ass);      2
    ) ;_  setq
  ) ;_  defun


;;;        (2 )
  (defun desk_f2 ()
    (setq fldat2 (open dfl3 "r")
	  bs	 (read-line fldat2)
	  bss	 (read bs)
	  dd	 (nth 0 bss)
	  dv	 (nth 1 bss)
	  rd	 bss
    ) ;_  setq
  ) ;_  defun


;;;    
  (defun clos_dfl2 ()
    (close fldat)
    (desk_f)
  ) ;_  defun


;;;    
  (defun clos_dfl3 ()
    (close fldat2)
    (desk_f2)
  ) ;_  defun



;;;      (1 ) 
  (defun whl ()
    (if	(/= (nth (atoi ddy) dl) dd)
      (clos_dfl2)
    ) ;_  if 
    (while (/= (nth (atoi ddy) dl) dd)
      (setq as	 (read-line fldat)
	    ass	 (read as)
	    dd	 (nth 0 ass)
	    d1	 (nth 1 ass)
	    d2	 (nth 2 ass)
	    d3	 (nth 3 ass)
	    dotv (nth 4 ass)
	    h	 (nth 5 ass)
	    h1	 (nth 6 ass)
	    notv (nth 7 ass)
	    sps1 (nth 8 ass) ;      1
	    sps2 (nth 9 ass) ;      2
      ) ;_  setq
    ) ;_  while
    (if	(= tipf "0")
      (setq sps sps1)
      (setq sps sps2)
    ) ;_  if
  ) ;_  defun

;;;      (2 )
  (defun whl2 ()
    (if	(or (/= (nth (atoi ddy) dl) dd)
	    (/= (nth (atoi dvy) sps) dv)
	) ;_  or
      (clos_dfl3)
    ) ;_  if 
    (while (or (/= (nth (atoi ddy) dl) dd)
	       (/= (nth (atoi dvy) sps) dv)
	   ) ;_  or
      (setq bs	(read-line fldat2)
	    bss	(read bs)
	    dd	(nth 0 bss)
	    dv	(nth 1 bss)
	    rd	bss
      ) ;_  setq
    ) ;_  while
    (if	(= tipf "0")
      (setq h2 (nth 5 rd)
	    h0 (+ h1 h2 h)
      ) ;_  setq
      (setq h3 (nth 5 rd)
	    h10 (+ h1 h3 h)
      ) ;_  setq
    ) ;_  if
  ) ;_  defun


;;;    
  (defun tipf_l	()
    (start_list "Tipf")
    (mapcar 'add_list spis)
    (end_list)
  ) ;_  defun

;;;    
  (defun ddyf_l	()
    (start_list "D")
    (mapcar 'add_list ddyf)
    (end_list)
  ) ;_  defun


;;;    
  (defun dvyf_l	()
    (start_list "dv")
    (mapcar 'add_list dvyf)
    (end_list)
  ) ;_  defun


;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
  (defun prv_p (p vf pole pk / n i sm us)
    (setq us 0
	  i  1
	  n  (strlen p)
	  sm (substr p 1 1)
    ) ;_  setq

    (while (not (eq sm ","))
      (if (not (or (eq sm "0")
		   (eq sm "1")
		   (eq sm "2")
		   (eq sm "3")
		   (eq sm "4")
		   (eq sm "5")
		   (eq sm "6")
		   (eq sm "7")
		   (eq sm "8")
		   (eq sm "9")
		   (eq sm ".")
	       ) ;_  or
	  ) ;_  not
	(setq sm ","
	      us 1
	) ;_  setq
      ) ;_  if
      (if (or (= i n) (= us 1))
	(setq sm ",")
	(progn (setq i	(1+ i)
		     sm	(substr p i 1)
	       ) ;_  setq
	       (if (eq sm ",")
		 (setq us 1)
	       ) ;_  if
	) ;_  progn
      ) ;_  if
    ) ;_  while

    (if	(or (/= i n) (= us 1))
      (progn (attn)
	     (mode_tile pole 2)
	     (set vf (eval vf))
	     (if (= vf 'l)
	       (setq l 0)
	     ) ;_  if
	     (if (= (type (eval vf)) 'STR)
	       (set_tile pole (eval vf))
	       (if (= (type (eval vf)) 'INT)
		 (set_tile pole (itoa (eval vf)))
		 (set_tile pole (rtos (eval vf)))
	       ) ;_  if
	     ) ;_  if
      ) ;_  progn
      (if (eq pk "s")
	(set vf p)
	(if (eq pk "i")
	  (set vf (atoi p))
	  (set vf (atof p))
	) ;_  if
      ) ;_  if
    ) ;_  if 
  ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))

;;;    (if (= l 0)
    (setq srv (* dotv mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
  (defun attn ()
    (new_dialog "att1" dcl_id)
    (action_tile "accept" "(done_dialog 1)")
    (start_dialog)
  ) ;_  defun



;;;    
  (defun ins1 ()

    (if	(and (eq p2 "0") (eq angl nil))
      (setq angl "0")
    ) ;_  if
    (if	(eq p3 nil)
      (setq p3 "1")
    ) ;_  if

    (new_dialog "ins1" dcl_id)

    (setq sech2 sech)
    (s_t1)
    (pred)

    (action_tile "xcor" "(setq xc $value)")
    (action_tile "ycor" "(setq yc $value)")

    (action_tile "Mash"
		 "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)"
    ) ;_  action_tile
    (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

    (action_tile
      "per1"
      (strcat
	"(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
	"(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
	"(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
	"(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "per2"
      (strcat
	"(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
	"(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile "per3" "(setq p3 $value)")

    (action_tile "accept" "(done_dialog)(wrfl)")
    (action_tile "cancel" "(exit)")

    (start_dialog)  ;   


  ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

		    ; DCL-
    (if	(not (new_dialog "krpdh" dcl_id)) ; 
      (exit)
    )		    ;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (fn_dd)
    (fn_dat)
    (setq ddyf (lst_per dl))
    (setq dd (nth (atoi ddy) dl))
    (desk_f)
    (whl)
    (setq dvyf (lst_per sps))
    (setq dv (nth (atoi dvy) sps))
    (desk_f2)
    (whl2)
    (tipf_l)
    (ddyf_l)
    (dvyf_l)
    (s_t)
    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (if	(eq sbk "1")
      (mode_tile "Osv" 1)
    ) ;_  if
    (mode_tile "Tipf" 2)

;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(defl)"
	      "(fn_dd)"
              "(fn_dat)"
              "(setq ddyf (lst_per dl))"
	      "(setq dd (nth (atoi ddy) dl))"
	      "(desk_f)"
	      "(whl)"
	      "(setq dvyf (lst_per sps))"
	      "(setq dv (nth (atoi dvy) sps))"
	      "(desk_f2)"
	      "(whl2)"
	      "(ddyf_l)"
	      "(dvyf_l)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(setq ddy $value)"
	      "(setq dd (nth (atoi ddy) dl))"
	      "(desk_f)"
	      "(whl)"
	      "(setq dvy \"0\")"
	      "(setq dvyf (lst_per sps))"
	      "(setq dv (nth (atoi dvy) sps))"
	      "(desk_f2)"
	      "(whl2)"
	      "(dvyf_l)"
	      "(s_t)"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "dv"
      (strcat "(setq dvy $value)"
	      "(setq dv (nth (atoi dvy) sps))"
	      "(desk_f2)"
	      "(whl2)"
	      "(s_t)"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Osv"
      (strcat "(setq osv1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)" "(setq sprd \"0\")" "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)" "(mode_tile \"Osv\" 0)" "(show_im (name))"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)" "(setq sech \"0\")" "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 1)" "(mode_tile \"Osv\" 0)" "(show_im (name))"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)" "(setq sech \"0\")" "(setq sprd \"0\")"
	      "(mode_tile \"Shtr\" 1)" "(mode_tile \"Osv\" 1)" "(show_im (name))"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(close fldat)(close fldat2)(done_dialog)")
    (action_tile "cancel" "(close fldat)(close fldat2)(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)


;;;   

  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
	(setq a1 (+ a1 pi))
      ) ;_  if
    ) ;_  progn
    (setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
  ) ;_  if


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (setq pv (* d2 mb))
  (if (< vs (* pv 2))
    (command "_ZOOM" "_C" inptG (* pv 2))
  ) ;_  if

;;;    
  (if (= osv1 "0")
    (setq hole 1)
    (setq hole 2)
  ) ;_  if


;;;    
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (cov21 dd dv d1 d2 d3 dotv h h1 rd inptG a1 mb hole shtrp)
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (cov21_2 dv d1 d2 dotv notv rd inptG a1 mb hole)
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (cov21_3 dd dv d1 d2 d3 dotv h h1 rd inptG a1 mb)
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (cov22 dd dv d1 d2 d3 dotv h h1 rd inptG a1 mb hole shtrp)
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (cov22_2 dv d1 d2 dotv notv rd inptG a1 mb hole)
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (cov22_3 dd dv d1 d2 d3 dotv h h1 rd inptG a1 mb)
	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while
  
  (if (eq p3 "0")
    (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400))
  (prin1)

) ;_  KRPDH
