;;; CAD-CEE 2000
;;;   : 25.03.91
;;;    : 17.05.2002 ( ..)
;;;  ..
;;;      .  
;;; ,  .
;;;  : (sval2 dv b tp dopb dopt rzb tip ip a1 mb shtrp)
;;;  : dv -  ;
;;;                    b -  ;
;;;                    tp -   ;
;;;                    dopb -   b ( tip ="0" -  nil);
;;;                    dopt -   t1 ( tip ="0" -  nil);
;;;                    rzb -   ("1" - , "0" - );
;;;                    tip -    ("0" - , "1" - c d-t1, "2" -  t1);
;;;		       ip -  ;
;;;		       a1 -  ;
;;;		       mb -  ;
;;;                    shtrp -    ("0" - , "1" - )


(defun sval2 (dv b tp dopb dopt	rzb tip	ip a1 mb shtrp / bli cmd cla mod vs bd
	      td a2 a3 a4 lt dvr bw h p	p1 p2 p3 p4 p5 p6 p7 p8	p9 p10 p11 o1 o2
	      o3 o4 d1 d2 w1 w2	sl num
	     )

		    ;    
  (setq	dvr (* (/ dv 2.0) mb)
	bw  (* (/ b 2.0) mb)
	h   (- dvr (sqrt (- (expt dvr 2.0) (expt bw 2.0))))
	tp  (* tp mb)
  ) ;_  setq
  (if (< dvr 7.5)
    (setq p 1.0)
    (setq p 1.6)
  ) ;_  if
  (setq	a4  (/ pi 2.0)
	a3  (+ pi (/ pi 2.0))
	a2  (/ pi 6.0)
	p1  (polar ip (+ a1 pi) dvr)
	p2  (polar ip a1 dvr)
	p3  (polar p2 (+ a1 pi) h)
	p4  (polar p3 (+ a1 a3) bw)
	p5  (polar p3 (+ a1 a4) bw)
	p6  (polar p2 (+ a1 pi) tp)
	p7  (polar p6 (+ a1 a3) bw)
	p8  (polar p6 (+ a1 a4) bw)
	p9  (polar ip (+ a1 a2) (- dvr p))
	p10 (polar ip (+ a1 pi) (- dvr p))
	p11 (polar ip (- a1 a2) (- dvr p))
	o1  (polar ip a1 (+ dvr 5.0))
	o2  (polar ip (+ a1 pi) (+ dvr 5.0))
	o3  (polar ip (+ a1 a3) (+ dvr 5.0))
	o4  (polar ip (+ a1 a4) (+ dvr 5.0))
	d1  (polar p2 a1 20.0)
	d2  (polar ip (+ a1 a3) (+ dvr 20.0))
	w1  (polar o2 (+ a1 a3) (+ dvr 30.0))
	w2  (polar d1 (+ a1 a4) (+ dvr 30.0))
  ) ;_  setq

  (osn)
  (command "_PLINE" p5 "_W" "0"	"0" p8 p7 p4 "_A" "_S" p1 p5 "")
  (setq label (entlast))
  (setq sset (ssadd (entlast)))

  (if (= shtrp "1")
    (progn
      (ton)
      (command "_BHATCH" "_P" "_U" 45 2 "_N" ip "")
    ) ;_  progn
  ) ;_  if
 
  (axs)
  (command "_LINE" o1 o2 "")
  (command "_LINE" o3 o4 "")

  (if (= rzb "1")
    (progn
      (ton)
      (command "_ARC" p9 p10 p11)
    ) ;_  progn
  ) ;_  if

  (textf)

  (cond	((= tip "1")
	 (command "_DIMALIGNED" p4 p5 d1 (strcat (rtos b) dopb))
	 (command "_DIMALIGNED" p6 p1 d2 (strcat (rtos (- d tp)) dopt))
	)
	((= tip "2")
	 (command "_DIMALIGNED" p4 p5 d1 (strcat (rtos b) dopb))
	 (command "_DIMALIGNED" p2 p6 d2 (strcat (rtos tp) dopt))
	)
  ) ;_  cond
  (if (= tip "2")
    (command "_ARC" p4 "_C" ip p2)
  ) ;_  if
  
) ;_  SVAL2
