
;;; 
;;;:  ..
;;; : 09.10.2000
;;;CAD-CEE 2000

(defun dv_t_r (/ cmd blpm apsz osmd cpt	ept hdv	bdv hp1	hp2 hp3	lp1 rd1
	       rd2 label sset edat3 cpt	ept pt0	pt1 pt2	pt3 pt4	pt5 pt6
	       pt7 pt8 pt9 pt10	pt11 pt12 pt13 pt14 pt15 pt16 pt17 pt18
	       pt19 pt20 pt21 clay cltp	ccol inpt0 a1 ept1
	      )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq
    hdv	(nth 1 bb)
    bdv	(nth 2 bb)
    hp1	(nth 3 bb)
    hp2	(nth 4 bb)
    hp3	(nth 5 bb)
    lp1	(nth 6 bb)
    rd1	(nth 7 bb)
    rd2	(nth 8 bb)
  ) ;_ end of setq





;;;     

  (if (eq p1 nil)
    (setq p1 "1")
  ) ;_  if
  (if (eq p2 nil)
    (setq p2 "1")
  ) ;_  if
  (if (eq p3 nil)
    (setq p3 "0")
  ) ;_  if

  (if (eq xc nil)
    (setq xc "0")
  ) ;_  if
  (if (eq yc nil)
    (setq yc "0")
  ) ;_  if


  (if (eq mash nil)
    (setq mash "1")
  ) ;_  if

  (if (and (eq p2 "0") (eq angl nil))
    (setq angl "0")
  ) ;_  if

  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  (initget 1)
  (if (eq p1 "1")
    (setq inpt0 (getpoint "\n  :"))
    (setq inpt0 (list (atof xc) (atof yc)))
  ) ;_  if
  (setq mb (atof mash))

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(setq cpt inpt0)
	(initget 1)
	(setq ept1 (polar cpt 0 (getdist cpt "\n  :")))
      ) ;_ end of progn
      (setq cpt	 inpt0
	    ept1 (polar cpt 0 (* (read dlndt) mb))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inpt0
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (atof angl))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if 

  (if (eq sec1 "0")
    (setq ept (polar cpt (+ 0 a1) (distance cpt ept1)))
  ) ;_  if



  (defun ris_dvt ()

;;;  

    (defun dvt_gl_sz ()


      (setq pt3	(polar cpt (+ (/ pi 2) a1) (* hdv mb))
	    pt4	(polar ept (+ (/ pi 2) a1) (* hdv mb))
	    pt5	(polar cpt (+ (/ pi 2) a1) (* hp1 mb))
	    pt7	(polar cpt (+ (/ pi 2) a1) (* hp2 mb))
	    pt6	(polar ept (+ (/ pi 2) a1) (* hp1 mb))
	    pt8	(polar ept (+ (/ pi 2) a1) (* hp2 mb))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (osn)
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")
    )					;    dvt_gl_sz

;;;   

    (defun dvt_v_sv ()

      (setq pt3	(polar cpt (+ (/ pi 2) a1) (* bdv mb))
	    pt4	(polar ept (+ (/ pi 2) a1) (* bdv mb))
	    pt5	(polar cpt (+ (/ pi 2) a1) (* (/ (- bdv hp3) 2.0000) mb))
	    pt6	(polar ept (+ (/ pi 2) a1) (* (/ (- bdv hp3) 2.0000) mb))
	    pt7	(polar cpt (+ (/ pi 2) a1) (* (/ (+ bdv hp3) 2.0000) mb))
	    pt8	(polar ept (+ (/ pi 2) a1) (* (/ (+ bdv hp3) 2.0000) mb))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)

      (osn)
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")

      (ton)
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")
    )					;   dvt_v_sv

;;; 

    (defun dvt_sc ()

      (setq cpt inpt0)

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt0 (polar cpt (+ (/ pi 2) a1) (* (/ hdv 2.0000) mb)))
      (setq pt1 (polar cpt (+ 0 a1) (* (/ bdv 2.0000) mb)))
      (setq pt11 (polar cpt (+ (/ pi 2) a1) (* hdv mb)))
      (setq pt10 (polar pt11 (+ 0 a1) (* (/ bdv 2.0000) mb)))
      (setq pt2 (polar pt1 (+ (/ pi 2) a1) (* lp1 mb)))
      (setq pt9 (polar pt10 (+ (/ (* pi 3) 2) a1) (* lp1 mb)))
      (setq
	pt8 (polar pt9
		   (+ (/ (* pi 91) 72) a1)
		   (* (* 2.0000 (* rd1 (sin (/ (* pi 17) 72)))) mb)
	    ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt3 (polar pt2
		   (+ (/ (* pi 53) 72) a1)
		   (* (* 2.0000 (* rd1 (sin (/ (* pi 17) 72)))) mb)
	    ) ;_ end of polar
      ) ;_ end of setq
      (if (not (eq pr_fl "9"))
	(setq
	  pt4 (polar pt3
		     (+ (/ (* pi 175) 180) a1)
		     (*	(/ (- (/ (- bdv hp3) 2.0000)
			      (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			   ) ;_ end of -
			   (cos (/ pi 36))
			) ;_  /
			mb
		     ) ;_ end of *
	      ) ;_ end of polar
	) ;_  setq
	(setq pt4 (polar pt3
			 (+ pi a1)
			 (* (- (/ (- bdv hp3) 2.0000) rd2)
			    mb
			 ) ;_ end of *
		  ) ;_ end of polar
	) ;_ end of setq
      ) ;_  if

      (if (not (eq pr_fl "9"))
	(setq
	  pt7 (polar pt8
		     (+ (/ (* pi 185) 180) a1)
		     (*	(/ (- (/ (- bdv hp3) 2.0000)
			      (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			   ) ;_ end of -
			   (cos (/ pi 36))
			) ;_  /
			mb
		     ) ;_ end of *
	      ) ;_ end of polar
	) ;_ end of setq
	(setq pt7 (polar pt8
			 (+ pi a1)
			 (* (- (/ (- bdv hp3) 2.0000) rd2)
			    mb
			 ) ;_ end of *
		  ) ;_ end of polar
	) ;_ end of setq
      ) ;_  if
      (setq
	pt5 (polar pt4
		   (+ (/ (* pi 53) 72) a1)
		   (* (* 2.0000 (* rd2 (sin (/ (* pi 17) 72)))) mb)
	    ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt6 (polar pt7
		   (+ (/ (* pi 91) 72) a1)
		   (* (* 2.0000 (* rd2 (sin (/ (* pi 17) 72)))) mb)
	    ) ;_ end of polar
      ) ;_ end of setq

      (setq pt21 (polar pt10 (+ pi a1) (* bdv mb)))
      (setq pt20 (polar pt1 (+ pi a1) (* bdv mb)))
      (setq pt19 (polar pt20 (+ (/ pi 2) a1) (* lp1 mb)))
      (setq pt12 (polar pt21 (+ (/ (* pi 3) 2) a1) (* lp1 mb)))
      (setq
	pt13 (polar pt12
		    (+ (/ (* pi 125) 72) a1)
		    (* (* 2.0000 (* rd1 (sin (/ (* pi 17) 72)))) mb)
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt18 (polar pt19
		    (+ (/ (* pi 19) 72) a1)
		    (* (* 2.0000 (* rd1 (sin (/ (* pi 17) 72)))) mb)
	     ) ;_ end of polar
      ) ;_ end of setq
      (if (not (eq pr_fl "9"))
	(setq
	  pt14 (polar pt13
		      (+ (/ (* pi 71) 36) a1)
		      (* (/ (- (/ (- bdv hp3) 2.0000)
			       (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			    ) ;_ end of -
			    (cos (/ pi 36))
			 ) ;_  /
			 mb
		      ) ;_ end of *
	       ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt14 (polar pt13
		      (+ 0 a1)
		      (* (- (/ (- bdv hp3) 2.0000) rd2)
			 mb
		      ) ;_ end of *
	       ) ;_ end of polar
	) ;_ end of setq	
      ) ;_  if
      (if (not (eq pr_fl "9"))
	(setq
	  pt17 (polar pt18
		      (+ (/ pi 36) a1)
		      (* (/ (- (/ (- bdv hp3) 2.0000)
			       (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			    ) ;_ end of -
			    (cos (/ pi 36))
			 ) ;_  /
			 mb
		      ) ;_ end of *
	       ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt17 (polar pt18
		      (+ 0 a1)
		      (* (- (/ (- bdv hp3) 2.0000) rd2)
			 mb
		      ) ;_ end of *
	       ) ;_ end of polar
	) ;_ end of setq
      ) ;_  if
      (setq
	pt16 (polar pt17
		    (+ (/ (* pi 19) 72) a1)
		    (* (* 2.0000 (* rd2 (sin (/ (* pi 17) 72)))) mb)
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt15 (polar pt14
		    (+ (/ (* pi 125) 72) a1)
		    (* (* 2.0000 (* rd2 (sin (/ (* pi 17) 72)))) mb)
	     ) ;_ end of polar
      ) ;_ end of setq


      (osn)
      (command "_line" pt2 pt1 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" pt1 pt20 pt19 "")
      (command "_line" pt12 pt21 pt10 pt9 "")
      (if (not (eq pr_fl "9"))
	(progn
	  (command "_arc" pt8 "_e" pt9 "_r" (* rd1 mb))
	  (command "_arc" pt2 "_e" pt3 "_r" (* rd1 mb))
	) ;_  progn
      ) ;_  if
      (command "_line" pt8 pt7 "")
      (command "_line" pt3 pt4 "")
      (command "_arc" pt5 "_e" pt4 "_r" (* rd2 mb))
      (command "_arc" pt7 "_e" pt6 "_r" (* rd2 mb))

      (command "_line" pt5 pt6 "")
      (if (not (eq pr_fl "9"))
	(progn
	  (command "_arc" pt12 "_e" pt13 "_r" (* rd1 mb))
	  (command "_arc" pt18 "_e" pt19 "_r" (* rd1 mb))
	) ;_  progn
      ) ;_  if

      (command "_line" pt13 pt14 "")
      (command "_line" pt18 pt17 "")
      (command "_arc" pt15 "_e" pt14 "_r" (* rd2 mb))
      (command "_arc" pt17 "_e" pt16 "_r" (* rd2 mb))
      (command "_line" pt16 pt15 "")

    )					;    dvt_sc


    (cond ((= glv1 "1") (dvt_gl_sz))
	  ((= vsv1 "1") (dvt_v_sv))
	  ((= sec1 "1") (dvt_sc))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun
;;;_end of RIS_DVT


  (defun clip_bl ()

    (ris_dvt)

    (if	(eq p3 "0")
      (anblk sset cpt)
    ) ;_  if

    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
  ) ;_ end of defun


  (clip_bl)
  (prin1)

) ;_end of defun DV_T_R
