

;;; 
;;;:  ..
;;; : 09.10.2000
;;;CAD-CEE 2000

(defun sv_l_rg (/      cmd    blpm   apsz   osmd   cpt	  ept	 hsvg
		bsvg   ssvg   rsvg    sset   label  edat3	 pt1
		pt2    pt3    pt4    pt5    pt6	   pt7	  pt8	 pt9
		pt10   pt11   pt12   clay   cltp   ccol   inpt0  a1
		ept1
	       )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	hsvg (nth 1 bb)
	bsvg (nth 2 bb)
	ssvg (nth 3 bb)
	rsvg (nth 4 bb)
  ) ;_ end of setq

  ;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )

  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  
  (initget 1)
  (if (eq p1 "1")
    (setq inpt0 (getpoint "\n  :"))
    (setq inpt0 (list (atof xc) (atof yc)))
  ) ;_  if
  (setq mb (atof mash))

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(setq cpt inpt0)
	(initget 1)
	(setq ept1 (polar cpt 0 (getdist cpt "\n  :")))
      ) ;_ end of progn
      (setq cpt	 inpt0
	    ept1 (polar cpt 0 (* (read dlndt) mb))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inpt0
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (atof angl))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if 
  

  (if (eq sec1 "0")
   (setq ept (polar cpt (+ 0 a1) (distance cpt ept1)))
 ) ;_  if
  

  (defun ris_shrg ()

;;;     


    (defun shv_gl_szg ()

      (setq pt3	(polar cpt (+ (/ pi 2) a1) (* hsvg mb))
	    pt4	(polar ept (+ (/ pi 2) a1) (* hsvg mb))
	    pt5	(polar cpt (+ (/ pi 2) a1) (* ssvg mb))
	    pt7	(polar pt3 (+ (/ (* pi 3) 2) a1) (* ssvg mb))
	    pt6	(polar ept (+ (/ pi 2) a1) (* ssvg mb))
	    pt8	(polar pt4 (+ (/ (* pi 3) 2) a1) (* ssvg mb))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      
      (osn)
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (if (eq vsz1 "1")
       (progn
        (ton)
       )
       (progn
        (osn)
       )
      ) ;_ end of if
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")

    ) ;_ end of defun

;;;  

    (defun shv_v_svg ()

      (setq pt3	(polar cpt (+ (/ pi 2) a1) (* bsvg mb))
	    pt4	(polar ept (+ (/ pi 2) a1) (* bsvg mb))
	    pt5	(polar pt3 (+ (/ (* pi 3) 2) a1) (* ssvg mb))
	    pt6	(polar pt4 (+ (/ (* pi 3) 2) a1) (* ssvg mb))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      
      (osn)
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")

      
      (ton)
      (command "_line" pt5 pt6 "")

    )					;    shv_v_svg

;;; 

    (defun shv_scg ()

      (setq cpt inpt0)

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt1	 (polar cpt (+ 0 a1) (* (+ ssvg rsvg) mb))
	    pt12 (polar cpt (+ (/ pi 2) a1) (* (+ ssvg rsvg) mb))
	    pt10 (polar pt1 (+ (/ pi 2) a1) (* hsvg mb))
	    pt4	 (polar pt1 (+ (/ pi 2) a1) (* ssvg mb))
	    pt7	 (polar pt10 (+ (/ (* pi 3) 2) a1) (* ssvg mb))
	    pt2	 (polar cpt (+ 0 a1) (* bsvg mb))
	    pt3	 (polar pt2 (+ (/ pi 2) a1) (* ssvg mb))
	    pt9	 (polar pt2 (+ (/ pi 2) a1) (* hsvg mb))
	    pt8	 (polar pt9 (+ (/ (* pi 3) 2) a1) (* ssvg mb))
	    pt5	 (polar pt12 (+ 0 a1) (* ssvg mb))
	    pt11 (polar cpt (+ (/ pi 2) a1) (* (- hsvg (+ ssvg rsvg)) mb))
	    pt6	 (polar pt11 (+ 0 a1) (* ssvg mb))
      ) ;_ end of setq

      
      (osn)

      (command "_line" pt4 pt3 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))


      (command "_line" pt3 pt2 pt1 "")
      (command "_arc" pt7 "_e" pt6 "_r" (* rsvg mb))
      (command "_arc" pt10 "_e" pt11 "_r" (* (+ rsvg ssvg) mb))
      (command "_line" pt10 pt9 pt8 pt7 "")
      (command "_line" pt11 pt12 "")
      (command "_arc" pt5 "_e" pt4 "_r" (* rsvg mb))
      (command "_arc" pt12 "_e" pt1 "_r" (* (+ rsvg ssvg) mb))
      (command "_line" pt5 pt6 "")
    )					;    shv_scg

    (cond ((or (= glv1 "1") (= vsz1 "1")) (shv_gl_szg))
	  ((= vsv1 "1") (shv_v_svg))
	  ((= sec1 "1") (shv_scg))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_end of defun RIS_SHRG

  (defun clip_bl ()
    
    (ris_shrg)
  
    (if	(eq p3 "0")
	(anblk sset cpt)
    ) ;_  if
  
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
  ) ;_ end of defun


  (clip_bl)
  (prin1)

)					;    SV_L_RG
