

;;;  
;;;:  ..
;;; : 09.10.2000
;;;CAD-CEE 2000

(defun ug_rp (/	    cmd	  blpm	apsz  osmd  cpt	  ept	bug   sug
	      lp1   rd1	  rd2		    sset  label	edat3 pt1
	      pt2   pt3	  pt4	pt5   pt6   pt7	  pt8   clay  cltp
	      ccol  inpt0 a1    ept1
	     )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	bug (nth 1 bb)
	sug (nth 2 bb)
	lp1 (nth 3 bb)
	rd2 (nth 4 bb)
	rd1 (nth 5 bb)
  ) ;_ end of setq


  ;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun


 
  (initget 1)
  (if (eq p1 "1")
    (setq inpt0 (getpoint "\n  :"))
    (setq inpt0 (list (atof xc) (atof yc)))
  ) ;_  if
  (setq mb (atof mash))

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(setq cpt inpt0)
	(initget 1)
	(setq ept1 (polar cpt 0 (getdist cpt "\n  :")))
      ) ;_ end of progn
      (setq cpt	 inpt0
	    ept1 (polar cpt 0 (* (read dlndt) mb))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inpt0
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (atof angl))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if 
  

  (if (eq sec1 "0")
   (setq ept (polar cpt (+ 0 a1) (distance cpt ept1)))
  ) ;_  if
  

  (defun ris_ugrp ()

;;;     


    (defun ug_gl_sz ()

      (setq pt3	(polar cpt (+ (/ pi 2) a1) (* bug mb))
	    pt4	(polar ept (+ (/ pi 2) a1) (* bug mb))
	    pt5	(polar cpt (+ (/ pi 2) a1) (* sug mb))
	    pt6	(polar ept (+ (/ pi 2) a1) (* sug mb))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      
      (osn)
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (if (eq vsz1 "1")
        (ton)
        (osn)
      ) ;_ end of if
      (command "_line" pt5 pt6 "")

    ) ;_ end of defun


;;; 

    (defun ug_sc ()

      (setq cpt inpt0)

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt1	(polar cpt (+ 0 a1) (* bug mb))
	    pt8	(polar cpt (+ (/ pi 2) a1) (* bug mb))
	    pt7	(polar pt8 (+ 0 a1) (* lp1 mb))
	    pt2	(polar pt1 (+ (/ pi 2) a1) (* lp1 mb))
	    pt3	(polar pt2 (+ (/ (* pi 3) 4) a1) (* (* (sqrt 2.0000) rd1) mb))
	    pt6	(polar pt7 (+ (/ (* pi 7) 4) a1) (* (* (sqrt 2.0000) rd1) mb))
	    pt4	(polar pt3 (+ pi a1) (* (- bug (+ (+ rd1 rd2) sug)) mb))
	    pt5	(polar pt6 (+ (/ (* pi 3) 2) a1) (* (- bug (+ (+ rd1 rd2) sug)) mb))
      ) ;_ end of setq

      
      (osn)

      (command "_line" pt2 pt1 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))


      (command "_line"
	       pt7
	       pt8
	       cpt
	       pt1
	       ""
	       "_line"
	       pt3
	       pt4
	       ""
	       "_line"
	       pt5
	       pt6
	       ""
      ) ;_ end of command
      (command "_arc"
	       pt6
	       "_e"
	       pt7
	       "_r"
	       (* rd1 mb)
	       "_arc"
	       pt2
	       "_e"
	       pt3
	       "_r"
	       (* rd1 mb)
	       "_arc"
	       pt5
	       "_e"
	       pt4
	       "_r"
	       (* rd2 mb)
      ) ;_ end of command

    )					;    ug_sc

    (cond ((or (= glv1 "1") (= vsz1 "1")) (ug_gl_sz))
	  ((= sec1 "1") (ug_sc))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_end of defun RIS_UGRP

  (defun clip_bl ()
        
    (ris_ugrp)
  
    (if	(eq p3 "0")
	(anblk sset cpt)
    ) ;_  if
  
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
  ) ;_ end of defun

  (clip_bl)
  (prin1)

)					;    UG_RP
