;;;  
;;;:  ..
;;; : 04.10.2000
;;;CAD-CEE 2000


(defun vnts (bb     cpt
	     /	    dmts   dlns	  dlns1	 dgbs	sgbs   hgbs   dvts
	     fsks   dgb1   hgbs1
	     hnb    h1gb   rgb	  tgb	 tgbt	tg1bt  tgbn   
	     pt0    pto1   pto2   pt1    pt2
	     pt3    pt4	   pt5	  pt6	 pt7	pt8    pt9    pt10
	     pt11   pt12   pt7-1  pt8-1	 cpt1v	pt2-2  pt2-3  pt2-4
	     pt3-2  pt3-3  pt3-4  pt14	 pt14-1	pt14-2 pt15   pt16
	     pt17   pt18   pt19	  pt19-1 pt19-2	pt20   pt21   pt22
	     pt23   pt24   pt25   pt26   cut
	    )

  (setq	dmts  (nth 3 bb)
	dlns  (nth 4 bb)
	dlns1 (nth 5 bb)
	dbgs  (nth 6 bb)
	sgbs  (nth 7 bb)
	hgbs  (nth 8 bb)
	dvts  (nth 9 bb)
	fsks  (nth 10 bb)
  ) ;_ end of setq
  (cond	((eq gost "2")
	 (setq dgb1 (nth 13 bb)
	       hgbs1 (nth 14 bb)
	 ) ;_ end of setq
	)
	((eq gost "3") (setq dgb1 (nth 13 bb)))
  ) ;_ end of cond



     (defun osn ()
	   (command "_'layer" "_s" "" "")
     )
     (defun ton ()
          (command "_'layer" "_s" "" "")
      )


;;;;;;;;;;;    1491;;;;;;;;;;;;;;;;;

      (defun gbgl ()
	(setq hnb (nth 13 bb)
	      pt1 (polar cpt (+ (/ pi 2) a1) (* (/ dbgs 2.00) mb))
	      pt2 (polar pt1 (+ pi a1) (* hgbs mb))
	      pt3 (polar pt2
			 (+ (/ (* pi 3) 2) a1)
			 (* (/ (- dbgs sgbs) 2.00) mb)
		  ) ;_ end of polar
	      pt4 (polar pt3 (+ 0 a1) (* hnb mb))
	      pt5 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dbgs 2.00) mb))
	      pt6 (polar pt5 (+ pi a1) (* hgbs mb))
	      pt7 (polar pt6
			 (+ (/ pi 2) a1)
			 (* (/ (- dbgs sgbs) 2.00) mb)
		  ) ;_ end of polar
	      pt8 (polar pt7 (+ 0 a1) (* hnb mb))
	) ;_end of setq

	(osn)
	(command "_line"
		 pt1
		 pt2
		 "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_line"
		 pt2
		 pt3
		 pt4
		 pt8
		 pt7
		 pt6
		 pt5
		 pt1
		 ""
	)				;      1491 
      ) ;_ end of defun

;;;;;;;;;;;    11738;;;;;;;;;;;;;;;;;

      (defun grgl ()
	(setq pt1 (polar cpt (+ (/ pi 2) a1)  (* (/ dbgs 2.00) mb))
	      pt2 (polar pt1 (+ pi a1) (* hgbs mb))
	      pt3 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dbgs 2.00) mb))
	      pt4 (polar pt3 (+ pi a1) (* hgbs mb))
	) ;_end of setq

	(osn)
	(command "_line"
		 pt4
		 pt3
		 "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_line"
		 pt3
		 pt1
		 pt2
		 pt4
		 ""
	)				;      11738 
      ) ;_ end of defun

;;;;;;;;    17473;;;;;;;;;;;;;;;;;;;

      (defun gbbv ()
	(setq hnb  (nth 13 bb)
	      h1gb (nth 14 bb)
	      rgb  (* (nth 15 bb) mb)
	      pt0  (polar cpt (+ pi a1) (* hgbs mb))
	      pt1  (polar cpt (+ (/ pi 2) a1)  (* (/ dbgs 2.00) mb))
	      pt2  (polar pt1 (+ pi a1) (* h1gb mb))
	      pt3  (polar pt0 (+ (/ pi 2) a1) (* (/ sgbs 2.00) mb))
	      pt4  (polar pt3 (+ 0 a1) (* hnb mb))
	      pt5  (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dbgs 2.00) mb))
	      pt6  (polar pt5 (+ pi a1) (* h1gb mb))
	      pt7  (polar pt0 (+ (/ (* pi 3) 2) a1) (* (/ sgbs 2.00) mb))
	      pt8  (polar pt7 (+ 0 a1) (* hnb mb))
	) ;_ end of setq
	(osn)
	(command "_line"
		 pt2
		 pt1
		 "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_line" pt1 pt5 pt6 "")
	(command "_line"
		 pt7
		 pt8
		 pt4
		 pt3
		 ""
		 "_arc"
		 pt2
		 "_e"
		 pt3
		 "_r"
		 rgb
		 "_arc"
		 pt7
		 "_e"
		 pt6
		 "_r"
		 rgb
	)				;    
      ) ;_ end of defun

;;;;;;;;;;;;;    1488-75;;;;;;;;;;;;;;;;;;;;;;;;
      (defun gb2bv ()
	(setq pt1   (polar cpt (+ (/ pi 2.00) a1) (* (/ dgb1 2.00) mb))
	      pt2   (polar pt1 (+ pi a1) (* hgbs1 mb))
	      pt3   (polar pt2 (+ (/ (* pi 3) 2) a1) (* dgb1 mb))
	      pt4   (polar pt3 (+ 0 a1) (* hgbs1 mb))
	      cpt1v (polar cpt (+ pi a1) (* hgbs1 mb))
	      pt5   (polar cpt1v (+ (/ pi 2.00) a1) (* (/ dbgs 2.00) mb))
	      pt6   (polar
		      pt5
		      (+ pi a1)
		      (* (- hgbs
			 (/ (- (/ dbgs 2.00) (* sgbs 0.45)) (cos (/ pi 6)) 2.00)) mb)
		    ) ;_ end of polar
	      pt7   (polar pt6
			   (+ (/ (* pi 4) 3) a1)
			   (* (/ (- (/ dbgs 2.00) (* sgbs 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	      pt10  (polar cpt1v (+ (/ (* pi 3) 2) a1) (* (/ dbgs 2.00) mb))
	      pt9   (polar
		      pt10
		      (+ pi a1)
		      (* (- hgbs
			 (/ (- (/ dbgs 2.00) (* sgbs 0.45)) (cos (/ pi 6)) 2.00)) mb)
		    ) ;_ end of polar
	      pt8   (polar pt9
			   (+ (/ (* pi 2) 3) a1)
			   (* (/ (- (/ dbgs 2.00) (* sgbs 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	      tgb   (/ (* (sqrt (- 1 (/ (expt sgbs 2) (expt dbgs 2)))) dbgs) sgbs)
	      tgbt  (atan tgb)
	      pt2-2 (polar cpt1v
			   (+ (/ pi 2) a1)
			   (* (* (/ dbgs 2.00) (sin (- (/ pi 4) tgbt))) mb)
		    ) ;_ end of polar
	      pt2-3 (polar pt2-2
			   (+ pi a1)
			   (* (- hgbs
			      (/ (- (/ dbgs 2.00) (* sgbs 0.45))
				 (cos (/ pi 6)) 2.00)) mb)
		    ) ;_ end of polar
	      pt2-4 (polar pt2-3
			   (+ (/ (* pi 4) 6) a1)
			   (* (/ (- (/ dbgs 2.00) (* sgbs 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	      pt3-2 (polar cpt1v
			   (+ (/ (* pi 3) 2) a1)
			   (* (* (/ dbgs 2.00) (sin (- (/ pi 4) tgbt))) mb)
		    ) ;_ end of polar
	      pt3-3 (polar pt3-2
			   (+ pi a1)
			   (* (- hgbs
			        (/ (- (/ dbgs 2.00) (* sgbs 0.45))
				 (cos (/ pi 6)) 2.00)) mb)
		    ) ;_ end of polar
	      pt3-4 (polar pt3-3
			   (+ (/ (* pi 8) 6) a1)
			   (* (/ (- (/ dbgs 2.00) (* sgbs 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	) ;_ end of setq
	(osn)
	(command "_line"
		 pt1
		 pt2
		 "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_line"
		 pt2
		 pt3
		 pt4
		 pt1
		 ""
		 "_line"
		 pt5
		 pt6
		 pt7
		 pt8
		 pt9
		 pt10
		 ""
		 "_line"
		 pt2-2
		 pt2-3
		 pt3-3
		 pt3-2
		 ""
		 "_line"
		 pt2-4
		 pt2-3
		 ""
		 "_line"
		 pt3-4
		 pt3-3
		 ""
	) ;_ end of command
	;;    1488 
      ) ;_ end of defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      (defun strg ()
	       (setq pt14   (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dmts 2.00) mb))
		     pt15   (polar pt14 (+ 0 a1) (* (- dlns fsks) mb))
		     pt16   (polar pt15 (+ (/ pi 4) a1) (* (* fsks (sqrt 2.00)) mb))
		     pt19   (polar cpt (+ (/ pi 2) a1) (* (/ dmts 2.0000) mb))
		     pt18   (polar pt19 (+ 0 a1) (* (- dlns fsks) mb))
		     pt17   (polar pt18 (+ (/ (* pi 7) 4) a1) (* (* fsks (sqrt 2.00)) mb))
		     pt20   (polar pt14 (+ 0 a1) (* (- dlns dlns1) mb))
		     pt21   (polar pt19 (+ 0 a1) (* (- dlns dlns1) mb))
		     pt26   (polar cpt (+ 0 a1) (* (* dlns 0.1) mb))
		     pt27   (polar cpt (+ 0 a1) (* (* dlns 0.9) mb))
	       ) ;_ end of setq

	      (if (< (* (/ (- dmts dvts) 2) mb) 0.6)
		(progn
		  (setq dvts (- dmts (/ (* 2 0.6) mb)))
		  (if (> (* (/ (- dmts dvts) 2) mb) (* fsks mb))
		    (setq zam dlns1)
		    (setq zam (+ (- dlns1 fsks) (/ (- dmts dvts) 2.00)))
		  ) ;_  if
		  (setq	pt22 (polar pt21
				    (+ (/ (* pi 3) 2) a1)
				    (* (/ (- dmts dvts) 2.00) mb)
			     ) ;_  polar
			pt23 (polar pt20
				    (+ (/ pi 2) a1)
				    (* (/ (- dmts dvts) 2.00) mb)
			     ) ;_  polar
			pt24 (polar
			       pt22
			       (+ 0 a1)
			       (* zam mb)
			     ) ;_  polar
			pt25 (polar
			       pt23
			       (+ 0 a1)
			       (* zam mb)
			     ) ;_  polar
		  ) ;_  setq
		) ;_  progn
		(setq pt22 (polar pt21
				  (+ (/ (* pi 3) 2) a1)
				  (* (/ (- dmts dvts) 2.00) mb)
			   ) ;_  polar
		      pt23 (polar pt20
				  (+ (/ pi 2) a1)
				  (* (/ (- dmts dvts) 2.00) mb)
			   ) ;_  polar
		      pt24 (polar
			     pt22
			     (+ 0 a1)
			     (*	(+ (- dlns1 fsks) (/ (- dmts dvts) 2.00))
				mb
			     ) ;_  *
			   ) ;_  polar
		      pt25 (polar
			     pt23
			     (+ 0 a1)
			     (*	(+ (- dlns1 fsks) (/ (- dmts dvts) 2.00))
				mb
			     ) ;_  *
			   ) ;_  polar
		) ;_  setq
	      ) ;_  if



	(osn)

	  (command "_line"
		   pt14
		   pt15
		   "")
	    (command "_line"
		   pt15
		   pt16
		   pt17
		   pt18
		   "")
	    (command "_line"
	           pt18
		   pt19
	 	   "")	  
	    (command "_line"
		   pt15
		   pt18
		   ""
	    ) 
	 
	(if (/= dlns dlns1)
	  (command "_line" pt20 pt21 "")
	) ;_ end of if
	(if (not (< (* (/ dmt 2) mb) 0.6))
	  (progn
	    (ton)
	    (command "_line"
		     pt22
		     pt24
		     ""
		     "_line"
		     pt23
		     pt25
		     ""
		    ) ;_  command
	  ) ;_  command
	) ;_ end of if
					;    
      ) ;_ end of defun


      (cond ((eq gost "0") (gbgl))
	    ((eq gost "1") (gbbv))
	    ((eq gost "2") (gb2bv))
	    ((eq gost "3") (grgl))
      ) ;_ end of cond
      (strg)

  (prin1)
) ;_ end of defun VNTS
