;;;    
;;;: (unnend2 mat typ ip a1 mb dap aap s1 x1 dn sp)
;;;   mat -  ;
;;;      typ -    ;
;;;      ip -   ;
;;;      a1 -   ;
;;;      mb - ;
;;;      dap -    ;
;;;      aap -     ( x1=0 -  );
;;;      s1 -  ,   ;
;;;      x1 -       ;
;;;      dn -   ;
;;;      sp -   ;
;;;  : 26.07.2001

(defun unnend2 (mat  typ  ip   a1   mb	 dap  aap  s1	x1   dn	  sp
		/    a3	  a4   a2   r	 h    rn   rv	y    yn	  yv
		hs1  hy	  hob  doph delh p1   p2   hv	p3   p4	  p5
		vd   dist2     dist3	 c1   c2   c3	c4   c0	  del1
		o1   o2	  hig  cut  ld	 no   dname	p6   p7	  p8
		inp1 inp2 dst1 dst2 an1  valp
	       )
  (osn)
  (setq	a3 (/ pi 2)
	a4 (+ a3 pi)
  ) ;_  setq
  (if (and (= mat 2) (= x1 0))
    (setq aap (+ aap a3))
  ) ;_  if
  (if (and (= mat 2)
	   (not (or (= a1 0) (= a1 a3) (= a1 pi) (= a1 a4)))
      ) ;_  and
    (setq x1 0)
  ) ;_  if
  (if (or (= aap a3) (= aap a4))
    (cond ((<= a1 a3) (setq a2 (- a3 a1)))
	  ((and (> a1 a3) (<= a1 pi)) (setq a2 (- a1 a3)))
	  ((and (> a1 pi) (<= a1 a4)) (setq a2 (- a4 a1)))
	  ((> a1 a4) (setq a2 (- a1 a4)))
    ) ;_  cond
    (cond ((<= a1 a3) (setq a2 a1))
	  ((and (> a1 a3) (<= a1 pi)) (setq a2 (- pi a1)))
	  ((and (> a1 pi) (<= a1 a4)) (setq a2 (- a1 pi)))
	  ((> a1 a4) (setq a2 (- (* 2.0 pi) a1)))
    ) ;_  cond
  ) ;_  if
  (if (= a2 0) (setq a2 0.01))
  (if (= a2 pi) (setq a2 (+ pi 0.01)))
  (if (= mat 1)
    (setq hob
	   (/
	     (-	(* 0.5 dap)
		(* 0.5
		   (sqrt (- (* 4.0 (expt (* 0.5 dap) 2.0)) (expt dn 2.0)))
		) ;_  *
	     ) ;_  -
	     (sin a2)
	   ) ;_  /
    ) ;_  setq
    (setq hob 0)
  ) ;_  if
  (if (= typ 1)
    (setq doph (* 0.5 dn (/ (cos a2) (sin a2))))
    (setq doph 0)
  ) ;_  if
  (if (= mat 2)
    (setq r   (* 0.5 dap)
	  h   (* 0.25 dap)
	  rn  (* 0.5 dn)
	  rv  (- rn sp)
	  y   (mapcar '(lambda (x a b)
			 (/ (* b (sqrt (- (expt a 2.0) (expt x 2.0)))) a)
		       ) ;_  lambda
		      (list x1
			    (- x1 rn)
			    (+ x1 rn)
			    x1
			    (- x1 rn)
			    (+ x1 rn)
			    (- x1 rv)
			    (+ x1 rv)
		      ) ;_  list
		      (list (+ r s1) (+ r s1) (+ r s1) r r r r r)
		      (list (+ h s1) (+ h s1) (+ h s1) h h h h h)
	      ) ;_  mapcar
	  yn  (min (nth 1 y) (nth 2 y))
	  yv  (apply 'min y)
	  hs1 (- yn yv)
	  hy  (- (nth 0 y) yn)
    ) ;_  setq
    (setq hs1 (/ s1 (sin a2))
	  hy  0
    ) ;_  setq
  ) ;_  if
  (setq delh (- hob doph))
  (if (minusp delh)
    (setq delh 0)
  ) ;_  if
  (cond	((= typ 1)
	 (if (< sp 10.0)
	   (setq hv 10)
	   (setq hv (+ sp 5.0))
	 ) ;_  if
	)
	((= typ 2) (setq hv 5.0))
	((= typ 3) (setq hv (- (* 0.5 hs1) hs1)))
  ) ;_  cond
  (setq	h  (+ hy hs1 hv doph delh)
	p1 (polar ip (+ a1 pi) (* h mb))
	p2 (polar p1 (+ a1 a3) (* (/ dn 2.0) mb))
	p3 (polar p1 (+ a1 a4) (* (/ dn 2.0) mb))
	p4 (polar p2 (+ a1 a4) (* sp mb))
	p5 (polar p3 (+ a1 a3) (* sp mb))
  ) ;_  setq
  (if (and (/= typ 1)
	   (/= mat 2)
	   (not (or (= a1 0) (= a1 a3) (= a1 pi) (= a1 a4)))
      ) ;_  and
    (setq p2 (polar p1 aap (* (/ (/ dn 2.0) (sin a2)) mb))
	  p3 (polar p1 (+ aap pi) (* (/ (/ dn 2.0) (sin a2)) mb))
	  p4 (polar p2 (+ aap pi) (* (/ sp (sin a2)) mb))
	  p5 (polar p3 aap (* (/ sp (sin a2)) mb))
    ) ;_  setq
  ) ;_  if
  (cond	((and (= mat 1) (>= typ 2))
	 (setq p2 (polar p2 a1 (* delh mb))
	       p3 (polar p3 a1 (* delh mb))
	       p4 (polar p4 a1 (* delh mb))
	       p5 (polar p5 a1 (* delh mb))
	 ) ;_  setq
	)
	((and (= mat 2) (>= typ 2) (/= x1 0))
	 (setq vd    (polar ip (+ aap pi) (* x1 mb))
	       dist2 (distance vd p2)
	       dist3 (distance vd p3)
	 ) ;_  setq
	 (if (< dist2 dist3)
	   (setq c1 (nth 6 y)
		 c2 (nth 7 y)
		 p2 (polar p2 a1 (* (- (nth 4 y) yv) mb))
	   ) ;_  setq
	   (setq c1 (nth 7 y)
		 c2 (nth 6 y)
		 p3 (polar p3 a1 (* (- (nth 4 y) yv) mb))
	   ) ;_  setq
	 ) ;_  if
	 (setq p4 (polar p4 a1 (* (- c1 yv) mb))
	       p5 (polar p5 a1 (* (- c2 yv) mb))
	       p1 (polar p1 a1 (* (- (nth 3 y) yv) mb))
	 ) ;_  setq
	)
  ) ;_  cond

;;;  
  (cond	((= mat 2)
	 (setq c0 (polar ip
			 a1
			 (* (+ (/ (- (apply 'max y) (nth 0 y)) (sin a2)) 5.0) mb)
		  ) ;_  polar
	       c1 (polar c0 (+ a1 a3) (* (/ dn 2.0) mb))
	       c2 (polar c0 (+ a1 a4) (* (/ dn 2.0) mb))
	 ) ;_  setq
	)
	(t
	 (setq c1 (polar ip aap (* (/ (/ dn 2.0) (sin a2)) mb))
	       c2 (polar ip (+ aap pi) (* (/ (/ dn 2.0) (sin a2)) mb))
	       c3 (polar c1 (+ a1 pi) (* hs1 mb))
	       c4 (polar c2 (+ a1 pi) (* hs1 mb))
	 ) ;_  setq
	)
  ) ;_  cond
  (setq	hig (getvar "HIGHLIGHT")
	o1  (polar ip a1 2.0)
	o2  (polar ip (+ a1 pi) (* (+ hs1 10.0) mb))
  ) ;_  setq
  (if (or (and (= typ 3) (= mat 2)) (and (= typ 3) (= mat 3)))
    (setq o2 (polar ip (+ a1 pi) (* (/ hs1 2.0) mb)))
  ) ;_  if
  (setq	o1 (polar o1 (+ a1 a3) 1.0)
	o2 (polar o2 (+ a1 a4) 1.0)
  ) ;_  setq
  (setq del1 (ssget "_C" o1 o2))
  (if del1
    (progn
      (setq ld (sslength del1)
	    no -1
      ) ;_  setq
      (setvar "HIGHLIGHT" 0)
      (cond ((and (= typ 3) (= mat 1)) (command "_LINE" c1 c3 ""))
	    ((< (distance c1 p2) (distance c1 p3))
	     (command "_LINE" c1 p2 "")
	    )
	    ((< (distance c1 p3) (distance c1 p2))
	     (command "_LINE" c1 p3 "")
	    )
      ) ;_  cond
      (setq cut (ssadd (entlast)))
      (cond ((and (= typ 3) (= mat 1)) (command "_LINE" c2 c4 ""))
	    ((< (distance c2 p3) (distance c2 p2))
	     (command "_LINE" c2 p3 "")
	    )
	    ((< (distance c2 p2) (distance c2 p3))
	     (command "_LINE" c2 p2 "")
	    )
      ) ;_  cond
      (ssadd (entlast) cut)
      (command "_trim" cut "")
      (repeat ld
	(setq no    (1+ no)
	      dname (ssname del1 no)
	) ;_  setq
	(if (= (cdr (assoc 8 (entget dname))) "DRAW")
	  (command (list dname ip))
	) ;_  if
      ) ;_  repeat
      (command "")
      (setvar "HIGHLIGHT" hig)
      (entdel (ssname cut 0))
      (entdel (ssname cut 1))
    ) ;_  progn
  ) ;_  if

;;;    
;;;       
  (cond	((or (= typ 1) (= mat 3) (and (= mat 2) (= x1 0)))
	 (command "_LINE" p2 p3 "")
	 (if (= mat 2)
	   (progn
	     (setq inp (polar p2 (- a1 (/ pi 2.0)) (* (/ dn 2.0) mb)))
	     (setq inptG (polar inp a1 (* l mb))) ;     
	   ) ;_  progn
	   (progn
	     (setq dst1	 (distance p3 p2)
		   an1   (angle p3 p2)
		   inp	 (polar p3 an1 (/ dst1 2.0))
		   inptG (polar inp a1 (* l mb)) ;    
		                                 ;(- (* l mb) (abs (/ (* dst1 (sin a1)) 2.0)))) (c )
	     ) ;_  setq
	   ) ;_  progn
	 ) ;_  if
	)
	((and (>= typ 2) (or (= mat 1) (= mat 2)))
	 (command "_LINE" p2 p4 "")
	 (command "_ARC" p4 p1 p5 "")
	 (command "_LINE" p5 p3 "")
	 (if (= mat 2)
	   (progn
	     (setq inp1	(polar p2 (- a1 (/ pi 2.0)) (* (/ dn 2.0) mb))
		   inp2	(polar p3 (+ a1 (/ pi 2.0)) (* (/ dn 2.0) mb))
		   dst1	(distance p1 inp1)
		   dst2	(distance p1 inp2)
	     ) ;_  setq
	     (if (> dst1 dst2)
	       (setq inp (polar p1 (+ a1 pi) (* dst1 mb)))
	       (setq inp (polar p1 (+ a1 pi) (* dst2 mb)))
	     ) ;_  if
	     (setq inptG (polar inp a1 (* l mb))) ;     
	   ) ;_  progn
	   (progn
	     (setq dst1	 (distance p3 p2)
		   an1   (angle p3 p2)
		   inp	 (polar p3 an1 (/ dst1 2.0))
		   inptG (polar inp a1 (* l mb));    
		                                 ;(- (* l mb) (abs (/ (* dst1 (sin a1)) 2.0)))) (c )
	     ) ;_  setq
	   ) ;_  progn
	 ) ;_  if	 
	 (if (= mat 1)
	   (command "_ARC" p3 p1 p2)
	 ) ;_  if
	)
  ) ;_  cond
  (if (= typ 3)
    (progn
      (cond ((and (= mat 2) (/= x1 0) (< dist2 dist3))
	     (setq p6 (* (/ (- (nth 1 y) (nth 4 y)) 2.0) mb)
		   p7 (* (/ (- (nth 2 y) (nth 5 y)) 2.0) mb)
	     ) ;_  setq
	    )
	    ((and (= mat 2) (/= x1 0) (> dist2 dist3))
	     (setq p6 (* (/ (- (nth 2 y) (nth 5 y)) 2.0) mb)
		   p7 (* (/ (- (nth 1 y) (nth 4 y)) 2.0) mb)
	     ) ;_  setq
	    )
	    (t
	     (setq p6 (* (abs hv) mb)
		   p7 (* (abs hv) mb)
	     ) ;_  setq
	    )
      ) ;_  cond
      (setq p6 (polar p2 (+ a1 pi) p6)
	    p7 (polar p3 (+ a1 pi) p7)
      ) ;_  setq
    ) ;_  progn
  ) ;_  if
  (if (and p6 p7)
    (progn
      (command "_LINE" p2 p6 "" "_LINE" p3 p7 "")
      (if (= mat 1)
	(progn
	  (setq p8 (polar p1 (+ a1 pi) (* (abs hv) mb)))
	  (command "_ARC" p6 p8 p7)
	) ;_  progn
      ) ;_  if
    ) ;_  progn
  ) ;_  if

;;;      
  
(if (or (= mat 1) (= mat 3))
  (cond	((and (= an1 0.0)
	      (or (< (/ pi 2.0) a1 pi)
		  (< 0 a1 (/ pi 2.0))
	      ) ;_  or
	 ) ;_  and
	 (setq valp 1)
	)
	((and (= an1 (/ pi 2.0))
	      (or (< (/ pi 2.0) a1 pi)
		  (< pi a1 (* 3 (/ pi 2.0)))
	      ) ;_  or
	 ) ;_  and
	 (setq valp 1)
	)
	((and (= an1 pi)
	      (or (< (* 3 (/ pi 2.0)) a1 (* pi 1.9999))
		  (< pi a1 (* 3 (/ pi 2.0)))
	      ) ;_  or
	 ) ;_  and
	 (setq valp 1)
	)
	((and (= an1 (* 3 (/ pi 2.0)))
	      (or (< 0.0 a1 (/ pi 2.0))
		  (< (* 3 (/ pi 2.0)) a1 (* pi 1.9999))
	      ) ;_  or
	 ) ;_  and
	 (setq valp 1)
	)
  ) ;_  cond
) ;_  if


  (if (= valp 1)
    (setq ptr2 p3
	  ptr3 p2
	  ptr4 p5
	  ptr5 p4
    ) ;_  setq
    (setq ptr2 p2
	  ptr3 p3
	  ptr4 p4
	  ptr5 p5
    ) ;_  setq
  ) ;_  if


) ;_  UNNEND2
