;;;       12820-80
;;;:  ..
;;; : 21.05.2001
;;;CAD-CEE 2000
;;; : (vdsv3 inptG d d1 d2 s osv)
;;; inptG -  ;
;;; d -   , ;
;;; d1 -   , ;
;;; d2 -     , ;
;;; s -   , ;
;;; osv -     ("0" - , "1" - )

(defun vdsv3 (inptG d d1 d2 s osv / pr1 pr2 pr3 pr4 cpt label2 sset2 label1 sset1 an1)


;;;;;;;   
    (defun bl_vs (cpt bb / sgb dgb)

;;;     
      (setq dgb	(nth 6 bb)
	    sgb	(nth 7 bb)
      ) ;_  setq

   
      (setq tgb	 (/ (sqrt (- (expt dgb 2) (expt sgb 2))) sgb)
	    tgbt (atan tgb)
      ) ;_ end of setq
      (setq pt1	 (polar cpt (+ tgbt a1) (* (/ dgb 2.0) mb))
	    pt3	 (polar cpt (+ (+ tgbt (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt5	 (polar cpt (+ (+ tgbt (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt7	 (polar cpt (+ (+ tgbt pi) a1) (* (/ dgb 2.0) mb))
	    pt9	 (polar cpt (+ (+ tgbt (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt11 (polar cpt (+ (+ tgbt (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    tgbn (- pi tgbt)
	    pt6	 (polar cpt (+ tgbn a1) (* (/ dgb 2.0) mb))
	    pt8	 (polar cpt (+ (+ tgbn (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt10 (polar cpt (+ (+ tgbn (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt12 (polar cpt (+ (+ tgbn pi) a1) (* (/ dgb 2.0) mb))
	    pt2	 (polar cpt (+ (+ tgbn (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt4	 (polar cpt (+ (+ tgbn (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    pt13 (polar cpt (+ 0 a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt14 (polar cpt (+ pi a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt15 (polar cpt (+ (/ (* pi 3) 2) a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt16 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dgb 2.0) 3) mb))
      ) ;_ end of setq

      (axs)
      (command "_line" pt14 pt13 "")
      (setq label2 (entlast))
      (setq sset2 (ssadd (entlast)))
;;;      (command "_line" pt15 pt16 "")
      
      (if (= osv "1")
	(progn
            (osn)
            (command "_circle" cpt (* (/ (* sgb 0.9000) 2.0000) mb))
            (command "_line" pt12 pt1 ""
	             "_line" pt2 pt3 ""
	             "_line" pt4 pt5 ""
	             "_line" pt6 pt7 ""
	             "_line" pt8 pt9 ""
	             "_line" pt10 pt11 ""
            ) ;_ end of command
            (command "_arc" pt1 "_e" pt2 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt3 "_e" pt4 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt5 "_e" pt6 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt7 "_e" pt8 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt9 "_e" pt10 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt11 "_e" pt12 "_r" (* (/ dgb 2.0) mb)
            ) ;_ end of command
	 );_  progn
      ) ;_  if

    ) ;_ end of defun
;;; _end of   BL_VS

;;;;;;;   
    (defun gk_vs (cpt bb / sgb dgb dmt dvt)

;;;     
      (setq dmt	(nth 3 bb)
	    dgb	(nth 6 bb)
	    sgb	(nth 7 bb)
	    dvt	(nth 9 bb)
      ) ;_  setq
      
      (setq tgb	 (/ (sqrt (- (expt dgb 2) (expt sgb 2))) sgb)
	    tgbt (atan tgb)
      ) ;_ end of setq
      (if (< (* (/ (- dmt dvt) 2) mb) 0.6)
	(setq dvt (- dmt (/ (* 2 0.6) mb)))
      ) ;_  if
      (setq pt1	 (polar cpt (+ tgbt a1) (* (/ dgb 2.0) mb))
	    pt3	 (polar cpt (+ (+ tgbt (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt5	 (polar cpt (+ (+ tgbt (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt7	 (polar cpt (+ (+ tgbt pi) a1) (* (/ dgb 2.0) mb))
	    pt9	 (polar cpt (+ (+ tgbt (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt11 (polar cpt (+ (+ tgbt (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    tgbn (- pi tgbt)
	    pt6	 (polar cpt (+ tgbn a1) (* (/ dgb 2.0) mb))
	    pt8	 (polar cpt (+ (+ tgbn (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt10 (polar cpt (+ (+ tgbn (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt12 (polar cpt (+ (+ tgbn pi) a1) (* (/ dgb 2.0) mb))
	    pt2	 (polar cpt (+ (+ tgbn (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt4	 (polar cpt (+ (+ tgbn (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    pt13 (polar cpt (+ 0 a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt14 (polar cpt (+ pi a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt15 (polar cpt (+ (/ (* pi 3) 2) a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt16 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dgb 2.0) 3) mb))
	    pts	 (polar cpt (+ (/ pi 3) a1) (* (/ dvt 2.0) mb))
	    pte	 (polar cpt (+ (/ (* pi 11) 6) a1) (* (/ dvt 2.0) mb))
      ) ;_ end of setq

      (axs)
      (command "_line" pt14 pt13 "")
      (setq label2 (entlast))
      (setq sset2 (ssadd (entlast)))
;;;      (command "_line" pt15 pt16 "")

      (if (= osv "1")
	(progn
            (osn)
            (command "_circle" cpt (* (/ (* sgb 0.9) 2.0) mb))
            (command "_circle" cpt (* (/ dmt 2.0) mb))
            (command "_line" pt12 pt1 ""
	             "_line" pt2 pt3 ""
	             "_line" pt4 pt5 ""
	             "_line" pt6 pt7 ""
	             "_line" pt8 pt9 ""
	             "_line" pt10 pt11 ""
            ) ;_ end of command
            (command "_arc" pt1 "_e" pt2 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt3 "_e" pt4 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt5 "_e" pt6 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt7 "_e" pt8 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt9 "_e" pt10 "_r" (* (/ dgb 2.0) mb)
	             "_arc" pt11 "_e" pt12 "_r" (* (/ dgb 2.0) mb)
            ) ;_ end of command
            (if (not (< (* (/ dmt 2.0) mb) 0.6))
  	      (progn
	         (ton)
	         (command "_arc" "_c" cpt pts pte)
	      ) ;_  progn
            ) ;_  if
        );_  progn
      ) ;_  if

    ) ;_ end of defun
;;; _end of   GK_VS

;;;     
    (defun sh_vs (cpt bb / dmt)

;;;     
      (setq dmt	(nth 3 bb))  
      (osn)
;;;   
      (if (= osv "1")
         (command "_circle" cpt (* (/ dmt 2.0) mb))
      ) ;_  if
      
    ) ;_  defun
;;; _end of   SH_VS



;;;    ----------------- ----------------------
   (setq an1 a1
	 a1  0.0
   ) ;_  setq
   (setq pr1 (polar inptG (+ a1 pi) (* (* (/ d1 2.0) 1.1) mb))
	 pr2 (polar pr1 a1 (* (* d1 1.1) mb))
	 pr3 (polar inptG (+ a1 (/ pi 2.0)) (* (* (/ d1 2.0) 1.1) mb))
	 pr4 (polar pr3 (- a1 (/ pi 2.0)) (* (* d1 1.1) mb))
	 cpt (polar inptG (+ a1 pi) (* (/ d2 2.0) mb))
   ) ;_  setq

;;;       ( )
   (axs)
   (command "_line" pr1 pr2 "")
   (setq label (entlast))
   (setq sset (ssadd (entlast)))
   (setq label1 (entlast))
   (setq sset1 (ssadd (entlast)))
   (command "_line" pr3 pr4 "")
   (command "_circle" inptG (* (/ d2 2.0) mb))

   (osn)
   (command "_circle" inptG (* (/ d1 2.0) mb))
   (command "_circle" inptG (* (/ d 2.0) mb))
   (command "_circle" inptG (* (+ (/ d 2.0) s) mb))


;;;   
   (if (= bbs1 nil) (setq bbs1 (list 0 0 0)))
   (if (= bbs2 nil) (setq bbs2 (list 0 0 0)))
  
;;;     
   (if (eq blpr "1")
     (progn
       (bl_vs cpt bb0)
       (if (or	(< (nth 3 bb0) (nth 3 bbs1))
		(< (nth 3 bb0) (nth 3 bbs2))
	   ) ;_  and
	 (if (>= (nth 3 bbs1) (nth 3 bbs2))
	   (sh_vs cpt bbs1)
	   (progn
	     (sh_vs cpt bbs1)
	     (sh_vs cpt bbs2)
	   ) ;_  progn
	 ) ;_  if
       ) ;_  if
     ) ;_  progn
     (progn
       (gk_vs cpt bbg1)
       (if (or	(< (nth 3 bb0) (nth 3 bbs1))
		(< (nth 3 bb0) (nth 3 bbs2))
	   ) ;_  and
	 (if (>= (nth 3 bbs1) (nth 3 bbs2))
	   (sh_vs cpt bbs1)
	   (progn
	     (sh_vs cpt bbs1)
	     (sh_vs cpt bbs2)
	   ) ;_  progn
	 ) ;_  if
       ) ;_  if
     ) ;_  progn
   ) ;_  if

   (while (setq label2 (entnext label2))
          (setq sset2 (ssadd label2 sset2))
   ) ;_  while
 
   (command "_ROTATE" sset2 "" inptG (* (/ (+ (/ pi notv) a1) pi) 180))
   (command "_ARRAY" sset2 "" "_p" inptG notv "" "")

   (while (setq label1 (entnext label1))
          (setq sset1 (ssadd label1 sset1))
   ) ;_  while

   (command "_ROTATE" sset1 "" inptG (* (/ an1 pi) 180))
      
) ;_  VDSV
