;;;     
;;;: (krukotr l r0 l1 l2 b b1 b2 r r1 s2 l0 b0 ip a1 mb pr pr2 pdl shtrp)
;;;:   l  -      ;
;;;       r0 -   ;
;;;       l1 -   l;
;;;       l2 -   l1;
;;;       b  -   b;
;;;       b1 -   b1;
;;;       b2 -   b2;
;;;       r  -   r;
;;;       r1 -   r1;
;;;       s2 -    ;
;;;       l0 -    L;
;;;       b0 -    B;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pr -   (1 -  1, 2 -  2);
;;;       pr2 -   (1 - , 0 - );
;;;       pdl -    ("1" - );
;;;       shtrp -  ("1" - , "0" - )
;;; : 22.08.2001

(defun krukotr (l  r0   l1   l2	 b    b1   b2	r    r1	  s2   l0
		  b0   ip   a1	 mb   pr   pr2	pdl  shtrp     /
		  p1   p2   p3	 p4   p5   p6	p7   p8	  ks0  ks12
		  z    a    box	 lsta e	   flag	ang1 pt1  pt2  pt3
		  p1a  p2a  p3a	 p4a  p5a  p6a	p1b  p2b  p3b  p4b
		  p5b  p6b  lt	 pc1  pc2  lt1	lt2  p9	  p10
		 ) 


  (osn)
;;;      
  (setq	l    (* l mb)
	r0   (* r0 mb)
	l1   (* l1 mb)
	l2   (* l2 mb)
	b    (* b mb)
	b1   (* b1 mb)
	b2   (* b2 mb)
	r    (* r mb)
	r1   (* r1 mb)
	s2   (* s2 mb)
	l0   (* l0 mb)
	b0   (* b0 mb)
	lsta (- b b2) 
  ) ;_  setq

;;;     
  (if (and (= pr 1) (= pdl "1"))
    (setq ang1 (/ b0 (+ r0 (* s2 0.5)))
	  lt   (* 2 r0 (sin (/ ang1 2.0)))
	  lt1  (- r0 (sqrt (- (expt r0 2) (/ (expt lt 2) 4.0))))
	  lt   (* 2 (+ r0 s2) (sin (/ ang1 2.0)))
	  lt2  (- (+ r0 s2)
		  (sqrt (- (expt (+ r0 s2) 2) (/ (expt lt 2) 4.0)))
	       ) ;_  -
    ) ;_  setq
    (if	(/= pdl "1")
      (setq s2 0 lt1 0 lt2 0 l 0)
      (setq lt1	0 lt2 0) 
    ) ;_  if
  ) ;_  if

;;;    
(defun plastina ()
  (setq	p1  (polar ip (+ a1 pi) s2)
	p2  (polar p1 (- a1 (/ pi 2.0)) l0)
	p3  (polar p2 a1 s2)
	p1b (polar ip a1 lt1)
	p1a (polar p1 a1 lt2)	
	p2a  (polar p1a (- a1 (/ pi 2.0)) l0)
	p2b (polar p1b (- a1 (/ pi 2.0)) l0)
  ) ;_  setq
  (if (/= s2 0)
    (progn
      (command "_line" ip p1 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" p1 p2 "" "_line" p2 p3 "")
      (if (= pr2 1)
	(command "_line" ip p3 "")
	(progn
	  (command "_line" p3 p2b "" "_line" ip p1b "" "_line" p1b p2b "")
	  (command "_line" p1a p2a "")
	) ;_  progn
      ) ;_  if
    ) ;_  progn
  ) ;_  if
  
) ;_  PLASTINA
  

;;;    
(defun skoba (/ label1 label2 label3 label4)
  (setq	p4  (polar p1 (- a1 (/ pi 2.0)) l)
	p5  (polar p4 (+ a1 pi) b2)
	p6  (polar p5
		   (- a1 (* (/ pi 4.0) 3.0))
		   (/ lsta (cos (/ pi 4.0)))
	    ) ;_  polar
	p7  (polar p6 (- a1 (/ pi 2.0)) (- l1 lsta))
	p8  (polar p7 a1 (- b b1))
	p9  (polar p8 (+ a1 (/ pi 2.0)) (- l1 l2))
	p10 (polar p9 a1 b1)
  ) ;_  setq

  (command "_line" p4 p5 "")
  (if (= s2 0)
    (progn
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
    ) ;_  progn
  ) ;_  if
  (command "_line" p5 p6 "" "_line" p4 p10 "")

;;;     
  (command "_fillet" "_r" r1)
  (command "_line" p6 p7 "")
  (setq label1 (entlast))
  (command "_line" p7 p8 "")
  (setq label2 (entlast))
  (command "_line" p8 p9 "")
  (setq label3 (entlast))
  (command "_line" p9 p10 "")
  (setq label4 (entlast))
  (command "_fillet" label1 label2)
  (command "_fillet" label2 label3)
  (command "_fillet" "_r" r)
  (command "_fillet" label3 label4)
) ;_  SKOBA


;;;    
  (defun sht (/ dl ang1 pt1 av)
      (setq dl	 (distance p2 ip)
	    ang1 (angle p2 ip)
	    pt1	 (polar p2 ang1 (/ dl 2.0))
	    av	 (* (/ a1 pi) 180)
      ) ;_  setq
      (ton)
      (command "_bhatch" "_p" "_u" (+ av 45) 2.0 "_n" pt1 "")
  ) ;_  defun

;;;  ---------- ---------
  (plastina)
  (skoba)
  (if (and (= pr2 1) (eq shtrp "1"))
    (sht)
  ) ;_  if 
) ;_  KRUKOTR


;;;     
;;;: (krukotr2 r0 s1 b b2 s2 b0 ip ip1 n0 a1 mb pr pdl)
;;;:   r0 -   ;
;;;       s1 -  ;
;;;       b  -   b;
;;;       b2 -   b2;
;;;       s2 -    ;
;;;       b0 -    B;
;;;       ip -  ;
;;;       n0 -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pr -    (1 -  1, 2 -  2);
;;;       pdl -    ("1" - );
;;; : 22.08.2001
(defun krukotr2 (r0  s1	 b    b2   s2	b0   ip	  n0   a1   mb	 pr
		    pdl	 /    pt1  pt2	pt3  pt4  p1   p2   p3	 p4
		    p5	 p1a  p2a  p3a	p4a  p5a  ang1 lt1  label1
		    sset1  ip1 lsta
		   ) 

  (osn)
;;;      
  (setq	r0   (* r0 mb)
	s1   (* s1 mb)
	b    (* b mb)
	b2   (* b2 mb)
	s2   (* s2 mb)
	b0   (* b0 mb)
	lsta (- b b2)
	ip1  (polar ip a1 r0)
  ) ;_  setq

;;;     
  (if (and (= pr 1) (= pdl "1"))
    (setq ang1 (/ (/ b0 (+ r0 (* s2 0.5))) 2.0)
	  lt1  (- (+ r0 s2) (sqrt (- (expt (+ r0 s2) 2) (/ (expt s1 2) 4.0))))
    ) ;_  setq
    (if	(/= pdl "1")
      (progn
	(setq s2 0 lt1 0)
	(setq ang1 (/ (/ s1 r0) 2.0))
	(if (= pr 1)
	  (setq	lt1  (-	r0
			(sqrt (- (expt r0 2) (/ (expt s1 2) 4.0)))
		     ) ;_  -
	  ) ;_  setq
	) ;_  if
      ) ;_  progn
      (setq lt1 0)
    ) ;_  if
  ) ;_  if

;;;   pt2
  (setq	pt2  (polar ip (+ a1 pi) (+ b s2))
	pt2a (polar ip (+ a1 pi) (* (+ b s2) 1.05))
  ) ;_  setq


;;;     ( 1)
  (defun plastina1 ()
     (setq p1  (polar ip1 (+ (+ a1 pi) ang1) r0)
	   p2  (polar ip1 (+ (+ a1 pi) ang1) (+ r0 s2))
	   p1a (polar ip1 (- (+ a1 pi) ang1) r0)
	   p2a (polar ip1 (- (+ a1 pi) ang1) (+ r0 s2))
	   pt1 (polar ip1 (+ a1 pi) (+ r0 s2))
     ) ;_  setq
    (if	(/= s2 0)
      (progn
	(command "_line" p1a p2a "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(setq label1 (entlast))
	(setq sset1 (ssadd (entlast)))
	(command "_line" p1 p2 "")
	(command "_arc" p1a ip p1)
	(command "_arc" p2a pt1 p2)
      ) ;_  progn
    ) ;_  if
  ) ;_  PLASTINA1

;;;     ( 2)
  (defun plastina2 ()
     (setq p1  (polar ip (+ a1 (/ pi 2.0)) (* b0 0.5))
	   pt1 (polar ip (+ a1 pi) s2)
	   p2  (polar ip (- a1 (/ pi 2.0)) (* b0 0.5))
	   p1a (polar pt1 (+ a1 (/ pi 2.0)) (* b0 0.5))
	   p2a (polar pt1 (- a1 (/ pi 2.0)) (* b0 0.5))	   
     ) ;_  setq
     (if (/= s2 0)
      (progn
	(command "_line" p1a p2a "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_line" p1 p2 "")
	(command "_line" p1a p1 "" "_line" p2a p2 "")
      ) ;_  progn
    ) ;_  if
  ) ;_  PLASTINA2

;;;    
 (defun	skoba ()
   (setq p3  (polar pt2 (- a1 (/ pi 2.0)) (* s1 0.5))
	 p3a (polar pt2 (+ a1 (/ pi 2.0)) (* s1 0.5))
	 p4  (polar p3 a1 lsta)
	 p4a (polar p3a a1 lsta)
	 p5  (polar p4 a1 (+ b2 lt1))
	 p5a (polar p4a a1 (+ b2 lt1))
   ) ;_  setq

   (command "_line" p3 p3a "")
   (if (= s2 0)
     (progn
       (setq label (entlast))
       (setq sset (ssadd (entlast)))
       (setq label1 (entlast))
       (setq sset1 (ssadd (entlast)))
       (if (= pr 1)
            (command "_arc" p5a pt1 p5)
            (command "_line" p5a p5 "")
       ) ;_  if
     ) ;_  progn
   ) ;_  if
   (command "_line" p4 p4a "")
   (command "_line" p3 p5 "" "_line" p3a p5a "")
;;;   
   (axs)
   (command "_line" ip pt2a "")
 ) ;_  SKOBA

;;;    
  (defun razm ()
    (while (setq label1 (entnext label1))
      (setq sset1 (ssadd label1 sset1))
    ) ;_  while
    (command "_select" sset1 "")
    (command "_array" "_p" "" "_p" ip1 n0 "360" "_Y")
  ) ;_  defun


;;;  ------------ -----------
  (if (= pr 1)
    (plastina1)
    (plastina2)
  ) ;_  if
  (skoba)
  (if (and (= pr 1) (> n0 1))
    (razm)
  ) ;_  if
 
) ;_  KRUKOTR2
