;;;       5264
;;;:  ..
;;; : 11.09.2001
;;;CAD-CEE 2000
;;;: C:SVR

(defun c:svr (/	dlg   dfl   lsp1  fld	strd  strdd orx	  aby	name1
		dcl_id	    vnln  dps	tol   baz   d1	  d2	d3
		d4    d5    d6	  d7	d8    d9    d10	  d11	d12
		pr    dps1  pl	  inptG	d13   d14   cla	  tol1	baz1
		s1    s2    r	  strd1	strdd1	    smin  smax	shtr
		raz   l	    s3	  b
	       ) 


  (setq	dlg  (findfile (strcat pathdcl2 "svarka\\svr.dcl"))
	dfl  (findfile (strcat pathlisp2 "svarka\\svr.d"))
	lsp1 (findfile (strcat pathlisp2 "svarka\\fasotr2.lsp"))
  ) ;_  setq

  (load lsp1)

  (setq spis '("  8"
	       "  11"
	       "  20"
	       "  21"
	       "  25"
	       "  6"
	       "  7"
	       "  6"
	       "  7"
	      ) 
  ) ;_  setq

  
;;;      SVR.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   dps	  (itoa (nth 0 strdd1))
	   s1	  (nth 1 strdd1)
	   s2	  (nth 2 strdd1)
	   r	  (nth 3 strdd1)
	   s3	  (nth 4 strdd1)
	   l	  (nth 5 strdd1)
	   shtr   (itoa (nth 6 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun

;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun
  

;;;            
  (defun s_t ()
    (set_tile "Tipf" (itoa (- (atoi dps) 1)))
    (set_tile "S1" (rtos s1))
    (set_tile "S2" (rtos s2))
    (set_tile "R" (rtos r))
    (set_tile "S3" (rtos s3))
    (set_tile "L" (rtos l))
    (set_tile "Shtr" shtr)
    (if	(or (<= 6 (atoi dps) 9) (<= 2 (atoi dps) 3))
      (mode_tile "R" 1)
      (mode_tile "R" 0)
    ) ;_  if
    (if	(<= 2 (atoi dps) 3)
      (progn
	(mode_tile "S2" 1)
	(mode_tile "S3" 0)
	(mode_tile "L" 0)
	(cond ((<= 3.0 s1 8.0) (setq b 3.0))
	      ((and (> s1 8.0) (<= s1 14.0)) (setq b 4.0))
	      ((and (> s1 14.0) (<= s1 60.0)) (setq b 5.0))
	) ;_  cond
	(set_tile "B" (rtos b))
      ) ;_  progn
      (progn
	(mode_tile "S2" 0)
	(mode_tile "S3" 1)
	(mode_tile "L" 1)
	(set_tile "B" " ")
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;       SVR.D
  (defun wrfl ()

    (setq fld  (open dfl "w")
	  strd (strcat "(" p1 " " p2 " " angl " " mash ")")
    ) ;_  setq
    (write-line strd1 fld)
    (write-line strd fld)
    (close fld)

  ) ;_  defun

  (defun wrfl_os ()
        (setq strd1 (strcat "(" dps " " (rtos s1) " " (rtos s2) " " (rtos r) " " (rtos s3) " " (rtos l)
			    " " shtr ")")
	)  ;_  setq        
  )  ;_  defun


;;;     
(defun name ()
  (cond	((eq dps "1")
	 (setq name1 (strcat pathdat2 "svarka\\svr(1).slb"))
	)
	((eq dps "2")
	 (setq name1 (strcat pathdat2 "svarka\\svr(10).slb"))
	)
	((eq dps "3")
	 (setq name1 (strcat pathdat2 "svarka\\svr(11).slb"))
	)
	((eq dps "4")
	 (setq name1 (strcat pathdat2 "svarka\\svr(2).slb"))
	)
	((eq dps "5")
	 (setq name1 (strcat pathdat2 "svarka\\svr(3).slb"))
	)
	((eq dps "6")
	 (setq name1 (strcat pathdat2 "svarka\\svr(4).slb"))
	)
	((eq dps "7")
	 (setq name1 (strcat pathdat2 "svarka\\svr(5).slb"))
	)
	((eq dps "8")
	 (setq name1 (strcat pathdat2 "svarka\\svr(6).slb"))
	)
	((eq dps "9")
	 (setq name1 (strcat pathdat2 "svarka\\svr(7).slb"))
	)
  ) ;_  cond
) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;    
    (defun tipf_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun

;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

   
;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
    (setq srv (* 1.0 mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;        
  (defun shvr ()
    (cond ((= dps "1") (setq smin 3.0 smax 60.0))
	  ((= dps "2") (setq smin 3.0 smax 60.0))
          ((= dps "3") (setq smin 3.0 smax 60.0))
          ((= dps "4") (setq smin 3.0 smax 60.0))
          ((= dps "5") (setq smin 8.0 smax 120.0))
	  ((= dps "6") (setq smin 3.0 smax 60.0))
	  ((= dps "7") (setq smin 3.0 smax 60.0))
	  ((= dps "8") (setq smin 3.0 smax 60.0))
	  ((= dps "9") (setq smin 3.0 smax 60.0))
    ) ;_  cond
;;;    (if	(or (< s1 smin) (> s1 smax) (< s2 smin) (> s2 smax))
;;;      (progn
;;;	(set_tile "S1" (rtos smin))
;;;	(set_tile "S2" (rtos smin))
;;;      ) ;_  progn
;;;    ) ;_  if

;;;     
    (if	(<= 6 (atoi dps) 9)
      (progn
	(setq smin (* s2 0.5))
	(if (< s1 smin)
	  (progn
	    (setq s1 smin)
	    (set_tile "S1" (rtos smin))
	  ) ;_  progn
	) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;       
;;;   : (sdop pl)
;;;   pl -  .
  (defun sdop (pl / stn stl ch)
;;;      
    (if	(= pl "S1")
      (setq stn s2 ch 0)
      (setq stn s1 ch 1)
    ) ;_  if

;;;      
    (if	(or (= (atoi dps) 1) (<= 4 (atoi dps) 5))
      (cond ((<= 1.0 stn 4.0)
	     (if (> (abs (- s2 s1)) 1.0)
	       (progn
                  (set_tile pl (rtos stn))
		  (if (= ch 0)
		    (setq s1 stn)
		    (setq s2 stn)
		  ) ;_  if
	       ) ;_  progn
	     ) ;_  if
	    )
	    ((and (> stn 4.0) (<= stn 20.0))
	     (if (> (abs (- s2 s1)) 2.0)
	       (progn
                  (set_tile pl (rtos stn))
		  (if (= ch 0)
		    (setq s1 stn)
		    (setq s2 stn)
		  ) ;_  if
	       ) ;_  progn
	     ) ;_  if
	    )
	    ((and (> stn 20.0) (<= stn 30.0))
	     (if (> (abs (- s2 s1)) 3.0)
	       (progn
                  (set_tile pl (rtos stn))
		  (if (= ch 0)
		    (setq s1 stn)
		    (setq s2 stn)
		  ) ;_  if
	       ) ;_  progn
	     ) ;_  if
	    )
	    (t
	     (if (> (abs (- s2 s1)) 4.0)
	       (progn
                  (set_tile pl (rtos stn))
		  (if (= ch 0)
		    (setq s1 stn)
		    (setq s2 stn)
		  ) ;_  if
	       ) ;_  progn
	     ) ;_  if
	    )
      ) ;_  cond
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

  
;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun



;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   

 ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "svr" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (tipf_l)
    (shvr)
    (s_t)


;;;     
    (action_tile
      "Tipf"
      (strcat "(setq dps (itoa (+ (atoi $value) 1)))"
	      "(show_im (name))"
	      "(shvr)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S1"
      (strcat "(prv_p $value 's1 \"S1\" \"r\")"
	      "(shvr)"
	      "(sdop \"S1\")"
	      "(sdop \"S2\")"
	      "(prov smin s1 smax \"S1\" \"\")"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S2"
      (strcat "(prv_p $value 's2 \"S2\" \"r\")"
	      "(shvr)"
	      "(sdop \"S1\")"
	      "(sdop \"S2\")"
	      "(prov smin s2 smax \"S2\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "R"
      (strcat "(prv_p $value 'r \"R\" \"r\")"
	      "(prov 0 r 3000 \"R\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S3"
      (strcat "(prv_p $value 's3 \"S3\" \"r\")"
	      "(prov 3 s3 100 \"S3\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "L"
      (strcat "(prv_p $value 'l \"L\" \"r\")"
	      "(prov 8 l 20 \"L\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtr $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun

;;; ---------------------------------- --------------------------------
  (show)
  (ins1)
;;;  (setvar "USERR1" mb); 
  (unload_dialog dcl_id)
  (prin1)

;;;    
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 (+ a1 pi))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)

  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* s1 3.0) 2))
    (command "_ZOOM" "_C" inptG (* (* s1 3.0) 2))
  ) ;_  if
  
;;;   
  (cond	((= dps "1")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 1)
	)
	((= dps "2")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 2)
	)
	((= dps "3")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 3)
	)
	((= dps "4")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 4)
	)
	((= dps "5")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 5)
	)
	((= dps "6")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 6)
	)
	((= dps "7")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 7)
	)
	((= dps "8")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 8)
	)
	((= dps "9")
	 (fasotr2 s1 s2 r s3 l b inptG mb a1 shtr 9)
	)
  ) ;_  cond

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400))
  (command "_LAYER" "_s" cla "")
  (prin1)
 
) ;_  SVR
