;;;    (   symb1.shx)
;;;:  ..
;;; : 03.09.2001 ( ..)
;;;CAD-CEE 2000
;;;: (spt code1 code2 tol baz)
;;;   : code1 -     ("0" - , "1" - );
;;;        code2 -    (1 -  , 4 -  , 6 -  );
;;;        tol -     ;
;;;        baz -    

(defun spt (code1 code2	tol baz	/ cla ort tang1	tang2 tangt dl pl cp tex
	    bp ipl ips ipi la bl)
  (setq	cla   (getvar "CLAYER")
	ort   (getvar "ORTHOMODE")
	bl    (getvar "BLIPMODE")
	code1 (atoi code1)
  ) ;_  setq
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (setq	obj    (entget (ssname (ssget "_l") 0))
	tangle (cdr (assoc '50 obj))
	ip     (cdr (assoc '10 obj))
	sloy   (cdr (assoc '8 obj))
  ) ;_  setq
  (if (/= sloy "")
    (command "_CHPROP" "_l" "" "_la" "" "")
  ) ;_  if
  (command "_LAYER" "_s" "" "")
  (cond	((= code2 1)
	 (setq ip    (polar ip (+ tangle (/ pi 2)) 12)
	       tang1 (- (/ pi 2) 0)
	       dl    3.75
	 ) ;_  setq
	)
	((= code2 4)
	 (setq dl    18.1
	       tangt tangle
	       tang1 0.11065
	 ) ;_  setq
	)
	((= code2 6)
	 (setq dl    18.1
	       pl    31.1
	       tang1 0.11065
	       tang2 0.064
	       tangt tangle
	 ) ;_  setq
	)
  ) ;_  cond
  (setq cp (polar ip (+ tangle tang1) dl))
  (setvar "TEXTEVAL" 1)
  (setvar "AUNITS" 3)
  (if (= code2 1)
    (progn
;;;      (setq tex (getstring (strcat "\n    <" baz ">:")))
;;;      (if (or (= tex nil) (= tex "")) (setq tex baz))
      (command "_TEXT" "_m" cp "3.5" "0" baz); 
      (setq baz1 tex)
    ) ;_  progn
    (progn
;;;      (setq tex (getstring (strcat "\n    <" tol ">:")))
;;;      (if (or (= tex nil) (= tex "")) (setq tex tol))
      (command "_TEXT" "_c" cp "3.5" tangt tol); 
      (setq tol1 tex)
    ) ;_  progn
  ) ;_  if
  (if (= code2 6)
    (progn
;;;      (setq tex (getstring (strcat "\n    <" baz ">:")))
      (setq bp	(polar ip (+ tangle tang2) pl))
;;;      (if (or (= tex nil) (= tex "")) (setq tex baz))
      (command "_TEXT" "_c" bp "3.5" tangt baz); 
      (setq baz1 tex)
    ) ;_  progn
  ) ;_  if
  (if (= code1 1)
    (progn
      (setvar "ORTHOMODE" 1)
      (setq ipl	(polar ip (+ tangle (/ pi 2)) 4.0)
	    ips	(getpoint
		  ipl
		  "\n   ( [ENTER]   ):"
		) ;_  getpoint
      ) ;_  setq
      (while (= ips nil)
	(setq ipi (getpoint ipl "\n :"))
	(command "_LINE" ipl ipi "")
	(setq ips (getpoint
		    ipi
		    "\n   ( [ENTER]   ):"
		  ) ;_  getpoint
	      ipl ipi
	) ;_  setq
      ) ;_  while
      (command "_LINE" ipl ips "")
      (setq la (angle ips ipl))
      (command "_PLINE" ips "_w" 0 "1.0" (polar ips la 4.0) "")
    ) ;_  progn
  ) ;_  if
;;;  (setvar "BLIPMODE" 1)
  (command "LAYER" "s" cla "")
  (setvar "AUNITS" 1)
  (setvar "CMDECHO" 1)
  (setvar "ORTHOMODE" ort)
  (setvar "BLIPMODE" bl)
  (princ)
) ;_  SPT
