;;;  
;;;:  ..
;;; : 05.10.2000
;;;CAD-CEE 2000

(defun gks (/	  cmd	blpm  apsz  osmd  dmt	dgb   sgb   hgb	  dvt
	    label sset	edat3 tgb   tgbt  tgbn	pts   pte   cpt	  ept
	    pt1	  pt2	pt3   pt4   pt5	  pt6	pt7   pt8   pt9	  pt10
	    pt11  pt12	pt13  pt14  pt15  pt16  clay  cltp ccol   ang
	    a1    mb    inpt0   
	   )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	dmt (nth 3 bb)
	dgb (nth 6 bb)
	sgb (nth 7 bb)
	hgb (nth 8 bb)
	dvt (nth 9 bb)
  ) ;_ end of setq

;;;   

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )



     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )
     (defun axs ()
          (command "_'layer" "_s" " " "")
      )
     (defun ton ()
          (command "_'layer" "_s" "" "")
      )


  (defun ris_gks ()

    (setq cpt inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)

;;;;;;;;;     
    (defun gk_gl_sb ()

					;   
      (defun gkgl ()

	(setq pt1 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ (* sgb 0.9) 2.0) mb)))
	(setq pt2 (polar cpt (+ (/ pi 2) a1) (* (/ (* sgb 0.9) 2.0)mb)))
	(setq
	  pt3 (polar pt1
		     (+ (/ (* pi 5) 3) a1)
		     (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	      ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt4 (polar pt2
		     (+ (/ pi 3) a1)
		     (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	      ) ;_ end of polar
	) ;_ end of setq
	(setq ept (polar cpt (+ 0 a1) (* hgb mb)))
	(setq pt5 (polar ept (+ (/ (* pi 3) 2) a1) (* (/ (* sgb 0.9) 2.0) mb)))
	(setq pt6 (polar ept (+ (/ pi 2) a1) (* (/ (* sgb 0.9) 2.0) mb)))
	(setq
	  pt7 (polar pt5
		     (+ (/ (* pi 4) 3) a1)
		     (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	      ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt8 (polar pt6
		     (+ (/ (* pi 2) 3) a1)
		     (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	      ) ;_ end of polar
	) ;_ end of setq
	(setq pt9 (polar pt7 (+ (/ pi 2) a1) (* (/ dgb 4.0) mb)))
	(setq pt10 (polar pt8 (+ (/ (* pi 3) 2) a1) (* (/ dgb 4.0) mb)))
	(setq pt11 (polar pt3 (+ (/ pi 2) a1) (* (/ dgb 4.0) mb)))
	(setq pt12 (polar pt4 (+ (/ (* pi 3) 2) a1) (* (/ dgb 4.0) mb)))
	(setq
	  pt13 (polar pt9
		      (+ (/ (* pi 5) 3) a1)
		      (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	       ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt14 (polar pt10
		      (+ (/ pi 3) a1)
		      (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	       ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt15 (polar pt11
		      (+ (/ (* pi 4) 3) a1)
		      (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	       ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt16 (polar pt12
		      (+ (/ (* pi 2) 3) a1)
		      (* (/ (/ (- dgb (* sgb 0.9)) 2.0) (cos (/ pi 6))) mb)
	       ) ;_ end of polar
	) ;_ end of setq

	(osn)
	(command "_line" pt1 pt2 "")
	(setq label (entlast)
	      sset  (ssadd (entlast))
	) ;_ end of setq
	(command "_line"
		 pt2
		 pt4
		 pt8
		 pt6
		 pt5
		 pt7
		 pt3
		 pt1
		 ""
		 "_line"
		 pt15
		 pt11
		 pt9
		 pt13
		 ""
		 "_line"
		 pt16
		 pt12
		 pt10
		 pt14
		 ""
		 "_arc"
		 pt12
		 cpt
		 pt11
		 "_arc"
		 pt9
		 ept
		 pt10
	)				;  
					;  
      ) ;_ end of defun GKGL

;;;;;;;;;;;;;;;;   ;;;;;;;;;;;;;;;;;;;;;
      (defun gkbv ()

	(setq ept (polar cpt (+ 0 a1) (* hgb mb)))
	(setq
	  pt1 (polar cpt
		     (+ 0 a1)
		     (* (/ (* (/ (- dgb (* sgb 0.9)) 2.0) (sin (/ pi 6)))
			(cos (/ pi 6))
		     ) mb) ;_ end of *
	      ) ;_ end of polar
	) ;_ end of setq
	(setq
	  pt2 (polar ept
		     (+ pi a1)
		     (* (/ (* (/ (- dgb (* sgb 0.9)) 2.0) (sin (/ pi 6)))
			(cos (/ pi 6))
		     ) mb);_ end of *
	      ) ;_ end of polar
	) ;_ end of setq
	(setq pt5 (polar pt1 (+ (/ (* pi 3) 2) a1) (* (/ sgb 2.0) mb)))
	(setq pt9 (polar pt1 (+ (/ pi 2) a1) (* (/ sgb 2.0) mb)))
	(setq pt6 (polar pt2 (+ (/ (* pi 3) 2) a1) (* (/ sgb 2.0) mb)))
	(setq pt10 (polar pt2 (+ (/ pi 2) a1) (* (/ sgb 2.0) mb)))
	(setq pt3 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ sgb 4.0) mb)))
	(setq pt7 (polar cpt (+ (/ pi 2) a1) (* (/ sgb 4.0) mb)))
	(setq pt4 (polar ept (+ (/ (* pi 3) 2) a1) (* (/ sgb 4.0) mb)))
	(setq pt8 (polar ept (+ (/ pi 2) a1) (* (/ sgb 4.0) mb)))
	(setq pt11 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ (* sgb 0.9) 2.0) mb)))
	(setq pt12 (polar ept (+ (/ (* pi 3) 2) a1) (* (/ (* sgb 0.9) 2.0) mb)))
	(setq pt14 (polar cpt (+ (/ pi 2) a1) (* (/ (* sgb 0.9) 2.0) mb)))
	(setq pt13 (polar ept (+ (/ pi 2) a1) (* (/ (* sgb 0.9) 2.0) mb)))

	(osn)
	(command "_line" pt1 pt2 "")
	(setq label (entlast)
	      sset  (ssadd (entlast))
	) ;_ end of setq
	(command "_line"
		 pt6
		 pt12
		 pt13
		 pt10
		 pt9
		 pt14
		 pt11
		 pt5
		 pt6
		 ""
		 "_arc"
		 pt10
		 pt8
		 pt2
		 "_arc"
		 pt2
		 pt4
		 pt6
		 "_arc"
		 pt5
		 pt3
		 pt1
		 "_arc"
		 pt1
		 pt7
		 pt9
	)				; -   
      ) ;_ end of defun GKBV

      (if (and (eq glv1 "1") (eq vsb1 "0"))
	(gkgl)
	(gkbv)
      ) ;_ end of if

    ) ;_ end of defun
;;;;;_end of      GK_GL_SB


;;;;;;;  
    (defun gk_vs ()
      (setq tgb	 (/ (sqrt (- (expt dgb 2) (expt sgb 2))) sgb)
	    tgbt (atan tgb)
      ) ;_ end of setq
      (if (< (* (/ (- dmt dvt) 2) mb) 0.6)
	(setq dvt (- dmt (/ (* 2 0.6) mb)))
      ) ;_  if
      (setq pt1	 (polar cpt (+ tgbt a1) (* (/ dgb 2.0) mb))
	    pt3	 (polar cpt (+ (+ tgbt (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt5	 (polar cpt (+ (+ tgbt (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt7	 (polar cpt (+ (+ tgbt pi) a1) (* (/ dgb 2.0) mb))
	    pt9	 (polar cpt (+ (+ tgbt (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt11 (polar cpt (+ (+ tgbt (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    tgbn (- pi tgbt)
	    pt6	 (polar cpt (+ tgbn a1) (* (/ dgb 2.0) mb))
	    pt8	 (polar cpt (+ (+ tgbn (/ pi 3)) a1) (* (/ dgb 2.0) mb))
	    pt10 (polar cpt (+ (+ tgbn (* (/ pi 3) 2)) a1) (* (/ dgb 2.0) mb))
	    pt12 (polar cpt (+ (+ tgbn pi) a1) (* (/ dgb 2.0) mb))
	    pt2	 (polar cpt (+ (+ tgbn (* (/ pi 3) 4)) a1) (* (/ dgb 2.0) mb))
	    pt4	 (polar cpt (+ (+ tgbn (* (/ pi 3) 5)) a1) (* (/ dgb 2.0) mb))
	    pt13 (polar cpt (+ 0 a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt14 (polar cpt (+ pi a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt15 (polar cpt (+ (/ (* pi 3) 2) a1) (* (+ (/ dgb 2.0) 3) mb))
	    pt16 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dgb 2.0) 3) mb))
	    pts	 (polar cpt (+ (/ pi 3) a1) (* (/ dvt 2.0) mb))
	    pte	 (polar cpt (+ (/ (* pi 11) 6) a1) (* (/ dvt 2.0) mb))
      ) ;_ end of setq

      (axs)
      (command "_line" pt14 pt13 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" pt15 pt16 "")

      (osn)
      (command "_circle" cpt (* (/ (* sgb 0.9) 2.0) mb))
      (command "_circle" cpt (* (/ dmt 2.0) mb))
      (command "_line"
	       pt12
	       pt1
	       ""
	       "_line"
	       pt2
	       pt3
	       ""
	       "_line"
	       pt4
	       pt5
	       ""
	       "_line"
	       pt6
	       pt7
	       ""
	       "_line"
	       pt8
	       pt9
	       ""
	       "_line"
	       pt10
	       pt11
	       ""
      ) ;_ end of command
      (command "_arc"
	       pt1
	       "_e"
	       pt2
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt3
	       "_e"
	       pt4
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt5
	       "_e"
	       pt6
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt7
	       "_e"
	       pt8
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt9
	       "_e"
	       pt10
	       "_r"
	       (* (/ dgb 2.0) mb)
	       "_arc"
	       pt11
	       "_e"
	       pt12
	       "_r"
	       (* (/ dgb 2.0) mb)
      ) ;_ end of command
      (if (not (< (* (/ dmt 2) mb) 0.6))
	(progn
	  (ton)
	  (command "_arc" "_c" cpt pts pte)
	) ;_  progn
      ) ;_  if


    ) ;_ end of defun
;;; _end of   GK_VS

    (cond
      ((and (or (eq glv1 "1") (eq vsb1 "1")) (eq vsv1 "0"))
       (gk_gl_sb)
      )
      ((and (eq glv1 "0") (eq vsb1 "0") (eq vsv1 "1")) (gk_vs))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun
;;;_end of RIS_GKS


  (defun clip_bl ()

      (setvar "aperture" apsz)
      (setvar "osmode" osmd)
      (setvar "clayer" clay)

      (initget 1)
      (if (eq p1 "1")
	(setq inpt0 (getpoint "\n  :"))
	(setq inpt0 (list (atof xc) (atof yc)))
      ) ;_  if
      (if (eq p2 "1")
	(progn
	  (setq	a1
		 (getangle inpt0
			   (strcat "\n   <" angl ">:")
		 ) ;_  getangle
	  ) ;_  setq
	  (if (= a1 nil)
	    (setq a1 (atof angl))
	  ) ;_  if
	) ;_  progn
	(setq a1 (* pi (/ (atof angl) 180)))
      ) ;_  if 
      (setq mb (atof mash))

      (ris_gks)

      (if (eq p3 "0")
	(anblk sset cpt)
      ) ;_  if

      (setvar "celtype" cltp)
      (setvar "cecolor" ccol)
      (setvar "aperture" apsz)
      (setvar "osmode" osmd)
      (setvar "clayer" clay)
    ) ;_ end of defun

  (clip_bl)
  (prin1)
) ;_ end of defun GKS
