
;;;  
;;;:  ..
;;; : 28.07.2000
;;;CAD-CEE 2000

(defun c:krpg (/       dvt1    dvt2    dvt3    dvt4    krcl    basd
	       bas1d   bas2d   bas3d   bas4d   bas5d   bas6d   bas7d
	       bas8d   bas9d   bas10d  bas11d  bas12d  bas13d  bas14d
	       bas15d  bas16   bas17d  bas18d  bas19d  bas20d  bas21
	       bas22d  bas23d  bas24d  bas25d  bas26d  bas27d  name1
	       orx     aby     fil     glv1    vsb1    vsv1    pr_fl
	       vk_rp   rr      rl      rs      spr     x       a
	       aa      a1      a2      a3      a4      b       bb
	       b0      b1      b2      b12     xc      yc      mash
	       angl    p1      p2      p3      dvt5    bas28d  bas29d
	       bas30d  bas31d  bas32d  bas33d  bas34d  bas35d  bas36d
	       dat1    fld     strd    strdd   bas37d  bas38d  bas39d
	       bas40d  bas41d  bas42d  bas43d  anbl    dmt     dvt
	      )

  (setq	dvt1   (findfile (strcat pathlisp2 "blts\\blts.lsp"))
	dvt2   (findfile (strcat pathlisp2 "blts\\vint.lsp"))
	dvt3   (findfile (strcat pathlisp2 "blts\\gks.lsp"))
	dvt4   (findfile (strcat pathlisp2 "blts\\shb.lsp"))
	dvt5   (findfile (strcat pathlisp2 "blts\\shpl.lsp"))
	anbl   (findfile (strcat pathlisp2 "$anblk.lsp"))
	dat1   (findfile (strcat pathlisp2 "blts\\krpz.d"))
	krcl   (findfile (strcat pathdcl2 "blts\\krpz.dcl"))
	basd   (findfile (strcat pathdat2 "blts\\b7805.dat"))
	bas1d  (findfile (strcat pathdat2 "blts\\b7808.dat"))
	bas2d  (findfile (strcat pathdat2 "blts\\b7798.dat"))
	bas3d  (findfile (strcat pathdat2 "blts\\b7796.dat"))
	bas36d (findfile (strcat pathdat2 "blts\\b262037.dat"))
	bas4d  (findfile (strcat pathdat2 "blts\\v1491.dat"))
	bas5d  (findfile (strcat pathdat2 "blts\\v17473.dat"))
	bas6d  (findfile (strcat pathdat2 "blts\\v17474.dat"))
	bas7d  (findfile (strcat pathdat2 "blts\\v17475.dat"))
	bas8d  (findfile (strcat pathdat2 "blts\\v11738.dat"))
	bas9d  (findfile (strcat pathdat2 "blts\\v1488.dat"))
	bas10d (findfile (strcat pathdat2 "blts\\g5915.dat"))
	bas11d (findfile (strcat pathdat2 "blts\\g5916.dat"))
	bas12d (findfile (strcat pathdat2 "blts\\g15521.dat"))
	bas13d (findfile (strcat pathdat2 "blts\\g15522.dat"))
	bas14d (findfile (strcat pathdat2 "blts\\g5927.dat"))
	bas15d (findfile (strcat pathdat2 "blts\\g5929.dat"))
	bas16d (findfile (strcat pathdat2 "blts\\g2524.dat"))
	bas17d (findfile (strcat pathdat2 "blts\\g2526.dat"))
	bas18d (findfile (strcat pathdat2 "blts\\g15524.dat"))
	bas19d (findfile (strcat pathdat2 "blts\\g5931.dat"))
	bas34d (findfile (strcat pathdat2 "blts\\g262038.dat"))
	bas35d (findfile (strcat pathdat2 "blts\\g262041.dat"))
	bas20d (findfile (strcat pathdat2 "blts\\s11371.dat"))
	bas21d (findfile (strcat pathdat2 "blts\\s6958.dat"))
	bas22d (findfile (strcat pathdat2 "blts\\s10450.dat"))
	bas23d (findfile (strcat pathdat2 "blts\\s6402n.dat"))
	bas24d (findfile (strcat pathdat2 "blts\\s6402l.dat"))
	bas25d (findfile (strcat pathdat2 "blts\\s6402t.dat"))
	bas26d (findfile (strcat pathdat2 "blts\\s6402ot.dat"))
	bas27d (findfile (strcat pathdat2 "blts\\s10906.dat"))
	bas37d (findfile (strcat pathdat2 "blts\\s262042.dat"))
	bas28d (findfile (strcat pathdat2 "blts\\sh2039d1.dat"))
	bas29d (findfile (strcat pathdat2 "blts\\sh2039d2.dat"))
	bas30d (findfile (strcat pathdat2 "blts\\sh2039d3.dat"))
	bas31d (findfile (strcat pathdat2 "blts\\sh2040.dat"))
	bas32d (findfile (strcat pathdat2 "blts\\sh2040pr.dat"))
	bas33d (findfile (strcat pathdat2 "blts\\sh2040p2.dat"))
	bas38d (findfile (strcat pathdat2 "blts\\sh22032.dat"))
	bas39d (findfile (strcat pathdat2 "blts\\sh22034.dat"))
	bas40d (findfile (strcat pathdat2 "blts\\sh22036.dat"))
	bas41d (findfile (strcat pathdat2 "blts\\sh22038.dat"))
	bas42d (findfile (strcat pathdat2 "blts\\sh22040.dat"))
	bas43d (findfile (strcat pathdat2 "blts\\sh22042.dat"))
  ) ;_ end of setq

  (load dvt1)
  (load dvt2)
  (load dvt3)
  (load dvt4)
  (load dvt5)
  (load anbl)

;;;      KRPZ.D 
  (defun rdfl ()
     (setq fld (open dat1 "r")
	   strd (read-line fld)
	   strdd (read strd)	   
	   p1 (itoa (nth 0 strdd))
	   p2 (itoa (nth 1 strdd))
	   angl (rtos (nth 2 strdd))
	   mash (rtos (nth 3 strdd))
     )
    (close fld)
    
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
    
    (set_tile "per1" p1)
    (if (eq p1 "0")
           (progn
	          (mode_tile "xcor" 0)
	          (mode_tile "ycor" 0)
	    )
     ) 
    
    (set_tile "per2" p2)
    (if (eq p2 "0")
          (mode_tile "Angl" 0)
    )
    
    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_ end of defun

;;;       KRPZ.D
  (defun wrfl ()
      (if (eq p1 nil) (setq p1 "1"))
      (if (eq p2 nil) (setq p2 "1"))

      (if (eq mash nil) (setq mash "1"))

      (if (eq angl nil) (setq angl "0"))		
     (setq fld (open dat1 "w")
	   strd (strcat "(" p1 " " p2 " " angl " " mash ")")
     )
     (write-line strd fld)
     (close fld)
  )  ;_ end of defun

  (defun show_im2 (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_ end of setq
    (start_image "image")
    (fill_image 0 0 orx aby 444)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_ end of defun


  (defun name ()
    (cond
      ((and (eq vk_rp "0")
	    (eq glv1 "1")
	    (eq vsb1 "0")
	    (eq vsv1 "0")
	    (or	(eq pr_fl nil)
		(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
	    ) ;_ end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(1).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (or	(eq pr_fl nil)
		(eq pr_fl "0")
	    ) ;_ end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(4).slb")
       ) ;_ end of setq
      )
      ((and (or (eq vk_rp "1") (eq vk_rp "3"))
	    (eq glv1 "0")
	    (eq vsb1 "1")
	    (eq vsv1 "0")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "7")
	    ) ;_ end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(17).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "1")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(6).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "2")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(8).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "3")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(9).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "4")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(10).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "5")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(11).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (eq pr_fl "4")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(12).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (eq pr_fl "5")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(13).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (or (eq pr_fl "0") (eq pr_fl "2") (eq pr_fl "3"))
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(5).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "1")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (eq pr_fl "1")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(7).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "0")
	    (eq glv1 "0")
	    (eq vsb1 "1")
	    (eq vsv1 "0")
	    (or	(eq pr_fl nil)
		(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
	    ) ;_ end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(2).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "0")
	    (eq glv1 "0")
	    (eq vsb1 "0")
	    (eq vsv1 "1")
	    (or	(eq pr_fl nil)
		(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
	    ) ;_ end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(3).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "2")
	    (eq glv1 "1")
	    (eq vsb1 "0")
	    (eq vsv1 "0")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "7")
		(eq pr_fl "8")
		(eq pr_fl "9")
		(eq pr_fl "10")
		(eq pr_fl "11")
	    ) ;_end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(14).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "2")
	    (eq glv1 "0")
	    (eq vsb1 "1")
	    (eq vsv1 "0")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "7")
		(eq pr_fl "8")
		(eq pr_fl "9")
		(eq pr_fl "10")
		(eq pr_fl "11")
	    ) ;_end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(15).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "2")
	    (eq glv1 "0")
	    (eq vsb1 "0")
	    (eq vsv1 "1")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "7")
		(eq pr_fl "8")
		(eq pr_fl "9")
		(eq pr_fl "10")
		(eq pr_fl "11")
	    ) ;_end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(16).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "3")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "8")
	    ) ;_end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(18).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "3")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (or	(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(eq pr_fl "6")
	    ) ;_end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(20).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "3")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "8")
	    ) ;_end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(19).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "3")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "7")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(21).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "3")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (eq pr_fl "7")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\vnt(22).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "4")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (or (eq pr_fl "5")
		(eq pr_fl "9"))
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\shpl(1).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "4")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "10")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\shpl(4).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "4")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq pr_fl "11")
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\shpl(3).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "4")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (or (eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
	        (eq pr_fl "6")
		(eq pr_fl "7")
		(eq pr_fl "8"))
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\shpl(2).slb")
       ) ;_ end of setq
      )
      ((and (eq vk_rp "4")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "7")
		(eq pr_fl "8")
		(eq pr_fl "9")
		(eq pr_fl "10")
		(eq pr_fl "11")
	    ) ;_end of or
       ) ;_ end of and
       (setq name1
	      (strcat pathdat2 "blts\\shpl(5).slb")
       ) ;_ end of setq
      )
    ) ;_ end of cond
  ) ;_ end of defun

;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
   (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
   ) ;_  defun

;;;   -     
  (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
  );_  defun

  (defun show (/ dcl_id)
    (setq dcl_id
	   (load_dialog
	     krcl
	   ) ;_ end of load_dialog
    )

                                         ; DCL-
    (if	(not (new_dialog "krpz" dcl_id)) ; 
      (exit)    
    )					;(,   )

    (defun sn_def ()
      (setq glv1 "1"
	    vsb1 "0"
	    vsv1 "0"
	    rr	 "0"
      ) ;_ end of setq
    ) ;_ end of defun


    (defun name_fil ()
      (cond
	((and (eq vk_rp "0") (eq pr_fl "0")) (setq fil bas2d))
	((and (eq vk_rp "0") (eq pr_fl "1")) (setq fil bas3d))
	((and (eq vk_rp "0") (eq pr_fl "2")) (setq fil basd))
	((and (eq vk_rp "0") (eq pr_fl "3")) (setq fil bas1d))
	((and (eq vk_rp "0") (eq pr_fl "4")) (setq fil bas36d))
	((and (eq vk_rp "1") (eq pr_fl "0")) (setq fil bas4d))
	((and (eq vk_rp "1") (eq pr_fl "1")) (setq fil bas5d))
	((and (eq vk_rp "1") (eq pr_fl "2")) (setq fil bas6d))
	((and (eq vk_rp "1") (eq pr_fl "3")) (setq fil bas7d))
	((and (eq vk_rp "1") (eq pr_fl "4")) (setq fil bas9d))
	((and (eq vk_rp "1") (eq pr_fl "5")) (setq fil bas8d))
	((and (eq vk_rp "2") (eq pr_fl "0")) (setq fil bas10d))
	((and (eq vk_rp "2") (eq pr_fl "1")) (setq fil bas11d))
	((and (eq vk_rp "2") (eq pr_fl "2")) (setq fil bas12d))
	((and (eq vk_rp "2") (eq pr_fl "3")) (setq fil bas13d))
	((and (eq vk_rp "2") (eq pr_fl "4")) (setq fil bas14d))
	((and (eq vk_rp "2") (eq pr_fl "5")) (setq fil bas15d))
	((and (eq vk_rp "2") (eq pr_fl "6")) (setq fil bas16d))
	((and (eq vk_rp "2") (eq pr_fl "7")) (setq fil bas17d))
	((and (eq vk_rp "2") (eq pr_fl "8")) (setq fil bas18d))
	((and (eq vk_rp "2") (eq pr_fl "9")) (setq fil bas19d))
	((and (eq vk_rp "2") (eq pr_fl "10")) (setq fil bas34d))
	((and (eq vk_rp "2") (eq pr_fl "11")) (setq fil bas35d))
	((and (eq vk_rp "3") (eq pr_fl "0")) (setq fil bas20d))
	((and (eq vk_rp "3") (eq pr_fl "1")) (setq fil bas21d))
	((and (eq vk_rp "3") (eq pr_fl "2")) (setq fil bas22d))
	((and (eq vk_rp "3") (eq pr_fl "3")) (setq fil bas23d))
	((and (eq vk_rp "3") (eq pr_fl "4")) (setq fil bas24d))
	((and (eq vk_rp "3") (eq pr_fl "5")) (setq fil bas25d))
	((and (eq vk_rp "3") (eq pr_fl "6")) (setq fil bas26d))
	((and (eq vk_rp "3") (eq pr_fl "7")) (setq fil bas27d))
	((and (eq vk_rp "3") (eq pr_fl "8")) (setq fil bas37d))
	((and (eq vk_rp "4") (eq pr_fl "0")) (setq fil bas38d))
	((and (eq vk_rp "4") (eq pr_fl "1")) (setq fil bas39d))
	((and (eq vk_rp "4") (eq pr_fl "2")) (setq fil bas40d))
        ((and (eq vk_rp "4") (eq pr_fl "3")) (setq fil bas41d))
	((and (eq vk_rp "4") (eq pr_fl "4")) (setq fil bas42d))
	((and (eq vk_rp "4") (eq pr_fl "5")) (setq fil bas43d))
	((and (eq vk_rp "4") (eq pr_fl "6")) (setq fil bas28d))
	((and (eq vk_rp "4") (eq pr_fl "7")) (setq fil bas29d))
	((and (eq vk_rp "4") (eq pr_fl "8")) (setq fil bas30d))
        ((and (eq vk_rp "4") (eq pr_fl "9")) (setq fil bas31d))
	((and (eq vk_rp "4") (eq pr_fl "10")) (setq fil bas32d))
	((and (eq vk_rp "4") (eq pr_fl "11")) (setq fil bas33d))
      ) ;_ end of cond
    ) ;_ end of defun


    (defun desk_f ()
      
      (setq x	(open (name_fil) "r")
	    a	(read-line x)
	    aa	(read a)
	    a1	(nth 0 aa)
	    a2	(nth (1+ (atoi rr)) aa)
	    a3	(nth 0 a2)
	    a4	(nth 1 a2)
	    b	(read-line x)
	    bb	(read b)
	    b0	(nth 0 bb)
	    b1	(nth 1 bb)
	    b2	(nth 2 bb)
	    b12	(nth 12 bb)
      ) ;_ end of setq
    ) ;_ end of defun


    (defun spis	(/ ltb)
      (cond
	((eq vk_rp "0")
	 (setq ltb '(" 7798-70 .."
		     " 7796-70 ..  ."
		     " 7805-70 .."
		     " 7808-70 ..  ."
		     " 26-2037-77  .."
		    )
	 ) ;_ end of setq
	)
	((eq vk_rp "1")
	 (setq ltb '(" 1491-72  ."
		     " 17473-72  ."
		     " 17474-72  ."
		     " 17475-72  ."
		     " 1488-75  .  ."
		     " 11738-72  ."
		    )
	 ) ;_ end of setq
	)
	((eq vk_rp "2")
	 (setq ltb '(" 5915-70.."
		     " 5916-70..."
		     " 15521-70.. .. ."
		     " 15522-70... .. ."
		     " 5927-70.."
		     " 5929-70..."
		     " 2524-70.. .. ."
		     " 2526-70... .. ."
		     " 15524-70..."
		     " 5931-70.. ."
		     " 26-2038-77..  .."
		     " 26-2041-77.  .."
		    )
	 ) ;_ end of setq
	)
	((eq vk_rp "3")
	 (setq ltb '(" 11371-78 "
		     " 6958-78 "
		     " 10450-78 "
		     " 6402-70  "
		     " 6402-70  "
		     " 6402-70  "
		     " 6402-70   "
		     " 10906-78 "
		     " 26-2042-77  .."
		    )
	 ) ;_ end of setq
	) 
	 ((eq vk_rp "4")
	  (setq ltb '(" 22032(33)-76  . d"
		     " 22034(35)-76  . 1,25d"
		     " 22036(37)-76  . 1,6d"
		     " 22038(39)-76  . 2d"
		     " 22040(41)-76  . 2,5d"
		     " 22042(43)-76  .  ." 
		     " 26-2039-77  . d"
		     " 26-2039-77  . 1,25d"
		     " 26-2039-77  . 2d"
		     " 26-2040-77  .  "
		     " 26-2040-77  .  "
		     " 26-2040-77  .  "		     
		    )
	  ) ;_ end of setq
	 )
      ) ;_ end of cond
    ) ;_ end of defun

    (defun r_r ()
      (start_list "n")
      (mapcar 'add_list a1)
      (end_list)
    ) ;_ end of defun

    (defun d_r ()
      (start_list "l_bt")
      (mapcar 'add_list a3)
      (end_list)
    ) ;_ end of defun

    (defun s_r ()
      (start_list "s_bt")
      (mapcar 'add_list a4)
      (end_list)
    ) ;_ end of defun

    (defun chart ()
      (start_list "sprav")
      (mapcar 'add_list b12)
      (end_list)
    ) ;_ end of defun

    (defun lb_t	()
      (start_list "prfl")
      (mapcar 'add_list (spis))
      (end_list)
    ) ;_ end of defun


    
    (if	(action_tile "vkrp" "")
      (progn
	(mode_tile "glv" 0)
	(mode_tile "vsb" 0)
	(mode_tile "vsv" 0)
	(setq vk_rp "0"
	      pr_fl "0"
	) ;_ end of setq
	(sn_def)
	(desk_f)
	(r_r)
	(d_r)
	(s_r)
	(chart)
	(lb_t)
	(show_im2 (name))
      ) ;_ end of progn
    ) ;_ end of if
    
    (defun clos_x ()
      (close x)
      (desk_f)
    ) ;_ end of defun

    (defun whl ()
      (if (or (< (atof rr) (atof b0))
	      (< (atof rs) (atof b2))
	      (< (atof rl) (atof b1))
	  ) ;_ end of or
	(clos_x)
      ) ;_ end of if
      (while (or (/= (atof rr) (atof b0))
		 (/= (atof rs) (atof b2))
		 (/= (atof rl) (atof b1))
	     ) ;_ end of or
	(setq b	  (read-line x)
	      bb  (read b)
	      b0  (nth 0 bb)
	      b1  (nth 1 bb)
	      b2  (nth 2 bb)
	      b12 (nth 12 bb)
	) ;_ end of setq
      ) ;_ end of while
    ) ;_ end of defun


    (defun hlp ()
      (set_tile "help" ": >>>")
    ) ;_ end of defun

    (defun vkr ()
      (cond ((and (eq vk_rp "0")
		  (or (eq glv1 "1") (eq vsb1 "1"))
		  (eq vsv1 "0")
	     ) ;_ end of and
	     (progn
	       (mode_tile "vsb" 0)
	       (mode_tile "l_bt" 0)
	       (mode_tile "s_bt" 0)
	     ) ;_end of progn
	    )
	    ((and (eq vk_rp "0")
		  (eq glv1 "0")
		  (eq vsb1 "0")
		  (eq vsv1 "1")
	     ) ;_ end of and
	     (progn
	       (mode_tile "vsb" 0)
	       (mode_tile "l_bt" 1)
	       (mode_tile "s_bt" 1)
	     ) ;_ end of progn
	    )
	    ((and (eq vk_rp "1")
		  (or (eq glv1 "1") (eq vsb1 "1"))
		  (eq vsv1 "0")
	     ) ;_ end of and
	     (progn
	       (mode_tile "vsb" 1)
	       (mode_tile "l_bt" 0)
	       (mode_tile "s_bt" 0)
	     ) ;_end of progn
	    )
	    ((and (eq vk_rp "1")
		  (eq glv1 "0")
		  (eq vsb1 "0")
		  (eq vsv1 "1")
	     ) ;_ end of and
	     (progn
	       (mode_tile "vsb" 1)
	       (mode_tile "l_bt" 1)
	       (mode_tile "s_bt" 1)
	     ) ;_ end of progn
	    )
	    ((and (eq vk_rp "2")
		  (or (eq glv1 "1") (eq vsb1 "1"))
		  (eq vsv1 "0")
	     ) ;_ end of and
	     (progn
	       (mode_tile "vsb" 0)
	       (mode_tile "l_bt" 1)
	       (mode_tile "s_bt" 1)
	     ) ;_ end of progn
	    )
	    ((and (eq vk_rp "2")
		  (eq glv1 "0")
		  (eq vsb1 "0")
		  (eq vsv1 "1")
	     ) ;_ end of and
	     (progn
	       (mode_tile "vsb" 0)
	       (mode_tile "l_bt" 1)
	       (mode_tile "s_bt" 0)
	     ) ;_ end of progn
	    )
	    ((eq vk_rp "3")
	     (progn
	       (mode_tile "vsb" 1)
	       (mode_tile "l_bt" 1)
	       (mode_tile "s_bt" 1)
	     ) ;_end of progn
	    )
	    ((and (eq vk_rp "4")
		  (eq glv1 "1")
		  (eq vsb1 "0")
		  (eq vsv1 "0")
	     ) ;_ end of and
	     (progn
	       (mode_tile "vsb" 1)
	       (mode_tile "l_bt" 0)
	       (mode_tile "s_bt" 0)
	     ) ;_end of progn
	    )
	    ((eq vk_rp "4")
	     (progn
	       (mode_tile "vsb" 1)
	       (mode_tile "l_bt" 1)
	       (mode_tile "s_bt" 1)
	     ) ;_ end of progn
	    )
      ) ;_end of cond
    ) ;_end of defun VKR


;;;      
  (defun pred (/ k)
    (if (eq shpr "1")
         (setq k 10)
         (setq k 9)
    )  
    (setq dmt (nth 3 bb)
	  dvt (nth k bb)
	  mb  (atof mash)
    ) ;_  setq
    (if	(< (* (/ (- dmt dvt) 2) mb) 0.6)
      (set_tile	"Pred"
		"!     "
      ) ;_  set_tile
      (set_tile	"Pred"
		""
      ) ;_  set_tile
    ) ;_  if
  ) ;_  defun

    (action_tile
      "vkrp"
      (strcat
	"(progn (setq vk_rp (get_tile \"vkrp\"))"
	"(vkr)"
	"(setq pr_fl \"0\")"
	"(sn_def)"
	"(desk_f)"
	"(r_r)"
	"(d_r)"
	"(s_r)"
	"(lb_t)"
	"(chart)"
	"(setq glv1 (get_tile \"glv\"))"
	"(setq vsb1 (get_tile \"vsb\"))"
	"(setq vsv1 (get_tile \"vsv\"))"
	"(show_im2 (name)))"
	"(hlp)"
      ) ;_ end of strcat
    ) ;_ end of action_tile



    (action_tile
      "prfl"
      (strcat
	"(progn (setq pr_fl (get_tile \"prfl\") rr \"0\")"
	"(desk_f)"
	"(r_r)"
	"(d_r)"
	"(s_r)"
	"(chart)"
	"(show_im2 (name)))"
	"(hlp)"
      ) ;_ end of strcat
    ) ;_ end of action_tile


    (defun rl_rs ()
      (setq rl "0"
	    rs "0"
      ) ;_ end of setq
    ) ;_ end of defun


    (action_tile
      "n"
      (strcat
	"(progn (sel_view)"
	"(rl_rs)"
	"(desk_f)"
	"(whl)"
	"(chart))"
	"(hlp)"
	"(d_r)"
	"(s_r)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "l_bt"
      (strcat
	"(progn (sel_view)"
	"(whl)"
	"(chart))"
	"(hlp)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (if	(action_tile "l_tb" "")
      (setq rl "0")
    ) ;_ end of if

    (action_tile
      "s_bt"
      (strcat
	"(progn (sel_view)"
	"(whl))"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (if	(action_tile "s_tb" "")
      (setq rs "0")
    ) ;_ end of if

    (defun sel_view ()
      (setq rr	 (get_tile "n")
	    rl	 (get_tile "l_bt")
	    rs	 (get_tile "s_bt")
	    vsb1 (get_tile "vsb")
	    glv1 (get_tile "glv")
	    vsv1 (get_tile "vsv")
      ) ;_ end of setq
    ) ;_ end of defun

    (action_tile
      "glv"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(vkr)"
      ) ;_ end of strcat 
    ) ;_ end of action_tile


    (action_tile
      "vsb"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(vkr)"
      ) ;_ end of strcat
    ) ;_ end of action_tile


    (action_tile
      "vsv"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(vkr)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

   
    
    (defun notes ()
      (cond
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq vk_rp "0")
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
	      ) ;_ end of or
	      (eq vk_rp "2")
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" ": >>>  ")
	)
	((and (eq pr_fl "7")
	      (eq vk_rp "3")
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (eq pr_fl "7")
	      (eq vk_rp "3")
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
	      ) ;_ end of or
	      (eq vk_rp "3")
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" ": >>>  ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
	      ) ;_ end of or
	      (eq vk_rp "3")
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" ": >>>  ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
	      ) ;_ end of or
	      (eq vk_rp "1")
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
	      ) ;_ end of or
	      (or (eq vk_rp "0")
		  (eq vk_rp "1")
		  (eq vk_rp "2")
	      ) ;_end of or
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
	      ) ;_ end of or
	      (eq vk_rp "1")
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" ": >>>    ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq vk_rp "0")
	      (eq spr "2")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
	      ) ;_ end of or
	      (eq vk_rp "1")
	      (eq spr "2")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
	      ) ;_ end of or
	      (eq vk_rp "2")
	      (eq spr "2")
	 ) ;_ end of and
	 (set_tile "help" ": >>>  ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
	      ) ;_ end of or
	      (or (eq vk_rp "0")
		  (eq vk_rp "1")
	      ) ;_ end of or
	      (eq spr "3")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
	      ) ;_ end of or
	      (eq vk_rp "4")
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" ": >>>    ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "11")
	      ) ;_ end of or
	      (eq vk_rp "4")
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" ": >>>    ")
	)
	((and (eq pr_fl "10")
	      (eq vk_rp "4")
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" ": >>>  ")
	)
	((and (eq pr_fl "11")
	      (eq vk_rp "4")
	      (eq spr "2")
	 ) ;_ end of and
	 (set_tile "help" ": >>>  ")
	)
	((and (eq pr_fl "10")
	      (eq vk_rp "4")
	      (eq spr "2")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
	((and (eq pr_fl "11")
	      (eq vk_rp "4")
	      (eq spr "3")
	 ) ;_ end of and
	 (set_tile "help" ": >>>   ")
	)
      ) ;_ end of cond
    ) ;_ end of defun

    (action_tile
      "sprav"
      (strcat
	"(setq spr (get_tile \"sprav\"))"
	"(notes)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (defun okey	()
      (if (and
	    (or (/= vk_rp "1") (/= vsb1 "1"))
	    (or (/= vk_rp "3") (/= vsb1 "1"))
	    (or (/= vk_rp "4") (/= vsb1 "1"))
	  ) ;_end of and
	(progn (done_dialog) (close x))
      ) ;_ end of if
    ) ;_ end of defun


    (action_tile
      "accept"
      (strcat
      "(okey)"
      )
    ) ;_ end of action_tile


    (action_tile
      "cancel"
      (strcat "(progn (setq rr nil)" "(done_dialog))" "(close x)" "(exit)")
    ) ;_ end of action_tile


    (start_dialog)			;  
    
;;;   
  (defun ins1 ()
    
    (new_dialog "ins1" dcl_id)
    
    (rdfl)
;;;    (setq mb (atof mash))
    (pred)
    
    (action_tile "xcor" "(setq xc $value)")
    (action_tile "ycor" "(setq yc $value)")

    (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
    (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")
    
    (action_tile "per1"
        (strcat "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
	        "(mode_tile \"ycor\" 0)) (progn (mode_tile \"xcor\" 1)"
		"(mode_tile \"ycor\" 1) (setq xc nil yc nil) (set_tile \"xcor\" \"0\")"
		"(set_tile \"ycor\" \"0\")))"
        )  
    )
    (action_tile "per2"
         (strcat "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
                 "(progn (mode_tile \"Angl\" 1) (setq angl nil) (set_tile \"Angl\" \"0\")))")
    )  
    (action_tile "per3" "(setq p3 $value)")

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")

    (start_dialog)                     ;    
    
  ) ;_ end of defun      
    (ins1)
    (unload_dialog dcl_id)		; DCL-
    (prin1)
  )					;   show 
  (show)
  (wrfl)
  (setvar "USERR1" mb); 
  (cond	((and (eq vk_rp "0")
	      (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (/= rr nil)
	 ) ;_ end of and
	 (blts)
	)
	((and (eq vk_rp "1")
	      (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
	      ) ;_ end of or
	      (/= rr nil)
	 ) ;_ end of and
	 (vnts)
	)
	((and (eq vk_rp "2")
	      (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
	      ) ;_ end of or
	      (/= rr nil)
	 ) ;_ end of and
	 (gks)
	)
	((and (eq vk_rp "3")
	      (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
	      ) ;_ end of or
	      (/= rr nil)
	 ) ;_ end of and
	 (shb)
	)
	((and (eq vk_rp "4")
	      (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
	      ) ;_ end of or
	      (/= rr nil)
	 ) ;_ end of and
	 (shpl)
	)
  ) ;_ end of cond

  (prin1)

) ;_ end of defun



