;;;  
;;;:  ..
;;; : 31.07.2000
;;;CAD-CEE 2000

(defun shb (/	  cmd	blpm  apsz  osmd  dmt	sgb   sgb1  sgb2  label
	    sset  edat3	cpt   ept   cpt1  ept1	pt1   pt2   pt3	  pt4
	    pt5	  pt6	pt7   pt8   clay  cltp ccol   ang   a1    mb
	    inpt0
	   )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	dmt (nth 3 bb)
	sgb (nth 4 bb)
  ) ;_ end of setq

 ;;;   

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )
     (defun axs ()
          (command "_'layer" "_s" " " "")
      )


  (defun ris_sh	()

    (setq cpt inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)

;;;;;;;;;   
    (defun sh_gl_sb ()
      (cond ((or (eq pr_fl "0")
		 (eq pr_fl "1")
		 (eq pr_fl "2")
		 (eq pr_fl "3")
		 (eq pr_fl "4")
		 (eq pr_fl "5")
		 (eq pr_fl "6")
		 (eq pr_fl "8")
	     ) ;_end of or
	     (progn
	       (setq pt1 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dmt 2.0) mb))
		     pt2 (polar pt1 (+ 0 a1) (* sgb mb))
		     pt3 (polar pt2 (+ (/ pi 2) a1) (* dmt mb))
		     pt4 (polar pt3 (+ pi a1) (* sgb mb))
	       ) ;_ end of setq

	       (if (or (eq pr_fl "3")
		       (eq pr_fl "4")
		       (eq pr_fl "5")
		       (eq pr_fl "6")
		   ) ;_end of or
		 (setq cpt1 (polar cpt (+ (/ pi 9) a1) (* (/ sgb (cos (/ pi 9))) mb))
		       ept  (polar cpt (+ 0 a1) (* sgb mb))
		       ept1 (polar ept (+ (/ (* pi 10) 9) a1) (* (/ sgb (cos (/ pi 9))) mb))
		 ) ;_ end of setq
	       ) ;_end of if
	     ) ;_end of progn
	    )

	    ((eq pr_fl "7")
	     (setq sgb1	(nth 5 bb)
		   sgb2	(nth 6 bb)
		   ept	(polar cpt (+ 0 a1) (* sgb mb))
		   pt1	(polar ept (+ (/ (* pi 3) 2) a1) (* (/ dmt 2) mb))
		   pt2	(polar ept (+ (/ pi 2) a1) (* (/ dmt 2) mb))
		   pt3	(polar pt2 (+ pi a1) (* sgb1 mb))
		   pt4	(polar pt1 (+ pi a1) (* sgb2 mb))
	     ) ;_ end of setq
	    )
      ) ;_end of cond



      (osn)
      (command "_line" pt1 pt2 "")
      (setq label (entlast)
	    sset  (ssadd (entlast))
      ) ;_ end of setq
      (command "_line"
	       pt2
	       pt3
	       pt4
	       pt1
	       ""
      ) ;_ end of command
      (if (or (eq pr_fl "3")
	      (eq pr_fl "4")
	      (eq pr_fl "5")
	      (eq pr_fl "6")
	  ) ;_end of or
	(command "_line"
		 cpt
		 cpt1
		 ""
		 "_line"
		 ept
		 ept1
		 ""
	) ;_end of command
      ) ;_end of if

    ) ;_ end of defun SH_GL_SB


;;;;;;;  
    (defun sh_vs ()

      (setq pt1	(polar cpt (+ (/ pi 4) a1) (* (* dmt (sqrt 0.5)) mb))
	    pt2	(polar pt1 (+ pi a1) (* dmt mb))
	    pt3	(polar pt2 (+ (/ (* pi 3) 2) a1) (* dmt mb))
	    pt4	(polar pt3 (+ 0 a1) (* dmt mb))
	    pt5	(polar cpt (+ 0 a1) (* (+ (/ dmt 2.0) 3.0) mb))
	    pt6	(polar cpt (+ pi a1) (* (+ (/ dmt 2.0) 3.0) mb))
	    pt7	(polar cpt (+ (/ pi 2) a1) (* (+ (/ dmt 2.0) 3.0) mb))
	    pt8	(polar cpt (+ (/ (* pi 3) 2) a1) (* (+ (/ dmt 2.0) 3.0) mb))
      ) ;_end of setq        

      (osn)
      (if (or (eq pr_fl "0")
	      (eq pr_fl "1")
	      (eq pr_fl "2")
	      (eq pr_fl "3")
	      (eq pr_fl "4")
	      (eq pr_fl "5")
	      (eq pr_fl "6")
	      (eq pr_fl "8")
	  ) ;_end of or
	(progn
	  (command "_circle" cpt (* (/ dmt 2.0) mb))
	  (setq label (entlast))
	  (setq sset (ssadd (entlast)))
	) ;_end of progn
	(progn
	  (command "_line" pt1 pt2 "")
	  (setq label (entlast))
	  (setq sset (ssadd (entlast)))
	  (command "_line" pt2 pt3 pt4 pt1 "")
	  (axs)
	  (command "_line" pt5 pt6 "" "_line" pt7 pt8 "")
	) ;_end of progn
      ) ;_end of if

    ) ;_ end of defun
;;; _end of   SH_VS

    (cond
      ((and (eq glv1 "1") (eq vsv1 "0"))
       (sh_gl_sb)
      )
      ((and (eq glv1 "0") (eq vsv1 "1")) (sh_vs))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun RIS_SH


  (defun clip_bl ()

      (initget 1)
      (if (eq p1 "1")
	(setq inpt0 (getpoint "\n  :"))
	(setq inpt0 (list (atof xc) (atof yc)))
      ) ;_  if
      (if (eq p2 "1")
	(progn
	  (setq	a1
		 (getangle inpt0
			   (strcat "\n   <" angl ">:")
		 ) ;_  getangle
	  ) ;_  setq
	  (if (= a1 nil)
	    (setq a1 (atof angl))
	  ) ;_  if
	) ;_  progn
	(setq a1 (* pi (/ (atof angl) 180)))
      ) ;_  if 
      (setq mb (atof mash))

      (ris_sh)

      (if (eq p3 "0")
	(anblk sset cpt)
      ) ;_  if

      (setvar "celtype" cltp)
      (setvar "cecolor" ccol)
      (setvar "aperture" apsz)
      (setvar "osmode" osmd)
      (setvar "clayer" clay)
    ) ;_ end of defun

  (clip_bl)
  (prin1)
) ;_ end of defun SHB
