;;;  
;;;:  ..
;;; : 04.10.2000
;;;CAD-CEE 2000


(defun vnts (/	    dmt	   dln	  dln1	 dgb	sgb    hgb    dvt
	     fsk    rsp	   cmd	  blpm	 apsz	osmd   dgb1   hgb1
	     hnb    h1gb   rgb	  tgb	 tgbt	tg1bt  tgbn   edat3
	     label  sset   cpt	  pt0	 pto1	pto2   pt1    pt2
	     pt3    pt4	   pt5	  pt6	 pt7	pt8    pt9    pt10
	     pt11   pt12   pt7-1  pt8-1	 cpt1v	pt2-2  pt2-3  pt2-4
	     pt3-2  pt3-3  pt3-4  pt14	 pt14-1	pt14-2 pt15   pt16
	     pt17   pt18   pt19	  pt19-1 pt19-2	pt20   pt21   pt22
	     pt23   pt24   pt25   clay   cltp   ccol   ang    mb
	     inpt0  a1     zam
	    )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	dmt  (nth 3 bb)
	dln  (nth 4 bb)
	dln1 (nth 5 bb)
	dgb  (nth 6 bb)
	sgb  (nth 7 bb)
	hgb  (nth 8 bb)
	dvt  (nth 9 bb)
	fsk  (nth 10 bb)
	rsp  (nth 11 bb)
  ) ;_ end of setq
  (cond	((eq pr_fl "4")
	 (setq dgb1 (nth 13 bb)
	       hgb1 (nth 14 bb)
	 ) ;_ end of setq
	)
	((eq pr_fl "5") (setq dgb1 (nth 13 bb)))
  ) ;_ end of cond

 ;;;   

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )
     (defun axs ()
          (command "_'layer" "_s" " " "")
      )
     (defun ton ()
          (command "_'layer" "_s" "" "")
      )



  (defun ris_blt ()

    (setq cpt inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)

;;;;;;;;;;;;;;;;;;;;;;  ;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    (defun bl_gl_sb ()


      (defun acsl ()
	(if (eq pr_fl "4")
	  (setq	hgb1 (nth 14 bb)
		pto1 (polar cpt (+ pi a1) (* (+ hgb hgb1 2.00) mb))
	  ) ;_ end of setq
	  (setq pto1 (polar cpt (+ pi a1) (* (+ hgb 2.00) mb)))
	) ;_ end of if
	(setq pto2 (polar cpt (+ 0 a1) (* (+ dln 2.00) mb))
	) ;_ end of setq
	(axs)
	(command "_line" pto1 pto2 "")	;   
	(setq label (entlast)
	      sset  (ssadd (entlast))
	) ;_ end of setq
      ) ;_ end of defun

      (acsl)

;;;;;;;;;;;    1491;;;;;;;;;;;;;;;;;

      (defun gbgl ()
	(setq hnb (nth 13 bb)
	      pt1 (polar cpt (+ (/ pi 2) a1) (* (/ dgb 2.00) mb))
	      pt2 (polar pt1 (+ pi a1) (* hgb mb))
	      pt3 (polar pt2
			 (+ (/ (* pi 3) 2) a1)
			 (* (/ (- dgb sgb) 2.00) mb)
		  ) ;_ end of polar
	      pt4 (polar pt3 (+ 0 a1) (* hnb mb))
	      pt5 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dgb 2.00) mb))
	      pt6 (polar pt5 (+ pi a1) (* hgb mb))
	      pt7 (polar pt6
			 (+ (/ pi 2) a1)
			 (* (/ (- dgb sgb) 2.00) mb)
		  ) ;_ end of polar
	      pt8 (polar pt7 (+ 0 a1) (* hnb mb))
	) ;_end of setq

	(osn)
	(command "_line"
		 pt1
		 pt2
		 pt3
		 pt4
		 pt8
		 pt7
		 pt6
		 pt5
		 pt1
		 ""
	)				;      1491 
      ) ;_ end of defun

;;;;;;;;;;;    11738;;;;;;;;;;;;;;;;;

      (defun grgl ()
	(setq pt1 (polar cpt (+ (/ pi 2) a1) (* (/ dgb 2.00) mb))
	      pt2 (polar pt1 (+ pi a1) (* hgb mb))
	      pt3 (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dgb 2.00) mb))
	      pt4 (polar pt3 (+ pi a1) (* hgb mb))
	) ;_end of setq

	(osn)
	(command "_line"
		 pt4
		 pt3
		 pt1
		 pt2
		 pt4
		 ""
	)				;      11738 
      ) ;_ end of defun

;;;;;;;;    17473;;;;;;;;;;;;;;;;;;;

      (defun gbbv ()
	(setq hnb  (nth 13 bb)
	      h1gb (nth 14 bb)
	      rgb  (nth 15 bb)
	      pt0  (polar cpt (+ pi a1) (* hgb mb))
	      pt1  (polar cpt (+ (/ pi 2) a1) (* (/ dgb 2.00) mb))
	      pt2  (polar pt1 (+ pi a1) (* h1gb mb))
	      pt3  (polar pt0 (+ (/ pi 2) a1) (* (/ sgb 2.00) mb))
	      pt4  (polar pt3 (+ 0 a1) (* hnb mb))
	      pt5  (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dgb 2.00) mb))
	      pt6  (polar pt5 (+ pi a1) (* h1gb mb))
	      pt7  (polar pt0 (+ (/ (* pi 3) 2) a1) (* (/ sgb 2.00) mb))
	      pt8  (polar pt7 (+ 0 a1) (* hnb mb))
	) ;_ end of setq
	(osn)
	(command "_line"
		 pt2
		 pt1
		 pt5
		 pt6
		 ""
		 "_line"
		 pt7
		 pt8
		 pt4
		 pt3
		 ""
		 "_arc"
		 pt2
		 "_e"
		 pt3
		 "_r"
		 (* rgb mb)
		 "_arc"
		 pt7
		 "_e"
		 pt6
		 "_r"
		 (* rgb mb)
	)				;    
      ) ;_ end of defun
;;;;;;;;;;;;;    17474  17475;;;;;;;;;;;;;
      (defun gb1bv ()
	(setq hgb1 (nth 13 bb)
	      h1gb (nth 14 bb)
	      pt1  (polar cpt (+ (/ pi 2) a1) (* (/ dgb 2.00) mb))
	      pt2  (polar pt1 (+ 0 a1) (* h1gb mb))
	      pt3  (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dgb 2.00) mb))
	      pt4  (polar pt3 (+ 0 a1) (* h1gb mb))
	      pt5  (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ sgb 2.00) mb))
	      pt6  (polar cpt (+ (/ pi 2) a1) (* (/ sgb 2.00) mb))
	      pt9  (polar pt4 (+ (/ pi 4) a1) (* (* (/ (- dgb dmt) 2.00) (sqrt 2.00)) mb))
	      pt10 (polar pt2
			  (+ (* (/ pi 4) 7) a1)
			  (* (* (/ (- dgb dmt) 2.00) (sqrt 2.00)) mb)
		   ) ;_ end of polar
	) ;_ end of setq
	(cond ((eq pr_fl "2")
	       (setq rgb (nth 15 bb)
		     pt7 (polar pt5 (+ pi a1) (* hgb mb))
		     pt8 (polar pt6 (+ pi a1) (* hgb mb))
	       ) ;_ end of setq
	      )
	      ((eq pr_fl "3")
	       (setq pt7   (polar pt5 (+ 0 a1) (* h1gb mb))
		     pt8   (polar pt6 (+ 0 a1) (* h1gb mb))
		     pt7-1 (polar pt5 (+ 0 a1) (* hgb mb))
		     pt8-1 (polar pt6 (+ 0 a1) (* hgb mb))
	       ) ;_ end of setq
	      )
	) ;_end of cond
	(osn)
	(cond ((eq pr_fl "2")
	       (command	"_line"
			pt9
			pt10
			pt2
			pt1
			pt3
			pt4
			pt9
			""
			"_line"
			pt7
			pt5
			""
			"_line"
			pt6
			pt8
			""
			"_line"
			pt2
			pt4
			""
			"_arc"
			pt1
			"_e"
			pt8
			"_r"
			(* rgb mb)
			"_arc"
			pt7
			"_e"
			pt3
			"_r"
			(* rgb mb)
	       ) ;_ end of command
	      )
	      ;;    17474 
	      ((eq pr_fl "3")
	       (command	"_line"
			pt7
			pt4
			pt3
			pt5
			pt7-1
			pt8-1
			pt8
			pt2
			pt1
			pt6
			pt8
			""
			"_line"
			pt2
			pt10
			pt9
			pt4
			""
	       ) ;_ end of command
	      )
	      ;;    17475 
	) ;_end of cond
      ) ;_end of defun

;;;;;;;;;;;;;    1488-75;;;;;;;;;;;;;;;;;;;;;;;;
      (defun gb2bv ()
	(setq pt1   (polar cpt (+ (/ pi 2.00) a1) (* (/ dgb1 2.00) mb))
	      pt2   (polar pt1 (+ pi a1) (* hgb1 mb))
	      pt3   (polar pt2 (+ (/ (* pi 3) 2) a1) (* dgb1 mb))
	      pt4   (polar pt3 (+ 0 a1) (* hgb1 mb))
	      cpt1v (polar cpt (+ pi a1) (* hgb1 mb))
	      pt5   (polar cpt1v (+ (/ pi 2.00) a1) (* (/ dgb 2.00) mb))
	      pt6   (polar
		      pt5
		      (+ pi a1)
		      (* (- hgb
			 (/ (- (/ dgb 2.00) (* sgb 0.45)) (cos (/ pi 6)) 2.00)
		      ) mb) ;_ end of *
		    ) ;_ end of polar
	      pt7   (polar pt6
			   (+ (/ (* pi 4) 3) a1)
			   (* (/ (- (/ dgb 2.00) (* sgb 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	      pt10  (polar cpt1v (+ (/ (* pi 3) 2) a1) (* (/ dgb 2.00) mb))
	      pt9   (polar
		      pt10
		      (+ pi a1)
		      (* (- hgb
			 (/ (- (/ dgb 2.00) (* sgb 0.45)) (cos (/ pi 6)) 2.00)
		      ) mb) ;_ end of *
		    ) ;_ end of polar
	      pt8   (polar pt9
			   (+ (/ (* pi 2) 3) a1)
			   (* (/ (- (/ dgb 2.00) (* sgb 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	      tgb   (/ (* (sqrt (- 1 (/ (expt sgb 2) (expt dgb 2)))) dgb) sgb)
	      tgbt  (atan tgb)
	      pt2-2 (polar cpt1v
			   (+ (/ pi 2) a1)
			   (* (* (/ dgb 2.00) (sin (- (/ pi 4) tgbt))) mb)
		    ) ;_ end of polar
	      pt2-3 (polar pt2-2
			   (+ pi a1)
			   (* (- hgb
			      (/ (- (/ dgb 2.00) (* sgb 0.45))
				 (cos (/ pi 6))
				 2.00
			      ) ;_ end of /
			   ) mb) ;_ end of *
		    ) ;_ end of polar
	      pt2-4 (polar pt2-3
			   (+ (/ (* pi 4) 6) a1)
			   (* (/ (- (/ dgb 2.00) (* sgb 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	      pt3-2 (polar cpt1v
			   (+ (/ (* pi 3) 2) a1)
			   (* (* (/ dgb 2.00) (sin (- (/ pi 4) tgbt))) mb)
		    ) ;_ end of polar
	      pt3-3 (polar pt3-2
			   (+ pi a1)
			   (* (- hgb
			      (/ (- (/ dgb 2.00) (* sgb 0.45))
				 (cos (/ pi 6))
				 2.00
			      ) ;_ end of /
			   ) mb) ;_ end of *
		    ) ;_ end of polar
	      pt3-4 (polar pt3-3
			   (+ (/ (* pi 8) 6) a1)
			   (* (/ (- (/ dgb 2.00) (* sgb 0.45)) (cos (/ pi 6))) mb)
		    ) ;_ end of polar
	) ;_ end of setq
	(osn)
	(command "_line"
		 pt1
		 pt2
		 pt3
		 pt4
		 pt1
		 ""
		 "_line"
		 pt5
		 pt6
		 pt7
		 pt8
		 pt9
		 pt10
		 ""
		 "_line"
		 pt2-2
		 pt2-3
		 pt3-3
		 pt3-2
		 ""
		 "_line"
		 pt2-4
		 pt2-3
		 ""
		 "_line"
		 pt3-4
		 pt3-3
		 ""
	) ;_ end of command
	;;    1488 
      ) ;_ end of defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;   ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

      (defun strg ()
	(setq hgb1 (nth 13 bb))
	(cond ((or (eq pr_fl "0")
		   (eq pr_fl "1")
		   (eq pr_fl "4")
		   (eq pr_fl "5")
	       ) ;_ end of or
		(setq pt14   (polar cpt (+ (/ (* pi 3) 2) a1) (* (/ dmt 2.00) mb))
		      pt14-1 (polar cpt (+ (/ (* pi 3) 2) a1) (* (+ (/ dmt 2.00) rsp) mb))
		      pt14-2 (polar pt14-1 (+ (/ pi 4) a1) (* (/ rsp (cos (/ pi 4))) mb))
		      pt15   (polar pt14 (+ 0 a1) (* (- dln fsk) mb))
		      pt16   (polar pt15 (+ (/ pi 4) a1) (* (* fsk (sqrt 2.00)) mb))
		      pt19   (polar cpt (+ (/ pi 2) a1) (* (/ dmt 2.0000) mb))
		      pt19-1 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dmt 2.00) rsp) mb))
		      pt19-2 (polar pt19-1
				    (+ (/ (* pi 7) 4) a1)
				    (* (/ rsp (cos (/ pi 4))) mb)
			     ) ;_  polar
		      pt18   (polar pt19 (+ 0 a1) (* (- dln fsk) mb))
		      pt17   (polar pt18 (+ (/ (* pi 7) 4) a1) (* (* fsk (sqrt 2.00)) mb))
		      pt20   (polar pt14 (+ 0 a1) (* (- dln dln1) mb))
		      pt21   (polar pt19 (+ 0 a1) (* (- dln dln1) mb))
		) ;_ end of setq
		(if (< (* (/ (- dmt dvt) 2) mb) 0.6)
		  (progn
		    (setq dvt (- dmt (/ (* 2 0.6) mb)))
		    (if	(> (/ (- dmt dvt) 2) fsk)
		      (setq zam dln1)
		      (setq zam (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)))
		    ) ;_  if
		    (setq pt22 (polar pt21
				      (+ (/ (* pi 3) 2) a1)
				      (* (/ (- dmt dvt) 2.00) mb)
			       ) ;_  polar
			  pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			  pt24 (polar pt22 (+ 0 a1) (* zam mb))
			  pt25 (polar pt23 (+ 0 a1) (* zam mb))
		    ) ;_  setq
		  ) ;_  progn
		  (setq	pt22 (polar pt21
				    (+ (/ (* pi 3) 2) a1)
				    (* (/ (- dmt dvt) 2.00) mb)
			     ) ;_  polar
			pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			pt24 (polar pt22
				    (+ 0 a1)
				    (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
			     ) ;_  polar
			pt25 (polar pt23
				    (+ 0 a1)
				    (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
			     ) ;_  polar
		  ) ;_  setq
		) ;_  if
	      )
	      ((eq pr_fl "2")
		(setq pt15 (polar pt9 (+ 0 a1) (* (- (+ dln hgb) (+ hgb1 fsk)) mb))
		      pt16 (polar pt15 (+ (/ pi 4) a1) (* (* fsk (sqrt 2.00)) mb))
		      pt18 (polar pt10 (+ 0 a1) (* (- (+ dln hgb) (+ hgb1 fsk)) mb))
		      pt17 (polar pt18 (+ (/ (* pi 7) 4) a1) (* (* fsk (sqrt 2.00)) mb))
		      pt20 (polar pt9 (+ 0 a1) (* (- (+ dln hgb) dln1 hgb1) mb))
		      pt21 (polar pt10 (+ 0 a1) (* (- (+ dln hgb) dln1 hgb1) mb))
		) ;_end of setq
		(if (eq dln dln1)
		  (if (< (* (/ (- dmt dvt) 2) mb) 0.6)
		    (progn
		      (setq dvt (- dmt (/ (* 2 0.6) mb)))
		      (if (> (/ (- dmt dvt) 2.0) fsk)
			(setq zam (- dln h1gb (/ (- dgb dmt) 2.0)))
			(setq zam (+ (- dln1 fsk hgb1)
				     (/ (- dmt dvt) 2.00)
				     hgb
				  ) ;_  +
			) ;_  setq
		      ) ;_  if
		      (setq pt20 pt9
			    pt21 pt10
			    pt22 (polar	pt21
					(+ (/ (* pi 3) 2) a1)
					(* (/ (- dmt dvt) 2.00) mb)
				 ) ;_  polar
			    pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			    pt24 (polar pt22 (+ 0 a1) (* zam mb))
			    pt25 (polar pt23 (+ 0 a1) (* zam mb))
		      ) ;_  setq
		    ) ;_  progn
		    (setq pt20 pt9
			  pt21 pt10
		          pt22 (polar pt21
				      (+ (/ (* pi 3) 2) a1)
				      (* (/ (- dmt dvt) 2.00) mb)
			       ) ;_  polar
			  pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			  pt24 (polar pt22
				      (+ 0 a1)
				      (* (+ (- dln1 fsk hgb1)
					 (/ (- dmt dvt) 2.00)
					 hgb
				      ) mb) ;_  *
			       ) ;_  polar
			  pt25 (polar pt23
				      (+ 0 a1)
				      (* (+ (- dln1 fsk hgb1)
					 (/ (- dmt dvt) 2.00)
					 hgb
				      ) mb) ;_  *
			       ) ;_  polar
		    ) ;_  setq
		  ) ;_  if
		  (if (< (* (/ (- dmt dvt) 2) mb) 0.6)
		    (progn
		      (setq dvt (- dmt (/ (* 2 0.6) mb)))
		      (if (> (/ (- dmt dvt) 2) fsk)
			(setq zam dln1)
			(setq zam (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)))
		      ) ;_  if
		      (setq pt22 (polar	pt21
					(+ (/ (* pi 3) 2) a1)
					(* (/ (- dmt dvt) 2.00) mb)
				 ) ;_  polar
			    pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			    pt24 (polar pt22 (+ 0 a1) (* zam mb))
			    pt25 (polar pt23 (+ 0 a1) (* zam mb))
		      ) ;_  setq
		    ) ;_  progn
		    (setq pt22 (polar pt21
				      (+ (/ (* pi 3) 2) a1)
				      (* (/ (- dmt dvt) 2.00) mb)
			       ) ;_  polar
			  pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			  pt24 (polar pt22
				      (+ 0 a1)
				      (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
			       ) ;_  polar
			  pt25 (polar pt23
				      (+ 0 a1)
				      (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
			       ) ;_  polar
		    ) ;_  setq
		  ) ;_  if
		) ;_end of if
	      )
	      ((eq pr_fl "3")
	       (setq pt15 (polar pt9 (+ 0 a1) (* (- dln (+ hgb1 fsk)) mb))
		     pt16 (polar pt15 (+ (/ pi 4) a1) (* (* fsk (sqrt 2.00)) mb))
		     pt18 (polar pt10 (+ 0 a1) (* (- dln (+ hgb1 fsk)) mb))
		     pt17 (polar pt18 (+ (/ (* pi 7) 4) a1) (* (* fsk (sqrt 2.00)) mb))
		     pt20 (polar pt9 (+ 0 a1) (* (- dln dln1 hgb1) mb))
		     pt21 (polar pt10 (+ 0 a1) (* (- dln dln1 hgb1) mb))
	       ) ;_end of setq
	       (if (eq dln dln1)
		(if (< (* (/ (- dmt dvt) 2) mb) 0.6)
		  (progn
		    (setq dvt (- dmt (/ (* 2 0.6) mb)))
		    (if	(> (/ (- dmt dvt) 2) fsk)
		      (setq zam (- dln h1gb (/ (- dgb dmt) 2.0)))
		      (setq zam	(+ (- dln1 fsk hgb1)
				   (/ (- dmt dvt) 2.00)
				) ;_  +
		      ) ;_  setq
		    ) ;_  if
		    (setq pt20 pt9
			  pt21 pt10
		          pt22 (polar pt21
				      (+ (/ (* pi 3) 2) a1)
				      (* (/ (- dmt dvt) 2.00) mb)
			       ) ;_  polar
			  pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			  pt24 (polar pt22 (+ 0 a1) (* zam mb))
			  pt25 (polar pt23 (+ 0 a1) (* zam mb))
		    ) ;_  setq
		  ) ;_  progn
		  (setq pt20 pt9
			pt21 pt10
		        pt22 (polar pt21
				    (+ (/ (* pi 3) 2) a1)
				    (* (/ (- dmt dvt) 2.00) mb)
			     ) ;_  polar
			pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			pt24 (polar pt22
				    (+ 0 a1)
				    (* (+ (- dln1 fsk hgb1)
				       (/ (- dmt dvt) 2.00)
				    ) mb) ;_  *
			     ) ;_  polar
			pt25 (polar pt23
				    (+ 0 a1)
				    (* (+ (- dln1 fsk hgb1)
				       (/ (- dmt dvt) 2.00)
				    ) mb) ;_  *
			     ) ;_  polar
		  ) ;_  setq
		) ;_  if
		(if (< (* (/ (- dmt dvt) 2) mb) 0.6)
		  (progn
		    (setq dvt (- dmt (/ (* 2 0.6) mb)))
		    (if	(> (/ (- dmt dvt) 2) fsk)
		      (setq zam dln1)
		      (setq zam (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)))
		    ) ;_  if
		    (setq pt22 (polar pt21
				      (+ (/ (* pi 3) 2) a1)
				      (* (/ (- dmt dvt) 2.00) mb)
			       ) ;_  polar
			  pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			  pt24 (polar pt22 (+ 0 a1) (* zam mb))
			  pt25 (polar pt23 (+ 0 a1) (* zam mb))
		    ) ;_  setq
		  ) ;_  progn
		  (setq	pt22 (polar pt21
				    (+ (/ (* pi 3) 2) a1)
				    (* (/ (- dmt dvt) 2.00) mb)
			     ) ;_  polar
			pt23 (polar pt20 (+ (/ pi 2) a1) (* (/ (- dmt dvt) 2.00) mb))
			pt24 (polar pt22
				    (+ 0 a1)
				    (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
			     ) ;_  polar
			pt25 (polar pt23
				    (+ 0 a1)
				    (* (+ (- dln1 fsk) (/ (- dmt dvt) 2.00)) mb)
			     ) ;_  polar
		  ) ;_  setq
		) ;_  if
	       ) ;_end of if
	       )
	) ;_end of cond


	(osn)
	(if (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "4")
		(eq pr_fl "5")
	    ) ;_ end of or
	  (command "_line"
		   pt14-2
		   pt15
		   pt16
		   pt17
		   pt18
		   pt19-2
		   ""
		   "_arc"
		   pt19-1
		   "_e"
		   pt19-2
		   "_r"
		   (* rsp mb)
		   "_arc"
		   pt14-2
		   "_e"
		   pt14-1
		   "_r"
		   (* rsp mb)
		   "_line"
		   pt15
		   pt18
		   ""
	  ) ;_ end of command
	  (command "_line"
		   pt9
		   pt15
		   pt16
		   pt17
		   pt18
		   pt10
		   ""
		   "_line"
		   pt15
		   pt18
		   ""
	  ) ;_ end of command
	) ;_end of if
	(if (/= dln dln1)
	  (command "_line"
		   pt20
		   pt21
		   "")
	) ;_ end of if
	(if (not (< (* (/ dmt 2) mb) 0.6))
	  (progn
	    (ton)
	    (command "_line"
		     pt22
		     pt24
		     ""
		     "_line"
		     pt23
		     pt25
		     ""
		    ) ;_  command
	  ) ;_  command
	) ;_ end of if
	                                         ;    
      ) ;_ end of defun


      (cond ((eq pr_fl "0") (gbgl))
	    ((eq pr_fl "1") (gbbv))
	    ((or (eq pr_fl "2") (eq pr_fl "3")) (gb1bv))
	    ((eq pr_fl "4") (gb2bv))
	    ((eq pr_fl "5") (grgl))
      ) ;_ end of cond
      (strg)

    ) ;_ end of defun
;;;;;_end of    BL_GL_SB;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (defun bl_vs ()

      (defun bl023vs ()
;;;; 1491, 17473, 17474, 17475-72
	(setq pt1 (polar cpt (+ 0 a1) (* (+ (/ dgb 2.00) 2.00) mb))
	      pt2 (polar cpt (+ pi a1) (* (+ (/ dgb 2.00) 2.00) mb))
	      pt3 (polar cpt (+ (* (/ pi 2) 3) a1) (* (+ (/ dgb 2.00) 2.00) mb))
	      pt4 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dgb 2.00) 2.00) mb))
	      pt5 (polar cpt (+ (/ pi 2) a1) (* (/ sgb 2.00) mb))
	      pt6 (polar cpt (+ (* (/ pi 2) 3) a1) (* (/ sgb 2.00) mb))
	) ;_ end of setq
	(if (eq pr_fl "1")
	  (setq	pt7  (polar
		       pt6
		       (+ 0 a1)
		       (* (*
			 (sqrt (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))
			 ) ;_ end of sqrt
			 0.9
		       ) mb);_ end of *
		     ) ;_ end of polar
		pt8  (polar
		       pt5
		       (+ 0 a1)
		       (* (*
			 (sqrt (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))
			 ) ;_ end of sqrt
			 0.9
		       ) mb);_ end of *
		     ) ;_ end of polar
		pt9  (polar
		       pt5
		       (+ pi a1)
		       (* (*
			 (sqrt (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))
			 ) ;_ end of sqrt
			 0.9
		       ) mb);_ end of *
		     ) ;_ end of polar
		pt10 (polar
		       pt6
		       (+ pi a1)
		       (* (* (sqrt
			    (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))
			  ) ;_ end of sqrt
			  0.9
		       ) mb);_ end of *
		     ) ;_ end of polar
	  ) ;_ end of setq

	  (setq	pt7  (polar
		       pt6
		       (+ 0 a1)
		       (* (sqrt (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))) mb)
		     ) ;_ end of polar
		pt8  (polar
		       pt5
		       (+ 0 a1)
		       (* (sqrt (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))) mb)
		     ) ;_ end of polar
		pt9  (polar
		       pt5
		       (+ pi a1)
		       (* (sqrt (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))) mb)
		     ) ;_ end of polar
		pt10 (polar
		       pt6
		       (+ pi a1)
		       (* (sqrt (- (expt (/ dgb 2.00) 2) (expt (/ sgb 2.00) 2))) 
		       mb) ;_ end of *
		     ) ;_ end of polar
	  ) ;_ end of setq
	) ;_end of if
	(axs)
	(command "_line" pt1 pt2 "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_line" pt3 pt4 "")

	(osn)
	(command "_circle" cpt (* (/ dgb 2.00) mb))
	(command "_line" pt7 pt10 "" "_line" pt8 pt9 "")
	(if (eq pr_fl "1")
	  (command "_line" pt7 pt8 "" "_line" pt9 pt10 "")
	) ;_ end of if
      ) ;_end of defun BL023VS


      (defun bl4vs ()
;;;;; 1488-75
	(setq tgb   (/ (* (sqrt (- 1 (/ (expt sgb 2) (expt dgb 2)))) dgb) sgb)
	      tgbt  (atan tgb)
	      tg1bt (- (/ pi 4) tgbt)
	      pt1   (polar cpt (+ tg1bt a1) (* (/ dgb 2.0) mb))
	      pt2   (polar cpt (+ (- (/ pi 2) tg1bt) a1) (* (/ dgb 2.0) mb))
	      pt3   (polar cpt (+ (+ (/ pi 2) tg1bt) a1) (* (/ dgb 2.0) mb))
	      pt4   (polar cpt (+ (- pi tg1bt) a1) (* (/ dgb 2.0) mb))
	      pt5   (polar cpt (+ (+ pi tg1bt) a1) (* (/ dgb 2.0) mb))
	      pt6   (polar cpt (+ (- (* (/ pi 2) 3) tg1bt) a1) (* (/ dgb 2.0) mb))
	      pt7   (polar cpt (+ (+ (* (/ pi 2) 3) tg1bt) a1) (* (/ dgb 2.0) mb))
	      pt8   (polar cpt (+ (- 0 tg1bt) a1) (* (/ dgb 2.0) mb))
	      pt9   (polar cpt (+ 0 a1) (* (+ (/ dgb1 2.0) 2) mb))
	      pt10  (polar cpt (+ pi a1) (* (+ (/ dgb1 2.0) 2) mb))
	      pt11  (polar cpt (+ (/ pi 2) a1) (* (+ (/ dgb1 2.0) 2) mb))
	      pt12  (polar cpt (+ (* (/ pi 2) 3) a1) (* (+ (/ dgb1 2.0) 2) mb))
	) ;_ end of setq

	(axs)
	(command "_line" pt9 pt10 "")
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_line" pt11 pt12 "")

	(osn)
	(command "_circle" cpt (* (/ (* sgb 0.90) 2.00) mb))
	(command "_circle" cpt (* (/ dgb1 2.00) mb))
	(command "_line"
		 pt1
		 pt2
		 ""
		 "_line"
		 pt3
		 pt4
		 ""
		 "_line"
		 pt5
		 pt6
		 ""
		 "_line"
		 pt7
		 pt8
		 ""
	) ;_ end of command
	(command "_arc"
		 pt8
		 "_e"
		 pt1
		 "_r"
		 (* (/ dgb 2.0) mb)
		 "_arc"
		 pt2
		 "_e"
		 pt3
		 "_r"
		 (* (/ dgb 2.0) mb)
		 "_arc"
		 pt4
		 "_e"
		 pt5
		 "_r"
		 (* (/ dgb 2.0) mb)
		 "_arc"
		 pt6
		 "_e"
		 pt7
		 "_r"
		 (* (/ dgb 2.0) mb)
	) ;_ end of command
      )					; _end of defun BL4VS


      (defun bl5vs ()
;;;;;; 11738-72
	(setq pt1 (polar cpt (+ 0 a1) (* (+ (/ dgb 2.00) 2.00) mb))
	      pt2 (polar cpt (+ pi a1) (* (+ (/ dgb 2.00) 2.00) mb))
	      pt3 (polar cpt (+ (* (/ pi 2) 3) a1) (* (+ (/ dgb 2.00) 2.00) mb))
	      pt4 (polar cpt (+ (/ pi 2) a1) (* (+ (/ dgb 2.00) 2.00) mb))
	) ;_ end of setq
	(osn)
	(command "_polygon" "6" cpt "c" (* (/ sgb 2.0) mb))
	(setq label (entlast))
	(setq sset (ssadd (entlast)))
	(command "_rotate" sset "" cpt 30)
	(command "_circle"
		 cpt
		 (* (/ dgb1 2.00) mb)
		 "_circle"
		 cpt
		 (* (/ dgb 2.00) mb)
	) ;_ end of command

	(axs)
	(command "_line" pt1 pt2 "")
	(command "_line" pt3 pt4 "")


      ) ;_end of defun BL5VS

      (cond ((or (eq pr_fl "0")
		 (eq pr_fl "1")
		 (eq pr_fl "2")
		 (eq pr_fl "3")
	     ) ;_ end of or
	     (bl023vs)
	    )
	    ((eq pr_fl "4") (bl4vs))
	    ((eq pr_fl "5") (bl5vs))
      ) ;_ end of cond

    ) ;_ end of defun
;;;;;;;;;; _end of   BL_VS;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    (cond
      ((and (eq glv1 "1") (eq vsv1 "0"))
       (bl_gl_sb)
      )
      ((and (eq glv1 "0") (eq vsv1 "1")) (bl_vs))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun
;;;_end of RIS_BLT


  (defun clip_bl ()

    (initget 1) 
    (if (eq p1 "1")
             (setq inpt0 (getpoint "\n  :"))
             (setq inpt0 (list (atof xc) (atof yc)))
    )
    (if (eq p2 "1")
             (progn 
                  (setq a1 (getangle inpt0 (strcat "\n   <" angl ">:")))
	          (if (= a1 nil)
		           (setq a1 (atof angl))
		  )
	      )
             (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if 
    (setq mb (atof mash))
        
    (ris_blt)
  
    (if	(eq p3 "0")
           (anblk sset cpt)
    ) ;_  if
  
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
  ) ;_ end of defun

  (clip_bl)
  (prin1)
) ;_ end of defun VNTS
