;;;       (  H)
;;;:  ..
;;; : 24.04.2004
;;;CAD-CEE 2000
;;;: (dimVl01 kv pr)
;;;   kv -   (H7, H11, H12, H14, H15, H16  nil -     );
;;;      pr -   (0 - ; 1 - )

(defun dimVl01 (kv pr / dfl dfl2 dat1 mash fld strd strd cmd osmd ccol cltp dyf
	      it14 it15	it16 as	bs bss bss1 fldat val mb pt1 pt2 distx disty
	      dist ang txt it kv1 spis endw vsp	dat2 kv2 vsp2 h7 h11 h12 clay
              objname objlist rad name endw2 masht
	     )

  (setq	dfl   (findfile (strcat pathlisp2 "dim\\dimln.d"))
	dfl2  (findfile (strcat pathlisp2 "dim\\dimVl01.d"))
	dat1  (findfile (strcat pathdat2 "dim\\Dimdopsk.dat"))
	dat2  (findfile (strcat pathdat2 "dim\\h71112.dat"))
	spis  '(7 11 12 14 15 16)
	endw  0
	endw2 t
  ) ;_  setq

  (if (= pr 0)
    (setq vsp2 "h")
    (setq vsp2 "H")
  ) ;_  if

;;;      DIMLN.D 
  (defun rdfl ()
    (setq fld	(open dfl "r")
	  strd	(read-line fld)
	  strdd	(read strd)
	  mash	(rtos (nth 0 strdd))
	  kv2	(itoa (nth 1 strdd))
	  mb	(nth 0 strdd)
    ) ;_  setq
    (close fld)
  ) ;_  defun


;;;      DIMVL01.D 
  (defun rdfl2 ()
    (setq fld	(open dfl2 "r")
	  strd	(read-line fld)
	  strdd	(read strd)
	  kv1	(itoa (nth 0 strdd))
    ) ;_  setq
    (close fld)
  ) ;_  defun

;;;       DIMLN.D
  (defun wrfl ()

    (setq fld  (open dfl "w")
	  strd (strcat "(" mash " " kv2 ")")
    ) ;_  setq
    (write-line strd fld)
    (close fld)

  ) ;_  defun

;;;       DIMVL.D
  (defun wrfl2 ()

    (setq fld  (open dfl2 "w")
	  strd (strcat "(" kv1 ")")
    ) ;_  setq
    (write-line strd fld)
    (close fld)

  ) ;_  defun


;;;      
  (defun desk_f	()
    (setq fldat	(open dat1 "r")
	  as	(read-line fldat)
	  dyf	(read as)
	  bs	(read-line fldat)
	  bss	(read bs)
	  bss1	(nth 0 bss)
	  it14	(nth 1 bss)
	  it15	(nth 2 bss)
	  it16	(nth 3 bss)
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun whl ()
    (while (>= val bss1)
      (setq bs	 (read-line fldat)
	    bss	 (read bs)
	    bss1 (nth 0 bss)
      ) ;_  setq
      (if (>= val bss1)
	(setq it14 (nth 1 bss)
	      it15 (nth 2 bss)
	      it16 (nth 3 bss)
	) ;_  setq
      ) ;_  if
    ) ;_  while
    (close fldat)
  ) ;_  defun

  ;;;      
  (defun desk_f2 ()
    (setq fldat	(open dat2 "r")
	  as	(read-line fldat)
	  dyf	(read as)
	  bs	(read-line fldat)
	  bss	(read bs)
	  bss1	(nth 0 bss)
	  h7	(nth 1 bss)
	  h11	(nth 2 bss)
	  h12	(nth 3 bss)
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun whl2 ()
    (while (>= val bss1)
      (setq bs	 (read-line fldat)
	    bss	 (read bs)
	    bss1 (nth 0 bss)
      ) ;_  setq
      (if (>= val bss1)
	(setq h7  (nth 1 bss)
	      h11 (nth 2 bss)
	      h12 (nth 3 bss)
	) ;_  setq
      ) ;_  if
    ) ;_  while
    (close fldat)
  ) ;_  defun

;;;        
;;;   it -  
  (defun itfn (it / vsp1 vsp2 n i smv str)
    (setq vsp1 (rtos it 2 3)
	  n    (1+ (strlen vsp1))
	  i    1
	  str  ""
    ) ;_  setq
    (while (/= i n)
      (setq smv (substr vsp1 i 1))
      (if (eq smv ".")
	(setq smv ",")
      ) ;_  if
      (setq str	(strcat str smv)
	    i	(1+ i)
      ) ;_  setq
    ) ;_  while
    (setq vsp2 str)
  ) ;_  defun

;;;         
;;;   it -  
  (defun itfn2 (it / vsp1 vsp2 n i smv str)
    (setq vsp1 (rtos it 2 1)
	  n    (1+ (strlen vsp1))
	  i    1
	  str  ""
    ) ;_  setq
    (while (/= i n)
      (setq smv (substr vsp1 i 1))
      (if (eq smv ".")
	(setq smv ",")
      ) ;_  if
      (setq str	(strcat str smv)
	    i	(1+ i)
      ) ;_  setq
    ) ;_  while
    (setq vsp2 str)
  ) ;_  defun

;;;  ------------- -------------
  (setq cmd (getvar "cmdecho"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
;;;  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

;;;   
  (rdfl)
  (rdfl2)
  
;;;   ()
  (if (= (getvar "USERR1") 0)
    (setq mb (atof mash))
    (setq mb (getvar "USERR1"))
  ) ;_ end of if
  (setq mash (rtos mb))
  (setvar "USERR1" mb)
  (if (< mb 1.0)
    (setq masht (strcat "1:" (rtos (/ 1.0 mb))))
    (setq masht (strcat (rtos mb) ":1"))
  ) ;_ end of if
;;;  
  
;;;  (initget 1)
  (if (= kv nil)
    (progn
      (setq
	kv
	 (getint
	   (strcat
	     "\n\n    " vsp2 " (7, 11, 12, 14, 15  16) <"
	     kv1
	     ">:"
	   ) ;_  strcat
	 ) ;_  getint
      ) ;_  setq
      (if (or (= kv nil) (not (member kv spis)))
	(setq kv (atoi kv1))
	(setq kv1 (itoa kv))
      ) ;_  if
      (wrfl2)
    ) ;_  progn
  ) ;_  if

;;;  (setq	mb (getreal
;;;	     (strcat "\n\n      " vsp2 (itoa kv) " <" mash ">:")
;;;	   ) ;_  getreal
;;;  ) ;_  setq
;;;  (prin1)
;;;  (if (eq mb nil)
;;;    (setq mb (atof mash))
;;;    (setq mash (rtos mb))
;;;  ) ;_  if
  (wrfl)


;;;   

  (while (/= endw 1)
    (while endw2
      (initget 1)
      (setq objname (entsel (strcat "\n     ( " masht "):")))
      (if objname
	(progn
	  (setq objlist (entget (nth 0 objname)))
	  (setq	name  (cdr (assoc 0 objlist))
		endw2 nil
	  ) ;_  setq
	) ;_  progn
      ) ;_  if
      (if (or (eq name "CIRCLE") (eq name "ARC"))
	(setq rad (cdr (assoc 40 objlist)))
	(setq endw2 t)
      ) ;_  if
    ) ;_  while
    (setq endw2 t)
    (setq val (/ (* 2.0 rad) mb))
    (if	(or (< val 1) (> val 3150))
      (progn
	(setq endw 1)
	(setvar "cmdecho" cmd)
	(setvar "celtype" cltp)
	(setvar "cecolor" ccol)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(prin1)
	(princ "\n    ")
      ) ;_  progn
    ) ;_  if
    (if	(= endw 0)
      (progn
	(cond ((= kv 7) (desk_f2) (whl2) (setq it h7))
	      ((= kv 11) (desk_f2) (whl2) (setq it h11))
	      ((= kv 12) (desk_f2) (whl2) (setq it h12))
	      ((= kv 14) (desk_f) (whl) (setq it (* it14 2.0)))
	      ((= kv 15) (desk_f) (whl) (setq it (* it15 2.0)))
	      ((= kv 16) (desk_f) (whl) (setq it (* it16 2.0)))
	) ;_  cond
	(if (= pr 1)
	  (setq txt (strcat "\\" (itfn2 val) "@$" (itfn it)))
	  (setq txt (strcat "\\" (itfn2 val) "@&" (itfn it)))
	) ;_  if
	(command "_LAYER" "_s" "" "")
	(cond ((eq name "CIRCLE")
	       (command "_DIMDIAMETER" objname txt pause)
	      )
	      ((eq name "ARC")
	       (command "_DIMRADIUS" objname txt pause)
	      )
	) ;_ end of cond
      
	(setvar "cmdecho" cmd)
	(setvar "celtype" cltp)
	(setvar "cecolor" ccol)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(prin1)
	(setq vsp
	       (getstring
		 nil
		 (strcat "\n   ENTER  SPACE(),  ESC (" vsp2 (itoa kv) ",  "
			 masht "):")
	       ) ;_  getstring
	) ;_  setq
	(if (or (= vsp nil) (= vsp "") (= vsp " "))
	  (setq endw 0)
	  (setq endw 1)
	) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  while

  (prin1)
) ;_  DIMVl01
