;;;    
;;;:  ..
;;; : 01.11.2001
;;;CAD-CEE 2000
;;;: C:DOPUSK3

(defun c:dopusk3 (/ dlg dfl lsp1 fld strd strdd orx aby name1 dcl_id
		   vnln dps tol baz d1 d2 d3 d4 d5 d6 d7 d8 d9 d10
		   d11 d12 pr dps1 pl inptG tol1 baz1 
		    ) 

  (setq	dlg  (findfile (strcat pathdcl2 "dopusk3.dcl"))
	dfl  (findfile (strcat pathlisp2 "dopusk3.d"))
	lsp1 (findfile (strcat pathlisp2 "spt.lsp"))
  ) ;_  setq

  (load lsp1)

;;;   
  (setq	d1 (strcat pathdat2 "dopusk3(1).slb")
	d2 (strcat pathdat2 "dopusk3(2).slb")
	d3 (strcat pathdat2 "dopusk3(3).slb")
	d4 (strcat pathdat2 "dopusk3(4).slb")
	d5 (strcat pathdat2 "dopusk3(5).slb")
	d6 (strcat pathdat2 "dopusk3(6).slb")
	d7 (strcat pathdat2 "dopusk3(7).slb")
	d8 (strcat pathdat2 "dopusk3(8).slb")
	d9 (strcat pathdat2 "dopusk3(9).slb")
	d10 (strcat pathdat2 "dopusk3(10).slb")
;;;	d11 (strcat pathdat2 "dopusk3(11).slb")
;;;	d12 (strcat pathdat2 "dopusk3(12).slb")
  ) ;_  setq

;;;    
  (defun textf ()
    (command "_layer" "_s" "" "")
  ) ;_  defun

  
;;;      DOPUSK2.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd	  (read-line fld)
	   strdd  (read strd)
           dps    (itoa (nth 0 strdd))
	   vnln   (itoa (nth 1 strdd))
	   tol    (nth 2 strdd)
	   baz    (nth 3 strdd)
	   tol1   tol
	   baz1   baz
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

;;;            
  (defun s_t ()
    (set_tile "Tol" tol)
    (set_tile "Baz" baz)
    (set_tile "Vnln" vnln)
    (set_tile "Prim" pr)
    (if	(or (eq dps "1") (eq dps "2"))
      (progn
	(mode_tile "Vnln" 1)
	(mode_tile "Tol" 1)
      ) ;_  progn
      (progn
	(mode_tile "Vnln" 0)
	(mode_tile "Tol" 0)
      ) ;_  progn
    ) ;_  if
    (if	(or (eq dps "1") (<= 3 (atoi dps) 6))
      (mode_tile "Baz" 1)
      (mode_tile "Baz" 0)
    ) ;_  if
  ) ;_  defun

;;;    
  (defun sl_im ()
    (show_im d1 "D1" 9)
    (show_im d2 "D2" 9)
    (show_im d3 "D3" 9)
    (show_im d4 "D4" 9)
    (show_im d5 "D5" 9)
    (show_im d6 "D6" 9)
    (show_im d7 "D7" 9)
    (show_im d8 "D8" 9)
    (show_im d9 "D9" 9)
    (show_im d10 "D10" 9)
;;;    (show_im d11 "D11" 9)
;;;    (show_im d12 "D12" 9)
  ) ;_  defun

;;;     
  (defun prim ()
    (cond ((= dps "1") (setq pr ""))
          ((= dps "2") (setq pr " "))
          ((= dps "3") (setq pr " "))
	  ((= dps "4") (setq pr "   "))
	  ((= dps "5") (setq pr "   "))
	  ((= dps "6") (setq pr "   "))
	  ((= dps "7") (setq pr "   "))
	  ((= dps "8") (setq pr "     "))
	  ((= dps "9") (setq pr "     "))
	  ((= dps "10") (setq pr "     "))
;;;          ((= dps "11") (setq pr "   "))
;;;	  ((= dps "12") (setq pr "    "))
    ) ;_  cond
  ) ;_  defun

;;;     
;;;   : (pl_enbl dpsf kd)
;;;   dpsf -  ;
;;;   kd -   (252 - , 9 -  ( ))
 (defun	pl_enbl	(dpsf kd / namef)
;;;     
   (setq pl    (strcat "D" dpsf)
	 namef (strcat pathdat2 "dopusk3(" dpsf ").slb")
   ) ;_  setq
;;;    
   (show_im namef pl kd)
;;;   (mode_tile pl 2)
 ) ;_  defun

;;;       DOPUSK2.D
  (defun wrfl ()
      (setq fld	 (open dfl "w")
	    strd (strcat "(" dps " " vnln " \"" tol "\" \"" baz "\")")
      ) ;_  setq
     (write-line strd fld)
     (close fld)
  )  ;_  defun


;;;   
  (defun show_im (name1 pole clr)
    (setq orx (dimx_tile pole)
	  aby (dimy_tile pole)
    ) ;_  setq
    (start_image pole)
    (fill_image 0 0 orx aby clr)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "dopusk3" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (sl_im)
    (pl_enbl dps 252)
    (prim)
    (s_t)


;;;     
    (action_tile
      "D1"
      (strcat "(setq dps1 dps dps \"1\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D2"
      (strcat "(setq dps1 dps dps \"2\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D3"
      (strcat "(setq dps1 dps dps \"3\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D4"
      (strcat "(setq dps1 dps dps \"4\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D5"
      (strcat "(setq dps1 dps dps \"5\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D6"
      (strcat "(setq dps1 dps dps \"6\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D7"
      (strcat "(setq dps1 dps dps \"7\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D8"
      (strcat "(setq dps1 dps dps \"8\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D9"
      (strcat "(setq dps1 dps dps \"9\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D10"
      (strcat "(setq dps1 dps dps \"10\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
;;;    (action_tile
;;;      "D11"
;;;      (strcat "(setq dps1 dps dps \"11\")"
;;;	      "(pl_enbl dps1 9)"
;;;	      "(pl_enbl dps 252)"
;;;	      "(prim)"
;;;	      "(s_t)"
;;;      ) ;_  strcat
;;;    ) ;_  action_tile
;;;    (action_tile
;;;      "D12"
;;;      (strcat "(setq dps1 dps dps \"12\")"
;;;	      "(pl_enbl dps1 9)"
;;;	      "(pl_enbl dps 252)"
;;;	      "(prim)"
;;;	      "(s_t)"
;;;      ) ;_  strcat
;;;    ) ;_  action_tile
    (action_tile
      "Tol"
      (strcat "(setq tol $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Baz"
      (strcat "(setq baz $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Vnln"
      (strcat "(setq vnln $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl)")
    (start_dialog)

  ) ;_  defun

;;; ---------------------------------- --------------------------------
  (show)
  (unload_dialog dcl_id)
  (prin1)
;;;    
  (command "_LOAD" "symb1.shx")

;;;    
  (initget 1)
  (setq inptG
	   (getpoint "\n  :")
  ) ;_  setq

  (setq	wr1 (getvar "TDUSRTIMER")
	cla (getvar "CLAYER")
  ) ;_  setq
  (textf)
;;;   
  (cond	((= dps "1")
	 (command "_SHAPE" "base1" inptG "1.0" pause)
	 (command "_CHPROP" "_l" "" "_la" "dim" "")
	 (princ)
	)
	((= dps "2")
	 (command "_SHAPE" "base2" inptG "1.0" pause)
	 (spt "0" 1 tol baz)
	)
	((= dps "3")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "bien1" inptG "1.0" "0")
	 (spt vnln 4 tol baz)
	)
	((= dps "4")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "ram1" inptG "1.0" "0")
	 (command "_SHAPE" "fzpo" inptG "1.0" "0")
	 (spt vnln 4 tol baz)
	)
	((= dps "5")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "ram1" inptG "1.0" "0")
	 (command "_SHAPE" "fzpr" inptG "1.0" "0")
	 (spt vnln 4 tol baz)
	)
	((= dps "6")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "ram1" inptG "1.0" "0")
	 (command "_SHAPE" "pbien" inptG "1.0" "0")
	 (spt vnln 4 tol baz)
	)
	((= dps "7")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "bien3" inptG "1.0" "0")
	 (spt vnln 6 tol baz)
	)
	((= dps "8")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "ram3" inptG "1.0" "0")
	 (command "_SHAPE" "fzpo" inptG "1.0" "0")
	 (spt vnln 6 tol baz)
	)
	((= dps "9")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "ram3" inptG "1.0" "0")
	 (command "_SHAPE" "fzpr" inptG "1.0" "0")
	 (spt vnln 6 tol baz)
	)
	((= dps "10")
	 (setq inptG (polar inptG (* 3.0 (/ pi 2.0)) 4.0))
	 (command "_SHAPE" "ram3" inptG "1.0" "0")
	 (command "_SHAPE" "pbien" inptG "1.0" "0")
	 (spt vnln 6 tol baz)
	)
;;;	((= dps "11")
;;;	 (command "_SHAPE" "ram3" inptG "1.0" "0")
;;;	 (command "_SHAPE" "sym" inptG "1.0" "0")
;;;	 (spt vnln 6 tol baz)
;;;	)
;;;	((= dps "12")
;;;	 (command "_SHAPE" "ram3" inptG "1.0" "0")
;;;	 (command "_SHAPE" "pos" inptG "1.0" "0")
;;;	 (spt vnln 6 tol baz)
;;;	)
  ) ;_  cond

  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  DOPUSK3
