;;;    
;;;:  ..
;;; : 13.03.2002
;;;CAD-CEE 2000
;;;: C:KRPEZL

(defun c:krpezl	(/ tipf	db d dotv notv l1 l2 l3	l4 l5 l6 lt l s	sech
		 sprd name1 orx	aby dlg	dfl lsp1 lsp2 lsp3 lsp4	lsp5 fld
		 strd strdd strd1 strdd1 p1 p2 p3 angl mash name1 spis
		 pti inptG xc yc dcl_id	inptG a1 mb cmd	blpm apsz osmd
		 clay cltp ccol	vs vctr	pv anbl	sset label sech2 sbk py
		 dy pyf	dyf stf	fldat dfl2 as ass bs bss bss1 bss2
		 fldat2	as2 ass2 dtb stb shtrp spism mtr hpa hpn st bd
		 pd co dat1 dat2 dat3 dat4 dat5	sbk r1 r2 r3 r4	r5 lr
		 tpf dtr btr htr sh1 sh2 rst agl n0 n svr r ms rdm
		)

  (setq	dlg  (findfile (strcat pathdcl2 "element\\krpezl.dcl"))
	dfl  (findfile (strcat pathlisp2 "element\\krpezl.d"))
;;;	dat1 (findfile (strcat pathdat2 "korpus\\el6533n.dat"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "element\\krpotr.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

;;;   
  (setq	spis '("60"
	       "80"
	       "100"
	      )
  ) ;_  setq

;;;    
  (setq	d  5.0
	s  3.0
	l1 30.0
	l2 15.0
	l3 26.0
	l4 25.0
	l5 9.0
	l6 50.0
	r1 2.5
	r2 5.0
	r3 3.0
	r4 3.0
	r5 5.0				; 
  ) ;_  setq


;;;      KRPEZL.D 
  (defun rdfl ()
    (setq fld	 (open dfl "r")
	  strd1	 (read-line fld)
	  strdd1 (read strd1)
	  tipf	 (itoa (nth 0 strdd1))
	  sech	 (itoa (nth 1 strdd1))
	  sprd	 (itoa (nth 2 strdd1))
	  sbk	 (itoa (nth 3 strdd1))
	  svr	 (itoa (nth 4 strdd1))
	  shtrp	 (itoa (nth 5 strdd1))
	  tpf	 (itoa (nth 6 strdd1))
	  dtr	 (nth 7 strdd1)
	  btr	 (nth 8 strdd1)
	  htr	 (nth 9 strdd1)
	  agl	 (nth 10 strdd1)
	  r	 (nth 11 strdd1)
	  rdm	 (nth 12 strdd1)
	  strd	 (read-line fld)
	  strdd	 (read strd)
	  p1	 (itoa (nth 0 strdd))
	  p2	 (itoa (nth 1 strdd))
	  angl	 (rtos (nth 2 strdd))
	  mash	 (rtos (nth 3 strdd))
    ) ;_  setq
    (close fld)
  ) ;_  defun


;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "R" (rtos r))
    (set_tile "L1" (itoa l))
    (set_tile "Lr" (itoa lr))
    (set_tile "M" (rtos ms 2 3))
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Svr" svr)
    (set_tile "Shtr" shtrp)
  ) ;_  defun


;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       KRPEZL.D
  (defun wrfl ()

    (setq fld  (open dfl "w")
	  strd (strcat "(" p1 " " p2 " " angl " " mash ")")
    ) ;_  setq
    (write-line strd1 fld)
    (write-line strd fld)
    (close fld)

  ) ;_  defun


  (defun wrfl_os ()
    (setq strd1	(strcat	"("
			tipf
			" "
			sech
			" "
			sprd
			" "
			sbk
			" "
			svr
			" "
			shtrp
			" "
			tpf
			" "
			(rtos dtr)
			" "
			(rtos btr)
			" "
			(rtos htr)
			" "
			(rtos agl)
			" "
			(rtos r)
			" "
			(rtos rdm)
			")"
		) ;_  strcat
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun name ()
    (cond ((and	(eq sech "1")
		(eq sprd "0")
		(eq sbk "0")
		(eq svr "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\krpezl(1).slb"))
	  )
	  ((and	(eq sech "0")
		(eq sprd "1")
		(eq sbk "0")
		(eq svr "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\krpezl(2).slb"))
	  )
	  ((and	(eq sech "0")
		(eq sprd "0")
		(eq sbk "1")
		(eq svr "0")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\krpezl(3).slb"))
	  )
	  ((and	(eq sech "0")
		(eq sprd "0")
		(eq sbk "0")
		(eq svr "1")
	   ) ;_  and
	   (setq name1 (strcat pathdat2 "element\\krpezl(6).slb"))
	  )
    ) ;_  cond

  ) ;_  defun


;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;    
  (defun tipf_l	()
    (start_list "Tipf")
    (mapcar 'add_list spis)
    (end_list)
  ) ;_  defun


;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
  (defun prv_p (p vf pole pk / n i sm us)
    (setq us 0
	  i  1
	  n  (strlen p)
	  sm (substr p 1 1)
    ) ;_  setq

    (while (not (eq sm ","))
      (if (not (or (eq sm "0")
		   (eq sm "1")
		   (eq sm "2")
		   (eq sm "3")
		   (eq sm "4")
		   (eq sm "5")
		   (eq sm "6")
		   (eq sm "7")
		   (eq sm "8")
		   (eq sm "9")
		   (eq sm ".")
	       ) ;_  or
	  ) ;_  not
	(setq sm ","
	      us 1
	) ;_  setq
      ) ;_  if
      (if (or (= i n) (= us 1))
	(setq sm ",")
	(progn (setq i	(1+ i)
		     sm	(substr p i 1)
	       ) ;_  setq
	       (if (eq sm ",")
		 (setq us 1)
	       ) ;_  if
	) ;_  progn
      ) ;_  if
    ) ;_  while

    (if	(or (/= i n) (= us 1))
      (progn (attn)
	     (mode_tile pole 2)
	     (set vf (eval vf))
	     (if (= vf 'l)
	       (setq l 0)
	     ) ;_  if
	     (if (= (type (eval vf)) 'STR)
	       (set_tile pole (eval vf))
	       (if (= (type (eval vf)) 'INT)
		 (set_tile pole (itoa (eval vf)))
		 (set_tile pole (rtos (eval vf)))
	       ) ;_  if
	     ) ;_  if
      ) ;_  progn
      (if (eq pk "s")
	(set vf p)
	(if (eq pk "i")
	  (set vf (atoi p))
	  (set vf (atof p))
	) ;_  if
      ) ;_  if
    ) ;_  if 
  ) ;_  defun

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
  (defun prov (i1 i2 i3 pole obz)
    (if	(not (<= i1 i2 i3))
      (progn
	(attn2 i1 i3 obz)
	(mode_tile pole 2)
	(setq fe 1)
      ) ;_  progn
      (setq fe 0)
    ) ;_  if
  ) ;_  defun



;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))

;;;    (if (= l 0)
    (setq srv (* s mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 1.0)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
;;;	     (if (eq sech2 "1")
;;;	       (setq sech "0"
;;;		     sbk  "1"
;;;	       ) ;_  setq
;;;	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;      
  (defun rsh_l (/ x lt1)
    (cond ((= tipf "0")
	   (setq lt 150.0
		 lr 180
		 ms 0.046
	   ) ;_  setq
	  )
	  ((= tipf "1")
	   (setq lt 190.0
		 lr 220
		 ms 0.052
	   ) ;_  setq
	  )
	  ((= tipf "2")
	   (setq lt 190.0
		 lr 220
		 ms 0.052
	   ) ;_  setq
	  )
    ) ;_  cond
    (setq x   (* (/ (+ r5 (/ d 2.0)) 2.0) pi)
	  lt1 (- lt (+ (- l6 (+ r5 d)) x))
	  l   (fix (+ lt1 (+ r5 d)))
    ) ;_  setq
  ) ;_  defun

;;;   -     
  (defun attn ()
    (new_dialog "att1" dcl_id)
    (action_tile "accept" "(done_dialog 1)")
    (start_dialog)
  ) ;_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
  (defun attn2 (ot dov obz / str1)
    (setq str1 (strcat "  "
		       (rtos ot)
		       " "
		       obz
		       "   "
		       (rtos dov)
		       " "
		       obz
		       "."
	       ) ;_  strcat
    ) ;_  setq
    (new_dialog "att2" dcl_id)
    (set_tile "Ot" str1)
    (action_tile "accept" "(done_dialog 1)")
    (start_dialog)
  ) ;_  defun

;;;    
  (defun ins1 ()

    (if	(and (eq p2 "0") (eq angl nil))
      (setq angl "0")
    ) ;_  if
    (if	(eq p3 nil)
      (setq p3 "1")
    ) ;_  if

    (new_dialog "ins1" dcl_id)

    (setq sech2 sech)
    (s_t1)
    (pred)

    (action_tile "xcor" "(setq xc $value)")
    (action_tile "ycor" "(setq yc $value)")

    (action_tile
      "Mash"
      "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)"
    ) ;_  action_tile
    (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

    (action_tile
      "per1"
      (strcat
	"(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
	"(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
	"(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
	"(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "per2"
      (strcat
	"(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
	"(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile "per3" "(setq p3 $value)")

    (action_tile "accept" "(done_dialog)(wrfl)")
    (action_tile "cancel" "(exit)")

    (start_dialog)			;   


  ) ;_  defun


;;;        
  (defun rash (/ sr dv spis2 vsp1 vsp2 vsp3)

;;;     
    (setq spis2	'(" "
		  " "
		  " "
		 )
    ) ;_  setq

;;;      
    (setq sh1 500.0
	  sh2 500.0
	  rst 250.0
    ) ;_  setq


;;;       
    (defun s_tr	()
      (set_tile "Tpf" tpf)
      (set_tile "D" (rtos dtr))
      (set_tile "B" (rtos btr))
      (set_tile "H" (rtos htr))
      (set_tile "Z" (rtos sh1))
      (set_tile "Y" (rtos sh2))
      (set_tile "X" (rtos rst))
      (set_tile "R" (rtos rdm))
      (set_tile "Ag" (rtos agl))
      (set_tile "N" (itoa (fix n)))
      (set_tile "Ms" (rtos (* (fix n) ms) 2 2))
      (cond ((= tpf "0")
	     (mode_tile "D" 0)
	     (mode_tile "B" 1)
	     (mode_tile "Ag" 0)
	     (mode_tile "R" 1)
	    )
	    ((= tpf "1")
	     (mode_tile "D" 1)
	     (mode_tile "B" 0)
	     (mode_tile "Ag" 1)
	     (mode_tile "R" 1)
	    )
	    ((= tpf "2")
	     (mode_tile "D" 0)
	     (mode_tile "B" 1)
	     (mode_tile "Ag" 1)
	     (mode_tile "R" 0)
	    )
      ) ;_  cond
    ) ;_  defun

;;;     
    (defun name2 ()
      (cond ((eq tpf "0")
	     (setq name1 (strcat pathdat2 "element\\krpezl(6a).slb"))
	    )
	    ((eq tpf "1")
	     (setq name1 (strcat pathdat2 "element\\krpezl(7a).slb"))
	    )
	    ((eq tpf "2")
	     (setq name1 (strcat pathdat2 "element\\krpezl(8a).slb"))
	    )
      ) ;_  cond

    ) ;_  defun


;;;   
    (defun show_im2 (name0)
      (setq orx	(dimx_tile "image2")
	    aby	(dimy_tile "image2")
      ) ;_  setq
      (start_image "image2")
      (fill_image 0 0 orx aby 252)
      (slide_image 0 0 orx aby name1)
      (end_image)
    ) ;_  defun

;;;    
    (defun tpf_l ()
      (start_list "Tpf")
      (mapcar 'add_list spis2)
      (end_list)
    ) ;_  defun


;;;      
    (defun fn_rr_sr (/ r)
      (cond ((= tpf "0") (rash1))
	    ((= tpf "1") (rash2))
	    ((= tpf "2") (rash3))
      ) ;_  cond
    ) ;_  defun


;;;      
    (defun rash1 (/ ld aglr nsh nld)
      (if (> agl 360)
	(setq agl 360.0)
      ) ;_  if
      (setq ld	 (- htr (* 2.0 rst))
	    aglr (* (/ agl 360.0) pi)
	    nsh	 (/ (* aglr dtr) sh1) ;  
	    nld	 (+ (/ ld sh2) 1) ;  
      ) ;_  setq
      (if (< agl 360)
	(setq nsh (+ nsh 1))
      ) ;_  if
      (if (< nsh 1.0)
	(setq nsh 1)
	(setq nsh (fix (+ nsh 0.2)))
      ) ;_  if
      (if (< nld 1.0)
	(setq nld 1)
	(setq nld (fix (+ nld 0.2)))
      ) ;_  if
      (setq n (* nld nsh))		;  
    ) ;_  defun

;;;      
    (defun rash2 (/ ld hd nsh nld)
      (setq ld	(- htr (* 2.0 rst))
	    hd	(- btr (* 2.0 sh1))
	    nsh	(+ (/ hd sh2) 1)	;  
	    nld	(+ (/ ld sh2) 1)	;  
      ) ;_  setq
      (if (< nsh 1.0)
	(setq nsh 1)
	(setq nsh (fix (+ nsh 0.2)))
      ) ;_  if
      (if (< nld 1.0)
	(setq nld 1)
	(setq nld (fix (+ nld 0.2)))
      ) ;_  if
      (setq n (* nld nsh))		;  
    ) ;_  defun

;;;      
    (defun rash3 (/ ld aglr nsh nld vsp10)
      (setq nsh	(/ (* pi dtr) sh2)	;  
      ) ;_  setq
      (if (< nsh 1.0)
	(setq nsh 1)
	(setq nsh (fix (+ nsh 0.2)))
      ) ;_  if
      (if (and (> rst 30) (<= rst (- htr 20)))
	(setq n nsh)			;     
	(setq n 0)
      ) ;_  if
;;;          
      (setq nld	  (+ (/ (- (/ dtr 2.0) rdm) sh1) 1)
	    vsp10 rdm
      ) ;_  setq
      (if (< nld 1.0)
	(setq nld 1)
	(setq nld (fix (+ nld 0.2)))
      ) ;_  if
;;;          .  
      (while (/= nld 0)
	(setq nsh   (/ (* 2.0 pi vsp10) sh2)
	      vsp10 (+ vsp10 sh1)
	      nld   (1- nld)
	) ;_  setq
	(if (< nsh 1.0)
	  (setq nsh 1)
	  (setq nsh (fix (+ nsh 0.2)))
	) ;_  if
	(setq n (+ n nsh))
      ) ;_  while
      (if (< dtr 800)
	(setq n 4)
      ) ;_  if
    ) ;_  defun

;;;       
    (defun rdm_fn ()
      (if (< dtr 800)
	(setq rdm 150.0)
	(setq rdm 400.0)
      ) ;_  if
    ) ;_  defun

    (defun rst_fn ()
      (setq vsp2 rst)
      (if (= tpf "2")
	(if (< htr rst)
	  (setq rst (- htr 20))
	) ;_  if
	(setq rst vsp2)
      ) ;_  if
    ) ;_  defun

;;;     
    (new_dialog "ras" dcl_id)
    (tpf_l)
    (show_im2 (name2))
    (rdm_fn)
    (rst_fn)
    (fn_rr_sr)
    (s_tr)
    (action_tile
      "Tpf"
      "(setq tpf $value)(show_im2 (name2))(rdm_fn)(rst_fn)(fn_rr_sr)(s_tr)"
    ) ;_  action_tile
    (action_tile
      "D"
      "(prv_p $value 'dtr \"D\" \"r\")(rdm_fn)(s_tr)"
    ) ;_  action_tile
    (action_tile "B" "(prv_p $value 'btr \"B\" \"r\")")
    (action_tile "H" "(prv_p $value 'htr \"H\" \"r\")(rst_fn)(s_tr)")
    (action_tile "R" "(prv_p $value 'rdm \"R\" \"r\")")
    (action_tile
      "Z"
      "(prv_p $value 'sh1 \"Z\" \"r\")(prov 100 sh1 1000 \"Z\" \"\")"
    ) ;_  action_tile
    (action_tile
      "Y"
      "(prv_p $value 'sh2 \"Y\" \"r\")(prov 100 sh2 1000 \"Y\" \"\")"
    ) ;_  action_tile
    (action_tile "X" "(prv_p $value 'rst \"X\" \"r\")")
    (action_tile "Ag" "(prv_p $value 'agl \"Ag\" \"r\")")

    (action_tile "RR" "(fn_rr_sr)(s_tr)")
    (action_tile "cancel" "(done_dialog 1)")

    (start_dialog)			;   


  ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "krpezl" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (tipf_l)
    (rsh_l)
    (s_t)

    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (if	(eq svr "1")
      (mode_tile "R" 0)
    ) ;_  if
    (mode_tile "Tipf" 2)

;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(rsh_l)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "R"
      (strcat "(prv_p $value 'r \"R\" \"r\")"
	      "(prov 0 r 5000 \"R\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)" "(setq sprd \"0\")"
	      "(setq sbk \"0\")" "(setq svr \"0\")"
	      "(mode_tile \"Shtr\" 0)" "(mode_tile \"R\" 1)"
	      "(show_im (name))"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)" "(setq sech \"0\")"
	      "(setq sbk \"0\")" "(setq svr \"0\")"
	      "(mode_tile \"Shtr\" 1)" "(mode_tile \"R\" 1)"
	      "(show_im (name))"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)" "(setq sech \"0\")"
	      "(setq sprd \"0\")" "(setq svr \"0\")"
	      "(mode_tile \"Shtr\" 1)" "(mode_tile \"R\" 1)"
	      "(show_im (name))"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Svr"
      (strcat "(setq svr $value)" "(setq sech \"0\")"
	      "(setq sprd \"0\")" "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 1)" "(mode_tile \"R\" 0)"
	      "(show_im (name))"
	     ) ;_  strcat
 ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Rash"
      (strcat "(rash)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)


;;;   

  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
;;;	(if (/= svr "1")
	(setq a1 (+ a1 (/ pi 2)))
;;;	) ;_  if
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if




  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* l mb) 2))
    (command "_ZOOM" "_C" inptG (* (* l mb) 2))
  ) ;_  if


;;;    
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq svr "0")
	 ) ;_  and
	 (krpotr d s l4 l5 l6 r1 r2 r4 r5 l inptG a1 mb shtrp)
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	      (eq svr "0")
	 ) ;_  and
	 (krpotr2 d s l1 l2 l3 l4 l6 r1 r2 r3 r4 r5 inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	      (eq svr "0")
	 ) ;_  and
	 (krpotr3 d s l4 l5 l6 r1 r2 r4 r5 l inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq svr "1")
	 ) ;_  and
	 (krpotr4 d s l1 l3 l5 r3 r4 l r inptG a1 mb)
	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
    (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
    (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400))
  (prin1)

) ;_  KRPEZL
