;;;  
;;;: (kompshll d d1 l h r r1 sp an ip a1 mb pr pr2 shtrp)
;;;:   d -   ;
;;;       d1 -   ;
;;;       l -  ;
;;;       h -  ;
;;;       r -  R;
;;;       r1 -  R1;
;;;       sp -   ;
;;;       an -    ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pr -   (1 - , 0 - );
;;;       pr2 -   (1 - , 0 - );
;;;       shtrp -  ("1" - , "0" - )
;;; : 16.08.2001

(defun kompshll (d  d1	l    h	  r    r1   sp	 an   ip   a1	mb
		   pr	pr2  shtrp     /    p1	 p2   p3   p4	p5
		   p6	p7   p8	  ks0  ks12 z	 a    box  lsta	e
		   flag	ang1 pt1  pt2  pt3  p1a	 p2a  p3a  p4a	p5a
		   p6a	p1b  p2b  p3b  p4b  p5b	 p6b  lt   pc1	pc2
		   lt2
		  )

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun


  (osn)
;;;      
  (setq	d   (* d mb)
	d1  (* d1 mb)
	l   (* l mb)
	h   (* h mb)
	r   (* r mb)
	r1  (* r1 mb)
	sp  (* mb sp)
	an  (* (/ an 180) pi)
	pt1 (polar ip (- a1 (/ pi 2.0)) (/ l 2.0))
	lt  (* (- (- (* d1 0.5) (+ r1 sp)) (+ (* d 0.5) r))
	       (/ (sin an) (cos an))
	    ) ;_  *
  ) ;_  setq


;;;      
(defun osn_kon (/ label1 label2 sset1)
  (setq	p1  (polar ip (+ a1 pi) (* d 0.5))
	p6  (polar pt1 (+ a1 pi) (* d1 0.5))
	p2  (polar p1 (- a1 (/ pi 2.0)) (+ (- (* l 0.5) h r) lt))
	pc1 (polar p2 (+ a1 pi) r)
	p3  (polar pc1 (- a1 (/ pi 2.0)) r)
	p5  (polar p6 (+ a1 (/ pi 2.0)) (- h (+ r1 sp)))
	pc2 (polar p5 a1 (+ r1 sp))
	p4  (polar pc2 (+ a1 (/ pi 2.0)) (+ r1 sp))
	pt2 (polar ip (- a1 (/ pi 2.0)) (- (* l 0.5) h))
  ) ;_  setq

  (command "_line" ip p1 "")
  (setq label1 (entlast))
  (setq label2 (entlast))
  (setq sset1 (ssadd (entlast)))
  (command "_line" p1 p2 "" "_line" p5 p6 "")  
  (command "_arc" p4 "_c" pc2 p5)
  (if (and (= pr2 0) (= an 0))
      (command "_line" p3 pt2 "")
  ) ;_  if
  (if (/= an 0)
    (progn
      (setq lt2	(+ (- (- (* d1 0.5) (+ r1 sp)) (+ (* d 0.5) r))
		   (sqrt (- (expt r 2) (expt (- r lt) 2)))
		) ;_  +
	    p7	(polar p4 a1 lt2)
      ) ;_  setq
      (command "_line" p4 p7 "")
      (if (= pr2 1)
	(progn
	  (command "_line" p3 p4 "")
	  (command "_arc" p3 "_c" pc1 p2)
	) ;_  progn
	(progn
	  (command "_line" p7 pt2 "")
	  (command "_arc" p7 "_c" pc1 p2)
	)
      ) ;_  if
    ) ;_  progn
    (progn
      (command "_line" p3 p4 "")
      (command "_arc" p3 "_c" pc1 p2)
    ) ;_  progn
  ) ;_  if
  (if (= pr 1)
    (command "_line" p6 pt1 "")
  ) ;_  if

;;;     
  (while (setq label1 (entnext label1))
    (setq sset1 (ssadd label1 sset1))
  ) ;_  while
  (command "_MIRROR" sset1 "" ip pt1 "_N")
  (while (setq label2 (entnext label2))
    (setq sset1 (ssadd label2 sset1))
  ) ;_  while
  (command "_MIRROR" sset1 "" p6 pt1 "_N")
) ;_  OSN_KON
  

;;;      
(defun vsp_kon (/ label1 label2 sset1)
  (setq	p1a (polar ip (+ a1 pi) (- (* d 0.5) sp))
	p6a (polar pt1 (+ a1 pi) (- (* d1 0.5) sp))
	p2a (polar p1a (- a1 (/ pi 2.0)) (+ (- (* l 0.5) h r) lt))
	p3a (polar pc1 (- a1 (/ pi 2.0)) (+ r sp))
	p5a (polar p6a (+ a1 (/ pi 2.0)) (- h (+ r1 sp)))
	p4a (polar pc2 (+ a1 (/ pi 2.0)) r1)
	pt2 (polar ip (- a1 (/ pi 2.0)) (- (* l 0.5) (- h sp lt)))
  ) ;_  setq

  (command "_line" p1a p2a "")
  (setq label1 (entlast))
  (setq label2 (entlast))
  (setq sset1 (ssadd (entlast)))
  (command "_line" p3a p4a "" "_line" p5a p6a "")
  (command "_line" p3a pt2 "")
  (command "_arc" p3a "_c" pc1 p2a)
  (command "_arc" p4a "_c" pc2 p5a)
  
;;;     
  (while (setq label1 (entnext label1))
    (setq sset1 (ssadd label1 sset1))
  ) ;_  while
  (command "_MIRROR" sset1 "" ip pt1 "_N")
  (while (setq label2 (entnext label2))
    (setq sset1 (ssadd label2 sset1))
  ) ;_  while
  (command "_MIRROR" sset1 "" p6 pt1 "_N")
) ;_  VSP_KON

;;;        
(defun svr_kon (/ label1 sset1)
  (setq	p1b (polar p1a a1 (* d 0.25))
	pc1 (polar pc1 a1 (* d 0.25))
	pc2 (polar pc2 a1 (* d 0.25))
	p6b (polar p6a a1 (* d 0.25))
	p2b (polar p2a a1 (* d 0.25))
	p3b (polar p3a a1 (* d 0.25))
	p5b (polar p5a a1 (* d 0.25))
	p4b (polar p4a a1 (* d 0.25))
  ) ;_  setq
  (command "_line" p1b p2b "")
  (setq label1 (entlast))
  (setq sset1 (ssadd (entlast)))
  (command "_line" p5b p6b "")
  (command "_arc" p3b "_c" pc1 p2b)
  (command "_arc" p4b "_c" pc2 p5b)

;;;      
  (while (setq label1 (entnext label1))
    (setq sset1 (ssadd label1 sset1))
  ) ;_  while
  (command "_MIRROR" sset1 "" p6 pt1 "_N")
) ;_  SVR_KON

;;;    
  (defun sht_kon (/ dl ang1 pt1 pt2 label1)
      (setq dl	 (distance p1a p2)
	    ang1 (angle p1a p2)
	    pt1	 (polar p1a ang1 (/ dl 2.0))
	    pt2	 (polar pt1 a1 (- d sp))
	    av	 (* (/ a1 pi) 180)
      ) ;_  setq
      (ton)
      (command "_bhatch" "_p" "_u" (+ av 45) 2.0 "_n" pt1 pt2 "")
      (if (= pr 1)
	(progn
	  (setq label1 (entlast))
	  (command "_MIRROR" label1 "" p6 p6a "_N")
	) ;_  progn
      ) ;_  if
  ) ;_  defun

;;;  ---------- ---------
  (osn_kon)
  (if (= pr2 1)
    (progn
      (vsp_kon)
      (if (= pr 0)
	(svr_kon)
      ) ;_  if
      (if (eq shtrp "1")
	(sht_kon)
      ) ;_  if
    ) ;_  progn
  ) ;_  if
  
) ;_  KOMPSHLL


;;;   
;;;: (kompshll2 d d1 sp ip a1 mb)
;;;:   d -    ;
;;;       d1 -    ;
;;;       sp -   ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 17.08.2001
(defun kompshll2 (d d1 sp ip a1 mb / pt1 pt2 pt3 pt4 p1 p2 p3 p4)
;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  
  (osn)
  (command "_circle" ip (* (/ d 2.0) mb))
  (setq label (entlast))
  (setq sset (ssadd (entlast)))
  (command "_circle" ip (* (- (/ d 2.0) sp) mb))
  (command "_circle" ip (* (/ d1 2.0) mb))
;;;     
  (setq	pt1 (polar ip (+ a1 pi) (* (* d1 0.55) mb))
	pt2 (polar pt1 a1 (* (* d1 1.1) mb))
	pt3 (polar ip (+ a1 (/ pi 2.0)) (* (* d1 0.55) mb))
	pt4 (polar pt3 (- a1 (/ pi 2.0)) (* (* d1 1.1) mb))
  ) ;_  setq

;;;   
  (axs2)
  (command "_line" pt1 pt2 "")
  (command "_line" pt3 pt4 "")
) ;_  KOMPSHLL2
