;;;    
;;;:  ..
;;; : 14.08.2001
;;;CAD-CEE 2000
;;;: C:RESHET

(defun c:reshet (/ tipf	 db    d     d1  notv	 h     h2    b
		   l	 s     sech  sprd  name1 orx   aby   dlg
		   dfl	 lsp1  lsp2  lsp3  lsp4	 lsp5  fld   strd
		   strdd strd1 strdd1	   p1	 p2    p3    angl
		   mash	 name1 spis  pti   inptG xc    yc    dcl_id
		   inptG a1    mb    cmd   blpm	 apsz  osmd  clay
		   cltp	 ccol  vs    vctr  pv	 anbl  sset  label
		   sech2 sbk   py    dy	   pyf	 dyf   stf   fldat
		   dfl2	 as    ass   bs	   bss	 bss1  bss2  fldat2
		   as2	 ass2  dtb   stb   shtrp spism mtr   hpa
		   hpn	 st    ang1  dy1   dy1f  dor   tt    dat1
		   dat2  dat3  dat4  dt    dop   ass1  ass2  nsum
		   lstn  dy1z  dyz   dz    dtz   lstn1 fldat3 trb
		   otv   osv
		  ) 

  (setq	dlg  (findfile (strcat pathdcl2 "element\\reshet.dcl"))
	dfl  (findfile (strcat pathlisp2 "element\\reshet.d"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "element\\heat.lsp"))
	dat1 (findfile (strcat pathdat2 "element\\heat.dat"))
	dat2 (findfile (strcat pathdat2 "element\\heat1.dat"))
	dat3 (findfile (strcat pathdat2 "element\\heat2.dat"))
	dat4 (findfile (strcat pathdat2 "element\\heat4.dat"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

  

;;;    
  (setq	spis '(""
	       ""
	       ""
	      )
  ) ;_  setq

;;;            
  (defun df_v ()
     (cond ((eq tipf "0")
	     (setq dyf '("159" "273" "325" "400" "600" "800" "1000"
			 "1200"	"1400")
	     ) ;_  setq
	     (setq dy1f '("20" "25" "38"))
	     (setq dfl2 dat2)
	   )
	   ((eq tipf "1")
	     (setq dyf '("325" "400" "600" "800" "1000" "1200" "1400")
	     ) ;_  setq
	     (setq dy1f '("20" "25"))
	     (setq dfl2 dat3)
	   )
	   ((eq tipf "2")
	     (setq dyf '("600" "800" "1000" "1200" "1400")
	     ) ;_  setq
	     (setq dy1f '("20" "25"))
	     (setq dfl2 dat4)
	   )
     ) ;_  cond
  ) ;_  defun



;;;      RESHET.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   dy	  (itoa (nth 1 strdd1))
	   dy1	  (itoa (nth 2 strdd1))
	   trb	  (itoa (nth 3 strdd1))
	   otv	  (itoa (nth 4 strdd1))
	   osv	  (itoa (nth 5 strdd1))
	   shtrp  (itoa (nth 6 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "D" dy)
    (set_tile "D1" dy1)
    (set_tile "S" (rtos s))
    (set_tile "D2" (rtos dor))
    (set_tile "T" (rtos tt))
    (set_tile "N" (rtos nsum))
    (set_tile "Trb" trb)
    (set_tile "Otv" otv)
    (set_tile "Osv" osv)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       RESHET.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " dy " " dy1 " " trb " " otv " " osv " " shtrp ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")(/= shtrp "3"))
	 (setq name1 (strcat pathdat2 "element\\reshet(1).slb"))
	)
	((and (eq tipf "1")(/= shtrp "3"))
	 (setq name1 (strcat pathdat2 "element\\reshet(2).slb"))
	)
	((and (eq tipf "2")(/= shtrp "3"))
	 (setq name1 (strcat pathdat2 "element\\reshet(3).slb"))
	)
	(t
	 (setq name1 (strcat pathdat2 "element\\reshet(4).slb"))
	)
  ) ;_  cond
) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;      
(defun desk_f1 ()
  (setq	fldat (open dat1 "r")
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	dor   (nth 1 bss)
	dop   (nth 2 bss)
	tt    (nth 3 bss)
	s     (nth 4 bss)
  ) ;_  setq
) ;_  defun


;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f1)
    ) ;_  defun

;;;      
(defun whl1 ()
  (if (/= dt bss1)
    (clos_dfl2)
  ) ;_  if 
  (while (/= dt bss1)
    (setq bs   (read-line fldat)
	  bss  (read bs)
	  bss1 (nth 0 bss)
	  dor  (nth 1 bss)
	  dop  (nth 2 bss)
	  tt   (nth 3 bss)
	  s    (nth 4 bss)
    ) ;_  setq
  ) ;_  while
) ;_  defun


;;;      
(defun desk_f2 ()
  (setq	fldat2 (open dfl2 "r")
	as     (read-line fldat2)
	ass    (read as)
	ass1   (nth 0 ass)
	ass2   (nth 1 ass)
	nsum   (nth 2 ass)
	lstn   (nth 3 ass)
  ) ;_  setq
) ;_  defun


;;;    
   (defun clos_dfl3 ()
      (close fldat2)
      (desk_f2)
    ) ;_  defun

;;;      
   (defun prd_z	()
      (setq dyz	 dy
	    dy1z dy1
	    dz	 d
	    dtz	 dt
      ) ;_  setq
   ) ;_  defun


;;;      
(defun whl2 ()
  (if (or (/= d ass1)
	  (/= dt ass2)
      ) ;_  or
    (clos_dfl3)
  ) ;_  if 
  (while (or (/= d ass1)
	     (/= dt ass2)
	 ) ;_  or
    (setq as  (read-line fldat2))
    (if	(= as nil)
      (progn
	(attn3)
	(setq d	  dz
	      dt  dtz
	      dy  dyz
	      dy1 dy1z
	) ;_  setq
	(desk_f2)
	(whl2)
	(set_tile "D" dy)
	(set_tile "D1" dy1)
      ) ;_  progn
      (setq ass (read as)
	    ass1 (nth 0 ass)
	    ass2 (nth 1 ass)
	    nsum (nth 2 ass)
	    lstn (nth 3 ass)
      ) ;_  setq
    ) ;_  if
  ) ;_  while
) ;_  defun

;;;       ( lstn1)
(defun desk_f3 ()
  (setq	fldat3 (open dat2 "r")
	as     (read-line fldat3)
	ass    (read as)
	ass1   (nth 0 ass)
	ass2   (nth 1 ass)
	lstn1  (nth 3 ass)
  ) ;_  setq
) ;_  defun


;;;     ( lstn1)
   (defun clos_dfl4 ()
      (close fldat3)
      (desk_f3)
    ) ;_  defun


;;;      ( lstn1)
(defun whl3 ()
  (if (or (/= d ass1)
	  (/= dt ass2)
      ) ;_  or
    (clos_dfl4)
  ) ;_  if 
  (while (or (/= d ass1)
	     (/= dt ass2)
	 ) ;_  or
    (setq as	(read-line fldat3)
	  ass	(read as)
	  ass1	(nth 0 ass)
	  ass2	(nth 1 ass)
	  lstn1	(nth 3 ass)
    ) ;_  setq
  ) ;_  while
) ;_  defun

;;;   
    (defun spis_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun


;;;   
    (defun dyf_l ()
      (start_list "D")
      (mapcar 'add_list dyf)
      (end_list)
    ) ;_  defun

;;;   
    (defun dy1f_l ()
      (start_list "D1")
      (mapcar 'add_list dy1f)
      (end_list)
    ) ;_  defun
  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun



;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -   
   (defun attn3 ()
        (new_dialog "att3" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun



;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "reshet" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (df_v)
    (spis_l)
    (dyf_l)
    (dy1f_l)
;;;           
    (setq d    (atof (nth (atoi dy) dyf))
	  dt   (atof (nth (atoi dy1) dy1f))
    ) ;_  setq
    (prd_z)
    (desk_f1)
    (whl1)
    (desk_f2)
    (whl2)
    (s_t)

    (mode_tile "Tipf" 2)

;;;     
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(df_v)"
	      "(dyf_l)"
	      "(dy1f_l)"
	      "(setq dy \"0\" dy1 \"0\")"
	      "(setq d  (atof (nth (atoi dy) dyf)))"
	      "(setq dt  (atof (nth (atoi dy1) dy1f)))"
	      "(prd_z)"
	      "(desk_f1)"
              "(whl1)"
	      "(desk_f2)"
              "(whl2)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(setq dy $value)"
	      "(setq dy1 \"0\")"
	      "(setq d  (atof (nth (atoi dy) dyf)))"
	      "(setq dt  (atof (nth (atoi dy1) dy1f)))"
	      "(prd_z)"
	      "(desk_f1)"
              "(whl1)"
	      "(desk_f2)"
              "(whl2)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D1"
      (strcat "(setq dy1 $value)"
	      "(setq dt  (atof (nth (atoi dy1) dy1f)))"
	      "(desk_f1)"
              "(whl1)"
	      "(desk_f2)"
              "(whl2)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile   
    (action_tile
      "Trb"
      (strcat "(setq trb $value)"
	      "(setq otv \"0\")"
	      "(setq osv \"0\")"
	      "(setq shtrp \"1\")"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Otv"
      (strcat "(setq otv $value)"
	      "(setq trb \"0\")"
	      "(setq osv \"0\")"
	      "(setq shtrp \"2\")"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Osv"
      (strcat "(setq osv $value)"
	      "(setq trb \"0\")"
	      "(setq otv \"0\")"
	      "(setq shtrp \"3\")"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 
  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 (- a1 (/ pi 2)))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  
;;;    
(cond ((eq tipf "0")
       (setq lstn1 lstn)
       (heat d dt dor s tt lstn lstn1 inptG a1 mb shtrp)
      )
      ((eq tipf "1")
       (desk_f3)
       (whl3)
       (heat d dt dor s tt lstn lstn1 inptG a1 mb shtrp)
      )
      ((eq tipf "2")
       (desk_f3)
       (whl3)
       (heat d dt dor s tt lstn lstn1 inptG a1 mb shtrp)
      )
) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "aperture" apsz)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  RESHET
