;;;     
;;;:  ..
;;; : 16.04.2004
;;;CAD-CEE 2000
;;;: C:BOBUSKA

(defun c:bobuska (/ tipf db d d0 d1 d2 d3 d4 d5 d6 h h2 b l s sech sprd
		    name1 orx aby dlg dfl lsp1 lsp2 lsp3 lsp4 lsp5 fld strd strdd
		    strd1 strdd1 p1 p2 p3 angl mash name1 spis pti inptG xc yc
		    dcl_id inptG a1 mb cmd blpm apsz osmd clay cltp ccol
		    vs vctr pv anbl sset label sech2 sbk py dy stf fldat dfl2
		    as ass bs bss bss1 bss2 fldat2 as2 ass2 dtb stb shtrp
		    spism mtr hpa hpn lb dat1 dat2 dat3 d1d d2d agl dyf sh l1 l2)

  (setq	dlg  (findfile (strcat pathdcl2 "element2\\bobuska.dcl"))
	dfl  (findfile (strcat pathlisp2 "element2\\bobuska.d"))
	dat1 (findfile (strcat pathdat2 "element2\\tip1.dat"))
	dat2 (findfile (strcat pathdat2 "element2\\tip2.dat"))
;;;	dat3 (findfile (strcat pathdat2 "element2\\tip3.dat"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "element2\\bobotr.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

  (setq spis '("  1"
	       "  2"
;;;	       "  6  4-6"
	      ) 
  ) ;_  setq

  
;;;      BOBUSKA.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   dy	  (itoa (nth 1 strdd1))
	   sech	  (itoa (nth 2 strdd1))
	   sprd	  (itoa (nth 3 strdd1))
	   sbk	  (itoa (nth 4 strdd1))
	   shtrp  (itoa (nth 5 strdd1))
	   d1d	  (nth 6 strdd1)
	   d2d	  (nth 7 strdd1)
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "D" dy)
    (set_tile "D1" (rtos d1))
    (set_tile "D2" (rtos d2))
    (set_tile "LB" (rtos lb))
    (set_tile "L" (rtos l))
    (set_tile "D0" (rtos d0))
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Shtr" shtrp)
;;;    (if	(= tipf "2")
;;;      (set_tile "A" (rtos agl))
;;;      (set_tile "A" " ")
;;;    ) ;_  if
    (if	(= tipf "0")
      (mode_tile "D2" 1)
      (mode_tile "D2" 0)
    ) ;_  if
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       BOBUSKA.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " dy " " sech " " sprd " " sbk " " shtrp
			    " " (rtos d1) " " (rtos d2) ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "element2\\termos(1).slb"))
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "element2\\termos(5).slb"))
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "element2\\termos(4).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "element2\\termos(2).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "element2\\termos(5).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "element2\\termos(4).slb"))
	)
;;;	((and (eq tipf "2")
;;;	      (eq sech "1")
;;;	      (eq sprd "0")
;;;	      (eq sbk "0")
;;;	 ) ;_  and
;;;	 (setq name1 (strcat pathdat2 "element2\\termos(3).slb"))
;;;	)
;;;	((and (eq tipf "2")
;;;	      (eq sech "0")
;;;	      (eq sprd "1")
;;;	      (eq sbk "0")
;;;	 ) ;_  and
;;;	 (setq name1 (strcat pathdat2 "element2\\termos(5).slb"))
;;;	)
;;;	((and (eq tipf "2")
;;;	      (eq sech "0")
;;;	      (eq sprd "0")
;;;	      (eq sbk "1")
;;;	 ) ;_  and
;;;	 (setq name1 (strcat pathdat2 "element2\\termos(4).slb"))
;;;	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;     
  (defun defl ()
    (setq dy "0")
  ) ;_  defun


;;;    
  (defun dfl_fn	()
    (cond ((= tipf "0") (setq dfl2 dat1))
	  ((= tipf "1") (setq dfl2 dat2))
;;;	  ((= tipf "2") (setq dfl2 dat3))
    ) ;_  cond
  ) ;_  defun

;;;      
(defun desk_f ()
  (setq	fldat (open dfl2 "r")
	as    (read-line fldat)
	dyf   (read as)
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	d     (nth 1 bss)
	sh    (nth 2 bss)
	d0    (nth 3 bss)
	lb    (nth 4 bss)
	l     (nth 5 bss)
	d1    (nth 6 bss)
	d2    (nth 7 bss)
  ) ;_  setq
) ;_  defun


 ;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun



;;;      
(defun whl ()
  (if (/= (atof dy) (atof bss1))
    (clos_dfl2)
  ) ;_  if 
  (while (/= (atof dy) (atof bss1))
    (setq bs   (read-line fldat)
	  bss  (read bs)
	  bss1 (nth 0 bss)
	  d    (nth 1 bss)
	  sh   (nth 2 bss)
	  d0   (nth 3 bss)
	  lb   (nth 4 bss)
	  l    (nth 5 bss)
	  d1   (nth 6 bss)
	  d2   (nth 7 bss)
    ) ;_  setq
  ) ;_  while
) ;_  defun


;;;    
    (defun tipf_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun


;;;    
    (defun dyf_l ()
      (start_list "D")
      (mapcar 'add_list dyf)
      (end_list)
    ) ;_  defun

;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* d2 mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(<= srv 2.0)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;         
;;;  : (os_ln h)
;;;      h -   
   (defun os_ln	(h / pt1)
         (setq pt1 (polar inptG (+ a1 (/ pi 2.0)) (* (* h 1.1) mb)))
         (command "_LAYER" "_S" " " "")
         (command "_LINE" inptG pt1 "")
         (setq label (entlast))
         (setq sset (ssadd (entlast)))
   ) ;_  defun

  
;;;       
;;;  : (os_ln2 d)
;;;      d -  
   (defun os_ln2 (d / pt1 pt2 pt3 pt4)
     (setq pt1 (polar inptG (+ a1 (/ pi 2.0)) (* (* d 0.75) mb))
	   pt2 (polar inptG (- a1 (/ pi 2.0)) (* (* d 0.75) mb))
	   pt3 (polar inptG (+ a1 pi) (* (* d 0.75) mb))
	   pt4 (polar inptG a1 (* (* d 0.75) mb))
     ) ;_  setq
     (command "_LAYER" "_S" " " "")
     (command "_LINE" pt1 pt2 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
     (command "_LINE" pt3 pt4 "")
   ) ;_  defun


;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun
  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "bobuska" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (dfl_fn)
    (desk_f)
    (whl)
    (setq d1 d1d
	  d2 d2d
    ) ;_  setq
    (tipf_l)
    (dyf_l)
    (s_t)
    
    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (mode_tile "Tipf" 2)

;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(defl)"
	      "(dfl_fn)"
	      "(desk_f)"
	      "(whl)"
	      "(dyf_l)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(setq dy $value)"
	      "(desk_f)"
	      "(whl)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D1"
      (strcat "(prv_p $value 'd1 \"D1\" \"r\")"
	      "(if (= tipf \"1\")"
	      "(prov 18 d1 d0 \"D1\" \"\")"
	      "(prov d d1 d0 \"D1\" \"\"))"
	      "(if (> d2 (- d1 4.0)) (setq d2 (- d1 4.0)))"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D2"
      (strcat "(prv_p $value 'd2 \"D2\" \"r\")"
	      "(prov 10 d2 (- d1 4.0) \"D2\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(close fldat)(done_dialog)")
    (action_tile "cancel" "(close fldat)(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 (- a1 (/ pi 2)))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* lb mb) 2))
    (command "_ZOOM" "_C" inptG (* (* lb mb) 2))
  ) ;_  if

;;;     
  (setq	l1  10.0
	l2  20.0
	d3  13.5
  ) ;_  setq

  
;;;    
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (os_ln lb)
	 (bobotr d sh d0 d1 d2 d3 lb l l1 l2 inptG a1 mb 1 shtrp)
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (os_ln2 d0)
	 (bobotr2 d sh d0 inptG a1 mb)
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (os_ln lb)
	 (bobotr3 d0 d1 lb l1 inptG a1 mb)
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (os_ln lb)
	 (bobotr d sh d0 d1 d2 d3 lb l l1 l2 inptG a1 mb 2 shtrp)	 
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (os_ln2 d0)
	 (bobotr2 d sh d0 inptG a1 mb)
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (os_ln lb)
	 (bobotr3 d0 d1 lb l1 inptG a1 mb)
	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  BOBUSKA
