;;;   
;;;:  ..
;;; : 22.01.2001
;;;CAD-CEE 2000
;;;: C:FLANOS1

(defun c:flanos1 (/ tipf db d dotv notv d1 d2 d3 d4 d5 d6 h h2 b l s sech sprd
		    name1 orx aby dlg dfl lsp1 lsp2 lsp3 lsp4 lsp5 fld strd strdd
		    strd1 strdd1 p1 p2 p3 angl mash name1 spis pti inptG xc yc
		    dcl_id rezos fe inptG a1 mb cmd blpm apsz osmd clay cltp ccol
		    vs vctr pv anbl sset label sech2 sbk shtr hpa hpn osv1)

  (setq	dlg  (findfile (strcat pathdcl2 "flan\\flan.dcl"))
	dfl  (findfile (strcat pathlisp2 "flan\\flanos1.d"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "flan\\flsvst.lsp"))
	lsp2 (findfile (strcat pathlisp2 "flan\\flvst.lsp"))
	lsp3 (findfile (strcat pathlisp2 "flan\\flvpd.lsp"))
	lsp4 (findfile (strcat pathlisp2 "flan\\flshp.lsp"))
	lsp5 (findfile (strcat pathlisp2 "flan\\flpaz.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)
  (load lsp2)
  (load lsp3)
  (load lsp4)
  (load lsp5)

  (setq spis '("  . "
	       "  "
	       "  "
	       "  "
	       "  "
	       " ()"
	      ) 
  ) ;_  setq

;;;    ( )
  (defun upm_vs (/ dlo)
    (if	(eq tipf "5")
      (progn
	(setq h 0)
	(setq d2 0)
	(setq d (+ db 100))
	(setq d1 (+ db 50))
	(setq dlo (* pi d1))
	(setq notv (fix (/ dlo 120.0)))
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  
;;;      FLANOS1.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   db	  (nth 1 strdd1)
	   d	  (nth 2 strdd1)
	   dotv	  (nth 3 strdd1)
	   notv	  (nth 4 strdd1)
	   d1	  (nth 5 strdd1)
	   d2	  (nth 6 strdd1)
	   d3	  (nth 7 strdd1)
	   d4	  (nth 8 strdd1)
	   d5	  (nth 9 strdd1)
	   d6	  (nth 10 strdd1)
	   h	  (nth 11 strdd1)
	   h2	  (nth 12 strdd1)
	   b	  (nth 13 strdd1)
	   l	  (nth 14 strdd1)
	   s	  (nth 15 strdd1)
	   sech	  (itoa (nth 16 strdd1))
	   sprd	  (itoa (nth 17 strdd1))
	   sbk	  (itoa (nth 18 strdd1))
	   shtr	  (itoa (nth 19 strdd1))
	   osv1	  (itoa (nth 20 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (setq fe 0)
    (set_tile "Tipf" tipf)
    (set_tile "Db" (rtos db))
    (set_tile "D" (rtos d))   
    (set_tile "Dotv" (rtos dotv))
    (set_tile "Notv" (itoa notv))
    (set_tile "D1" (rtos d1))
    (set_tile "H" (rtos h))
    (set_tile "B" (itoa b))
    (set_tile "L" (itoa l))
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Shtr" shtr)
    (set_tile "Osv" osv1)
    (if	(= db 0.0)
      (progn
	(mode_tile "L" 1)
	(mode_tile "S" 1)
      ) ;_  progn
      (progn
	(mode_tile "L" 0)
      ) ;_  progn
    ) ;_  if
    (vtr)
    (shtr_f)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       FLANOS1.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " (rtos db) " " (rtos d) " " (rtos dotv) " "
			    (itoa notv) " " (rtos d1) " " (rtos d2) " " (itoa d3) " "
			    (itoa d4) " " (itoa d5)  " " (itoa d6) " " (rtos h) " "
			    (rtos h2) " " (itoa b) " " (itoa l) " " (rtos s) " "
			    sech " " sprd " " sbk " " shtr " " osv1 ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(1).slb"))
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(2).slb"))
	)
	((and (eq tipf "0")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(11).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(3).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(4).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(12).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(5).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(6).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(13).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(7).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(8).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(14).slb"))
	)
	((and (eq tipf "4")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(9).slb"))
	)
	((and (eq tipf "4")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(10).slb"))
	)
	((and (eq tipf "4")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(11).slb"))
	)
	((and (eq tipf "5")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(1).slb"))
	)
	((and (eq tipf "5")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(2).slb"))
	)
	((and (eq tipf "5")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "flan\\flani(11).slb"))
	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;  D2-D6
  (defun nfn ()
    (set_tile "D2" "")
    (set_tile "D3" "")
    (set_tile "D4" "")
    (set_tile "D5" "")
    (set_tile "D6" "")
    (set_tile "H2" "")
  )  


;;;     
  (defun vtr()
    (cond ((eq tipf "0")
	   (mode_tile "D2" 0)
	   (mode_tile "D3" 1)
	   (mode_tile "D4" 1)
	   (mode_tile "D5" 1)
	   (mode_tile "D6" 1)
	   (mode_tile "H2" 1)
	   (nfn)
	   (set_tile "D2" (rtos d2))
	  )
	  ((eq tipf "1")
	   (mode_tile "D2" 1)
	   (mode_tile "D3" 1)
	   (mode_tile "D4" 0)
	   (mode_tile "D5" 1)
	   (mode_tile "D6" 1)
	   (mode_tile "H2" 1)
	   (nfn)
	   (set_tile "D4" (itoa d4))
	  )
	  ((eq tipf "2")
	   (mode_tile "D2" 0)
	   (mode_tile "D3" 1)
	   (mode_tile "D4" 1)
	   (mode_tile "D5" 1)
	   (mode_tile "D6" 0)
	   (mode_tile "H2" 0)
	   (nfn)
	   (set_tile "D2" (rtos d2))
	   (set_tile "D6" (itoa d6))
	   (set_tile "H2" (rtos h2))
	  )
	  ((eq tipf "3")
	   (mode_tile "D2" 1)
	   (mode_tile "D3" 0)
	   (mode_tile "D4" 0)
	   (mode_tile "D5" 1)
	   (mode_tile "D6" 1)
	   (mode_tile "H2" 1)
	   (nfn)
	   (set_tile "D3" (itoa d3))
	   (set_tile "D4" (itoa d4))
	  )
	  ((eq tipf "4")
	   (mode_tile "D2" 0)
	   (mode_tile "D3" 1)
	   (mode_tile "D4" 1)
	   (mode_tile "D5" 0)
	   (mode_tile "D6" 0)
	   (mode_tile "H2" 0)
	   (nfn)
	   (set_tile "D2" (rtos d2))
	   (set_tile "D5" (itoa d5))
	   (set_tile "D6" (itoa d6))
	   (set_tile "H2" (rtos h2))
	  )
          ((eq tipf "5")
	   (mode_tile "D2" 0)
	   (mode_tile "D3" 1)
	   (mode_tile "D4" 1)
	   (mode_tile "D5" 1)
	   (mode_tile "D6" 1)
	   (mode_tile "H2" 1)
	   (nfn)
	   (set_tile "D2" (rtos d2))
	  )
    ) ;_  cond
  )

;;;     
  (defun shtr_f ()
    
    (if	(or (= db 0) (= l 0))
      (progn (mode_tile "S" 1)
	     (set_tile "S" "")
      ) ;_  progn
      (progn (mode_tile "S" 0)
	     (set_tile "S" (rtos s))
	     ;(mode_tile "S" 2)
      ) ;_  progn
    ) ;_  if
    
  ) ;_  defun



;;;    
    (defun tipf_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun


;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

   
;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun


;;;    
(defun prov_gl (/ r1 r2 r3 r4 r5 r6 r7 r8 r9 r6a r6b)
  (cond	((or (eq tipf "0")(eq tipf "5"))
	 (if (> d2 (- d1 dotv 1))
	   (progn
	     (mode_tile "D2" 2)
	     (setq rezos 0)
	   ) ;_  progn
	   (setq rezos 1)
	 ) ;_  if
	)
	((eq tipf "1")
	 (if (= d4 0)
	   (progn
	     (mode_tile "D4" 2)
	     (setq rezos 0)
	   ) ;_  progn
	   (setq rezos 1)
	 ) ;_  if
	)
	((eq tipf "2")
	 (if (= d2 0)
	   (progn
	     (mode_tile "D2" 2)
	     (setq r1 0)
	   ) ;_  progn
	   (setq r1 1)
	 ) ;_  if
	 (if (= d6 0)
	   (progn
	     (mode_tile "D6" 2)
	     (setq r2 0)
	   ) ;_  progn
	   (setq r2 1)
	 ) ;_  if
	 (if (= h2 0)
	   (progn
	     (mode_tile "H2" 2)
	     (setq r3 0)
	   ) ;_  progn
	   (setq r3 1)
	 ) ;_  if
	 (if (or (= r1 0) (= r2 0) (= r3 0))
	   (setq rezos 0)
	   (setq rezos 1)
	 ) ;_  if
	)
	((eq tipf "3")
	 (if (= d3 0)
	   (progn
	     (mode_tile "D3" 2)
	     (setq r1 0)
	   ) ;_  progn
	   (setq r1 1)
	 ) ;_  if
	 (if (= d4 0)
	   (progn
	     (mode_tile "D4" 2)
	     (setq r2 0)
	   ) ;_  progn
	   (setq r2 1)
	 ) ;_  if
	 (if (or (= r1 0) (= r2 0))
	   (setq rezos 0)
	   (setq rezos 1)
	 ) ;_  if
	)
	((eq tipf "4")
	 (if (= d2 0)
	   (progn
	     (mode_tile "D2" 2)
	     (setq r1 0)
	   ) ;_  progn
	   (setq r1 1)
	 ) ;_  if
	 (if (= d5 0)
	   (progn
	     (mode_tile "D5" 2)
	     (setq r2 0)
	   ) ;_  progn
	   (setq r2 1)
	 ) ;_  if
	 (if (= d6 0)
	   (progn
	     (mode_tile "D6" 2)
	     (setq r3 0)
	   ) ;_  progn
	   (setq r3 1)
	 ) ;_  if
	 (if (= h2 0)
	   (progn
	     (mode_tile "H2" 2)
	     (setq r4 0)
	   ) ;_  progn
	   (setq r4 1)
	 ) ;_  if
	 (if (or (= r1 0) (= r2 0) (= r3 0) (= r4 0))
	   (setq rezos 0)
	   (setq rezos 1)
	 ) ;_  if
	)
  ) ;_  cond

  (if (= b 0)
    (progn
      (mode_tile "B" 2)
      (setq r5 0)
    ) ;_  progn
    (setq r5 1)
  ) ;_  if
  (if (< h 0); 
    (progn
      (mode_tile "H" 2)
      (setq r6 0)
    ) ;_  progn
    (setq r6 1)
  ) ;_  if
  (if (= notv 0)
    (progn
      (mode_tile "Notv" 2)
      (setq r6a 0)
    ) ;_  progn
    (setq r6a 1)
  ) ;_  if
  (if (= dotv 0)
    (progn
      (mode_tile "Dotv" 2)
      (setq r6b 0)
    ) ;_  progn
    (setq r6b 1)
  ) ;_  if
  (if (= d1 0)
    (progn
      (mode_tile "D1" 2)
      (setq r7 0)
    ) ;_  progn
    (setq r7 1)
  ) ;_  if
  (if (= d 0)
    (progn
      (mode_tile "D" 2)
      (setq r8 0)
    ) ;_  progn
    (setq r8 1)
  ) ;_  if
;;;  (if (= db 0)
;;;    (progn
;;;      (mode_tile "Db" 2)
;;;      (setq r9 0)
;;;    ) ;_  progn
;;;    (setq r9 1)
;;;  ) ;_  if
  (if (or (eq rezos 0) (= r5 0) (= r6 0) (= r6a 0) (= r6b 0) (= r7 0) (= r8 0) (= r9 0))
    (setq rezos 0)
    (setq rezos 1)
  ) ;_  if

  (if (= rezos 1)
    (done_dialog)
    (attn3)
  ) ;_  if
) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
    (setq srv (* dotv mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

  
;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;   -   
   (defun attn3 ()
        (new_dialog "att3" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun



;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "flanotr" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (if (= h 0) (setq d2 (- d1 dotv 1)))
    (upm_vs)
    (s_t)
    (tipf_l)
    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (mode_tile "Tipf" 2)
    

;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(if (= h 0) (setq d2 (- d1 dotv 1)))"
	      "(upm_vs)"
	      "(vtr)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Db"
      (strcat "(prv_p $value 'db \"Db\" \"r\")"
	      "(prov 0 db 5000 \"Db\" \"\")"
	      "(upm_vs)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(prv_p $value 'd \"D\" \"r\")"
	      "(prov (+ db 65) d 5000 \"D\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D1"
      (strcat "(prv_p $value 'd1 \"D1\" \"r\")"
	      "(prov (+ db 30) d1 (- d dotv 10) \"D1\" \"\")"
	      "(if (eq tipf \"5\") (setq notv (fix (/ (* d1 pi) 120.0))))"
	      "(if (eq tipf \"5\") (s_t))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D2"
      (strcat "(prv_p $value 'd2 \"D2\" \"r\")"
	      "(if (/= tipf \"5\")"
	      "(prov db d2 (- d1 dotv 1) \"D2\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D3"
      (strcat "(prv_p $value 'd3 \"D3\" \"i\")"
	      "(prov db d3 (- d1 dotv 16) \"D3\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D4"
      (strcat "(prv_p $value 'd4 \"D4\" \"i\")"
	      "(if (eq tipf \"1\") (prov db d4 d1 \"D4\" \"\")"
	      "(prov (+ d3 6) d4 (- d1 dotv 5) \"D4\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D5"
      (strcat "(prv_p $value 'd5 \"D5\" \"i\")"
	      "(prov db d5 (- d1 dotv 16) \"D5\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D6"
      (strcat "(prv_p $value 'd6 \"D6\" \"i\")"
	      "(if (eq tipf \"2\") (prov db d6 d2 \"D6\" \"\")"
	      "(prov (+ d5 6) d6 (- d1 dotv 5) \"D6\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Dotv"
      (strcat "(prv_p $value 'dotv \"Dotv\" \"i\")"
	      "(prov 10 dotv (- (/ (- d db) 2.0) 22.0) \"Dotv\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Notv"
      (strcat "(prv_p $value 'notv \"Notv\" \"i\")"
	      "(prov 2 notv (fix (/ (/ (* pi d1) dotv) 1.1)) \"Notv\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "H"
      (strcat "(prv_p $value 'h \"H\" \"r\")"
	      "(prov 0 h 6 \"H\" \"\")"
	      "(if (= h 0) (setq d2 (- d1 dotv 1)))"
	      "(vtr)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "H2"
      (strcat "(prv_p $value 'h2 \"H2\" \"r\")"
	      "(prov 3 h2 5 \"H2\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "B"
      (strcat "(prv_p $value 'b \"B\" \"i\")"
	      "(prov 8 b 125 \"B\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "L"
      (strcat "(prv_p $value 'l \"L\" \"i\")"
	      "(shtr_f)"
	      "(if (> l 0) (prov (+ b 10) l 5000 \"L\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S"
      (strcat "(prv_p $value 's \"S\" \"r\")"
	      "(prov 1 s 20 \"S\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Osv"
      (strcat "(setq osv1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtr $value)"
      ) ;_  strcat
    ) ;_  action_tile


    (action_tile "accept" "(prov_gl)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
      ) ;_  if
    ) ;_  progn
    (setq a1 (- (* pi (/ (atof angl) 180)) (/ pi 2)))
  ) ;_  if

;;;      
  (setq a1 (+ a1 (/ pi 2)))
 

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))
  (if (> d (+ l b))
    (setq pv (* d mb))
    (setq pv (* (+ l b) mb))
  ) ;_  if

  (if (< vs (* pv 2))
    (command "_ZOOM" "_C" inptG (* pv 2))
  ) ;_  if

  (if (= l 0) (setq l 3.0)) ; 
  
;;;    
  (cond	((and (or (eq tipf "0")(eq tipf "5"))
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and  
	 (if (eq osv1 "0")
	   (flsvst inptG db d d1 d2 dotv notv h b (- l 3.0) s 0 shtr a1)
	   (flsvst inptG db d d1 d2 dotv notv h b (- l 3.0) s 4 shtr a1)
	 ) ;_  if
	)
	((and (or (eq tipf "0")(eq tipf "5"))
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (flsvst inptG db d d1 d2 dotv notv h b (- l 3.0) s 1 shtr a1)
	)
	((and (or (eq tipf "0")(eq tipf "5"))
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (flsvst inptG db d d1 d2 dotv notv h b (- l 3.0) s 2 shtr a1)
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (if (eq osv1 "0")
	    (flvst inptG db d d1 d4 dotv notv h b (- l 3.0) s 0 shtr a1)
	    (flvst inptG db d d1 d4 dotv notv h b (- l 3.0) s 4 shtr a1)
	 ) ;_  if
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (flvst inptG db d d1 d4 dotv notv h b (- l 3.0) s 1 shtr a1)
	)
	((and (eq tipf "1")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (flvst inptG db d d1 d4 dotv notv h b (- l 3.0) s 2 shtr a1)
	)
	((and (eq tipf "2")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (if (eq osv1 "0")
	    (flvpd inptG db d d1 d2 d6 dotv notv h h2 b (- l 3.0) s 0 shtr a1)
	    (flvpd inptG db d d1 d2 d6 dotv notv h h2 b (- l 3.0) s 4 shtr a1)
	 ) ;_  if
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (flvpd inptG db d d1 d2 d6 dotv notv h h2 b (- l 3.0) s 1 shtr a1)
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (flvpd inptG db d d1 d2 d6 dotv notv h h2 b (- l 3.0) s 2 shtr a1)
	)
	((and (eq tipf "3")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (if (eq osv1 "0")
	    (flshp inptG db d d1 d3 d4 dotv notv h b (- l 3.0) s 0 shtr a1)
	    (flshp inptG db d d1 d3 d4 dotv notv h b (- l 3.0) s 4 shtr a1)
	 ) ;_  if
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (flshp inptG db d d1 d3 d4 dotv notv h b (- l 3.0) s 1 shtr a1)
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (flshp inptG db d d1 d3 d4 dotv notv h b (- l 3.0) s 2 shtr a1)
	)
	((and (eq tipf "4")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	  (if (eq osv1 "0")
	    (flpaz inptG db d d1 d2 d5 d6 dotv notv h h2 b (- l 3.0) s 0 shtr a1)
	    (flpaz inptG db d d1 d2 d5 d6 dotv notv h h2 b (- l 3.0) s 4 shtr a1)
	  ) ;_  if
	)
	((and (eq tipf "4")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (flpaz inptG db d d1 d2 d5 d6 dotv notv h h2 b (- l 3.0) s 1 shtr a1)
	)
	((and (eq tipf "4")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (flpaz inptG db d d1 d2 d5 d6 dotv notv h h2 b (- l 3.0) s 2 shtr a1)
	)
  ) ;_  cond

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  FLANOS1
