;;;:  ..
;;; : 06.10.2000
;;;CAD-CEE 2000

;;;;;;;;;;;;;;;  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun uzelfas ( / cmd blpm apsz osmd clay cltp ccol rfas cpt pt1 pt1f
                   pt1fug pt1fun pt5f pt5fu pt9 pt9un pt9uv pt200 pt201
                   pt202 pt203 pt204 pt205 pt206 label1 sset1 tvst inpt0
		   a1)


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq oscor (getvar "osnapcoord"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osnapcoord" 1) 

  ;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )

     (defun ton ()
          (command "_'layer" "_s" "" "")
      )

  
 (if (eq fasn1 "1")
     (setq rfas fas1)
     (setq rfas fas2)
 )
 

  (defun ris_uzel ()

    (setq cpt inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)

    (if	(> htv rfas)
      (setq rfas htv)
    ) ;_  if
    
;;-------------------   -------------------- 
 (setq pt1    (polar cpt (+ (/ pi 2) a1) (* (- (* 0.5 dmtr) htv) mb)) 
       pt1f   (polar pt1 (+ 0 a1) (* rfas mb))
       pt1fug (polar pt1f (+ 0 a1) (* (* 1.2 rfas) mb))
       pt1fun (polar pt1f (+ (- (/ pi 2)) a1) (* (* 1.2 rfas) mb))
       pt5f   (polar pt1f (+ (/ (* pi 3) 4) a1) (* (* (sqrt 2.0) htv) mb))
       pt5fu  (polar pt5f (+ 0 a1) (* (+ htv (* 1.2 rfas)) mb))
       pt9    (polar pt1 (+ (/ pi 2) a1) (* rfas mb))
       pt9un  (polar pt9 (+ (- (/ pi 2)) a1) (* (+ rfas (* 1.2 rfas)) mb))
       pt9uv  (polar pt9 (+ (/ pi 2) a1) (* (* 1.2 rfas) mb))
   )
;;-----------------------------------------------------------------

;;-------------------   ----------------------
 (setq pt200 (polar cpt (+ (/ pi 2) a1) (* (- (* dmtr 0.5) rfas) mb))
       pt201 (polar pt200 (+ (/ pi 4) a1) (* (* rfas (sqrt 2.0)) mb))
       pt202 (polar pt201 (+ 0 a1) (* htv mb))
       pt203 (polar pt202 (+ (- (/ pi 2)) a1) (* htv mb))
       pt204 (polar pt201 (+ (- (/ pi 2)) a1) (* (+ rfas htv) mb))
       pt205 (polar pt200 (+ (- (/ pi 2)) a1) (* htv mb))
       pt206 (polar pt201 (+ (- (* (/ pi 4) 3)) a1) (* (* htv (sqrt 2.0)) mb))
 )
;;-----------------------------------------------------------------
(defun uzelvntfas ()
  (osn)
  (command "_line" pt9uv pt9un "")
      (setq label1 (entlast)
	    sset1   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt9 pt1f pt1fug ""
            "_line" pt1f pt1fun "")
  (ton)
  (command "_line" pt5f pt5fu "")
  (command "_pline" pt9un "_a" "_r" (* (* 1.5 rfas) mb) pt1fun
                               "_r" (* (* 1.5 rfas) mb) pt1fug 
                               "_r" (* (* 1.5 rfas) mb) pt5fu 
                               "_r" (* (* 2.0 rfas) mb) pt9uv "")

) ;end of uzelvntfas----------------------------------------------
;;-----------------------------------------------------------------
(defun uzelnarfas ()
   (osn)
   (command "_line" pt200 pt205 "")
      (setq label1 (entlast)
	    sset1   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt202 pt201 pt204 ""
            "_line" pt200 pt201 "")
  (ton)
  (command "_line" pt203 pt206 "")
  (command "_pline" pt205 "_a" "_r" (* (* 1.5 rfas) mb) pt204
                               "_r" (* (* 2 rfas) mb) pt203
                               "_r" (* (* 2 rfas) mb) pt202 "")
      
) ;end of uzelnarfas----------------------------------------------

(if (eq strg1 "1")
    (progn (setq tvst pt200) (uzelnarfas))
    (progn (setq tvst pt1f) (uzelvntfas))
)

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label1 (entnext label1))
      (setq sset1 (ssadd label1 sset1))
    ) ;_ end of while
  ) ;_end of RIS-UZEL

  
;;;   
(defun show_z ()
  (setq	dcl_id
	 (load_dialog (strcat pathdcl2 "kons1\\rgbd.dcl")) ; _ end of
					; load_dialog
  )					; DCL-

  (new_dialog "ins1" dcl_id)
 
  (set_tile "vst" "  ")

  (setq p3 "0")
  (set_tile "per3" "0")
  (rdfl)

  (pred)

  (action_tile "xcor" "(setq xc $value)")
  (action_tile "ycor" "(setq yc $value)")

  (action_tile "Mash" "(setq mash $value)(pred)")
  (action_tile "Angl" "(setq angl $value)")

  (action_tile
    "per1"
    (strcat
      "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
      "(mode_tile \"ycor\" 0)) (progn (mode_tile \"xcor\" 1)"
      "(mode_tile \"ycor\" 1) (setq xc nil yc nil) (set_tile \"xcor\" \"0\")"
      "(set_tile \"ycor\" \"0\")))"
    ) ;_  strcat
  ) ;_  action_tile
  (action_tile
    "per2"
    (strcat
      "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
      "(progn (mode_tile \"Angl\" 1) (setq angl nil) (set_tile \"Angl\" \"0\")))"
    ) ;_  strcat
  ) ;_  action_tile
  (action_tile "per3" "(setq p3 $value)")

  (action_tile "accept" "(done_dialog)")
  (action_tile "cancel" "(exit)")

  (start_dialog)			;    


  (unload_dialog dcl_id)
  (prin1)
) ;_  defun


(defun clip_bl1 ()
    

    (if (= y_p 1)
           (show_z)
    )  

    (initget 1) 
    (if (eq p1 "1")
             (setq inpt0 (getpoint "\n    :"))
             (setq inpt0 (list (atof xc) (atof yc)))
    )
    (if (eq p2 "1")
             (progn 
                  (setq a1 (getangle inpt0 (strcat "\n   <" angl ">:")))
	          (if (= a1 nil)
		           (setq a1 (atof angl))
		  )
	      )
             (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if 
    (setq mb (atof mash))

    (if	(not (>= htv (* 0.5 dmtr)))
      (progn
	(ris_uzel)
	(if (eq p3 "0")
	  (anblk sset1 cpt)
	) ;_  if
      ) ;_  progn
      (alert "  .  ")
    ) ;_  if

    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun
 (clip_bl1)
  (prin1)
)
