;;;:  ..
;;; : 06.10.2000
;;;CAD-CEE 2000

;;;;;;;;;;;;;;;  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun uzelned ( / cmd blpm apsz osmd clay cltp ccol dlnd pt3 pt3g pt3v
                   pt3vv pt3n pt7g pt7 pt7vv pt7v pt300 pt301 pt302 pt303 
                   pt304 pt305 pt306 pt307 label1 sset1 tvst inpt0 a1)

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq oscor (getvar "osnapcoord"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osnapcoord" 1) 

  ;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )

     (defun ton ()
          (command "_'layer" "_s" "" "")
      )


  
 (if (eq ndrn1 "1")
     (setq dlnd lndn)
     (setq dlnd lndu)
 )

  (defun ris_uzeln ()

    (setq pt3 inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)
    
;;------------------   --------------------
 (setq pt3g  (polar pt3 (+ pi a1) (* (+ htv dlnd) mb))
       pt3v  (polar pt3 (+ (- (/ pi 2)) a1) (* (* 2.5 htv) mb))
       pt3vv (polar pt3 (+ (/ pi 2) a1) (* (* 2.0 htv) mb))
       pt3n  (polar pt3 (+ (- (/ pi 3)) a1) (* (* 2 htv) mb))
       pt7g  (polar pt3g (+ (/ pi 2) a1) (* htv mb))
       pt7   (polar pt7g (+ 0 a1) (* htv mb))
       pt7vv (polar pt7 (+ (/ pi 2) a1) (* (* 1.5 htv) mb))
       pt7v  (polar pt7 (+ (- (/ pi 2)) a1) (* (* 3.5 htv) mb))
   )
;;------------------   -----------------------
 (setq pt300 (polar pt3 (+ 0 a1) (* dlnd mb))
       pt301 (polar pt3 (+ pi a1) (* htv mb))
       pt302 (polar pt301 (+ (- (/ pi 2)) a1) (* htv mb))
       pt303 (polar pt3 (+ (- (/ pi 2)) a1) (* (* 2 htv) mb))
       pt304 (polar pt303 (+ 0 a1) (* dlnd mb))
       pt305 (polar pt300 (+ 0 a1) (* htv mb))
       pt306 (polar pt300 (+ (/ pi 2) a1) (* htv mb))
       pt307 (polar pt3 (+ (- (/ pi 2)) a1) (* htv mb))
 ) 
;;-------------------------------------------------------------------
(defun uzelvnned ()
   (osn)
   (command "_line" pt3 pt3n "")
      (setq label1 (entlast)
	    sset1   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt3v pt3 pt3g ""
            "_line" pt7v pt7 "")
  (ton)
  (command "_line" pt7 pt7g "")
  (command "_pline" pt7g "_a" "_r" (* (* 2.7 htv) mb) pt3g 
                              "_r" (* (* 3 htv) mb) pt7v 
                              "_r" (* (* 1.5 dlnd) mb) pt3v 
                              "_r" (* (* 2 htv) mb) pt3n 
                              "_r" (* (* 0.5 dlnd) mb) pt3vv 
                              "_r" (* (* 1.1 dlnd) mb) pt7vv 
                              "_r" (* (* 2.5 htv) mb) pt7g "")    
) ;_end of uzelvnned
;;--------------------------------------------------------------------
(defun uzelnarned ()
   (osn)
   (command "_line" pt3 pt303 "")
      (setq label1 (entlast)
	    sset1   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt306 pt304 ""
            "_line" pt300 pt301 "")
  (ton)
  (command "_line" pt307 pt302 "")
  (command "_pline" pt301 "_a" "_r" (* (* 2 htv) mb) pt302 
                               "_r" (* (* 2 htv) mb) pt303 
                               "_r" (* (* 1.5 dlnd) mb) pt304 
                               "_r" (* (* 2 htv) mb) pt305 
                               "_r" (* (* 1.2 htv) mb) pt306 "")  
) ;_end of uzelnarned
;;--------------------------------------------------------------------
(if (eq strg1 "1")
    (progn (setq tvst pt300) (uzelnarned))
    (progn (setq tvst pt7v) (uzelvnned))
)

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label1 (entnext label1))
      (setq sset1 (ssadd label1 sset1))
    ) ;_ end of while
  ) ;_end of RIS-UZELN

  
;;;   
(defun show_z ()
  (setq	dcl_id
	 (load_dialog (strcat pathdcl2 "kons1\\rgbd.dcl")) ; _ end of
					; load_dialog
  )					; DCL-

  (new_dialog "ins1" dcl_id)
 
  (set_tile "vst" "  ")

  (setq p3 "0")
  (set_tile "per3" "0")
  
  (rdfl)

  (pred)

  (action_tile "xcor" "(setq xc $value)")
  (action_tile "ycor" "(setq yc $value)")

  (action_tile "Mash" "(setq mash $value)(pred)")
  (action_tile "Angl" "(setq angl $value)")

  (action_tile
    "per1"
    (strcat
      "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
      "(mode_tile \"ycor\" 0)) (progn (mode_tile \"xcor\" 1)"
      "(mode_tile \"ycor\" 1) (setq xc nil yc nil) (set_tile \"xcor\" \"0\")"
      "(set_tile \"ycor\" \"0\")))"
    ) ;_  strcat
  ) ;_  action_tile
  (action_tile
    "per2"
    (strcat
      "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
      "(progn (mode_tile \"Angl\" 1) (setq angl nil) (set_tile \"Angl\" \"0\")))"
    ) ;_  strcat
  ) ;_  action_tile
  (action_tile "per3" "(setq p3 $value)")

  (action_tile "accept" "(done_dialog)")
  (action_tile "cancel" "(exit)")

  (start_dialog)			;    


  (unload_dialog dcl_id)
  (prin1)
) ;_  defun


(defun clip_bl2 ()
    

    (if (= y_p 1)
           (show_z)
    )  

    (initget 1) 
    (if (eq p1 "1")
             (setq inpt0 (getpoint "\n    :"))
             (setq inpt0 (list (atof xc) (atof yc)))
    )
    (if (eq p2 "1")
             (progn 
                  (setq a1 (getangle inpt0 (strcat "\n   <" angl ">:")))
	          (if (= a1 nil)
		           (setq a1 (atof angl))
		  )
	      )
             (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if 
    (setq mb (atof mash))
    
    (if	(not (>= htv (* 0.5 dmtr)))
      (progn
	(ris_uzeln)
	(if (eq p3 "0")
	     (anblk sset1 pt3)
	) ;_  if
      ) ;_  progn
      (alert "  .  ")
    ) ;_  if


    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun
  
 (clip_bl2)
  (prin1)
)
