;;;:  ..
;;; : 06.10.2000
;;;CAD-CEE 2000


;;;;;;;;;;;;;;;  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun uzelprt ( / cmd blpm apsz osmd clay cltp ccol bprt rprt r1prt 
                   pt11 pt11g pt11vn pt13 pt13vv pt15 pt15vv pt17 pt19vn 
                   pt19 cpv11 pt21 pt21vv pt21vn pt21g pt23 pt33 pt31vn 
                   pt31g pt33v pt35 lbpr1 lbpr2 bpr3 ypr3 cpvp1 cptp1 
                   pt37 pt37vv pt37vn pt37g ybsq zz pt35v pt41 pt41g 
                   pt41vv pt119 pt121 pt123 pt125 pt115 pt113 pt119g 
                   pt121g pt119v pt111v pt115v pt113g pt113v pt113vn 
                   cpv9 pt127 pt129 cpv10 pt131 b1pr2n b2pr2n b3pr2n 
                   b4pr2n pt133 pt131v kt1q pt135 pt127g pt135g pt127v 
                   pt131vn pt133v pt131g label3 sset3 tvst koef
                   koef1 koef2 inpt0 a1)

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq oscor (getvar "osnapcoord"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osnapcoord" 1) 

   ;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


     (defun osn ()
	   (command "_'layer" "_s" "" "")
       )

     (defun ton ()
          (command "_'layer" "_s" "" "")
      )

      (if (eq prtn1 "1")
	(setq bprt  bprn
	      rprt  rprn
	      r1prt r1prn
	) ;_ end of setq
	(setq bprt  bpru
	      rprt  rpru
	      r1prt r1pru
	) ;_ end of setq
      ) ;_ end of if

  (defun ris_uzelp ()

    (setq pt11 inpt0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)

;;------------------------- I .---------------------------------------

 (if (or  (eq prtu1 "0") 
          (and (/= shagv 1.0) 
               (/= shagv 1.25)
               (/= shagv 1.5)
               (/= shagv 2.0)
               (/= shagv 2.5)
               (/= shagv 3.0)
               (/= shagv 3.5)
               (/= shagv 4.0)
               (/= shagv 4.5)
               (/= shagv 5.0)
          ) ;_end of and
      ) ;_end of or
     (setq koef 1.0) 
   (cond ((eq shagv 1.0) (setq koef 1.4)) 
         ((eq shagv 1.25) (setq koef 1.4))
         ((eq shagv 1.5) (setq koef 1.6))
         ((eq shagv 2.0) (setq koef 1.4)) 
         ((eq shagv 2.5) (setq koef 1.6))
         ((eq shagv 3.0) (setq koef 1.4)) 
         ((eq shagv 3.5) (setq koef 1.4)) 
         ((eq shagv 4.0) (setq koef 1.4))
         ((eq shagv 4.5) (setq koef 1.4))
         ((eq shagv 5.0) (setq koef 1.6))
    ) ;_end of cond
  ) ;_end of if          
      (setq pt11g  (polar pt11 (+ 0 a1) (* (* 2 htv) mb))
            pt11vn (polar pt11 (+ (- (/ pi 2)) a1) (* (* 0.5 bpru) mb))
            pt13   (polar pt11 (+ (* (/ pi 4) 3) a1) (* (* (sqrt 2.0) rprt) mb))
            pt13vv (polar pt13 (+ (/ pi 2) a1) (* (* 2 htv) mb))
	    pt15   (polar pt13
			(+ pi a1)
			(* (- (- bprt rprt)
			   (/ (* r1prt (sin (/ pi 8))) (cos (/ pi 8)))
			) mb) ;_ end of *
		 ) ;_ end of polar
            pt15vv (polar pt15 (+ (/ pi 2) a1) (* (* 2 htv) mb))            
	    pt17   (polar pt15 (+ (* (/ pi 8) 9) a1) (* (* r1prt (sin (/ pi 8)) 2.0) mb))
	    cpv11  (polar pt13 (+ pi a1) (* (- bprt rprt) mb))
	    pt19   (polar cpv11 (+ (- (/ pi 2)) a1) (* r1prt mb))
	    pt19vn (polar cpv11 (+ (- (/ pi 2)) a1) (* (+ rprt (* 0.55 bpru)) mb))
	    pt21   (polar cpv11
			(+ (* (/ pi 4) 5) a1)
			(* (* (sqrt 2.0) (+ (* (- d4 dmtr) 0.5) htv) mb))
		 ) ;_ end of polar
            pt21vn (polar pt21 (+ (- (/ pi 2)) a1) (* (* (- (+ (* 0.5 bpru) rprt) 
                                               (+ (* (- d4 dmtr) 0.5) htv)) 1.0) mb))
            pt21vv (polar pt21 (+ (/ pi 2) a1) (* (* 3 htv) mb))
            pt21g  (polar pt21 (+ pi a1) (* (* 2 htv) mb))
	    pt23   (polar pt21 (+ (/ pi 4) a1) (* (* (sqrt 2.0) htv) mb))
            pt23g  (polar pt21g (+ (/ pi 2) a1) (* htv mb))
      ) ;_end of setq
;;--------------------- II .-------------------------------------------
      (setq pt33  (polar pt11
			 (+ (/ pi 4) a1)
			 (* (/
			   (- (+ (* (- d4 dmtr) 0.5) htv)
			      (- rpr2 (* rpr2 (sin (/ pi 4))))
			   ) ;_ end of -
			   (cos (/ pi 4))
			 ) mb);_ end of *
		  ) ;_ end of polar
            pt31vn (polar pt11 (+ (- (/ pi 2)) a1) (* (* 3 htv) mb))
            pt31g  (polar pt11 (+ pi a1) (* (* 3 htv) mb))
	    pt33v  (polar pt33 (+ 0 a1) (* (* rpr2 (cos (/ pi 4))) mb))
	    pt35   (polar pt33v (+ (/ pi 2) a1) (* (- rpr2 (* rpr2 (sin (/ pi 4)))) mb))
	    lbpr1 (* rpr2 (cos (/ pi 4)))
	    lbpr2 (-
		    (+ (* (- d4 dmtr) 0.5) htv)
		    (- rpr2 (* rpr2 (sin (/ pi 4))))
		  ) ;_ end of -
	    bpr3  (- (- bpr2 lbpr1) lbpr2)
	    ypr3  (sqrt (abs (- (expt rpr2 2) (expt bpr3 2))))
            cpvp1 (polar pt11 (+ (- (/ pi 2)) a1) (* (- (* dmtr 0.5) htv) mb))
            cptp1 (polar cpvp1 (+ 0 a1) (* bpr2 mb)) 
	    pt37  (polar cptp1 (+ (/ pi 2) a1) (* (+ (- (* d4 0.5) rpr2) ypr3) mb))
            pt37vv (polar pt37 (+ (/ pi 2) a1) (* (* 5 htv) mb))
            pt37vn (polar pt37 (+ (- (/ pi 2)) a1) (* (* 2 htv) mb))
            pt37g  (polar pt37 (+ 0 a1) (* (* 2 htv) mb))
	    ybsq  (expt	 (- (* d4 0.5) (- (* d4 0.5) rpr2) (* (- d4 dmtr) 0.5)) 2)
	    zz	  (sqrt (abs (- (expt rpr2 2) ybsq)))
	    pt35v (polar pt35 (+ pi a1) (* zz mb))
	    pt41  (polar pt35v (+ (- (/ pi 2)) a1) (* (* (- d4 dmtr) 0.5) mb))
            pt41g (polar pt41 (+ pi a1) (* (* 4 htv) mb))
            pt41vv (polar pt41 (+ (/ pi 2) a1) (* (* 3 htv) mb))
       ) ;_end of setq

;;--------------------- I .-------------------------------------
  (if (or 
          (and (eq prtn1 "1")
               (and (/= shagv 0.5)
                    (/= shagv 0.8)
                    (/= shagv 1.0)
                    (/= shagv 1.25)
               ) ; _end of and
           ) ;_end of and
          (and (eq prtn1 "0")
               (and (/= shagv 2.5)
                    (/= shagv 3.0)
                    (/= shagv 3.5)
                    (/= shagv 4.0)
                    (/= shagv 4.5)
                    (/= shagv 5.0)
               ) ; _end of and
           ) ;_end of and
        ) ;_end of or
       (setq koef1 1.0 koef2 1.0)
    (cond 
         ((and (setq prtn1 "1") (eq shagv 0.5))
          (setq koef1 0.8 koef2 1.1))
         ((and (setq prtn1 "1") (eq shagv 0.8))
          (setq koef1 0.7 koef2 1.4))
         ((and (setq prtn1 "1") (eq shagv 1.0))
          (setq koef1 0.7 koef2 1.0))
         ((and (setq prtn1 "1") (eq shagv 1.25))
          (setq koef1 0.8 koef2 1.0))
         ((and (setq prtn1 "0") (eq shagv 2.5))
          (setq koef1 1.4 koef2 1.4))
         ((and (setq prtn1 "0") (eq shagv 3.0))
          (setq koef1 1.7 koef2 1.1))
         ((and (setq prtn1 "0") (eq shagv 3.5))
          (setq koef1 1.4 koef2 6.8))
         ((and (setq prtn1 "0") (eq shagv 4.0))
          (setq koef1 1.6 koef2 1.6))
         ((and (setq prtn1 "0") (eq shagv 4.5))
          (setq koef1 1.6 koef2 1.4))
         ((and (setq prtn1 "0") (eq shagv 5.0))
          (setq koef1 1.7 koef2 1.4))
     ) ;_end of cond
 ) ;_end of if

     (setq  pt119 (polar pt11 (+ (* (/ pi 4) 3) a1) (* (* (/ (- dmtr d3) 2.0) (sqrt 2.0)) mb))
	    pt121 (polar pt119 (+ (- (/ pi 4)) a1) (* (* (sqrt 2.0) htv) mb))
	    pt123 (polar pt11 (+ 0 a1) (* (/ (* r1prt (sin (/ pi 8))) (cos (/ pi 8))) mb))
	    pt125 (polar pt11
			(+ (* (/ pi 4) 3) a1)
			(* (/ (* r1prt (sin (/ pi 8))) (cos (/ pi 8))) mb)
		 ) ;_ end of polar
            pt115 (polar pt11 (+ 0 a1) (* (- bprt rprt) mb))
            pt113 (polar pt115 (+ (/ pi 4) a1) (* (* (sqrt 2.0) rprt) mb))
            pt119g (polar pt119 (+ pi a1) (* htv mb))
            pt121g (polar pt119g (+ (- (/ pi 2)) a1) (* htv mb))
            pt119v (polar pt119  (+ (- (/ pi 2)) a1) (* (+ (* (- dmtr d3) 0.5) (* 2 htv)) mb))
            pt111v (polar pt11 (+ (- (/ pi 2)) a1) (* (* 2.5 htv) mb))
            pt115v (polar pt115 (+ (- (/ pi 2)) a1) (* (* 2 htv) mb))
            pt113g (polar pt113 (+ 0 a1) (* rprt mb))
            pt113v (polar pt113 (+ (/ pi 2) a1) (* rprt mb))
            pt113vn (polar pt113 (+ (- (/ pi 2)) a1) (* (* (* rprt 2.7) koef1) mb))
      ) ;_end of setq
;;--------------------- II .-------------------------------------
      (setq cpv9   (polar pt11 (+ pi a1) (* bpr2 mb))
            pt127  (polar cpv9 (+ (/ pi 2) a1) (* (* dmtr 0.5) mb))
	    pt129  (polar
		    pt127
		    (+ (- (/ pi 4)) a1)
		    (* (/ (- (* (- dmtr d3) 0.5) (- rpr2 (* rpr2 (cos (/ pi 4)))))
		       (cos (/ pi 4))
		    ) mb);_ end of *
		  ) ;_ end of polar
	    cpv10  (polar cpv9
			 (+ 0 a1)
			 (* (+ (* rpr2 (cos (/ pi 4)))
			    (- (* (- dmtr d3) 0.5)
			       (- rpr2 (* rpr2 (cos (/ pi 4))))
			    ) ;_ end of -
			 ) mb);_ end of *
		  ) ;_ end of polar
	    pt131  (polar cpv10 (+ (/ pi 2) a1) (* (* d3 0.5) mb))
	    b1pr2n (+ (* rpr2 (cos (/ pi 4)))
		     (- (* (- dmtr d3) 0.5) (- rpr2 (* rpr2 (cos (/ pi 4)))))
		  ) ;_ end of +
	    b2pr2n (- bpr2 b1pr2n)
	    b3pr2n (sqrt (abs (- (expt rpr2 2) (expt b2pr2n 2))))
	    b4pr2n (- rpr2 b3pr2n)
	    pt133  (polar pt11 (+ (/ pi 2) a1) (* (+ (/ d3 2.0) b4pr2n) mb))
	    pt131v  (polar pt131 (+ (/ pi 2) a1) (* (- (* (- dmtr d3) 0.5) htv) mb))
	    kt1q  (expt (- rpr2 (- (* (- dmtr d3) 0.5) htv)) 2)
	    pt135  (polar pt131v (+ pi a1) (* (sqrt (abs (- (expt rpr2 2) kt1q))) mb))
            pt127g (polar pt127 (+ pi a1) (* htv mb))
            pt135g (polar pt127g (+ (- (/ pi 2)) a1) (* htv mb))
            pt127v (polar pt127 (+ (- (/ pi 2)) a1) (* (+ (- dmtr d3) htv) mb))
            pt131vn (polar pt131 (+ (- (/ pi 2)) a1) (* (* 2.4 htv) mb))
            pt133v  (polar pt127v (+ 0 a1) (* bpr2 mb))
            pt131g  (polar pt131 (+ 0 a1) (* (+ rpr2 htv) mb))
      ) ;_ end of setq
;;----------------------------------------------------------------------
    
(defun uzprotI ()
   (osn)
   (command "_line" pt19vn pt19 "")
      (setq label3 (entlast)
	    sset3   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt21g pt21 pt21vn ""
            "_line" pt21 pt17 ""
            "_line" pt15 pt13 ""
            "_line" pt11 pt11vn ""
            "_arc"  pt11 "_e" pt13 "_r" (* rprt mb)
            "_arc"  pt15 "_e" pt17 "_r" (* r1prt mb))
  (ton)
  (command "_line" pt23 pt23g "")
  (command "_pline" pt23g "_a" "_r" (* (* 2.8 htv) mb) pt21g 
                               "_r" (* (* 3.5 htv) mb) pt21vn 
                               "_r" (* bprt mb) pt19vn 
                               "_r" (* (* 2.5 bprt) mb) pt11vn 
                               "_r" (* (* 3.5 htv) mb) pt11g 
                               "_r" (* (* (* 0.65 bprt) koef) mb) pt13vv 
                               "_r" (* (* 1.5 bprt) mb) pt15vv 
                               "_r" (* (* 2 bprt) mb) pt21vv 
                               "_r" (* (* 3.2 htv) mb) pt23g "")

) ;_end of defun UZPROTI------------------------------------------------------

;;-----------------------------------------------------------------------------
(defun uzprotII ()
   (osn)
   (command "_line" pt11 pt31vn "")
      (setq label3 (entlast)
	    sset3   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt33 pt11 pt31g ""
            "_line" pt37vn pt37 ""
            "_arc"  pt37 "_e" pt35 "_r" (* rpr2 mb)
            "_arc"  pt35 "_e" pt33 "_r" (* rpr2 mb))
  (ton)
  (command "_line" pt41 pt41g "")
  (command "_pline" pt41g "_a" "_r" (* (* 2.8 htv) mb) pt31g 
                               "_r" (* (* 3.5 htv) mb) pt31vn 
                               "_r" (* (* 3.0 bpr2) mb) pt37vn 
                               "_r" (* (* 3.5 htv) mb) pt37g 
                               "_r" (* (* 3.5 htv) mb) pt37vv 
                               "_r" (* (* 1.8 bpr2) mb) pt41vv 
                               "_r" (* (* 3.8 htv) mb) pt41g "")

      
) ;_end of defun UZPROTII------------------------------------------------------

;;------------------------------------------------------------------------------    
(defun uzprotIn ()
   (osn)
   (command "_line" pt113v pt113vn "")
      (setq label3 (entlast)
	    sset3   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt119g pt119 pt119v ""
            "_line" pt119 pt125 ""
            "_line" pt123 pt115 ""
            "_line" pt11 pt111v ""
            "_arc"  pt115 "_e" pt113 "_r" (* rprt mb)
            "_arc"  pt125 "_e" pt123 "_r" (* r1prt mb))
  (ton)
  (command "_line" pt121 pt121g "")
  (command "_pline" pt119g "_a" "_r" (* (* 2.8 htv) mb) pt121g 
                                "_r" (* (* 3.5 htv) mb) pt119v 
                                "_r" (* (* 3.5 htv) mb) pt111v 
                                "_r" (* (* 1.6 bprt) mb) pt113vn 
                                "_r" (* (* 2.2 rprt) mb) pt113g 
                                "_r" (* (* (* 1.6 htv) koef2) mb) pt113v "")
) ;_end of defun UZPROTIN------------------------------------------------------

;;------------------------------------------------------------------------------
(defun uzprotIIn ()
   (osn)
   (command "_line" pt133v pt133 "")
      (setq label3 (entlast)
	    sset3   (ssadd (entlast))
      ) ;_ end of setq
   (command "_line" pt127g pt127 pt127v ""
            "_line" pt127 pt129 ""
            "_arc"  pt129 "_e" pt131 "_r" (* rpr2 mb)
            "_arc"  pt131 "_e" pt133 "_r" (* rpr2 mb))
  (ton)
  (command "_line" pt135 pt135g "")
  (command "_pline" pt127g "_a" "_r" (* (* 2.8 htv) mb) pt135g 
                                "_r" (* (* 3.8 htv) mb) pt127v 
                                "_r" (* (* 1.1 bpr2) mb) pt133v 
                                "_r" (* (* 2.5 htv) mb) pt131g 
                                "_r" (* (* 3.6 htv) mb) pt133 "")

      
) ;_end of defun UZPROTIIN------------------------------------------------------


(cond ((and (eq otvg1 "1") (eq typ11 "1") (eq typ21 "0")) 
       (progn (setq tvst pt11) (uzprotI)))
      ((and (eq otvg1 "1") (eq typ11 "0") (eq typ21 "1")) 
       (progn (setq tvst pt11) (uzprotII)))
      ((and (eq strg1 "1") (eq typ11 "1") (eq typ21 "0")) 
       (progn (setq tvst pt11) (uzprotIn)))
      ((and (eq strg1 "1") (eq typ11 "0") (eq typ21 "1")) 
       (progn (setq tvst pt131) (uzprotIIn)))
)

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label3 (entnext label3))
      (setq sset3 (ssadd label3 sset3))
    ) ;_ end of while
  ) ;_end of RIS-UZELP


;;;   
(defun show_z ()
  (setq	dcl_id
	 (load_dialog (strcat pathdcl2 "kons1\\rgbd.dcl")) ; _ end of
					; load_dialog
  )					; DCL-

  (new_dialog "ins1" dcl_id)
 
  (set_tile "vst" "  ")

  (setq p3 "0")
  (set_tile "per3" "0")
  
  (rdfl)

  (pred)

  (action_tile "xcor" "(setq xc $value)")
  (action_tile "ycor" "(setq yc $value)")

  (action_tile "Mash" "(setq mash $value)(pred)")
  (action_tile "Angl" "(setq angl $value)")

  (action_tile
    "per1"
    (strcat
      "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
      "(mode_tile \"ycor\" 0)) (progn (mode_tile \"xcor\" 1)"
      "(mode_tile \"ycor\" 1) (setq xc nil yc nil) (set_tile \"xcor\" \"0\")"
      "(set_tile \"ycor\" \"0\")))"
    ) ;_  strcat
  ) ;_  action_tile
  (action_tile
    "per2"
    (strcat
      "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
      "(progn (mode_tile \"Angl\" 1) (setq angl nil) (set_tile \"Angl\" \"0\")))"
    ) ;_  strcat
  ) ;_  action_tile
  (action_tile "per3" "(setq p3 $value)")

  (action_tile "accept" "(done_dialog)")
  (action_tile "cancel" "(exit)")

  (start_dialog)			;    


  (unload_dialog dcl_id)
  (prin1)
) ;_  defun

(defun clip_bl3 ()
    

    (if (= y_p 1)
           (show_z)
    )  

    (initget 1) 
    (if (eq p1 "1")
             (setq inpt0 (getpoint "\n    :"))
             (setq inpt0 (list (atof xc) (atof yc)))
    )
    (if (eq p2 "1")
             (progn 
                  (setq a1 (getangle inpt0 (strcat "\n   <" angl ">:")))
	          (if (= a1 nil)
		           (setq a1 (atof angl))
		  )
	      )
             (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if 
    (setq mb (atof mash))

    (if	(not (>= htv (* 0.5 dmtr)))
      (progn
	(ris_uzelp)
	(if (eq p3 "0")
	  (anblk sset3 pt11)
	) ;_  if
      ) ;_  progn
      (alert "  .  ")
    ) ;_  if

    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun
 (clip_bl3)
  (prin1)
)
