;;;   
;;;: (ellips d sp hb h1 ip a1 mb ap)
;;;:   d -   ;
;;;       sp -   ;
;;;       hb -     ;
;;;       h1 -  ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       ap -    ( ap=nil -   )
;;; : 30.07.2001

(defun ellips (d sp   hb   h1	 ip   a1   mb	ap   /	  p0   p2
		  p3   p5   p4	 ks0  ks12 z	r1   a	  box  pt
		  lsta e    flag ang1 pt1 pt2 lt
		 ) 
  (osn)
  (setq	r1 (* d mb 0.5)
	sp (* mb sp)
	h1 (* mb h1)
	hb (* mb hb)
	p0 (polar ip (+ a1 (/ pi 2)) h1)
	p2 (polar ip a1 r1)
	p4 (polar ip (+ a1 pi) r1)
	p3 (polar p4 (+ a1 pi) sp)
	p5 (polar p2 a1 sp)
	a  (- (/ pi 12))
  ) ;_  setq
  (repeat 13
    (setq a    (+ a (/ pi 12))
	  lsta (append lsta (list (+ a a1)))
    ) ;_  setq
  ) ;_  repeat
  (repeat 2
    (setq pt (mapcar
	       '(lambda	(a / n1 n2 n3 n4 n)
		  (setq	n1 (polar p0 a r1)
			n2 (polar p0 a hb)
			n3 (polar n1 (+ a1 (* pi 1.5)) r1)
			n4 (polar n2 a1 r1)
			n  (inters n1 n3 n2 n4 nil)
		  ) ;_  setq
		) ;_  lambda
	       lsta
	     ) ;_  mapcar
	  z  (polar p3 (+ (/ pi 2.0) a1) (+ hb h1 sp))
	  e  1
    ) ;_  setq
    (if	(not flag)
      (progn
	(command "_zoom" "_w" p5 z)
	(setq k12 (nth 12 pt)
	      k0  (nth 0 pt)
	) ;_  setq
      ) ;_  progn
      (setq ks12 (nth 12 pt)
	    ks0	 (nth 0 pt)
      ) ;_  setq
    ) ;_  if
    (command "_pline" (nth 0 pt) "_w" "0" "0")
    (while (< e 13) (command (nth e pt)) (setq e (1+ e)))
    (command "")
    (setq box (ssget "l"))
    (command "_pedit" box "_f" "")
    (setq r1   (+ r1 sp)
	  hb   (+ hb sp)
	  a    (- (/ pi 12))
	  flag T
    ) ;_  setq
  ) ;_  repeat
  (setq	r1 (- r1 sp)
	hb (- hb sp)
  ) ;_  setq
  (command "_line" ks12 p3 "" "_line" p4 k12 "")
  (command "_line" k0  p2 "" "_line" p5 ks0  "")
  (if (not ap)
    (command "_line" p3 p5 "")
  ) ;_  if
  (if (eq shtrp "1")
    (progn
      (setq lt	 (distance p3 k12)
	    ang1 (angle p3 k12)
	    pt1	 (polar p3 ang1 (/ lt 2.0))
	    pt2	 (polar pt1 a1 (+ (* d mb) sp))
	    av	 (* (/ a1 pi) 180)
      ) ;_  setq
      (ton)
      (command "_bhatch" "_p" "_u" (+ av 45) 2.0 "_n" pt1 pt2 "")
    ) ;_  progn
  ) ;_  if
 
  
) ;_  ELLIPS


;;;   
;;;: (ellips2 d1 ip a1 mb)
;;;:   d1 -   ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 01.08.2001
(defun ellips2 (d1 ip a1 mb / pt1 pt2 pt3 pt4)
      (osn)
      (command "_circle" ip (* (/ d1 2.0) mb))
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
;;;     
      (setq pt1	(polar ip (+ a1 pi) (* (* d1 0.55) mb))
	    pt2	(polar pt1 a1 (* (* d1 1.1) mb))
	    pt3	(polar ip (+ a1 (/ pi 2.0)) (* (* d1 0.55) mb))
	    pt4	(polar pt3 (- a1 (/ pi 2.0)) (* (* d1 1.1) mb))
      ) ;_  setq

      (axs)
      (command "_line" pt1 pt2 "")
      (command "_line" pt3 pt4 "")
) ;_  ELLIPS2


;;;  
;;;: (ellips3 d sp hb h1 ip a1 mb ap)
;;;:   d -   ;
;;;       sp -   ;
;;;       hb -     ;
;;;       h1 -  ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       ap -    ( ap=nil -   )
;;; : 15.01.2002

(defun ellips3 (d sp   hb   h1	 ip   a1   mb	ap   /	  p0   p2
		  p3   p5   p4	 k0  k12 z	r1   a	  box  pt
		  lsta e    flag ang1 pt1 pt2 lt
		 ) 
  (osn)
  (setq	r1 (* d mb 0.5)
	sp (* mb sp)
	h1 (* mb h1)
	hb (* mb hb)
	p0 (polar ip (+ a1 (/ pi 2)) h1)
	p2 (polar ip a1 r1)
	p4 (polar ip (+ a1 pi) r1)
	p3 (polar p4 (+ a1 pi) sp)
	p5 (polar p2 a1 sp)
	a  (- (/ pi 12))
  ) ;_  setq
  (repeat 13
    (setq a    (+ a (/ pi 12))
	  lsta (append lsta (list (+ a a1)))
    ) ;_  setq
  ) ;_  repeat
  
;;;  
  (setq	r1 (+ r1 sp)
	hb (+ hb sp)
	a  (- (/ pi 12))
  ) ;_  setq
  (setq	pt (mapcar
	     '(lambda (a / n1 n2 n3 n4 n)
		(setq n1 (polar p0 a r1)
		      n2 (polar p0 a hb)
		      n3 (polar n1 (+ a1 (* pi 1.5)) r1)
		      n4 (polar n2 a1 r1)
		      n	 (inters n1 n3 n2 n4 nil)
		) ;_  setq
	      ) ;_  lambda
	     lsta
	   ) ;_  mapcar
	z  (polar p3 (+ (/ pi 2.0) a1) (+ hb h1 sp))
	e  1
  ) ;_  setq
  (command "_zoom" "_w" p5 z)
  (setq	k12 (nth 12 pt)
	k0  (nth 0 pt)
  ) ;_  setq
  (command "_pline" (nth 0 pt) "_w" "0" "0")
  (while (< e 13) (command (nth e pt)) (setq e (1+ e)))
  (command "")
  (setq box (ssget "l"))
  (command "_pedit" box "_f" "")

    
  (setq	r1 (- r1 sp)
	hb (- hb sp)
  ) ;_  setq
  (command "_line" k12 p3 "" "_line" p5 k0 "")
  (if (not ap)
    (command "_line" p3 p5 "")
  ) ;_  if
 
) ;_  ELLIPS3