;;;    
;;;:  ..
;;; : 02.08.2001
;;;CAD-CEE 2000
;;;: C:KONDN

(defun c:kondn (/ tipf db d dotv notv d1 d2 d3 d4 d5 d6 h h2 b l s sech sprd
		    name1 orx aby dlg dfl lsp1 lsp2 lsp3 lsp4 lsp5 fld strd strdd
		    strd1 strdd1 p1 p2 p3 angl mash name1 spis pti inptG xc yc
		    dcl_id inptG a1 mb cmd blpm apsz osmd clay cltp ccol
		    vs vctr pv anbl sset label sech2 sbk py dy pyf dyf stf fldat dfl2
		    as ass bs bss bss1 bss2 fldat2 as2 ass2 dtb stb shtrp
		    spism mtr hpa hpn st bd pd co fr ang1 rzv massa omega)

  (setq	dlg  (findfile (strcat pathdcl2 "korpus\\kondn.dcl"))
	dfl  (findfile (strcat pathlisp2 "korpus\\kondn.d"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "korpus\\shellkon.lsp"))
	lsp2 (findfile (strcat pathlisp2 "korpus\\rzvrkon.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)
  (load lsp2)

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun
  (defun textf ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  
;;;      KONDN.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   d	  (nth 0 strdd1)
	   d1	  (nth 1 strdd1)
	   s	  (nth 2 strdd1)
	   l	  (nth 3 strdd1)
	   sech	  (itoa (nth 4 strdd1))
	   sprd	  (itoa (nth 5 strdd1))
	   sbk	  (itoa (nth 6 strdd1))
	   rzv	  (itoa (nth 7 strdd1))
	   shtrp  (itoa (nth 8 strdd1))
	   co	  (nth 9 strdd1)
	   pd	  (nth 10 strdd1)
	   bd	  (nth 11 strdd1)
	   fr	  (nth 12 strdd1)
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "D1" (rtos d1))
    (set_tile "D" (rtos d))
    (set_tile "S" (rtos s))
    (set_tile "L" (rtos l))
    (set_tile "A" (angtos omega))
    (set_tile "M" massa)
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Rzv" rzv)
    (set_tile "Shtr" shtrp)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if
    
    (set_tile "per2" p2)
    (if	(= rzv "1")
      (progn
	(mode_tile "per2" 1)
	(mode_tile "per3" 1)
      ) ;_  progn
    ) ;_  if
 
    (if	(and (eq p2 "0") (/= rzv "1"))
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       KONDN.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" (rtos d) " " (rtos d1) " " (rtos s) " " (rtos l) " " sech " " sprd " " sbk " "
			    rzv " " shtrp " " (rtos co) " " (rtos pd) " " (rtos bd) " " (rtos fr) ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq rzv "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\kondn(1).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	      (eq rzv "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\kondn(2).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	      (eq rzv "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\kondn(3).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq rzv "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\kondn(4).slb"))
	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun
  

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun

;;;    
   (defun prov_gl ()
      (if (<= d1 d)
       (if (< d1 200)
	 (if (> s (* 0.3 d1))
	     (progn
	        (attn2 1 (* 0.3 d1) "")
	        (mode_tile "S" 2)
	     )
	     (done_dialog)
	 ) ;_  if
	 (if (or (> s (* 0.1 d)) (< s 1.0))
	     (progn
	        (attn2 1 (* 0.1 d1) "")
	        (mode_tile "S" 2)
	     )
	     (done_dialog)
	 ) ;_  if
       ) ;_  if
       (progn
	     (attn2 d1 10000 "")
	     (mode_tile "D" 2)
	)
      )	
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;    
  (defun rs_mss	(/  omega1 dd dd1 hh ro rr r massa1 massa2 so vo)
   (if (/= d d1)
     (setq ro	     7.95		;    (121810-)
	   omega1    (/ (/ (- d d1) 2.0) l)
	   omega     (atan omega1)
	   dd	     (+ d (* s (cos omega)))
	   dd1	     (+ d1 (* s (cos omega)))
	   hh	     (/ (* dd l) (- dd dd1))
	   rr	     (sqrt (+ (* 0.25 (expt dd 2.0)) (expt hh 2.0)))
	   r	     (sqrt (+ (* 0.25 (expt dd1 2.0)) (expt (- hh l) 2.0)))
	   alphagrad (/ (* 180 dd) rr)
	   massa1    (* (* pi alphagrad) (* s ro))
	   massa2    (- (expt rr 2.0) (expt r 2.0))
	   massa     (/ (* massa1 massa2) 3.6e8)
	   massa     (rtos massa 2 1)
     ) ;_  setq
     (setq ro	  7950			;    (121810-)
	   omega1 (/ (/ (- d d1) 2.0) l)
	   omega  (atan omega1)
	   so1	  (* pi (expt (+ (/ d 2.0) s) 2.0))
	   so2	  (* pi (expt (/ d 2.0) 2.0))
	   so	  (- so1 so2)
	   vo	  (* (* so l) 0.000000001)
	   massa  (* vo ro)
	   massa  (rtos massa 2 3)
     ) ;_  setq  
   ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;    
;;;  : (os_ln l)
;;;      l -   
   (defun os_ln	(l / pt1)
         (setq pt1 (polar inptG (+ a1 (/ pi 2.0)) (* l mb)))
         (axs)
         (command "_LINE" inptG pt1 "")
         (setq label (entlast))
         (setq sset (ssadd (entlast)))
   ) ;_  defun


;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


;;;     
 (defun	rash (/ sr dk)

;;;      
  (defun s_tr ()
    (set_tile "Dk" (rtos dk))
    (set_tile "A" (angtos ang1 0 2))
    (set_tile "Sv" (rtos s))
    (set_tile "C" (rtos co))
    (set_tile "P" (rtos pd))
    (set_tile "B" (rtos bd))
    (set_tile "F" (rtos fr))
  ) ;_  defun

;;;      
   (defun fn_rr_sr (/ r a1)
     (setq  a1 (* 0.7 (sqrt (* (/ d (cos ang1)) (- s co))))
	    dk (- d (* 1.4 (sin ang1)))
            sr (+ (* (/ (* pd dk) (- (* 2.0 bd fr) pd)) (/ 1.0 (cos ang1))) co)
     ) ;_  setq
     (set_tile "Sr" (rtos sr))
     (if (> sr s)
          (set_tile "Zk" "<     >")
          (set_tile "Zk" "<    >")
     )  
   ) ;_  defun
  
   (new_dialog "ras" dcl_id)
   
;;;       
   (setq ang1 (atan (/ (/ (- d d1) 2.0) l)))

   (fn_rr_sr)
   (s_tr)
    
   (action_tile "C" "(prv_p $value 'co \"C\" \"r\")")
   (action_tile "P" "(prv_p $value 'pd \"P\" \"r\")")
   (action_tile "B" "(prv_p $value 'bd \"B\" \"r\")")
   (action_tile "F" "(prv_p $value 'fr \"F\" \"r\")(prov 0.65 fr 1.0 \"F\" \".\")")
   
   (action_tile "RR" "(fn_rr_sr)")
   (action_tile "cancel" "(done_dialog 1)")

   (start_dialog)			;   


 ) ;_  defun

  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "kondn" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (rs_mss)
    (s_t)
    
    (if	(or (eq sech "1")(eq rzv "1"))
      (mode_tile "Shtr" 0)
    ) ;_  if
    (mode_tile "D1" 2)

;;;     
    (action_tile
      "D1"
      (strcat "(prv_p $value 'd1 \"D1\" \"r\")"
	      "(prov 4 d1 10000 \"D1\" \"\")"
	      "(rs_mss)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(prv_p $value 'd \"D\" \"r\")"
	      "(prov d1 d 10000 \"D\" \"\")"
	      "(rs_mss)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    
    (action_tile
      "S"
      (strcat "(prv_p $value 's \"S\" \"r\")"
	      "(if (< d1 200)"
	      "(prov 1 s (* 0.3 d1) \"S\" \"\")"
	      "(prov 1 s (* 0.1 d1) \"S\" \"\"))";
	      "(rs_mss)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "L"
      (strcat "(prv_p $value 'l \"L\" \"r\")"
	      "(prov 1 l 50000 \"L\" \"\")"
	      "(rs_mss)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(setq rzv \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk \"0\")"
	      "(setq rzv \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(setq rzv \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Rzv"
      (strcat "(setq rzv $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Rash"
      (strcat "(rash)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(prov_gl)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (and (eq p2 "1") (/= rzv "1"))
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 (- a1 (/ pi 2)))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* l mb) 2))
    (command "_ZOOM" "_C" inptG (* (* l mb) 2))
  ) ;_  if

  
;;;    
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq rzv "0")
	 ) ;_  and
	 (os_ln l)
	 (shellkon d d1 s l inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	      (eq rzv "0")
	 ) ;_  and
	 (shellkon2 d d1 s l inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	      (eq rzv "0")
	 ) ;_  and
	 (os_ln l)
	 (shellkon3 d d1 s l inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "0")
	      (eq rzv "1")
	 ) ;_  and
	 (rzvrkon d d1 s l inptG mb shtrp)
	)
  ) ;_  cond

;;;      
  (if (/= rzv "1")
    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_  while
  ) ;_  if


  (if (and (eq p3 "0")(/= rzv "1"))
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  KONDN
