;;;   
;;;: (rzvrkon ddv dv s h ip mb shtrp)
;;;:   ddv -    ;
;;;       dv -    ;
;;;       s -   ;
;;;       h -   ;
;;;       ip -  ;
;;;       mb -  ;
;;;       shtrp -  ("1" - )
;;; : 05.04.2002
(defun rzvrkon (ddv dv s h ip mb shtrp / vs tipwe kw1	kw2 kw3	cmd bli	m kw ro
		el gost	mb omega1 omega	dd d hh	rr r alphagrad alpha
		betagrad beta betad s2 s1 ll alphad mbr	rrd s1d	s2d lld
		ddvd dvd hd sd ddm dm hm sm rrm	rm s1m s2m llm a3 a4 g4
		g6 g10 g14 g15 rt rd tr pt1 pt2
	       )

  (defun wddd ()
    (if	(= ddv dv)
      (setq ddv	(+ dv 0.0001)
	    tr	1
      ) ;_  setq
    ) ;_  if
    (setq omega1 (/ (/ (- ddv dv) 2) h)
	  omega	 (atan omega1)
	  dd	 (+ ddv (* s (cos omega)))
	  d	 (+ dv (* s (cos omega)))
    ) ;_  setq
  ) ;_  defun

  (defun razvertca (/ massa1 massa2 massa box lt)
    (setq hh	    (/ (* dd h) (- dd d))
	  rr	    (sqrt (+ (* 0.25 (expt dd 2.0)) (expt hh 2.0)))
	  r	    (sqrt (+ (* 0.25 (expt d 2.0)) (expt (- hh h) 2.0)))
	  alphagrad (/ (* 180 dd) rr)
	  alpha	    (* pi (/ alphagrad 180.0))
	  a3	    (/ pi 2.0)
	  a4	    (+ (/ pi 2.0) pi)
    ) ;_  setq
    (cond ((>= alphagrad 180.0)
	   (setq betagrad (- 360 alphagrad)
		 beta	  (* pi (/ betagrad 180.0))
		 betad	  (angtos beta 0 2)
		 s2	  (* 2 (* rr (sin (/ beta 2.0))))
		 s1	  (* 2 (* r (sin (/ beta 2.0))))
		 ll	  (* rr (+ 1.0 (cos (/ beta 2.0))))
	   ) ;_  setq
	  )
	  ((< alphagrad 180.0)
	   (setq gammagrad (/ (- 180.0 alphagrad) 2.0)
		 gamma	   (* pi (/ gammagrad 180.0))
		 alphad	   (angtos alpha 0 2)
		 s2	   (* 2 (* rr (cos gamma)))
		 s1	   (* 2 (* r (cos gamma)))
		 ll	   (- rr (* r (sin gamma)))
	   ) ;_  setq
	  )
    ) ;_  cond
;;;    (setq rrd  (strcat "R" (rtos rr 2 0))
;;;	  rd   (strcat "R" (rtos r 2 0))
;;;	  s1d  (strcat (rtos s1 2 0) "*")
;;;	  s2d  (strcat (rtos s2 2 0) "*")
;;;	  lld  (strcat (rtos ll 2 0) "*")
;;;	  ddvd (strcat "\\" (rtos ddv 2 0))
;;;	  dvd  (strcat "\\" (rtos dv 2 0))
;;;	  hd   (rtos h 2 0)
;;;	  sd   (strcat (rtos s 2 0) "*")
;;;    ) ;_  setq
    (setq ddm (* ddv mb)
	  dm  (* dv mb)
	  hm  (* h mb)
	  sm  (* s mb)
	  rrm (* rr mb)
	  rm  (* r mb)
	  s1m (* s1 mb)
	  s2m (* s2 mb)
	  llm (* ll mb)
	  rd  (strcat "R" (rtos r 2 0))
    ) ;_  setq
  ) ;_  defun

;;;  
  (defun gvid (/ g1 g2 g3 g5 g7	g8 g9 g11 g12 g13 g16 g17 g18 p5 p6 p7
	       p8 p9 p10 w1 w2 w3
	      )
    (setq g1  ip
          ;g1  (list (+ 80.0 (/ ddm 2.0)) (+ 60.0 ddm))
;;;	  a3  (/ pi 2.0)
;;;	  a4  (+ (/ pi 2.0) pi)
	  g2  (polar g1 a3 hm)
	  g3  (polar g1 0 (/ ddm 2.0))
	  g4  (polar g1 pi (/ ddm 2.0))
	  g5  (polar g3 omega sm)
	  g6  (polar g4 (- pi omega) sm)
	  g7  (polar g2 0 (/ dm 2.0))
	  g8  (polar g2 pi (/ dm 2.0))
	  g9  (polar g7 omega sm)
	  g10 (polar g8 (- pi omega) sm)
	  g11 (polar g1 a4 5.0)
	  g12 (polar g2 a3 6.0)
	  g13 (polar g1 a4 25.0)
	  g14 (polar g2 a3 15.0)
	  g15 (polar g5 0 15.0)
	  g16 (polar g6 a4 12.5)
	  g17 (polar g1 0 (/ ddm 4.0))
	  g18 (polar g2 0 (/ dm 4.0))
	  w1  (list 0.0 0.0)
	  w2  (polar g14 0 (+ (/ ddm 2.0) 15.0))
	  w3  (polar w2 a3 15.0)
    ) ;_  setq
    (command "_ZOOM" "_W" w1 w3)
    (osn)
    (command "_PLINE" g3 g5 g9 g7 "c")
    (command "_PLINE" g4 g6 g10 g8 "c")
;;;    
    (if	(= shtrp "1")
      (progn
	(ton)
	(command "_HATCH" "_u" "45.0" "2.5" "" g3 g4 "")
      ) ;_  progn
    ) ;_  if
    (axs)
    (command "_LINE" g11 g12 "")
;;;    (textf)
;;;    (command "_DIM1" "_hor" g3 g4 g13 ddvd)
;;;    (command "_DIM1" "_hor" g7 g8 g14 dvd)
;;;    (command "_DIM1" "_ver" g3 g7 g15 hd)
;;;    (command "_DIM1" "_aligned" g4 g6 g16 sd)
    (osn)
    (command "_LINE" g3 g4 "")
    (command "_LINE" g7 g8 "")
    (command "_LINE" g9 g10 "")
    (command "_LINE" g17 g18 "")
  ) ;_  defun

;;;    
  (defun pvid (/ p1 p2 p3 p4 label1)
    (setq p1 (polar ip (- 0.0 (/ pi 2.0)) (+ 40.0 (/ ddm 2.0)))
          ;p1 (list (+ 80 (/ ddm 2.0)) (+ 20 (/ ddm 2.0)))
	  p2 (polar p1 0.0 (+ 5.0 (+ (/ ddm 2.0) (* sm (cos omega)))))
	  p3 (polar p1 (/ pi 4.0) (+ (/ dm 2.0) (* sm (cos omega))))
	  p4 (polar p3 (/ pi 4.0) (- (/ ddm 2.0) (/ dm 2.0)))
    ) ;_  setq
    (command "_CIRCLE" p1 (/ dm 2.0))
    (command "_CIRCLE" p1 (+ (* sm (cos omega)) (/ dm 2.0)))
    (command "_CIRCLE" p1 (+ (* sm (cos omega)) (/ ddm 2.0)))
    (command "_LINE" p3 p4 "")
    (axs)
    (command "_LINE" p1 p2 "")
    (setq label1 (entlast))
    (command "_ARRAY" label1 "" "p" p1 "4" "" "")
  ) ;_  defun

;;;     alphagrad < 180 .
  (defun razvertca1 (/ r1 r4 r5	r6 r7 r8 r9 r10	r11 r12	r13 r14	r15 r16
		     r17 r18 r19 r20 r21 r22 r23 r24 w4	w5 a5
		    )
    (setq r1  (polar g15 0 (+ 15.0 rrm))
	  r4  (polar r1 a4 (+ rrm 5.0))
	  r5  (polar r1 a3 5.0)
	  r6  (polar r1 a4 rm)
	  r7  (polar r1 (- (* 2 pi) gamma) rm)
	  r8  (polar r1 (+ pi gamma) rm)
	  r9  (polar r1 a4 rrm)
	  r10 (polar r1 (- (* 2.0 pi) gamma) rrm)
	  r11 (polar r1 (+ gamma pi) rrm)
	  r12 (polar r1 (- a4 (/ pi 15.0)) rrm)
	  r13 (polar r1 (+ a4 (/ pi 15.0)) rm)
	  r14 (polar r13 (+ a4 (/ pi 15.0)) 12.0)
	  r15 (polar r14 0 (* 2.45 (strlen rd)))
	  r16 (polar r1 (- a4 (/ pi 15.0)) (- rm 10.0))
	  r17 (polar r16 (- pi (/ pi 15.0)) 2.0)
	  r18 (polar r14 a3 2.0)
	  r19 (polar r5 a3 10.0)
	  r20 (polar r19 a3 15.0)
	  r21 (polar r10 0 25.0)
	  r22 (polar r4 a4 15.0)
	  r23 (polar r22 a3 2.5)
	  r24 (polar r7 (angle r7 r10) 1.0)
	  r25 (polar r8 (angle r8 r11) 1.0)
	  rt  (polar r20 a3 20.0)
	  w4  (polar r22 0 (+ 100.0 (/ rrm 2.0)))
	  w5  (polar g14 pi (+ 120.0 (/ ddm 2.0)))
    ) ;_  setq
    (command "_ZOOM" "_W" w5 w4)
    (axs2)
    (command "_LINE" r5 r4 "")
    (osn)
    (command "_LINE" r7 r10 "")
    (command "_LINE" r8 r11 "")
;;;    (textf)
;;;    (command "_DIM1" "_ang" r7 r8 r22 alphad r23)
;;;    (command "_DIM1" "_lea" r12 r1 "" " ")
;;;    (command "_DIM1" "_lea" r13 r1 "" " ")
;;;    (command "_LINE" r13 r14 r15 "")
    (setq a5 (- a3 (/ pi 15.0))
	  a5 (angtos a5 1 4)
    ) ;_  setq
;;;    (command "_TEXT" r17 "3.5" a5 rrd)
;;;    (command "_TEXT" r18 "3.5" "0" rd)
;;;    (command "_DIM1" "_hor" r7 r8 r19 s1d)
;;;    (command "_DIM1" "_hor" r10 r11 r20 s2d)
;;;    (command "DIM1" "_ver" r9 r7 r21 lld)
    (osn)
    (command "_ARC" r8 r6 r7)
    (command "_ARC" r11 r9 r10)
    (command "_ZOOM" "_w" (list -5.0 -5.0) w4)
  ) ;_  defun

;;;     alphagrad >= 180 .
  (defun razvertca2 (/ r1 r2 r3	r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14
		     r15 r16 r17 r18 r19 r20 r21 r22 r23 w4 w5 a5
		    )
    (setq r1  (polar g15 0 (+ 15.0 rrm))
	  r2  (polar r1 0 (+ rrm 5.0))
	  r3  (polar r1 a3 (/ rm 2.0))
	  r4  (polar r1 pi (+ rrm 5.0))
	  r5  (polar r1 a4 (+ rrm 5.0))
	  r6  (polar r1 (+ a3 (/ beta 2.0)) rrm)
	  r7  (polar r1 a4 rrm)
	  r8  (polar r1 (- a3 (/ beta 2.0)) rrm)
	  r9  (polar r1 (+ a3 (/ beta 2.0)) rm)
	  r10 (polar r1 a4 rm)
	  r11 (polar r1 (- a3 (/ beta 2.0)) rm)
	  r12 (polar r3 a3 3.0)
	  r13 (polar r12 a3 2.5)
	  r14 (polar r2 0 30.0)
	  r15 (polar r11 a3 20.0)
	  r16 (polar r8 a3 25.0)
	  r17 (polar r1 (+ pi (/ pi 6.0)) rrm)
	  r18 (polar r1 (+ a4 (/ pi 6.0)) rm)
	  r19 (polar r18 (+ a4 (/ pi 6.0)) rm)
	  r20 (polar r19 0 (* 2.45 (strlen rd)))
	  r21 (polar r1 (+ pi (/ pi 6.0)) (+ rm 15.0))
	  r22 (polar r21 (+ a3 (/ pi 6.0)) 2.0)
	  r23 (polar r19 a3 2.0)
	  rt  (polar r3 a3 rrm)
	  w4  (polar r5 0 (+ 120.0 (/ rrm 2.0)))
	  w5  (polar g14 pi (+ 120.0 (/ ddm 2.0)))
    ) ;_  setq
    (command "_ZOOM" "_W" w5 w4)
    (axs2)
    (command "_LINE" r2 r4 "")
    (command "_LINE" r5 r3 "")
    (osn)
    (command "_LINE" r6 r9 "")
    (command "_LINE" r8 r11 "")
;;;    (textf)
;;;    (command "_DIM1" "_ang" r9 r11 r12 betad r13)
;;;    (command "_DIM1" "_lea" r17 r1 "" " ")
;;;    (command "_DIM1" "_lea" r18 r1 "" " ")
;;;    (command "_LINE" r18 r19 r20 "")
    (setq a5 (/ pi 6.0)
	  a5 (angtos a5 1 4)
    ) ;_  setq
;;;    (command "_TEXT" r22 "3.5" a5 rrd)
;;;    (command "_TEXT" r23 "3.5" "0" rd)
;;;    (command "_DIM1" "_hor" r9 r11 r15 s1d)
;;;    (command "_DIM1" "_hor" r6 r8 r16 s2d)
;;;    (command "_DIM1" "_ver" r8 r7 r14 lld)
    (osn)
    (command "_ARC" r6 r7 r8)
    (command "_ARC" r9 r10 r11)
    (command "_ZOOM" "_w" (list -5.0 -5.0) w4)
  ) ;_  defun

;;;--------------------- -------------------

  (wddd)
  (razvertca)
  (gvid)
  (pvid)
  (if (/= tr 1)
    (cond ((< alphagrad 180) (razvertca1))
	  ((>= alphagrad 180) (razvertca2))
    ) ;_  cond
    (progn
      (setq ll	(* pi (+ dm sm))
	    pt1	(polar g15 0 15.0)
	    pt2 (polar pt1 0 ll)
	    pt2 (polar pt2 (/ pi 2.0) hm)
      ) ;_  setq
      (osn)
      (command "_RECTANG" pt1 pt2)
    ) ;_  progn
 
  ) ;_  if
  (princ)
) ;_  defun
