;;;   
;;;:  ..
;;; : 03.08.2001
;;;CAD-CEE 2000
;;;: C:TRUBDN

(defun c:trubdn (/ tipf db d dotv notv d1 d2 d3 d4 d5 d6 h h2 b l s sech sprd
		    name1 orx aby dlg dfl lsp1 lsp2 lsp3 lsp4 lsp5 fld strd strdd
		    strd1 strdd1 p1 p2 p3 angl mash name1 spis pti inptG xc yc
		    dcl_id inptG a1 mb cmd blpm apsz osmd clay cltp ccol
		    vs vctr pv anbl sset label sech2 sbk py dy pyf dyf stf fldat dfl2
		    as ass bs bss bss1 bss2 fldat2 as2 ass2 dtb stb shtrp
		    spism mtr hpa hpn st bd pd co fr dat1 dat2 dat3 dat4 ins inptG2 massa)

  (setq	dlg  (findfile (strcat pathdcl2 "korpus\\trubdn.dcl"))
	dfl  (findfile (strcat pathlisp2 "korpus\\trubdn.d"))
	dat1 (findfile (strcat pathdat2 "korpus\\tr3433.dat"))
	dat2 (findfile (strcat pathdat2 "korpus\\tr3231.dat"))
	dat3 (findfile (strcat pathdat2 "korpus\\tr9941.dat"))
	dat4 (findfile (strcat pathdat2 "korpus\\tr9940.dat"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "korpus\\shell.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

  (setq spis '("   8734-75/8733-74"
	       "   8732-78/8731-74"
	       "   9941-81"
	       "   9940-81"
	      ) 
  ) ;_  setq

  
;;;      TRUBDN.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   dy	  (itoa (nth 1 strdd1))
	   st	  (itoa (nth 2 strdd1))
	   l	  (nth 3 strdd1)
	   sech	  (itoa (nth 4 strdd1))
	   sprd	  (itoa (nth 5 strdd1))
	   sbk	  (itoa (nth 6 strdd1))
	   shtrp  (itoa (nth 7 strdd1))
	   co	  (nth 8 strdd1)
	   pd	  (nth 9 strdd1)
	   bd	  (nth 10 strdd1)
	   ins	  (itoa (nth 11 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "D" dy)
    (set_tile "S" st)
    (set_tile "L" (rtos l))
    (set_tile "Ins" ins)
    (set_tile "M" massa)
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Shtr" shtrp)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       TRUBDN.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " dy " " st" " (rtos l) " " sech " " sprd " " sbk " " shtrp " " (rtos co)
			    " " (rtos pd) " " (rtos bd) " " ins ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\trubdn(1).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\trubdn(2).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "korpus\\trubdn(3).slb"))
	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;     
  (defun defl ()
    (setq dy "0"
	  st "0"
    ) ;_  setq
  ) ;_  defun


;;;    
  (defun dfl_fn	()
    (cond ((= tipf "0") (setq dfl2 dat1))
	  ((= tipf "1") (setq dfl2 dat2))
	  ((= tipf "2") (setq dfl2 dat3))
	  ((= tipf "3") (setq dfl2 dat4))
    ) ;_  cond
  ) ;_  defun

;;;      
(defun desk_f ()
  (setq	fldat (open dfl2 "r")
	as    (read-line fldat)
	ass   (read as)
	dyf   (nth 0 ass)
	stf   (nth (+ (atoi dy) 1) ass)
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	bss2  (nth 1 bss)
	d     (nth 2 bss)
	s     (nth 3 bss)
  ) ;_  setq
) ;_  defun


 ;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun



;;;      
(defun whl ()
  (if (or (/= (atof dy) (atof bss1))
	  (/= (atof st) (atof bss2))
      ) ;_  or
    (clos_dfl2)
  ) ;_  if 
  (while (or (/= (atof dy) (atof bss1))
	     (/= (atof st) (atof bss2))
	 ) ;_  or
    (setq bs   (read-line fldat)
	  bss  (read bs)
	  bss1 (nth 0 bss)
	  bss2 (nth 1 bss)
	  d    (nth 2 bss)
	  s    (nth 3 bss)
    ) ;_  setq
  ) ;_  while
) ;_  defun


;;;    
    (defun tipf_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun


;;;    
    (defun dyf_l ()
      (start_list "D")
      (mapcar 'add_list dyf)
      (end_list)
    ) ;_  defun

  
;;;    
    (defun stf_l ()
      (start_list "S")
      (mapcar 'add_list stf)
      (end_list)
    ) ;_  defun

  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

  
;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;    
  (defun rs_mss	(/  ro so so1 so2 vo)
    (setq ro     7950 ;    (121810-)
	  so1    (* pi (expt (/ d 2.0) 2.0))
          so2    (* pi (expt (- (/ d 2.0) s) 2.0))
	  so     (- so1 so2)
	  vo     (* (* so l) 0.000000001)
	  massa  (* vo ro)
	  massa  (rtos massa 2 2)
    ) ;_  setq  
  ) ;_  defun

  
;;;    
;;;  : (os_ln l)
;;;      l -   
   (defun os_ln	(l / pt1)
         (setq pt1 (polar inptG (- a1 (/ pi 2.0)) (* l mb)))
         (command "_LAYER" "_S" " " "")
         (command "_LINE" inptG pt1 "")
         (setq label (entlast))
         (setq sset (ssadd (entlast)))
   ) ;_  defun


;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)
   
   (if (and (eq ins "1")(eq sprd "0"))
     (progn (mode_tile "Angl" 1) (mode_tile "per2" 1))
   ) ;_  if

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


;;;     
 (defun	rash (/ sr)

;;;      
  (defun s_tr ()
    (set_tile "Dv" (rtos d))
    (set_tile "Sv" (rtos s))
    (set_tile "C" (rtos co))
    (set_tile "P" (rtos pd))
    (set_tile "B" (rtos bd))
  ) ;_  defun

;;;      
   (defun fn_rr_sr (/ r)
     (setq sr (+ (/ (* pd d) (- (* 2.0 bd) pd)) co)
     ) ;_  setq
     (set_tile "Sr" (rtos sr))
     (if (> sr s)
          (set_tile "Zk" "<     >")
          (set_tile "Zk" "<    >")
     )  
   ) ;_  defun

    
   (new_dialog "ras" dcl_id)
   (s_tr)
   (fn_rr_sr)
   
   (action_tile "C" "(prv_p $value 'co \"C\" \"r\")")
   (action_tile "P" "(prv_p $value 'pd \"P\" \"r\")")
   (action_tile "B" "(prv_p $value 'bd \"B\" \"r\")")
   (action_tile "F" "(prv_p $value 'fr \"F\" \"r\")(prov 0.65 fr 1.0 \"F\" \".\")")
   
   (action_tile "RR" "(fn_rr_sr)")
   (action_tile "cancel" "(done_dialog 1)")

   (start_dialog)			;   


 ) ;_  defun

  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "trubdn" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
    (dfl_fn)
    (desk_f)
    (whl)
    (tipf_l)
    (dyf_l)
    (stf_l)
    (if	(eq ins "0")
      (rs_mss)
      (setq massa "?")
    ) ;_  if
    (s_t)

    (if	(or (eq sech "1") (eq sprd "1"))
      (mode_tile "Shtr" 0)
    ) ;_  if

    (if	(eq sprd "1")
      (mode_tile "Ins" 1)
    ) ;_  if
    
    (if	(eq ins "1")
      (mode_tile "L" 1)
      (mode_tile "L" 0)
    ) ;_  if
    
    (mode_tile "Tipf" 2)

;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(defl)"
	      "(dfl_fn)"
	      "(desk_f)"
	      "(whl)"
	      "(dyf_l)"
	      "(stf_l)"
	      "(if (eq ins \"0\") (rs_mss) (setq massa \"?\"))"
	      "(s_t)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(setq dy $value)"
	      "(setq st \"0\")"
	      "(desk_f)"
	      "(whl)"
	      "(stf_l)"
	      "(if (eq ins \"0\") (rs_mss) (setq massa \"?\"))"
	      "(s_t)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S"
      (strcat "(setq st $value)"
	      "(desk_f)"
	      "(whl)"
	      "(if (eq ins \"0\") (rs_mss) (setq massa \"?\"))"
	      "(s_t)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "L"
      (strcat "(prv_p $value 'l \"L\" \"r\")"
	      "(prov 1 l 50000 \"L\" \"\")"
	      "(if (eq ins \"0\") (rs_mss) (setq massa \"?\"))"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Ins"
      (strcat "(setq ins $value)"
	      "(if (eq ins \"1\") (mode_tile \"L\" 1)(mode_tile \"L\" 0))"
	      "(if (eq ins \"0\") (rs_mss) (setq massa \"?\"))"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(mode_tile \"Ins\" 0)"
	      "(if (eq ins \"1\") (mode_tile \"L\" 1)(mode_tile \"L\" 0))"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(mode_tile \"Ins\" 1)"
	      "(if (eq ins \"1\") (mode_tile \"L\" 1)(mode_tile \"L\" 0))"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(mode_tile \"Ins\" 0)"
	      "(if (eq ins \"1\") (mode_tile \"L\" 1)(mode_tile \"L\" 0))"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Rash"
      (strcat "(rash)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if

  (if (= sprd "1") (setq ins "0"))
  
  (if (/= ins "1")
    (if	(eq p2 "1")
      (progn
	(setq
	  a1 (getangle inptG
		       (strcat "\n   <" angl ">:")
	     ) ;_  getangle
	) ;_  setq
	(if (= a1 nil)
	  (setq a1 (* pi (/ (atof angl) 180)))
	  (setq a1 (+ a1 (/ pi 2.0)))
	) ;_  if
      ) ;_  progn
      (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if
    (progn
      (initget 1)
      (setq inptG2 (getpoint inptG "\n   :")
	    l	   (/ (distance inptG inptG2) mb)
	    a1	   (+ (angle inptG inptG2) (/ pi 2.0))
      ) ;_  setq
    ) ;_  progn
  ) ;_  if


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* l mb) 2))
    (command "_ZOOM" "_C" inptG (* (* l mb) 2))
  ) ;_  if

  
;;;    
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (os_ln l)
	 (shell (- d (* 2.0 s)) s l inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	 (shell2 (- d (* 2.0 s)) s inptG a1 mb)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	 (os_ln l)
	 (shell3 (- d (* 2.0 s)) s l inptG a1 mb)
	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  TRUBDN
