;;;    90  
;;;: (lpotr dn a a1 a2 b b1 b2 c 1 h h1 m n d d1 d2 s1 s2 al hl ip an1 mb pdl shtrp)
;;;:   dn -   Dn;
;;;       a -  a;
;;;       a1 -  a1;
;;;       a2 -  a2;
;;;       b -  b;
;;;       b1 -  b1;
;;;       b2 -  b2;
;;;       c -  c;
;;;       c1 -  c1;
;;;       h -  h;
;;;       h1 -  h1;
;;;       m -  m;
;;;       n -  n;
;;;       d -   d;
;;;       d1 -   d1;
;;;       d2 -   d2;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       hl -  H;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - );
;;;       shtrp -  ("1" - , "0" - )
;;; : 01.10.2001

(defun lpotr (dn  a   a1   a2	b    b1	  b2   c    1	 h    h1   m
		 n    d	   d1	d2   s1	  s2   al   hl	 ip   an1  mb
		 pdl  shtrp	/    p1	  p2   p3   p4	 p5   p6   p7
		 p8   ks0  ks12	z    box  lsta e    flag ang1 lt1  lt2
		 p9   p10  an0	an2  ip1  pc3  an3  label1    sset1
		 r0   p11  p12	p13  p14  p15  p16  p17	 p18  p19  p20
		 p21  p21a p22	p23  p24  p25  p26  p16a p27  p28  p29
		 p30  p31  os1	os2  os3  os4  p28a p30a xt1  
		) 


;;;      
  (setq	r0 (* dn 0.5 mb)
	a  (* a mb)
;;;	a1 (* a1 mb)
;;;	a2 (* a2 mb)
	b  (* b mb)
	b1 (* b1 mb)
	b2 (* b2 mb)
	c  (* c mb)
	c1 (* c1 mb)
	h  (* h mb)
	h1 (* h1 mb)
	m  (* m mb)
	n  (* n mb)
	d  (* d mb)
	d1 (* d1 mb)
	d2 (* d2 mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
;;;	al (* al mb)
	hl (* hl mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt lt1 lt2)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (- (* a 0.5) s1)
	   xt  (- lt1 (sqrt (- (expt lt1 2.0) (expt lt2 2.0))))
;;;	   ip1 (polar ip (+ an1 pi) r0)
	   b   (- b xt)
	   m   (- m xt)
     ) ;_  setq
;;;        
     (setq p1  (polar ip an1 s2)
	   p2  (polar p1 an1 (- b b1))
	   p3  (polar p2 (- an1 (/ pi 2.0)) h1)
	   p4  (polar p3 an1 b2)
	   p5  (polar p4 (+ an1 (/ pi 2.0)) h1)
	   p6  (polar p5 an1 (- b1 b2))
	   p7  (polar p6 (+ an1 (/ pi 2.0)) s1)
	   p8  (polar p6 (+ an1 (/ pi 2.0)) n)
	   p10 (polar p1 (+ an1 (/ pi 2.0)) h)
	   p9  (polar p10 an1 m)
	   p11 (polar p7 (+ an1 pi) b)
	   p12 (polar p1 (- an1 (/ pi 2.0)) (/ (- hl h) 2.0));  
	   p13 (polar p12 (+ an1 pi) s2);  
	   p14 (polar p13 (+ an1 (/ pi 2.0)) hl);  
	   p15 (polar p14 an1 s2);  
     ) ;_  setq
    
;;;        
     (cond ((<= d2 20) (setq xt1 (* 1.6 mb)))
	   ((<= d2 30) (setq xt1 (* 2.0 mb)))
	   ((<= d2 48) (setq xt1 (* 2.5 mb)))
     ) ;_  cond
     (if (< xt1 1.0)
       (setq xt1 1.0)
     ) ;_  if
    
     (setq p16a	(polar p7 (+ an1 pi) c1)
	   p28a	(polar p7 (+ an1 pi) c)
	   p17  (polar p16a an1 (/ d1 2.0))
	   p18  (polar p17 (- an1 (/ pi 2.0)) s1)
	   p19  (polar p18 (+ an1 pi) (/ (- d1 d2) 2.0))
	   p20  (polar p19 (- an1 (/ pi 2.0)) h1)
	   p29  (polar p28a an1 (/ d 2.0))
	   p30  (polar p29 (- an1 (/ pi 2.0)) (+ h1 s1))
	   p27  (polar p19 (+ an1 pi) xt1)
	   p21  (polar p27 (- an1 (/ pi 2.0)) h1)
	   os1  (polar p16a (+ an1 (/ pi 2.0)) s1)
	   os2  (polar os1 (- an1 (/ pi 2.0)) (+ h1 s1 s1 s1))
	   os3  (polar p28a (+ an1 (/ pi 2.0)) s1)
	   os4  (polar os3 (- an1 (/ pi 2.0)) (+ h1 s1 s1 s1)) 
     ) ;_  setq

;;;      (  )
     (osn)
     (command "_LINE" p1 p6 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
     (command "_LINE" p2 p3 p4 p5 "")
     (command "_LINE" p6 p8 p9 p10 "")
     (command "_LINE" p7 p11 "")
     (command "_LINE" p1 p10 "")

;;;     
     (if (= pdl "1")
       (command "_LINE" p1 p12 p13 p14 p15 p10 "")
     ) ;_  if

;;;      
     (axs)
     (command "_LINE" os1 os2 "")
     (command "_LINE" os3 os4 "")

;;;     
    (osn)
    (command "_LINE" p29 p30 "")
    (setq label1 (entlast))
    (command "_MIRROR" label1 "" os3 os4 "_N")

;;;     
    (command "_LINE" p17 p18 "")
    (setq label1 (entlast))
    (setq sset1 (ssadd (entlast)))
    (command "_LINE" p27 p21 "")
    (while (setq label1 (entnext label1))
      (setq sset1 (ssadd label1 sset1))
    ) ;_  while
    (command "_MIRROR" sset1 "" os1 os2 "_N")
;;; ----  -----
    (if	(eq shtrp "1")
      (sht)
    ) ;_  if

;;;     
    (ton)
    (command "_LINE" p19 p20 "")
    (setq label1 (entlast))
    (command "_MIRROR" label1 "" os1 os2 "_N")
  ) ;_  OPR


;;;    
  (defun sht (/	dl1 dl2	dl3 dl4	ang1 ang2 ang3 ang4 pt1	pt2 pt3	pt4 pt5
	      pt6 pt7)
    (setq dl1  (distance p13 p15)
	  dl2  (distance p2 p11)
	  dl3  (distance p6 p29)
	  dl4  (distance p5 p30)
	  ang1 (angle p13 p15)
	  ang2 (angle p2 p11)
	  ang3 (angle p6 p29)
	  ang4 (angle p5 p30)
	  pt1  (polar p13 ang1 (/ dl1 2.0))
	  pt2  (polar p2 ang2 (/ dl2 2.0))
	  pt3  (polar p6 ang3 (/ dl3 2.0))
	  pt4  (polar p5 ang4 (/ dl4 2.0))
	  pt5  (polar p3 (+ an1 (/ pi 4.0)) s1)
	  pt6  (polar p21 (+ an1 (/ pi 4.0)) s1)
	  pt7  (polar p18 (+ an1 (/ pi 4.0)) s1)
    ) ;_  setq
    (ton)
    (command "_BHATCH" "_p" "_u" 45 2.0 "_n" pt2 pt3 pt7 "")
    (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pt4 pt5 pt6 "")
    (if	(eq pdl "1")
      (command "_BHATCH" "_p" "_u" 315 3.0 "_n" pt1 "")
    ) ;_  if
  ) ;_  SHT
 
;;;  ---------- ---------
  (opr)
  
) ;_  LPOTR


;;;    90   
;;;: (lpotra dn n0 a a1 b c 1 m d d1 d2 s1 s2 al ip an1 mb pdl)
;;;:   dn -   Dn;
;;;       n0 -  ;
;;;       a -  a;
;;;       a1 -  a1;
;;;       b -  b;
;;;       c -  c;
;;;       c1 -  c1;
;;;       m -  m;
;;;       d -   d;
;;;       d1 -   d1;
;;;       d2 -   d2;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - )
;;; : 02.10.2001

(defun lpotra (dn n0   a    a1	 b    c	   1	m    d	  d1   d2
		  s1   s2   al	 ip   an1  mb	pdl  /	  p1   p2
		  p3   p4   p5	 p6   p7   p8	ks0  ks12 z    box
		  lsta e    flag ang1 lt1  lt2	p9   p10  an0  an2
		  ip1  pc3  an3	 label1	   sset1     r0	  xt1  pc1
		  pc2  os1  os2	 os3  os4  os5  label2 sset2   p11
	          p12  p3a  p2a
		 ) 

;;;      
  (setq	r0 (* dn 0.5 mb)
	a  (* a mb)
	a1 (* a1 mb)
	b  (* b mb)
	c  (* c mb)
	c1 (* c1 mb)
	m  (* m mb)
	d  (* d mb)
	d1 (* d1 mb)
	d2 (* d2 mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
	al (* al mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt lt1 lt2)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (- (* a 0.5) s1)
	   xt  (- lt1 (sqrt (- (expt lt1 2.0) (expt lt2 2.0))))
	   ip1 (polar ip (+ an1 pi) r0)
	   an0 (/ al (* 2.0 (+ r0 (* 0.5 s2))))
     ) ;_  setq
;;;        
     (setq p1  (polar ip an1 s2)
	   p2  (polar p1 (+ an1 pi) xt)
	   p2  (polar p2 (+ an1 (/ pi 2.0)) lt2)
           p3  (polar p2 (+ an1 (/ pi 2.0)) s1)
	   p4  (polar p3 (+ an1 (/ pi 2.0)) (/ (- a1 a) 2.0))
	   p5  (polar p4 an1 b)
	   p6  (polar p3 an1 b)
	   p7  (polar p2 an1 b)
	   p3a (polar p3 an1 m)
	   p2a (polar p2 an1 m)
	   p8  (polar p1 an1 (- b xt))
	   p9  (polar ip1 (+ an1 an0) (+ r0 s2))
	   p10 (polar ip1 (+ an1 an0) r0)
	   os1 (polar ip an1 (+ b s2 s1))
	   pc1 (polar p8 (+ an1 pi) c1)
	   pc2 (polar p8 (+ an1 pi) c)
     ) ;_  setq
    
;;;        
     (cond ((<= d2 20) (setq xt1 (* 1.6 mb)))
	   ((<= d2 30) (setq xt1 (* 2.0 mb)))
	   ((<= d2 48) (setq xt1 (* 2.5 mb)))
     ) ;_  cond
     (if (< xt1 1.0)
       (setq xt1 1.0)
     ) ;_  if
    
     (setq os2 (polar pc1 (+ an1 (/ pi 2.0)) d1)
	   os3 (polar pc1 (- an1 (/ pi 2.0)) d1)
	   os4 (polar pc2 (+ an1 (/ pi 2.0)) d)
	   os5 (polar pc2 (- an1 (/ pi 2.0)) d)
	   p11 (polar pc1 an1 (/ d2 2.0))
	   p12 (polar pc1 (- an1 (/ pi 2.0)) (/ d2 2.0))
     ) ;_  setq

;;;      (  )
     (osn)
     (command "_LINE" p2 p4 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
     (setq label1 (entlast))
     (setq sset1 (ssadd (entlast)))
     (setq label2 (entlast))
     (setq sset2 (ssadd (entlast)))
     (command "_LINE" p4 p5 p8 "")
     (command "_LINE" p6 p3 "" "_LINE" p7 p2 "")
     (command "_LINE" p2a p3a "")
;;;     (command "_ARC" "_c" ip1 p1 p2)

;;;     
     (if (= pdl "1")
       (progn
	 (command "_ARC" "_c" ip1 p1 p9)
	 (command "_LINE" p9 p10 "")
       ) ;_  progn
     ) ;_  if

     (while (setq label1 (entnext label1))
       (setq sset1 (ssadd label1 sset1))
     ) ;_  while
     (command "_MIRROR" sset1 "" os1 ip "_N")

;;;      
     (axs)
     (command "_LINE" ip os1 "")
     (command "_LINE" os2 os3 "")
     (command "_LINE" os4 os5 "")

;;;     
    (osn)
    (command "_CIRCLE" pc2 (/ d 2.0))

;;;     
    (command "_CIRCLE" pc1 (/ d1 2.0))
    (command "_CIRCLE" pc1 (- (/ d2 2.0) xt1))

;;;     
    (ton)
    (command "_ARC" "_c" pc1 p11 p12)
    
;;; 
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (if	(> n0 1)
      (command "_ARRAY" sset2 "" "_p" ip1 n0 "" "")
    ) ;_  if
 
  ) ;_  OPR

;;;  ---------- ---------
  (opr)
) ;_  LPOTRA


;;;    90 
;;;: (lpotrb dn a a1 a2 h h1 n s1 s2 al hl ip an1 mb pdl)
;;;:   dn -   Dn;
;;;       a -  a;
;;;       a1 -  a1;
;;;       a2 -  a2;
;;;       h -  h;
;;;       h1 -  h1;
;;;       n -  n;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       hl -  H;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - )
;;; : 02.10.2001

(defun lpotrb (dn a    a1   a2	 h    h1   n	s1   s2	  al   hl
		  ip   an1  mb	 pdl  /	   p1	p2   p3	  p4   p5
		  p6   p7   p8	 ks0  ks12 z	box  lsta e    flag
		  ang1 lt1  lt2	 p9   p10  an0	an2  ip1  pc3  an3
		  label1    sset1     r0   p11	p12  xt1  p4a  p5a
		  pc1  pc2
		 )

;;;      
  (setq	r0 (* dn 0.5 mb)
	a  (* a mb)
	a1 (* a1 mb)
	a2 (* a2 mb)
	h  (* h mb)
	h1 (* h1 mb)
	n  (* n mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
	al (* al mb)
	hl (* hl mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt lt1 lt2)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (/ (- hl h) 2.0)
	   an0 (/ al (* 2.0 (+ r0 (* s2 0.5))))
	   xt  (* lt1 (sin an0))
     ) ;_  setq
;;;        
     (setq p1  (polar ip (+ an1 pi) (/ a2 2.0))
	   p2  (polar ip (+ an1 pi) (/ a1 2.0))
	   p3  (polar p2 (+ an1 (/ pi 2.0)) s1)
	   p6  (polar ip (+ an1 (/ pi 2.0)) s1)
	   p4  (polar p6 (+ an1 pi) (/ a 2.0))
	   p5  (polar p6 (+ an1 pi) (- (/ a 2.0) s1))
	   p7  (polar ip (- an1 (/ pi 2.0)) h1)
	   p8  (polar p7 (+ an1 pi) (/ a2 2.0))
	   p9  (polar p4 (+ an1 (/ pi 2.0)) (- h s1))
	   p10 (polar p5 (+ an1 (/ pi 2.0)) (- h s1))
	   p4a (polar p4 (+ an1 (/ pi 2.0)) (- n s1))
	   p5a (polar p5 (+ an1 (/ pi 2.0)) (- n s1))
	   pc1 (polar ip (+ an1 (/ pi 2.0)) (+ h lt2))
	   pc2 (polar pc1 (- an1 (/ pi 2.0)) hl)
	   p11 (polar pc1 (+ an1 pi) xt)
	   p12 (polar p11 (- an1 (/ pi 2.0)) hl)
     ) ;_  setq
    

;;;      (  )
     (osn)
     (command "_LINE" ip p2 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
     (setq label1 (entlast))
     (setq sset1 (ssadd (entlast)))
     (command "_LINE" p2 p3 p6 "")
     (command "_LINE" p4 p9 p10 p5 "")
     (command "_LINE" p7 p8 p1 "")
     (command "_LINE" p4a p5a "")

;;;     
     (if (= pdl "1")
       (command "_LINE" pc2 p12 p11 pc1 "")
     ) ;_  if

;;;     
     (while (setq label1 (entnext label1))
       (setq sset1 (ssadd label1 sset1))
     ) ;_  while
     (command "_MIRROR" sset1 "" pc1 pc2 "_N")
  ) ;_  OPR
 
;;;  ---------- ---------
  (opr)
  
) ;_  LPOTRB


;;;    90  
;;;: (lpotrc dn a b b1 b2 h h1 m n s1 s2 al hl ip an1 mb pdl)
;;;:   dn -   Dn;
;;;       a -  a;
;;;       b -  b;
;;;       b1 -  b1;
;;;       b2 -  b2;
;;;       h -  h;
;;;       h1 -  h1;
;;;       m -  m;
;;;       n -  n;
;;;       s1  -  s1;
;;;       s2 -    s2;
;;;       al -  A;
;;;       hl -  H;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pdl -    ("1" - )
;;; : 03.10.2001

(defun lpotrc (dn a    b    b1	 b2   h	   h1	m    n	  s1   s2
		  al   hl   ip	 an1  mb   pdl	/    p1	  p2   p3
		  p4   p5   p6	 p7   p8   ks0	ks12 z	  box  lsta
		  e    flag ang1 lt1  lt2  p9	p10  an0  an2  ip1
		  pc3  an3  label1    sset1	r0   p11  p12  p13
		  p14  p15  p16	 p17  p18  p19	xt1
		 ) 


;;;      
  (setq	r0 (* dn 0.5 mb)
	a  (* a mb)
	b  (* b mb)
	b1 (* b1 mb)
	b2 (* b2 mb)
	h  (* h mb)
	h1 (* h1 mb)
	m  (* m mb)
	n  (* n mb)
	s1 (* s1 mb)
	s2 (* s2 mb)
	al (* al mb)
	hl (* hl mb)
  ) ;_  setq

  (if (/= pdl "1")
    (setq s2 0.0)
  ) ;_  if

;;;   
  (defun opr (/ xt xt1 xt2 lt1 lt2)    
;;;     
     (setq lt1 (+ r0 s2)
	   lt2 (- (* a 0.5) s1)
	   xt  (- lt1 (sqrt (- (expt lt1 2.0) (expt lt2 2.0))))
	   ip1 (polar ip (+ an1 pi) r0)
	   an0 (/ al (* 2.0 (+ r0 (* s2 0.5))))
	   xt1 (- (+ r0 s2) (* r0 (cos an0)))
	   xt2 (- (+ r0 s2) (* (+ r0 s2) (cos an0)))
     ) ;_  setq
;;;        
     (setq p1  (polar ip an1 s2)
	   p2  (polar p1 an1 (- b b1 xt))
	   p3  (polar p2 (- an1 (/ pi 2.0)) h1)
	   p4  (polar p3 an1 b2)
	   p5  (polar p4 (+ an1 (/ pi 2.0)) h1)
	   p6  (polar p5 an1 (- b1 b2))
	   p7  (polar p6 (+ an1 (/ pi 2.0)) s1)
	   p8  (polar p6 (+ an1 (/ pi 2.0)) n)
	   p10 (polar p1 (+ an1 (/ pi 2.0)) h)
	   p9  (polar p10 an1 (- m xt))
	   p18 (polar p10 (+ an1 pi) xt)
	   p19 (polar p18 (- an1 (/ pi 2.0)) h)
	   p11 (polar p7 (+ an1 pi) b)
	   p12 (polar p1 (- an1 (/ pi 2.0)) (/ (- hl h) 2.0));  
	   p13 (polar p12 (+ an1 pi) xt1);  
	   p14 (polar p13 (+ an1 (/ pi 2.0)) hl);  
	   p15 (polar p14 an1 xt1);  
	   p16 (polar p12 (+ an1 pi) xt2);  
	   p17 (polar p16 (+ an1 (/ pi 2.0)) hl);  
     ) ;_  setq

;;;     
    (if	(= pdl "1")
      (obrobj p12 hl (* 4.0 s2) (/ pi 2.0))
      (obrobj p19 h (* 4.0 s1) (/ pi 2.0))
    ) ;_  if


;;;      (  )
     (osn)
     (command "_LINE" p19 p6 "")
     (setq label (entlast))
     (setq sset (ssadd (entlast)))
     (command "_LINE" p2 p3 p4 p5 "")
     (command "_LINE" p6 p8 p9 p18 "")
     (command "_LINE" p7 p11 "")
     (command "_LINE" p19 p18 "")

;;;     
     (if (= pdl "1")
       (command "_LINE" p1 p12 p13 p14 p15 p10 "" "_LINE" p16 p17 "")
     ) ;_  if
  ) ;_  OPR
 
;;;  ---------- ---------
  (opr)
  
) ;_  LPOTRC