;;;     
;;;: (ubotr d s d1 d2 d3 s1 s2 s3 d0 n l h ip a1 mb pr shtr)
;;;:   d -  ;
;;;       s -   ;
;;;       d1 -  D1;
;;;       d2 -  D2;
;;;       d3 -  D3;
;;;       s1 -   S1;
;;;       s2 -   S2;
;;;       s3 -   S3;
;;;       d0 -  ;
;;;       n -  ;
;;;       l -   ;
;;;       h -  ;
;;;       ip -  ;
;;;       a1 -   (  - 0);
;;;       mb -  ;
;;;       pr -  ;
;;;       shtr -      ("1" -  , "0" - ) 
;;; : 27.09.2001

(defun ubotr (d	s    d1	  d2   d3   s1	 s2   s3   d0	n    l	  h
		ip   a1	  mb   pr   shtr /    p1   p2	p3   p5	  p4
		p6   p7	  p8   ks0  ks12 z    r1   a	box  pt	  lsta
		e    flag ang1 pt1  pt2	 lt   r2   p0	r3   r	  dr
		hv   h1   h0   p9   p10  p11  p12  p13  p14  p15  ip1
	        label2 sset2   p15  p16  p17  p18  p19  p20  p21  p22
	        p23  p24  p17a p21a os1  os2  os3  os4  os5  p25  p26
	        pt3  pt4  pt5  pt6  pt7  pt8  pt9  pt10 p1a  p2a  p3a
	        p4a
	       ) 

;;;      
  (setq	r   (* d mb 0.5)
	s   (* mb s)
	r1  (* d1 mb 0.5)
	r2  (* d2 mb 0.5)
	r3  (* d3 mb 0.5)
	s1  (* mb s1)
	s2  (* mb s2)
	s3  (* mb s3)
	d0  (* mb d0)
	l   (* mb l)
	h   (* mb h)
  ) ;_  setq

;;;     
  (setq	hv (* 0.5 r)
	dr (+ (* 2.0 r) s)
	h1 (* (/ (+ hv s) dr)
	      (sqrt (- (expt dr 2.0) (expt (* 2.0 r) 2.0)))
	   ) ;_  *
	h2 (- hv h1)
  ) ;_  setq

;;;      
  (defun osn_ch	()
    (setq ip1  (polar ip (+ a1 (/ pi 2.0)) h2)
	  p1   (polar ip1 (+ a1 pi) r)
	  p2   (polar p1 (+ a1 pi) s1)
	  p3   (polar p2 (- a1 (/ pi 2.0)) (- h s2))
	  p4   (polar p1 (- a1 (/ pi 2.0)) (- h s2))
	  p6   (polar p4 a1 r)
	  p7   (polar p6 (- a1 (/ pi 2.0)) s2)
	  p5   (polar p6 (+ a1 pi) r1)
	  p8   (polar p7 (+ a1 pi) r1)
	  p13a (polar p6 (+ a1 pi) r2)
	  p9a  (polar p7 (+ a1 pi) r2)
	  p11  (polar p7 (+ a1 pi) r3)
	  p12  (polar p6 (+ a1 pi) r3)
	  p13  (polar p13a (+ a1 pi) (/ d0 2.0))
	  p14  (polar p13a a1 (/ d0 2.0))
	  p10  (polar p9a (+ a1 pi) (/ d0 2.0))
	  p9   (polar p9a a1 (/ d0 2.0))
	  os1  (polar p13a (+ a1 (/ pi 2.0)) s2)
	  os2  (polar p9a (- a1 (/ pi 2.0)) s2)
	  os3  (polar p7 (- a1 (/ pi 2.0)) s2)
    ) ;_  setq
    (axs)
    (command "_LINE" os1 os2 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (setq label2 (entlast))
    (setq sset2 (ssadd (entlast)))
    
    (osn)
    (command "_LINE" p1 p2 "")
    (command "_LINE" p1 p4 "" "_LINE" p2 p3 "")
    (command "_LINE" p7 p11 p12 p6 "")
    (command "_LINE" p5 p8 "")
    (command "_LINE" p10 p13 "" "_LINE" p9 p14 "")

;;;     
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (command "_MIRROR" sset2 "" ip os3 "_N")

    (axs)
    (command "_LINE" ip os3 "")
  ) ;_  OSN_CH


;;;       ( 1)
  (defun vsp1 (/ xt xt2 xt3 xt4 xt5 an1 an2 lt1 lt2)
    (setq an1 (/ pi n)
          xt  (- r3 (+ r s1))
	  xt1 (* r3 (cos an1))
	  xt2 (* xt 0.3);  
	  xt3 (* (+ r s1 xt2) (cos an1))
	  xt4 (* (+ r s1) (cos an1))
	  lt1 (* (* 0.5 s1) (sin an1))
	  p15 (polar p6 (+ a1 pi) (+ xt1 lt1))
	  p16 (polar p6 (+ a1 pi) (+ xt3 lt1))
	  p17 (polar p6 (+ a1 pi) (+ xt4 lt1))
	  p16 (polar p16 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p17 (polar p17 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  an2 (angle p15 p16)
    ) ;_  setq
;;;       
    (if	(>= xt3 (+ r s))
      (progn
	(setq p18 (polar p3 (+ a1 (/ pi 2.0)) (* 300.0 mb)))
	(osn)
	(command "_LINE" p15 p16 "")
	(setq label2 (entlast))
	(setq sset2 (ssadd (entlast)))
	(command "_LINE" p16 p18 "")
      ) ;_  progn
      (progn
	(setq xt5 (- xt1 (+ r s1))
	      lt2 (* xt5 (/ (sin an2) (cos an2)))
	      p18 (polar p3 (+ a1 (/ pi 2.0)) lt2)
	) ;_  setq
	(if (> xt1 (+ r s1))
	  (progn
	    (osn)
	    (command "_LINE" p15 p18 "")
	    (setq label2 (entlast))
	    (setq sset2 (ssadd (entlast)))
	  ) ;_  progn
	) ;_  if
      ) ;_  progn
    ) ;_  if
    
;;;     
    (if	(> xt1 (+ r s1))
      (progn
	(while (setq label2 (entnext label2))
	  (setq sset2 (ssadd label2 sset2))
	) ;_  while
	(command "_MIRROR" sset2 "" ip os3 "_N")
      ) ;_  progn
    ) ;_  if

;;;    
    (if	(= shtr "1")
      (sht)
    ) ;_  if
  ) ;_  VSP1


;;;       ( 2  3)
  (defun vsp2 (/ xt)
    (setq xt   (sqrt (- (expt r3 2.0) (expt (* 80 mb) 2.0)))
	  p15  (polar p12 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p20  (polar p3 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p21a (polar p13a (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p16  (polar p15 (+ a1 (/ pi 2.0)) s3)
	  p19  (polar p20 (+ a1 (/ pi 2.0)) s3)
          p17a (polar p21a (+ a1 (/ pi 2.0)) s3)
	  p24  (polar p6 (+ a1 pi) xt)
	  p23  (polar p24 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p17  (polar p17a (+ a1 pi) (/ d0 2.0))
	  p18  (polar p17a a1 (/ d0 2.0))
	  p22  (polar p21a (+ a1 pi) (/ d0 2.0))
	  p21  (polar p21a a1 (/ d0 2.0))
	  os4  (polar p17a (+ a1 (/ pi 2.0)) s2)
	  os5  (polar p21a (- a1 (/ pi 2.0)) s2)
	  p25  (polar p19 a1 (* (+ r s1) 2.0))
	  p26  (polar p20 a1 (* (+ r s1) 2.0))
    ) ;_  setq
;;;    
    (axs)
    (command "_LINE" os4 os5 "")
    (setq label2 (entlast))
    (setq sset2 (ssadd (entlast)))

    (osn)
    (command "_LINE" p20 p15 p16 p19 "")
    (command "_LINE" p24 p23 "")
    (command "_LINE" p22 p17 "" "_LINE" p21 p18 "")
    
;;;     
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (command "_MIRROR" sset2 "" ip os3 "_N")
;;;    
    (if	(= shtr "1")
      (sht)
    ) ;_  if
;;;    
    (if	(= pr 3)
      (progn
	(punkt)
	(command "_LINE" p20 p26 "" "_LINE" p19 p25 "")
      ) ;_  progn
    ) ;_  if
  ) ;_  VSP2

;;;       ( 5)
  (defun vsp5 (/ xt xt2)
    (setq xt   (sqrt (- (expt r1 2.0) (expt (* 80 mb) 2.0)))
	  xt2  (sqrt (- (expt r1 2.0) (expt (/ l 2.0) 2.0)))
	  p20  (polar p6 (+ a1 pi) xt2)
	  p15  (polar p4 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p20  (polar p20 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p21a (polar p13a (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p16  (polar p15 (+ a1 (/ pi 2.0)) s3)
	  p19  (polar p20 (+ a1 (/ pi 2.0)) s3)
          p17a (polar p21a (+ a1 (/ pi 2.0)) s3)
	  p24  (polar p6 (+ a1 pi) xt)
	  p23  (polar p24 (+ a1 (/ pi 2.0)) (* 300.0 mb))
	  p17  (polar p17a (+ a1 pi) (/ d0 2.0))
	  p18  (polar p17a a1 (/ d0 2.0))
	  p22  (polar p21a (+ a1 pi) (/ d0 2.0))
	  p21  (polar p21a a1 (/ d0 2.0))
	  os4  (polar p17a (+ a1 (/ pi 2.0)) s2)
	  os5  (polar p21a (- a1 (/ pi 2.0)) s2)
	  p25  (polar p19 a1 (* (+ r s1) 2.0))
	  p26  (polar p20 a1 (* (+ r s1) 2.0))
    ) ;_  setq
;;;    
    (axs)
    (command "_LINE" os4 os5 "")
    (setq label2 (entlast))
    (setq sset2 (ssadd (entlast)))

    (osn)
    (command "_LINE" p15 p20 p19 p16 "")
    (command "_LINE" p24 p23 "")
    (command "_LINE" p20 p19 "")
    (command "_LINE" p22 p17 "" "_LINE" p21 p18 "")
    
;;;     
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (command "_MIRROR" sset2 "" ip os3 "_N")
;;;    
    (if	(= shtr "1")
      (sht)
    ) ;_  if
  ) ;_  VSP5

;;;    
  (defun sht (/ xt xt1 xt2)
    (setq xt   (- r3 r2 (/ d0 2.0))
	  xt1  (- r2 r1 (/ d0 2.0))
	  xt2  (- r2 (+ r s1) (/ d0 2.0))
	  pt1  (polar p4 (angle p4 p2) (/ (distance p4 p2) 2.0))
	  pt2  (polar pt1 a1 (+ (* r 2.0) s1))
	  pt3  (polar p11 (angle p11 p13) (/ (distance p11 p13) 2.0))
	  pt4  (polar pt3 a1 (- (* r3 2.0) xt))
	  pt5  (polar p9 (angle p9 p5) (/ (distance p9 p5) 2.0))
	  pt6  (polar pt5 a1 (+ (* r1 2.0) xt1))
    ) ;_  setq
    (ton)
    (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pt1 pt2 "")
    (command "_BHATCH" "_p" "_u" 45 2.0 "_n" pt3 pt4 pt5 pt6 "")
    (cond ((or (= pr 2) (= pr 3))
	   (setq pt7  (polar p15 (angle p15 p17) (/ (distance p15 p17) 2.0))
		 pt8  (polar pt7 a1 (+ (* r2 2.0) d0 xt))
		 pt9  (polar p21 (angle p21 p19) (/ (distance p21 p19) 2.0))
		 pt10 (polar pt9 a1 (- (* r2 2.0) d0 xt2))
	   ) ;_  setq
	   (command "_BHATCH" "_p" "_u"	45 2.0 "_n" pt7	pt8 pt9	pt10 "")
	  )
	  ((= pr 5)
	   (setq xt1  (- r r2 (/ d0 2.0))
		 xt2  (- r2 r1 (/ d0 2.0))
	         pt7  (polar p15 (angle p15 p17) (/ (distance p15 p17) 2.0))
		 pt8  (polar pt7 a1 (+ (* r2 2.0) d0 xt1))
		 pt9  (polar p21 (angle p21 p19) (/ (distance p21 p19) 2.0))
		 pt10 (polar pt9 a1 (- (* r2 2.0) d0 xt2))
	   ) ;_  setq
	   (command "_BHATCH" "_p" "_u"	45 2.0 "_n" pt7	pt8 pt9	pt10 "")
	  )
    ) ;_  cond
  ) ;_  SHT


;;;  ---------------------- --------------------
  (osn_ch)

;;;    
  (cond	((= pr 1) (vsp1))
	((= pr 2) (vsp2))
	((= pr 3) (vsp2))
	((= pr 5) (vsp5))
  ) ;_  cond

) ;_  UBOTR


;;;     
;;;: (ubotr2 d d1 d2 d3 s1 d0 n l ip a1 mb pr shtr)
;;;:   d -  ;
;;;       d1 -  D1;
;;;       d2 -  D2;
;;;       d3 -  D3;
;;;       s1 -   S1;
;;;       d0 -  ;
;;;       n -  ;
;;;       l -   ;
;;;       ip -  ;
;;;       a1 -   (  - 0);
;;;       mb -  ;
;;;       pr -  ;
;;;       shtr -      ("1" -  , "0" - ) 
;;; : 27.09.2001

(defun ubotr2 (d  d1   d2   d3	s1   d0	  n    l    ip	 a1   mb   pr
		 shtr /	   p1	p2   p3	  p5   p4   p6	 p7   p8   ks0
		 ks12 z	   r1	a    box  pt   lsta e	 flag ang1 pt1
		 pt2  lt   r2	p0   r3	  r    dr   hv	 h1   h0   p9
		 p10  p11  p12	p13  p14  p15  ip1  label2    sset2
		 p15  p16  p17	p18  p19  p20  p21  p22	 p23  p24  p17a
		 p21a os1  os2	os3  os4  os5  p25  p26  pt3  pt4  p2a
	         p3a  p4a  p1a
		) 


;;;      
  (setq	r   (* d mb 0.5)
	r1  (* d1 mb 0.5)
	r2  (* d2 mb 0.5)
	r3  (* d3 mb 0.5)
	s1  (* mb s1)
	d0  (* mb d0)
	l   (* mb l)
  ) ;_  setq


;;;      
  (defun osn_ch	()
    (setq h1  (- r3 r2)
          p1  (polar ip (+ a1 pi) r2)
	  os1 (polar ip (+ a1 (/ pi 2.0)) (* r3 1.1))
	  os2 (polar ip (- a1 (/ pi 2.0)) (* r3 1.1))
	  os3 (polar ip (+ a1 pi) (* r3 1.1))
	  os4 (polar ip a1 (* r3 1.1))
	  os5 (polar p1 (+ a1 pi) h1)
	  os6 (polar p1 a1 h1)
    ) ;_  setq
    
;;;    
    (osn)
    (command "_CIRCLE" ip r3)
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (if	(/= pr 5)
      (command "_CIRCLE" ip r1)
    ) ;_  if
    (command "_CIRCLE" ip r)
    (command "_CIRCLE" ip (+ r s1))
    
    (axs)
    (command "_CIRCLE" ip r2)

;;;     
    (axs)
    (command "_LINE" os1 os2 "")
    (command "_LINE" os3 os4 "")
;;;    
    (if	(= shtr "1")
      (sht)
    ) ;_  if

;;;    
    (osn)
    (command "_CIRCLE" p1 (/ d0 2.0))
    (setq label2 (entlast))
    (setq sset2 (ssadd (entlast)))
    (if	(= pr 1)
      (progn
	(axs)
	(command "_LINE" os5 os6 "")
      ) ;_  progn
    ) ;_  if

;;;   
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (command "_ARRAY" sset2 "" "_p" inptG n "" "")
  ) ;_  OSN_CH


;;;       ( 1)
  (defun vsp1 (/ xt xt2 xt3 xt4 xt5 an1 st1)
    (setq an1 (/ 180 n)
	  st1 (* 0.5 s1)
	  xt  (- r3 (+ r s1))
          xt1 (- r3 (sqrt (- (expt r3 2.0) (expt st1 2.0))))
	  xt2 (- (+ r s1) (sqrt (- (expt (+ r s1) 2.0) (expt st1 2.0))))
	  xt3 (* xt 0.3);  
	  xt4 (- r3 r2)
	  xt5 (- r2 (+ r s1))
	  ip1 (polar ip (+ a1 pi) (+ r s1))
	  ip1 (polar ip1 (+ a1 pi) xt3)
	  p2a (polar p1 (+ a1 (/ pi 2.0)) st1)
          p2  (polar p2a (+ a1 pi) (- xt4 xt1))
	  p3  (polar p2a a1 (+ xt5 xt2))
	  p5  (polar p2 (- a1 (/ pi 2.0)) s1)
	  p4  (polar p3 (- a1 (/ pi 2.0)) s1)
	  p6  (polar ip1 (+ a1 (/ pi 2.0)) st1)
	  p7  (polar ip1 (- a1 (/ pi 2.0)) st1)
    ) ;_  setq
;;;    
    (osn)
    (command "_LINE" p2 p3 "")
    (setq label2 (entlast))
    (setq sset2 (ssadd (entlast)))
    (command "_LINE" p4 p5 "")
    (command "_LINE" p6 p7 "")   
;;;    
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (command "_ROTATE" sset2 "" ip an1)
    (command "_ARRAY" sset2 "" "_p" ip n "" "")
  ) ;_  VSP1


;;;       ( 2  3)
  (defun vsp2 (/ xt xt2 xt3 xt4 xt5 xt6 xt7 xt8 xt9 an1 st1 lt lt1)
    (setq lt  (* 0.5 l)
	  lt1 (* 80.0 mb)
          st1 (* 0.5 s1)
	  xt  (- r3 (+ r s1))
          xt1 (- r3 (sqrt (- (expt r3 2.0) (expt lt 2.0))))
	  xt2 (- (+ r s1) (sqrt (- (expt (+ r s1) 2.0) (expt lt 2.0))))
	  xt4 (- r3 r2)
	  xt5 (- r2 (+ r s1))
	  xt6 (- r3 (sqrt (- (expt r3 2.0) (expt (+ lt1 s1) 2.0))))
	  xt7 (- (+ r s1) (sqrt (- (expt (+ r s1) 2.0) (expt (+ lt1 s1) 2.0))))
	  xt8 (- r3 (sqrt (- (expt r3 2.0) (expt lt1 2.0))))
	  xt9 (- (+ r s1) (sqrt (- (expt (+ r s1) 2.0) (expt lt1 2.0))))
	  os1 (polar ip (+ a1 pi) (+ r s1))
	  os2 (polar ip (+ a1 pi) r3)
	  p2a (polar p1 (+ a1 (/ pi 2.0)) lt)
	  p3a (polar p1 (+ a1 (/ pi 2.0)) (+ lt1 s1))
	  p4a (polar p1 (+ a1 (/ pi 2.0)) lt1)
          p2  (polar p2a (+ a1 pi) (- xt4 xt1))
	  p3  (polar p2a a1 (+ xt5 xt2))
	  p5  (polar p2 (- a1 (/ pi 2.0)) l)
	  p4  (polar p3 (- a1 (/ pi 2.0)) l)
	  p6  (polar p3a (+ a1 pi) (- xt4 xt6))
	  p7  (polar p3a a1 (+ xt5 xt7))
	  p9  (polar p6 (- a1 (/ pi 2.0)) (* (+ lt1 s1) 2.0))
	  p8  (polar p7 (- a1 (/ pi 2.0)) (* (+ lt1 s1) 2.0))
	  p10 (polar p4a (+ a1 pi) (- xt4 xt8))
	  p11 (polar p4a a1 (+ xt5 xt9))
	  p13 (polar p10 (- a1 (/ pi 2.0)) (* lt1 2.0))
	  p12 (polar p11 (- a1 (/ pi 2.0)) (* lt1 2.0))
    ) ;_  setq
;;;    
    (punkt)
    (command "_LINE" p6 p7 "")
    (setq label2 (entlast))
    (setq sset2 (ssadd (entlast)))
    (command "_LINE" p9 p8 "")
    (command "_LINE" p10 p11 "" "_LINE" p12 p13 "")
    
    (if	(= pr 2)
      (progn
	(osn)
	(command "_LINE" p2 p3 "")
	(command "_LINE" p4 p5 "")
      ) ;_  progn
    ) ;_  if
;;;     
    (axs)
    (command "_LINE" os1 os2 "")
;;;    
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (command "_ARRAY" sset2 "" "_p" ip n "" "")
  ) ;_  VSP2
  

;;;       ( 5)
  (defun vsp5 (/ xt xt2 xt3 xt4 xt5 an0 an1 an2 an3 an4)
    (setq lt  (* 0.5 l)
	  lt1 (* 80.0 mb)
          st1 (* 0.5 s1)
	  xt  (- r r1)
          xt1 (- r (sqrt (- (expt r 2.0) (expt lt 2.0))))
	  xt2 (- r1 (sqrt (- (expt r1 2.0) (expt lt 2.0))))
	  xt4 (- r r2)
	  xt5 (- r2 r1)
	  xt6 (- r (sqrt (- (expt r 2.0) (expt (+ lt1 s1) 2.0))))
	  xt7 (- r1 (sqrt (- (expt r1 2.0) (expt (+ lt1 s1) 2.0))))
	  xt8 (- r (sqrt (- (expt r 2.0) (expt lt1 2.0))))
	  xt9 (- r1 (sqrt (- (expt r1 2.0) (expt lt1 2.0))))
	  os1 (polar ip (+ a1 pi) r1)
	  os2 (polar ip (+ a1 pi) r)
	  p2a (polar p1 (+ a1 (/ pi 2.0)) lt)
	  p3a (polar p1 (+ a1 (/ pi 2.0)) (+ lt1 s1))
	  p4a (polar p1 (+ a1 (/ pi 2.0)) lt1)
          p2  (polar p2a (+ a1 pi) (- xt4 xt1))
	  p3  (polar p2a a1 (+ xt5 xt2))
	  p5  (polar p2 (- a1 (/ pi 2.0)) l)
	  p4  (polar p3 (- a1 (/ pi 2.0)) l)
	  p6  (polar p3a (+ a1 pi) (- xt4 xt6))
	  p7  (polar p3a a1 (+ xt5 xt7))
	  p9  (polar p6 (- a1 (/ pi 2.0)) (* (+ lt1 s1) 2.0))
	  p8  (polar p7 (- a1 (/ pi 2.0)) (* (+ lt1 s1) 2.0))
	  p10 (polar p4a (+ a1 pi) (- xt4 xt8))
	  p11 (polar p4a a1 (+ xt5 xt9))
	  p13 (polar p10 (- a1 (/ pi 2.0)) (* lt1 2.0))
	  p12 (polar p11 (- a1 (/ pi 2.0)) (* lt1 2.0))
	  os3 (polar p3 (- a1 (/ pi 2.0)) lt)
    ) ;_  setq
;;;    
    (punkt)
    (command "_LINE" p6 p7 "")
    (setq label2 (entlast))
    (setq sset2 (ssadd (entlast)))
    (command "_LINE" p9 p8 "")
    (command "_LINE" p10 p11 "" "_LINE" p12 p13 "")
    (command "_ARC" "_c" ip p3 p4)
    
    (osn)
    (command "_LINE" p2 p3 "")
    (command "_LINE" p4 p5 "")
    (command "_LINE" p3 p4 "")
;;;     
    (axs)
    (command "_LINE" os2 os3 "")
;;;    
    (while (setq label2 (entnext label2))
      (setq sset2 (ssadd label2 sset2))
    ) ;_  while
    (command "_ARRAY" sset2 "" "_p" ip n "" "")

;;;      
    (setq an1 (atan (/ lt (sqrt (- (expt r1 2.0) (expt lt 2.0)))))
          an0 (* 2.0 an1)
	  an2 (/ (- (* 2.0 pi) (* an0 n)) n)
	  an3 (/ an2 2.0)
	  p15 (polar ip (+ a1 pi an3) r1)
	  p14 (polar ip (- (+ a1 pi) an3) r1)
	  an4 (* (/ (+ an1 an3) pi) 180)
    ) ;_  setq
    (osn)
    (command "_ARC" "_c" ip p14 p15)
    (setq label2 (entlast))
    (command "_ROTATE" label2 "" ip an4)
    (command "_ARRAY" label2 "" "_p" ip n "" "")
  ) ;_  VSP5

;;;    
  (defun sht ()
    (setq pt1 (polar ip (+ a1 (/ pi 4.0)) (+ r (/ s1 2.0)))
	  pt2 (polar ip (- a1 (/ pi 4.0)) (+ r (/ s1 2.0)))
	  pt3 (polar ip (+ a1 (* (/ pi 4.0) 3.0)) (+ r (/ s1 2.0)))
	  pt4 (polar ip (- a1 (* (/ pi 4.0) 3.0)) (+ r (/ s1 2.0)))
    ) ;_  setq
    (ton)
    (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pt1 pt2 pt3 pt4 "")
  ) ;_  SHT


;;;  ---------------------- --------------------
  (osn_ch)

;;;    
  (cond	((= pr 1) (vsp1))
	((= pr 2) (vsp2))
	((= pr 3) (vsp2))
	((= pr 5) (vsp5))
  ) ;_  cond

) ;_  UBOTR2