;;;      
;;;: (otvod_gn d sp r ang1 l ip a1 mb pr)
;;;:   d -   ;
;;;       sp -  ;
;;;       r -  ;
;;;       ang1 -  ;
;;;       l -    ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pr -   (1 - , 0 - )
;;; : 09.08.2001

(defun otvod_gn (d  sp	r    ang1 l    ip   a1	 mb   pr   /	p1
		   p2	p3   p5	  p4   p6   p7	 p8   ks0  ks12	z
		   r1	a    box  pt   lsta e	 flag ang1 pt1	pt2
		   lt	r2   p0	  p1a p2a p3a p4a p5a p6a  p7a p8a
		   pt3  
		  ) 


  
  

;;;      
  (setq	r1  (* d mb 0.5)
	sp  (* mb sp)
	l   (* mb l)
	r   (* mb r)
	pt1 (polar ip (+ a1 (/ pi 2.0)) l)
	p0  (polar pt1 a1 r)
	pt2 (polar p0 (- a1 (+ pi ang1)) r)
	pt3 (polar pt2 (+ a1 (- (/ pi 2.0) ang1)) l)
	p1  (polar ip (+ a1 pi) r1)
	p1a (polar ip (+ a1 pi) (- r1 sp))
	p5a (polar ip a1 (- r1 sp))
	p5  (polar ip a1 r1)
	p2  (polar pt1 (+ a1 pi) r1)
	p2a (polar pt1 (+ a1 pi) (- r1 sp))
	p6a (polar pt1 a1 (- r1 sp))
	p6  (polar pt1 a1 r1)
	p3  (polar p0 (- a1 (+ pi ang1)) (+ r r1))
	p3a (polar p0 (- a1 (+ pi ang1)) (+ r (- r1 sp)))
	p7  (polar p0 (- a1 (+ pi ang1)) (- r r1))
	p7a (polar p0 (- a1 (+ pi ang1)) (- r (- r1 sp)))
	p4  (polar p3 (+ a1 (- (/ pi 2.0) ang1)) l)
	p4a (polar p3a (+ a1 (- (/ pi 2.0) ang1)) l)
	p8  (polar p7 (+ a1 (- (/ pi 2.0) ang1)) l)
	p8a (polar p7a (+ a1 (- (/ pi 2.0) ang1)) l)
  ) ;_  setq

;;;   
  (axs2)
  (command "_arc" "_c" p0 pt2 pt1)
  (setq label (entlast))
  (setq sset (ssadd (entlast))) 
  (command "_line" ip pt1 "")
  (command "_line" pt2 pt3 "")

;;;   
  (osn)
  (command "_line" p1 p5 "" "_line" p4 p8 "")
  (command "_line" p1 p2 "" "_line" p5 p6 "")
  (command "_line" p3 p4 "" "_line" p7 p8 "")
  (command "_arc" "_c" p0 p3 p2)
  (command "_arc" "_c" p0 p7 p6)

;;;     
  (if (= pr 1)
    (progn
      (command "_line" p1a p2a "" "_line" p5a p6a "")
      (command "_line" p3a p4a "" "_line" p7a p8a "")
      (command "_arc" "_c" p0 p3a p2a)
      (command "_arc" "_c" p0 p7a p6a)
    ) ;_  progn
  ) ;_  if

  
  (if (and (eq shtrp "1") (= pr 1))
    (progn
      (setq pt1	 (polar p2 (+ a1 (/ pi 4.0)) (* sp 0.5))
	    pt2	 (polar pt1 a1 (- (* r1 2.0) sp))
	    av	 (* (/ a1 pi) 180)
      ) ;_  setq
      (ton)
      (command "_bhatch" "_p" "_u" (+ av 45) 2.0 "_n" pt1 pt2 "")
    ) ;_  progn
  ) ;_  if
 
) ;_  OTVOD_GN

;;;     
;;;: (otvod_gn2 d r ang1 l ip a1 mb pr)
;;;:   d -   ;
;;;       r -  ;
;;;       ang1 -  ;
;;;       l -    ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;;       pr -   (1 - , 0 - )
;;; : 09.08.2001
(defun otvod_gn2 (d r ang1 l ip a1 mb pr / pt1 pt2 pt3 pt4 p1 p2 p3 p4 p5 l1 r2)

    (if	(<= ang1 (/ pi 2.0))
      (progn
	(setq l1  (+ l (* r (sin ang1)) (* l (cos ang1)))
	      r1  (* d mb 0.5)
	      l1  (* mb l1)
	      r2  (* r1 (sin ang1))
	      pt1 (polar ip (+ a1 (/ pi 2.0)) l1)
	      pt2 (polar pt1 (+ a1 (/ pi 2.0)) r2)
	      pt3 (polar pt1 (+ a1 pi) (* r1 1.1))
	      pt4 (polar pt1 a1 (* r1 1.1))
	      p1  (polar ip (+ a1 pi) r1)
	      p3  (polar ip a1 r1)
	      p2  (polar p1 (+ a1 (/ pi 2.0)) l1)
	      p4  (polar p3 (+ a1 (/ pi 2.0)) l1)
	      p5  (polar pt1 (- a1 (/ pi 2.0)) r2)
	) ;_  setq
;;;      
	(axs)
	(command "_line" ip pt2 "")
	(setq label (entlast))
        (setq sset (ssadd (entlast)))
	(command "_line" pt3 pt4 "")
;;;      
	(osn)
        (command "_line" p1 p2 "" "_line" p3 p4 "" "_line" p1 p3 "")
	(command "_ellipse" "_a" p4 p2 r2 p4 p2)
	(if (= pr 0)
	  (command "_ellipse" "_a" p4 p2 r2 p2 p4)
	) ;_  if
      ) ;_  progn
      (progn
	(setq l1  (+ l r)
	      r1  (* d mb 0.5)
	      l1  (* mb l1)
	      pt1 (polar ip (+ a1 (/ pi 2.0)) l1)
	      pt2 (polar pt1 (+ a1 (/ pi 2.0)) r1)
	      pt3 (polar pt1 (+ a1 pi) (* r1 1.05))
	      pt4 (polar pt1 a1 (* r1 1.05))
	      p1  (polar ip (+ a1 pi) r1)
	      p3  (polar ip a1 r1)
	      p2  (polar p1 (+ a1 (/ pi 2.0)) l1)
	      p4  (polar p3 (+ a1 (/ pi 2.0)) l1)
	) ;_  setq
;;;      
	(axs)
	(command "_line" ip pt2 "")
	(setq label (entlast))
        (setq sset (ssadd (entlast)))
	(command "_line" pt3 pt4 "")
;;;      
	(osn)
	(command "_line" p1 p2 "" "_line" p3 p4 "" "_line" p1 p3 "")
        (command "_arc" "_c" pt1 p4 p2)	
      ) ;_  progn
    ) ;_  if
      
  
) ;_  OTVOD_GN2

