;;;    
;;;:  ..
;;; : 10.08.2001
;;;CAD-CEE 2000
;;;: C:SVOTVD

(defun c:svotvd (/ tipf	 db    d     dotv  notv	 h     h2    b
		   l	 s     sech  sprd  name1 orx   aby   dlg
		   dfl	 lsp1  lsp2  lsp3  lsp4	 lsp5  fld   strd
		   strdd strd1 strdd1	   p1	 p2    p3    angl
		   mash	 name1 spis  pti   inptG xc    yc    dcl_id
		   inptG a1    mb    cmd   blpm	 apsz  osmd  clay
		   cltp	 ccol  vs    vctr  pv	 anbl  sset  label
		   sech2 sbk   py    dy	   pyf	 dyf   stf   fldat
		   dfl2	 as    ass   bs	   bss	 bss1  bss2  fldat2
		   as2	 ass2  dtb   stb   shtrp spism mtr   hpa
		   hpn	 st    ang1  an	   anf   nf    nn    n
		   r
		  ) 

  (setq	dlg  (findfile (strcat pathdcl2 "otvod\\svotvd.dcl"))
	dfl  (findfile (strcat pathlisp2 "otvod\\svotvd.d"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "otvod\\otvod_sv.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

;;;    ,    
  (setq	dyf '("6"    "8"    "10"   "12"	  "14"	 "16"	"18"   "20"
	      "25"   "32"   "38"   "45"	  "57"	 "76"	"89"   "108"
	      "133"  "159"  "219"  "273"  "325"	 "377"	"425"
	     )
  ) ;_  setq

  (setq anf '("30" "45" "60" "90"))

  (setq nf '("2" "3" "4" "5"))
  
;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun
  (defun textf ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  
;;;      SVOTVD.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
;;;	   dy	  (itoa (nth 0 strdd1))
	   d	  (nth 0 strdd1)
	   s	  (nth 1 strdd1)
	   r	  (nth 2 strdd1)
	   an	  (itoa (nth 3 strdd1))
	   nn	  (itoa (nth 4 strdd1))
	   l	  (nth 5 strdd1)
	   sech	  (itoa (nth 6 strdd1))
	   sprd	  (itoa (nth 7 strdd1))
	   sbk1	  (itoa (nth 8 strdd1))
	   sbk2	  (itoa (nth 9 strdd1))
	   shtrp  (itoa (nth 10 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
;;;    (set_tile "D" dy)
    (set_tile "D" (rtos d))
    (set_tile "S" (rtos s))
    (set_tile "R" (rtos r))
    (set_tile "A" an)
    (set_tile "N" nn)
    (set_tile "L" (rtos l))  
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk1" sbk1)
    (set_tile "Sbk2" sbk2)
    (set_tile "Shtr" shtrp)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       SVOTVD.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
;;;        (setq strd1 (strcat "(" dy " " (rtos s) " " (rtos r) " " an " " nn " " (rtos l) " " sech " " sprd
;;;			    " " sbk1 " " sbk2 " " shtrp ")")
;;;	)
         (setq strd1 (strcat "(" (rtos d) " " (rtos s) " " (rtos r) " " an " " nn " " (rtos l) " " sech " " sprd
			    " " sbk1 " " sbk2 " " shtrp ")")
	)  
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk1 "0")
	      (eq sbk2 "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "otvod\\svotvd(1).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk1 "0")
	      (eq sbk2 "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "otvod\\svotvd(2).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk1 "1")
	      (eq sbk2 "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "otvod\\svotvd(3).slb"))
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk1 "0")
	      (eq sbk2 "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "otvod\\svotvd(4).slb"))
	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;   
    (defun dyf_l ()
      (start_list "D")
      (mapcar 'add_list dyf)
      (end_list)
    ) ;_  defun

;;;   
    (defun anf_l ()
      (start_list "A")
      (mapcar 'add_list anf)
      (end_list)
    ) ;_  defun

;;;    
    (defun nf_l ()
      (start_list "N")
      (mapcar 'add_list nf)
      (end_list)
    ) ;_  defun
  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun
  

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun

;;;    
   (defun prov_gl ()
;;;       (if (< d 200)
	 (if (> s (* 0.3 d))
	     (progn
	        (attn2 1 (* 0.3 d) "")
	        (mode_tile "S" 2)
	     )
	     (if (< r (* d 0.1))
	       (progn
	        (attn2 (* d 0.1) (* d 10.0) "")
	        (mode_tile "R" 2)
	       )
	       (done_dialog)
	     ) ;_  if
	 ) ;_  if
;;;	 (if (or (> s (* 0.1 d)) (< s 4.0))
;;;	     (progn
;;;	        (attn2 4 (* 0.1 d) "")
;;;	        (mode_tile "S" 2)
;;;	     )
;;;	     (if (< r (* d 0.1))
;;;	       (progn
;;;	        (attn2 (* d 0.1) (* d 10.0) "")
;;;	        (mode_tile "R" 2)
;;;	       )
;;;	       (done_dialog)
;;;	     ) ;_  if
;;;	 ) ;_  if
;;;       ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "svotvd" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (show_im (name))
;;;    (dyf_l)
    (anf_l)
    (nf_l)
;;;           
    (setq ;d    (atof (nth (atoi dy) dyf))
	  ang1 (atof (nth (atoi an) anf))
	  ang1 (* (/ ang1 180.0) pi)
	  n (atof (nth (atoi nn) nf))
    ) ;_  setq
    (s_t)

    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (mode_tile "D" 2)

;;;     
;;;    (action_tile
;;;      "D"
;;;      (strcat "(setq dy $value)"
;;;	      "(setq d  (atof (nth (atoi dy) dyf)))"
;;;	      "(if (< r (* d 0.1)) (progn (setq r (* d 0.1)) (set_tile \"R\" (rtos r))))"
;;;      ) ;_  strcat
;;;    ) ;_  action_tile
    (action_tile
      "D"
      (strcat "(prv_p $value 'd \"D\" \"r\")"
	      "(prov 6 d 1000 \"D\" \"\")"
	      "(if (< r (* d 0.1)) (progn (setq r (* d 0.1)) (set_tile \"R\" (rtos r))))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S"
      (strcat "(prv_p $value 's \"S\" \"r\")"
;;;	      "(if (< d 200)"
	      "(prov 1 s (* 0.3 d) \"S\" \"\")"
;;;	      "(prov 4 s (* 0.1 d) \"S\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "R"
      (strcat "(prv_p $value 'r \"R\" \"r\")"
	      "(prov (* d 0.1) r (* d 10) \"R\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "A"
      (strcat "(setq an $value)"
	      "(setq ang1 (atof (nth (atoi an) anf)))"
	      "(setq ang1 (* (/ ang1 180.0) pi))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N"
      (strcat "(setq nn $value)"
	      "(setq n  (atof (nth (atoi nn) nf)))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "L"
      (strcat "(prv_p $value 'l \"L\" \"r\")"
	      "(prov 0 l 2000 \"L\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk1 \"0\")"
	      "(setq sbk2 \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk1 \"0\")"
	      "(setq sbk2 \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk1"
      (strcat "(setq sbk1 $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(setq sbk2 \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk2"
      (strcat "(setq sbk2 $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(setq sbk1 \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(prov_gl)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 (- a1 (/ pi 2)))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* (+ r l l) mb) 2))
    (command "_ZOOM" "_C" inptG (* (* (+ r l l) mb) 2))
  ) ;_  if

  
;;;    
  (cond	((and (eq sech "1")
	      (eq sprd "0")
	      (eq sbk1 "0")
	      (eq sbk2 "0")
	 ) ;_  and
	 (otvod_sv d s r ang1 n l inptG a1 mb 1)
	)
	((and (eq sech "0")
	      (eq sprd "1")
	      (eq sbk1 "0")
	      (eq sbk2 "0")
	 ) ;_  and
	 (otvod_sv d s r ang1 n l inptG a1 mb 0)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk1 "1")
	      (eq sbk2 "0")
	 ) ;_  and
	 (otvod_sv2 d r ang1 n l inptG a1 mb 1)
	)
	((and (eq sech "0")
	      (eq sprd "0")
	      (eq sbk1 "0")
	      (eq sbk2 "1")
	 ) ;_  and
	 (otvod_sv2 d r ang1 n l inptG a1 mb 0)
	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  SVOTVD
