;;;     
;;;: (konshtm d d1 sp sp1 l l1 r ip a1 mb)
;;;:   d -    ;
;;;       d1 -    ;
;;;       sp -    d;
;;;       sp1 -    d1;
;;;       l -   ;
;;;       l1 -    ;
;;;       r -  ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 07.08.2001

(defun konshtm (d d1   sp   sp1	 l    l1   r	ip   a1	  mb   /
		  p1   p2   p3	 p5   p4   p6	p7   p8	  ks0  ks12
		  z    r1   a	 box  pt   lsta	e    flag ang1 pt1
		  pt2  lt   r2	 p0  label sset p6a p7a  
		 ) 

;;;         
;;;   (ln_pr p1 p2 p3 p4)
;;;  : p1,p2 -   ;
;;;       p2,p3 -   ;
;;;       p3,p4 -   
;;;  :      
  (defun ln_pr (p1 p2 p3 p4 / label1 label2 label3)
      (command "_line" p1 p2 "")
      (setq label1 (entlast))
      (command "_line" p2 p3 "")
      (setq label2 (entlast))
      (command "_line" p3 p4 "")
      (setq label3 (entlast))
      (command "_fillet" label1 label2)
      (command "_fillet" label2 label3)
  ) ;_  defun

  
  (osn)

;;;      
  (setq	r1  (* d mb 0.5)
	r2  (* d1 mb 0.5)
	sp  (* mb sp)
	sp1 (* mb sp1)
	l   (* mb l)
	l1  (* mb l1)
	r   (* mb r)
	p0  (polar ip (+ a1 (/ pi 2.0)) l)
	p1  (polar ip (+ a1 pi) r1)
	p5 (polar ip (+ a1 pi) (- r1 sp))
	p2  (polar p1 (+ a1 (/ pi 2.0)) l1)
	p6 (polar p5 (+ a1 (/ pi 2.0)) l1)
	p6a (polar p6 a1 (* (- r1 sp) 2.0))
	p4  (polar p0 (+ a1 pi) r2)
	p8 (polar p0 (+ a1 pi) (- r2 sp1))
	p3  (polar p4 (- a1 (/ pi 2.0)) l1)
	p7 (polar p8 (- a1 (/ pi 2.0)) l1)
	p7a (polar p7 a1 (* (- r2 sp1) 2.0))
  ) ;_  setq

  (command "_line" ip p1 "")
  (setq label (entlast))
  (setq sset (ssadd (entlast)))
  (command "_line" p0 p4 "")

;;;    
;;;  (command "_line" p6 p6a "")
;;;  (command "_line" p7 p7a "")

;;;    
  (command "_fillet" "_r" r)
  (ln_pr p1 p2 p3 p4)
  (ln_pr p5 p6 p7 p8)
  
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while
  (command "_MIRROR" sset "" p0 ip "_N")
  
  (if (eq shtrp "1")
    (progn
      (setq lt	 (distance p1 p6)
	    ang1 (angle p1 p6)
	    pt1	 (polar p1 ang1 (/ lt 2.0))
	    pt2	 (polar pt1 a1 (- (* r1 2.0) sp))
	    av	 (* (/ a1 pi) 180)
      ) ;_  setq
      (ton)
      (command "_bhatch" "_p" "_u" (+ av 45) 2.0 "_n" pt1 pt2 "")
    ) ;_  progn
  ) ;_  if
 
  
) ;_  KONSHTM

;;;    
;;;: (konshtm2 d d1 s ip a1 mb)
;;;:   d -    ;
;;;       d1 -    ;
;;;       s -   ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 07.08.2001
(defun konshtm2 (d d1 s ip a1 mb / pt1 pt2 pt3 pt4 p1 p2 p3 p4)
      (osn)
      (command "_circle" ip (* (+ (/ d1 2.0) s) mb))
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_circle" ip (* (+ (/ d 2.0) s) mb))
;;;     
      (setq pt1	(polar ip (+ a1 pi) (* (* (+ d (* s 2.0)) 0.55) mb))
	    pt2	(polar pt1 a1 (* (* (+ d (* s 2.0)) 1.1) mb))
	    pt3	(polar ip (+ a1 (/ pi 2.0)) (* (* (+ d (* s 2.0)) 0.55) mb))
	    pt4	(polar pt3 (- a1 (/ pi 2.0)) (* (* (+ d (* s 2.0)) 1.1) mb))
      ) ;_  setq

      (axs)
      (command "_line" pt1 pt2 "")
      (command "_line" pt3 pt4 "")
  
) ;_  KONSHTM2

;;;    
;;;: (konshtm3 d d1 sp sp1 l l1 r ip a1 mb)
;;;:   d -    ;
;;;       d1 -    ;
;;;       l -   ;
;;;       l1 -    ;
;;;       r -  ;
;;;       ip -  ;
;;;       a1 -  ;
;;;       mb -  ;
;;; : 07.08.2001

(defun konshtm3 (d  d1	l    l1	  r    ip   a1	 mb   /	   p1	p2
		   p3	p5   p4	  p6   p7   p8	 ks0  ks12 z	r1
		   a	box  pt	  lsta e    flag ang1 pt1  pt2	lt
		   r2	p0   label  sset   p2a	 p3a
		  ) 

;;;         
;;;   (ln_pr p1 p2 p3 p4)
;;;  : p1,p2 -   ;
;;;       p2,p3 -   ;
;;;       p3,p4 -   
;;;  :      
  (defun ln_pr (p1 p2 p3 p4 / label1 label2 label3)
      (command "_line" p1 p2 "")
      (setq label1 (entlast))
      (command "_line" p2 p3 "")
      (setq label2 (entlast))
      (command "_line" p3 p4 "")
      (setq label3 (entlast))
      (command "_fillet" label1 label2)
      (command "_fillet" label2 label3)
  ) ;_  defun

  
  (osn)

;;;      
  (setq	r1  (* d mb 0.5)
	r2  (* d1 mb 0.5)
	l   (* mb l)
	l1  (* mb l1)
	r   (* mb r)
	p0  (polar ip (+ a1 (/ pi 2.0)) l)
	p1  (polar ip (+ a1 pi) r1)
	p2  (polar p1 (+ a1 (/ pi 2.0)) l1)
	p2a (polar p2 a1 (* r1 2.0))
	p4  (polar p0 (+ a1 pi) r2)
	p3  (polar p4 (- a1 (/ pi 2.0)) l1)
	p3a (polar p3 a1 (* r2 2.0))
  ) ;_  setq

  (command "_line" ip p1 "")
  (setq label (entlast))
  (setq sset (ssadd (entlast)))
  (command "_line" p0 p4 "")

;;;    
;;;  (command "_line" p2 p2a "")
;;;  (command "_line" p3 p3a "")

;;;    
  (command "_fillet" "_r" r)
  (ln_pr p1 p2 p3 p4)
  
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while
  (command "_MIRROR" sset "" p0 ip "_N")
  
) ;_  KONSHTM3