;;;CAD-CEE 2000
;;; : 24.11.92
;;;  : 15.05.2002 ( ..)
;;; ..
;;;    18512-73 ( 1)  
;;; : (cov21 dd dv d1 d2 d3 do h h1 rd ip a1 mb hole shtrp)
;;; : dd -   ;
;;;                   dv -  ;
;;;                   d1 -    ;
;;;		      d2 -   ;
;;;		      d3 -   ;
;;;		      do -   ;
;;;		      h -  ;
;;;		      h1 -   ;
;;;		      rd -     ;
;;;		      ip -  ;
;;;		      a1 -  ;
;;;		      mb -  ;
;;;		      hole -    (1-, 2-);
;;;                   shtrp -    ("0" - , "1" - )

(defun cov21 (dd dv d1 d2 d3 do	h h1 rd	ip a1 mb hole shtrp /	d4 d5 d6 h2 l b1 bm r a3
	      a4 c1 c2 c3 c4 c5	c6 c7 c8 c9 c10	c11 c12	c13 c14	c15 c16	c17 c18
	      c19 c20 c21 c22 c23 c24 c25 c26 c27 c28 c29 c30 c31 c32 c33 c34
	      c35 c36 c37 c38 c39 c40 c41 c42 c43 c44 c45 c46 c47 c48 c49 c50
	      c51 w ob1	ob2 ob3	ob4 ob5	ob6 asz hat1 hat2 hat3
	     )

  (setq d1 (* d1 mb)
	d2 (* d2 mb)
	d3 (* d3 mb)
	do (* do mb)
	h  (* h mb)
	h1 (* h1 mb)
	d5 (* (nth 2 rd) mb) ;     
	d6 (* (nth 3 rd) mb) ;  
  ) ;_  setq
  (if (> d6 d3)
    (setq d3 d6)
  ) ;_  if
  (setq	d4  (* (nth 4 rd) mb) ;  ( h2>0)
	h2  (* (nth 5 rd) mb) ; 
	l   (* (nth 6 rd) mb) ;  
	b1  (* (nth 7 rd) mb) ;   
	bm  (* (nth 8 rd) mb) ; 
	r   (/ (sqrt (* (expt h2 2.0) 2.0)) 2.0) ; 
	dv  (* dv mb)
	dd  (* dd mb)
	a3  (/ pi 2.0)
	a4  (+ a3 pi)
	c1  (polar ip (+ a1 a3) (/ dv 2.0))
	c2  (polar ip (+ a1 a4) (/ dv 2.0))
	c3  (polar ip (+ a1 a3) (/ d3 2.0))
	c4  (polar ip (+ a1 a4) (/ d3 2.0))
	c5  (polar ip (+ a1 a3) (/ dd 2.0))
	c6  (polar ip (+ a1 a4) (/ dd 2.0))
	c7  (polar c5 (+ a1 pi) h)
	c8  (polar c6 (+ a1 pi) h)
	c9  (polar c3 (+ a1 pi) l)
	c10 (polar c4 (+ a1 pi) l)
	c11 (polar c1 (+ a1 pi) l)
	c12 (polar c2 (+ a1 pi) l)
	c13 (polar c11 (+ a1 pi) b1)
	c14 (polar c12 (+ a1 pi) b1)
	c15 (polar c13 (+ a1 a3) (/ (- d6 dv) 2.0))
	c16 (polar c15 (+ a1 a4) d6)
	c17 (polar c15 a1 bm)
	c18 (polar c16 a1 bm)
	c19 (polar c15 a1 b1)
	c20 (polar c16 a1 b1)
	c21 (polar c13 (+ a1 a3) (/ (- d5 dv) 2.0))
	c22 (polar c21 (+ a1 a4) d5)
	c23 (polar c1 (+ a1 pi) (+ h h1 h2))
	c24 (polar c23 (+ a1 a4) dv)
	c25 (polar c23 (+ a1 a3) (/ (- d5 dv) 2.0))
	c26 (polar c25 (+ a1 a4) d5)
	c27 (polar c23 (+ a1 a3) (/ (- d4 (* 2.0 h2) dv) 2.0))
	c28 (polar c24 (+ a1 a4) (/ (- d4 (* 2.0 h2) dv) 2.0))
	c29 (polar c7 (+ a1 a3) (/ (- d2 dd) 2.0))
	c30 (polar c29 (+ a1 a4) d2)
	c31 (polar c29 (+ a1 pi) h1)
	c32 (polar c30 (+ a1 pi) h1)
	c33 (polar c31 (+ a1 a4) (/ (- d2 d4) 2.0))
	c34 (polar c33 (+ a1 a4) d4)
	c35 (polar ip (+ a1 a3) (/ d1 2.0))
	c36 (polar ip (+ a1 a4) (/ d1 2.0))
	c37 (polar c35 (+ a1 pi) (+ h h1 h2 5.0))
	c38 (polar c36 (+ a1 pi) (+ h h1 h2 5.0))
	c39 (polar c29 (+ a1 a4) (/ (- d2 d1 do) 2.0))
	c40 (polar c39 (+ a1 a4) do)
	c41 (polar c39 (+ a1 pi) h1)
	c42 (polar c40 (+ a1 pi) h1)
	c49 (polar c13 a1 bm)
	c50 (polar c14 a1 bm)
	c43 (polar c49 (+ a1 a3 (/ a3 2.0)) 1.0)
	c44 (polar c43 (+ a1 a4) (+ dv 2.0))
	c45 (polar c15 (+ a1 a4 (/ a3 2.0)) 1.0)
	c46 (polar c45 (+ a1 a4) (- d6 2.0))
	asz (* (getvar "DIMASZ") 1.2)
	c47 (polar c43 (angle c43 c45) asz)
	c48 (polar c44 (angle c44 c46) asz)
	c51 (polar ip (+ a1 pi) (+ h h1 h2))
	w   (/ asz 2.85)
  ) ;_  setq
  (osn)
  (if (zerop h2)
    (progn
      (command "_LINE" c3 c5 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_LINE" c5 c7 c29 c31 c25 c21 c15 c19 c9 c3 "") 
      (command "_LINE" c4 c6 c8 c30 c32 c26 c22 c16 c20 c10 "_C")
    ) ;_  progn
    (progn
      (command "_LINE" c25 c21 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_LINE" c21 c15 c19 c9 c3 c5 c7 c29 c31 "")
      (command "_LINE" c26 c22 c16 c20 c10 c4 c6 c8 c30 c32 "")
      (command "_LINE" c31 c33 "")
      (setq ob1 (entlast))
      (command "_LINE" c32 c34 "")
      (setq ob2 (entlast))
      (command "_LINE" c33 c27 "")
      (setq ob3 (entlast))
      (command "_LINE" c34 c28 "")
      (setq ob4 (entlast))
      (command "_LINE" c27 c25 "")
      (setq ob5 (entlast))
      (command "_LINE" c28 c26 "")
      (setq ob6 (entlast))
      (command "_FILLET" "_R" r)
      (command "_FILLET" ob1 ob3)
      (command "_FILLET" ob2 ob4)
      (command "_FILLET" ob3 ob5)
      (command "_FILLET" ob4 ob6)
    ) ;_  progn
  ) ;_  if
  (if (= hole 1)
    (progn
      (command "_LINE" c39 c41 "")
      (command "_LINE" c40 c42 "")
    ) ;_  progn
  ) ;_  if

;;;  
  (if (= shtrp "1")
    (progn
      (setq hat1 (polar c9 (angle c9 c7) (/ (distance c9 c7) 2.0))
	    hat2 (polar c10 (angle c10 c8) (/ (distance c10 c8) 2.0))
	    hat3 (polar c31 (angle c31 c39) (/ (distance c31 c39) 2.0))
      ) ;_  setq
      (ton)
      (command "_BHATCH" "_P" "_U" 45 2 "_N" hat1 "")
      (command "_BHATCH" hat2 "")
      (if (= hole 1)
	(command "_BHATCH" hat3 "")
      ) ;_  if
    ) ;_  progn
  ) ;_  if
  
  
;;;   
  (osn)
  (command "_LINE" c25 c23 "")
  (command "_LINE" c24 c26 "")
  (command "_LINE" c13 c21 "")
  (command "_LINE" c14 c22 "")
  (command "_LINE" c49 c17 "")
  (command "_LINE" c50 c18 "")
  (if (/= d3 d6)
    (progn
      (command "_LINE" c11 c19 "")
      (command "_LINE" c12 c20 "")
    ) ;_  progn
  ) ;_  if
  (command "_LINE" c4 c2 "")
  (command "_LINE" c1 c3 "")
  (if (> (distance c43 c45) asz)
    (progn
      (ton)
      (command "_PLINE" c43 "_W" 0 w c47 "_W" 0 0 c45 "")
      (command "_PLINE" c44 "_W" 0 w c48 "_W" 0 0 c46 "")
    ) ;_  progn
  ) ;_  if

;;; 
  (axs)
  (command "_LINE" ip c51 "")
  (command "_LINE" c35 c37 "")
  (command "_LINE" c36 c38 "")
) ;_  COV21


;;;    18512-73 ( 1)  
;;; : (cov21_2 dv d1 d2 dotv notv rd ip a1 mb hole)
;;; : dv -  ;
;;;                   d1 -    ;
;;;		      d2 -   ;
;;;		      dotv -   ;
;;;		      notv -   ;
;;;		      rd -     ;
;;;		      ip -  ;
;;;		      a1 -  ;
;;;		      mb -  ;
;;;		      hole -    (1-, 2-)
  (defun cov21_2 (dv d1	d2 dotv	notv rd	ip a1 mb hole /	p1 p2 p3 os1 os2 os3 os4
		  av d4	d5 h2
		 )
    
    (setq av  (/ pi notv)
	  d4  (nth 4 rd)
	  d5  (nth 2 rd)
	  h2  (nth 5 rd)
	  p1  (polar inptG (+ (+ pi av) a1) (* (/ d1 2.0) mb))
	  p2  (polar p1 (+ (+ pi av) a1) (* (* dotv 0.55) mb))
	  p3  (polar p1 (+ av a1) (* (* dotv 0.55) mb))
	  os1 (polar inptG (+ pi a1) (* (* d2 0.55) mb))
	  os2 (polar inptG a1 (* (* d2 0.55) mb))
	  os3 (polar inptG (+ a1 (/ pi 2)) (* (* d2 0.55) mb))
	  os4 (polar inptG (- a1 (/ pi 2)) (* (* d2 0.55) mb))
    ) ;_  setq

    (axs)
    (command "_LINE" p2 p3 "")
    (setq label (entlast))
    (setq sset (ssadd (entlast)))
    (osn)
    (if	(and (>= (* dotv mb) 0.6) (= hole 1))
      (progn
	(command "_CIRCLE" p1 "_D" (* dotv mb))
	(setq sset (ssadd (entlast) sset))
      ) ;_  progn
    ) ;_  if
;;;     
    (command "_ARRAY" sset "" "_P" inptG notv "" "")

    (command "_CIRCLE" inptG "_D" (* d2 mb))
    (if	(/= h2 0.0)
      (command "_CIRCLE" inptG "_D" (* d4 mb))
    ) ;_  if

;;;    (if	(> (* (/ (- d5 dv) 2.0) mb) 0.6)
      (command "_CIRCLE" inptG "_D" (* d5 mb))
;;;    ) ;_  if

    (axs)
    (command "_CIRCLE" inptG "_D" (* d1 mb))
    (command "_LINE" os1 os2 "")
    (command "_LINE" os3 os4 "")

  ) ;_  COV21_2

;;;    18512-73 ( 1) 
;;; : (cov21_3 dd dv d1 d2 d3 do h h1 rd ip a1 mb)
;;; : dd -   ;
;;;                   dv -  ;
;;;                   d1 -    ;
;;;		      d2 -   ;
;;;		      d3 -   ;
;;;		      do -   ;
;;;		      h -  ;
;;;		      h1 -   ;
;;;		      rd -     ;
;;;		      ip -  ;
;;;		      a1 -  ;
;;;		      mb -  

(defun cov21_3 (dd dv d1 d2 d3 do h h1 rd ip a1	mb / d4	d5 d6 h2 l b1 bm r a3 a4
		c1 c2 c3 c4 c5 c6 c7 c8	c9 c10 c11 c12 c13 c14 c15 c16 c17 c18
		c19 c20	c21 c22	c23 c24	c25 c26	c27 c28	c29 c30	c31 c32	c33 c34
		c35 c36	c37 c38	c39 c40	c41 c42	c43 c44	c45 c46	c47 c48	c49 c50
		c51 w ob1 ob2 ob3 ob4 ob5 ob6 asz hat1 hat2 hat3
	       )

  (setq	d1 (* d1 mb)
	d2 (* d2 mb)
	d3 (* d3 mb)
	do (* do mb)
	h  (* h mb)
	h1 (* h1 mb)
	d5 (* (nth 2 rd) mb) ;     
	d6 (* (nth 3 rd) mb) ;  
  ) ;_  setq
  (if (> d6 d3)
    (setq d3 d6)
  ) ;_  if
  (setq	d4  (* (nth 4 rd) mb) ;  ( h2>0)
	h2  (* (nth 5 rd) mb) ; 
	l   (* (nth 6 rd) mb) ;  
	b1  (* (nth 7 rd) mb) ;   
	bm  (* (nth 8 rd) mb) ; 
	r   (/ (sqrt (* (expt h2 2.0) 2.0)) 2.0) ; 
	dv  (* dv mb)
	dd  (* dd mb)
	a3  (/ pi 2.0)
	a4  (+ a3 pi)
	c1  (polar ip (+ a1 a3) (/ dv 2.0))
	c2  (polar ip (+ a1 a4) (/ dv 2.0))
	c3  (polar ip (+ a1 a3) (/ d3 2.0))
	c4  (polar ip (+ a1 a4) (/ d3 2.0))
	c5  (polar ip (+ a1 a3) (/ dd 2.0))
	c6  (polar ip (+ a1 a4) (/ dd 2.0))
	c7  (polar c5 (+ a1 pi) h)
	c8  (polar c6 (+ a1 pi) h)
	c9  (polar c3 (+ a1 pi) l)
	c10 (polar c4 (+ a1 pi) l)
	c11 (polar c1 (+ a1 pi) l)
	c12 (polar c2 (+ a1 pi) l)
	c13 (polar c11 (+ a1 pi) b1)
	c14 (polar c12 (+ a1 pi) b1)
	c15 (polar c13 (+ a1 a3) (/ (- d6 dv) 2.0))
	c16 (polar c15 (+ a1 a4) d6)
	c17 (polar c15 a1 bm)
	c18 (polar c16 a1 bm)
	c19 (polar c15 a1 b1)
	c20 (polar c16 a1 b1)
	c21 (polar c13 (+ a1 a3) (/ (- d5 dv) 2.0))
	c22 (polar c21 (+ a1 a4) d5)
	c23 (polar c1 (+ a1 pi) (+ h h1 h2))
	c24 (polar c23 (+ a1 a4) dv)
	c25 (polar c23 (+ a1 a3) (/ (- d5 dv) 2.0))
	c26 (polar c25 (+ a1 a4) d5)
	c27 (polar c23 (+ a1 a3) (/ (- d4 (* 2.0 h2) dv) 2.0))
	c28 (polar c24 (+ a1 a4) (/ (- d4 (* 2.0 h2) dv) 2.0))
	c29 (polar c7 (+ a1 a3) (/ (- d2 dd) 2.0))
	c30 (polar c29 (+ a1 a4) d2)
	c31 (polar c29 (+ a1 pi) h1)
	c32 (polar c30 (+ a1 pi) h1)
	c33 (polar c31 (+ a1 a4) (/ (- d2 d4) 2.0))
	c34 (polar c33 (+ a1 a4) d4)
	c35 (polar ip (+ a1 a3) (/ d1 2.0))
	c36 (polar ip (+ a1 a4) (/ d1 2.0))
	c37 (polar c35 (+ a1 pi) (+ h h1 h2 5.0))
	c38 (polar c36 (+ a1 pi) (+ h h1 h2 5.0))
	c51 (polar ip (+ a1 pi) (+ h h1 h2 5.0))
  ) ;_  setq
  (osn)
  (if (zerop h2)
    (progn
      (command "_LINE" c29 c31 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_LINE" c29 c30 c32 c31 "")
    ) ;_  progn
    (progn
      (command "_LINE" c29 c31 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_LINE" c29 c30 c32 c31 "")
      (command "_LINE" c25 c26 "")
      (command "_LINE" c31 c33 "")
      (setq ob1 (entlast))
      (command "_LINE" c32 c34 "")
      (setq ob2 (entlast))
      (command "_LINE" c33 c27 "")
      (setq ob3 (entlast))
      (command "_LINE" c34 c28 "")
      (setq ob4 (entlast))
      (command "_LINE" c27 c25 "")
      (setq ob5 (entlast))
      (command "_LINE" c28 c26 "")
      (setq ob6 (entlast))
      (command "_FILLET" "_R" r)
      (command "_FILLET" ob1 ob3)
      (command "_FILLET" ob2 ob4)
      (command "_FILLET" ob3 ob5)
      (command "_FILLET" ob4 ob6)
    ) ;_  progn
  ) ;_  if


;;; 
  (axs)
  (command "_LINE" ip c51 "")
  (command "_LINE" c35 c37 "")
  (command "_LINE" c36 c38 "")
) ;_  COV21_3