;;; CAD-CEE 2000
;;;   : 28.04.93
;;;    : 17.05.2002 ( ..)
;;;  ..
;;;          
;;;  .
;;;  : (keyseat2 dv b tp dopb dopt tip ip a1 mb)
;;;  : dv -  ;
;;;                    b -  ;
;;;                    tp -   ;
;;;                    dopb -   b ( tip ="0" -  nil);
;;;                    dopt -   t2 ( tip ="0" -  nil);
;;;                    tip -    ("0" - , "1" - c d+t2, "2" -  t1);
;;;		       ip -  ;
;;;		       a1 -  ;
;;;		       mb -  

(defun keyseat2	(dv b tp dopb dopt tip ip a1 mb	/ bli cmd cla mod vs dv	b tp bd
		 td ip a1 a3 a4	mb lt dvr bw h p1 p2 p3	p4 p5 p6 p7 p8 d1 d2 sl
		)

;;;    
  (setq	dvr (* (/ dv 2.0) mb)
	bw  (* (/ b 2.0) mb)
	h   (- dvr (sqrt (- (expt dvr 2.0) (expt bw 2.0))))
	tp  (* tp mb)
  ) ;_  setq
  (setq	a4 (/ pi 2.0)
	a3 (+ pi (/ pi 2.0))
	p1 (polar ip (+ a1 pi) dvr)
	p2 (polar ip a1 dvr)
	p3 (polar p2 (+ a1 pi) h)
	p4 (polar p3 (+ a1 a3) bw)
	p5 (polar p3 (+ a1 a4) bw)
	p6 (polar p2 a1 tp)
	p7 (polar p6 (+ a1 a3) bw)
	p8 (polar p6 (+ a1 a4) bw)
	d1 (polar p6 a1 20.0)
	d2 (polar ip (+ a1 a3) (+ dvr 20.0))
  ) ;_  setq

  (osn)
  (command "_PLINE" p5 "_W" "0"	"0" p8 p7 p4 "_A" "_S" p1 p5 "")
  (setq label (entlast))
  (setq sset (ssadd (entlast)))

  (textf)

  (cond	((= tip "1")
	 (command "_DIMALIGNED" p7 p8 d1 (strcat (rtos b) dopb))
	 (command "_DIMALIGNED" p6 p1 d2 (strcat (rtos (+ d tp)) dopt))
	)
	((= tip "2")
	 (command "_DIMALIGNED" p7 p8 d1 (strcat (rtos b) dopb))
	 (command "_DIMALIGNED" p2 p6 d2 (strcat (rtos tp) dopt))
	)
  ) ;_  cond
  (if (= tip "2")
    (command "_ARC" p4 "_C" ip p2)
  ) ;_  if

) ;_  KEYSEAT2

