;;;    
;;;:  ..
;;; : 16.05.2002
;;;CAD-CEE 2000
;;;: C:SHPNK

(defun c:shpnk (/ tipf dz d b tt tt1 tt2 l y svr sval name1 orx	aby dlg	dfl lsp1
		  lsp2 lsp3 lsp4 lsp5 fld strd strdd strd1 strdd1 p1 p2	p3 angl
		  mash name1 spis pti inptG xc yc dcl_id inptG a1 mb cmd blpm
		  apsz osmd clay cltp ccol vs vctr pv anbl sset	label sech2 svtk
		  py dy	stf fldat dfl2 as ass bs bss bss1 bss2 fldat2 as2 ass2
		  dtb stb shtrp	spism mtr hpa hpn lb dat1 dat2 dat3 dd m rzb
		  spis rdim rl rl1 rl2 rl3 l1 l1s ly bty btf dmin dmax dopb1
		  dopb2 dopt bty1 btyz bty1z
		 ) 

  (setq	dlg  (findfile (strcat pathdcl2 "privod\\shpnk.dcl"))
	dfl  (findfile (strcat pathlisp2 "privod\\shpnk.d"))
	dat2 (findfile (strcat pathdat2 "privod\\slot.dat"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "privod\\slot2.lsp"))
	lsp2 (findfile (strcat pathlisp2 "privod\\sval2.lsp"))
	lsp3 (findfile (strcat pathlisp2 "privod\\keyseat2.lsp"))
  ) ;_  setq

  (load anbl)
  (load lsp1)
  (load lsp2)
  (load lsp3)

;;;    
  (setq	spis '(" "
	       "1 "
	       "2 "
	      )
  ) ;_  setq

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun
  (defun textf ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun


;;;      SHPNK.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   d	  (nth 0 strdd1)
	   bty	  (itoa (nth 1 strdd1))
	   btyz	  (itoa (nth 2 strdd1))
	   ly	  (itoa (nth 3 strdd1))
	   rdim	  (itoa (nth 4 strdd1))
	   rzb	  (itoa (nth 5 strdd1))
	   svr	  (itoa (nth 6 strdd1))
	   sval	  (itoa (nth 7 strdd1))
	   svtk	  (itoa (nth 8 strdd1))
	   shtrp  (itoa (nth 9 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "D" (rtos d))
    (set_tile "BT" bty)
    (set_tile "L" ly)
    (set_tile "T1" (rtos tt1))
    (set_tile "T2" (rtos tt2))
    (set_tile "DIM" rdim)
    (set_tile "Rzb" rzb)
    (set_tile "Svr" svr)
    (set_tile "Sval" sval)
    (set_tile "Svtk" svtk)
    (set_tile "Shtr" shtrp)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       SHPNK.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" (rtos d) " " bty " " btyz " " ly " " rdim " " rzb " " svr 
			    " " sval " " svtk " " shtrp ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq svr "1")
	      (eq sval "0")
	      (eq svtk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "privod\\shpnk(1).slb"))
	)
	((and (eq svr "0")
	      (eq sval "1")
	      (eq svtk "0")
	      (eq rdim "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "privod\\shpnk(2).slb"))
	)
	((and (eq svr "0")
	      (eq sval "1")
	      (eq svtk "0")
	      (eq rdim "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "privod\\shpnk(3).slb"))
	)
	((and (eq svr "0")
	      (eq sval "1")
	      (eq svtk "0")
	      (eq rdim "2")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "privod\\shpnk(4).slb"))
	)
	((and (eq svr "0")
	      (eq sval "0")
	      (eq svtk "1")
	      (eq rdim "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "privod\\shpnk(5).slb"))
	)
	((and (eq svr "0")
	      (eq sval "0")
	      (eq svtk "1")
	      (eq rdim "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "privod\\shpnk(6).slb"))
	)
	((and (eq svr "0")
	      (eq sval "0")
	      (eq svtk "1")
	      (eq rdim "2")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "privod\\shpnk(7).slb"))
	)
  ) ;_  cond

) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

;;;       
  (defun lst_per (lst / nl i els lst1)
    (setq nl   (length lst)
	  i    1
	  lst1 '()
    ) ;_  setq
    (while (<= i nl)
      (setq els	 (itoa (fix (nth (1- i) lst)))
	    i	 (1+ i)
	    lst1 (cons els lst1)
      ) ;_  setq
    ) ;_  while
    (setq lst1 (reverse lst1))
  ) ;_  defun

;;;       
  (defun bty_fn	()
    (if	(> (atof bty1) (atof btyz))
      (if (not (or (and (= bty1 "6") (= btyz "5"))
		   (and (= bty1 "15") (= btyz "14"))
	       ) ;_  or
	  ) ;_  not
	(progn
	  (attn3)
	  (setq bty1 btyz)
	) ;_  progn
      ) ;_  if
    ) ;_  if 
  ) ;_  defun


;;;      
(defun desk_f ()
  (setq	fldat (open dat2 "r")
	as    (read-line fldat)
	btf   (read as)
	bs    (read-line fldat)
	bss   (read bs)
	bty   (nth 0 bss)
	dmin  (nth 1 bss)
	dmax  (nth 2 bss)
	b     (nth 3 bss)
	tt    (nth 4 bss)
	l1    (nth 5 bss)
	tt1   (nth 6 bss)
	tt2   (nth 7 bss)
	dopb1 (nth 8 bss)
	dopb2 (nth 9 bss)
	dopt  (nth 10 bss)
  ) ;_  setq
) ;_  defun


 ;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun



;;;       ( )
(defun whl ()
  (if (not (<= dmin d dmax))
    (clos_dfl2)
  ) ;_  if 
  (while (not (<= dmin d dmax))
    (setq bs	(read-line fldat)
	  bss	(read bs)
	  bty	(nth 0 bss)
	  dmin	(nth 1 bss)
	  dmax	(nth 2 bss)
	  b	(nth 3 bss)
	  tt	(nth 4 bss)
	  l1	(nth 5 bss)
	  tt1	(nth 6 bss)
	  tt2	(nth 7 bss)
	  dopb1	(nth 8 bss)
	  dopb2	(nth 9 bss)
	  dopt	(nth 10 bss)
    ) ;_  setq
  ) ;_  while
  (setq	btyz bty
	dz   d
  ) ;_  setq
) ;_  defun


;;;       (  )
(defun whl2 ()
  (if (/= (atof bty1) (atof bty))
    (clos_dfl2)
  ) ;_  if 
  (while (/= (atof bty1) (atof bty))
    (setq bs	(read-line fldat)
	  bss	(read bs)
	  bty	(nth 0 bss)
	  dmin	(nth 1 bss)
	  dmax	(nth 2 bss)
	  b	(nth 3 bss)
	  tt	(nth 4 bss)
	  l1	(nth 5 bss)
	  tt1	(nth 6 bss)
	  tt2	(nth 7 bss)
	  dopb1	(nth 8 bss)
	  dopb2	(nth 9 bss)
	  dopt	(nth 10 bss)
    ) ;_  setq
  ) ;_  while
  (setq bty1z bty1)
) ;_  defun


;;;     
    (defun btf_l ()
      (start_list "BT")
      (mapcar 'add_list btf)
      (end_list)
    ) ;_  defun

;;;    
    (defun l1f_l ()
      (start_list "L")
      (mapcar 'add_list l1s)
      (end_list)
    ) ;_  defun

;;;     
    (defun dimf_l ()
      (start_list "DIM")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun

;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
    (if	(= svr "1")
      (setq srv (* b mb))
      (if (= sval "1")
	(setq srv (* tt1 mb))
	(setq srv (* tt2 mb))
      ) ;_  if
    ) ;_  if

    (if	(<= srv 1.0)
      (progn (set_tile "Pred"
		       "!    "
	     ) ;_  set_tile
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -       
   (defun attn3 ()
        (new_dialog "att3" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun
  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "shpnk" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (setq y 0)
    (rdfl)
    (setq bty1 bty)
    (show_im (name))
    (desk_f)
    (whl2)
    (setq l1s (lst_per l1))
    (setq l (nth (atoi ly) l1))
    (setq dz d)
    (btf_l)
    (l1f_l)
    (dimf_l)
    (s_t)
    (setq y 1)

    (if	(= svr "1")
      (mode_tile "DIM" 1)
    ) ;_  if
    (if	(= sval "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    (if	(= sval "1")
      (mode_tile "Rzb" 0)
    ) ;_  if
    (mode_tile "D" 2)

;;;       
    (action_tile
      "D"
      (strcat "(prv_p $value 'd \"D\" \"r\")"
	      "(prov 6 d 500 \"D\" \"\")"
	      "(if (/= dz d)"
	      "(progn"
	      "(desk_f)"
	      "(whl)"
	      "(setq ly \"0\")" 
	      "(setq l1s (lst_per l1))"
	      "(setq l (nth (atoi ly) l1))"
	      "(l1f_l)"
	      "(s_t)"
	      "))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "BT"
      (strcat "(setq bty1 $value)"
	      "(bty_fn)"
	      "(if (/= bty1z bty1) (setq ly \"0\"))"
	      "(desk_f)"
	      "(whl2)"
	      "(setq l1s (lst_per l1))"
	      "(setq l (nth (atoi ly) l1))"
	      "(l1f_l)"
	      "(s_t)"
	     ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "L"
      (strcat "(setq ly $value)"
	      "(setq l (nth (atoi ly) l1))"
	     ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "DIM"
      (strcat "(setq rdim $value)"
	      "(show_im (name))"
	      "(s_t)"
	     ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Rzb"
      (strcat "(setq rzb $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Svr"
      (strcat "(setq svr $value)"
	      "(setq sval \"0\")"
	      "(setq svtk \"0\")"
	      "(mode_tile \"DIM\" 1)"
	      "(mode_tile \"Shtr\" 1)"
	      "(mode_tile \"Rzb\" 1)"
	      "(show_im (name))"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sval"
      (strcat "(setq sval $value)"
	      "(setq svr \"0\")"
	      "(setq svtk \"0\")"
	      "(mode_tile \"DIM\" 0)"
	      "(mode_tile \"Shtr\" 0)"
	      "(mode_tile \"Rzb\" 0)"
	      "(show_im (name))"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Svtk"
      (strcat "(setq svtk $value)"
	      "(setq svr \"0\")"
	      "(setq sval \"0\")"
	      "(mode_tile \"DIM\" 0)"
	      "(mode_tile \"Shtr\" 1)"
	      "(mode_tile \"Rzb\" 1)"
	      "(show_im (name))"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(close fldat)(done_dialog)")
    (action_tile "cancel" "(close fldat)(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 a1)
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* d mb) 2))
    (command "_ZOOM" "_C" inptG (* (* d mb) 2))
  ) ;_  if

  
;;;    
  (cond	((and (eq svr "1")
	      (eq sval "0")
	      (eq svtk "0")
	 ) ;_  and
	 (if (eq p2 "1")
	   (setq a1 (+ a1 pi))
	 ) ;_  if
	 (slot2 b l inptG a1 mb)
	)
	((and (eq svr "0")
	      (eq sval "1")
	      (eq svtk "0")
	 ) ;_  and
	 (sval2 d b tt1 dopb1 dopt rzb rdim inptG a1 mb shtrp)
	)
	((and (eq svr "0")
	      (eq sval "0")
	      (eq svtk "1")
	 ) ;_  and
	 (keyseat2 d b tt2 dopb2 dopt rdim inptG a1 mb)
	)
  ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  SHPNK
