
;;;      
;;;:  ..
;;; : 31.07.2000
;;;CAD-CEE 2000

(defun c:prkt (/ dvt shr shp shg ugr ugn ugrg ugng dvcl	lib dvd	svrd
	       svpd svgd ugrd uggrd uggnd ugnd name1 orx aby pr_fl glv1
	       glvm1 vsz1 vszm1	vsv1 sec1 rr x a aa aaa	b bb bbb dlnug
	       dvd1 dvd2 spr dlndt xc yc mash angl p1 p2 p3 dat1 fld
	       strd strdd anbl gst mb
	      )

  (setq	dvt   (findfile (strcat pathlisp2 "procat\\dvt_r.lsp"))
	shr   (findfile (strcat pathlisp2 "procat\\shv_r.lsp"))
	shp   (findfile (strcat pathlisp2 "procat\\shv_rp.lsp"))
	shg   (findfile (strcat pathlisp2 "procat\\shv_rg.lsp"))
	ugr   (findfile (strcat pathlisp2 "procat\\ug_rp.lsp"))
	ugn   (findfile (strcat pathlisp2 "procat\\ug_np.lsp"))
	ugrg  (findfile (strcat pathlisp2 "procat\\ug_rg.lsp"))
	ugng  (findfile (strcat pathlisp2 "procat\\ug_ng.lsp"))
	anbl  (findfile (strcat pathlisp2 "$anblk.lsp"))
	dat1  (findfile (strcat pathlisp2 "procat\\prcat.d"))
	dvcl  (findfile (strcat pathdcl2 "procat\\d_vtr.dcl"))
	lib   (findfile (strcat pathdat2 "procat\\procat.slb"))
	dvd   (findfile (strcat pathdat2 "procat\\dvtr.dat"))
	dvd1  (findfile (strcat pathdat2 "procat\\dvtr2.dat"))
	dvd2  (findfile (strcat pathdat2 "procat\\dvtp2.dat"))
	svrd  (findfile (strcat pathdat2 "procat\\svlr.dat"))
	svpd  (findfile (strcat pathdat2 "procat\\svlrp.dat"))
	svgd  (findfile (strcat pathdat2 "procat\\svlrg.dat"))
	ugrd  (findfile (strcat pathdat2 "procat\\ugrp.dat"))
	uggrd (findfile (strcat pathdat2 "procat\\ugrg.dat"))
	uggnd (findfile (strcat pathdat2 "procat\\ugng.dat"))
	ugnd  (findfile (strcat pathdat2 "procat\\ugnp.dat"))
  ) ;_ end of setq
  (load dvt)
  (load shr)
  (load shp)
  (load shg)
  (load ugr)
  (load ugn)
  (load ugrg)
  (load ugng)
  (load anbl)

  (setq gst '("   8239-72" 
              "   8240-72  ."
              "   8240-72  ."
              " .   8278-75."
              "   8509-72 ."
              "   8510-72 ."
              " .   19771-74 ."
              " .   19772-74 ."
              "   19425-74  ."
              " .   26020-83")
   )


;;;      PRCAT.D 
  (defun rdfl ()
    (setq fld	(open dat1 "r")
	  strd	(read-line fld)
	  strdd	(read strd)
	  p1	(itoa (nth 0 strdd))
	  p2	(itoa (nth 1 strdd))
	  angl	(rtos (nth 2 strdd))
	  mash	(rtos (nth 3 strdd))
    ) ;_  setq
    (close fld)
    
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  
    (set_tile "per1" p1)
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_ end of defun

;;;       PRCAT.D
  (defun wrfl ()
    (if	(eq p1 nil)
      (setq p1 "1")
    ) ;_  if
    (if	(eq p2 nil)
      (setq p2 "1")
    ) ;_  if

    (if	(eq mash nil)
      (setq mash "1")
    ) ;_  if

    (if	(eq angl nil)
      (setq angl "0")
    ) ;_  if

    (setq fld  (open dat1 "w")
	  strd (strcat "(" p1 " " p2 " " angl " " mash ")")
    ) ;_  setq
    (write-line strd fld)
    (close fld)
  ) ;_ end of defun


  (defun show_im2 (name1)
    (setq orx (dimx_tile "show_image1")
	  aby (dimy_tile "show_image1")
    ) ;_ end of setq
    (start_image "show_image1")
    (fill_image 0 0 orx aby 444)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_ end of defun


  (defun r10 ()
    (cond
      ((or (eq pr_fl "0")
	   (eq pr_fl "8")
	   (eq pr_fl "9")
       ) ;_  or
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 1)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 0)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "1")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 0)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "2")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 0)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "3")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 0)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "4")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 1)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "5")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 0)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 0)
	 (mode_tile "vsv" 1)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "6")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 1)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "7")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 0)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 0)
	 (mode_tile "vsv" 1)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
    ) ;_ end of cond
  ) ;_ end of defun

  (defun name ()
    (cond
      ((and (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq sec1 "0")
	    (or	(eq pr_fl "0")
		(eq pr_fl "8")
		(eq pr_fl "9")
		(eq pr_fl "1")
		(and (eq pr_fl "2") (eq vsz1 "0"))
		(and (eq pr_fl "3") (eq vsz1 "0"))
	    ) ;_ end of or
       ) ;_ end of and
       (setq name1
	      (strcat lib "(1)")
       ) ;_ end of setq
      )
      ((and (or	(eq pr_fl "0")
		(eq pr_fl "8")
		(eq pr_fl "9")
	    ) ;_  or
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(2)")
       ) ;_ end of setq
      )
      ((and (or	(eq pr_fl "0")
		(eq pr_fl "8")
		(eq pr_fl "9")
	    ) ;_  or
	    (eq glv1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(3)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "1") (eq pr_fl "2") (eq pr_fl "3"))
	    (eq glv1 "0")
	    (eq vsz1 "1")
	    (eq vsv1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(4)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "1") (eq pr_fl "2") (eq pr_fl "3"))
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(5)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "1")
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(6)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "2")
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(7)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "3")
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(8)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "4") (eq pr_fl "6"))
	    (eq glv1 "1")
	    (eq vsz1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(9)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "4") (eq pr_fl "6"))
	    (eq glv1 "0")
	    (eq vsz1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(10)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "4")
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(11)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "5") (eq pr_fl "7"))
	    (eq glv1 "1")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(12)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "5") (eq pr_fl "7"))
	    (eq glv1 "0")
	    (eq glvm1 "1")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(13)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "5") (eq pr_fl "7"))
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "1")
	    (eq vszm1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(14)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "5") (eq pr_fl "7"))
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(15)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "5")
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(16)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "6")
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(17)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "7")
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(18)")
       ) ;_ end of setq
      )
    ) ;_ end of cond
  ) ;_ end of defun

;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
   (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
   ) ;_  defun

;;;   -     
  (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
  );_  defun

  (defun show (/ dcl_id)
    (setq dcl_id
	   (load_dialog
	     dvcl
	   ) ;_ end of load_dialog
    )					; DCL-
    (if	(not (new_dialog "dvtr" dcl_id)) ; 
      (exit)
    )					;(,   )

    (defun sn_def ()
      (setq glv1 "0"
	    glvm1 "0"
	    vsz1 "0"
	    vszm1 "0"
	    vsv1 "0"
	    sec1 "1"
	    rr "0"
      ) ;_ end of setq
    ) ;_ end of defun

    (defun name_fil ()
      (cond
	((eq pr_fl "0") (setq fil dvd))
	((eq pr_fl "1") (setq fil svrd))
	((eq pr_fl "2") (setq fil svpd))
	((eq pr_fl "3") (setq fil svgd))
	((eq pr_fl "4") (setq fil ugrd))
	((eq pr_fl "5") (setq fil ugnd))
	((eq pr_fl "6") (setq fil uggrd))
	((eq pr_fl "7") (setq fil uggnd))
	((eq pr_fl "8") (setq fil dvd1))
	((eq pr_fl "9") (setq fil dvd2))
      ) ;_ end of cond
    ) ;_ end of defun


    (defun desk_f ()
      (setq x	(open (name_fil) "r")
	    a	(read-line x)
	    aa	(read a)
	    b	(read-line x)
	    bb	(read b)
	    aaa	(nth 0 bb)
	    bbb	(nth 9 bb)
      ) ;_ end of setq
    ) ;_ end of defun


    (defun g_r ()
      (start_list "prfl")
      (mapcar 'add_list gst)
      (end_list)
    ) ;_ end of defun
    
    (defun r_r ()
      (start_list "n")
      (mapcar 'add_list aa)
      (end_list)
    ) ;_ end of defun


    (defun chart ()
      (start_list "sprav")
      (mapcar 'add_list bbb)
      (end_list)
    ) ;_ end of defun



    (if	(action_tile "prfl" "")
      (progn
	(setq dlnug "0")
	(mode_tile "glv" 0)
	(mode_tile "glvm" 1)
	(mode_tile "vsz" 1)
	(mode_tile "vszm" 1)
	(mode_tile "vsv" 0)
	(mode_tile "sec" 0)
	(mode_tile "dln_dt" 1)
	(mode_tile "dl_ug" 1)
	(setq pr_fl "0")
        (g_r)
	(sn_def)
	(desk_f)
	(r_r)
	(chart)
	(show_im2 (name))
      ) ;_ end of progn
    ) ;_ end of if

    (defun se_sec ()
      (set_tile "sec" "1")
      (sn_def)
    ) ;_ end of defun


    (defun clos_x ()
      (close x)
      (desk_f)
    ) ;_ end of defun

    (defun whl ()
      (if (< (atof rr) (atof aaa))
	(clos_x)
      ) ;_ end of if
      (while (/= (atof rr) (atof aaa))
	(setq b	  (read-line x)
	      bb  (read b)
	      aaa (nth 0 bb)
	      bbb (nth 9 bb)
	) ;_ end of setq
      ) ;_ end of while
    ) ;_ end of defun

    (defun ukas	()
      (cond
	((and (or (eq glv1 "1")
		  (eq glvm1 "1")
		  (eq vsz1 "1")
		  (eq vszm1 "1")
		  (eq vsv1 "1")
	      ) ;_ end of or
	      (eq sec1 "0")
	      (eq dlnug "1")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 1) (mode_tile "ug_dt" 1))
	)
	((and (or (eq glv1 "1")
		  (eq glvm1 "1")
		  (eq vsz1 "1")
		  (eq vszm1 "1")
		  (eq vsv1 "1")
	      ) ;_ end of or
	      (eq sec1 "0")
	      (eq dlnug "0")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 0) (mode_tile "ug_dt" 0))
	)
	((and (or (eq glv1 "0")
		  (eq glvm1 "0")
		  (eq vsz1 "0")
		  (eq vszm1 "0")
		  (eq vsv1 "0")
	      ) ;_ end of or
	      (eq sec1 "1")
	      (eq dlnug "1")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 1) (mode_tile "ug_dt" 1))
	)
	((and (or (eq glv1 "0")
		  (eq glvm1 "0")
		  (eq vsz1 "0")
		  (eq vszm1 "0")
		  (eq vsv1 "0")
	      ) ;_ end of or
	      (eq sec1 "1")
	      (eq dlnug "0")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 1) (mode_tile "ug_dt" 0))
	)
      ) ;_ end of cond
    ) ;_ end of defun

    (defun hlp ()
      (set_tile "help" ": >>>")
    ) ;_ end of defun


    (action_tile
      "prfl"
      (strcat
	"(progn (setq pr_fl (get_tile \"prfl\"))" "(se_sec)" "(desk_f)"
	"(r_r)"	"(chart)" "(show_im2 (name)))" "(r10)" "(ukas)"
	"(mode_tile \"dl_ug\" 1)" "(hlp)"
       ) ;_  strcat
 ;_ end of strcat
    ) ;_ end of action_tile


    (action_tile
      "n"
      (strcat
	"(progn (setq rr (get_tile \"n\"))"
	"(whl)"
	"(chart))"
	"(hlp)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (defun sel_view ()
      (setq rr	  (get_tile "n")
	    vsv1  (get_tile "vsv")
	    glv1  (get_tile "glv")
	    glvm1 (get_tile "glvm")
	    vsz1  (get_tile "vsz")
	    vszm1 (get_tile "vszm")
	    sec1  (get_tile "sec")
      ) ;_ end of setq
    ) ;_ end of defun



    (action_tile
      "glv"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat 
    ) ;_ end of action_tile

    (action_tile
      "glvm"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "vsz"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "vszm"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "vsv"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "sec"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 1)"
      ) ;_ end of strcat
    ) ;_ end of action_tile


    (if	(action_tile "dln_dt" "")
      (setq dlndt "500")
    ) ;_ end of if

    (action_tile
      "dl_ug"
      (strcat
	"(setq dlnug (get_tile \"dl_ug\"))"
	"(ukas)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "dln_dt"
      "(setq dlndt (get_tile \"dln_dt\"))"
    ) ;_ end of action_tile

    (defun notes ()
      (cond
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
	      ) ;_ end of or
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" " 1 .. ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
	      ) ;_ end of or
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" " ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "3")
		      (eq pr_fl "8")
		      (eq pr_fl "9")
		  ) ;_ end of or
		  (eq spr "2")
	     ) ;_ end of and
	     (and (or (eq pr_fl "4") (eq pr_fl "6")) (eq spr "1"))
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((and (or (eq pr_fl "5") (eq pr_fl "7")) (eq spr "1"))
	 (set_tile "help" "  ")
	)
	((and (or (eq pr_fl "5") (eq pr_fl "7")) (eq spr "2"))
	 (set_tile "help" "  ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
	      ) ;_ end of or
	      (eq spr "3")
	 ) ;_ end of and
	 (set_tile "help" " ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "1")
	      ) ;_  or
	      (eq spr "4")
	 ) ;_  and
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "3") (eq pr_fl "7")) (eq spr "4"))
	     (and (eq pr_fl "6") (eq spr "3"))
	 ) ;_ end of or
	 (set_tile "help" "   < >")
	)
	((or (and (eq pr_fl "3") (eq spr "5"))
	     (and (eq pr_fl "6") (eq spr "4"))
	 ) ;_ end of or
	 (set_tile
	   "help"
	   "n = (b - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (eq pr_fl "7") (eq spr "5"))
	 (set_tile
	   "help"
	   "n1 = (B - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (eq pr_fl "7") (eq spr "6"))
	 (set_tile
	   "help"
	   "n2 = (b - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (eq pr_fl "3") (eq spr "6"))
	 (set_tile
	   "help"
	   "n1 = (h - 2(R + s)) / s -  .   s "
	 ) ;_ end of set_tile
	)
	((or (and (eq pr_fl "2") (eq spr "4"))
	     (and (or (eq pr_fl "4") (eq pr_fl "6")) (eq spr "2"))
	     (and (or (eq pr_fl "3") (eq pr_fl "5") (eq pr_fl "7"))
		  (eq spr "3")
	     ) ;_ end of and
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
	      ) ;_  or
	      (eq spr "5")
	 ) ;_ end of and
	 (set_tile "help" "    ")
	)
	((or (and (eq pr_fl "4") (eq spr "3"))
	     (and (eq pr_fl "5") (eq spr "4"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "8")
		      (eq pr_fl "9")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		  ) ;_  or
		  (eq spr "6")
	     ) ;_ end of and
	     (and (eq pr_fl "4") (eq spr "4"))
	     (and (eq pr_fl "5") (eq spr "5"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "3")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "9")
		  ) ;_ end of or
		  (eq spr "7")
	     ) ;_ end of and
	     (and (or (eq pr_fl "4") (eq pr_fl "6")) (eq spr "5"))
	     (and (eq pr_fl "5") (eq spr "6"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "3")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "9")
		  ) ;_ end of or
		  (eq spr "8")
	     ) ;_ end of and
	     (and (or (eq pr_fl "4") (eq pr_fl "6")) (eq spr "6"))
	     (and (eq pr_fl "5") (eq spr "7"))
	 ) ;_ end of or
	 (set_tile "help" "    -")
	)
	((or (and (eq pr_fl "4") (eq spr "8")) ;_ end of and 
	     (and (eq pr_fl "6") (eq spr "10")) ;_ end of and 
	     (and (eq pr_fl "7") (eq spr "16")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    o-o")
	)
	((or (and (eq pr_fl "4") (eq spr "9")) ;_ end of and 
	     (and (eq pr_fl "6") (eq spr "11")) ;_ end of and 
	     (and (eq pr_fl "7") (eq spr "17")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    o-o")
	)
	((or (and (eq pr_fl "4") (eq spr "10")) ;_ end of and 
	     (and (eq pr_fl "6") (eq spr "12")) ;_ end of and
	     (and (eq pr_fl "7") (eq spr "18")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    Yo-Yo")
	)
	((and (eq pr_fl "5") (eq spr "13")) ;_ end of and  
	 (set_tile "help" "    Y1-Y1(min)")
	)
	((and (eq pr_fl "5") (eq spr "15")) ;_ end of and  
	 (set_tile "help" "    U-U(min)")
	)
	((or (and (eq pr_fl "4") (eq spr "11")) ;_ end of and 
	     (and (eq pr_fl "6") (eq spr "13")) ;_ end of and  
	     (and (eq pr_fl "7") (eq spr "19")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    Yo-Yo")
	)
	((and (eq pr_fl "5") (eq spr "16")) ;_ end of and  
	 (set_tile "help" "    U-U(min)")
	)
	((and (eq pr_fl "5") (eq spr "17")) ;_ end of and  
	 (set_tile "help" "    U-U")
	)
	((and (eq pr_fl "7") (eq spr "20")) ;_ end of and  
	 (set_tile "help" "    Yo-Yo")
	)
	((or (and (or (eq pr_fl "4") (eq pr_fl "7")) (eq spr "12")) ;_ end of and
	     (and (eq pr_fl "5") (eq spr "11"))
	     (and (eq pr_fl "6") (eq spr "14")) ;_ end of and 
	 ) ;_end of or 
	 (set_tile "help" "    X1-X1")
	)
	((or (and (eq pr_fl "6") (eq spr "15")) ;_ end of and
	     (and (eq pr_fl "7") (eq spr "14")) ;_ end of and
	 ) ;_ end of or
	 (set_tile "help" "    Y1-Y1")
	)
	((or (and (eq pr_fl "4") (eq spr "13")) ;_ end of and
	     (and (eq pr_fl "5") (eq spr "12"))
	     (and (eq pr_fl "5") (eq spr "14"))
	     (and (eq pr_fl "6") (or (eq spr "16") (eq spr "17"))) ;_ end of and
	     (and (eq pr_fl "7") (or (eq spr "13") (eq spr "15")))
	 ) ;_end of or  
	 (set_tile "help"
		   "       "
	 ) ;_ end of set_tile
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
	      ) ;_ end of or
	      (eq spr "9")
	 ) ;_ end of and
	 (set_tile "help" "    -")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "3")
		      (eq pr_fl "8")
		      (eq pr_fl "9")
		  ) ;_ end of or
		  (eq spr "10")
	     ) ;_ end of and
	     (and (eq pr_fl "4") (eq spr "7"))
	     (and (eq pr_fl "7") (eq spr "9"))
	     (and (or (eq pr_fl "5") (eq pr_fl "6")) (eq spr "8"))
	 ) ;_ end of or
	 (set_tile "help" "    -")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
	      ) ;_ end of or
	      (eq spr "11")
	 ) ;_ end of and
	 (set_tile "help"
		   "     -"
	 ) ;_ end of set_tile
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "3")
		      (eq pr_fl "8")
		      (eq pr_fl "9")
		  ) ;_ end of or
		  (eq spr "12")
	     ) ;_ end of and 
	     (and (eq pr_fl "5") (eq spr "9"))
	     (and (eq pr_fl "6") (eq spr "7"))
	     (and (eq pr_fl "7") (eq spr "10"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
	      ) ;_ end of or
	      (eq spr "13")
	 ) ;_ end of and
	 (set_tile "help" "    Y-Y")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "3")
		      (eq pr_fl "8")
		      (eq pr_fl "9")
		  ) ;_ end of or
		  (eq spr "14")
	     ) ;_ end of and
	     (and (eq pr_fl "5") (eq spr "10"))
	     (and (eq pr_fl "6") (eq spr "9"))
	     (and (eq pr_fl "7") (eq spr "11"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((and (or (eq pr_fl "1") (eq pr_fl "2") (eq pr_fl "3"))
	      (eq spr "15")
	 ) ;_ end of and
	 (set_tile "help"
		   "   Y-Y    "
	 ) ;_ end of set_tile
	)
      ) ;_ end of cond
    ) ;_ end of defun

    (action_tile
      "sprav"
      (strcat
	"(setq spr (get_tile \"sprav\"))"
	"(notes)"
      ) ;_ end of strcat
    ) ;_ end of action_tile




    (action_tile			;  
      "accept"				;   


      (strcat "(progn (setq rr (get_tile \"n\"))"

	      "(done_dialog))"
	      "(close x)"
      ) ;_ end of strcat
    )					; , 
					;  
    (action_tile
      "cancel"
      (strcat "(progn (setq rr nil)"
	      "(done_dialog))"
	      "(close x) (exit)"
      ) ;_  strcat
    ) ;_ end of action_tile


    (start_dialog)			;  

;;;   
    (defun ins1	()
      (new_dialog "ins1" dcl_id)
           
      (rdfl)
      (setq mb (atof mash))

      (action_tile "xcor" "(setq xc $value)")
      (action_tile "ycor" "(setq yc $value)")

      (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))")
      (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

      (action_tile
	"per1"
	(strcat
	  "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
	  "(mode_tile \"ycor\" 0)) (progn (mode_tile \"xcor\" 1)"
	  "(mode_tile \"ycor\" 1) (setq xc nil yc nil) (set_tile \"xcor\" \"0\")"
	  "(set_tile \"ycor\" \"0\")))"
	) ;_  strcat
      ) ;_  action_tile
      (action_tile
	"per2"
	(strcat
	  "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
	  "(progn (mode_tile \"Angl\" 1) (setq angl nil) (set_tile \"Angl\" \"0\")))"
	) ;_  strcat
      ) ;_  action_tile
      (action_tile "per3" "(setq p3 $value)")

      (action_tile "accept" "(done_dialog)")
      (action_tile "cancel" "(exit)")

      (start_dialog)			;    

    ) ;_ end of defun
    (ins1)


    (unload_dialog dcl_id)		; DCL-
    (prin1)
  )					;   show 

  (show)
  (wrfl)
  (setvar "USERR1" mb); 
  (cond	((and (or (eq pr_fl "0") (eq pr_fl "8") (eq pr_fl "9"))
	      (/= rr nil)
	 ) ;_  and
	 (dv_t_r)
	)
	((and (eq pr_fl "1") (/= rr nil))
	 (sv_l_r)
	)
	((and (eq pr_fl "2") (/= rr nil))
	 (sv_l_rp)
	)
	((and (eq pr_fl "3") (/= rr nil))
	 (sv_l_rg)
	)
	((and (eq pr_fl "4") (/= rr nil))
	 (ug_rp)
	)
	((and (eq pr_fl "5") (/= rr nil))
	 (ug_np)
	)
	((and (eq pr_fl "6") (/= rr nil))
	 (ug_rg)
	)
	((and (eq pr_fl "7") (/= rr nil))
	 (ug_ng)
	)
  ) ;_ end of cond

  (prin1)

) ;_ end of defun



