 

;;; 
;;;:  ..
;;; : 06.10.2000
;;;CAD-CEE 2000

(defun sv_l_rp (/      cmd    blpm   apsz   osmd   cpt	  ept	 hsvp
		bsvp   hp1p   hp2p   hp3p   lp1p   rd1p	  rd2p	 
		sset   label  edat3  pt1    pt2	   pt3	  pt4	 pt5
		pt6    pt7    pt8    pt9    pt10   pt11   clay  cltp
		ccol   inpt0  a1     ept1
	       )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	hsvp (nth 1 bb)
	bsvp (nth 2 bb)
	hp1p (nth 3 bb)
	hp2p (nth 4 bb)
	hp3p (nth 5 bb)
	lp1p (nth 6 bb)
	rd1p (nth 7 bb)
	rd2p (nth 8 bb)
  ) ;_ end of setq


   ;;;     

  (if (eq p1 nil) (setq p1 "1"))
  (if (eq p2 nil) (setq p2 "1"))
  (if (eq p3 nil) (setq p3 "0"))
  
  (if (eq xc nil) (setq xc "0"))
  (if (eq yc nil) (setq yc "0"))
  

  (if (eq mash nil) (setq mash "1"))

  (if (and (eq p2 "0") (eq angl nil))
	 (setq angl "0")		
  )


  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  
  (initget 1)
  (if (eq p1 "1")
    (setq inpt0 (getpoint "\n  :"))
    (setq inpt0 (list (atof xc) (atof yc)))
  ) ;_  if
  (setq mb (atof mash))

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(setq cpt inpt0)
	(initget 1)
	(setq ept1 (polar cpt 0 (getdist cpt "\n  :")))
      ) ;_ end of progn
      (setq cpt	 inpt0
	    ept1 (polar cpt 0 (* (read dlndt) mb))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inpt0
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (atof angl))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if 
  

  (if (eq sec1 "0")
   (setq ept (polar cpt (+ 0 a1) (distance cpt ept1)))
 ) ;_  if
  

  (defun ris_shrp ()

;;;     


    (defun shv_gl_szp ()

      (setq pt3	(polar cpt (+ (/ pi 2) a1) (* hsvp mb))
	    pt4	(polar ept (+ (/ pi 2) a1) (* hsvp mb))
	    pt5	(polar cpt (+ (/ pi 2) a1) (* hp1p mb))
	    pt7	(polar cpt (+ (/ pi 2) a1) (* hp2p mb))
	    pt6	(polar ept (+ (/ pi 2) a1) (* hp1p mb))
	    pt8	(polar ept (+ (/ pi 2) a1) (* hp2p mb))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      
      (osn)
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (if (eq vsz1 "1")
        (ton)
        (osn)
      ) ;_ end of if
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")


    ) ;_ end of defun

;;;  

    (defun shv_v_svp ()

      (setq pt3	(polar cpt (+ (/ pi 2) a1) (* bsvp mb))
	    pt4	(polar ept (+ (/ pi 2) a1) (* bsvp mb))
	    pt5	(polar pt3 (+ (/ (* pi 3) 2) a1) (* hp3p mb))
	    pt6	(polar pt4 (+ (/ (* pi 3) 2) a1) (* hp3p mb))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      
      (osn)
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")

      
      (ton)
      (command "_line" pt5 pt6 "")

    )					;    shv_v_svp

;;; 

    (defun shv_scp ()

      (setq cpt inpt0)

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt1 (polar cpt (+ 0 a1) (* bsvp mb)))
      (setq pt11 (polar cpt (+ (/ pi 2) a1) (* hsvp mb)))
      (setq pt10 (polar pt11 (+ 0 a1) (* bsvp mb)))
      (setq pt2 (polar pt1 (+ (/ pi 2) a1) (* lp1p mb)))
      (setq pt9 (polar pt10 (+ (/ (* pi 3) 2) a1) (* lp1p mb)))
      (setq pt8	(polar pt9
		       (+ (/ (* pi 5) 4) a1)
		       (* (* rd1p (sqrt 2.0000)) mb)
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt3	(polar pt2
		       (+ (/ (* pi 3) 4) a1)
		       (* (* rd1p (sqrt 2.0000)) mb)
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt4
	     (polar pt3
		    (+ pi a1)
		    (* (- (- (- bsvp hp3p) rd1p) rd2p) mb)
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt7
	     (polar pt8
		    (+ pi a1)
		    (* (- (- (- bsvp hp3p) rd1p) rd2p) mb)
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt5	(polar pt4
		       (+ (/ (* pi 3) 4) a1)
		       (* (* rd2p (sqrt 2.0000)) mb)
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt6	(polar pt7
		       (+ (/ (* pi 5) 4) a1)
		       (* (* rd2p (sqrt 2.0000)) mb)
		) ;_ end of polar
      ) ;_ end of setq


      
      (osn)

      (command "_line" pt2 pt1 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))


      (command "_line" pt1 cpt pt11 pt10 pt9 "")
      (command "_arc" pt8 "_e" pt9 "_r" (* rd1p mb))
      (command "_arc" pt2 "_e" pt3 "_r" (* rd1p mb))
      (command "_line" pt8 pt7 "")
      (command "_line" pt3 pt4 "")
      (command "_arc" pt5 "_e" pt4 "_r" (* rd2p mb))
      (command "_arc" pt7 "_e" pt6 "_r" (* rd2p mb))
      (command "_line" pt5 pt6 "")

    )					;    shv_scp

    (cond ((or (= glv1 "1") (= vsz1 "1")) (shv_gl_szp))
	  ((= vsv1 "1") (shv_v_svp))
	  ((= sec1 "1") (shv_scp))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_end of defun RIS_SHRP

  (defun clip_bl ()
    
        
    (ris_shrp)
  
    (if	(eq p3 "0")
	(anblk sset cpt)
    ) ;_  if
  
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
  ) ;_ end of defun
  
  (clip_bl)
  (prin1)

)					;    SV_L_RP
