
;;;   ( )
;;;:  ..
;;; : 04.10.2000 
;;;CAD-CEE 2000
;;;----------------------------------------------------------------------------------
;;;
;;;   AutoCAD: rsd
;;;
;;;----------------------------------------------------------------------------------

(defun c:rsd(/ dvt1    dvt2    dvt3    dvt4    dvt5    rsdd    basd
	       bas1d   bas2d   bas3d   bas4d   bas5d   
	       bas8d   bas9d   bas10d  bas11d  bas12d  bas13d  bas14d
	       bas15d  bas16d  bas17d  bas18d  bas19d  bas20d  bas21d
	       bas22d  bas23d  bas24d  bas25d  bas26d  bas27d  bas37d
	       bas28d  bas29d  bas30d  bas31d  bas32d  bas33d  bas34d
	       bas35d  bas36d  dat1    fld     strd    strdd   orx
	       aby     name1   xc      yc      angl    mash    p1
	       p2      p3      blpr    shpr    vnpr    ltb1    ltb2
	       ltb1a   ltb2a   gost    fil     flg1    flg2    flg3
	       flg4    fls1    fls2    fls3    fls4    gstgl1  gstgl2
	       gstgl3  gstgl4  gstsh1  gstsh2  gstsh3  gstsh4  angl1
	       x       x1      a1      a2      a3      b0      b1
	       aa      a       b       rd      rl      pti     
	       sgb     hgb     dmt     dmt1    dl0     dln     dlnA
	       bbs1    bbs2    bbs3    bbs4    bbg1    bbg2    bbg3
	       bbg4    bb0     bb2     dcl_id  fsk     fsk1
	       sgb1    sgb2    sgb3    sgb4    hgb1    hgb2    hgb3
	       hgb4    strd1   strdd1  bb1     dln0    dln1a   j
	       inpt0   inpg1   inpg2   inpg3   inpg4   inps1   inps2
	       inps3   inps4   inptG   a1      mb      ept     pt1
	       pto1    pto2    sset    label   name_bl cmd     blpm
	       apsz    osmd    clay    cltp    ccol    i       no
	       bas38d  bas39d  bas40d  bas41d  bas42d  bas43d  obr
	       inpt1   vs      vctr    anbl    dvt     dln10   dln_dp
	       dmtZ    priz
	      )
  

  (setq	dvt1   (findfile (strcat pathlisp2 "rsd\\blts2.lsp"))
	dvt2   (findfile (strcat pathlisp2 "rsd\\vint2.lsp"))
	dvt3   (findfile (strcat pathlisp2 "rsd\\gks2.lsp"))
	dvt4   (findfile (strcat pathlisp2 "rsd\\shb2.lsp"))
	dvt5   (findfile (strcat pathlisp2 "rsd\\shpl2.lsp"))
	obr    (findfile (strcat pathlisp2 "$obrobj.lsp"))
	anbl   (findfile (strcat pathlisp2 "$anblk.lsp"))
	dat1   (findfile (strcat pathlisp2 "rsd\\rsd.d"))
	rsdd   (findfile (strcat pathdcl2 "rsd\\rsd.dcl"))
	basd   (findfile (strcat pathdat2 "blts\\b7805.dat"))
	bas1d  (findfile (strcat pathdat2 "blts\\b7808.dat"))
	bas2d  (findfile (strcat pathdat2 "blts\\b7798.dat"))
	bas3d  (findfile (strcat pathdat2 "blts\\b7796.dat"))
	bas36d (findfile (strcat pathdat2 "blts\\b262037.dat"))
	bas4d  (findfile (strcat pathdat2 "blts\\v1491.dat"))
	bas5d  (findfile (strcat pathdat2 "blts\\v17473.dat"))
	bas8d  (findfile (strcat pathdat2 "blts\\v11738.dat"))
	bas9d  (findfile (strcat pathdat2 "blts\\v1488.dat"))
	bas10d (findfile (strcat pathdat2 "blts\\g5915.dat"))
	bas11d (findfile (strcat pathdat2 "blts\\g5916.dat"))
	bas12d (findfile (strcat pathdat2 "blts\\g15521.dat"))
	bas13d (findfile (strcat pathdat2 "blts\\g15522.dat"))
	bas14d (findfile (strcat pathdat2 "blts\\g5927.dat"))
	bas15d (findfile (strcat pathdat2 "blts\\g5929.dat"))
	bas16d (findfile (strcat pathdat2 "blts\\g2524.dat"))
	bas17d (findfile (strcat pathdat2 "blts\\g2526.dat"))
	bas18d (findfile (strcat pathdat2 "blts\\g15524.dat"))
	bas19d (findfile (strcat pathdat2 "blts\\g5931.dat"))
	bas34d (findfile (strcat pathdat2 "blts\\g262038.dat"))
	bas35d (findfile (strcat pathdat2 "blts\\g262041.dat"))
	bas20d (findfile (strcat pathdat2 "blts\\s11371.dat"))
	bas21d (findfile (strcat pathdat2 "blts\\s6958.dat"))
	bas22d (findfile (strcat pathdat2 "blts\\s10450.dat"))
	bas23d (findfile (strcat pathdat2 "blts\\s6402n.dat"))
	bas24d (findfile (strcat pathdat2 "blts\\s6402l.dat"))
	bas25d (findfile (strcat pathdat2 "blts\\s6402t.dat"))
	bas26d (findfile (strcat pathdat2 "blts\\s6402ot.dat"))
	bas27d (findfile (strcat pathdat2 "blts\\s10906.dat"))
	bas37d (findfile (strcat pathdat2 "blts\\s262042.dat"))
	bas28d (findfile (strcat pathdat2 "blts\\sh2039d1.dat"))
	bas29d (findfile (strcat pathdat2 "blts\\sh2039d2.dat"))
	bas30d (findfile (strcat pathdat2 "blts\\sh2039d3.dat"))
	bas31d (findfile (strcat pathdat2 "blts\\sh2040.dat"))
	bas32d (findfile (strcat pathdat2 "blts\\sh2040pr.dat"))
	bas33d (findfile (strcat pathdat2 "blts\\sh2040p2.dat"))
	bas38d (findfile (strcat pathdat2 "blts\\sh22032.dat"))
	bas39d (findfile (strcat pathdat2 "blts\\sh22034.dat"))
	bas40d (findfile (strcat pathdat2 "blts\\sh22036.dat"))
	bas41d (findfile (strcat pathdat2 "blts\\sh22038.dat"))
	bas42d (findfile (strcat pathdat2 "blts\\sh22040.dat"))
	bas43d (findfile (strcat pathdat2 "blts\\sh22042.dat"))
  ) ;_  setq


  ;;;      RSD.D 
  (defun rdfl ()
     (setq fld (open dat1 "r")
	   strd1 (read-line fld)
	   strdd1 (read strd1)
	   gost (itoa (nth 0 strdd1))
	   rd (itoa (nth 1 strdd1))
	   rl (itoa (nth 2 strdd1))
	   gstgl1 (itoa (nth 3 strdd1))
	   hgb1 (nth 4 strdd1)
	   gstgl2 (itoa (nth 5 strdd1))
	   hgb2 (nth 6 strdd1)
	   gstgl3 (itoa (nth 7 strdd1))
	   hgb3 (nth 8 strdd1)
	   gstgl4 (itoa (nth 9 strdd1))
	   hgb4 (nth 10 strdd1)
	   gstsh1 (itoa (nth 11 strdd1))
	   sgb1 (nth 12 strdd1)
	   gstsh2 (itoa (nth 13 strdd1))
	   sgb2 (nth 14 strdd1)
	   gstsh3 (itoa (nth 15 strdd1))
	   sgb3 (nth 16 strdd1)
	   gstsh4 (itoa (nth 17 strdd1))
	   sgb4 (nth 18 strdd1)
	   shpr (itoa (nth 19 strdd1))
	   blpr (itoa (nth 20 strdd1))
	   vnpr (itoa (nth 21 strdd1))
	   strd (read-line fld)
	   strdd (read strd)	   
	   p1 (itoa (nth 0 strdd))
	   p2 (itoa (nth 1 strdd))
	   angl (rtos (nth 2 strdd))
	   mash (rtos (nth 3 strdd))	   
     )
    (close fld)
  ) ;_  defun
  

;;;            
  (defun s_t ()
    (set_tile "Blt" blpr)
    (set_tile "Shpl" shpr)
    (set_tile "Vnt" vnpr)   
    (set_tile "GOST" gost)
    (set_tile "Dmt" rd)
    (set_tile "Dln" rl)
    (set_tile "Gstgl1" gstgl1)
    (set_tile "Gstgl2" gstgl2)
    (set_tile "Gstgl3" gstgl3)
    (set_tile "Gstgl4" gstgl4)
    (set_tile "Gstsh1" gstsh1)
    (set_tile "Gstsh2" gstsh2)
    (set_tile "Gstsh3" gstsh3)
    (set_tile "Gstsh4" gstsh4)
    (set_tile "Dlop" (itoa (fix dl0)))
  ) ;_  defun

  
;;;          
  (defun s_t1()
    (set_tile "per1" p1)
    (if (eq p1 "0")
           (progn
	          (mode_tile "xcor" 0)
	          (mode_tile "ycor" 0)
	          (set_tile "xcor" xc)
	          (set_tile "ycor" yc)
	    )
     ) 
    
    (set_tile "per2" p2)
    (if (eq p2 "0")
          (mode_tile "Angl" 0)
    )
    
    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun  


  

;;;       RSD.D
  (defun wrfl ()
      (if (eq p1 nil) (setq p1 "1"))
      (if (eq p2 nil) (setq p2 "1"))

      (if (eq mash nil) (setq mash "1"))

      (if (eq angl nil) (setq angl "0"))

      (if (eq shpr nil) (setq shpr "0"))
      (if (eq blpr nil) (setq blpr "0"))
      (if (eq vnpr nil) (setq vnpr "0"))
    
      (setq fld (open dat1 "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" gost " " rd " " rl " " gstgl1 " " (rtos hgb1) " " gstgl2
			    " " (rtos hgb2) " " gstgl3 " " (rtos hgb3) " " gstgl4
			    " " (rtos hgb4) " " gstsh1 " " (rtos sgb1) " " gstsh2
			    " " (rtos sgb2) " " gstsh3 " " (rtos sgb3) " " gstsh4
			    " " (rtos sgb4) " " shpr " " blpr " " vnpr ")")
	)          
  )  ;_  defun
  

;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 444)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun

  
;;;    
  (defun name ()
    (cond
      ((eq blpr "1")
        (setq name1 (strcat pathdat2 "rsd\\rsd(1).slb"))
      )
      ((and (eq shpr "1") (or (eq gost "5") 
			      (eq gost "9")
			      (eq gost "10")))
        (setq name1 (strcat pathdat2 "rsd\\rsd(2).slb"))
      )
      ((and (eq shpr "1") (or
			      (eq gost "0")
			      (eq gost "1")
			      (eq gost "2")
			      (eq gost "3")
			      (eq gost "4")
			      (eq gost "6")
			      (eq gost "7")
			      (eq gost "8")
			      (eq gost "11")))
        (setq name1 (strcat pathdat2 "rsd\\rsd(3).slb"))
      )
      ((eq vnpr "1")
        (setq name1 (strcat pathdat2 "rsd\\rsd(4).slb"))
      )
    ) ;_  cond  
  ) ;_  defun


;;;  / 
  (defun vkr()
       (cond
	    ((eq blpr "1")
	          (shgb_l "Gstsh1" ltb2)
	          (shgb_l "Gstsh2" ltb2)
	          (shgb_l "Gstsh3" ltb2)
	          (shgb_l "Gstsh4" ltb2)
	          (shgb_l "Gstgl1" '())
	          (shgb_l "Gstgl2" '())
	          (shgb_l "Gstgl3" ltb1)
	          (shgb_l "Gstgl4" ltb1)
	          (mode_tile "Gstgl1" 1)
	          (mode_tile "Gstgl2" 1)
	          (mode_tile "Gstsh1" 0)
	          (mode_tile "Gstsh2" 0)
	          (mode_tile "Gstgl3" 0)
	          (mode_tile "Gstgl4" 0)
	          (mode_tile "Gstsh3" 0)
	          (mode_tile "Gstsh4" 0)
	    )
	    ((and (eq shpr "1")(or (eq gost "5")
				   (eq gost "9")
				   (eq gost "10")))
	          (shgb_l "Gstsh1" ltb2)
	          (shgb_l "Gstsh2" ltb2)
	          (shgb_l "Gstsh3" ltb2)
	          (shgb_l "Gstsh4" ltb2)
	          (shgb_l "Gstgl1" ltb1)
	          (shgb_l "Gstgl2" ltb1)
	          (shgb_l "Gstgl3" ltb1)
	          (shgb_l "Gstgl4" ltb1)
	          (mode_tile "Gstgl1" 0)
	          (mode_tile "Gstgl2" 0)
	          (mode_tile "Gstsh1" 0)
	          (mode_tile "Gstsh2" 0)
	          (mode_tile "Gstgl3" 0)
	          (mode_tile "Gstgl4" 0)
	          (mode_tile "Gstsh3" 0)
	          (mode_tile "Gstsh4" 0)
	    )
	    ((and (eq shpr "1")(or (eq gost "0")
				   (eq gost "1")
				   (eq gost "2")
				   (eq gost "3")
				   (eq gost "4")
				   (eq gost "6")
				   (eq gost "7")
				   (eq gost "8")
				   (eq gost "11")))
	          (shgb_l "Gstgl1" '())
	          (shgb_l "Gstgl2" '())
	          (shgb_l "Gstsh1" '())
	          (shgb_l "Gstsh2" '())
	          (shgb_l "Gstsh3" ltb2)
	          (shgb_l "Gstsh4" ltb2)
	          (shgb_l "Gstgl3" ltb1)
	          (shgb_l "Gstgl4" ltb1)
                  (mode_tile "Gstgl1" 1)
	          (mode_tile "Gstgl2" 1)
	          (mode_tile "Gstsh1" 1)
	          (mode_tile "Gstsh2" 1)
	          (mode_tile "Gstgl3" 0)
	          (mode_tile "Gstgl4" 0)
	          (mode_tile "Gstsh3" 0)
	          (mode_tile "Gstsh4" 0)
	    )
	    ((eq vnpr "1")
	          (shgb_l "Gstsh1" ltb2)
	          (shgb_l "Gstsh2" ltb2)
	          (shgb_l "Gstsh3" '())
	          (shgb_l "Gstsh4" '())
	          (shgb_l "Gstgl1" '())
	          (shgb_l "Gstgl2" '())
	          (shgb_l "Gstgl3" '())
	          (shgb_l "Gstgl4" '())
	          (mode_tile "Gstgl1" 1)
	          (mode_tile "Gstgl2" 1)
	          (mode_tile "Gstsh1" 0)
	          (mode_tile "Gstsh2" 0)
	          (mode_tile "Gstgl3" 1)
	          (mode_tile "Gstgl4" 1)
	          (mode_tile "Gstsh3" 1)
	          (mode_tile "Gstsh4" 1)
	    )
       ) ;_  cond   
  ) ;_  defun



;;;  
  (defun name_fil ()
    (cond
         ((and (eq shpr "1")(eq gost "0"))(setq fil bas38d))
	 ((and (eq shpr "1")(eq gost "1"))(setq fil bas39d))
	 ((and (eq shpr "1")(eq gost "2"))(setq fil bas40d))
	 ((and (eq shpr "1")(eq gost "3"))(setq fil bas41d))
	 ((and (eq shpr "1")(eq gost "4"))(setq fil bas42d))
	 ((and (eq shpr "1")(eq gost "5"))(setq fil bas43d))
         ((and (eq shpr "1")(eq gost "6"))(setq fil bas28d))
	 ((and (eq shpr "1")(eq gost "7"))(setq fil bas29d))
	 ((and (eq shpr "1")(eq gost "8"))(setq fil bas30d))
	 ((and (eq shpr "1")(eq gost "9"))(setq fil bas31d))
	 ((and (eq shpr "1")(eq gost "10"))(setq fil bas32d))
	 ((and (eq shpr "1")(eq gost "11"))(setq fil bas33d))
         ((and (eq blpr "1")(eq gost "0"))(setq fil bas2d))
	 ((and (eq blpr "1")(eq gost "1"))(setq fil bas3d))
	 ((and (eq blpr "1")(eq gost "2"))(setq fil basd))
	 ((and (eq blpr "1")(eq gost "3"))(setq fil bas1d))
	 ((and (eq blpr "1")(eq gost "4"))(setq fil bas36d))
	 ((and (eq vnpr "1")(eq gost "0"))(setq fil bas4d))
	 ((and (eq vnpr "1")(eq gost "1"))(setq fil bas5d))
	 ((and (eq vnpr "1")(eq gost "2"))(setq fil bas9d))
	 ((and (eq vnpr "1")(eq gost "3"))(setq fil bas8d))
    ) ;_  cond    
  ) ;_  defun

  (defun name_flg (gstgl)
    (cond
         ((eq gstgl "1")(setq fil bas10d))
         ((eq gstgl "2")(setq fil bas11d))
	 ((eq gstgl "3")(setq fil bas12d))
	 ((eq gstgl "4")(setq fil bas13d))
	 ((eq gstgl "5")(setq fil bas14d))
	 ((eq gstgl "6")(setq fil bas15d))
	 ((eq gstgl "7")(setq fil bas16d))
	 ((eq gstgl "8")(setq fil bas17d))
	 ((eq gstgl "9")(setq fil bas18d))
	 ((eq gstgl "10")(setq fil bas19d))
	 ((eq gstgl "11")(setq fil bas34d))
	 ((eq gstgl "12")(setq fil bas35d))
    ) ;_  cond    
  ) ;_  defun

  (defun name_fls (gstsh)
    (cond
         ((eq gstsh "1")(setq fil bas20d))
         ((eq gstsh "2")(setq fil bas21d))
	 ((eq gstsh "3")(setq fil bas22d))
	 ((eq gstsh "4")(setq fil bas23d))
	 ((eq gstsh "5")(setq fil bas24d))
	 ((eq gstsh "6")(setq fil bas25d))
	 ((eq gstsh "7")(setq fil bas26d))
	 ((eq gstsh "8")(setq fil bas27d))
	 ((eq gstsh "9")(setq fil bas37d))
    ) ;_  cond    
  ) ;_  defun


;;;       
   (defun fsk_us ()
      (if (eq shpr "1")
	    (nth 7 bb0)
	    (nth 10 bb0)
      )	
   ) ;_  defun


;;;    (    )
   (defun dln_pr ()
     (setq dln (nth 4 bb0))
     (if (eq shpr "1")
       (if (or (eq gost "0")
	       (eq gost "1")
	       (eq gost "2")
	       (eq gost "3")
	       (eq gost "4")
	       (eq gost "6")
	       (eq gost "7")
	       (eq gost "8")
	   ) ;_  or
	 (progn
	   (setq dln1a (nth 6 bb0)
		 dln  (+ dln dln1a)
	   ) ;_  setq
	 ) ;_  progn
       ) ;_  if
     ) ;_  if
     (setq dln dln)
   ) ;_  defun


;;;        
  (defun dln2_usl (/ dln2)
    (cond ((or (eq blpr "1")
	       (and (eq shpr "1")
		    (or	(eq gost "0")
			(eq gost "1")
			(eq gost "2")
			(eq gost "3")
			(eq gost "4")
			(eq gost "6")
			(eq gost "7")
			(eq gost "8")
			(eq gost "11")
		    ) ;_  or
	       ) ;_  and
	   ) ;_  or
	   (setq dln2 (+ dln0 dln10))
	  )
	  ((eq vnpr "1")
	   (setq dln2 dln)
	  )
	  ((and	(eq shpr "1")
		(or (eq gost "5")
		    (eq gost "9")
		    (eq gost "10")
		) ;_  or
	   ) ;_  and
	   (setq dln2 (* dln0 2))
	  )
    ) ;_  cond
    (setq dln2 dln2)
  ) ;_  defun



  
;;;      
   (defun desk_f ()
      (setq x	(open (name_fil) "r")
	    a	(read-line x)
	    aa	(read a)
	    a1	(nth 0 aa)
	    a2	(nth (1+ (atoi rd)) aa)
	    a3	(nth 0 a2)
	    b	(read-line x)
	    bb0	(read b)
	    b0	(nth 0 bb0)
	    b1	(nth 1 bb0)
	    dmt (nth 3 bb0)
	    dln (dln_pr)
	    dln0 (nth 5 bb0)
	    dln10 (nth 6 bb0)
	    fsk (fsk_us)
       ) ;_  setq 
    ) ;_  defun

;;;    
   (defun desk_f2 ()
      (setq a2	(nth (1+ (atoi rd)) aa)
	    a3	(nth 0 a2)
       ) ;_  setq 
    ) ;_  defun


;;;     
  (defun desk_sh (gstsh)
      (setq x1	(open (name_fls gstsh) "r")
	    a	(read-line x1)
	    b	(read-line x1)
	    bb1	(read b)
	    dmt1 (nth 8 bb1)
	    sgb  (nth 4 bb1)
      ) ;_  setq
  ) ;_  defun


;;;     
  (defun desk_g (gstgl)
      (setq x1	(open (name_flg gstgl) "r")
	    a	(read-line x1)
	    b	(read-line x1)
	    bb1	(read b)
	    dmt1 (nth 3 bb1)
	    hgb  (nth 8 bb1)
      ) ;_  setq  
  ) ;_  defun


  ;;;    
   (defun clos_x ()
      (close x)
      (desk_f)
    ) ;_  defun



;;;     ,, 
    (defun whl ()
      (setq bb2 bb0)
      (if (or (/= (atof rd) (atof b0))
	      (/= (atof rl) (atof b1))
	  ) ;_  or
	(clos_x)
      ) ;_  if 
      (while (or (/= (atof rd) (atof b0))
		 (/= (atof rl) (atof b1))
	     ) ;_  or
	     (setq b   (read-line x)
		   bb0 (read b)
		   b0  (nth 0 bb0)
		   b1  (nth 1 bb0)
		   dmt (nth 3 bb0)
		   dln (dln_pr)
		   dln0 (nth 5 bb0)
		   dln10 (nth 6 bb0)
		   fsk (fsk_us)
	     ) ;_  setq
      ) ;_  while
    ) ;_  defun

  
;;;    , , 
  (defun whl_l (/ dl01 dlnA1 dmtP)
    (setq dlnA1 dlnA)
    (setq dl01 dl0)
    (while (or (> dlnA1 dln)
	       (< dl01 (- dln (dln2_usl)))
	   ) ;_  or
      (setq b (read-line x))
      (if (or (eq b nil)
	      (eq b "")
	  ) ;_  or
	(progn
	  (attn)
	  (setq	bb0  bb2
		b0   (nth 0 bb0)
		b1   (nth 1 bb0)
		dln  (dln_pr)
		dln0 (nth 5 bb0)
		fsk  (fsk_us)
		rd   b0
		rl   b1
	  ) ;_  setq
	  (setq dlnA1 dln)
	  (setq dl01 (- dln (dln2_usl)))
	  (set_tile "Dmt" b0)
	  (set_tile "Dln" b1)
	) ;_  progn
	(progn
	  (setq	bb0  (read b)
		b0   (nth 0 bb0)
		b1   (nth 1 bb0)
		dmtP (nth 3 bb0)
	  ) ;_  setq
;;;	  (if (> dmtP dmt)
;;;	    (progn
;;;	      (if (= y 0)
;;;		(attn2)
;;;	      ) ;_  if
;;;	      (setq bb0	 bb2
;;;		    b0	 (nth 0 bb0)
;;;		    b1	 (nth 1 bb0)
;;;		    dln	 (dln_pr)
;;;		    dln0 (nth 5 bb0)
;;;		    fsk	 (fsk_us)
;;;		    rd	 b0
;;;		    rl	 b1
;;;	      ) ;_  setq
;;;	      (setq dlnA1 dln)
;;;	      (setq dl01 (- dln (dln2_usl)))
;;;	      (set_tile "Dmt" b0)
;;;	      (set_tile "Dln" b1)
;;;	    ) ;_  progn
	    (setq dmt  (nth 3 bb0)
		  dln  (dln_pr)
		  dln0 (nth 5 bb0)
		  fsk  (fsk_us)
		  rd   b0
		  rl   b1
	    ) ;_  setq
;;;	  ) ;_  if
	) ;_  progn
      ) ;_  if
    ) ;_  while
    (setq bb2 bb0
	  dmt (nth 3 bb0)
    ) ;_  setq
  ) ;_  defun


;;;    , ,  (. )
  (defun whl_l2 (/ dl01 dlnA1 dmtP)
    (setq dlnA1 dlnA)
    (setq dl01 dl0
	  dmtZ dmt)
    (while (or (> dlnA1 dln)
	       (< dl01 (- dln (dln2_usl)))
	   ) ;_  or
      (setq b (read-line x))
      (if (or (eq b nil)
	      (eq b "")
	  ) ;_  or
	(progn
	  (attn)
	  (setq	bb0  bb2
		b0   (nth 0 bb0)
		b1   (nth 1 bb0)
		dln  (dln_pr)
		dln0 (nth 5 bb0)
		fsk  (fsk_us)
		rd   b0
		rl   b1
	  ) ;_  setq
	  (setq dlnA1 dln)
	  (setq dl01 (- dln (dln2_usl)))
	  (set_tile "Dmt" b0)
	  (set_tile "Dln" b1)
	) ;_  progn
	(progn
	  (setq	bb0  (read b)
		b0   (nth 0 bb0)
		b1   (nth 1 bb0)
		dmtP (nth 3 bb0)
	  ) ;_  setq
	  (if (> dmtP dmtZ)
	    (progn
	      (if (= y 0)
		(attn2)
	      ) ;_  if
	      (setq bb0	 bb2
		    b0	 (nth 0 bb0)
		    b1	 (nth 1 bb0)
		    dln	 (dln_pr)
		    dln0 (nth 5 bb0)
		    fsk	 (fsk_us)
		    rd	 b0
		    rl	 b1
	      ) ;_  setq
	      (setq dlnA1 dln)
	      (setq dl01 (- dln (dln2_usl)))
	      (set_tile "Dmt" b0)
	      (set_tile "Dln" b1)
	    ) ;_  progn
	    (setq dmt  (nth 3 bb0)
		  dln  (dln_pr)
		  dln0 (nth 5 bb0)
		  fsk  (fsk_us)
		  rd   b0
		  rl   b1
	    ) ;_  setq
	  ) ;_  if
	) ;_  progn
      ) ;_  if
    ) ;_  while
    (setq bb2 bb0
	  dmt (nth 3 bb0)
    ) ;_  setq
  ) ;_  defun



;;;        
    (defun whl_d (k k1 pl gstgl / )
         (while (/= dmt dmt1)
	       (setq b (read-line x1))
	       (if (or (eq b nil)(eq b ""))
		       (progn
			      (attn)
		              (setq dmt1 dmt)
			      (setq hgb 0)
			      (set_tile pl "0")
			      (set gstgl "0")
		       )	 
	               (setq bb1  (read b)
	                     dmt1 (nth k bb1)
	        	     hgb (nth k1 bb1)
	               ) ;_  setq
	       );_  if     
         ) ;_  while
    ) ;_  defun


;;;   
  (defun spis(/ ltb)
      (cond
	((eq blpr "1")
	 (setq ltb '(
		     " 7798-70 .."
		     " 7796-70 ..  ."
		     " 7805-70 .."
		     " 7808-70 ..  ."
		     " 26-2037-77  .."
		    )
	 ) ;_  setq
	)
        ((eq shpr "1")
	  (setq ltb '(" 22032(33)-76  . d"
		     " 22034(35)-76  . 1,25d"
		     " 22036(37)-76  . 1,6d"
		     " 22038(39)-76  . 2d"
		     " 22040(41)-76  . 2,5d"
		     " 22042(43)-76  .  ." 
		     " 26-2039-77  . d"
		     " 26-2039-77  . 1,25d"
		     " 26-2039-77  . 2d"
		     " 26-2040-77  .  "
		     " 26-2040-77  .  "
		     " 26-2040-77  .  "		     
		    )
	  ) ;_  setq
	 )
	((eq vnpr "1")
	  (setq ltb '(" 1491-72  ."
		     " 17473-72  ."
		     " 1488-75  .  ."
		     " 11738-72  ."
		    )
	   ) ;_  setq
	 ) 
      ) ;_  cond
   ) ;_  defun

    
   (defun spis2()
	 (setq ltb1 '("<>"
		     " 5915-70.." 
		     " 5916-70..."
                     " 15521-70.. .. ."
		     " 15522-70... .. ."
		     " 5927-70.."
		     " 5929-70..." 
		     " 2524-70.. .. ."
		     " 2526-70... .. ."
		     " 15524-70..." 
		     " 5931-70.. ." 		     
		     " 26-2038-77..  .."
		     " 26-2041-77.  .."
		    )
	 ) ;_  setq

	 (setq ltb2 '("<>"
		     " 11371-78 "
		     " 6958-78 "
		     " 10450-78 "  	     
		     " 6402-70  "
		     " 6402-70  "
		     " 6402-70  "
		     " 6402-70   "
		     " 10906-78 "
		     " 26-2042-77  .."  
		    )
	 ) ;_  setq
    
    ) ;_  defun

  
;;;      
    (defun bsh_l ()
       (start_list "GOST")
       (mapcar 'add_list (spis))
       (end_list)
    ) ;_  defun

  
;;;       
    (defun shgb_l (strsh lst)
       (start_list strsh)
       (mapcar 'add_list lst)
       (end_list)      
    ) ;_  defun


;;;    
    (defun d_r ()
      (start_list "Dmt")
      (mapcar 'add_list a1)
      (end_list)
    ) ;_  defun

    (defun l_r ()
      (start_list "Dln")
      (mapcar 'add_list a3)
      (end_list)
    ) ;_  defun


;;;     
   (defun deflt ()
     (setq gstgl1 "0"
	   gstgl2 "0"
	   gstgl3 "0"
	   gstgl4 "0"
	   gstsh1 "0"
	   gstsh2 "0"
	   gstsh3 "0"
	   gstsh4 "0")
   ) ;_  defun

   (defun deflt_dl ()
      (setq rd "0"
	    rl "0")
   ) ;_  defun 
   

   (defun deflt_h ()
     (setq sgb1 0 sgb2 0 sgb3 0 sgb4 0
	   hgb1 0 hgb2 0 hgb3 0 hgb4 0 
     ) 
   ) ;_  defun  


;;;    ,,
(defun dl_f ()
  (setq dln_dp 0)
  (cond	((and (eq shpr "1")
	      (or (eq gost "0")
		  (eq gost "1")
		  (eq gost "2")
		  (eq gost "3")
		  (eq gost "4")
		  (eq gost "6")
		  (eq gost "7")
		  (eq gost "8")
		  (eq gost "11")
	      ) ;_  or
	 ) ;_  and
	 (setq fsk1 (* fsk 2))
	 (setq dln_dp dln10)
	)
	((eq blpr "1")
	 (setq fsk1 (* fsk 2))
	)
	((eq vnpr "1")
	 (setq fsk1 0)
	)
	((and (eq shpr "1")
	      (or (eq gost "5")
		  (eq gost "9")
		  (eq gost "10")
	      ) ;_  or
	 ) ;_  and
	 (setq fsk1 (* fsk 4))
	)
  ) ;_  cond
  (setq	dlnA (+
	       sgb1 sgb2 sgb3 sgb4 hgb1	hgb2 hgb3 hgb4 dl0 fsk1 dln_dp) ;_  +
  ) ;_  setq
) ;_  defun



;;;      ,,
   (defun usl_dl ( bd bl )
       (if (and (/= bd nil)(/= bl nil))
              (progn (set_tile "Dmt" bd)
                     (set_tile "Dln" bl)
	      )
       )	 	 
   ) ;_  defun


;;;     
  (defun schg_d (gstgl hg bg k k1 pl)
    (if	(/= (eval gstgl) "0")
      (progn
	(desk_g (eval gstgl))
	(whl_d k k1 pl gstgl)
	(set hg hgb)
	(set bg bb1)
	(dl_f)
	(whl_l2)	   
	(close x1)
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


  (defun schs_d (gstsh sg bg k k1 pl)
    (if	(/= (eval gstsh) "0")
      (progn
	(desk_sh (eval gstsh))
	(whl_d k k1 pl gstsh)
	(set sg hgb)
	(set bg bb1)
	(dl_f)
	(whl_l2)
	(close x1)
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

  
;;;      
  (defun pred (/ k)
    (if (eq shpr "1")
         (setq k 10)
         (setq k 9)
    )  
    (setq dmt (nth 3 bb0)
	  dvt (nth k bb0)
	  mb  (atof mash)
    ) ;_  setq
    (if	(< (* (/ (- dmt dvt) 2) mb) 0.6)
      (set_tile	"Pred"
		"!     "
      ) ;_  set_tile
      (set_tile	"Pred"
		""
      ) ;_  set_tile
    ) ;_  if
  ) ;_  defun




;;;      
  (defun pr_dl0 ()
    (if (or (> dlnA dln)
            (< dl0 (- dln (dln2_usl))))
          (progn
                (attn2)
	  )
          (progn
	        (done_dialog)
	        (wrfl)
	        (close x)
	  ) 
    ) ;_  if 
  ) ;_  defun


;;;      
  (defun pr_dl0_z ()
    (if	(or (> dlnA dln)
	    (< dl0 (- dln (dln2_usl)))
	) ;_  or
      (attn2)
    ) ;_  if 
  ) ;_  defun

    ;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
   (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn3)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
   ) ;_  defun


;;;   -  ,    
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -  ,       
   (defun attn2 ()
        (new_dialog "att2" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -     
  (defun attn3 ()
        (new_dialog "att3" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
  );_  defun
  

;;;   
 (defun	ins1 ()

   (setq xc    (rtos (car pti))
	 yc    (rtos (cadr pti))
	 inptG pti
   ) ;_  setq


   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "0")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   

   (if (eq p1 "0")
     (setq inptG (list (atof xc) (atof yc)))
   ) ;_  if


 ) ;_  defun


;;; ------------------------  ------------------------------
  (defun otr ()
    (initget 1) 
    (if	(eq p1 "1")
      (setq inptG
	     (getpoint "\n    :"
	     ) ;_  getpoint
      ) ;_  setq
      (setq inptG (list (atof xc) (atof yc)))
    ) ;_  if
    
    (if	(eq p2 "1")
      (progn
	(setq
	  a1 (getangle inptG
		       (strcat "\n   <" angl ">:")
	     ) ;_  getangle
	) ;_  setq
	(if (= a1 nil)
	  (setq a1 (atof angl))
	) ;_  if
      ) ;_  progn
      (progn
	(if (and (eq shpr "1")
		 (or (eq gost "0")
		     (eq gost "1")
		     (eq gost "2")
		     (eq gost "3")
		     (eq gost "4")
		     (eq gost "6")
		     (eq gost "7")
		     (eq gost "8")
		     (eq gost "11")
		 ) ;_  or
	    ) ;_  and
	   (setq a1 (* pi (/ (atof angl) 180)))
	   (setq a1 (* pi (/ (atof angl) 180)))
	) ;_  if
      ) ;_  progn
    ) ;_  if

    (setq mb (atof mash))

;;;        
    (setq inps2 (polar inptG a1 (* (- sgb2) mb)))
    (setq inps1 (polar inps2 a1 (* (- sgb1) mb)))
    (setq inpg1 (polar inps1 a1 (* (- hgb1) mb)))
    (setq inpg2 (polar inpg1 a1 (* (- hgb2) mb)))

    (if (and (eq shpr "1") (or (eq gost "0")
			       (eq gost "1")
			       (eq gost "2")
                               (eq gost "3")
			       (eq gost "4")
			       (eq gost "6")
               		       (eq gost "7")
		               (eq gost "8")
			       (eq gost "11")))
       (progn
	   (setq inps4 (polar inptG a1 (* (- sgb4) mb)))
    	   (setq inps3 (polar inps4 a1 (* (- sgb3) mb)))   	   
	   (setq inpg3 (polar inps3 a1 (* (- hgb3) mb)))
    	   (setq inpg4 (polar inpg3 a1 (* (- hgb4) mb)))
       )
       (progn
	   (setq inps4 (polar inptG a1 (* dl0 mb)))
           (setq inps3 (polar inps4 a1 (* sgb4 mb)))    	   
	   (setq inpg3 (polar inps3 a1 (* sgb3 mb)))
    	   (setq inpg4 (polar inpg3 a1 (* hgb3 mb)))
       )
    );_  if 

    (cond ((and	(eq shpr "1")
		(or (eq gost "5")
		    (eq gost "9")
		    (eq gost "10")
		) ;_  or
	   ) ;_  and
	    (setq inpt0
		   (polar inpg2
			  a1
			  (* (- (/ (- dln (- dlnA (* fsk 4))) 2.0)) mb)
		   ) ;_  polar
		  inpt1 (polar inpt0 a1 (* (/ dln 2) mb))
	    ) ;_  setq
	    (obrobj inpt0 (* dln mb) (* dmt mb) a1)
	  )
	  ((and	(eq shpr "1")
		(or (eq gost "0")
		    (eq gost "1")
		    (eq gost "2")
		    (eq gost "3")
		    (eq gost "4")
		    (eq gost "6")
		    (eq gost "7")
		    (eq gost "8")
		    (eq gost "11")
		) ;_  or
	   ) ;_  and
	    (setq inpt0	(polar inptG (+ a1 pi) (* (- (+ dl0 dln10)) mb))
		  inpt1 (polar inpt0 a1 (* (- (/ dln 2)) mb))
		  j	0
	    ) ;_  setq 
	    (obrobj inpt0 (* dln mb) (* dmt mb) (+ a1 pi))
	  )
	  ((or (eq blpr "1") (eq vnpr "1"))
	   (setq inpt0 inps1
		 inpt1 (polar inpt0 a1 (* (/ dln 2) mb))
	   ) ;_  setq
	   (obrobj inpt0 (* dln mb) (* dmt mb) a1)	   
	  )
    )					;  cond

    (if	(< vs (* dln mb))
      (command "_ZOOM" "_C" inpt1 (* dln mb))
      (command "_ZOOM" "_C" inpt1 "")
    ) ;_  if

    
;;;     
    (cond ((eq blpr "1")	       
	      (blts bb0 inpt0)
	  )
	  ((eq shpr "1")
	      (shpl bb0 inpt0 gost)
	  )
	  ((eq vnpr "1")
	      (vnts bb0 inpt0)
	  ) 
    );  cond

    (if (/= gstgl1 "0")
                  (gks bbg1 inpg1 dmt)
    ) ;_  if 

    (if (/= gstgl2 "0")
                  (gks bbg2 inpg2 dmt)
    );_  if  

    (if (/= gstgl3 "0") 
                  (gks bbg3 inpg3 dmt)
    );_  if

    (if (/= gstgl4 "0")
                  (gks bbg4 inpg4 dmt)
    );_  if  
    
    (if (/= gstsh1 "0")
                  (shb bbs1 inps1 dmt gstsh1)
    );_  if

    (if (/= gstsh2 "0")
                  (shb bbs2 inps2 dmt gstsh2)
    );_  if

    (if (/= gstsh3 "0")
                  (shb bbs3 inps3 dmt gstsh3)
    );_  if

    (if (/= gstsh4 "0")
                  (shb bbs4 inps4 dmt gstsh4)
    );_  if

    (cond ((= blpr "1")
	   (setq hgb (nth 8 bb0))
	   (setq pt1  (polar inpt0 (+ pi a1) (* hgb mb))
		 pto1 (polar pt1 (+ pi a1) (* 2.00 mb))
		 ept  (polar inpt0 (+ 0 a1) (* dln mb))
		 pto2 (polar ept (+ 0 a1) (* 2.00 mb))
	   ) ;_  setq
	  )
	  ((= shpr "1")
	    (if	j
	      (setq a1 (+ a1 pi))
	    ) ;_  if
	    (setq pto1 (polar inpt0 (+ pi a1) (* 2.00 mb))
		  ept  (polar inpt0 (+ 0 a1) (* dln mb))
		  pto2 (polar ept (+ 0 a1) (* 2.00 mb))
	    ) ;_  setq
	  )
	  ((= vnpr "1")
	   (if (eq gost "2")
	     (setq hgb1	(nth 14 bb0)
		   hgb	(nth 8 bb0)
		   pto1	(polar inpt0 (+ pi a1) (* (+ hgb hgb1 2.00) mb))
	     ) ;_  setq
	     (setq hgb	(nth 8 bb0)
	           pto1 (polar inpt0 (+ pi a1) (* (+ hgb 2.00) mb))
	     ) ;_  setq
	   ) ;_  if
	   (setq pto2 (polar inpt0 (+ 0 a1) (* (+ dln 2.00) mb)))
	  )
    ) ;_  cond

    (command "_layer" "_s" " " "")
    (command "_line" pto1 pto2 "")	;   
    

;;;        
    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_  while
    
   
  );_  defun

  
;;;  ------------------------------------ --------------------------------


;;;        
  (initget 1)
  (setq pti (getpoint "\n\n      :"))
  (initget 1)
  (setq dl0 (getdist pti "\n :"))  
  (rdfl)
  ;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (setq mb (getreal (strcat "\n  <" mash ">:")))
  (prin1)
  
  (if (not (eq mb nil))
    (setq mash (rtos mb))
    (setq mb (atof mash))
  ) ;_  if
  (setq dl0 (/ dl0 mb))
  

;;;       
  (load dvt1)
  (load dvt2)
  (load dvt3)
  (load dvt4)
  (load dvt5)
  (load obr)
  (load anbl)
  

;;;         
  
  (setq dcl_id (load_dialog rsdd)) ;_  load_dialog

                                         ; DCL-
  (if	(not (new_dialog "rezsoed" dcl_id)) ; 
      (exit)    
  )					;(,   )
  
      (setq y 0)
      (spis2)
      (vkr)
      (bsh_l)       
      (show_im (name))
      (desk_f)
      (d_r)
;;;      (l_r)
      (dl_f)
      (whl)
      (while (not priz)
	(whl_l)
	(setq y 1)
	(schg_d 'gstgl1 'hgb1 'bbg1 3 8 "Gstgl1")
	(schg_d 'gstgl2 'hgb2 'bbg2 3 8 "Gstgl2")
	(schg_d 'gstgl3 'hgb3 'bbg3 3 8 "Gstgl3")
	(schg_d 'gstgl4 'hgb4 'bbg4 3 8 "Gstgl4")
	(schs_d 'gstsh1 'sgb1 'bbs1 8 4 "Gstsh1")
	(schs_d 'gstsh2 'sgb2 'bbs2 8 4 "Gstsh2")
	(schs_d 'gstsh3 'sgb3 'bbs3 8 4 "Gstsh3")
	(schs_d 'gstsh4 'sgb4 'bbs4 8 4 "Gstsh4")
;;;	(if (or	(> dlnA dln)
;;;		(< dl0 (- dln (dln2_usl)))
;;;	    ) ;_  or
;;;	  (setq priz nil)
	  (setq priz t)
;;;	) ;_  if 
      ) ;_  while
      (desk_f2)
      (l_r)
      (s_t) 
      (setq y 0)
  
   
 
;;;       
    (action_tile "Blt" (strcat "(setq blpr $value)"
			       "(setq shpr \"0\" vnpr \"0\")"
			       "(setq gost \"0\")"
			       "(deflt)"
			       "(deflt_dl)"
			       "(deflt_h)"
			       "(vkr)"	       
			       "(bsh_l)"
			       "(show_im (name))"
			       "(close x)"
			       "(desk_f)"
			       "(d_r)"
;;;			       "(l_r)"
			       "(dl_f)"
			       "(setq bb2 bb0)"
			       "(whl_l)"
			       "(desk_f2)"
			       "(l_r)"
			       "(s_t)"
;;;			       "(usl_dl b0 b1)"
			     )
    )

    (action_tile "Shpl"(strcat "(setq shpr $value)"
			       "(setq blpr \"0\" vnpr \"0\")"
			       "(setq gost \"0\")"
			       "(deflt)"
			       "(deflt_dl)"
			       "(deflt_h)"
			       "(vkr)"
			       "(bsh_l)"
			       "(show_im (name))"
			       "(close x)"
			       "(desk_f)"
			       "(d_r)"
;;;			       "(l_r)"
			       "(dl_f)"
			       "(setq bb2 bb0)"
			       "(whl_l)"
			       "(desk_f2)"
			       "(l_r)"
			       "(s_t)"
;;;			       "(usl_dl b0 b1)"
			 )
    )

    (action_tile "Vnt" (strcat "(setq vnpr $value)"
			       "(setq shpr \"0\" blpr \"0\")"
			       "(setq gost \"0\")"
			       "(deflt)"
			       "(deflt_dl)"
			       "(deflt_h)"
			       "(vkr)"
			       "(bsh_l)"
			       "(show_im (name))"
			       "(close x)"
			       "(desk_f)"
			       "(d_r)"
;;;			       "(l_r)"
			       "(dl_f)"
			       "(setq bb2 bb0)"
			       "(whl_l)"
			       "(desk_f2)"
			       "(l_r)"
			       "(s_t)"
;;;			       "(usl_dl b0 b1)"
			 )
    )

    (action_tile "GOST" (strcat "(setq gost $value)"
				"(setq rd \"0\" rl \"0\")"
			        "(deflt)"
			        "(deflt_dl)"
			        "(deflt_h)"
				"(vkr)"
				"(show_im (name))"
				"(close x)"
				"(desk_f)"
				"(d_r)"
;;;			        "(l_r)"
				"(dl_f)"
				"(setq bb2 bb0)"
			        "(whl_l)"
				"(desk_f2)"
			        "(l_r)"
				"(s_t)"
;;;			        "(usl_dl b0 b1)"
			 )
    )

    (action_tile "Dmt" (strcat "(setq rd $value)"
			       "(setq rl \"0\")"
			       "(deflt)"
			       "(deflt_h)"
			       "(vkr)"		       
			       "(close x)"
			       "(desk_f)"	       
			       "(dl_f)"
			       "(whl)"
;;;			       "(l_r)"
			       "(whl_l)"
			       "(desk_f2)"
			       "(l_r)"
			       "(s_t)"
;;;			       "(usl_dl b0 b1)"
			)
    )  

    (action_tile "Dln" (strcat "(setq rl $value)"		       
			       "(whl)"
			       "(dl_f)"
			       "(whl_l2)"
			       "(s_t)"
;;;			       "(usl_dl b0 b1)"
		        )
    )  

    (action_tile "Gstgl1" (strcat "(setq gstgl1 $value)"
				  "(if (eq gstgl1 \"0\")"
				  "(progn (set_tile \"Gstgl2\" \"0\")"
				  "(setq gstgl2 \"0\")"
				  "(setq hgb1 0)"
				  "(setq hgb2 0)"
				  "(dl_f)"
				  "(whl_l))"
				  "(schg_d 'gstgl1 'hgb1 'bbg1 3 8 \"Gstgl1\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			  )
    )

    (action_tile "Gstgl2" (strcat "(setq gstgl2 $value)"
				  "(if (eq gstgl2 \"0\") (setq hgb2 0))"
				  "(if (eq gstgl1 \"0\")"
				  "(progn (set_tile \"Gstgl2\" \"0\")"
				  "(setq gstgl2 \"0\")"
				  "(setq hgb2 0)"
				  "(dl_f)"
				  "(whl_l))"
				  "(schg_d 'gstgl2 'hgb2 'bbg2 3 8 \"Gstgl2\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			  )
    )

    (action_tile "Gstgl3" (strcat "(setq gstgl3 $value)"
				  "(if (eq gstgl3 \"0\")"
				  "(progn (set_tile \"Gstgl4\" \"0\")"
				  "(setq gstgl4 \"0\")"
				  "(setq hgb3 0)"
				  "(setq hgb4 0)"
				  "(dl_f)"
				  "(whl_l))"
				  "(schg_d 'gstgl3 'hgb3 'bbg3 3 8 \"Gstgl3\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			  )
    )

    (action_tile "Gstgl4" (strcat "(setq gstgl4 $value)"
				  "(if (eq gstgl4 \"0\") (setq hgb4 0))"
				  "(if (eq gstgl3 \"0\")"
				  "(progn (set_tile \"Gstgl4\" \"0\")"
				  "(setq gstgl4 \"0\")"
				  "(setq hgb4 0)"
				  "(dl_f)"
				  "(whl_l))"
				  "(schg_d 'gstgl4 'hgb4 'bbg4 3 8 \"Gstgl4\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			  )
    )

    (action_tile "Gstsh1" (strcat "(setq gstsh1 $value)"
				  "(if (eq gstsh1 \"0\")"
				  "(progn (set_tile \"Gstsh2\" \"0\")"
				  "(setq gstsh2 \"0\")"
				  "(setq sgb1 0)"
				  "(setq sgb2 0)"
				  "(dl_f)"
				  "(whl_l))"
				  "(schs_d 'gstsh1 'sgb1 'bbs1 8 4 \"Gstsh1\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			  )
    )  

    (action_tile "Gstsh2" (strcat "(setq gstsh2 $value)"
				  "(if (eq gstsh2 \"0\") (setq sgb2 0))"
				  "(if (eq gstsh1 \"0\")"
				  "(progn (set_tile \"Gstsh2\" \"0\")"
				  "(setq gstsh2 \"0\")"
				  "(setq sgb2 0)"
				  "(dl_f)"
				  "(whl_l))"
				  "(schs_d 'gstsh2 'sgb2 'bbs2 8 4 \"Gstsh2\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			   )
    )

    (action_tile "Gstsh3" (strcat "(setq gstsh3 $value)"
				  "(if (eq gstsh3 \"0\")"
				  "(progn (set_tile \"Gstsh4\" \"0\")"
				  "(setq gstsh4 \"0\")"
				  "(setq sgb3 0)"
				  "(setq sgb4 0)"
				  "(dl_f)"
				  "(whl_l))"
				  "(schs_d 'gstsh3 'sgb3 'bbs3 8 4 \"Gstsh3\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			  )
    )

    (action_tile "Gstsh4" (strcat "(setq gstsh4 $value)"
				  "(if (eq gstsh4 \"0\") (setq sgb4 0))"
				  "(if (eq gstsh3 \"0\")"
				  "(progn (set_tile \"Gstsh4\" \"0\")"
				  "(setq gstsh4 \"0\")"
				  "(setq sgb4 0)"
				  "(dl_f)"
				  "(whl_l))"				  
				  "(schs_d 'gstsh4 'sgb4 'bbs4 8 4 \"Gstsh4\"))"
;;;				  "(pr_dl0_z)"
				  "(desk_f2)"
				  "(l_r)"
				  "(s_t)"
;;;				  "(usl_dl b0 b1)"
			  )
    )

    (action_tile "accept" "(pr_dl0)")

    (action_tile "cancel" (strcat "(done_dialog 0)"
				  "(close x)"
				  "(exit)")
    )

    (action_tile "Svdf" "(wrfl_os)")

    (start_dialog)

    (ins1)
    (setvar "USERR1" mb); 
  
    (unload_dialog dcl_id)
    (prin1)

    (setq cmd (getvar "cmdecho"))
    (setq blpm (getvar "blipmode"))
    (setq apsz (getvar "aperture"))
    (setq osmd (getvar "osmode"))
    (setq clay (getvar "clayer"))
    (setq cltp (getvar "celtype"))
    (setq ccol (getvar "cecolor"))
    (setq vs (getvar "viewsize"))
    (setq vctr (getvar "viewctr"))
    (setvar "cmdecho" 0)
    (setvar "blipmode" 0)
    (setvar "highlight" 0)
    (setvar "osmode" 0)
    (setvar "aperture" 1)

    (otr)
  	   
    (if	(eq p3 "0")
           (anblk sset inptG)
    ) ;_  if

    (command "_ZOOM" "_C" vctr vs)
    (setvar "highlight" 1)
    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
    (setvar "osmode" osmd)
    (setvar "clayer" clay)
  
  (prin1)
  
  ) ; _   