;;;      
;;;:  ..
;;; : 26.07.2001
;;;CAD-CEE 2000

(defun vris_rs (/ inptB_0 dl_b dl_mx pt_i inp cnell xb yb xc yc	ang1
		  ang2 ang3 a b pt2 vspm ddv y0 y
		 ) ;_  /




;;;       (inp)
  (defun fn_osn_pn (/ x1 y1)

;;;      
    (setq x1 (nth 0 inptB_0)
	  y1 (nth 1 inptB_0)
	  a  (+ (/ dvst 2.0) svst)
	  b  (+ (* dvst 0.25) svst)
    ) ;_  setq

    (if	(/= det 2)
      (progn
	(setq ang1 (angle inptB_0 pt_i)
	      inp  (polar inptB_0 ang1 (* dl_b mb))
	) ;_  setq
      ) ;_  progn
      (progn
	(if (/= dl_b 0.0)
	  (progn
	    (setq ang2 (angle pt_i pt_vn)
		  y0   (* (/ b a) (sqrt (- (expt a 2.0) (expt dl_b 2.0))))
		  y    (- b y0)
                  inp  (polar pt_i ang2 (* y mb))
		  a1   (angle inp pt_i) ;     ( )
            ) ;_  setq
	  ) ;_  progn
	  (progn
	    (setq inp (polar inptB_0 0.0 0.0)
		  a1  (angle pt_vn inp)	;     ( )
	    ) ;_  setq
	  ) ;_  progn
	) ;_  if
      ) ;_  progn
    ) ;_  if
    
  ) ;_  defun

;;;        
  (defun fn_ang3 (/ inp_z pt1 pt2 x1 y1 xs ls)
    
      (if (= dl_b 0.0)
	(setq x1 0.0)
	(setq x1 (+ dl_b 0.5))
      ) ;_  if

     (setq y1    (+ (/ (* a (- x1 dl_b) (sqrt (- (expt a 2.0) (expt dl_b 2.0))))
		       (* b dl_b)
		    ) ;_  /
		    y0
		 ) ;_  +
	   pt1	 (list x1 y1 0.0)
	   inp_z (list dl_b y0 0.0)
	   ang3	 (angle inp_z pt1)
	   xs	 (* y (/ (cos ang3) (sin ang3)))
	   pt1	 (polar pt_i ang1 (* xs mb))
	   a1    (angle inp pt1) ;      
     ) ;_  setq
    
  ) ;_  defun


;;;  ------------------------------- -------------------------
;;; ---------------------------  ----------------------
  (initget 1)
  (setq	inptB_0 (getpoint "\n  : "))

  (if (= (getvar "ORTHOMODE") 0)
    (progn
      (setq ddv 1)
      (setvar "ORTHOMODE" 1)
    ) ;_  progn
    (setq ddv 0)
  ) ;_  if

  (initget 1)
  (if (= det 2)
    (progn
      (setq dl_mx (- (/ dvst 2.0) (+ (* 0.1 dvst) (/ db 2.0))))
      (setq dl_b (getdist inptB_0
			  (strcat "\n    <"
				  (rtos dl_mx 2 2)
				  " max>:"
			  ) ;_  strcat
		 ) ;_  getdist
      ) ;_  setq
      (if (> dl_b dl_mx)
	   (progn
	    (setq dl_b dl_mx)
	    (princ "\n!!!    !!!")
	    (prin1)
	   )
      )	
    ) ;_  progn
    (setq dl_b (getdist inptB_0 "\n   :"))
  ) ;_  if
    
  (if (/= dl_b 0.0)
    (progn
      (initget 1)
      (setq pt_i (getpoint inptB_0 "\n  :"))
    ) ;_  progn
    (setq pt_i inptB_0)
  ) ;_  if


  (if (= det 2)
    (if	(/= dl_b 0.0)
      (progn
	(setq ang1 (angle inptB_0 pt_i)
	      pt_i (polar inptB_0 ang1 (* dl_b mb))
	) ;_  setq
	(initget 1)
	(setq pt_vn
	       (getpoint pt_i
			 "\n    :"
	       ) ;_  getpoint
	) ;_  setq
      ) ;_  progn
      (progn
	(initget 1)
	(setq pt_vn
	       (getpoint inptB_0
			 "\n    :"
	       ) ;_  getpoint
	) ;_  setq
      ) ;_  progn
    ) ;_  if
  ) ;_  if

  (if (= ddv 1)
      (setvar "ORTHOMODE" 0)
  ) ;_  if

;;;      inp
  (fn_osn_pn)

;;;       
  (if (and (= det 2) (= norm 1) (/= dl_b 0.0))
    (fn_ang3)
  ) ;_  if

;;;       dl_b=0
  (if (and (= det 2) (= dl_b 0.0))
    (setq ang1 a1)
  ) ;_  if


;;;       (, )
  (if (/= det 2)
    (if	(eq p2 "1")
      (progn
	(setq
	  a1 (getangle inp
		       (strcat "\n   <" angl ">:")
	     ) ;_  getangle
	) ;_  setq
	(if (= a1 nil)
	  (progn
	     (setq a1 (* pi (/ (atof angl) 180)))
	  )
	) ;_  if
      ) ;_  progn
      (progn
	(setq a1 (* pi (/ (atof angl) 180)))
;;;	(setq a1 (+ a1 ang1))
      ) ;_  progn
    ) ;_  if
  ) ;_  if
  (if (= a1 ang1)
    (setq ang1 (+ a1 (* (/ pi 2.0) 3.0)))
  ) ;_  if


;;;       
  (unnend2 det kat inp a1 mb dvst ang1 svst dl_b db s)
  
) ;_  VRIS_RS