;;;    
;;;:  ..
;;; : 19.09.2001
;;;CAD-CEE 2000
;;;: C:TBSHT

(defun c:tbsht (/ dlg	 dfl	orx    aby    name1  dcl_id vnln
		  dps	 pr	dps1   pl     inptG  cla    smin
		  smax	 shtr	raz    svmat  n1     n2     n3
		  n4     n5     n6     o1     o2     o3     o4
		  o5     o6     k1     k2     k3     k4     k5
		  k6     d1     d2     d3     d4     d5     d6
		  p1     p2     p3     p4     p5     p6     np
		  n      prd    nl     ol     kl     dl     pl
		  i      n      o      k      d      p      ip1
		  pt1    pt2    a1     a2     a3     a4     a5
		  a6     svmat0 a      k0     d0     p0     pt3
		  pal    o0     pa     attd
		 ) 

  (setq	dlg (findfile (strcat pathdcl2 "shtucer\\tbsht.dcl")))

;;;    
  (setq o0    ""
        k0    "1"
	d0    "50"
	p0    "10"
	prd   1
	o1    o0
	k1    k0
	d1    d0
	p1    p0
	a     0
  ) ;_  setq

;;;          
  (defun s_t ()
    (set_tile "O1" o0)
    (set_tile "K1" k0)
    (set_tile "D1" d0)
    (set_tile "P1" p0)
  ) ;_  defun

;;;      
;;;  : (dost vpl vpl1 pl1 pl2 a)
;;;  vpl -   ;
;;;  vpl1 -   ;
;;;  pl1 -    ( );
;;;  pl2 -    ( );
;;;  a -     .
  (defun dost (vpl vpl1 pl1 pl2 a)
    (if	(and (/= vpl "") (= a 1))
      (progn
	(mode_tile (strcat "O" pl2) 0)
	(mode_tile (strcat "N" pl2) 0)
	(mode_tile (strcat "K" pl2) 0)
	(mode_tile (strcat "D" pl2) 0)
	(mode_tile (strcat "P" pl2) 0)
;;;	(set_tile (strcat "O" pl2) o0)
	(set_tile (strcat "K" pl2) k0)
	(set_tile (strcat "D" pl2) d0)
	(set_tile (strcat "P" pl2) p0)
	(setq k k0 d d0 p p0)
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;       
;;;  : (fntxt str)
;;;    str -  
;;;    pa
  (defun fntxt (str / n j be sn b1)
;;;    (setq b1 (substr str 1 1))
;;;    (if	(or (eq b1 "1")
;;;	    (eq b1 "2")
;;;	    (eq b1 "3")
;;;	    (eq b1 "4")
;;;	    (eq b1 "5")
;;;	    (eq b1 "6")
;;;	    (eq b1 "7")
;;;	    (eq b1 "8")
;;;	    (eq b1 "9")
;;;	) ;_  or
;;;      (setq j  0
;;;	    n  (strlen str)
;;;	    sn (substr str 1 (- n 1))
;;;	    be (substr str n 1)
;;;	    pa (strcat sn "," be)
;;;      ) ;_  setq
;;;      (setq pa str)
;;;    ) ;_  if
    
;;;       
     (setq n (strlen str)
	   j 1
     ) ;_   setq
    
;;;     
     (if (/= n j)
       (progn
	 (while	(<= j n)
	   (setq b1 (substr str j 1))
	   (if (or (= b1 ",") (= b1 "."))
	     (cond
	       ((= j 2)
		(setq pa (strcat "0," (substr str 1 1) (substr str 3))
		      j	 (+ n 1)
		) ;_   setq
	       )
	       (t
		(setq pa (strcat (substr str 1 (- j 2))
				 ","
				 (substr str (- j 1) 1)
				 (substr str (+ j 1))
			 ) ;_   strcat
		      j	 (+ n 1)
		) ;_   setq
	       )
	     ) ;_   cond
	     (progn
	       (setq j (1+ j))
	       (if (= j n)
		 (setq pa (strcat (substr str 1 (- j 1)) ",0")
		       j  (+ n 1)
		 ) ;_   setq
	       ) ;_   if
	     ) ;_   progn
	   ) ;_   if
	 ) ;_   while
       ) ;_   progn
       (setq pa (strcat "0," str))
     ) ;_   if
  ) ;_  defun


;;;       
  (defun spis ()
    (setq ol  (list o1 o2 o3 o4 o5 o6)
	  nl  (list n1 n2 n3 n4 n5 n6)
	  kl  (list k1 k2 k3 k4 k5 k6)
	  dl  (list d1 d2 d3 d4 d5 d6)
	  pl  (list p1 p2 p3 p4 p5 p6)
    ) ;_  setq
  ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "tbsht" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (setq prd 0)
    (s_t)


;;;     
    (action_tile
      "O1"
      (strcat "(setq o1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N1"
      (strcat "(setq n1 $value)"
	      "(if (/= n1 \"\") (setq a1 (1+ a1)))"
	      "(dost n1 o1 \"1\" \"2\" a1)"
	      "(if (and (= a1 1) (/= n1 \"\")) (setq k1 k d1 d p1 p))"
	      "(if (= o1 nil) (setq o1 o0))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "K1"
      (strcat "(setq k1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D1"
      (strcat "(setq d1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "P1"
      (strcat "(setq p1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O2"
      (strcat "(setq o2 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N2"
      (strcat "(setq n2 $value)"
	      "(if (/= n2 \"\") (setq a2 (1+ a2)))"
	      "(dost n2 o2 \"2\" \"3\" a2)"
	      "(if (and (= a2 1) (/= n2 \"\")) (setq k2 k d2 d p2 p))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "K2"
      (strcat "(setq k2 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D2"
      (strcat "(setq d2 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "P2"
      (strcat "(setq p2 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O3"
      (strcat "(setq o3 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N3"
      (strcat "(setq n3 $value)"
	      "(if (/= n3 \"\") (setq a3 (1+ a3)))"
	      "(dost n3 o3 \"3\" \"4\" a3)"
	      "(if (and (= a3 1) (/= n3 \"\")) (setq k3 k d3 d p3 p))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "K3"
      (strcat "(setq k3 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D3"
      (strcat "(setq d3 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "P3"
      (strcat "(setq p3 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O4"
      (strcat "(setq o4 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N4"
      (strcat "(setq n4 $value)"
	      "(if (/= n4 \"\") (setq a4 (1+ a4)))"
	      "(dost n4 o4 \"4\" \"5\" a4)"
	      "(if (and (= a4 1) (/= n4 \"\")) (setq k4 k d4 d p4 p))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "K4"
      (strcat "(setq k4 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D4"
      (strcat "(setq d4 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "P4"
      (strcat "(setq p4 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O5"
      (strcat "(setq o5 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N5"
      (strcat "(setq n5 $value)"
	      "(if (/= n5 \"\") (setq a5 (1+ a5)))"
	      "(dost n5 o5 \"5\" \"6\" a5)"
	      "(if (and (= a5 1) (/= n5 \"\")) (setq k5 k d5 d p5 p))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "K5"
      (strcat "(setq k5 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D5"
      (strcat "(setq d5 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "P5"
      (strcat "(setq p5 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O6"
      (strcat "(setq o6 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N6"
      (strcat "(setq n6 $value)"
	      "(if (/= n6 \"\") (setq a6 (1+ a6)))"
	      "(if (/= n6 \"\") (mode_tile \"Prd\" 0))"
	      "(dost n6 o6 \"6\" \"7\" a6)"
	      "(if (and (= a6 1) (/= n6 \"\")) (setq k6 k d6 d p6 p))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "K6"
      (strcat "(setq k6 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D6"
      (strcat "(setq d6 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "P6"
      (strcat "(setq p6 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    


    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Prd" "(setq prd 1)(done_dialog)")
    
    (start_dialog)
    
    (unload_dialog dcl_id)
    (prin1)

  ) ;_  defun

;;; ---------------------------------- --------------------------------
  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq attd (getvar "attdia"))
  (setvar "cmdecho" 0)
  (setvar "attdia" 0)
  (setvar "blipmode" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)

  
;;;   
(while (= prd 1)
  (setq i 0)
  (setq	nl nil n1 nil n2 nil n3 nil n4 nil n5 nil n6 nil) 
  (setq a1 0 a2 0 a3 0 a4 0 a5 0 a6 0)
  
  (show)
  (spis)
;;;     
  (if (and (/= (nth 0 nl) nil) (= a 0))
    (progn
      (initget 1)
      (setq inptG
	     (getpoint "\n  :")
      ) ;_  setq
;;;      
      (command "_INSERT" (strcat pathblock2 "tab_pnz") inptG "1.0" "1.0" "0.0") 
      (setq inptG (polar inptG (- 0.0 (/ pi 2.0)) 33.0)) 
    ) ;_  progn
  ) ;_  if

;;;        
  (while (/= (nth i nl) nil)
    (setq n  (nth i nl)
	  o  (nth i ol)
	  k  (nth i kl)
	  d  (nth i dl)
	  p  (nth i pl)
    ) ;_  setq
    (fntxt p)
    (if (= o nil) (setq o ""))
    (command "_INSERT" (strcat pathblock2 "tab_pns") inptG "1.0" "1.0" "0.0" o n k d p pa) 
    (setq inptG	(polar inptG (- 0.0 (/ pi 2.0)) 8.0)) 
    (setq i (1+ i)) 
  ) ;_  while

;;;   
  (setq	a  (1+ a)
	o0 o
	k0 k
	d0 d
	p0 p
  ) ;_  setq
  (setq ol nil o1 nil o2 nil o3 nil o4 nil o5 nil o6 nil
	kl nil k1 nil k2 nil k3 nil k4 nil k5 nil k6 nil
	dl nil d1 nil d2 nil d3 nil d4 nil d5 nil d6 nil
	pl nil p1 nil p2 nil p3 nil p4 nil p5 nil p6 nil
  ) ;_  setq
) ;_  while
  
  (initget 1)
  (setq i (getint "\n\n     (0 -  ):"))
  (if (or (= i nil) (= i 0))
    (setq i 0)
  ) ;_  if
  
  (while (/= i 0)
    (command "_INSERT" (strcat pathblock2 "tab_pns") inptG "1.0" "1.0" "0.0" " " " " " " " " " " " ") 
    (setq inptG	(polar inptG (- 0.0 (/ pi 2.0)) 8.0)) 
    (setq i (1- i)) 
  ) ;_  while

  
  (setvar "cmdecho" cmd)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setvar "attdia" attd)
  (prin1)
 
) ;_  TBSHT
