;;;   
;;;:  ..
;;; : 30.08.2001
;;;CAD-CEE 2000
;;;: C:CAPFA

(defun c:capfa (/ tipf  db    d     d1  notv	 h     h2    b
		   l	 s1     sech  sprd  name1 orx   aby   dlg
		   dfl	 lsp1  lsp2  lsp3  lsp4	 lsp5  fld   strd
		   strdd strd1 strdd1	   p1	 p2    p3    angl
		   mash	 name1 spis  pti   inptG xc    yc    dcl_id
		   inptG a1    mb    cmd   blpm	 apsz  osmd  clay
		   cltp	 ccol  vs    vctr  pv	 anbl  sset  label
		   sech2 sbk   py    gr	   pyf	 grf   stf   fldat
		   dfl2	 as    ass   bs	   bss	 bss1  bss2  fldat2
		   as2	 ass2  dtb   stb   shtrp spism mtr   hpa
		   hpn	 st    ang1  dy1   dy1f  dor   tt    dat1
		   dat2  dat3  dat4  dt    dop   ass1  ass2  nsum
		   lstn  dy1z  dyz   dz    dtz   lstn1 fldat3 h1
		   r     r1    an    l1    h1min lt    r0    n0
	           grz   pdl   s2    l2    b     b1    b2    r2
	           l0    b0    inptG1 nl0  nlf   s3    d3    d2
		   d1
		  ) 

  (setq	dlg  (findfile (strcat pathdcl2 "strop\\capfa.dcl"))
	dfl  (findfile (strcat pathlisp2 "strop\\capfa.d"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	lsp1 (findfile (strcat pathlisp2 "strop\\capfotr.lsp"))
	dat1 (findfile (strcat pathdat2 "strop\\capfa.dat"))
  ) ;_  setq

  (load anbl)
  (load lsp1)

  
;;;   
  (setq	spis '(" 1"
	       " 2"
	      )
  ) ;_  setq

;;;    
  (setq grf '("1.0" "2.0" "4.0" "8.0" "16.0" "25.0" "32.0"))

;;;    
  (setq nlf '("1" "2" "3" "4"))

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun

;;;      CAPFA.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   gr	  (itoa (nth 1 strdd1))
	   pdl    (itoa (nth 2 strdd1))
	   r0     (nth 3 strdd1)
	   nl0    (itoa (nth 4 strdd1))
	   sech	  (itoa (nth 5 strdd1))
	   sprd	  (itoa (nth 6 strdd1))
	   sbk	  (itoa (nth 7 strdd1))
	   shtrp  (itoa (nth 8 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "Gr" gr)
;;;    (set_tile "Podk" pdl)
    (set_tile "D1" (rtos d1))
    (set_tile "S1" (rtos s1))
    (set_tile "H" (rtos (+ l s3)))
    (set_tile "D2" (rtos d2))
    (set_tile "S2" (rtos s2))
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Shtr" shtrp)
    (if	(eq tipf "0")
      (progn (mode_tile "R" 0)
	     (mode_tile "N" 0)
	     (set_tile "R" (rtos r0))
	     (set_tile "N" nl0)
      ) ;_  progn
      (progn (mode_tile "R" 1)
	     (mode_tile "N" 1)
      ) ;_  progn
    ) ;_  if
    (if	(eq pdl "0")
      (progn (set_tile "D2" "0")
	     (set_tile "S2" "0")
	     (mode_tile "Shtr" 1)
      ) ;_  progn
      (if (= sech "1")
	(mode_tile "Shtr" 0)
      ) ;_  if
    ) ;_  if
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       CAPFA.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " gr " " pdl " " (rtos r0) " "
			     nl0 " " sech " " sprd " " sbk " " shtrp ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	      (= n0 1)
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(1).slb"))
	)
	((and
	   (eq tipf "0")
	   (eq sech "1")
	   (eq sprd "0")
	   (eq sbk "0")
	   (> n0 1)
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(7).slb"))
	)
	((and
	   (eq tipf "0")
	   (eq sech "0")
	   (eq sprd "1")
	   (eq sbk "0")
	   
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(3).slb"))
	)
	((and
	   (eq tipf "0")
	   (eq sech "0")
	   (eq sprd "0")
	   (eq sbk "1")
	   (= n0 1)
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(5).slb"))
	)
	((and
	   (eq tipf "0")
	   (eq sech "0")
	   (eq sprd "0")
	   (eq sbk "1")
	   (> n0 1)
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(8).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(2).slb"))
	)
	((and
	   (eq tipf "1")
	   (eq sech "0")
	   (eq sprd "1")
	   (eq sbk "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(4).slb"))
	)
	((and
	   (eq tipf "1")
	   (eq sech "0")
	   (eq sprd "0")
	   (eq sbk "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "strop\\capfa(6).slb"))
	)
  ) ;_  cond
) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;      
(defun desk_f ()
  (setq	fldat (open dat1 "r")
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	d1    (nth 1 bss)
	d2    (nth 2 bss)
	s1    (nth 3 bss)
	s2    (nth 4 bss)
	l     (nth 5 bss)
	d3    (nth 6 bss)
	s3    (nth 7 bss)
  ) ;_  setq
) ;_  defun


;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun

;;;      
(defun whl ()
  (if (/= grz bss1)
    (clos_dfl2)
  ) ;_  if 
  (while (/= grz bss1)
    (setq bs   (read-line fldat)
	  bss  (read bs)
	  bss1 (nth 0 bss)
	  d1   (nth 1 bss)
	  d2   (nth 2 bss)
	  s1   (nth 3 bss)
	  s2   (nth 4 bss)
	  l    (nth 5 bss)
	  d3   (nth 6 bss)
	  s3   (nth 7 bss)
    ) ;_  setq
  ) ;_  while
) ;_  defun


;;;    
    (defun spis_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun


;;;   
    (defun grf_l ()
      (start_list "Gr")
      (mapcar 'add_list grf)
      (end_list)
    ) ;_  defun

;;;    
    (defun nlf_l ()
      (start_list "N")
      (mapcar 'add_list nlf)
      (end_list)
    ) ;_  defun


  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STRING)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun



;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s2 mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun



;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "capfa" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (setq pdl "1") ;
    (spis_l)
    (grf_l)
    (nlf_l)
;;;          
    (setq grz (atof (nth (atoi gr) grf))
	  n0 (atoi (nth (atoi nl0) nlf))
    ) ;_  setq
    (show_im (name))
    (desk_f)
    (whl)
    (s_t)

    (if	(eq sech "1")
      (mode_tile "Shtr" 0)
    ) ;_  if
    
    (mode_tile "Tipf" 2)

;;;     
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Gr"
      (strcat "(setq gr $value)"
	      "(setq grz  (atof (nth (atoi gr) grf)))"
	      "(desk_f)"
              "(whl)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Podk"
      (strcat "(setq pdl $value)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
   (action_tile
      "R"
      (strcat "(prv_p $value 'r0 \"R\" \"r\")"
	      "(prov 100 r0 2000 \"R\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N"
      (strcat "(setq nl0 $value)"
	      "(setq n0  (atoi (nth (atoi nl0) nlf)))"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 0)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(mode_tile \"Shtr\" 1)"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (and (or (eq sech "1")(eq sbk "1")) (> n0 1) (eq tipf "0"))
    (if	(eq p1 "1")
      (setq inptG1
	     (getpoint "\n   :")
      ) ;_  setq
      (setq inptG1 (list (atof xc) (atof yc))
      ) ;_  setq
    ) ;_  if
    (if	(eq p1 "1")
      (setq inptG
	     (getpoint "\n   :")
      ) ;_  setq
      (setq inptG (list (atof xc) (atof yc)))
    ) ;_  if
  ) ;_  if
  
  (if (and (or (eq sech "1")(eq sbk "1")) (> n0 1) (eq tipf "0"))
    (if	(eq p2 "1")
      (progn
	(setq
	  a1 (getangle inptG1
		       (strcat "\n   <" angl ">:")
	     ) ;_  getangle
	) ;_  setq
	(if (= a1 nil)
	  (setq	a1    (* pi (/ (atof angl) 180))
		inptG (polar inptG1 (+ a1 (/ pi 2.0)) (* r0 mb))
	  ) ;_  setq
	  (setq	a1    (- a1 (/ pi 2.0))
		inptG (polar inptG1 (+ a1 (/ pi 2.0)) (* r0 mb))
	  ) ;_  setq
	) ;_  if
      ) ;_  progn
      (setq a1	  (* pi (/ (atof angl) 180))
	    inptG (polar inptG1 (+ a1 (/ pi 2.0)) (* r0 mb))
      ) ;_  setq
    ) ;_  if
    (if	(eq p2 "1")
      (progn
	(setq
	  a1 (getangle inptG
		       (strcat "\n   <" angl ">:")
	     ) ;_  getangle
	) ;_  setq
	(if (= a1 nil)
	  (setq a1 (* pi (/ (atof angl) 180)))
	  (setq a1 (- a1 (/ pi 2.0)))
	) ;_  if
      ) ;_  progn
      (setq a1 (* pi (/ (atof angl) 180)))
    ) ;_  if
  ) ;_  if


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* d2 mb) 2))
    (command "_ZOOM" "_C" inptG (* (* d2 mb) 2))
  ) ;_  if

  
;;;    
   (cond ((and (eq tipf "0")
	       (eq sech "1")
	       (eq sprd "0")
	       (eq sbk "0")
	  ) ;_  and
	  (capfotr r0 n0 d1 d2 s1 s2 l d3 s3 inptG a1 mb 1 1 pdl shtrp)
	 )
	 ((and
	    (eq tipf "0")
	    (eq sech "0")
	    (eq sprd "1")
	    (eq sbk "0")
	  ) ;_  and
	  (capfotr2 r0 d2 d3 s2 inptG a1 mb 1 pdl)
	 )
	 ((and
	    (eq tipf "0")
	    (eq sech "0")
	    (eq sprd "0")
	    (eq sbk "1")
	  ) ;_  and
	  (capfotr r0 n0 d1 d2 s1 s2 l d3 s3 inptG a1 mb 1 0 pdl shtrp)
	 )
	 ((and (eq tipf "1")
	       (eq sech "1")
	       (eq sprd "0")
	       (eq sbk "0")
	  ) ;_  and
	  (capfotr r0 n0 d1 d2 s1 s2 l d3 s3 inptG a1 mb 2 1 pdl shtrp)
	 )
	 ((and
	    (eq tipf "1")
	    (eq sech "0")
	    (eq sprd "1")
	    (eq sbk "0")
	  ) ;_  and
	  (capfotr2 r0 d2 d3 s2 inptG a1 mb 2 pdl)
	 )
	 ((and
	    (eq tipf "1")
	    (eq sech "0")
	    (eq sprd "0")
	    (eq sbk "1")
	  ) ;_  and
	  (capfotr r0 n0 d1 d2 s1 s2 l d3 s3 inptG a1 mb 2 0 pdl shtrp)
	 )
   ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  CAPFA
