;;;   
;;;:  ..
;;; : 22.08.2001
;;;CAD-CEE 2000
;;;: C:USHKO

(defun c:ushko (/ tipf  db    d     d1  notv	 h     h2    b
		   l	 s1     sech  sprd  name1 orx   aby   dlg
		   dfl	 lsp1  lsp2  lsp3  lsp4	 lsp5  fld   strd
		   strdd strd1 strdd1	   p1	 p2    p3    angl
		   mash	 name1 spis  pti   inptG xc    yc    dcl_id
		   inptG a1    mb    cmd   blpm	 apsz  osmd  clay
		   cltp	 ccol  vs    vctr  pv	 anbl  sset  label
		   sech2 sbk   py    gr	   pyf	 grf   stf   fldat
		   dfl2	 as    ass   bs	   bss	 bss1  bss2  fldat2
		   as2	 ass2  dtb   stb   shtrp spism mtr   hpa
		   hpn	 st    ang1  dy    dyf   dor   tt    dat1
		   dat2  dat3  dat4  dt    dop   ass1  ass2  nsum
		   lstn  dy1z  dyz   dz    dtz   lstn1 fldat3 h1
		   r     r1    an    l1    h1min lt    r0    n0
	           grz   pdl   s2    l2    b     b1    b2    r2
	           l0    b0    inptG1 nl0  nlf   elpt  ellst xt
		   d0    s0    okpt   vt
		  )   

  (setq	dlg  (findfile (strcat pathdcl2 "strop\\ushko.dcl"))
	dfl  (findfile (strcat pathlisp2 "strop\\ushko.d"))
	anbl (findfile (strcat pathlisp2 "$anblk.lsp"))
	elpt (findfile (strcat pathlisp2 "$ellpt.lsp"))
	okpt (findfile (strcat pathlisp2 "$okrpt.lsp"))
	lsp1 (findfile (strcat pathlisp2 "strop\\ushotr.lsp"))
	dat1 (findfile (strcat pathdat2 "strop\\ushko.dat"))
  ) ;_  setq

  (load anbl)
  (load elpt)
  (load okpt)
  (load lsp1)

  

;;;   
  (setq	spis '(" 1 ( . )"
	       " 1 ( . )"
	       " 2"
	       " 3"
	      )
  ) ;_  setq

;;;    
  (setq grf '("1.0" "2.0" "4.0" "8.0" "16.0" "32.0"))

;;;    
  (setq nlf '("1" "2" "3" "4"))

;;;   
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun axs ()
    (command "_'layer" "_s" " " "")
  ) ;_  defun
  (defun axs2 ()
    (command "_'layer" "_s" " 2" "")
  ) ;_  defun
  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  (defun punkt2 ()
     (command "_'layer" "_s" "2" "")
  ) ;_  defun
  (defun textf ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun


;;;      USHKO.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   gr	  (itoa (nth 1 strdd1))
	   pdl    (itoa (nth 2 strdd1))
	   r0     (nth 3 strdd1)
	   s0     (nth 4 strdd1)
	   r1     (nth 5 strdd1)
	   nl0    (itoa (nth 6 strdd1))
	   sech	  (itoa (nth 7 strdd1))
	   sprd	  (itoa (nth 8 strdd1))
	   sbk	  (itoa (nth 9 strdd1))
	   shtrp  (itoa (nth 10 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "Gr" gr)
    (set_tile "Podk" pdl)
    (set_tile "R" (rtos (* r0 2.0)))
    (set_tile "S0" (rtos s0))
    (set_tile "R1" (rtos r1))
    (set_tile "N" nl0)
    (set_tile "A" (rtos (+ (- h1 r) s2)))
    (set_tile "D" (rtos d))
    (set_tile "L0" (rtos l0))
    (set_tile "B" (rtos b0))
    (set_tile "S" (rtos s1))
    (set_tile "S1" (rtos s2))
    (if	(eq pdl "0")
      (progn (set_tile "S1" "0")
	     (set_tile "L0" "0")
	     (set_tile "B" "0")
      ) ;_  progn
    ) ;_  if
    (if	(or (eq tipf "0") (eq tipf "1"))
      (progn
	(mode_tile "Sbk" 1)
	(if (eq sbk "1")
	  (setq	sech "1"
		sprd "0"
		sbk  "0"
	  ) ;_  setq
	) ;_  if
      ) ;_  progn
      (mode_tile "Sbk" 0)
    ) ;_  if
    (set_tile "Sech" sech)
    (set_tile "Sprd" sprd)
    (set_tile "Sbk" sbk)
    (set_tile "Shtr" shtrp)
;;;      
    (cond ((eq tipf "2")
	   (mode_tile "R" 0)
	   (mode_tile "S0" 0)
	   (mode_tile "R1" 1)
	   (mode_tile "N" 0)
	  )
	  ((eq tipf "3")
	   (mode_tile "R" 1)
	   (mode_tile "S0" 1)
	   (mode_tile "R1" 1)
	   (mode_tile "N" 1)
	  )
	  (t
	   (mode_tile "R" 0)
	   (mode_tile "S0" 0)
	   (mode_tile "R1" 0)
	   (mode_tile "N" 0)
	  )
    ) ;_  cond
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       USHKO.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " gr " " pdl " " (rtos r0) " " (rtos s0) " " (rtos r1) " "
			     nl0 " " sech " " sprd " " sbk " " shtrp ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(10).slb"))
	)
	((and (eq tipf "1")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(11).slb"))
	)
	((and (or (eq tipf "0") (eq tipf "1"))
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(12).slb"))
	)
	((and (or (eq tipf "0") (eq tipf "1"))
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(7).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(2).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(5).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	      (= n0 1)
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(8).slb"))
	)
	((and (eq tipf "2")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	      (> n0 1)
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(13).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "1")
	      (eq sprd "0")
	      (eq sbk "0")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(3).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "1")
	      (eq sbk "0")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(6).slb"))
	)
	((and (eq tipf "3")
	      (eq sech "0")
	      (eq sprd "0")
	      (eq sbk "1")
	 ) ;_  and
	  (setq name1 (strcat pathdat2 "strop\\ushko(9).slb"))
	)
  ) ;_  cond
) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;      
(defun desk_f ()
  (setq	fldat (open dat1 "r")
	bs    (read-line fldat)
	bss   (read bs)
	bss1  (nth 0 bss)
	s1    (nth 1 bss)
	l1    (nth 2 bss)
	h1    (nth 3 bss)
	d     (nth 4 bss)
	r     (nth 5 bss)
	s2    (nth 6 bss)
	l0    (nth 7 bss)
	b0    (nth 8 bss)
  ) ;_  setq
) ;_  defun


;;;    
   (defun clos_dfl2 ()
      (close fldat)
      (desk_f)
    ) ;_  defun

;;;      
(defun whl ()
  (if (/= grz bss1)
    (clos_dfl2)
  ) ;_  if 
  (while (/= grz bss1)
    (setq bs   (read-line fldat)
	  bss  (read bs)
	  bss1 (nth 0 bss)
	  s1   (nth 1 bss)
	  l1   (nth 2 bss)
	  h1   (nth 3 bss)
	  d    (nth 4 bss)
	  r    (nth 5 bss)
	  s2   (nth 6 bss)
	  l0   (nth 7 bss)
	  b0   (nth 8 bss)
    ) ;_  setq
  ) ;_  while
) ;_  defun


;;;    
    (defun spis_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun


;;;   
    (defun grf_l ()
      (start_list "Gr")
      (mapcar 'add_list grf)
      (end_list)
    ) ;_  defun

;;;    
    (defun nlf_l ()
      (start_list "N")
      (mapcar 'add_list nlf)
      (end_list)
    ) ;_  defun


  
;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STRING)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun

;;;  1
   (defun rpt1 ()
     (if (eq pdl "1")
       (setq vt b0)
       (setq vt s1)
     ) ;_  if
     (if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5))))
       (progn
	 (setq n0  1
	       nl0 "0"
	 ) ;_  setq
	 (set_tile "N" nl0)
       ) ;_  progn
     ) ;_  if
   ) ;_  defun

;;;  2
   (defun rpt2 ()
     (if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5))))
       (progn
	 (setq n0  1
	       nl0 "0"
	 ) ;_  setq
	 (set_tile "N" nl0)
       ) ;_  progn
     ) ;_  if
     (if (or (eq tipf "2") (eq pdl "0"))
       (mode_tile "Shtr" 1)
       (mode_tile "Shtr" 0)
     ) ;_  if
   ) ;_  defun
  
;;;  3
   (defun rpt3 ()
     (if (> r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0))))
       (progn
	 (setq r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0))))
	 (set_tile "R1" (rtos r1))
       ) ;_  progn
     ) ;_  if
     (if (eq pdl "1")
       (setq vt b0)
       (setq vt s1)
     ) ;_  if
     (if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5))))
       (progn
	 (setq n0  1
	       nl0 "0"
	 ) ;_  setq
	 (set_tile "N" nl0)
       ) ;_  progn
     ) ;_  if
   ) ;_  defun

;;;  4
   (defun rpt4 ()
     (if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5))))
       (progn
	 (setq n0  1
	       nl0 "0"
	 ) ;_  setq
	 (set_tile "N" nl0)
       ) ;_  progn
     ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
      (setq srv (* s2 mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun



;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

;;;       
   (if (and (or (eq tipf "0") (eq tipf "1"))
	    (eq sech "1")
       ) ;_  and
     (progn
       (mode_tile "Angl" 1)
       (mode_tile "per2" 1)
     ) ;_  progn
   ) ;_  if

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


  
;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "ushko" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (spis_l)
    (grf_l)
    (nlf_l)
;;;          
    (setq grz (atof (nth (atoi gr) grf))
	  n0 (atoi (nth (atoi nl0) nlf))
    ) ;_  setq
    (show_im (name))
    (desk_f)
    (whl)
    (s_t)

;;;          
    (if	(eq pdl "1")
      (setq xt l0)
      (setq xt l1)
    ) ;_  if

    (if	(and (eq sech "1") (or (/= tipf "2")(eq pdl "1")))
      (mode_tile "Shtr" 0)
    ) ;_  if
    
    (mode_tile "Tipf" 2)

;;;     
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(s_t)"
	      "(show_im (name))"
	      "(if (or (eq tipf \"2\") (eq pdl \"0\"))"
	      "(mode_tile \"Shtr\" 1)(mode_tile \"Shtr\" 0))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Gr"
      (strcat "(setq gr $value)"
	      "(setq grz  (atof (nth (atoi gr) grf)))"
	      "(desk_f)"
              "(whl)"
	      "(s_t)"
	      "(if (eq pdl \"1\") (setq xt l0)(setq xt l1))"
	      "(if (> r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0))))"
	      "(progn (setq r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0)))) (set_tile \"R1\" (rtos r1))))"
	      "(rpt1)"
;;;	      "(if (eq pdl \"1\") (setq vt b0)(setq vt s1))"
;;;	      "(if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5)))) (progn (setq n0 1 nl0 \"0\") (set_tile \"N\" nl0)))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Podk"
      (strcat "(setq pdl $value)"
	      "(s_t)"
	      "(if (eq pdl \"1\") (setq xt l0)(setq xt l1))"
	      "(if (> r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0))))"
	      "(progn (setq r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0)))) (set_tile \"R1\" (rtos r1))))"
	      "(if (eq pdl \"1\") (setq vt b0)(setq vt s1))"
	      "(rpt2)"
;;;	      "(if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5)))) (progn (setq n0 1 nl0 \"0\") (set_tile \"N\" nl0)))"
;;;	      "(if (or (eq tipf \"2\") (eq pdl \"0\"))"
;;;	      "(mode_tile \"Shtr\" 1)(mode_tile \"Shtr\" 0))"
      ) ;_  strcat
    ) ;_  action_tile
   (action_tile
      "R"
      (strcat ;"(alert \"2\")"
	      "(prv_p $value 'r0 \"R\" \"r\")"
	      "(setq r0 (/ r0 2.0))"
	      "(prov 100 r0 2500 \"R\" \"\")"
	      "(if (> s0 (* 0.2 r0)) (progn (setq s0 (* 0.2 r0)) (set_tile \"S0\" (rtos s0))))"
              "(rpt3)"
;;;	      "(if (> r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0))))"
;;;	      "(progn (setq r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0)))) (set_tile \"R1\" (rtos r1))))"
;;;	      "(if (eq pdl \"1\") (setq vt b0)(setq vt s1))"
;;;	      "(if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5)))) (progn (setq n0 1 nl0 \"0\") (set_tile \"N\" nl0)))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S0"
      (strcat "(prv_p $value 's0 \"S0\" \"r\")"
	      "(prov 4 s0 (* 0.2 r0) \"S0\" \"\")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "R1"
      (strcat "(prv_p $value 'r1 \"R1\" \"r\")"
	      "(if (eq pdl \"1\") (setq xt l0)(setq xt l1))"
	      "(prov 0 r1 (- r0 (+ (* 0.05 r0) (/ xt 2.0))) \"R1\" \"\")"
	      "(if (eq pdl \"1\") (setq vt b0)(setq vt s1))"
	      "(rpt4)"
;;;	      "(if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5)))) (progn (setq n0 1 nl0 \"0\") (set_tile \"N\" nl0)))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N"
      (strcat "(setq nl0 $value)"
	      "(setq n0  (atoi (nth (atoi nl0) nlf)))"
	      "(if (eq pdl \"1\") (setq vt b0)(setq vt s1))"
	      "(if (> (* vt n0) (* 2 pi (- r1 (* l1 0.5)))) (progn (setq n0 1 nl0 \"0\") (set_tile \"N\" nl0)))"
	      "(show_im (name))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sech"
      (strcat "(setq sech $value)"
	      "(setq sprd \"0\")"
	      "(setq sbk \"0\")"
	      "(show_im (name))"
	      "(if (/= tipf \"2\")(mode_tile \"Shtr\" 0))(mode_tile \"Shtr\" 1)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sprd"
      (strcat "(setq sprd $value)"
	      "(setq sech \"0\")"
	      "(setq sbk \"0\")"
	      "(show_im (name))"
	      "(mode_tile \"Shtr\" 1)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Sbk"
      (strcat "(setq sbk $value)"
	      "(setq sech \"0\")"
	      "(setq sprd \"0\")"
	      "(show_im (name))"
	      "(mode_tile \"Shtr\" 1)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtrp $value)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
;;;   ()
    (if	(= (getvar "USERR1") 0)
      (setq mb (atof mash))
      (setq mb (getvar "USERR1"))
    ) ;_ end of if
    (setq mash (rtos mb))
;;;      
  (ins1)
  (setvar "USERR1" mb); 

  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  (defun inpt1 ()
    (initget 1)
    (if	(or (and (eq sprd "1") (or (eq tipf "0") (eq tipf "1")))
	    (and (eq sbk "1") (eq tipf "2") (> n0 1))
	) ;_  or
      (if (eq p1 "1")
	(setq inptG1
	       (getpoint "\n   :")
	) ;_  setq
	(setq inptG1 (list (atof xc) (atof yc))
	) ;_  setq
      ) ;_  if
      (if (eq p1 "1")
	(setq inptG
	       (getpoint "\n  :")
	) ;_  setq
	(setq inptG (list (atof xc) (atof yc)))
      ) ;_  if
    ) ;_  if

    (if	(or (and (eq sprd "1") (or (eq tipf "0") (eq tipf "1")))
	    (and (eq sbk "1") (eq tipf "2") (> n0 1))
	) ;_  or
      (if (eq p2 "1")
	(progn
	  (setq
	    a1
	     (getangle inptG1
		       (strcat "\n   <" angl ">:")
	     ) ;_  getangle
	  ) ;_  setq
	  (if (= a1 nil)
	    (progn
	      (setq a1 (* pi (/ (atof angl) 180)))
	      (if (eq tipf "2")
		(setq inptG
		       (polar inptG1 (+ a1 (/ pi 2.0)) (* (+ r0 s0) mb))
		) ;_  setq
		(setq inptG (polar inptG1 (+ a1 pi) (* r1 mb)))
	      ) ;_  if
	    ) ;_  progn
	    (if	(eq sprd "1")
	      (setq a1	  (+ a1 pi)
		    inptG (polar inptG1 (+ a1 pi) (* r1 mb))
	      ) ;_  setq
	      (setq a1	  (- a1 (/ pi 2.0))
		    inptG (polar inptG1 (+ a1 (/ pi 2.0)) (* (+ r0 s0) mb))
	      ) ;_  setq
	    ) ;_  if
	  ) ;_  if
	) ;_  progn
	(progn
	  (setq a1 (* pi (/ (atof angl) 180)))
	  (if (eq tipf "2")
	    (setq
	      inptG (polar inptG1 (+ a1 (/ pi 2.0)) (* (+ r0 s0) mb))
	    ) ;_  setq
	    (setq inptG (polar inptG1 (+ a1 pi) (* r1 mb)))
	  ) ;_  if
	) ;_  progn
      ) ;_  if
      (if (eq p2 "1")
	(progn
	  (setq
	    a1
	     (getangle inptG
		       (strcat "\n   <" angl ">:")
	     ) ;_  getangle
	  ) ;_  setq
	  (if (= a1 nil)
	    (setq a1 (* pi (/ (atof angl) 180)))
	    (if	(eq sprd "1")
	      (setq a1 (+ a1 pi))
	      (setq a1 (- a1 (/ pi 2.0)))
	    ) ;_  if
	  ) ;_  if
	) ;_  progn
	(setq a1 (* pi (/ (atof angl) 180)))
      ) ;_  if
    ) ;_  if
  ) ;_  defun

;;;    
  (cond	((and (eq tipf "0") (eq sech "1"))
	 (setq ellst (ellpt r0 s0 r1 (* 3.0 (/ pi 2.0)) mb)
	       inptG (nth 0 ellst)
	       a1    (nth 3 ellst)
	 ) ;_  setq
	)
	((and (eq tipf "1") (eq sech "1"))
	 (setq ellst (okrpt r0 s0 r1 (* 3.0 (/ pi 2.0)) mb)
	       inptG (nth 0 ellst)
	       a1    (nth 3 ellst)
	 ) ;_  setq
	)
	(t
	 (inpt1)
	)
  ) ;_  cond


  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))
  
  (if (< vs (* (* l0 mb) 2))
    (command "_ZOOM" "_C" inptG (* (* l0 mb) 2))
  ) ;_  if

;;;    
   (cond ((and (eq tipf "0")
	       (eq sech "1")
	       (eq sprd "0")
	       (eq sbk "0")
	  ) ;_  and
	   (ushotr r0 s0 r1 l1 h1 d r s2 l0 b0 inptG a1 mb 0 pdl ellst shtrp)
	 )
	 ((and
	    (eq tipf "0")
	    (eq sech "0")
	    (eq sprd "1")
	    (eq sbk "0")
	  ) ;_  and
	  (ushotr2 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 0 pdl n0)
	 )
	 ((and
	    (eq tipf "0")
	    (eq sech "0")
	    (eq sprd "0")
	    (eq sbk "1")
	  ) ;_  and
	  (ushotr3 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 0 pdl)
	 )
	 ((and (eq tipf "1")
	       (eq sech "1")
	       (eq sprd "0")
	       (eq sbk "0")
	  ) ;_  and
	  (ushotr r0 s0 r1 l1 h1 d r s2 l0 b0 inptG a1 mb 1 pdl ellst shtrp)
	 )
	 ((and
	    (eq tipf "1")
	    (eq sech "0")
	    (eq sprd "1")
	    (eq sbk "0")
	  ) ;_  and
	  (ushotr2 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 1 pdl n0)
	 )
	 ((and
	    (eq tipf "1")
	    (eq sech "0")
	    (eq sprd "0")
	    (eq sbk "1")
	  ) ;_  and
	  (ushotr3 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 1 pdl)
	 )
	 ((and (eq tipf "2")
	       (eq sech "1")
	       (eq sprd "0")
	       (eq sbk "0")
	  ) ;_  and
	  (ushotr r0 s0 r1 l1 h1 d r s2 l0 b0 inptG a1 mb 2 pdl ellst shtrp)
	 )
	 ((and
	    (eq tipf "2")
	    (eq sech "0")
	    (eq sprd "1")
	    (eq sbk "0")
	  ) ;_  and
	  (ushotr2 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 2 pdl n0)
	 )
	 ((and
	    (eq tipf "2")
	    (eq sech "0")
	    (eq sprd "0")
	    (eq sbk "1")
	  ) ;_  and
	  (ushotr3 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 2 pdl)
	 )
	 ((and (eq tipf "3")
	       (eq sech "1")
	       (eq sprd "0")
	       (eq sbk "0")
	  ) ;_  and
	  (ushotr r0 s0 r1 l1 h1 d r s2 l0 b0 inptG a1 mb 3 pdl ellst shtrp)
	 )
	 ((and
	    (eq tipf "3")
	    (eq sech "0")
	    (eq sprd "1")
	    (eq sbk "0")
	  ) ;_  and
	  (ushotr2 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 3 pdl n0)
	 )
	 ((and
	    (eq tipf "3")
	    (eq sech "0")
	    (eq sprd "0")
	    (eq sbk "1")
	  ) ;_  and
	  (ushotr3 r0 s0 s1 r1 h1 r s2 l0 b0 inptG a1 mb 3 pdl)
	 )
   ) ;_  cond

;;;      
  (while (setq label (entnext label))
      (setq sset (ssadd label sset))
  ) ;_  while

  (if (eq p3 "0")
   (anblk sset inptG)
  ) ;_  if

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  USHKO