;;;        
;;;:  ..
;;; : 10.09.2001
;;;CAD-CEE 2000
;;;: C:FASKA

(defun c:faska (/ tipf	db    d	    h	  h2	b     l	    s	  sech
		  sprd	name1 orx   aby	  dlg	dfl   lsp1  lsp2  lsp3
		  lsp4	lsp5  fld   strd  strdd	strd1 strdd1	  p1
		  p2	p3    angl  mash  name1	spis  pti   inptG xc
		  yc	dcl_id	    rezos fe	inptG a1    mb	  cmd
		  blpm	apsz  osmd  clay  cltp	ccol  vs    vctr  pv
		  anbl	sset  label sech2 sbk	shtr  hpa   hpn	  ang0
		  a	x     an1   an2	  r	bn1   bn2   anl1  anl2
		 ) 

  (setq	dlg  (findfile (strcat pathdcl2 "svarka\\faska.dcl"))
	dfl  (findfile (strcat pathlisp2 "svarka\\faska.d"))
	lsp1 (findfile (strcat pathlisp2 "svarka\\fasotr.lsp"))
  ) ;_  setq

  (load lsp1)

  (setq spis '("  "
	       "  "
	      ) 
  ) ;_  setq

;;;     
  (setq ang0 '("0" "12" "20" "25" "30" "45" "50" "55"))
  
;;;      FASKA.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd1  (read-line fld)
	   strdd1 (read strd1)
	   tipf	  (itoa (nth 0 strdd1))
	   s	  (nth 1 strdd1)
	   a	  (nth 2 strdd1)
	   x	  (nth 3 strdd1)
	   anl1	  (itoa (nth 4 strdd1))
	   anl2	  (itoa (nth 5 strdd1))
	   r	  (nth 6 strdd1)
	   shtr	  (itoa (nth 7 strdd1))
	   strd	  (read-line fld)
	   strdd  (read strd)
	   p1	  (itoa (nth 0 strdd))
	   p2	  (itoa (nth 1 strdd))
	   angl	  (rtos (nth 2 strdd))
	   mash	  (rtos (nth 3 strdd))
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

  ;;;            
  (defun s_t ()
    (set_tile "Tipf" tipf)
    (set_tile "S" (rtos s))
    (set_tile "A" (rtos a))   
    (set_tile "X" (rtos x))
    (set_tile "A1" anl1)
    (set_tile "A2" anl2)
    (set_tile "R" (rtos r))
    (set_tile "Shtr" shtr)
  ) ;_  defun

  
;;;          
  (defun s_t1 ()
    (set_tile "per1" p1)
    (setq xc "0"
	  yc "0"
    ) ;_  setq
    (if	(eq p1 "0")
      (progn
	(mode_tile "xcor" 0)
	(mode_tile "ycor" 0)
	(set_tile "xcor" xc)
	(set_tile "ycor" yc)
      ) ;_  progn
    ) ;_  if

    (set_tile "per2" p2)
    (if	(eq p2 "0")
      (mode_tile "Angl" 0)
    ) ;_  if

    (set_tile "Angl" angl)
    (set_tile "Mash" mash)
  ) ;_  defun



;;;       FASKA.D
  (defun wrfl ()
    
      (setq fld (open dfl "w")
	    strd (strcat "(" p1 " " p2 " " angl " " mash ")")
      )
     (write-line strd1 fld)
     (write-line strd fld)
     (close fld)
    
  )  ;_  defun


  (defun wrfl_os ()
        (setq strd1 (strcat "(" tipf " " (rtos s) " " (rtos a) " " (rtos x) " "
			    anl1 " " anl2 " " (rtos r) " " shtr ")")
	)          
  )  ;_  defun


;;;     
(defun name ()
  (cond	((and (eq tipf "0")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "svarka\\faska(1).slb"))
	)
	((and (eq tipf "1")
	 ) ;_  and
	 (setq name1 (strcat pathdat2 "svarka\\faska(3).slb"))
	)
  ) ;_  cond
) ;_  defun

  
;;;   
  (defun show_im (name1)
    (setq orx (dimx_tile "image")
	  aby (dimy_tile "image")
    ) ;_  setq
    (start_image "image")
    (fill_image 0 0 orx aby 252)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun



;;;     
(defun vtr ()
  (cond	((eq tipf "0")
	 (mode_tile "A2" 0)
	 (mode_tile "R" 0)
	)
	((eq tipf "1")
	 (mode_tile "A2" 1)
	 (mode_tile "R" 1)
	)
  ) ;_  cond
) ;_  defun


;;;    
    (defun tipf_l ()
      (start_list "Tipf")
      (mapcar 'add_list spis)
      (end_list)
    ) ;_  defun

;;;   
    (defun an1_l ()
      (start_list "A1")
      (mapcar 'add_list ang0)
      (end_list)
    ) ;_  defun

;;;   
    (defun an2_l ()
      (start_list "A2")
      (mapcar 'add_list ang0)
      (end_list)
    ) ;_  defun


;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

   
;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun


;;;      
  (defun pred (/ srv)

    (setq mb (atof mash))
    
;;;    (if (= l 0)
    (setq srv (* a mb))
;;;      (setq srv (* s mb))
;;;    ) ;_  if

    (if	(< srv 0.6)
      (progn (set_tile "Pred"
		       "!   "
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "0"
		     sbk  "1"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
      (progn (set_tile "Pred"
		       ""
	     ) ;_  set_tile
	     (if (eq sech2 "1")
	       (setq sech "1"
		     sbk  "0"
	       ) ;_  setq
	     ) ;_  if
      ) ;_  progn
    ) ;_  if
  ) ;_  defun


;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

  
;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (itoa ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun



;;;    
 (defun	ins1 ()

   (if (and (eq p2 "0") (eq angl nil))
     (setq angl "0")
   ) ;_  if
   (if (eq p3 nil)
     (setq p3 "1")
   ) ;_  if

   (new_dialog "ins1" dcl_id)

   (setq sech2 sech)
   (s_t1)
   (pred)

   (action_tile "xcor" "(setq xc $value)")
   (action_tile "ycor" "(setq yc $value)")

   (action_tile "Mash" "(prv_p $value 'mb \"Mash\" \"r\")(setq mash (rtos mb))(pred)")
   (action_tile "Angl" "(prv_p $value 'angl \"Angl\" \"s\")")

   (action_tile
     "per1"
     (strcat
       "(setq p1 $value) (if (eq p1 \"0\") (progn (mode_tile \"xcor\" 0)"
       "(mode_tile \"ycor\" 0)(set_tile \"xcor\" xc)(set_tile \"ycor\" yc))"
       "(progn (mode_tile \"xcor\" 1)(mode_tile \"ycor\" 1)"
       "(set_tile \"xcor\" \"0\")(set_tile \"ycor\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile
     "per2"
     (strcat
       "(setq p2 $value)(if (eq p2 \"0\")(mode_tile \"Angl\" 0)"
       "(progn (mode_tile \"Angl\" 1) (setq angl \"0\") (set_tile \"Angl\" \"0\")))"
     ) ;_  strcat
   ) ;_  action_tile
   (action_tile "per3" "(setq p3 $value)")

   (action_tile "accept" "(done_dialog)(wrfl)")
   (action_tile "cancel" "(exit)")

   (start_dialog)			;   


 ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog
    
					; DCL-
    (if	(not (new_dialog "faska" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    ;;;         
    (setq an1 (atof (nth (atoi anl1) ang0))
	  an2 (atoi (nth (atoi anl2) ang0))
    ) ;_  setq
    (show_im (name))
    (s_t)
    (tipf_l)
    (an1_l)
    (an2_l)
    (vtr)
    (mode_tile "Tipf" 2)
    
;;;       
    (action_tile
      "Tipf"
      (strcat "(setq tipf $value)"
	      "(show_im (name))"
	      "(vtr)"
	      "(if (eq tipf \"0\")"
	      "(progn (setq x 0.0) (set_tile \"X\" (rtos x)))"
	      "(progn (setq x 8.0) (set_tile \"X\" (rtos x)))"
	      ")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "S"
      (strcat "(prv_p $value 's \"S\" \"r\")"
	      "(prov 1 s 200 \"S\" \"\")"
	      "(if (> a s) (progn (setq a s) (set_tile \"A\" (rtos a))))"
	      "(if (and (> (+ x a) s) (eq tipf \"0\")) (progn (setq x 0.0) (set_tile \"X\" (rtos x))))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "A"
      (strcat "(prv_p $value 'a \"A\" \"r\")"
	      "(prov 0 a s \"A\" \"\")"
	      "(if (and (> (+ x a) s) (eq tipf \"0\")) (progn (setq x 0.0) (set_tile \"X\" (rtos x))))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "X"
      (strcat "(prv_p $value 'x \"X\" \"r\")"
	      "(if (eq tipf \"0\")"
	      "(prov 0 x (- s a) \"X\" \"\")"
	      "(prov 8 x 20 \"X\" \"\")"
	      ")"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "A1"
      (strcat "(setq anl1 $value anl2 anl1)"
	      "(setq an1 (atof (nth (atoi anl1) ang0)))"
	      "(setq an2 (atof (nth (atoi anl2) ang0)))"
	      "(set_tile \"A2\" anl2)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "A2"
      (strcat "(setq anl2 $value)"
	      "(setq an2 (atof (nth (atoi anl2) ang0)))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "R"
      (strcat "(prv_p $value 'r \"R\" \"r\")"
	      "(prov 0 r 3000 \"R\" \"\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Shtr"
      (strcat "(setq shtr $value)"
      ) ;_  strcat
    ) ;_  action_tile


    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (action_tile "Svdf" "(wrfl_os)")
    (start_dialog)

  ) ;_  defun


;;;  
  (show)
  (ins1)
;;;  (setvar "USERR1" mb); 
  
  (unload_dialog dcl_id)
  (prin1)

  
;;;   
  
  (initget 1)
  (if (eq p1 "1")
    (setq inptG
	   (getpoint "\n  :")
    ) ;_  setq
    (setq inptG (list (atof xc) (atof yc)))
  ) ;_  if
  (if (eq p2 "1")
    (progn
      (setq
	a1 (getangle inptG
		     (strcat "\n   <" angl ">:")
	   ) ;_  getangle
      ) ;_  setq
      (if (= a1 nil)
	(setq a1 (* pi (/ (atof angl) 180)))
	(setq a1 (+ a1 pi))
      ) ;_  if
    ) ;_  progn
    (setq a1 (* pi (/ (atof angl) 180)))
  ) ;_  if

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq hpa (getvar "hpang"))
  (setq hpn (getvar "hpname"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "highlight" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)


  (setq wr1 (getvar "TDUSRTIMER"))

  (if (< vs (* (* s 3.0) 2))
    (command "_ZOOM" "_C" inptG (* (* s 3.0) 2))
  ) ;_  if
  
;;;    
  (cond	((and (eq tipf "0")
	 ) ;_  and
	 (fasotr s a x an1 an2 r 0 0 inptG mb a1 shtr 1)
	)
	((and (eq tipf "1")
	 ) ;_  and
	 (fasotr s a x an1 an2 0.0 0 0 inptG mb a1 shtr 2)
	)
  ) ;_  cond

  (command "_ZOOM" "_C" vctr vs)
  (setvar "highlight" 1)
  (setvar "cmdecho" cmd)
  (setvar "hpang" hpa)
  (setvar "hpname" hpn)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400)) 
  (prin1)
 
) ;_  FASKA
