;;;     
;;;:  ..
;;; : 10.09.2001
;;;CAD-CEE 2000
;;; (fasotr s a x an1 an2 r bn1 bn2 ip mb a1 shtrp pr)
;;;   : s -   S, ;
;;;        a -  a, ;
;;;        x -  X, ;
;;;        an1 -  A1, .;
;;;        an2 -  A2, .;
;;;        r -    R, ;
;;;        bn1 -  B1, . (  );
;;;        bn2 -  B2, . (  );
;;;        ip -  ;
;;;        mb -  ;
;;;        a1 -   ;
;;;        shtr -      ("1" -  , "0" - );
;;;        pr -     (1 -  1, 2 -  2).


(defun fasotr (s    a	 x    an1  an2	r    bn1  bn2  ip   mb	 a1
	       shtrp	 pr   /	   an0	b    ip1  p1   p1a  p1b	 p2
	       p2a  p2b	 p3   p4   p4a	p4b  p5   b1   an   sos  pt1
	       pt2  b2
	      )
;;;    
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
;;;   
  (setq	s   (* s mb)
	a   (* a mb)
	x   (* x mb)
	r   (* r mb)
	an1 (* (/ an1 180.0) pi)
	an2 (* (/ an2 180.0) pi)
	bn1 (* (/ bn1 180.0) pi);  
	bn2 (* (/ bn2 180.0) pi);  
	sos (* s 0.2)
  ) ;_  setq
  (if (/= r 0.0)
    (setq an0 (/ s r))
    (setq an0 0.0)
  ) ;_  if

;;;       1
  (defun isp1 ()
;;;       
    (setq b   (- s (+ a x))
	  b1  (* b (/ (sin an1) (cos an1)))
	  b2  (* x (/ (sin an2) (cos an2)))
	  ip1 (polar ip (- a1 (/ pi 2.0)) (+ r s))
	  p1  (polar ip (+ a1 pi) b1)
	  p2  (polar ip (- a1 (/ pi 2.0)) b)
	  p3  (polar p2 (- a1 (/ pi 2.0)) a)
	  p5  (polar ip (- a1 (/ pi 2.0)) s)
	  p4  (polar p5 (+ a1 pi) b2)
	  p1a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) (+ r s))
	  p2a (polar ip1 (+ a1 (/ pi 2.0) (* 3.0 an0)) (+ r (* 0.5 s)))
	  p4a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) r)
	  p1b (polar ip (+ a1 pi) (* s 2.5))
	  p2b (polar p2 (+ a1 pi) (* s 3.0))
	  p4b (polar p5 (+ a1 pi) (* s 2.5))
    ) ;_  setq
    (if	(/= r 0.0)
      (setq an (/ b1 (+ r s))
	    p1 (polar ip1 (+ a1 (/ pi 2.0) an) (+ r s))
	    pt1 (polar ip1 (+ a1 (/ pi 2.0) an (/ sos r)) (+ r s))
	    pt2 (polar ip1 (+ a1 (/ pi 2.0) (/ b2 r) (/ sos r)) r)
      ) ;_  setq
      (setq pt1 (polar p1 (+ a1 pi) sos)
	    pt2 (polar p4 (+ a1 pi) sos)
      ) ;_  setq
    ) ;_  if
;;;    
    (if	(eq shtrp "1")
      (osn)
      (ton)
    ) ;_  if
    (command "_LINE" p1 p2 "")
    (command "_LINE" p2 p3 "")
    (command "_LINE" p3 p4 "")
    (if	(= r 0.0)
      (progn
	(command "_LINE" p1 pt1 "" "_LINE" p4 pt2 "")
	(osn)
	(command "_LINE" pt1 p1b "")
	(command "_LINE" pt2 p4b "")
	(ton)
	(command "_SPLINE" p1b p2b p4b "" "" "")
      ) ;_  progn
      (progn
	(command "_arc" "_c" ip1 p1 pt1)
	(command "_arc" "_c" ip1 p4 pt2)
	(osn)
	(command "_arc" "_c" ip1 pt1 p1a)
	(command "_arc" "_c" ip1 pt2 p4a)
	(ton)
	(command "_SPLINE" p1a p2a p4a "" "" "")
      ) ;_  progn
    ) ;_  if
  ) ;_  ISP1

;;;       2
  (defun isp2 ()
;;;       
    (setq b   (- s a)
	  ip1 (polar ip (- a1 (/ pi 2.0)) (+ r s))
	  p1  (polar ip (+ a1 pi) (* b (/ (sin an1) (cos an1))))
	  p2  (polar ip (- a1 (/ pi 2.0)) b)
	  p3  (polar p2 a1 x)
	  p4  (polar p3 (- a1 (/ pi 2.0)) a)
	  p1a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) (+ r s))
	  p2a (polar ip1 (+ a1 (/ pi 2.0) (* 3.0 an0)) (+ r (* 0.5 s)))
	  p4a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) r)
	  p1b (polar ip (+ a1 pi) (* s 2.5))
	  p2b (polar p2 (+ a1 pi) (* s 3.0))
	  p4b (polar p4 (+ a1 pi) (+ (* s 2.5) x))
    ) ;_  setq   
;;;    
    (if	(eq shtrp "1")
      (osn)
      (ton)
    ) ;_  if
    (command "_LINE" p1 p2 "")
    (osn)
    (command "_LINE" p2 p3 "")
    (command "_LINE" p3 p4 "")
    (if	(= r 0.0)
      (progn
	(command "_LINE" p1 p1b "")
	(command "_LINE" p4 p4b "")
	(ton)
	(command "_SPLINE" p1b p2b p4b "" "" "")
      ) ;_  progn
      (progn
	(command "_arc" "_c" ip1 p1 p1a)
	(command "_arc" "_c" ip1 p4 p4a)
	(ton)
	(command "_SPLINE" p1a p2a p4a "" "" "")
      ) ;_  progn
    ) ;_  if
  ) ;_  ISP2

;;;    
  (defun sht (/ pt1)
    (setq pt1  (polar p1 (- a1 (* (/ pi 4.0) 3.0)) s)) 
    (ton)
    (command "_bhatch" "_p" "_u" 45 2.0 "_n" pt1 "")
  ) ;_  SHT


;;;  ------------- ----------
  (if (= pr 1)
    (isp1)
    (isp2)
  ) ;_  if
  (if (eq shtrp "1")
    (sht)
  ) ;_  if
) ;_  FASOTR

