;;;     5264
;;;:  ..
;;; : 14.09.2001
;;;CAD-CEE 2000
;;; (fasotr2 s1 s2 r s3 l bx ip mb a1 shtrp pr)
;;;   : s1 -    S1, ;
;;;        s2 -    S2, ;
;;;        r -    R, ;
;;;        s3 -   S3, ;
;;;        l  -   L, ;
;;;        bx -   , ;
;;;        ip -  ;
;;;        mb -  ;
;;;        a1 -   ;
;;;        shtr -      ("1" -  , "0" - );
;;;        pr -   .


(defun fasotr2 (s1  s2	r    s3	  l    bx   ip	 mb   a1   shtrp
		   pr	/    an0  b    ip1  p1	 p1a  p1b  p2	p2a
		   p2b	p3   p4	  p4a  p4b  p5	 b1   an   p6	p7
		   p8	p9   p6a  p6b  p7a  p7b	 p9a  p9b  os1	os2
		   pt1	pt2  pt3  pt4  pt5  pt6	 pt7  pt8  p10	ip2
		   an3	an4  x1	  b1   b2   b0	 x0   ip3  os1	os2
		   an5	sos  an6  an7  pt9  pt10 kat  pt11 sos2	p5a
		   x    y    pt2a pt2b
		  ) 

;;;    
  (defun osn ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun

  (defun ton ()
    (command "_'layer" "_s" "" "")
  ) ;_  defun
  
;;;      
  (defun stk ()
;;;   
    (setq s1  (* s1 mb)
	  s2  (* s2 mb)
	  r   (* r mb)
	  a   (* a mb)
	  x   (* x mb)
	  x0  (* x0 mb)
	  x1  (* x1 mb)
	  an1 (* (/ an1 180.0) pi)
	  an2 (* (/ an2 180.0) pi)
	  an3 (* (/ an3 180.0) pi)
	  an4 (* (/ an4 180.0) pi)
	  sos (* 0.2 s1)
    ) ;_  setq
    (if	(/= r 0.0)
      (setq an0 (/ s1 r))
      (setq an0 0.0)
    ) ;_  if
;;;       
    (setq b   (- s1 (+ a x))
	  b0  (- s2 (+ a x0))
	  b1  (* b (/ (sin an1) (cos an1)))
	  b2  (* b0 (/ (sin an3) (cos an3)))
	  ip1 (polar ip (- a1 (/ pi 2.0)) (+ r s1))
	  p1  (polar ip (+ a1 pi) b1)
	  p2  (polar ip (- a1 (/ pi 2.0)) b)
	  p3  (polar p2 (- a1 (/ pi 2.0)) a)
	  p5  (polar ip (- a1 (/ pi 2.0)) s1)
	  p4  (polar p5 (+ a1 pi) (* x (/ (sin an2) (cos an2))))
	  p1a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) (+ r s1))
	  p2a (polar ip1 (+ a1 (/ pi 2.0) (* 3.0 an0)) (+ r (* 0.5 s1)))
	  p4a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) r)
	  p1b (polar ip (+ a1 pi) (* s1 2.5))
	  p2b (polar p2 (+ a1 pi) (* s1 3.0))
	  p4b (polar p5 (+ a1 pi) (* s1 2.5))
	  p5a (polar p5 a1 x1)
	  ip2 (polar p5a (+ a1 (/ pi 2.0)) s2)
	  ip3 (polar ip2 (- a1 (/ pi 2.0)) (+ r s2))
	  p6  (polar ip2 a1 b2)
	  p7  (polar ip2 (- a1 (/ pi 2.0)) b0)
	  p8  (polar p7 (- a1 (/ pi 2.0)) a)
	  p10 (polar ip2 (- a1 (/ pi 2.0)) s2)
	  p9  (polar p10 a1 (* x0 (/ (sin an4) (cos an4))))
	  p6a (polar ip3 (- (+ a1 (/ pi 2.0)) (* 2.5 an0)) (+ r s2))
	  p7a (polar ip3 (- (+ a1 (/ pi 2.0)) (* 3.0 an0)) (+ r (* 0.5 s2)))
	  p9a (polar ip3 (- (+ a1 (/ pi 2.0)) (* 2.5 an0)) r)
	  p6b (polar ip2 a1 (* s2 2.5))
	  p7b (polar p7 a1 (* s2 3.0))
	  p9b (polar p10 a1 (* s2 2.5))
    ) ;_  setq
    (if	(/= r 0.0)
      (setq an	(/ b1 (+ r s1))
	    p1	(polar ip1 (+ a1 (/ pi 2.0) an) (+ r s1))
	    an5	(/ b2 (+ r s2))
	    p6	(polar ip3 (- (+ a1 (/ pi 2.0)) an5) (+ r s2))
	    an6 (/ (* x (/ (sin an2) (cos an2))) r)
	    an7 (/ (* x0 (/ (sin an4) (cos an4))) r)
	    os1	(polar p1 (angle p1 p6) (/ (distance p1 p6) 2.0))
	    os2	(polar p4 a1 (/ (distance p4 p9) 2.0))
	    pt1	(polar ip1 (+ (+ a1 (/ pi 2.0)) an (/ sos r)) (+ r s1))
	    pt2	(polar ip1 (+ (+ a1 (/ pi 2.0)) an6 (/ sos r)) r)
	    pt3	(polar ip3
		       (- (+ a1 (/ pi 2.0)) an5 (/ sos r))
		       (+ r s2)
		) ;_  polar
	    pt4	(polar ip3 (- (+ a1 (/ pi 2.0)) an7 (/ sos r)) r)
	    pt5	(polar os1 (+ a1 (/ pi 2.0)) sos)
	    pt6	(polar os2 (- a1 (/ pi 2.0)) sos)
	    pt7	(polar os2 (+ a1 (/ pi 2.0)) (+ sos x a))
	    pt8 (polar p2 (+ a1 pi) (* sos 0.5))
	    pt9 (polar p7 a1 (* sos 0.5))
      ) ;_  setq
      (setq os1	(polar p1 (angle p1 p6) (/ (distance p1 p6) 2.0))
	    os2	(polar p4 a1 (/ (distance p4 p9) 2.0))
	    pt1	(polar p1 (+ a1 pi) sos)
	    pt2	(polar p4 (+ a1 pi) sos)
	    pt3	(polar p6 a1 sos)
	    pt4	(polar p9 a1 sos)
	    pt5	(polar os1 (+ a1 (/ pi 2.0)) sos)
	    pt6	(polar os2 (- a1 (/ pi 2.0)) sos)
	    pt7	(polar os2 (+ a1 (/ pi 2.0)) (+ sos x a))
	    pt8 (polar p2 (+ a1 pi) (* sos 0.5))
	    pt9 (polar p7 a1 (* sos 0.5))
      ) ;_  setq
    ) ;_  if
;;;    
    (ton)
    (command "_LINE" p1 p2 "" "_LINE" p2 p3 "" "_LINE" p3 p4 "")
    (command "_LINE" p6 p7 "" "_LINE" p7 p8 "" "_LINE" p8 p9 "")
    (osn)
    (if	(= r 0.0)
      (progn
	(command "_LINE" p1b pt1 "" "_LINE" p4b pt2 "")
	(command "_LINE" p6b pt3 "" "_LINE" p9b pt4 "")
	(ton)
	(command "_SPLINE" p1b p2b p4b "" "" "")
	(command "_SPLINE" p6b p7b p9b "" "" "")
	(command "_LINE" p1 pt1 "" "_LINE" p6 pt3 "")
	(if (= pr 1)
	  (osn)
	) ;_  if
	(command "_LINE" p4 pt2 "" "_LINE" p9 pt4 "")
      ) ;_  progn
      (progn
	(command "_ARC" "_c" ip1 pt1 p1a)
	(command "_ARC" "_c" ip1 pt2 p4a)
	(command "_ARC" "_c" ip3 p6a pt3)
	(command "_ARC" "_c" ip3 p9a pt4)
	(ton)
	(command "_ARC" "_c" ip1 p1 pt1)
	(command "_ARC" "_c" ip3 pt3 p6)
	(command "_SPLINE" p1a p2a p4a "" "" "")
	(command "_SPLINE" p6a p7a p9a "" "" "")
	(if (= pr 1)
	  (osn)
	) ;_  if
	(command "_ARC" "_c" ip1 p4 pt2)
	(command "_ARC" "_c" ip3 pt4 p9)
      ) ;_  progn
    ) ;_  if
  ) ;_  STK

;;;       
  (defun stk2 ()
;;;   
    (setq s1  (* s1 mb)
	  s2  (* s2 mb)
	  s3  (* s3 mb)
	  l   (* l mb)
	  a   (* a mb)
	  x   (* x mb)
	  x1  (* x1 mb)
	  an1 (* (/ an1 180.0) pi)
	  an2 (* (/ an2 180.0) pi)
	  an3 (* (/ an3 180.0) pi)
	  an4 (* (/ an4 180.0) pi)
	  sos (* 0.2 s1)
	  y   (* 1.0 mb) ;      
	  s2  (+ s1 y)
    ) ;_  setq
;;;       
    (setq b   (- s1 (+ a x))
	  b1  (* b (/ (sin an1) (cos an1)))
	  b2  (* s2 (/ (sin an3) (cos an3)))
;;;	  ip1 (polar ip (- a1 (/ pi 2.0)) (+ r s1))
	  p1  (polar ip (+ a1 pi) b1)
	  p2  (polar ip (- a1 (/ pi 2.0)) b)
	  p3  (polar p2 (- a1 (/ pi 2.0)) a)
	  p5  (polar ip (- a1 (/ pi 2.0)) s1)
	  p4  (polar p5 (+ a1 pi) (* x (/ (sin an2) (cos an2))))
;;;	  p1a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) (+ r s1))
;;;	  p2a (polar ip1 (+ a1 (/ pi 2.0) (* 3.0 an0)) (+ r (* 0.5 s1)))
;;;	  p4a (polar ip1 (+ a1 (/ pi 2.0) (* 2.5 an0)) r)
	  p1b (polar ip (+ a1 pi) (* s1 2.5))
	  p2b (polar p2 (+ a1 pi) (* s1 3.0))
	  p4b (polar p5 (+ a1 pi) (* s1 2.5))
	  p5a (polar p5 a1 x1)
	  ip2 (polar p5a (+ a1 (/ pi 2.0)) s1)
;;;	  ip3 (polar ip2 (- a1 (/ pi 2.0)) (+ r s2 s3))
	  p6  (polar ip2 a1 b2)
	  p7  (polar ip2 (- a1 (/ pi 2.0)) s2)
	  p8  (polar p7 (+ a1 pi) l)
	  p9  (polar p8 (- a1 (/ pi 2.0)) s3)
;;;	  p6a (polar ip3 (- (+ a1 (/ pi 2.0)) (* 2.5 an0)) (+ r s2 s3))
;;;	  p7a (polar ip3 (- (+ a1 (/ pi 2.0)) (* 3.0 an0)) (+ r (* 0.5 (+ s2 s3))))
;;;	  p9a (polar ip3 (- (+ a1 (/ pi 2.0)) (* 2.5 an0)) (- r s3))
	  p6b (polar ip2 a1 (* s2 2.5))
	  p7b (polar p7 a1 (* s2 3.0))
	  p9b (polar p9 a1 (+ (* s2 2.5) l))
    ) ;_  setq
;;;       
    (setq os1  (polar p1 (angle p1 p6) (/ (distance p1 p6) 2.0))
	  os2  (polar p4 a1 (/ (distance p4 p7) 2.0))
	  pt1  (polar p1 (+ a1 pi) sos)
	  pt2  (polar p4 (+ a1 pi) sos)
	  pt2a (polar p7 (+ a1 pi) (+ x1 (- sos y)))
	  pt2b (polar pt2 (angle pt2 pt1) (/ (distance pt2 pt1) 2.0))
	  pt3  (polar p6 a1 sos)
	  pt4  (polar p7 a1 sos)
	  pt5  (polar os1 (+ a1 (/ pi 2.0)) sos)
	  pt6  (polar os2 (- a1 (/ pi 2.0)) (* s3 0.7))
;;;	  pt7  (polar os2 (+ a1 (/ pi 2.0)) (+ sos x a))
;;;	  pt8  (polar p2 (+ a1 pi) (* sos 0.5))
;;;	  pt9  (polar p7 a1 (* sos 0.5))
    ) ;_  setq
;;;    
    (ton)
    (command "_LINE" p1 p2 "" "_LINE" p2 p3 "" "_LINE" p3 p4 "")
    (command "_LINE" p6 p7 "" "_LINE" p7 pt2a "")
    (osn)
    (command "_LINE" p1b pt1 "" "_LINE" p4b pt2 "")
    (command "_LINE" p6b pt3 "" "_LINE" p9b p9 "")
    (command "_LINE" pt2a p8 "" "_LINE" p8 p9 "")
    (ton)
    (command "_SPLINE" p1b p2b p4b "" "" "")
    (command "_SPLINE" p6b p7b p9b "" "" "")
    (command "_LINE" p1 pt1 "" "_LINE" p6 pt3 "")
    (command "_LINE" p4 pt2 "")
  ) ;_  STK2


;;;      
  (defun ugl (/ st)
;;;   
    (setq s1   (* s1 mb)
	  s2   (* s2 mb)
	  a    (* a mb)
	  x    (* x mb)
	  x0  (* x0 mb)
	  x1   (* x1 mb)
	  an1  (* (/ an1 180.0) pi)
	  an2  (* (/ an2 180.0) pi)
	  an3  (* (/ an3 180.0) pi)
	  an4  (* (/ an4 180.0) pi)
	  sos  (* 0.2 s1)
	  sos2 (* 0.2 s2)
    ) ;_  setq
;;;    (if	(< s1 s2)
;;;         (setq kat (* s1 1.2))
;;;         (setq kat (* s2 1.2))
;;;    ) ;_  if
    (if	(< s1 s2)
       (setq st (* s1 0.5))
       (setq st (* s2 0.5))
    ) ;_  if
    (if	(< st 3.0)
      (setq kat 3.0)
      (setq kat st)
    ) ;_  if
;;;       
    (setq b   (- s2 (+ a x))
	  b0  (- s2 (+ a x0))
	  b1  (* b (/ (sin an1) (cos an1)))
	  b2  (* b0 (/ (sin an3) (cos an3)))
	  ip2 (polar ip (+ a1 (/ pi 2.0)) x1)
	  p1  (polar ip (- a1 (/ pi 2.0)) b1)
	  p2  (polar ip (+ a1 pi) b)
	  p5  (polar ip (- a1 (/ pi 2.0)) s1)
	  p4  (polar p5 (+ a1 pi) (* x (/ (sin an2) (cos an2))))
	  p1b (polar ip (+ a1 pi) (* s2 2.5))
	  p2b (polar p1b (+ a1 (* (/ pi 4.0) 5.0)) (* s2 0.5))
	  p4b (polar p5 (+ a1 pi) (* s2 2.5))
	  p6  (polar ip2 (+ a1 (/ pi 2.0)) b2)
	  p7  (polar ip2 (+ a1 pi) b0)
	  p8  (polar p7 (+ a1 pi) a)
	  p10 (polar ip2 (+ a1 pi) s2)
	  p9  (polar p10 (+ a1 (/ pi 2.0)) (* x0 (/ (sin an4) (cos an4))))
	  p6b (polar ip2 (+ a1 (/ pi 2.0)) (* s2 2.5))
	  p7b (polar p7 (+ a1 (/ pi 2.0)) (* s2 3.0))
	  p9b (polar p10 (+ a1 (/ pi 2.0)) (* s2 2.5))
    ) ;_  setq
;;;      
   (setq pt1  (polar p1 (- a1 (/ pi 2.0)) sos)
	 pt2  (polar ip (+ a1 pi) s2)
	 pt3  (polar pt2 (+ a1 pi) kat)
	 pt4  (polar pt2 (+ a1 (/ pi 2.0)) kat)
	 pt5  (polar p6 (+ a1 (/ pi 2.0)) sos2)
	 os1  (polar p1 (+ a1 (/ pi 2.0)) (/ (distance p1 p6) 2.0))
	 os2  (polar pt2 (+ a1 (/ pi 2.0)) (/ (distance pt2 p9) 2.0))
	 pt6  (polar os1 a1 sos)
	 pt7  (polar os2 (+ a1 pi) sos)
	 pt8  (polar os2 a1 (+ x a))
	 pt9  (polar p7 (+ a1 (/ pi 2.0)) sos)
	 pt10 (polar pt2 (- a1 (* (/ pi 4.0) 3.0)) sos)
   ) ;_  setq

;;;    
    (ton)
    (command "_LINE" p1 p2 "")
    (command "_LINE" p6 p7 "" "_LINE" p7 p8 "" "_LINE" p8 p9 "")
    
    (osn)
    (command "_LINE" pt1 p4 "")
    (command "_LINE" p1b pt3 "")
    (command "_LINE" p4b p4 "")
    (command "_LINE" p6b pt5 "" "_LINE" p9b pt4 "")
    
    (ton)
    (command "_SPLINE" p1b p2b p4b "" "" "")
    (command "_SPLINE" p6b p7b p9b "" "" "")
    (command "_LINE" p2 pt2 "" "_LINE" pt1 p1 "" "_LINE" p6 pt5 "")
    
    (if	(= pr 4)
      (osn)
    ) ;_  if
    (command "_LINE" pt3 pt2 "" "_LINE" p9 pt4 "")
  ) ;_  UGL

;;;      
  (defun tav (/ st)
;;;   
    (setq s1   (* s1 mb)
	  s2   (* s2 mb)
	  a    (* a mb)
	  x    (* x mb)
	  x0  (* x0 mb)
	  x1   (* x1 mb)
	  an1  (* (/ an1 180.0) pi)
	  an2  (* (/ an2 180.0) pi)
	  an3  (* (/ an3 180.0) pi)
	  an4  (* (/ an4 180.0) pi)
	  sos  (* 0.2 s1)
	  sos2 (* 0.2 s2)
    ) ;_  setq
;;;    (if	(< s1 s2)
;;;         (setq kat (* s1 1.2))
;;;         (setq kat (* s2 1.2))
;;;    ) ;_  if
    (if	(< s1 s2)
       (setq st (* s1 0.5))
       (setq st (* s2 0.5))
    ) ;_  if
    (if	(< st 3.0)
      (setq kat 3.0)
      (setq kat st)
    ) ;_  if
;;;       
    (setq b   (- s2 (+ a x))
	  b0  (- s2 (+ a x0))
	  b2  (* b0 (/ (sin an3) (cos an3)))
	  ip2 (polar ip (+ a1 (/ pi 2.0)) x1)
	  p1  (polar ip a1 (* s2 2.5))
	  p2  (polar ip (+ a1 pi) b)
	  p4  (polar p1 (- a1 (/ pi 2.0)) s1)
	  p5  (polar p4 (+ a1 (/ pi 4.0)) (* s1 0.5))
	  p1b (polar ip (+ a1 pi) (* s2 2.5))
	  p2b (polar p1b (+ a1 (* (/ pi 4.0) 5.0)) (* s1 0.5))
	  p4b (polar p4 (+ a1 pi) (* s2 5.0))
	  p6  (polar ip2 (+ a1 (/ pi 2.0)) b2)
	  p7  (polar ip2 (+ a1 pi) b0)
	  p8  (polar p7 (+ a1 pi) a)
	  p10 (polar ip2 (+ a1 pi) s2)
	  p9  (polar p10 (+ a1 (/ pi 2.0)) (* x0 (/ (sin an4) (cos an4))))
	  p6b (polar ip2 (+ a1 (/ pi 2.0)) (* s2 2.5))
	  p7b (polar p7 (+ a1 (/ pi 2.0)) (* s2 3.0))
	  p9b (polar p10 (+ a1 (/ pi 2.0)) (* s2 2.5))
    ) ;_  setq
;;;      
   (setq pt1  (polar ip a1 sos)
	 pt2  (polar ip (+ a1 pi) s2)
	 pt3  (polar pt2 (+ a1 pi) kat)
	 pt4  (polar pt2 (+ a1 (/ pi 2.0)) kat)
	 pt5  (polar p6 (+ a1 (/ pi 2.0)) sos2)
	 os1  (polar ip (+ a1 (/ pi 2.0)) (/ (distance ip p6) 2.0))
	 os2  (polar pt2 (+ a1 (/ pi 2.0)) (/ (distance pt2 p9) 2.0))
	 pt6  (polar os1 a1 sos)
	 pt7  (polar os2 (+ a1 pi) sos)
	 pt8  (polar os2 a1 (+ x a))
	 pt9  (polar p7 (+ a1 (/ pi 2.0)) sos)
	 pt10 (polar pt2 (- a1 (* (/ pi 4.0) 3.0)) sos)
	 pt11 (polar p2 (- a1 (/ pi 4.0)) sos)
   ) ;_  setq


;;;    
    (ton)
    (command "_LINE" ip p2 "")
    (command "_LINE" p6 p7 "" "_LINE" p7 p8 "" "_LINE" p8 p9 "")
    
    (osn)
    (command "_LINE" pt1 p1 "")
    (command "_LINE" p1b pt3 "" "_LINE" p4b p4 "")
    (command "_LINE" p6b pt5 "" "_LINE" p9b pt4 "")
    
    (ton)
    (command "_SPLINE" p1b p2b p4b "" "" "")
    (command "_SPLINE" p1 p5 p4 "" "" "")
    (command "_SPLINE" p6b p7b p9b "" "" "")
    (command "_LINE" pt2 p2 ""  "_LINE" pt1 ip "" "_LINE" p6 pt5 "")
    
    (if	(= pr 6)
      (osn)
    ) ;_  if
    (command "_LINE" pt3 pt2 "" "_LINE" p9 pt4 "")
  ) ;_  TAV

;;;    
  (defun sht ()
    (if	(< pr 6)
      (setq pt1	(polar pt1 (- a1 (* (/ pi 4.0) 3.0)) (* s1 0.5))
	    pt3	(polar pt3 (- a1 (/ pi 4.0)) s2)
      ) ;_  setq
      (setq pt1	(polar pt2 (- a1 (/ pi 2.0)) (* s1 0.5))
	    pt3	(polar p6b (- a1 (* (/ pi 4.0) 3.0)) (* s2 0.5))
      ) ;_  setq
    ) ;_  if
    (ton)
    (command "_BHATCH" "_p" "_u" 45 2.0 "_n" pt1 "")
    (command "_BHATCH" "_p" "_u" 315 2.0 "_n" pt3 "")
  ) ;_  SHT


;;;  ------------- ----------
  (cond	((= pr 1)
	 (setq an1 0.0
	       an2 0.0
	       an3 45.0
	       an4 0.0
	       a   1.0
	       x   0.0
	       x0  0.0
	       x1  2.0
	 ) ;_  setq
	 (stk)
;;;	  
	 (osn)
	 (command "_SPLINE" pt1 pt5 pt3 "" "" "")
	 (command "_SPLINE" pt1 p4 os2 p9 pt3 "" "" "")
	)
	((= pr 2)
	 (setq an1 0.0
	       an2 0.0
	       an3 45.0
	       an4 0.0
	       a   0.0
	       x   0.0
	       x1  bx
	 ) ;_  setq
	 (stk2)
;;;	  
	 (osn)
	 (command "_SPLINE" pt1 pt5 pt3 "" "" "")
	 (command "_SPLINE" pt3 pt4 pt6 pt2a pt2 pt2b pt1 "" "" "")
	)
	((= pr 3)
	 (setq an1 25.0
	       an2 0.0
	       an3 25.0
	       an4 0.0
	       a   1.0
	       x   0.0
	       x1  bx
	 ) ;_  setq
	 (stk2)
;;;	  
	 (osn)
	 (command "_SPLINE" pt1 pt5 pt3 "" "" "")
	 (command "_SPLINE" pt3 pt4 pt6 pt2a pt2 pt2b pt1 "" "" "")
	)
	((= pr 4)
	 (setq an1 25.0
	       an2 0.0
	       an3 25.0
	       an4 0.0
	       a   1.0
	       x   0.0
	       x0  0.0
	       x1  2.0
	 ) ;_  setq
	 (stk)
;;;	  
	 (osn)
	 (command "_SPLINE" pt1 pt5 pt3 "" "" "")
	 (command "_SPLINE" pt1 pt8 "" "" "")
	 (command "_SPLINE" pt3 pt9 "" "" "")
	 (command "_SPLINE" pt2 pt8 pt7 pt9 pt4 "" "" "")
	 (command "_SPLINE" pt2 pt6 pt4 "" "" "")
	)
	((= pr 5)
	 (setq an1 25.0
	       an2 25.0
	       an3 25.0
	       an4 25.0
	       a   1.0
	       x   (/ (- s1 a) 2.0)
	       x0  (/ (- s2 a) 2.0)
	       x1  2.0
	 ) ;_  setq
	 (stk)
;;;	  
	 (osn)
	 (command "_SPLINE" pt1 pt5 pt3 "" "" "")
	 (command "_SPLINE" pt1 pt8 "" "" "")
	 (command "_SPLINE" pt3 pt9 "" "" "")
	 (command "_SPLINE" pt2 pt8 pt7 pt9 pt4 "" "" "")
	 (command "_SPLINE" pt2 pt6 pt4 "" "" "")
	)
	((= pr 6)
	 (setq an1 0.0
	       an2 0.0
	       an3 45.0
	       an4 0.0
	       a   1.0
	       x   0
	       x0  0
	       x1  2.0
	 ) ;_  setq
	 (ugl)
;;;	  
	 (osn)
	 (command "_SPLINE" pt5 pt6 pt1 "" "" "")
	 (command "_SPLINE" pt1 pt2 os2 p9 pt5 "" "" "")
	)
	((= pr 7)
	 (setq an1 0.0
	       an2 0.0
	       an3 45.0
	       an4 0.0
	       a   1.0
	       x   0
	       x0  0
	       x1  2.0
	 ) ;_  setq
	 (ugl)
;;;	  
	 (osn)
	 (command "_SPLINE" pt5 pt6 pt1 "" "" "")
	 (command "_SPLINE" pt1 p2 "" "" "")
	 (command "_SPLINE" pt5 pt9 "" "" "")
	 (command "_SPLINE" pt3 pt4 "" "" "")
	 (command "_SPLINE" pt3 pt10 p2 pt8 pt9 pt4 "" "" "")
	)
	((= pr 8)
	 (setq an1 0.0
	       an2 0.0
	       an3 45.0
	       an4 0.0
	       a   1.0
	       x   0
	       x0  0
	       x1  2.0
	 ) ;_  setq
	 (tav)
;;;	  
	 (osn)
	 (command "_SPLINE" pt5 pt6 pt1 "" "" "")
	 (command "_SPLINE" pt1 pt2 os2 p9 pt5 "" "" "")
	)
	((= pr 9)
	 (setq an1 0.0
	       an2 0.0
	       an3 45.0
	       an4 0.0
	       a   1.0
	       x   0
	       x0  0
	       x1  2.0
	 ) ;_  setq
	 (tav)
;;;	  
	 (osn)
	 (command "_SPLINE" pt5 pt6 pt1 "" "" "")
	 (command "_SPLINE" pt1 pt11 p2 "" "" "")
	 (command "_SPLINE" pt5 pt9 "" "" "")
	 (command "_SPLINE" pt3 pt4 "" "" "")
	 (command "_SPLINE" pt3 pt10 p2 pt8 pt9 pt4 "" "" "")
	)
  ) ;_  cond
  (if (eq shtrp "1")
    (sht)
  ) ;_  if
) ;_  FASOTR2

