;;;     
;;;:  ..
;;; : 18.09.2001
;;;CAD-CEE 2000
;;;: C:TBSVR

(defun c:tbsvr (/ dlg	 dfl	orx    aby    name1  dcl_id vnln
		  dps	 pr	dps1   pl     inptG  cla    smin
		  smax	 shtr	raz    svmat  n1     n2     n3
		  n4     n5     n6     o1     o2     o3     o4
		  o5     o6     k1     k2     k3     k4     k5
		  k6     c1     c2     c3     c4     c5     c6
		  z1     z2     z3     z4     z5     z6     np
		  n      prd    nl     ol     kl     cl     zl
		  i      n      o      k      c      z      ip1
		  pt1    pt2    a1     a2     a3     a4     a5
		  a6     svmat0 a      k0     c0     z0     pt3
		  ip2    pt4    l      x      spis1  o1l    o2l
		  svl    p1     o1a    o2a    o3a    o4a    vctr
		  vs     pt5    pt6    a      attd   
		 ) 

  (setq	dlg (findfile (strcat pathdcl2 "svarka\\tbsvr.dcl")))

;;;   
  (setq	spis1 '("<>"
		" "
	       ". "
	       " 5264-80"
	       " 8713-79"
	       " 11534-75"
	       " 14771-76"
	       " 16037-80"
	      )
  ) ;_  setq


;;;    
  (setq	svmat "  -082092   10052-75"
	k0    1
	c0    ", , , , , , "
	prd   1
	a     0
	k1    k0
	c1    c0
  ) ;_  setq
  (if (= np nil) (setq np 0)(setq np (1- np)))

;;;      
  (defun tip_sv	()
    (cond ((= o1l "3") (setq svl '("2" "C4" "5" "6" "7" "C8" "9" "10" "C11" "C12" "C14"
				   "C15" "C43" "C17" "C18" "C19" "C20" "C21" "C24" "C25" "C39"
				   "4" "5" "6" "7" "8" "9" "10" "1" "3" "6" "7" "9"
				   "1" "2")); 5264
	  )
	  ((= o1l "4") (setq svl '("2" "C3" "C6" "C7" "C9" "C10" "C13" "C14" "C15" "C16" "C17"
				   "C18" "C19" "C29" "C30" "C31" "C34" "2" "3" "4" "1" "2"
				   "3" "4" "5" "6" "7" "8" "9" "10" "11" "1" "2" "3"
				   "4" "5" "6")); 8731
	  )
	  ((= o1l "5") (setq svl '("1" "2" "3" "4" "5" "6" "7" "8" "1" "2" "3" "4"
				   "5" "6" "7" "8")); 11534
	  )
	  ((= o1l "6") (setq svl '("2" "4" "5" "6" "7" "C8" "9" "10" "C11" "12" "15" "17"
				   "18" "19" "C20" "C21" "C25" "4" "5" "6" "7" "8" "9" "10"
				   "1" "3" "6" "7" "8" "9" "1" "2"));14771
	  )  
	  ((= o1l "7") (setq svl '("2" "4" "5" "C8" "10" "C11" "17" "18" "19" "54" "55" "56"
				   "5" "7" "8" "16" "17" "18" "19" "20" "21" "1")); 16037
	  )
	  (t (setq svl '(" "))
	  ) 
    );_  cond
  ) ;_  defun

;;;          
  (defun s_t ()
    (set_tile "N1" (itoa np))
    (if	(/= o1l "1")
      (progn
	(set_tile "Tipf" svmat)
	(set_tile "K1" (itoa k0))
	(set_tile "C1" c0)
      ) ;_  progn
      (progn
	(setq k1 "" c1 " ")
	(set_tile "K1" "")
	(set_tile "C1" "")
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;    
  (defun vtr ()
    (if	(/= o1l "0")
      (progn
	(if (= a 2)
	  (mode_tile "Prw" 1)
	  (if (= np 1)
	    (mode_tile "Prw" 1)
	    (mode_tile "Prw" 0)
	  ) ;_  if
	) ;_  if
	(mode_tile "O4" 0)
	(mode_tile "Z1" 0)
	(mode_tile "Z2" 0)
	(mode_tile "Z3" 0)
	(mode_tile "Z4" 0)
	(mode_tile "Z5" 0)
	(mode_tile "K1" 0)
	(mode_tile "C1" 0)
	(if (or (= o1l "1")(= o1l "2"))
	  (progn
	    (mode_tile "O2" 1)
	    (mode_tile "O3" 1)
	    (if	(= o1l "1")
	      (progn
		(mode_tile "O4" 1)
;;;		(mode_tile "Prw" 1)
;;;		(mode_tile "Z1" 1)
;;;		(mode_tile "Z2" 1)
;;;		(mode_tile "Z3" 1)
;;;		(mode_tile "Z4" 1)
;;;		(mode_tile "Z5" 1)
;;;		(mode_tile "K1" 1)
;;;		(mode_tile "C1" 1)
	      ) ;_  progn
	    ) ;_  if
	  ) ;_  progn
	  (progn
	    (mode_tile "O2" 0)
	    (mode_tile "O3" 0)
	  ) ;_  progn
	) ;_  if
      ) ;_  progn
      (progn
	(mode_tile "Prw" 1)
	(mode_tile "O2" 1)
	(mode_tile "O3" 1)
	(mode_tile "O4" 1)
	(mode_tile "Z1" 1)
	(mode_tile "Z2" 1)
	(mode_tile "Z3" 1)
	(mode_tile "Z4" 1)
	(mode_tile "Z5" 1)
	(mode_tile "K1" 1)
	(mode_tile "C1" 1)
      ) ;_  progn
    ) ;_  if
  ) ;_  defun

;;;     ( )
;;;  (defun prw_fn	()
;;;    (done_dialog)
;;;    (unload_dialog dcl_id)
;;;    (if	(> np 1)
;;;      (command "_ZOOM" "_W" p1 p2)
;;;    ) ;_  if
;;;    (getstring t " (  ENTER) ?")
;;;    (show)
;;;  ) ;_  defun

;;;   
  (defun end_fn	()
     (command "_LAYER" "_s" "" "")
     (command "_LINE" pt1 pt2 "")
     (setq x   (/ (- l 20) 2.0)
	   pt4 (polar ip2 (- 0.0 (/ pi 2.0)) (+ x 1.0))
	   ip2 (polar ip2 (- 0.0 (/ pi 2.0)) l)
	   l   0
     ) ;_  setq
     (command "_LAYER" "_s" "" "")
     (if (< (strlen svmat) 45)
       (command	"_MTEXT" pt4 "_h" 3.5 "_j" "_ML" "@47,-18" svmat "") ;_  command
       (command	"_MTEXT" pt4 "_h" 2.5 "_j" "_ML" "@47,-18" svmat "") ;_  command
     ) ;_  if 
  ) ;_  defun


;;;    
;;;    p -  
;;;    vf -  
;;;    pole -  
;;;    pk -     ("i" - INT, "r" - REAL, "s" - STR)
    (defun prv_p (p vf pole pk / n i sm us)
      (setq us 0
	    i  1
	    n  (strlen p)
	    sm (substr p 1 1)
      ) ;_  setq

      (while (not (eq sm ","))
	(if (not (or (eq sm "0")
		     (eq sm "1")
		     (eq sm "2")
		     (eq sm "3")
		     (eq sm "4")
		     (eq sm "5")
		     (eq sm "6")
		     (eq sm "7")
		     (eq sm "8")
		     (eq sm "9")
		     (eq sm ".")
		 ) ;_  or
	    ) ;_  not
	  (setq	sm ","
		us 1
	  ) ;_  setq
	) ;_  if
	(if (or (= i n) (= us 1))
	  (setq sm ",")
	  (progn (setq i  (1+ i)
		       sm (substr p i 1)
		 ) ;_  setq
		 (if (eq sm ",")
		   (setq us 1)
		 ) ;_  if
	  ) ;_  progn
	) ;_  if
      ) ;_  while

      (if (or (/= i n) (= us 1))
	(progn (attn)
	       (mode_tile pole 2)
	       (set vf (eval vf))
	       (if (= vf 'l)
		 (setq l 0)
	       ) ;_  if
	       (if (= (type (eval vf)) 'STR)
		 (set_tile pole (eval vf))
		 (if (= (type (eval vf)) 'INT)
		   (set_tile pole (itoa (eval vf)))
		   (set_tile pole (rtos (eval vf)))
		 ) ;_  if
	       ) ;_  if
	) ;_  progn
	(if (eq pk "s")
	  (set vf p)
	  (if (eq pk "i")
	    (set vf (atoi p))
	    (set vf (atof p))
	  ) ;_  if
	) ;_  if
      ) ;_  if 
    ) ;_  defun

   
;;;   
;;;    i1 -   
;;;    i2 -  
;;;    i3 -   
;;;    pole -    
;;;    obz -  
   (defun prov (i1 i2 i3 pole obz)
     (if (not (<= i1 i2 i3))
       (progn
	 (attn2 i1 i3 obz)
	 (mode_tile pole 2)
	 (setq fe 1)
       ) ;_  progn
       (setq fe 0)
     ) ;_  if
   ) ;_  defun

;;;       
  (defun spis ()
    (setq ol (strcat o1 o2 o3 o4)
    ) ;_  setq
  ) ;_  defun

;;;     
    (defun o1_l ()
      (start_list "O1")
      (mapcar 'add_list spis1)
      (end_list)
    ) ;_  defun

;;;     
    (defun o2_l ()
      (start_list "O2")
      (mapcar 'add_list svl)
      (end_list)
    ) ;_  defun

;;;   -     
   (defun attn ()
        (new_dialog "att1" dcl_id)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun

  
;;;   -    
;;;    ot -  
;;;    dov -  
;;;    obz -  
   (defun attn2 (ot dov obz / str1)
        (setq str1 (strcat "  " (rtos ot) " " obz "   " (rtos dov) " " obz "."))
        (new_dialog "att2" dcl_id)
        (set_tile "Ot" str1)
        (action_tile "accept" "(done_dialog 1)")
        (start_dialog)
   );_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "tbsvr" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (setq np (1+ np))
    (o1_l)
    (s_t)
    (vtr)
    (mode_tile "O1" 2)

;;;     
    (action_tile
      "Tipf"
      (strcat "(setq svmat $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "N1"
      (strcat "(prv_p $value 'np \"N1\" \"i\")"
	      "(prov 1 np 100 \"N1\" \"\")"
	      "(vtr)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O1"
      (strcat "(setq o1l $value)"
	      "(setq o1a (nth (atoi o1l) spis1))"
	      "(tip_sv)"
	      "(setq o2 (nth (atoi o2l) svl))"
              "(o2_l)"
	      "(vtr)"
	      "(s_t)"
	      "(if (> (atoi o1l) 2) (setq o1 (strcat o1a \"-\")) (setq o1 o1a))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O2"
      (strcat "(setq o2l $value)"
	      "(setq o2 (nth (atoi o2l) svl))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O3"
      (strcat "(setq o3 $value)"
	      "(setq o3 (strcat \"-\" o3))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "O4"
      (strcat "(setq o4a $value)"
	      "(if (> (atoi o1l) 2) (setq o4 (strcat \"-\" o4a)) (setq o4 o4a))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Z1"
      (strcat "(setq z1 $value)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Z2"
      (strcat "(setq z2 $value)"
	      "(if (= z2 \"1\") (mode_tile \"Z3\" 1) (mode_tile \"Z3\" 0))"
	      "(if (= z2 \"1\") (setq z3 \"0\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Z3"
      (strcat "(setq z3 $value)"
	      "(if (= z3 \"1\") (mode_tile \"Z2\" 1) (mode_tile \"Z2\" 0))"
	      "(if (= z3 \"1\") (setq z2 \"0\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Z4"
      (strcat "(setq z4 $value)"
	      "(if (= z4 \"1\") (mode_tile \"Z5\" 1) (mode_tile \"Z5\" 0))"
	      "(if (= z4 \"1\") (setq z5 \"0\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "Z5"
      (strcat "(setq z5 $value)"
	      "(if (= z5 \"1\") (mode_tile \"Z4\" 1) (mode_tile \"Z4\" 0))"
	      "(if (= z5 \"1\") (setq z4 \"0\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "K1"
      (strcat "(if (> (atoi o1l) 1) (prv_p $value 'k1 \"K1\" \"i\") (setq k1 $value))"
	      "(if (> (atoi o1l) 1) (prov 1 k1 1000 \"K1\" \".\"))"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "C1"
      (strcat "(setq c1 $value)"
      ) ;_  strcat
    ) ;_  action_tile


    (action_tile "Prw" "(done_dialog)(setq a 1)")
    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(setq prd 0)(done_dialog)")
    
    (start_dialog)

    (if	(and (= (atoi o1l) 1) (or (= k1 nil) (= k1 "")))
      (setq k1 " ")
      (setq k1 (itoa k1))
    ) ;_  if
    
    (unload_dialog dcl_id)
    (prin1)

  ) ;_  defun

;;; ---------------------------------- --------------------------------
  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setq vs (getvar "viewsize"))
  (setq vctr (getvar "viewctr"))
  (setq attd (getvar "attdia"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "attdia" 0)
  (setvar "osmode" 0)
  (setvar "aperture" 1)

  (command "_LOAD" "symb2.shx")
  
;;;   
(while (= prd 1)
  (setq	o1 "" o2 "" o3 "" o4 ""
	o1a "" o2a "" o3a "" o4a ""
	z1 "0" z2 "0" z3 "0" z4 "0" z5 "0"
	ol nil k1 k0 c1 c0
	o1l "0" o2l "0"
  ) ;_  setq
  (setq svmat0 svmat)
  
  (show)
  (spis)
;;;     
  (if (and (/= o1l "0") (= prd 1) (or (= a 0) (= a 1)))
    (progn
      (if (= a 0)
	(progn
	  (initget 1)
	  (setq	inptG (getpoint "\n  :")
		ip2   (polar inptG 0.0 82.0)
		p1    inptG
		l     0
	  ) ;_  setq
	) ;_  progn
	(progn
	  (setvar "OSMODE" 32)
	  (initget 1)
	  (setq	inptG (getpoint "\n    :")
		ip2   (polar inptG 0.0 82.0)
		p1    inptG
		l     0
	  ) ;_  setq
	  (setvar "OSMODE" 0)
	) ;_  progn
      ) ;_  if
;;;      
      (if (and (= a 0) (= np 1))
	(progn
	  (command "_INSERT" (strcat pathblock2 "tab_we") inptG "1.0" "1.0" "0.0") 
	  (setq	inptG (polar inptG (- 0.0 (/ pi 2.0)) 33.0)
		ip2   (polar inptG 0.0 82.0)
		p2    (polar inptG 0.0 170.0)
	  ) ;_  setq
	) ;_  progn
      ) ;_  if
    ) ;_  progn
  ) ;_  if

;;;   
  (if (and (/= svmat svmat0) (> np 1) (= prd 1) (/= o1l "0") (/= a 1))
    (progn
      (command "_LAYER" "_s" "" "")
      (command "_LINE" pt1 pt2 "")
      (setq x	(/ (- l 20) 2.0)
	    pt4	(polar ip2 (- 0.0 (/ pi 2.0)) (+ x 1.0))
	    ip2 (polar ip2 (- 0.0 (/ pi 2.0)) l)
	    l   0
      ) ;_  setq
      (command "_LAYER" "_s" "" "")
      (if (< (strlen svmat0) 45)
	(command "_MTEXT" pt4 "_h" 3.5 "_j" "_ML" "@47,-18" svmat0 "")
	(command "_MTEXT" pt4 "_h" 2.5 "_j" "_ML" "@47,-18" svmat0 "")
      ) ;_  if 
    ) ;_  progn
  ) ;_  if

  (if (and (= prd 1) (/= o1l "0"))
    (progn
      (command "_INSERT" (strcat pathblock2 "tab1we") inptG "1.0" "1.0" "0.0" (itoa np) ol k1) 
      (setq ip1	  (polar inptG (* (/ 320.29 360.0) 2.0 pi) 17.29)
	    pt5   (polar inptG (* (/ 351.0 360.0) 2.0 pi) 63.0)
	    pt6   (polar inptG (* (/ 349.5 360.0) 2.0 pi) 53.0)
	    pt3	  (polar inptG 0.0 131.0)
	    inptG (polar inptG (- 0.0 (/ pi 2.0)) 20.0)
	    pt1	  (polar inptG 0.0 81.0)
	    pt2	  (polar inptG 0.0 130.0)
	    p2	  (polar inptG 0.0 170.0)
	    l	  (+ l 20)
      ) ;_  setq
      (command "_LAYER" "_s" "" "")
      (if (< (strlen c1) 26)
	(command "_MTEXT" pt3 "_h" 4.5 "_j" "_MC" "@38,-20" c1 "")
	(command "_MTEXT" pt3 "_h" 4.0 "_j" "_MC" "@38,-20" c1 "")
      ) ;_  if
      (if (= z1 "1")
	(command "_SHAPE" "ms" ip1 "1.0" "0")
      ) ;_  if
      (if (= z2 "1")
	(command "_SHAPE" "zs" ip1 "1.0" "0")
      ) ;_  if
      (if (= z3 "1")
	(command "_SHAPE" "nl" pt5 "1.0" "0")
      ) ;_  if
      (if (and (= z4 "1") (= z3 "0"))
	(command "_SHAPE" "us" pt5 "1.0" "0")
      ) ;_  if
      (if (and (= z5 "1") (= z3 "0"))
	(command "_SHAPE" "ns" pt5 "1.0" "0")
      ) ;_  if
      (if (and (= z4 "1") (= z3 "1"))
	(command "_SHAPE" "us" pt6 "1.0" "0")
      ) ;_  if
      (if (and (= z5 "1") (= z3 "1"))
	(command "_SHAPE" "ns" pt6 "1.0" "0")
      ) ;_  if
    ) ;_  progn
  ) ;_  if
  (if (= o1l "0")
    (progn (setq prd 0))
  ) ;_  if
  (if (= prd 0)
    (end_fn)
    (command "_ZOOM" "_W" p1 p2)
  ) ;_  if
  (setq a 2)
 );_ while

  (command "_ZOOM" "_C" vctr vs)
  (setvar "cmdecho" cmd)
  (setvar "aperture" apsz)
  (setvar "blipmode" blpm)
  (setvar "celtype" cltp)
  (setvar "cecolor" ccol)
  (setvar "osmode" osmd)
  (setvar "clayer" clay)
  (setvar "attdia" attd)
  (prin1)
 
) ;_  TBSVR
