; CAD-CEE 
;  : 16.11.92.
;   : 04.10.95
;     11871-88

(defun sn (/ cmd bli cla vs fn rl rl1 ipa1 mb rl2)

;⠭ ६, 㧪 ᫠  ணࠬ "sv1"
   (setq cmd (getvar "CMDECHO")
         bli (getvar "BLIPMODE")
         cla (getvar "CLAYER")
         vs "\\cad-cee\\screw(slotnut)"
         d 0
   )
   (setvar "CMDECHO" 0)
   (setvar "BLIPMODE" 0)
   (if (/= cla "")
       (command "_LAYER" "_s" "" "")
   )
   (load (strcat pathlisp "light.lsp"))
   (command "_ZOOM" "_w" (list -5.0 -5.0) (list 436.0 314.5))
   (command "_VSLIDE" vs)
   (light 1.0 216.5 2.5 259.5 5)
   (light 220.5 426.5 45.5 259.5 5)
   (load (strcat pathlisp "sv1.lsp"))

;롮 ਠ ࠦ
   (light 1.0 216.5 2.5 259.5 4)
   (princ "\nSelect modification (1,2): ")
   (setq mod (sv1 4.0 213.5 5.5 256.5 209.5 125.5 2 0 -1))
   (if (= (type mod) 'STR)
       (progn
         (setq mod (atoi mod))
         (while (or (< mod 1) (> mod 2))
             (princ "\nSelect modification (1,2): ")
             (setq mod (sv1 4.0 213.5 5.5 256.5 209.5 125.5 2 0 -1))
             (if (= (type mod) 'STR) (setq mod (atoi mod)))
         )
       )
       (princ mod)
   )
   (light 1.0 216.5 2.5 259.5 5)

;롮  १
   (light 220.5 426.5 45.5 259.5 4)
   (princ "\nd, mm (6..200): ")
   (setq n (sv1 223.5 423.5 48.5 256.5 50.0 16.0 13 0 -1)
         fn (strcat pathdat "slotnut.tab")
         rl (open fn "r")
         rl1 (read-line rl)
         rl2 (read rl1)
   )
   (while (/= (car rl2) d)
       (cond ((= (type n) 'STR)
               (setq d (atof n))
               (setq rl1 (read-line rl))
               (if (/= rl1 nil)
                   (setq rl2 (read rl1))
                   (progn
                     (setq rl2 nil)
                     (*error* (strcat " " (rtos d 2 0) "   11871-88 "))
                   )
               )
             )
             ((= (type n) 'INT)
               (repeat n
                   (setq rl1 (read-line rl))
                   (if (/= rl1 nil)
                       (setq rl2 (read rl1))
                       (setq rl2 nil)
                   )
               )
               (if (/= nil rl2)
	           (progn
                     (setq d (car rl2))
                     (princ d)
	           )
	       )
             )
       )
       (if (not rl2)
           (progn
             (close rl)
             (princ "\nd, mm (6..200): ")
             (setq n (sv1 223.5 423.5 48.5 256.5 50.0 16.0 13 0 -1)
                   rl (open fn "r")
                   rl1 (read-line rl)
             )
           )
       )
   )
   (light 220.5 426.5 45.5 259.5 5)
   (close rl)
   (menucmd "S=SCL")
   (initget (+ 2 4))
   (setq mb (getreal "\nScale factor <1.0>: ")
         sv1 nil
         light nil
   )
   (if (not mb)
       (progn
         (setq mb 1.0)
         (prompt "1.0")
       )
   )
   (command "_ZOOM" "_p")

;। ࠬ஢ 
   (setq d (* (nth 0 rl2) mb)
         dd (* (nth 1 rl2) mb)
         d2 (* (nth 2 rl2) mb)
         m (* (nth 3 rl2) mb)
         h (* (nth 4 rl2) mb)
         s (* (nth 5 rl2) mb)
   )
   (if (< s 0.8) (setq s 0.8))

;। 窨 ⠢ 㣫  ࠦ 
   (load (strcat pathlisp "ip&a1.lsp"))
   (setq a3 (/ pi 2.0)
         a4 (+ a3 pi)
         ipa1 (ip&a1)
         ip (car ipa1)
	 a1 (cadr ipa1)
	 ip&a1 nil
   )
   (grlin ip a1 0)
   (dl)
   (setq dl nil a1 nil dd nil d2 nil m nil n nil s nil a4 nil a3 nil ip nil 
         d nil mod nil h nil
   )
   (menucmd "S=S1")
   (command "_LAYER" "_s" cla "")
   (setvar "CMDECHO" cmd)
   (setvar "BLIPMODE" bli)
   (princ)
)

;᫥ ࠦ
(defun grlin (ipgr agr color / r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14
                               s1 s2 s3 s4 s5 s6 s7 ss5 ss4 s44 s55 hat hat1)
    (if (= mod 2) (setq ipgr (list (+ (car ipgr) s) (cadr ipgr))))
    (setq r1 (polar ipgr (+ agr a3) (/ d 2.0))
          r2 (polar ipgr (+ agr a4) (/ d 2.0))
          r3 (polar r1 agr m)
          r4 (polar r2 agr m)
          r5 (polar ipgr (+ agr a3) (/ d2 2.0))
          r6 (polar ipgr (+ agr a4) (/ d2 2.0))
          r7 (polar r3 (+ agr a3) (- (/ dd 2.0) (/ d 2.0)))
          r8 (polar r4 (+ agr a4) (- (/ dd 2.0) (/ d 2.0)))
          r9 (polar r7 (+ agr pi) (- m (* (- (/ dd 2.0) (/ d2 2.0)) (/ (sin (/ pi 6.0)) (cos (/ pi 6.0))))))
          r10 (polar r9 (+ agr a4) dd)
          r11 (polar r7 (+ agr a4) h)
          r12 (polar r8 (+ agr a3) h)
          r13 (polar r11 (+ agr pi) (- m (* (- (- (/ dd 2.0) h) (/ d2 2.0)) (/ (sin (/ pi 6.0)) (cos (/ pi 6.0))))))
          r14 (polar r13 (+ agr a4) (- dd (* 2.0 h)))
    )
    (grdraw r1 r3 color)
    (grdraw r3 r7 color)
    (grdraw r7 r9 color)
    (grdraw r9 r5 color)
    (grdraw r5 r1 color)
    (grdraw r2 r4 color)
    (grdraw r4 r8 color)
    (grdraw r8 r10 color)
    (grdraw r10 r6 color)
    (grdraw r6 r2 color)
    (grdraw r11 r13 color)
    (grdraw r12 r14 color)
    (if (and (/= ip nil) (/= a1 nil))
        (progn
          (command "_PLINE" r1 "_w" "0" "0" r3 r11 r13 r5 "_c")
          (setq hat (ssadd (entlast)))
          (command "_PLINE" r2 r4 r12 r14 r6 "_c")
          (setq hat1 (ssadd (entlast) hat))
          (command "_LINE" r11 r7 r9 r13 "")
          (command "_LINE" r12 r8 r10 r14 "")
          (command "_LAYER" "_s" "" "")
          (command "_HATCH" "_u" "45" "1.5" "_n" hat1 "")
          (if (= mod 2)
              (progn
                (setq s1 (polar r5 (+ a1 pi) s)
                      s2 (polar r1 (+ a1 pi) s)
                      s3 (polar r2 (+ a1 pi) s)
                      s4 (polar r6 (+ a1 pi) s)
                      ss4 (polar r6 (+ a1 pi (/ pi 6.0)) s)
                      s5 (polar r14 (+ a1 a4) s)
                      ss5 (polar r14 (+ a1 pi (/ pi 6.0)) s)
                      s6 (polar r14 a1 (/ m 2.2))
                      s7 (polar s6 (+ a1 a4) s)
                      s44 (inters s3 s4 ss4 ss5 nil)
                      s55 (inters ss4 ss5 s5 s7 nil)
                )
                (command "_SOLID" s1 s2 r5 r1 "")
                (command "_SOLID" s3 s44 r2 r6 "")
                (command "_SOLID" s44 s55 r6 r14 "")
                (command "_SOLID" s55 s7 r14 s6 "")
              )
          )
        )
   )
)