;;;    
;;;:  ..
;;; : 04.09.2001
;;;CAD-CEE 2000
;;;: C:SVARKA

(defun c:svarka (/ dlg dfl lsp1 fld strd strdd orx aby name1 dcl_id
		   vnln dps tol baz d1 d2 d3 d4 d5 d6 d7 d8 d9 d10
		   pr dps1 pl inptG cla angl baz1 zm zm1 endw vsp ort
		    ) 

  (setq	dlg  (findfile (strcat pathdcl2 "svarka.dcl"))
	dfl  (findfile (strcat pathlisp2 "svarka.d"))
	lsp1 (findfile (strcat pathlisp2 "welding.lsp"))
	endw 0
  ) ;_  setq

  (load lsp1)

;;;   
  (setq	d1 (strcat pathdat2 "svarka(1).slb")
	d2 (strcat pathdat2 "svarka(2).slb")
	d3 (strcat pathdat2 "svarka(3).slb")
	d4 (strcat pathdat2 "svarka(4).slb")
	d5 (strcat pathdat2 "svarka(5).slb")
	d6 (strcat pathdat2 "svarka(6).slb")
	d7 (strcat pathdat2 "svarka(7).slb")
  ) ;_  setq

  
;;;      SVARKA.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd	  (read-line fld)
	   strdd  (read strd)
           dps    (itoa (nth 0 strdd))
	   baz    (nth 1 strdd)
	   zm     (nth 2 strdd)
	   baz1   baz
	   zm1    zm
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

;;;            
  (defun s_t ()
    (set_tile "Prim" pr)
  ) ;_  defun

;;;    
  (defun sl_im ()
    (show_im d1 "D1" 9)
    (show_im d2 "D2" 9)
    (show_im d3 "D3" 9)
    (show_im d4 "D4" 9)
    (show_im d5 "D5" 9)
    (show_im d6 "D6" 9)
    (show_im d7 "D7" 9)
  ) ;_  defun

;;;     
  (defun prim ()
    (cond ((= dps "1") (setq pr "   "))
          ((= dps "2") (setq pr " \" \""))
          ((= dps "3") (setq pr " \"  \""))
	  ((= dps "4") (setq pr " \" \""))
	  ((= dps "5") (setq pr " \" \""))
	  ((= dps "6") (setq pr " \" \""))
	  ((= dps "7") (setq pr " \" \""))
    ) ;_  cond
  ) ;_  defun

;;;     
;;;   : (pl_enbl dpsf kd)
;;;   dpsf -  ;
;;;   kd -   (252 - , 9 -  ( ))
 (defun	pl_enbl	(dpsf kd / namef)
;;;     
   (setq pl    (strcat "D" dpsf)
	 namef (strcat pathdat2 "svarka(" dpsf ").slb")
   ) ;_  setq
;;;    
   (show_im namef pl kd)
;;;   (mode_tile pl 2)
 ) ;_  defun

;;;       SVARKA.D
  (defun wrfl ()
      (setq fld	 (open dfl "w")
	    strd (strcat "(" dps " \"" baz "\" \"" zm "\")")
      ) ;_  setq
     (write-line strd fld)
     (close fld)
  )  ;_  defun


;;;   
  (defun show_im (name1 pole clr)
    (setq orx (dimx_tile pole)
	  aby (dimy_tile pole)
    ) ;_  setq
    (start_image pole)
    (fill_image 0 0 orx aby clr)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "svarka" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (sl_im)
    (pl_enbl dps 252)
    (prim)
    (s_t)


;;;     
    (action_tile
      "D1"
      (strcat "(setq dps1 dps dps \"1\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D2"
      (strcat "(setq dps1 dps dps \"2\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D3"
      (strcat "(setq dps1 dps dps \"3\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D4"
      (strcat "(setq dps1 dps dps \"4\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D5"
      (strcat "(setq dps1 dps dps \"5\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D6"
      (strcat "(setq dps1 dps dps \"6\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D7"
      (strcat "(setq dps1 dps dps \"7\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (start_dialog)

  ) ;_  defun

;;; ---------------------------------- --------------------------------
  (show)
  (unload_dialog dcl_id)
;;;    
  (command "_LOAD" "symb2.shx")
  (prin1)
;;;    
;;;  (if (/= dps "1")
;;;    (progn
;;;      (initget 1)
;;;      (setq inptG
;;;	     (getpoint "\n  :")
;;;      ) ;_  setq
;;;    ) ;_  progn
;;;  ) ;_  if

  (setq	wr1 (getvar "TDUSRTIMER")
	cla (getvar "CLAYER")
	ort (getvar "ORTHOMODE")
  ) ;_  setq
  (terpri)
  (command "_LAYER" "_s" "" "")
;;;   
  (cond	((= dps "1")
	 (while	(/= endw 1)
	   (we baz zm)
	   (prin1)
	   (setq baz baz1
		 zm  zm1
	   ) ;_  setq
	   (wrfl)
	   (command "_LAYER" "_s" cla "")
	   (setq vsp (getstring nil "\n   ENTER  SPACE(),  ESC:"))
           (if (or (= vsp nil) (= vsp "") (= vsp " "))
	     (setq endw 0)
	     (setq endw 1)
	   )  
	 ) ;_  while
	)
	((= dps "2")
	 (command "_SHAPE" "ks" pause "1.0" "0")
	 (prin1)
	 (wrfl)
	 (command "_LAYER" "_s" cla "")
	)
	((= dps "3")
	 (setvar "ORTHOMODE" 1)
	 (command "_SHAPE" "us" pause "1.0" pause)
	 (prin1)
	 (wrfl)
	 (setvar "ORTHOMODE" ort)
	 (command "_LAYER" "_s" cla "")
	)
	((= dps "4")
	 (setvar "ORTHOMODE" 1)
	 (command "_SHAPE" "ns" pause "1.0" pause)
	 (prin1)
	 (wrfl)
	 (setvar "ORTHOMODE" ort)
	 (command "_LAYER" "_s" cla "")
	)
	((= dps "5")
	 (command "_SHAPE" "nl" pause "1.0" "0")
	 (prin1)
	 (wrfl)
	 (command "_LAYER" "_s" cla "")
	)
	((= dps "6")
	 (command "_SHAPE" "ms" pause "1.0" "0")
	 (prin1)
	 (wrfl)
	 (command "_LAYER" "_s" cla "")
	)
	((= dps "7")
	 (command "_SHAPE" "zs" pause "1.0" "0")
	 (prin1)
	 (wrfl)
	 (command "_LAYER" "_s" cla "")
	)
  ) ;_  cond
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400))
  (prin1)
 
) ;_  SVARKA
