;;;     ,   ..
;;;:  ..
;;; : 04.09.2001
;;;CAD-CEE 2000
;;;: C:SYMVOL

(defun c:symvol (/ dlg dfl lsp1 fld strd strdd orx aby name1 dcl_id
		   vnln dps tol baz d1 d2 d3 d4 d5 d6 d7 d8 d9 d10
		   d11 d12 pr dps1 pl inptG d13 d14 cla angl baz1
		    ) 

  (setq	dlg  (findfile (strcat pathdcl2 "symvol.dcl"))
	dfl  (findfile (strcat pathlisp2 "symvol.d"))
	lsp1 (findfile (strcat pathlisp2 "section.lsp"))
  ) ;_  setq

  (load lsp1)

;;;   
  (setq	d1 (strcat pathdat2 "symvol(1).slb")
	d2 (strcat pathdat2 "symvol(2).slb")
	d3 (strcat pathdat2 "symvol(3).slb")
	d4 (strcat pathdat2 "symvol(4).slb")
	d5 (strcat pathdat2 "symvol(5).slb")
	d6 (strcat pathdat2 "symvol(6).slb")
	d7 (strcat pathdat2 "symvol(7).slb")
	d8 (strcat pathdat2 "symvol(8).slb")
	d9 (strcat pathdat2 "symvol(9).slb")
  ) ;_  setq

  
;;;      SYMVOL.D 
  (defun rdfl ()
     (setq fld	  (open dfl "r")
	   strd	  (read-line fld)
	   strdd  (read strd)
           dps    (itoa (nth 0 strdd))
	   baz    (nth 1 strdd)
	   baz1   baz
     ) ;_  setq
    (close fld)
  ) ;_  defun
  

;;;            
  (defun s_t ()
    (set_tile "Prim" pr)
  ) ;_  defun

;;;    
  (defun sl_im ()
    (show_im d1 "D1" 9)
    (show_im d2 "D2" 9)
    (show_im d3 "D3" 9)
    (show_im d4 "D4" 9)
    (show_im d5 "D5" 9)
    (show_im d6 "D6" 9)
    (show_im d7 "D7" 9)
    (show_im d8 "D8" 9)
    (show_im d9 "D9" 9)
  ) ;_  defun

;;;     
  (defun prim ()
    (cond ((= dps "1") (setq pr " \"\""))
          ((= dps "2") (setq pr " \"\""))
          ((= dps "3") (setq pr " \"\""))
	  ((= dps "4") (setq pr " \"\""))
	  ((= dps "5") (setq pr " \" \""))
	  ((= dps "6") (setq pr " \" \""))
	  ((= dps "7") (setq pr " \" \""))
	  ((= dps "8") (setq pr "    ()"))
	  ((= dps "9") (setq pr "     ()"))
    ) ;_  cond
  ) ;_  defun

;;;     
;;;   : (pl_enbl dpsf kd)
;;;   dpsf -  ;
;;;   kd -   (252 - , 9 -  ( ))
 (defun	pl_enbl	(dpsf kd / namef)
;;;     
   (setq pl    (strcat "D" dpsf)
	 namef (strcat pathdat2 "symvol(" dpsf ").slb")
   ) ;_  setq
;;;    
   (show_im namef pl kd)
;;;   (mode_tile pl 2)
 ) ;_  defun

;;;       SYMVOL.D
  (defun wrfl ()
      (setq fld	 (open dfl "w")
	    strd (strcat "(" dps " \"" baz "\")")
      ) ;_  setq
     (write-line strd fld)
     (close fld)
  )  ;_  defun


;;;   
  (defun show_im (name1 pole clr)
    (setq orx (dimx_tile pole)
	  aby (dimy_tile pole)
    ) ;_  setq
    (start_image pole)
    (fill_image 0 0 orx aby clr)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_  defun


;;;     
  (defun show ()

    (setq dcl_id (load_dialog dlg)) ;_  load_dialog

					; DCL-
    (if	(not (new_dialog "symvol" dcl_id)) ; 
      (exit)
    )					;(,   )


;;;      
    (rdfl)
    (sl_im)
    (pl_enbl dps 252)
    (prim)
    (s_t)


;;;     
    (action_tile
      "D1"
      (strcat "(setq dps1 dps dps \"1\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D2"
      (strcat "(setq dps1 dps dps \"2\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D3"
      (strcat "(setq dps1 dps dps \"3\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D4"
      (strcat "(setq dps1 dps dps \"4\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D5"
      (strcat "(setq dps1 dps dps \"5\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D6"
      (strcat "(setq dps1 dps dps \"6\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D7"
      (strcat "(setq dps1 dps dps \"7\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D8"
      (strcat "(setq dps1 dps dps \"8\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile
    (action_tile
      "D9"
      (strcat "(setq dps1 dps dps \"9\")"
	      "(pl_enbl dps1 9)"
	      "(pl_enbl dps 252)"
	      "(prim)"
	      "(s_t)"
      ) ;_  strcat
    ) ;_  action_tile

    (action_tile "accept" "(done_dialog)")
    (action_tile "cancel" "(exit)")
    (start_dialog)

  ) ;_  defun

;;; ---------------------------------- --------------------------------
  (show)
  (unload_dialog dcl_id)
;;;    
  (command "_LOAD" "symb2.shx")
  (prin1)
;;;;;;    
;;;  (if (or (= dps "8") (= dps "9"))
;;;    (setq dps dps) ; 
;;;    (progn
;;;      (initget 1)
;;;      (setq inptG
;;;	     (getpoint "\n  :")
;;;      ) ;_  setq
;;;      (if (or (= dps "2") (= dps "5") (= dps "6") (= dps "7"))
;;;	(progn
;;;	  (setq	angl
;;;		 (getangle inptG "\n   <0.0>:")
;;;	  ) ;_  setq
;;;	  (if (= angl nil)
;;;	    (setq angl 0.0)
;;;	    (setq angl (* (/ angl pi) 180))
;;;	  ) ;_  if
;;;	) ;_  progn
;;;      ) ;_  if
;;;    ) ;_  progn
;;;  ) ;_  if

  (setq	wr1 (getvar "TDUSRTIMER")
	cla (getvar "CLAYER")
  ) ;_  setq
  (terpri)
;;;   
  (cond	((= dps "1")
	 (command "_LAYER" "_s" "" "")
	 (command "_SHAPE" "kb" pause "1.0" "0")
	)
	((= dps "2")
	 (command "_LAYER" "_s" "" "")
	 (command "_SHAPE" "kon" pause "1.0" pause)
	)
	((= dps "3")
	 (command "_LAYER" "_s" "" "")
	 (command "_SHAPE" "rot" pause "1.0" "0")
	)
	((= dps "4")
	 (command "_LAYER" "_s" "" "")
	 (command "_SHAPE" "turn" pause "1.0" "0")
	)
	((= dps "5")
	 (command "_LAYER" "_s" "" "")
	 (command "_SHAPE" "view" pause "1.0" pause)
	)
	((= dps "6")
	 (command "_LAYER" "_s" "" "")
	 (command "_SHAPE" "ukr" pause "1.0" pause)
	)
	((= dps "7")
	 (command "_LAYER" "_s" "" "")
	 (command "_SHAPE" "ukl" pause "1.0" pause)
	)
	((= dps "8")
	 (section 0 baz)
	)
	((= dps "9")
	 (section 1 baz)
	)
  ) ;_  cond
  (prin1)
  (setq baz baz1)
  (wrfl)
  (setq wr2 (getvar "TDUSRTIMER"))
  (setq wri (* (- wr2 wr1) 86400))
  (command "_LAYER" "_s" cla "")
  (prin1)
 
) ;_  SYMVOL
